/*****************************************************************************
  $Id $
  File:		lib/ADT/TEST/Stack.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test suite for the domain adt::Stack
  Created:	Tue Jan  6 09:04:13 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("Stack"):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(adt::Stack):
//////////////////////////////////////////////////////////////////////////////

stack := adt::Stack():
prog::test(stack::pop(),
           FAIL):
stack := adt::Stack(a, b, c):
prog::test(stack::nops(), 3):
prog::test(stack::pop(),
           c):
prog::test(stack::pop(),
           b):
prog::test(stack::pop(),
           a):
prog::test(stack::nops(), 0):
prog::test(stack::pop(),
           FAIL):
prog::test(stack::nops(), 0):
prog::test(stack::push(a),
           a):
prog::test(stack::push(a),
           a):
prog::test(stack::pop(),
           a):
prog::test(stack::pop(),
           a):
prog::test(stack::pop(),
           FAIL):
prog::test(stack::top(),
           FAIL):
prog::test(stack::push(1),
           1):
prog::test(stack::top(),
           1):
prog::test(stack::nops(), 1):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("empty pop feature"):
//////////////////////////////////////////////////////////////////////////////

stack :=
adt::Stack::newExtended([a, b, c],
			id):
prog::test(stack::pop(),
           c):
prog::test(stack::pop(),
           b):
prog::test(stack::pop(),
           a):
prog::test(stack::pop(),
           0):
prog::test(stack::pop(),
           -1):
prog::test(stack::pop(),
           -2):
prog::test(stack::pop(),
           -3):
prog::test(stack::nops(), -4):

prog::testexit():

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

prog::check(test, 3):

// Local Variables:
// mode: mupad
// End:
