/*****************************************************************************
  $Id: GLIP.mu,v 1.1.1.3 2003/10/21 22:39:46 nthiery Exp $
  File:		lib/COMBINAT/GLIP.mu
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Created:	21/05/2003
  License:	LGPL
*****************************************************************************/
// Load the GLIP dynamic module and put it under combinat::GLIP
// If the module is not available, set combinat::GLIP to FAIL, and
// removes it from the combinat interface (mainly for prog::check)
// If the module is broken, raises an error
combinat::GLIP :=
proc()
    save GLIP;
begin
    if module::which("GLIP") = FAIL then
	// If the module is simply not available, fail silently
	userinfo(1, "Dynamic module GLIP not available"):
	sysassign(combinat::interface,
		  combinat::interface minus {hold(GLIP)});
	GLIP := FAIL;
    else
        // Avoids an internal error on exit of MuPAD 2.0.0
	%if version() = [2,0,0] then module::displace("stdmod"); end_if:
	if traperror(module("GLIP")) <> 0 then
	    warning("Error loading the dynamic module GLIP:");
	    lasterror();
	end_if;
    end_if;
    GLIP;
end_proc():
