/*****************************************************************************
  $Id: MachineIntegerListsLex.mu,v 1.1.1.3 2003/10/21 22:39:46 nthiery Exp $
  File:		lib/MODULES/MachineIntegerListsLex.mu
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Created:	21/05/2003
  License:	LGPL
*****************************************************************************/
// Load the MachineIntegerListsLex dynamic module and put it under
// combinat::MachineIntegerListsLex
// If the module is not available, set combinat::MachineIntegerListsLex to FAIL,
// and removes it from the combinat interface (mainly for prog::check)
// If the module is broken, raises an error
combinat::MachineIntegerListsLex :=
proc()
    save MachineIntegerListsLex;
begin
    if module::which("MachineIntegerListsLex") = FAIL then
	// If the module is simply not available, fail silently
	userinfo(1, "Dynamic module MachineIntegerListsLex not available"):
	sysassign(combinat::interface,
		  combinat::interface minus {hold(MachineIntegerListsLex)});
	MachineIntegerListsLex := FAIL;
    else
        // Avoids an internal error on exit of MuPAD 2.0.0
	%if version() = [2,0,0] then module::displace("stdmod"); end_if;
	if traperror(module("MachineIntegerListsLex")) <> 0 then
	    warning("Error loading the dynamic module MachineIntegerListsLex:");
	    lasterror();
	end_if;
    end_if;
    MachineIntegerListsLex;
end_proc():
