/*****************************************************************************
  $Id: Nauty.mu,v 1.1.1.1 2004/10/04 17:25:16 nthiery Exp $
  File:		lib/COMBINAT/Nauty.mu
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Created:	12/04/2004
  License:	LGPL
*****************************************************************************/
// Load the Nauty dynamic module and put it under
// combinat::Nauty
// If the module is not available, set combinat::Nauty to FAIL,
// and removes it from the combinat interface (mainly for prog::check)
// If the module is broken, raises an error
combinat::Nauty :=
proc()
    save Nauty;
begin
    if module::which("Nauty") = FAIL then
	// If the module is simply not available, fail silently
	userinfo(1, "Dynamic module Nauty not available"):
	sysassign(combinat::interface,
		  combinat::interface minus {hold(Nauty)});
	FAIL;
    else
        // Avoids an internal error on exit of MuPAD 2.0.0
	%if version() = [2,0,0] then module::displace("stdmod"); end_if;
	if traperror(module("Nauty")) <> 0 then
	    warning("Error loading the dynamic module Nauty:");
	    lasterror();
	end_if;
	Nauty;
    end_if;
end_proc():
