/*****************************************************************************
  $Id: binaryTrees.tst,v 1.1.1.2 2004/10/04 17:25:17 nthiery Exp $
  File:		lib/COMBINAT/TEST/binaryTrees.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'combinat::binaryTrees'
  Created:	27/06/2002
  License:	LGPL
*****************************************************************************/

prog::testinit("binaryTrees"):

alias(BT=combinat::binaryTrees):
alias(a=BT::one):

prog::testfunc(BT::isA):
prog::test(BT::isA(BT([])),
           TRUE):
prog::test(BT::isA(BT([]), 0),
           TRUE):
prog::test(BT::isA(BT([]), 1),
           FALSE):
prog::test(BT::isA(BT([1]), 1),
           TRUE):
prog::test(BT::isA(BT([1, [1]])),
           TRUE):
prog::test(BT::isA(BT([1, [1]]), 1),
           FALSE):
prog::test(BT::isA(BT([1, [1]]), 2),
           TRUE):
prog::test(BT::isA(BT([1, [1], [1]]), 2),
           FALSE):
prog::test(BT::isA(BT([1, [1], [1]])),
           TRUE):
prog::test(BT::isA(BT([1, [1], [1]]), 3),
           TRUE):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(BT::count):
//////////////////////////////////////////////////////////////////////////////
BT::grammar::makeCount():
prog::test([BT::count(i) $i=0..100],
	   [combinat::catalan(i) $i=0..100]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(BT::recursiveRevertRightBranch):
//////////////////////////////////////////////////////////////////////////////
prog::test(BT::recursiveRevertRightBranch(BT([1])),
	   BT([1])):
prog::test(BT::recursiveRevertRightBranch(BT([1,[],[1]])),
	   BT([1,[],[1]])):
prog::test(BT::recursiveRevertRightBranch(BT([1,[1], [1,[1],[1]]])),
	   BT([1, [], [1, [1, [], []], [1, [1, [], []], []]]])):
prog::test(BT::recursiveRevertRightBranch(BT([1,[1],[1]])),
	   BT([1,[], [1, [1],[]]])):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(BT::branchSlice):
//////////////////////////////////////////////////////////////////////////////
// Note: in MuPAD 2.0.0, expr does not map on elements of lists,
// so one cannot use directly expr((BT::....)) below
prog::test(map(BT::branchSlice(BT([]), Right),expr),
           []):
prog::test(map(BT::branchSlice(BT([1]), Right),expr),
           [[1, [], []]]):
prog::test(map(BT::branchSlice(BT([1, [1], []]), Right),expr),
           [[1, [1, [], []], []]]):
prog::test(map(BT::branchSlice(BT([1, [], [1]]), Right),expr),
           [[1, [], []], [1, [], []]]):
prog::test(map(BT::branchSlice(BT([1, [], [1, [1], [1]]]), Right),expr),
           [[1, [], []], [1, [1, [], []], []], [1, [], []]]):

for t in BT::list(5) do
    prog::test(bool(BT::branchSlice(revert(t),Left) =
		    map(BT::branchSlice(t,Right), revert))
	       );
end_for:

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(BT::shuffle):
//////////////////////////////////////////////////////////////////////////////
prog::test(map(BT::shuffle(BT([]), BT([])), expr),
           [[]]):
prog::test(map(BT::shuffle(BT([]), BT([1])), expr),
           [[1, [], []]]):
prog::test(map(BT::shuffle(BT([1]), BT([])), expr),
           [[1, [], []]]):
prog::test(map(BT::shuffle(BT([1]), BT([1])), expr),
           [[1, [1, [], []], []], [1, [], [1, [], []]]]):

t:=BT([]):
for n from 1 to 4 do
    t:=BT([1,t,[]]);
    prog::test(BT::shuffle::count(t,revert(t)),
	       2);
    prog::test(BT::shuffle::count(revert(t),t),
	       binomial(2*n,n));
end_for:

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package
//////////////////////////////////////////////////////////////////////////////
prog::testfunc(BT): 
prog::testexit():

prog::check(BT, 3):

// Local Variables: 
// mode: mupad
// End:
