/*****************************************************************************
  $Id: cartesianProduct.tst,v 1.1.1.3 2004/10/04 17:25:16 nthiery Exp $
  File:		lib/COMBINAT/TEST/cartesianProduct.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'combinat::cartesianProduct'
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("cartesianProduct", 0.5):

prog::testfunc(combinat::cartesianProduct::isA):
prog::test(combinat::cartesianProduct::isA([]),
           TRUE):
prog::test(combinat::cartesianProduct::isA([1], [2, 3, 1]),
           TRUE):
prog::test(combinat::cartesianProduct::isA([1], {2, 3, 1}),
           TRUE):
prog::test(combinat::cartesianProduct::isA([1], 3),
           TRUE):
prog::test(combinat::cartesianProduct::isA([1, 1]),
           TRUE):
prog::test(combinat::cartesianProduct::isA([1, 1], [1]),
           FALSE):
prog::test(combinat::cartesianProduct::isA([1, 1], {1}),
           FALSE):
prog::test(combinat::cartesianProduct::isA([1, 1], 1),
           FALSE):
prog::test(combinat::cartesianProduct::isA([1, 1], [2, 1]),
           FALSE):
prog::test(combinat::cartesianProduct::isA([1, 1], {2, 1}),
           FALSE):
prog::test(combinat::cartesianProduct::isA([1, 1], 2),
           FALSE):
prog::test(combinat::cartesianProduct::isA([1, 1], [2, 1], [1]),
           TRUE):
prog::test(combinat::cartesianProduct::isA([1, 1], {2, 1}, {1}),
           TRUE):
prog::test(combinat::cartesianProduct::isA([1, 1], 2, 1),
           TRUE):
prog::test(combinat::cartesianProduct::isA([1, 1], [2, 1], [1, 2]),
           TRUE):
prog::test(combinat::cartesianProduct::isA([1, 1], [2, 3, 1], [1, 2], [2]),
           FALSE):
prog::test(combinat::cartesianProduct::isA([1, 2, 1], [2, 3, 1], [1, 2], [2]),
           FALSE):
prog::test(combinat::cartesianProduct::isA([1, 2, 1], {2, 3, 1}, {1, 2}, {2}),
           FALSE):
prog::test(combinat::cartesianProduct::isA([1, 2, 1], 3, 2, {2}),
           FALSE):
prog::test(combinat::cartesianProduct::isA([1, 2, 1], 3, 2, 2),
           TRUE):
prog::test(combinat::cartesianProduct::isA([1, 2, 2], [2, 3, 1], [1, 2], [2]),
           TRUE):
prog::test(combinat::cartesianProduct::isA([2], 1),
           FALSE):
prog::test(combinat::cartesianProduct::isA([2], 2),
           TRUE):
prog::test(combinat::cartesianProduct::isA([2], [1, 3]),
           FALSE):
prog::test(combinat::cartesianProduct::isA([2], [1, 3, 2]),
           TRUE):


prog::testfunc(combinat::cartesianProduct::count):

prog::test(combinat::cartesianProduct::count(),		1):
prog::test(combinat::cartesianProduct::count([]),		0):
prog::test(combinat::cartesianProduct::count([a,b,c],[1]),	3):
prog::test(combinat::cartesianProduct::count([$1..5],[$1..3],[$1..13]), 195):

prog::testfunc(combinat::cartesianProduct::list):

// The order in which the elements of the cartesianProducts are listed
// is not in the specifications of combinat::cartesianProduct::list,
// so we sort the result before comparing.

prog::test(      combinat::cartesianProduct::list(),	       [[]] ):
prog::test(      combinat::cartesianProduct::list([a,b,c],[]),[] ):
prog::test( bool(sort(combinat::cartesianProduct::list([a,b,c],[1])) =
		 sort([[a,1], [b,1], [c,1]])) ):

prog::test( bool(sort(combinat::cartesianProduct::list({Diamondsuit,Heartsuit,Spadesuit,Clubsuit},{7,8,9,10})) =
		 sort([[Clubsuit, 7], [Clubsuit, 8], [Clubsuit, 9], [Clubsuit, 10],
		       [Spadesuit, 7], [Spadesuit, 8], [Spadesuit, 9],
		       [Spadesuit, 10], [Heartsuit, 7], [Heartsuit, 8],
		       [Heartsuit, 9], [Heartsuit, 10], [Diamondsuit, 7],
		       [Diamondsuit, 8], [Diamondsuit, 9], [Diamondsuit, 10]])) ):

prog::test( bool(sort(combinat::cartesianProduct::list({Diamondsuit,Heartsuit,Spadesuit,Clubsuit},3)) =
		 sort([[Clubsuit, 1], [Clubsuit, 2], [Clubsuit, 3], [Spadesuit, 1],
		       [Spadesuit, 2], [Spadesuit, 3], [Heartsuit, 1],
		       [Heartsuit, 2], [Heartsuit, 3], [Diamondsuit, 1],
		       [Diamondsuit, 2], [Diamondsuit, 3]])) ):

for i1 from 0 to 5 do
    for i2 from 0 to 5 do
        for i3 from 0 to 5 do
            prog::test( bool(nops(combinat::cartesianProduct::list(i1,i2,i3)) =
			     combinat::cartesianProduct::count(i1,i2,i3)) ) :
        end_for;
    end_for:
end_for:

// We don't test combinat::cartesianProduct::generator, since list is build
// on top of it.

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

// This this done at then end to ensure as much as possible of the
// package is initialized. A recursive prog::init(combinat::cartesianProduct)
// would be usefull here.

prog::testfunc(combinat::cartesianProduct):
prog::testexit():

prog::check(combinat::cartesianProduct, 3):


// Local Variables: 
// mode: mupad
// End:
