/*****************************************************************************
  $Id: countingFunctions.tst,v 1.1.1.2 2005/01/26 13:42:24 nthiery Exp $
  File:		lib/COMBINAT/TEST/countingFunctions.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test suite for the domain combinat::countingFunctions
  Created:	Sat Jul  3 10:19:07 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("countingFunctions"):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::countingFunctions):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::countingFunctions::_negate"):
prog::test([combinat::countingFunctions::_negate(id)(i) $ i = 0..10],
	   [0, -1, -2, -3, -4, -5, -6, -7, -8, -9, -10]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::countingFunctions::_plus"):
prog::test([combinat::countingFunctions::_plus(id, id^2)(i) $ i = 0..10],
	   [0, 2, 6, 12, 20, 30, 42, 56, 72, 90, 110]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::countingFunctions::one"):
prog::test([combinat::countingFunctions::one(i) $ i = 0..10],
           [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::countingFunctions::mult2"):
prog::test([combinat::countingFunctions::mult2(id, id^2)(i) $ i = 0..10],
	   [0, 0, 1, 6, 20, 50, 105, 196, 336, 540, 825]):
prog::test([combinat::countingFunctions::mult2(f, g)(i) $ i = 0..10],
	   [f(0)*g(0), f(0)*g(1) + f(1)*g(0), f(0)*g(2) + f(1)*g(1) + f(2)*g(0), f(0)*g(3) + f(1)*g(2) + f(2)*g(1) + f(3)*g(0), f(0)*g(4) + f(1)*g(3) + f(2)*g(2) + f(3)*g(1) + f(4)*g(0), f(0)*g(5) + f(1)*g(4) + f(2)*g(3) + f(3)*g(2) + f(4)*g(1) + f(5)*g(0), f(0)*g(6) + f(1)*g(5) + f(2)*g(4) + f(3)*g(3) + f(4)*g(2) + f(5)*g(1) + f(6)*g(0), f(0)*g(7) + f(1)*g(6) + f(2)*g(5) + f(3)*g(4) + f(4)*g(3) + f(5)*g(2) + f(6)*g(1) + f(7)*g(0), f(0)*g(8) + f(1)*g(7) + f(2)*g(6) + f(3)*g(5) + f(4)*g(4) + f(5)*g(3) + f(6)*g(2) + f(7)*g(1) + f(8)*g(0), f(0)*g(9) + f(1)*g(8) + f(2)*g(7) + f(3)*g(6) + f(4)*g(5) + f(5)*g(4) + f(6)*g(3) + f(7)*g(2) + f(8)*g(1) + f(9)*g(0), f(0)*g(10) + f(1)*g(9) + f(2)*g(8) + f(3)*g(7) + f(4)*g(6) + f(5)*g(5) + f(6)*g(4) + f(7)*g(3) + f(8)*g(2) + f(9)*g(1) + f(10)*g(0)]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::countingFunctions::_mult"):

f := combinat::countingFunctions::_mult():
prog::test([f(i) $ i = 0..10],
           [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]):
f := combinat::countingFunctions::_mult(id):
prog::test([id(i) $ i = 0..10],
	   [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10]):
f := combinat::countingFunctions::_mult(id, id, id):
prog::test([f(i) $ i = 0..10],
           [0, 0, 0, 1, 6, 21, 56, 126, 252, 462, 792]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::countingFunctions::_invert"):
delete(f):
g := combinat::countingFunctions::_invert(f):
prog::test(_plus(g(i) * x^i $ i=0..4),
	   expr(series(1/_plus(f(i) * x^i $i=0..10),x,5))):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::countingFunctions::D"):

g := combinat::countingFunctions::D(f):
prog::test([g(i) $ i = 0..5],
           [f(1), 2*f(2), 3*f(3), 4*f(4), 5*f(5), 6*f(6)]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::countingFunctions::int"):

g := combinat::countingFunctions::int(f):
prog::test([g(i) $ i = 0..5],
           [0, f(0), 1/2*f(1), 1/3*f(2), 1/4*f(3), 1/5*f(4)]):
// Coherence test: int and D are inverse transforms
g := combinat::countingFunctions::D(combinat::countingFunctions::int(f)):
prog::test([g(i) $ i = 0..5],
           [f(0), f(1), f(2), f(3), f(4), f(5)]):
g := combinat::countingFunctions::int(combinat::countingFunctions::D(f)):
prog::test([g(i) $ i = 0..5],
           [0, f(1), f(2), f(3), f(4), f(5)]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::countingFunctions::laplace"):

g := combinat::countingFunctions::laplace(f):
prog::test([g(i) $ i = 0..5],
           [f(0), f(1), 2*f(2), 6*f(3), 24*f(4), 120*f(5)]):

// Coherence test: the laplace transform replaces integration by
// multiplication by x and derivation by division by x
g := combinat::countingFunctions::laplace(combinat::countingFunctions::int(f)):
h := combinat::countingFunctions::laplace(f) @ (n->n-1):
prog::test([g(i) - h(i) $ i = 1..5],
           [0, 0, 0, 0, 0]):
g := combinat::countingFunctions::laplace(combinat::countingFunctions::D(f)):
h := combinat::countingFunctions::laplace(f) @ (n->n+1):
prog::test([g(i) - h(i) $ i = 1..5],
           [0, 0, 0, 0, 0]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::countingFunctions::invlaplace"):

g := combinat::countingFunctions::invlaplace(f):
prog::test([g(i) $ i = 0..5],
           [f(0), f(1), 1/2*f(2), 1/6*f(3), 1/24*f(4), 1/120*f(5)]):

// Coherence test: invlaplace and laplace are inverse transforms
g := combinat::countingFunctions::invlaplace(combinat::countingFunctions::laplace(f)):
prog::test([g(i) $ i = 0..5],
           [f(0), f(1), f(2), f(3), f(4), f(5)]):

prog::testexit():
//////////////////////////////////////////////////////////////////////////////

prog::check(combinat::countingFunctions, 3):


// Local Variables:
// mode: mupad
// End:
