/*****************************************************************************
  $Id $
  File:		lib/COMBINAT/TEST/freeTreesLabelled.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test suite for the domain combinat::freeTreesLabelled
  Created:	Mon Jan 12 15:54:36 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("freeTreesLabelled"):

alias(T=combinat::freeTreesLabelled):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(toListPrufer):
//////////////////////////////////////////////////////////////////////////////

// Check for each n>=2 that fromListPrufer and toListPrufer
// are reciprocal bijections between lists of n-2 integers
// between 1 and n, and freeTrees of size n.
// Cannot work for n=1 since we do not pass the n as argument
// to fromListPrufer

for n from 2 to 6 do
    g := combinat::cartesianProduct::generator([$1..n] $ n-2):
    while (l := g()) <> FAIL do
	tree := T::fromListPrufer(l);
	// Check that the result is a tree by verifying
	// that it has n-1 edges, and n nodes which are not isolated
	prog::test(nops(tree), n-1);
	prog::test(_union(e $ e in tree), {$1..n});
	// With this in mind, check that fromList and toList are inverse
	prog::test(T::toListPrufer(tree), l)
    end:
end_for:

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::freeTreesLabelled):
//////////////////////////////////////////////////////////////////////////////

prog::check(combinat::freeTreesLabelled, 3):

prog::testexit():

// Local Variables:
// mode: mupad
// End:
