/*****************************************************************************
  $Id: getOptions.tst,v 1.1.1.2 2004/10/04 17:25:16 nthiery Exp $
  File:		lib/PROG/TEST/getOptions.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the function 'combinat::getOptions'
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("getOptions"):

prog::testfunc(combinat::getOptions):

options:=table(a=1, b=NIL, c=FALSE, d=Mandatory):
optionsType:=table(a=Type::Integer, b=Type::Integer, c=DOM_BOOL):
Pref::typeCheck(Always):
/* Mandatory arguments not implemented, and no type checking
   on the default value
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0), 
           TrapError=1028):
end_proc():
*/
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0), 
           TrapError=1028):
end_proc(d=0):
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0),
           TrapError=1028):
end_proc(d=0, c=1):
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0), 
           TrapError=1028):
end_proc(d=0, c=TRUE):
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0),
           table(d = 0, c = TRUE, b = 1, a = 1)):
end_proc(d=0, c=TRUE, b=1):
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0),
           table(d = 0, c = TRUE, b = 1, a = 1)):
end_proc(d=0, c, b=1):
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0),
	       table(d = 0, c = FALSE, b = 1, a = 1)):
end_proc(d=0, b=1):
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0),
           table(d = 0, c = TRUE, b = 1, a = 1)):
end_proc(c, d=0, b=1):
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 1),
           table(d = 0, c = FALSE, b = 1, a = 1)):
end_proc(c, d=0, b=1):
/* Mandatory arguments not implemented
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 2),
           TrapError=1028):
end_proc(c, d=0, b=1):
*/
/* Why should it raise an error ?
 proc() begin
    prog::test(combinat::getOptions([a,b,c,d], optionsType, 0),
	       TrapError=1028):
end_proc(c, d=0, b=1):
*/
proc() begin
    prog::test(combinat::getOptions([a,b,c,d], optionsType, 0, Error),
           TrapError=1028):
end_proc(c, d=0, b=1, e):
options:=table(a=1, b=NIL, c=FALSE, d=Mandatory):
optionsType:=table(a=Type::Integer, b=Type::Integer, c=DOM_BOOL):
/* Mandatory arguments where not implemented
prog::test(combinat::getOptions(options, optionsType, 0),
           TrapError=1028):
prog::test(combinat::getOptions(options, optionsType, 0, d=0),
           TrapError=1028):
prog::test(combinat::getOptions(options, optionsType, 0, d=0, c=1),
           TrapError=1028):
prog::test(combinat::getOptions(options, optionsType, 0, d=0, c=TRUE),
           TrapError=1028):
*/
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0),
           table(d = 0, c = TRUE, b = 1, a = 1)):
end_proc(d=0, c=TRUE, b=1):
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0),
           table(d = 0, c = TRUE, b = 1, a = 1)):
end_proc(d=0, c, b=1):
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0),
           table(d = 0, c = FALSE, b = 1, a = 1)):
end_proc(d=0, b=1):
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0),
           table(d = 0, c = TRUE, b = 1, a = 1)):
end_proc(c, d=0, b=1):
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 1),
           table(d = 0, c = FALSE, b = 1, a = 1)):
end_proc(c, d=0, b=1):
/* Mandatory arguments where not implemented
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 2),
           TrapError=1028):
end_proc(c, d=0, b=1):
*/
proc() begin
    prog::test(combinat::getOptions(options, optionsType, 0, Error),
           TrapError=1028):
end_proc(c, d=0, b=1, e):
optionsType:=table(a=Type::Integer, b=Type::Integer, c=DOM_BOOL):
proc()
begin
    prog::test(combinat::getOptions([a,b,c,d], optionsType, 0, Error),
	       TrapError=1028):
end_proc(c, d=0, b=1, e):
/* Why should this raise an error ?
proc()
begin
    prog::test(combinat::getOptions([a,b,c,d,e], optionsType, 0, Error),
	       TrapError=1028):
end_proc(c, d=0, b=1, e):
*/
proc()
begin
    prog::test(combinat::getOptions([a,b,c,d,e], optionsType, 0),
	       table(e = TRUE, d = 0, c = TRUE, b = 1, a = 1)):
end_proc(a=1, c, d=0, b=1, e):
prog::testexit():

prog::check(combinat::getOptions, 3):

// Local Variables: 
// mode: mupad
// End:
