/*****************************************************************************
  $Id: independentSetsOfVectorSpace.tst,v 1.1.1.1 2005/01/26 13:42:24 nthiery Exp $
  File:		lib/COMBINAT/TEST/independentSetsOfVectorSpace.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test suite for the domain combinat::independentSetsOfVectorSpace
  Created:	Thu Dec 16 17:45:06 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("independentSetsOfVectorSpace"):

prog::testfunc("linearSpanGenerator"):
K:=Dom::IntegerMod(3):
M:= Dom::Matrix(K):

g := combinat::independentSetsOfVectorSpace::linearSpanGenerator(M([[1,2]])):
prog::test(combinat::generators::toList(g),
           [M([[0]]), M([[-1]]), M([[1]]), M([[1]]), M([[0]]), M([[-1]]), M([[-1]]), M([[1]]), M([[0]])]):

g := combinat::independentSetsOfVectorSpace::linearSpanGenerator(M([[1],[2]])):
prog::test(combinat::generators::toList(g),
           [M([[0], [0]]), M([[1], [-1]]), M([[-1], [1]])]):

g := combinat::independentSetsOfVectorSpace::linearSpanGenerator(M(2,0)):
prog::test(combinat::generators::toList(g),
           [M([[0], [0]])]):



K:= Dom::IntegerMod(2):
M:= Dom::Matrix(K):
g := combinat::independentSetsOfVectorSpace::generator(K, 0,0):
prog::test(combinat::generators::toList(g),
           [M([])]):
g := combinat::independentSetsOfVectorSpace::generator(K, 1,0):
prog::test(combinat::generators::toList(g),
           [M([[]])]):
g := combinat::independentSetsOfVectorSpace::generator(K, 1,1):
prog::test(combinat::generators::toList(g),
           [M([[1]])]):
g := combinat::independentSetsOfVectorSpace::generator(K, 2,0):
prog::test(combinat::generators::toList(g),
           [M([[], []])]):
g := combinat::independentSetsOfVectorSpace::generator(K, 2,1):
prog::test(combinat::generators::toList(g),
           [M([[0], [1]]), M([[1], [0]]), M([[1], [1]])]):
g := combinat::independentSetsOfVectorSpace::generator(K, 2,2):
prog::test(combinat::generators::toList(g),
           [M([[0, 1], [1, 0]]), M([[0, 1], [1, 1]]), M([[1, 0], [0, 1]]), M([[1, 1], [0, 1]]), M([[1, 0], [1, 1]]), M([[1, 1], [1, 0]])]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::independentSetsOfVectorSpace):
prog::testexit():
//////////////////////////////////////////////////////////////////////////////

prog::check(testDomain, 3):


// Local Variables:
// mode: mupad
// End:
