/*****************************************************************************
  $Id: integerMatrices.tst,v 1.1.1.6 2004/10/16 15:22:43 nthiery Exp $
  File:		lib/COMBINAT/TEST/integerMatrices.tst
  Authors:	Teresa Gomez-Diaz <Teresa.Gomez-Diaz@univ-mlv.fr>
                Florent Hivert <florent.hivert@univ-mlv.fr>
		Nicolas M. Thiry <nthiery@users.sourceforge.net>
		Authors of the combinat package of MuPAD 2.0.0
  Purpose:	Test file for the library 'combinat::integerMatrices'
  Created:	01/02/2003
  License:	LGPL
*****************************************************************************/

prog::testinit("integerMatrices", 9.1):
export(combinat, Alias, integerMatrices):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::integerMatrices::isA):
//////////////////////////////////////////////////////////////////////////////
prog::test(combinat::integerMatrices::isA([]),
           TRUE):
prog::test(combinat::integerMatrices::isA([]),
           TRUE):
prog::test(combinat::integerMatrices::isA([[1]]),
           TRUE):
prog::test(combinat::integerMatrices::isA([[1], [2]]),
           TRUE):
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2]]),
           TRUE):
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2, 3]]),
           FALSE):
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2]], [4, 4]),
           TRUE):
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2]], [4, 2]),
           FALSE):
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2]], [4, 4], [3, 2, 3]),
           TRUE):
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2]], [3, 2, 3], [4, 4]),
           FALSE):
if prog::TestNoTestargs = FALSE then
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2]], [4, 4], [3, 3, 3]),
           TrapError = 1028):
end_if:
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2]], [4, 5], [3, 3, 3]),
           FALSE):
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2]], [4, 4], [3, 2, 3], 0),
           TRUE):
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2]], [4, 4], [3, 2, 3], 1),
           FALSE):
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2]], [4, 4], [3, 2, 3], 0, 2),
           TRUE):
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2]], [4, 4], [3, 2, 3], 0, 1),
           FALSE):
prog::test(combinat::integerMatrices::isA([[1, 2], [2, 0], [1, 2]],
           combinat::integerMatrices::columnSums([[1, 2], [2, 0], [1, 2]]),
           combinat::integerMatrices::rowSums([[1, 2], [2, 0], [1, 2]]), 0, 2),
           TRUE):
prog::test(map(combinat::integerMatrices::list([2,0,5],[3,2,2]),
               ma -> combinat::integerMatrices::isA(ma, [2,0,5], [3,2,2], 0, 5)),
           [TRUE, TRUE, TRUE, TRUE, TRUE, TRUE]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(integerMatrices::nrows):
//////////////////////////////////////////////////////////////////////////////

prog::test(integerMatrices::nrows([]), 0):
prog::test(integerMatrices::nrows([[]]), 1):
prog::test(integerMatrices::nrows([[1,1,1]]), 1):
prog::test(integerMatrices::nrows([[1,1,1],[2,0,1]]), 2):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(integerMatrices::ncols):
//////////////////////////////////////////////////////////////////////////////
prog::test(integerMatrices::ncols([]), 0): // by convention
prog::test(integerMatrices::ncols([[]]), 0):
prog::test(integerMatrices::ncols([[1,1,1]]), 3):
prog::test(integerMatrices::ncols([[1,1,1],[2,0,1]]), 3):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(integerMatrices::isSquare):
//////////////////////////////////////////////////////////////////////////////
prog::test(integerMatrices::isSquare([])):
prog::test(integerMatrices::isSquare([[]]), FALSE):
prog::test(integerMatrices::isSquare([[1,1,1]]), FALSE):
prog::test(integerMatrices::isSquare([[1,1,1],[2,0,1]]), FALSE):
prog::test(integerMatrices::isSquare([[1,1,1],[2,0,1],[0,1,2]])):

/// count 
prog::testfunc(combinat::integerMatrices::count):

prog::test(combinat::integerMatrices::count([2,0,5],[3,2,2]), 6):

prog::test(combinat::integerMatrices::count([1,1,1,1,1],[1,1,1,1,1]), 120):

prog::test(combinat::integerMatrices::count([2 $ i=1..4], [2 $ i=1..4]), 282):

prog::test(combinat::integerMatrices::count([2,0,5],[3,2,2],0,3), 6):

prog::test(combinat::integerMatrices::count([2,0,5],[3,2,2],0,2), 3):

prog::test(combinat::integerMatrices::count([2,0,5],[3,2,2],0,1), 0):

prog::test(combinat::integerMatrices::count([2,0,5],[3,2,2],0,0), 0):

prog::test(combinat::integerMatrices::count([2,0,5],[3,2,2],1,3), 0):

prog::test(combinat::integerMatrices::count([2,0,5],[3,2,2],1,2), 0):

prog::test(combinat::integerMatrices::count([2 $ i=1..4], [2 $ i=1..4], 0, 2), 282):

/// list
prog::testfunc(combinat::integerMatrices::list):

prog::test(combinat::integerMatrices::list([0],[0]),
           [[[0]]]):
prog::test(combinat::integerMatrices::list([0, 0, 0], [0]),
           [[[0, 0, 0]]]):

prog::test(combinat::integerMatrices::list([0, 0, 0], [0, 0]),
           [[[0, 0, 0], [0, 0, 0]]]):

if prog::TestNoTestargs = FALSE then
prog::test(combinat::integerMatrices::list([0,0,0],[1,0,0]), 
           TrapError = 1028):
end_if:
prog::test(sort(combinat::integerMatrices::list([1,1],[1,1])),
           sort([[[1, 0], [0, 1]], [[0, 1], [1, 0]]])):

prog::test(combinat::integerMatrices::list([5, 2, 0], [7], 1),
           []): 

prog::test(combinat::integerMatrices::list([6 $ i=1..3], [6 $ i=1..3],0,2),
           [[[2, 2, 2], [2, 2, 2], [2, 2, 2]]]):

/// generator
prog::testfunc(combinat::integerMatrices::generator):

prog::test(bool(combinat::integerMatrices::list([2,0,5],[3,2,2]) = 
		combinat::generators::toList(
                    combinat::integerMatrices::generator([2,0,5],[3,2,2])))):

prog::test(bool(combinat::integerMatrices::list([],[]) =
		combinat::generators::toList(
                    combinat::integerMatrices::generator([],[])))):

/// a less trivial test
lc := combinat::compositions::list(6):
aleat := random(1..nops(lc)):
i := aleat():
j := aleat():
prog::test(bool(combinat::integerMatrices::list(lc[i], lc[j]) = 
		combinat::generators::toList(
                    combinat::integerMatrices::generator(lc[i], lc[j])))):

/// rowSums
prog::testfunc(combinat::integerMatrices::rowSums):

prog::test(bool(map(combinat::integerMatrices::list([2,2,2],[2,2,2]), 
		    combinat::integerMatrices::rowSums) =
                [[2,2,2]$ combinat::integerMatrices::count([2,2,2],[2,2,2])] )):

/// columnSums
prog::testfunc(combinat::integerMatrices::columnSums):

prog::test(bool(map(combinat::integerMatrices::list([2,2,2],[2,2,2]), 
		    combinat::integerMatrices::columnSums) = 
                [[2,2,2]$ combinat::integerMatrices::count([2,2,2],[2,2,2])] )):

/// standard
prog::testfunc(combinat::integerMatrices::standard):

prog::test(combinat::integerMatrices::standard([]),[]):

prog::test(
    combinat::integerMatrices::standard([[0,2,1],[1,1,0],[0,1,1]]),
    [4, 1, 2, 5, 6, 3, 7] ):

prog::test(bool(
    combinat::integerMatrices::standard([[0,2,1],[1,1,0],[0,1,1]]) =
    combinat::integerMatrices::standard([[0,2,1],[1,2,1]]))):

m1:=[[0,1,0],[1,0,0],[0,0,1],[0,1,0],[1,0,0],[0,0,1],[1,0,0]]:
m2:=[[0,1,0],[1,0,1],[0,1,0],[1,0,1],[1,0,0]]:
prog::test(bool(
    combinat::integerMatrices::standard(m1) =
    combinat::integerMatrices::standard(m2))):

ll:= combinat::permutations::list(4):
prog::test(
    [map(combinat::permutations::toMatrix(pp) $ pp in ll,
         mm -> combinat::integerMatrices::standard(coerce(mm, DOM_LIST)))],
    ll):

(C := bla[1]:
L := bla[2]:
prog::test(bool(
	   sort(map(combinat::integerMatrices::list(C,L), combinat::integerMatrices::standard), 
		combinat::integerVectors::_less) = 
	   sort(
		select(combinat::permutations::list(_plus(op(C))), z -> 
 		  _and(combinat::compositions::isFiner(C, combinat::permutations::descentsComposition(z)), 
		       combinat::compositions::isFiner(L, combinat::permutations::descentsComposition(
							     combinat::permutations::inverse(z))))),
		combinat::integerVectors::_less)))) $
bla in [[[1,3,2],[3,3]], [[2],[2]], [[1,2],[3]], [[3],[1,2]]]:		


/// fromStandard
prog::testfunc(combinat::integerMatrices::fromStandard):

prog::test(
    combinat::integerMatrices::fromStandard([2, 5, 7, 1, 4, 3, 6]),
    m2):

prog::test(
    combinat::integerMatrices::fromStandard([2, 5, 7, 1, 4, 3, 6], [3,2,2]),
    m2):

prog::test(
    combinat::integerMatrices::fromStandard([2, 5, 7, 1, 4, 3, 6], 
                                                        [3,2,2], [1,2,1,2,1]),
    m2):

prog::test(
    combinat::integerMatrices::fromStandard([2, 5, 7, 1, 4, 3, 6], 
                                                    [3,2,2], [1,1,1,1,1,1,1]),
    m1):

prog::test(
    combinat::integerMatrices::fromStandard([4,1,2,5,6,3,7]),
    [[0, 2, 1], [1, 2, 1]]):

prog::test(
    combinat::integerMatrices::fromStandard([4,1,2,5,6,3,7], 
                                                    [3,2,2], [3,2,2]),
    [[2, 0, 1], [1, 1, 0], [0, 1, 1]]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::integerMatrices::transpose):
//////////////////////////////////////////////////////////////////////////////
prog::test(integerMatrices::transpose([[1]]),
           [[1]]):
prog::test(integerMatrices::transpose([]),
           []):
prog::test(integerMatrices::transpose([[], []]),
           []):
prog::test(integerMatrices::transpose([[1], [2]]),
           [[1, 2]]):
prog::test(integerMatrices::transpose([[1, 2], [3, 4]]),
           [[1, 3], [2, 4]]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::integerMatrices::fromNonWeakDescentsComposition):
//////////////////////////////////////////////////////////////////////////////

prog::test(integerMatrices::fromNonWeakDescentsComposition([], [2, 2]),
           [[]]):
prog::test(integerMatrices::fromNonWeakDescentsComposition([0], [2, 2]),
           [[[0, 0, 0, 0]]]):
prog::test(integerMatrices::fromNonWeakDescentsComposition([0], [1, 1, 1, 1]),
           [[[0, 0, 0, 0]]]):
prog::test(integerMatrices::fromNonWeakDescentsComposition([0], []),
           [[[]]]):
prog::test(integerMatrices::fromNonWeakDescentsComposition([0, 0], []),
           [[[], []]]):
prog::test(integerMatrices::fromNonWeakDescentsComposition([0, 0], [1, 1, 1, 1]),
           [[[0, 0, 0, 0], [0, 0, 0, 0]]]):
prog::test(integerMatrices::fromNonWeakDescentsComposition([0, 0], [2]),
           [[[0, 0], [0, 0]]]):
prog::test(integerMatrices::fromNonWeakDescentsComposition([1, 0], []),
           []):
prog::test(integerMatrices::fromNonWeakDescentsComposition([3], [1, 1, 1, 1]),
           [[[3, 0, 0, 0]], [[2, 1, 0, 0]], [[2, 0, 1, 0]], [[2, 0, 0, 1]],
	    [[1, 2, 0, 0]], [[1, 1, 1, 0]], [[1, 1, 0, 1]], [[1, 0, 2, 0]],
	    [[1, 0, 1, 1]], [[1, 0, 0, 2]], [[0, 3, 0, 0]], [[0, 2, 1, 0]],
	    [[0, 2, 0, 1]], [[0, 1, 2, 0]], [[0, 1, 1, 1]], [[0, 1, 0, 2]],
	    [[0, 0, 3, 0]], [[0, 0, 2, 1]], [[0, 0, 1, 2]], [[0, 0, 0, 3]]]):
prog::test(integerMatrices::fromNonWeakDescentsComposition([1, 1], [2, 2]),
           [[[1, 0, 0, 0], [1, 0, 0, 0]], [[1, 0, 0, 0], [0, 1, 0, 0]], [[1, 0, 0, 0], [0, 0, 1, 0]], [[0, 0, 1, 0], [1, 0, 0, 0]], [[0, 0, 1, 0], [0, 0, 1, 0]], [[0, 0, 1, 0], [0, 0, 0, 1]]]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("toArray"):
//////////////////////////////////////////////////////////////////////////////

prog::test(combinat::integerMatrices::toArray([]),
           array(1..1, 1..1)):
prog::test(combinat::integerMatrices::toArray([[], [], []]),
           array(1..3, 1..1)):
prog::test(combinat::integerMatrices::toArray([[4, 2, 1], [1, 2, 3], [4, 5, 6]]),
           array(1..3, 1..3, (1,1) = 4, (1,2) = 2, (1,3) = 1, (2,1) = 1, (2,2) = 2, (2,3) = 3, (3,1) = 4, (3,2) = 5, (3,3) = 6)):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

// This is done at the end to ensure that as much as possible of the
// package is initialized. A recursive prog::init(combinat::integerMatrices)
// would be usefull here.

prog::testfunc(combinat::integerMatrices):
prog::testexit():

prog::check(combinat::integerMatrices, 3):


// Local Variables: 
// mode: mupad
// End:
