/*****************************************************************************
  $Id: integerVectors.tst,v 1.1.1.2 2004/10/04 17:25:17 nthiery Exp $
  File:		lib/COMBINAT/TEST/integerVectors.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  		Florent Hivert <florent.hivert@univ-mlv.fr>
		Authors of the combinat package of MuPAD 2.0.0
  Purpose:	Test file for the library 'combinat::integerVectors'
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("integerVectors", 5.1):

prog::testfunc(combinat::integerVectors::isA):
prog::test(combinat::integerVectors::isA([]),
           TRUE):
prog::test(combinat::integerVectors::isA([], 0),
           TRUE):
prog::test(combinat::integerVectors::isA([0], 0),
           TRUE):
prog::test(combinat::integerVectors::isA([0], 0, 1),
           TRUE):
prog::test(combinat::integerVectors::isA([], 0, 0),
           TRUE):
prog::test(combinat::integerVectors::isA([], 0, 1),
           FALSE):
prog::test(combinat::integerVectors::isA([], 1, 0),
           FALSE):
prog::test(combinat::integerVectors::isA([], 0, 0),
           TRUE):
prog::test(combinat::integerVectors::isA([3], 3),
           TRUE):
prog::test(combinat::integerVectors::isA([3], 2, 1),
           FALSE):
prog::test(combinat::integerVectors::isA([3], 2),
           FALSE):
prog::test(combinat::integerVectors::isA([3], 3, 1),
           TRUE):
prog::test(combinat::integerVectors::isA([3, 2, 2, 1]),
           TRUE):
prog::test(combinat::integerVectors::isA([3, 2, 2, 1], 9),
           FALSE):
prog::test(combinat::integerVectors::isA([3, 2, 2, 1], 9, 5),
           FALSE):
prog::test(combinat::integerVectors::isA([3, 2, 2, 1], 8),
           TRUE):
prog::test(combinat::integerVectors::isA([3, 2, 2, 1], 8, 5),
           FALSE):
prog::test(combinat::integerVectors::isA([3, 2, 2, 1], 8, 4),
           TRUE):
prog::test(combinat::integerVectors::isA([3, 2, 2, 1], 8, 4, MinPart = 1),
           TRUE):
prog::test(combinat::integerVectors::isA([3, 2, 2, 1], 8, 4, MinPart = 2),
           FALSE):


prog::testfunc(combinat::integerVectors::count):
prog::test(combinat::integerVectors::count(0,0),
           1):
prog::test(combinat::integerVectors::count(1,0),
           0):
prog::test(combinat::integerVectors::count(0,1),
           1):
prog::test(combinat::integerVectors::count(2,2),
           3):
prog::test(combinat::integerVectors::count(-1,0),
           0):
prog::test(combinat::integerVectors::count(-1,2),
           0):
prog::test(combinat::integerVectors::count(3, 3),
           10):
prog::test(combinat::integerVectors::count(3, 3, MinPart = 1),
           1):
prog::test(combinat::integerVectors::count(5, 3, MinPart = 1),
           6):
prog::test(combinat::integerVectors::count(13, 4, MinPart = 2, MaxPart = 4),
           16):

prog::testfunc(combinat::integerVectors::list):

// The order in which the integerVectors are listed is not in the
// specifications of combinat::integerVectors::list, so we sort the
// result before comparing.

prog::test(sort(combinat::integerVectors::list(0,0)),
           sort([[]])):
prog::test(sort(combinat::integerVectors::list(1,0)),
           sort([])):
prog::test(sort(combinat::integerVectors::list(0,1)),         
           sort([[0]])):
prog::test(sort(combinat::integerVectors::list(2,2)),   
           sort([[2,0],[1,1],[0,2]])):
prog::test(sort(combinat::integerVectors::list(-1,0)),
           sort([])):
prog::test(sort(combinat::integerVectors::list(-1,2)),
           sort([])):

prog::test(combinat::integerVectors::first(2,2), [2,0]):
prog::test(combinat::integerVectors::Next([2,0]), [1,1]):

// With MinPart option

prog::test(sort(combinat::integerVectors::list(-1,0, MinPart=1)),
           sort([])):
prog::test(sort(combinat::integerVectors::list(-1,2, MinPart=1)),
           sort([])):
prog::test(sort(combinat::integerVectors::list(0,0, MinPart=1)),
           sort([[]])):
prog::test(sort(combinat::integerVectors::list(3,0, MinPart=1)),
           sort([])):
prog::test(sort(combinat::integerVectors::list(0,1, MinPart=1)),
           sort([])):
prog::test(sort(combinat::integerVectors::list(2,2, MinPart=1)),
           sort([[1,1]])):
prog::test(sort(combinat::integerVectors::list(2,3, MinPart=1)),
           sort([])):
prog::test(sort(combinat::integerVectors::list(4,2, MinPart=1)),
            sort([[3,1],[2,2],[1,3]]) ):

// With Outer option

prog::test(sort(combinat::integerVectors::list(0, 3, Outer=[0,0,0])),
           sort([[0, 0, 0]])):
prog::test(sort(combinat::integerVectors::list(1, 3, Outer=[0,0,0])),
           sort([])):
prog::test(sort(combinat::integerVectors::list(2, 3, Outer=[0,2,0])),
           sort([[0, 2, 0]])):
prog::test(sort(combinat::integerVectors::list(2, 3, Outer=[1,2,1])),
           sort([[0, 1, 1], [0, 2, 0], [1, 0, 1], [1, 1, 0]])):
prog::test(sort(combinat::integerVectors::list(2, 3, Outer=[1,1,1])),
           sort([[1, 1, 0], [1, 0, 1], [0, 1, 1]])):
prog::test(sort(combinat::integerVectors::list(2, 5, Outer=[1,1,1,1,1])),
           sort([[1, 1, 0, 0, 0], [1, 0, 1, 0, 0], [1, 0, 0, 1, 0], [1, 0, 0, 0, 1],
                 [0, 1, 1, 0, 0], [0, 1, 0, 1, 0], [0, 1, 0, 0, 1], [0, 0, 1, 1, 0],
                 [0, 0, 1, 0, 1], [0, 0, 0, 1, 1]])):

prog::test(sort(_concat(combinat::integerVectors::list(i,3, Outer=[1,2,1])
                        $i=0..4)),
           sort([[0, 0, 0], [0, 0, 1], [0, 1, 0], [0, 1, 1], [0, 2, 0],
                 [0, 2, 1], [1, 0, 0], [1, 0, 1], [1, 1, 0], [1, 1, 1],
                 [1, 2, 0], [1, 2, 1]])):

// Since list is based on generator, we only check generator

for n from -2 to 6 do
    for k from 0 to 6 do
        prog::test(bool(combinat::integerVectors::count(n,k)=
			combinat::generators::count
			(combinat::integerVectors::generator(n,k)))):
    end_for;
end_for:

// check lexicographic comparison defined in integerListsLexStructure
prog::testfunc(combinat::integerVectors::_less):
prog::test(bool(combinat::integerVectors::_less([],[])), FALSE):
prog::test(bool(combinat::integerVectors::_less([],[2])), TRUE):
prog::test(bool(combinat::integerVectors::_less([1],[2])), TRUE):
prog::test(bool(combinat::integerVectors::_less([2],[1])), FALSE):
prog::test(bool(combinat::integerVectors::_less([1,3,2,4],[1,3,4,2])), TRUE):
prog::test(bool(combinat::integerVectors::_less([1,3,2],[1,3,2,4])), TRUE):
prog::test(bool(combinat::integerVectors::_less([1,3,2],[1,3,2])), FALSE):
prog::test(bool(combinat::integerVectors::_less([1,3,2,4],[1,3,2])), FALSE):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::integerVectors::fromNonWeakDescentsComposition):
//////////////////////////////////////////////////////////////////////////////

prog::test(combinat::integerVectors::fromNonWeakDescentsComposition(0, []),
           [[]]):
prog::test(combinat::integerVectors::fromNonWeakDescentsComposition(5, []),
           []):
prog::test(combinat::integerVectors::fromNonWeakDescentsComposition(0, [1]),
           [[0]]):
prog::test(combinat::integerVectors::fromNonWeakDescentsComposition(4, [1]),
           [[4]]):
prog::test(combinat::integerVectors::fromNonWeakDescentsComposition(4, [2]),
           [[4, 0], [3, 1], [2, 2]]):
prog::test(combinat::integerVectors::fromNonWeakDescentsComposition(4, [2, 2]),
           [[4, 0, 0, 0], [3, 1, 0, 0], [2, 2, 0, 0], [3, 0, 1, 0],
	    [2, 1, 1, 0], [2, 0, 2, 0], [2, 0, 1, 1], [1, 1, 2, 0],
	    [1, 1, 1, 1], [1, 0, 3, 0], [1, 0, 2, 1], [0, 0, 4, 0],
	    [0, 0, 3, 1], [0, 0, 2, 2]]):
prog::test(combinat::integerVectors::fromNonWeakDescentsComposition(5, [1, 1, 1]),
           [[5, 0, 0], [4, 1, 0], [4, 0, 1], [3, 2, 0], [3, 1, 1],
	    [3, 0, 2], [2, 3, 0], [2, 2, 1], [2, 1, 2], [2, 0, 3],
	    [1, 4, 0], [1, 3, 1], [1, 2, 2], [1, 1, 3], [1, 0, 4],
	    [0, 5, 0], [0, 4, 1], [0, 3, 2], [0, 2, 3], [0, 1, 4],
	    [0, 0, 5]]):
prog::test(combinat::integerVectors::fromNonWeakDescentsComposition(0, [2, 3]),
           [[0, 0, 0, 0, 0]]):



//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::integerVectors::_plus):
//////////////////////////////////////////////////////////////////////////////
prog::test(combinat::integerVectors::_plus(), []):
prog::test(combinat::integerVectors::_plus([1]), [1]):
prog::test(combinat::integerVectors::_plus([1,2]), [1,2]):
prog::test(combinat::integerVectors::_plus([1,2],[1]), [2,2]):
prog::test(combinat::integerVectors::_plus([1,2],[3,4]), [4,6]):
prog::test(combinat::integerVectors::_plus([1,2],[3,4,5]), [4,6,5]):
prog::test(combinat::integerVectors::_plus([1,2],[3,4,5],[0,0,0,0]), [4,6,5,0]):
prog::test(combinat::integerVectors::_plus([1,2],[3,4,5],[0,0,1,0]), [4,6,6,0]):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

// This is done at the end to ensure that as much as possible of the
// package is initialized. A recursive prog::init(combinat::integerVectors)
// would be usefull here.

prog::testfunc(combinat::integerVectors):
prog::testexit():

prog::check(combinat::integerVectors, 3):


// Local Variables: 
// mode: mupad
// End:
