/*****************************************************************************
  $Id: integerVectorsWeighted.tst,v 1.1.1.3 2004/10/04 17:25:16 nthiery Exp $
  File:		lib/COMBINAT/TEST/integerVectorsWeighted.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'combinat::integerVectorsWeighted'
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("integerVectorsWeighted", 1.3):

prog::testfunc(combinat::integerVectorsWeighted::isA):
prog::test(combinat::integerVectorsWeighted::isA([]),
           TRUE):
prog::test(combinat::integerVectorsWeighted::isA([], 0, []),
           TRUE):
prog::test(combinat::integerVectorsWeighted::isA([], 1, []),
           FALSE):
prog::test(combinat::integerVectorsWeighted::isA([3, 0, 0], 6, [2, 1, 1]),
           TRUE):
prog::test(combinat::integerVectorsWeighted::isA([1], 1, [1]),
           TRUE):
prog::test(combinat::integerVectorsWeighted::isA([1], 2, [2]),
           TRUE):
prog::test(combinat::integerVectorsWeighted::isA([2], 2, [1]),
           TRUE):
prog::test(combinat::integerVectorsWeighted::isA([2], 4, [2]),
           TRUE):
prog::test(combinat::integerVectorsWeighted::isA([2, 0], 4, [2, 2]),
           TRUE):
prog::test(combinat::integerVectorsWeighted::isA([2, 1], 4, [2, 2]),
           FALSE):
prog::test(combinat::integerVectorsWeighted::isA([2, 1], 6, [2, 2]),
           TRUE):
prog::test(combinat::integerVectorsWeighted::isA([2, 1, 0], 6, [2, 2]),
           FALSE):
prog::test(combinat::integerVectorsWeighted::isA([0], 0, []),
           FALSE):


prog::testfunc(combinat::integerVectorsWeighted::count):

prog::testfunc(combinat::integerVectorsWeighted::list):

// The order in which the integerVectorsWeighted are listed is not in
// the specifications of combinat::integerVectorsWeighted, so we sort
// the result before comparing.

for k from 0 to 10 do
    prog::test( bool(sort(combinat::integerVectorsWeighted::list(k,[1,1,1])) =
		     sort(combinat::integerVectors::list(k,3))));
end_for:
prog::test(      combinat::integerVectorsWeighted::list(7,[2,2]), [] ):
prog::test( bool(sort(combinat::integerVectorsWeighted::list(3,[2,1,1])) =
		 sort([[0, 0, 3], [0, 1, 2], [0, 2, 1], [1, 0, 1], [0, 3, 0], [1, 1, 0]]))):
for k from 0 to 10 do
    prog::test( bool(nops(combinat::integerVectorsWeighted::list(k,[2,3,7]))=
		     combinat::integerVectorsWeighted::count(k,[2,3,7])));
end_for:

// Compare the result with the expansion of (1+x1+x1^2...)*(1+x2+x2^2), ...
// where the weight of the xi is given by weights[i]

for weights in [[],[1], [2], [5], [2,3,1]] do
    maxd:=6;
    // The two dummy variables y,z ensure that the support of the terms
    // will be lists of integers
    P:=polylib::Poly([x.i $i=1..nops(weights),y,z]);
    p:=map(polylib::support(_mult(P(1),(_plus(P(x.i^k) $k=0..(maxd div weights[i])) $i=1..nops(weights)))),
	   t->[op(t,1..nops(weights))]);

    for d from 0 to maxd do
	prog::test(bool(sort(select(p, t->_plus(0,op(zip(t,weights,_mult)))=d)) =
			sort(combinat::integerVectorsWeighted::list(d,weights)))
		  );
    end_for;
end_for:

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

// This is done at then end to ensure as much as possible of the
// package is initialized. A recursive prog::init(combinat::subsets)
// would be usefull here.

prog::testfunc(combinat::integerVectorsWeighted):
prog::testexit():

prog::check(combinat::integerVectorsWeighted, 3):


// Local Variables: 
// mode: mupad
// End:
