/*****************************************************************************
  $Id: labelledBinaryTrees.tst,v 1.1.1.3 2004/10/04 17:25:17 nthiery Exp $
  File:		lib/COMBINAT/TEST/labelledBinaryTrees.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
                Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Test file for the library 'combinat::labelledBinaryTrees'
  Created:	27/06/2002
  License:	LGPL
*****************************************************************************/

prog::testinit("labelledBinaryTrees"):

alias(LBT=combinat::labelledBinaryTrees):
alias(l=LBT::dummyLabel):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(LBT::decreasingTree):
//////////////////////////////////////////////////////////////////////////////
prog::test(LBT::decreasingTree([]),
	   LBT([])):
prog::test(LBT::decreasingTree([1]),
	   LBT([1])):
prog::test(LBT::decreasingTree([1,2]),
	   LBT([2,[1], []])):
prog::test(LBT::decreasingTree([2,1]),
	   LBT([2,[], [1]])):
prog::test(LBT::decreasingTree([1,2,3,4]),
	   LBT([4,[3,[2,[1],[]], []], []])):
prog::test(LBT::decreasingTree([1,2,4,3]),
	   LBT([4,[2,[1], []], [3]])):
prog::test(LBT::decreasingTree([3,3,1,2,3]),
           LBT([3,[3,[3,[],[]],[2,[1,[],[]],[]]],[]])):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(LBT::searchTreeInsertLetter):
//////////////////////////////////////////////////////////////////////////////
prog::test(LBT::searchTreeInsertLetter(LBT([1]),1),
	   LBT([1, [1], []])):
prog::test(LBT::searchTreeInsertLetter(LBT([1]),0),
	   LBT([1, [0], []])):
prog::test(LBT::searchTreeInsertLetter(LBT([1]),2),
	   LBT([1, [], [2]])):
// LBT::searchTreeInsertWord is based on LBT::searchTreeInsertLetter
// so there is no need for other tests. 

prog::testfunc(LBT::searchTreeInsertWord):
prog::test(LBT::searchTreeInsertWord(LBT([]),[1]),
	   LBT([1])):
prog::test(LBT::searchTreeInsertWord(LBT([]),[2,1]),
	   LBT([2, [1], []])):
prog::test(LBT::searchTreeInsertWord(LBT([]),[5,4,3,2,1]),
	   LBT([5, [4, [3, [2, [1], []], []], []], []])):
prog::test(LBT::searchTreeInsertWord(LBT([]),[1,2,3,4,5]),
	   LBT([1, [], [2, [], [3, [], [4, [], [5]]]]])):

prog::testfunc(LBT::toWord):
for p in combinat::permutations(5) do
    prog::test(LBT::toWord(LBT::searchTreeInsertWord(LBT([]),p),Infix), sort(p));
end_for:

prog::testfunc(LBT::shape):
prog::test(LBT::shape(LBT([1, [], [2, [], [3, [], [4, [], [5]]]]])),
	   combinat::binaryTrees([l, [], [l, [], [l, [], [l, [], [l]]]]])):

prog::testfunc(LBT::fromShapeAndWord):
prog::test(LBT::fromShapeAndWord(LBT([]),
			       []),
	   LBT([])):
prog::test(LBT::fromShapeAndWord(LBT([1]), 
			       [1]),
	   LBT([1])):
prog::test(LBT::fromShapeAndWord(LBT([1, [1], []]), 
			       [1, 2], Infix),
	   LBT([2, [1], []])):
prog::test(LBT::fromShapeAndWord(LBT([1, [1], [1]]), 
			       [1, 2, 3], Infix),
	   LBT([2, [1], [3]])):
prog::test(LBT::fromShapeAndWord(LBT([1, [1], [1]]), 
			       [1, 2, 3], 
			       RightPostfix),
	   LBT([3, [2], [1]])):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

prog::testfunc(T):
prog::testexit():

prog::check(T, 3):

// Local Variables: 
// mode: mupad
// End:
