/*****************************************************************************
  $Id: lrcalc.tst,v 1.1.1.1 2004/10/04 17:25:16 nthiery Exp $
  File:		lib/COMBINAT/TEST/lrcalc.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test suite for the domain combinat::lrcalc
  Created:	Sun Jul 11 01:15:09 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("lrcalc"):

if module::which(hold(lrcalc)) = FAIL then
    warning("module lrcalc not available; not checking the combinat::lrcalc library");
else
// Get around a kernel crash in MuPAD 2.0.0
// when the module stdmod is loaded before another module
%if version()=[2,0,0] then
    module::displace(stdmod):
end_if:

lrcalc:=combinat::lrcalc:
// export(combinat, Alias, lrcalc): // does not work???

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(lrcalc::mult):

prog::test(sort(lrcalc::mult([],[])),
	   sort([[1, []]])):
prog::test(sort(lrcalc::mult([],[3,2])),
	   sort([[1, [3,2]]])):
prog::test(sort(lrcalc::mult([1],[1])),
	   sort([[1, [1, 1]], [1, [2]]])):
prog::test(sort(lrcalc::mult([2, 1],[2, 1])),
	   sort([[1, [3, 1, 1, 1]], [1, [2, 2, 1, 1]], [1, [4, 1, 1]], [2, [3, 2, 1]], [1, [2, 2, 2]], [1, [4, 2]], [1, [3, 3]]])):

lrcalc::mult([11,1],[14,3,1]): // should not segfault ...
// The following result has not yet been checked; it will only catch
// future changes
prog::test(lrcalc::mult([11, 3, 1], [14, 3, 1]),
           [[8, [22, 6, 3, 2]], [8, [18, 9, 3, 2, 1]],
	    [8, [22, 6, 4, 1]], [1, [25, 4, 2, 1, 1]],
	    [1, [16, 9, 6, 1, 1]], [1, [18, 7, 4, 4]],
	    [1, [19, 8, 2, 2, 1, 1]], [4, [19, 9, 2, 2, 1]],
	    [1, [18, 7, 5, 3]], [4, [17, 9, 5, 1, 1]],
	    [1, [18, 7, 6, 2]], [2, [19, 9, 2, 1, 1, 1]],
	    [4, [22, 7, 2, 2]], [1, [17, 8, 5, 1, 1, 1]],
	    [7, [18, 9, 4, 1, 1]], [7, [22, 7, 3, 1]],
	    [8, [19, 9, 3, 1, 1]], [4, [18, 8, 4, 3]],
	    [4, [18, 8, 5, 2]], [2, [18, 8, 6, 1]],
	    [5, [20, 9, 2, 1, 1]], [4, [22, 8, 2, 1]],
	    [1, [21, 4, 4, 2, 1, 1]], [2, [21, 9, 1, 1, 1]],
	    [1, [16, 11, 2, 2, 1, 1]], [4, [18, 9, 3, 3]],
	    [1, [20, 5, 3, 3, 2]], [1, [23, 6, 1, 1, 1, 1]],
	    [8, [18, 9, 4, 2]], [2, [21, 5, 4, 1, 1, 1]],
	    [5, [18, 9, 5, 1]], [2, [16, 12, 2, 1, 1, 1]],
	    [1, [14, 11, 5, 1, 1, 1]], [1, [22, 9, 1, 1]],
	    [1, [14, 14, 3, 1, 1]], [1, [20, 5, 4, 2, 2]],
	    [8, [18, 10, 3, 2]], [2, [20, 5, 4, 3, 1]],
	    [8, [18, 10, 4, 1]], [1, [15, 14, 2, 1, 1]],
	    [2, [21, 5, 3, 2, 2]], [4, [21, 5, 3, 3, 1]],
	    [1, [14, 11, 4, 4]], [1, [18, 7, 4, 2, 1, 1]],
	    [1, [14, 11, 5, 3]], [1, [16, 14, 1, 1, 1]],
	    [1, [14, 11, 6, 2]], [1, [15, 10, 3, 3, 2]],
	    [1, [22, 5, 2, 2, 2]], [1, [20, 9, 1, 1, 1, 1]],
	    [4, [18, 11, 2, 2]], [2, [20, 5, 5, 2, 1]],
	    [2, [18, 8, 4, 1, 1, 1]], [7, [18, 11, 3, 1]],
	    [6, [21, 5, 4, 2, 1]], [2, [14, 12, 4, 3]],
	    [2, [14, 12, 5, 2]], [1, [15, 10, 4, 2, 2]],
	    [1, [22, 3, 3, 3, 1, 1]], [1, [14, 12, 6, 1]],
	    [2, [15, 10, 4, 3, 1]], [8, [22, 5, 3, 2, 1]],
	    [4, [18, 12, 2, 1]], [2, [16, 10, 3, 2, 2]],
	    [2, [22, 4, 3, 2, 1, 1]], [4, [16, 10, 3, 3, 1]],
	    [4, [23, 5, 2, 2, 1]], [3, [21, 5, 5, 1, 1]],
	    [1, [15, 10, 4, 2, 1, 1]], [1, [14, 13, 3, 3]],
	    [1, [17, 10, 2, 2, 2]], [3, [22, 5, 3, 1, 1, 1]],
	    [2, [14, 13, 4, 2]], [1, [14, 13, 5, 1]],
	    [2, [15, 10, 5, 2, 1]], [1, [17, 12, 1, 1, 1, 1]],
	    [6, [22, 5, 4, 1, 1]], [2, [15, 11, 4, 1, 1, 1]],
	    [3, [23, 4, 3, 3]], [1, [18, 13, 1, 1]],
	    [4, [23, 4, 4, 2]], [6, [16, 10, 4, 2, 1]],
	    [7, [23, 5, 3, 1, 1]], [1, [14, 14, 3, 2]],
	    [1, [19, 6, 3, 3, 1, 1]], [8, [17, 10, 3, 2, 1]],
	    [1, [14, 14, 4, 1]], [4, [24, 5, 2, 1, 1]],
	    [1, [15, 10, 6, 1, 1]], [7, [23, 5, 3, 2]],
	    [2, [19, 7, 3, 2, 1, 1]], [4, [18, 10, 2, 2, 1]],
	    [6, [23, 5, 4, 1]], [1, [25, 5, 1, 1, 1]],
	    [4, [16, 10, 5, 1, 1]], [1, [19, 6, 4, 4]],
	    [3, [19, 8, 3, 1, 1, 1]], [1, [19, 6, 5, 3]],
	    [7, [17, 10, 4, 1, 1]], [1, [19, 6, 6, 2]],
	    [4, [23, 6, 2, 2]], [8, [18, 10, 3, 1, 1]],
	    [7, [23, 6, 3, 1]], [5, [19, 10, 2, 1, 1]],
	    [1, [16, 9, 3, 3, 1, 1]], [4, [19, 7, 4, 3]],
	    [1, [23, 4, 2, 2, 1, 1]], [4, [19, 7, 5, 2]],
	    [2, [19, 7, 6, 1]], [2, [20, 10, 1, 1, 1]],
	    [2, [16, 10, 3, 2, 1, 1]], [4, [23, 7, 2, 1]],
	    [1, [19, 6, 3, 3, 2]], [2, [23, 5, 2, 1, 1, 1]],
	    [1, [15, 12, 6]], [1, [15, 13, 5]],
	    [3, [16, 11, 3, 1, 1, 1]], [1, [15, 14, 4]],
	    [4, [19, 8, 3, 3]], [8, [19, 8, 4, 2]],
	    [5, [19, 8, 5, 1]], [1, [23, 8, 1, 1]],
	    [1, [19, 6, 4, 2, 2]], [2, [19, 6, 4, 3, 1]],
	    [1, [16, 11, 6]], [2, [16, 12, 5]],
	    [2, [16, 13, 4]], [2, [20, 6, 3, 2, 2]],
	    [1, [16, 14, 3]], [8, [19, 9, 3, 2]],
	    [1, [20, 7, 2, 2, 1, 1]], [4, [20, 6, 3, 3, 1]],
	    [8, [19, 9, 4, 1]], [1, [14, 11, 3, 3, 2]],
	    [1, [21, 6, 2, 2, 2]], [2, [20, 8, 2, 1, 1, 1]],
	    [1, [15, 10, 4, 4]], [2, [19, 6, 5, 2, 1]],
	    [1, [17, 10, 6]], [1, [18, 7, 5, 1, 1, 1]],
	    [1, [15, 10, 5, 3]], [2, [17, 11, 5]],
	    [1, [15, 10, 6, 2]], [3, [17, 12, 4]],
	    [2, [17, 13, 3]], [4, [19, 10, 2, 2]],
	    [6, [20, 6, 4, 2, 1]], [1, [17, 14, 2]],
	    [7, [19, 10, 3, 1]], [1, [14, 11, 4, 2, 2]],
	    [2, [14, 11, 4, 3, 1]], [8, [21, 6, 3, 2, 1]],
	    [1, [19, 6, 6, 1, 1]], [1, [18, 9, 6]],
	    [4, [15, 11, 4, 3]], [2, [18, 10, 5]],
	    [4, [15, 11, 5, 2]], [2, [15, 11, 3, 2, 2]],
	    [3, [18, 11, 4]], [2, [15, 11, 6, 1]],
	    [4, [15, 11, 3, 3, 1]], [2, [18, 12, 3]],
	    [4, [22, 6, 2, 2, 1]], [1, [17, 10, 2, 2, 1, 1]],
	    [4, [20, 6, 5, 1, 1]], [1, [18, 13, 2]],
	    [4, [19, 11, 2, 1]], [1, [24, 5, 1, 1, 1, 1]],
	    [1, [16, 11, 2, 2, 2]], [1, [22, 4, 4, 1, 1, 1]],
	    [2, [14, 11, 5, 2, 1]], [2, [17, 11, 2, 1, 1, 1]],
	    [7, [21, 6, 4, 1, 1]], [1, [19, 8, 6]],
	    [1, [15, 10, 5, 1, 1, 1]], [3, [15, 12, 3, 3]],
	    [2, [19, 9, 5]], [6, [15, 12, 4, 2]],
	    [3, [19, 10, 4]], [4, [15, 12, 5, 1]],
	    [6, [15, 11, 4, 2, 1]], [2, [19, 11, 3]],
	    [8, [22, 6, 3, 1, 1]], [1, [19, 12, 2]],
	    [1, [24, 3, 3, 3]], [1, [19, 12, 1, 1]],
	    [8, [16, 11, 3, 2, 1]], [5, [23, 6, 2, 1, 1]],
	    [1, [14, 11, 6, 1, 1]], [1, [20, 7, 6]],
	    [2, [20, 8, 5]], [4, [15, 13, 3, 2]],
	    [3, [20, 9, 4]], [1, [19, 6, 4, 2, 1, 1]],
	    [4, [17, 11, 2, 2, 1]], [4, [15, 13, 4, 1]],
	    [2, [24, 6, 1, 1, 1]], [4, [15, 11, 5, 1, 1]],
	    [2, [20, 10, 3]], [1, [20, 11, 2]],
	    [1, [21, 8, 1, 1, 1, 1]], [4, [24, 4, 3, 2]],
	    [2, [19, 7, 4, 1, 1, 1]], [3, [24, 4, 4, 1]],
	    [7, [16, 11, 4, 1, 1]], [1, [21, 6, 6]],
	    [2, [21, 7, 5]], [1, [20, 5, 4, 4]],
	    [1, [15, 14, 2, 2]], [3, [21, 8, 4]],
	    [1, [20, 5, 5, 3]], [8, [17, 11, 3, 1, 1]],
	    [2, [15, 14, 3, 1]], [2, [21, 9, 3]],
	    [1, [21, 10, 2]], [3, [24, 5, 2, 2]],
	    [5, [18, 11, 2, 1, 1]], [5, [24, 5, 3, 1]],
	    [1, [23, 3, 3, 2, 1, 1]], [2, [22, 6, 5]],
	    [2, [19, 11, 1, 1, 1]], [3, [22, 7, 4]],
	    [1, [16, 9, 4, 2, 1, 1]], [4, [20, 6, 4, 3]],
	    [2, [22, 8, 3]], [1, [18, 7, 3, 3, 2]],
	    [2, [23, 4, 3, 1, 1, 1]], [4, [20, 6, 5, 2]],
	    [1, [22, 9, 2]], [2, [20, 6, 6, 1]],
	    [1, [18, 11, 1, 1, 1, 1]], [2, [16, 10, 4, 1, 1, 1]],
	    [4, [24, 6, 2, 1]], [1, [23, 5, 5]],
	    [3, [23, 6, 4]], [4, [20, 7, 3, 3]],
	    [2, [23, 7, 3]], [1, [18, 7, 4, 2, 2]],
	    [8, [20, 7, 4, 2]], [1, [23, 8, 2]],
	    [1, [20, 5, 3, 3, 1, 1]], [2, [18, 7, 4, 3, 1]],
	    [5, [20, 7, 5, 1]], [1, [24, 7, 1, 1]],
	    [2, [19, 7, 3, 2, 2]], [2, [20, 6, 3, 2, 1, 1]],
	    [4, [19, 7, 3, 3, 1]], [2, [24, 5, 4]],
	    [1, [20, 7, 2, 2, 2]], [2, [24, 6, 3]],
	    [8, [20, 8, 3, 2]], [3, [20, 7, 3, 1, 1, 1]],
            [1, [24, 7, 2]], [2, [18, 7, 5, 2, 1]],
            [8, [20, 8, 4, 1]], [1, [16, 9, 4, 4]],
            [6, [19, 7, 4, 2, 1]], [1, [16, 9, 5, 3]],
            [1, [16, 9, 6, 2]], [1, [25, 4, 4]],
            [1, [25, 5, 3]], [4, [20, 9, 2, 2]],
            [8, [20, 7, 3, 2, 1]], [1, [25, 6, 2]],
            [1, [17, 8, 3, 3, 1, 1]], [1, [18, 7, 6, 1, 1]],
            [7, [20, 9, 3, 1]], [1, [14, 12, 3, 2, 2]],
            [2, [14, 12, 3, 3, 1]], [4, [21, 7, 2, 2, 1]],
            [2, [17, 9, 3, 2, 1, 1]], [4, [19, 7, 5, 1, 1]],
            [4, [16, 10, 4, 3]], [1, [24, 4, 2, 1, 1, 1]],
            [4, [16, 10, 5, 2]], [1, [15, 12, 2, 2, 2]],
            [2, [16, 10, 6, 1]], [3, [17, 10, 3, 1, 1, 1]],
            [7, [20, 7, 4, 1, 1]], [4, [20, 10, 2, 1]],
            [3, [14, 12, 4, 2, 1]], [8, [21, 7, 3, 1, 1]],
            [4, [16, 11, 3, 3]], [8, [16, 11, 4, 2]],
            [5, [16, 11, 5, 1]], [6, [15, 12, 3, 2, 1]],
            [5, [22, 7, 2, 1, 1]], [1, [14, 11, 3, 3, 1, 1]],
            [1, [20, 11, 1, 1]], [1, [21, 6, 2, 2, 1, 1]],
            [4, [16, 12, 2, 2, 1]], [2, [23, 7, 1, 1, 1]],
            [2, [14, 12, 5, 1, 1]], [1, [14, 12, 3, 2, 1, 1]],
            [1, [22, 3, 3, 3, 2]], [2, [21, 7, 2, 1, 1, 1]],
            [7, [16, 12, 3, 2]], [1, [19, 6, 5, 1, 1, 1]],
            [7, [16, 12, 4, 1]], [5, [15, 12, 4, 1, 1]],
            [1, [14, 13, 3, 1, 1, 1]], [1, [25, 3, 3, 2]],
            [7, [16, 12, 3, 1, 1]], [1, [21, 4, 4, 4]],
            [3, [16, 13, 2, 2]], [5, [17, 12, 2, 1, 1]],
            [5, [16, 13, 3, 1]], [1, [23, 3, 3, 2, 2]],
            [2, [23, 3, 3, 3, 1]], [1, [25, 4, 2, 2]],
            [1, [18, 9, 2, 2, 1, 1]], [2, [18, 12, 1, 1, 1]],
            [2, [25, 4, 3, 1]], [1, [17, 8, 3, 3, 2]],
            [2, [18, 10, 2, 1, 1, 1]], [1, [16, 9, 5, 1, 1, 1]],
            [4, [21, 5, 4, 3]], [2, [16, 14, 2, 1]],
            [3, [21, 5, 5, 2]], [2, [25, 5, 2, 1]],
            [1, [17, 8, 4, 2, 2]], [2, [17, 8, 4, 3, 1]],
            [2, [24, 3, 3, 2, 1]], [4, [21, 6, 3, 3]],
            [2, [18, 8, 3, 2, 2]], [8, [21, 6, 4, 2]],
            [1, [20, 5, 4, 2, 1, 1]], [4, [18, 8, 3, 3, 1]],
            [5, [21, 6, 5, 1]], [1, [15, 12, 2, 2, 1, 1]],
            [1, [25, 6, 1, 1]], [1, [19, 8, 2, 2, 2]],
            [1, [22, 7, 1, 1, 1, 1]], [2, [20, 6, 4, 1, 1, 1]],
            [2, [17, 8, 5, 2, 1]], [1, [15, 13, 2, 1, 1, 1]],
            [8, [21, 7, 3, 2]], [6, [18, 8, 4, 2, 1]],
            [8, [21, 7, 4, 1]], [1, [25, 3, 3, 1, 1]],
            [1, [17, 8, 4, 4]], [8, [19, 8, 3, 2, 1]],
            [1, [17, 8, 5, 3]], [1, [17, 8, 6, 1, 1]],
            [1, [17, 8, 6, 2]], [4, [21, 8, 2, 2]],
            [4, [20, 8, 2, 2, 1]], [1, [17, 8, 4, 2, 1, 1]],
            [4, [18, 8, 5, 1, 1]], [7, [21, 8, 3, 1]],
            [1, [24, 3, 3, 1, 1, 1]], [1, [19, 10, 1, 1, 1, 1]],
            [2, [17, 9, 4, 1, 1, 1]], [7, [19, 8, 4, 1, 1]],
            [4, [17, 9, 4, 3]], [4, [17, 9, 5, 2]],
            [2, [17, 9, 6, 1]], [8, [20, 8, 3, 1, 1]],
            [4, [21, 9, 2, 1]], [1, [21, 4, 3, 3, 1, 1]],
            [2, [14, 13, 3, 2, 1]], [5, [21, 8, 2, 1, 1]],
            [4, [17, 10, 3, 3]], [8, [17, 10, 4, 2]],
            [2, [21, 5, 3, 2, 1, 1]], [5, [17, 10, 5, 1]],
            [2, [15, 13, 2, 2, 1]], [2, [22, 8, 1, 1, 1]],
            [1, [14, 11, 4, 2, 1, 1]], [1, [21, 10, 1, 1]],
            [1, [21, 4, 3, 3, 2]], [3, [21, 6, 3, 1, 1, 1]],
            [1, [16, 13, 1, 1, 1, 1]], [2, [14, 13, 4, 1, 1]],
            [1, [14, 12, 4, 1, 1, 1]], [8, [17, 11, 3, 2]],
            [8, [17, 11, 4, 1]], [4, [15, 13, 3, 1, 1]],
            [1, [21, 4, 4, 2, 2]], [2, [21, 4, 4, 3, 1]],
            [1, [18, 7, 3, 3, 1, 1]], [4, [16, 13, 2, 1, 1]],
            [2, [22, 4, 3, 2, 2]], [4, [22, 4, 3, 3, 1]],
            [4, [17, 12, 2, 2]], [2, [18, 8, 3, 2, 1, 1]],
            [2, [17, 13, 1, 1, 1]], [7, [17, 12, 3, 1]],
            [1, [16, 9, 3, 3, 2]], [1, [23, 4, 2, 2, 2]],
            [3, [18, 9, 3, 1, 1, 1]], [4, [22, 4, 4, 2, 1]],
            [3, [22, 4, 4, 3]], [4, [17, 13, 2, 1]],
            [1, [16, 9, 4, 2, 2]], [2, [16, 9, 4, 3, 1]],
            [6, [23, 4, 3, 2, 1]], [1, [15, 10, 3, 3, 1, 1]],
            [2, [17, 9, 3, 2, 2]], [1, [22, 5, 2, 2, 1, 1]],
            [4, [17, 9, 3, 3, 1]], [2, [24, 4, 2, 2, 1]],
            [2, [15, 11, 3, 2, 1, 1]], [4, [22, 5, 3, 3]],
            [1, [17, 14, 1, 1]], [1, [18, 9, 2, 2, 2]],
            [2, [22, 6, 2, 1, 1, 1]], [7, [22, 5, 4, 2]],
            [1, [20, 5, 5, 1, 1, 1]], [3, [22, 5, 5, 1]],
            [2, [16, 9, 5, 2, 1]], [3, [23, 4, 4, 1, 1]],
            [2, [15, 12, 3, 1, 1, 1]], [6, [17, 9, 4, 2, 1]],
	    [4, [24, 4, 3, 1, 1]]]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(lrcalc::coprod):

prog::test(sort(lrcalc::coprod([])),
	   sort([[1, [[],[]]]])):
prog::test(sort(lrcalc::coprod([1])),
	   sort([[1, [[1],[]]]])):
prog::test(sort(lrcalc::coprod([2])),
	   sort([[1, [[2],[]]], [1, [[1],[1]]]])):
prog::test(sort(lrcalc::coprod([3])),
	   sort([[1, [[3],[]]], [1, [[2],[1]]]])):
prog::test(sort(lrcalc::coprod([3,2,1])),
	   sort([[1,[[3, 1],    [2]]],
		 [1,[[2, 2],    [1, 1]]],
		 [1,[[3, 1],    [1, 1]]],
		 [1,[[2, 1],    [3]]],
		 [2,[[2, 1],    [2, 1]]],
		 [1,[[2, 2, 1], [1]]],
		 [1,[[3, 2, 1], []]],
		 [1,[[3, 2],    [1]]],
		 [1,[[2, 1, 1], [2]]],
		 [1,[[3, 1, 1], [1]]],
		 [1,[[1, 1, 1], [2, 1]]],
		 [1,[[2, 1, 1], [1, 1]]],
		 [1,[[2, 2],    [2]]]])):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(lrcalc::lrcoef):

prog::test(lrcalc::lrcoef([],[],[]), 1):
prog::test(lrcalc::lrcoef([3,2,1],[2,1],[2,1]), 2):
prog::test(lrcalc::lrcoef([3,2],[3,2],[]), 1):
prog::test(lrcalc::lrcoef([3,2],[],[3,2]), 1):
prog::test(lrcalc::lrcoef([4],[2,1],[2,1]), 0):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(lrcalc::skew):

prog::test(sort(lrcalc::skew([],[])),
	   sort([[1,[]]])):
prog::test(sort(lrcalc::skew([7,4,3,1],[])),
	   sort([[1,[7,4,3,1]]])):
prog::test(sort(lrcalc::skew([3,2],[1])),
	   sort([[1,[2,2]],[1,[3,1]]])):
// Characterization of the _hash_next bug 2004/09/26
prog::test(lrcalc::skew([12, 6, 1], [6, 1]),
           [[1, [7, 4, 1]], [1, [12]], [1, [8, 3, 1]], [1, [9, 2, 1]], [1, [6, 6]], [1, [10, 1, 1]], [2, [7, 5]], [2, [8, 4]], [2, [9, 3]], [2, [10, 2]], [2, [11, 1]], [1, [6, 5, 1]]]):

//////////////////////////////////////////////////////////////////////////////
end_if:	// availability of lrcalc
prog::testexit():
//////////////////////////////////////////////////////////////////////////////

//prog::check(combinat::lrcalc, 3):


// Local Variables:
// mode: mupad
// End:
