/*****************************************************************************
  $Id $
  File:		lib/COMBINAT/TEST/lyndonWords.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test suite for the domain combinat::lyndonWords
  Created:	Wed Jan 28 23:42:48 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("lyndonWords"):

//////////////////////////////////////////////////////////////////////////////
//
prog::testfunc(combinat::lyndonWords):
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::lyndonWords::fromEvaluation):
//////////////////////////////////////////////////////////////////////////////

// count
prog::test(combinat::lyndonWords::fromEvaluation::count([]), 0):
prog::test(combinat::lyndonWords::fromEvaluation::count([2, 2]), 1):
prog::test(combinat::lyndonWords::fromEvaluation::count([2, 3, 2]), 30):

// generator
prog::test(combinat::lyndonWords::fromEvaluation([1]),
           [[1]]):
prog::test(combinat::lyndonWords::fromEvaluation([2]),
           []):
prog::test(combinat::lyndonWords::fromEvaluation([3]),
           []):
prog::test(combinat::lyndonWords::fromEvaluation([3, 1]),
           [[1, 1, 1, 2]]):
prog::test(combinat::lyndonWords::fromEvaluation([2, 2]),
           [[1, 1, 2, 2]]):
prog::test(combinat::lyndonWords::fromEvaluation([1, 3]),
           [[1, 2, 2, 2]]):
prog::test(combinat::lyndonWords::fromEvaluation([3, 3]),
           [[1, 1, 2, 2, 1, 2], [1, 1, 2, 1, 2, 2], [1, 1, 1, 2, 2, 2]]):
prog::test(combinat::lyndonWords::fromEvaluation([4, 3]),
           [[1, 1, 2, 1, 2, 1, 2], [1, 1, 2, 1, 1, 2, 2], [1, 1, 1, 2, 2, 1, 2], [1, 1, 1, 2, 1, 2, 2], [1, 1, 1, 1, 2, 2, 2]]):

// count and generator
for c in
    [[],[2,2],[3,2,7],[4,2]].combinat::compositions(3) do
    prog::test(bool
	       (combinat::lyndonWords::fromEvaluation::count(c) =
		combinat::generators::count
		(combinat::lyndonWords::fromEvaluation::generator(c))) )
end_for:

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::necklaces::fromContent):
//////////////////////////////////////////////////////////////////////////////

prog::test(combinat::lyndonWords::fromContent([A, A]),
           []):
prog::test(combinat::lyndonWords::fromContent([A, B]),
           [[A, B]]):
prog::test(combinat::lyndonWords::fromContent([A, A, B]),
           [[A, A, B]]):
prog::test(combinat::lyndonWords::fromContent([A, A, B, B]),
           [[A, A, B, B]]):
prog::test(combinat::lyndonWords::fromContent([A, A, A, B, B]),
           [[A, A, B, A, B], [A, A, A, B, B]]):

prog::testexit():

prog::check(test, 3):

// Local Variables:
// mode: mupad
// End:


