/*****************************************************************************
  $Id $
  File:		lib/COMBINAT/TEST/necklaces.tst
  Authors:	Xavier Molinero <molinero@lsi.upc.es>
           	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test suite for the domain combinat::necklaces
  Created:	Wed Jan 28 17:13:38 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("necklaces"):

//////////////////////////////////////////////////////////////////////////////
//
prog::testfunc(combinat::necklaces):
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::necklaces::fromEvaluation):
//////////////////////////////////////////////////////////////////////////////

// count
prog::test(combinat::necklaces::fromEvaluation::count([]), 0):
prog::test(combinat::necklaces::fromEvaluation::count([2, 2]), 2):
prog::test(combinat::necklaces::fromEvaluation::count([2, 3, 2]), 30):

// generator
prog::test(combinat::necklaces::fromEvaluation([]),
           []):
prog::test(combinat::necklaces::fromEvaluation([1]),
           [[1]]):
prog::test(combinat::necklaces::fromEvaluation([2]),
           [[1,1]]):
prog::test(combinat::necklaces::fromEvaluation([3]),
           [[1,1,1]]):
prog::test(combinat::necklaces::fromEvaluation([3, 3]),
           [[1, 2, 1, 2, 1, 2], [1, 1, 2, 2, 1, 2], [1, 1, 2, 1, 2, 2], [1, 1, 1, 2, 2, 2]]):
prog::test(combinat::necklaces::fromEvaluation([2, 1, 3]),
           [[1, 3, 2, 1, 3, 3], [1, 3, 1, 3, 3, 2], [1, 3, 1, 3, 2, 3], [1, 2, 3, 3, 1, 3], [1, 2, 3, 1, 3, 3], [1, 2, 1, 3, 3, 3], [1, 1, 3, 3, 3, 2], [1, 1, 3, 3, 2, 3], [1, 1, 3, 2, 3, 3], [1, 1, 2, 3, 3, 3]]):

// count and generator
for c in
    [[],[2,2],[3,2,7],[4,2]].combinat::compositions(3) do
    prog::test(bool
	       (combinat::necklaces::fromEvaluation::count(c) =
		combinat::generators::count
		(combinat::necklaces::fromEvaluation::generator(c))) )
end_for:

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::necklaces::fromContent):
//////////////////////////////////////////////////////////////////////////////

prog::test(combinat::necklaces::fromContent([]),
           []):
prog::test(combinat::necklaces::fromContent([A]),
           [[A]]):
prog::test(combinat::necklaces::fromContent([A, A, A, A]),
           [[A, A, A, A]]):
prog::test(combinat::necklaces::fromContent([A, A, A, B]),
           [[A, A, A, B]]):
prog::test(combinat::necklaces::fromContent([A, A, B, B]),
           [[A, B, A, B], [A, A, B, B]]):

prog::testexit():

prog::check(test, 3):

// Local Variables:
// mode: mupad
// End:

