/*****************************************************************************
  $Id: nonCrossingPartitions.tst,v 1.1.1.2 2004/10/04 17:25:17 nthiery Exp $
  File:		lib/COMBINAT/TEST/nonCrossingPartitions.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
		Authors of the combinat package of MuPAD 2.0.0
  Purpose:	Test file for the library 'combinat::nonCrossingPartitions'
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("nonCrossingPartitions",32.0):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("testtype"):
prog::test(testtype([], combinat::nonCrossingPartitions), FALSE):
prog::test(testtype({}, combinat::nonCrossingPartitions), TRUE):
prog::test(testtype({[1,2],[3]}, combinat::nonCrossingPartitions), TRUE):
prog::test(testtype({[1,3],[2]}, combinat::nonCrossingPartitions), TRUE):
prog::test(testtype({[1,3],[2,4]}, combinat::nonCrossingPartitions), FALSE):
prog::test(testtype({[3,1],[2]}, combinat::nonCrossingPartitions), TRUE):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("isA"):
prog::test(combinat::nonCrossingPartitions::isA({})):
prog::test(combinat::nonCrossingPartitions::isA([]), FALSE):
prog::test(combinat::nonCrossingPartitions::isA({[1]})):
prog::test(combinat::nonCrossingPartitions::isA({[2]}), FALSE):
prog::test(combinat::nonCrossingPartitions::isA({[1,2]})):
prog::test(combinat::nonCrossingPartitions::isA({[2,1]})):
prog::test(combinat::nonCrossingPartitions::isA({[1,2],[3]})):
prog::test(combinat::nonCrossingPartitions::isA({[2,1],[3]})):
prog::test(combinat::nonCrossingPartitions::isA({[2,1],[4]}), FALSE):
prog::test(combinat::nonCrossingPartitions::isA({[2,1],[3,4]})):
prog::test(combinat::nonCrossingPartitions::isA({[2,3],[1,4]})):
prog::test(combinat::nonCrossingPartitions::isA({[3,2],[1,4]})):
prog::test(combinat::nonCrossingPartitions::isA({[1,3],[2,4]}), FALSE):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("list"):
prog::test(nops({op(combinat::nonCrossingPartitions::list(i))}), 
	   combinat::nonCrossingPartitions::count(i)) $ i=1..8:
// The order in which the nonCrossingPartitions are listed is not in the
// specifications of combinat::nonCrossingPartitions::list, so we sort the
// result before comparing.

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("size"):
prog::test(map(combinat::nonCrossingPartitions(i), 
		combinat::nonCrossingPartitions::size), 
	    [i $ combinat::nonCrossingPartitions::count(i)]) $ i=0..4:

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

prog::testfunc(combinat::nonCrossingPartitions):
prog::testexit():
prog::check(combinat::nonCrossingPartitions, 3):

// Local Variables: 
// mode: mupad
// End:
