/*****************************************************************************
  $Id: parkingFunctions.tst,v 1.1.1.1 2005/01/26 13:42:24 nthiery Exp $
  File:		lib/COMBINAT/TEST/parkingFunctions.tst
  Authors:	Jean-Christophe Novelli <novelli@univ-mlv.fr>
  Purpose:	Test suite for the domain combinat::parkingFunctions
  Created:	Fri Nov  5 19:39:23 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("parkingFunctions", 10.0):

////////////////////////////////////////////////////////////////////////////////
// function isA test
////////////////////////////////////////////////////////////////////////////////


alias(PF =combinat::parkingFunctions):
alias(PFND =combinat::parkingFunctions::nonDecreasing):

prog::test(PF::isA([2, 3, 1, 4]), TRUE):
prog::test(PF::isA([2, 2, 1, 5]), FALSE):
prog::test(PF::isA([2, 2, 1, 3]), TRUE):
prog::test(PF::isA(combinat::permutations::random(12)), TRUE):
prog::test(PF::isA(combinat::permutations::random(22)), TRUE):
prog::test(PF::isA([1 $ 10]), TRUE):
prog::test(PF::isA([2 $ 10]), FALSE):
prog::test(PF::isA([1, 2 $ 10]), TRUE):
prog::test(PF::isA([1, 3 $ 10]), FALSE):
prog::test(PF::isA([a, a]), FALSE):
prog::test(PF::isA([a, 1]), FALSE):
prog::test(PF::isA([1, 0, 1]), FALSE):


////////////////////////////////////////////////////////////////////////////////
// function count
////////////////////////////////////////////////////////////////////////////////

prog::test(PF::count(0), 1):
prog::test(PF::count(4), 125):
prog::test(PF::count(6), 16807):
prog::test(PF::count([1, 1, 2]), 3):
prog::test(PF::count([1, 1, 3]), 3):
prog::test(PF::count([1, 2, 3]), 6):
prog::test(PF::count([1, 2, 3, 5]), 0):
prog::test(PF::count([a, a]), 0):

////////////////////////////////////////////////////////////////////////////////
// function list
////////////////////////////////////////////////////////////////////////////////

prog::test(PF::list(0), [[]]):
prog::test(PF::list(2), [[1, 1], [1, 2], [2, 1]]):
prog::test(PF::list(3),
      [[1, 1, 1], [1, 1, 2], [1, 2, 1], [2, 1, 1], [1, 2, 2], [2, 1, 2],
       [2, 2, 1], [1, 1, 3], [1, 3, 1], [3, 1, 1], [1, 2, 3], [1, 3, 2],
        [2, 1, 3], [2, 3, 1], [3, 1, 2], [3, 2, 1]]):
prog::test(PF::list([a, 1]), []):
prog::test(PF::list([1, 1]), [[1, 1]]):
prog::test(PF::list([1, 2]), [[1, 2], [2, 1]]):
prog::test(PF::list([1, 2, 2]), [[1, 2, 2], [2, 1, 2], [2, 2, 1]]):
prog::test(PF::list([1, 2, 4, 4]), []):

////////////////////////////////////////////////////////////////////////////////
// parkisation
////////////////////////////////////////////////////////////////////////////////

prog::test(PF::straighten([]), []):
prog::test(PF::straighten([3, 1]), [2, 1]):
prog::test(PF::straighten([5, 2, 3, 5, 5]), [3, 1, 2, 3, 3]):
prog::test(PF::straighten([11,10,10,10,6,2,7,8,2]), [7,6,6,6,3,1,4,5,1]):
prog::test(PF::straighten([5, 1, 1, 3, 5, 5]), [4, 1, 1, 3, 4, 4]):
prog::test(PF::straighten([5, 5]), [1, 1]):
prog::test(PF::straighten([5, 2, 5, 5, 5]), [2, 1, 2, 2, 2]):
prog::test(PF::straighten([0, 0, 0, 5, 5]), [1, 1, 1, 4, 4]):
prog::test(PF::straighten([0, 0, 0, 2, 2]), [1, 1, 1, 3, 3]):
prog::test(PF::straighten([-1, -1, 2]), [1, 1, 3]):
prog::test(PF::straighten([-1, -1, 8]), [1, 1, 3]):
prog::test(PF::straighten([-1, -1, 0]), [1, 1, 2]):
prog::test(PF::straighten([-1, -1, 0]), [1, 1, 2]):
prog::test(PF::straighten([1, 1, 10]), [1, 1, 3]):

////////////////////////////////////////////////////////////////////////////////
// deparkisation
////////////////////////////////////////////////////////////////////////////////

prog::test(PF::deparkisation([1, 3, 1, 1, 2, 6, 6], 0),
           [[1, 3, 1, 1, 2, 6, 6]]):

prog::test(PF::deparkisation([5,4,7,1,2,1,1,4,6], 0),
           [[5, 4, 7, 1, 2, 1, 1, 4, 6]]):

prog::test(PF::deparkisation([5,4,7,1,2,1,1,4,6], 1),
           [[5, 4, 7, 1, 2, 1, 1, 4, 6], [6, 5, 8, 2, 3, 2, 2, 5, 7]]):

prog::test(PF::deparkisation([1, 1, 2], 1),
           [[1, 1, 2], [2, 2, 3]]):

prog::test(PF::deparkisation([1, 1, 3], 1),
           [[1, 1, 3], [2, 2, 4], [1, 1, 4]]):

prog::test(PF::deparkisation([1, 2, 3], 1),
           [[1, 2, 3], [2, 3, 4], [1, 3, 4], [1, 2, 4]]):

prog::test(PF::deparkisation([2, 2, 1], 1),
           [[2, 2, 1], [3, 3, 2], [3, 3, 1]]):

prog::test(PF::deparkisation([2, 4, 2, 1], 3),
           [[2, 4, 2, 1], [3, 5, 3, 2], [3, 5, 3, 1], [2, 5, 2, 1],
            [4, 6, 4, 3], [4, 6, 4, 2], [3, 6, 3, 2], [4, 6, 4, 1],
            [3, 6, 3, 1], [2, 6, 2, 1], [5, 7, 5, 4], [5, 7, 5, 3],
            [4, 7, 4, 3], [5, 7, 5, 2], [4, 7, 4, 2], [3, 7, 3, 2],
            [5, 7, 5, 1], [4, 7, 4, 1], [3, 7, 3, 1], [2, 7, 2, 1]]):

prog::test(PF::deparkisation([2, 1, 4, 2, 1], 5),
           [[2, 1, 4, 2, 1], [3, 2, 5, 3, 2], [4, 3, 6, 4, 3],
            [5, 4, 7, 5, 4], [6, 5, 8, 6, 5], [7, 6, 9, 7, 6]]):

prog::test(bool(sort(select(combinat::words(7, 4), z ->
             PF::word2Parking(z)=[1,4,2,1])) =
             sort(PF::deparkisation([1,4,2,1], 3))),
           TRUE):

for park in PF(2) do
prog::test(bool(sort(select(combinat::words(8,2),
                            z->PF::word2Parking(z)=park )) =
                            sort(PF::deparkisation(park,8-max(op(park))))),
           TRUE):
end_for:

for park in PF(3) do
prog::test(bool(sort(select(combinat::words(6,3),
                            z->PF::word2Parking(z)=park )) =
                            sort(PF::deparkisation(park,6-max(op(park))))),
           TRUE):
end_for:

////////////////////////////////////////////////////////////////////////////////
// deconcatenation and shifted concatenation
////////////////////////////////////////////////////////////////////////////////

for park in PF(3) do
 prog::test(bool( park = PF::shiftedConcatenation(PF::park2Connected(park))),
           TRUE):
end_for:

for park in PF(5) do
prog::test(bool( park = PF::shiftedConcatenation(PF::park2Connected(park))),
           TRUE):
end_for:

prog::test(PF::park2Connected([4, 1, 2, 1, 5, 7, 5]), [[4,1,2,1], [1,3,1]]):
prog::test(PF::park2Connected([1, 2, 1, 5, 6, 1, 5]), [[1,2,1,5,6,1,5]]):
prog::test(PF::park2Connected([3, 1, 2, 1, 5, 6, 5]), [[3,1,2,1], [1,2,1]]):
prog::test(PF::park2Connected([3,1,2,6,4,5,9,10,7,8]),
           [[3, 1, 2], [3, 1, 2], [3, 4, 1, 2]]):
prog::test(PF::park2ConnectedLeft([3, 1, 2, 4]), [[3, 1, 2, 4]]):
prog::test(PF::park2ConnectedLeft([5,5,7,6,4,2,1,1]),
           [[1, 1, 3, 2], [1], [2, 1, 1]]):

////////////////////////////////////////////////////////////////////////////////
// primitive
////////////////////////////////////////////////////////////////////////////////

prog::test(PF::prime(3),
           [[1, 1, 1], [1, 1, 2], [1, 2, 1], [2, 1, 1]]):

prog::test(PF::prime(4),
           [[1, 1, 1, 1], [1, 1, 1, 2], [1, 1, 2, 1], [1, 2, 1, 1], [2,1,1,1],
            [1, 1, 2, 2], [1, 2, 1, 2], [1, 2, 2, 1], [2, 1, 1, 2], [2,1,2,1],
            [2, 2, 1, 1], [1, 1, 1, 3], [1, 1, 3, 1], [1, 3, 1, 1], [3,1,1,1],
            [1, 1, 2, 3], [1, 1, 3, 2], [1, 2, 1, 3], [1, 2, 3, 1], [1,3,1,2],
            [1, 3, 2, 1], [2, 1, 1, 3], [2, 1, 3, 1], [2, 3, 1, 1], [3,1,1,2],
            [3, 1, 2, 1], [3, 2, 1, 1]]):

prog::test(nops(PF::prime(4)), 3^3):
prog::test(nops(PF::prime(5)), 4^4):
prog::test(nops(PF::prime(6)), 5^5):

prog::test(PF::breaks([3, 1, 2, 2, 6, 5]), [1, 4, 5, 6]):
prog::test(PF::breaks([3, 1, 2, 2, 6, 5, 5]), [1, 4, 7]):
prog::test(PF::breaks([4, 1, 1, 1, 3]), [5]):

prog::test(PF::type([3, 1, 2, 2, 6, 5]), [1, 3, 1, 1]):
prog::test(PF::type([3, 1, 2, 2, 6, 5, 5]), [1, 3, 3]):
prog::test(PF::type([4, 1, 1, 1, 3]), [5]):
prog::test(bool(PF::type([3, 1, 2, 2, 6, 5]) =
          combinat::compositions::fromDescents(PF::breaks([3, 1, 2, 2, 6, 5]))),
           TRUE):

prog::test(PF::fromType([3]), [[1, 1, 1], [1, 1, 2], [1, 2, 1], [2, 1, 1]]):
prog::test(PF::fromType([2, 1]), [[1, 1, 3], [1, 3, 1], [3, 1, 1]]):
prog::test(PF::fromType([1, 2]), [[1, 2, 2], [2, 1, 2], [2, 2, 1]]):
prog::test(PF::fromType([1, 1, 1]),
           [[1, 2, 3], [1, 3, 2], [2, 1, 3], [2, 3, 1], [3, 1, 2], [3,2,1]]):
prog::test(PF::fromType([3, 2]),
           [[1, 1, 1, 4, 4], [1, 1, 4, 1, 4], [1, 1, 4, 4, 1], [1,4,1,1,4],
            [1, 4, 1, 4, 1], [1, 4, 4, 1, 1], [4, 1, 1, 1, 4], [4,1,1,4,1],
            [4, 1, 4, 1, 1], [4, 4, 1, 1, 1], [1, 1, 2, 4, 4], [1,1,4,2,4],
            [1, 1, 4, 4, 2], [1, 2, 1, 4, 4], [1, 2, 4, 1, 4], [1,2,4,4,1],
            [1, 4, 1, 2, 4], [1, 4, 1, 4, 2], [1, 4, 2, 1, 4], [1,4,2,4,1],
            [1, 4, 4, 1, 2], [1, 4, 4, 2, 1], [2, 1, 1, 4, 4], [2,1,4,1,4],
            [2, 1, 4, 4, 1], [2, 4, 1, 1, 4], [2, 4, 1, 4, 1], [2,4,4,1,1],
            [4, 1, 1, 2, 4], [4, 1, 1, 4, 2], [4, 1, 2, 1, 4], [4,1,2,4,1],
            [4, 1, 4, 1, 2], [4, 1, 4, 2, 1], [4, 2, 1, 1, 4], [4,2,1,4,1],
            [4, 2, 4, 1, 1], [4, 4, 1, 1, 2], [4, 4, 1, 2, 1], [4,4,2,1,1]]):


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// subdomain nonDecreasing
////////////////////////////////////////////////////////////////////////////////

prog::test(PFND(3),
           [[1, 1, 1], [1, 1, 2], [1, 2, 2], [1, 1, 3], [1, 2, 3]]):

prog::test(PFND(4),
           [[1, 1, 1, 1], [1, 1, 1, 2], [1, 1, 2, 2], [1, 1, 1, 3], [1,2,2,2],
            [1, 1, 2, 3], [1, 1, 1, 4], [1, 2, 2, 3], [1, 1, 3, 3], [1,1,2,4],
            [1, 2, 3, 3], [1, 2, 2, 4], [1, 1, 3, 4], [1, 2, 3, 4]]):

prog::test(PFND::prime(3), [[1, 1, 1], [1, 1, 2]]):

prog::test(PFND::prime(4),
           [[1, 1, 1, 1], [1, 1, 1, 2], [1, 1, 2, 2], [1, 1, 1, 3],
            [1, 1, 2, 3]]):

prog::test(PFND::prime(5),
           [[1, 1, 1, 1, 1], [1, 1, 1, 1, 2], [1, 1, 1, 2, 2], [1,1,1,1,3],
            [1, 1, 2, 2, 2], [1, 1, 1, 2, 3], [1, 1, 1, 1, 4], [1,1,2,2,3],
            [1, 1, 1, 3, 3], [1, 1, 1, 2, 4], [1, 1, 2, 3, 3], [1,1,2,2,4],
            [1, 1, 1, 3, 4], [1, 1, 2, 3, 4]]):

prog::test(nops(PFND::prime(7)), combinat::catalan(6)):
prog::test(nops(PFND::prime(8)), combinat::catalan(7)):

prog::test(PFND::breaks([1, 1, 1]), [3]):
prog::test(PFND::breaks([1, 1, 2]), [3]):
prog::test(PFND::breaks([1, 1, 3]), [2, 3]):
prog::test(PFND::breaks([1, 2, 2]), [1, 3]):
prog::test(PFND::breaks([1, 2, 3]), [1, 2, 3]):
prog::test(PFND::breaks([1, 1, 3, 3, 4, 6, 6, 7, 8, 10]), [2, 5, 9, 10]):

prog::test(PFND::type([1,1,2,3,5,5,6,8,8,10]), [4, 3, 2, 1]):
prog::test(PFND::type([1, 1, 2, 4, 4, 4, 4, 7, 9]), [3, 5, 1]):
prog::test(PFND::type([1$3, 4$1, 5$4, 9$1, 10$5]), [3, 1, 4, 1, 5]):

prog::test(PFND::fromType([1, 2, 3]),
           [[1, 2, 2, 4, 4, 4], [1, 2, 2, 4, 4, 5]]):

prog::test(PFND::fromType([3, 3]),
           [[1, 1, 1, 4, 4, 4], [1, 1, 1, 4, 4, 5], [1, 1, 2, 4, 4, 4],
            [1, 1, 2, 4, 4, 5]]):

prog::test(PFND::fromType([4, 3]),
           [[1, 1, 1, 1, 5, 5, 5], [1, 1, 1, 1, 5, 5, 6], [1,1,1,2,5,5,5],
            [1, 1, 1, 2, 5, 5, 6], [1, 1, 2, 2, 5, 5, 5], [1,1,2,2,5,5,6],
            [1, 1, 1, 3, 5, 5, 5], [1, 1, 1, 3, 5, 5, 6], [1,1,2,3,5,5,5],
            [1, 1, 2, 3, 5, 5, 6]]):

prog::test(PFND::fromType([4, 1]),
           [[1, 1, 1, 1, 5], [1, 1, 1, 2, 5], [1, 1, 2, 2, 5],
            [1, 1, 1, 3, 5], [1, 1, 2, 3, 5]]):

prog::test(PFND::park2Connected([1, 1, 1]), [[1, 1, 1]]):
prog::test(PFND::park2Connected([1, 1, 2]), [[1, 1, 2]]):
prog::test(PFND::park2Connected([1, 1, 3]), [[1, 1], [1]]):
prog::test(PFND::park2Connected([1,2,2]), [[1], [1, 1]]):
prog::test(PFND::park2Connected([1,2,3]), [[1], [1], [1]]):
prog::test(PFND::park2Connected([1,1,2,3,5,5,6,8,8,10]),
           [[1, 1, 2, 3], [1, 1, 2], [1, 1], [1]]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::parkingFunctions):
prog::testexit():
//////////////////////////////////////////////////////////////////////////////

prog::check(PF, 3):
prog::check(PFND, 3):

// Local Variables:
// mode: mupad
// End:
