/*****************************************************************************
  $Id: partitions.tst,v 1.1.1.4 2005/01/26 13:42:24 nthiery Exp $
  File:		lib/COMBINAT/TEST/partitions.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
		Authors of the combinat package of MuPAD 2.0.0
  Purpose:	Test file for the library 'combinat::partitions'
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("partitions", 10.0):


prog::testfunc(combinat::partitions::typeWithZeroes):
prog::test(testtype([3, 2, 0, 1, 0], combinat::partitions::typeWithZeroes),
           FALSE):
prog::test(testtype([3, 2, 1, 0], combinat::partitions::typeWithZeroes),
           TRUE):
prog::test(testtype([3, 2, 1, 0], combinat::partitions),
           FALSE):

prog::testfunc(combinat::partitions::isA):
prog::test(combinat::partitions::isA([])):
prog::test(combinat::partitions::isA([0]), FALSE):
prog::test(combinat::partitions::isA([1,2]), FALSE):
prog::test(combinat::partitions::isA([2,1])):
prog::test(combinat::partitions::isA([2,1,0]), FALSE):
prog::test(combinat::partitions::isA([2,2,2,1])):	   
prog::test(combinat::partitions::isA([3,3,1])):
prog::test(combinat::partitions::isA([3,3,1], MaxPart=3)):
prog::test(combinat::partitions::isA([3,3,1], MaxPart=2), FALSE):
prog::test(combinat::partitions::isA([3,3,1], MaxPart=4)):
prog::test(combinat::partitions::isA([3,3,1], 7)):
prog::test(combinat::partitions::isA([3,3,1], 8), FALSE):
prog::test(combinat::partitions::isA([3,3,1], 5), FALSE):
prog::test(combinat::partitions::isA([3,3,1,0], 7, MaxPart=3), FALSE):
prog::test(combinat::partitions::isA([3,3,1], 7, MaxPart=3)):
prog::test(combinat::partitions::isA([3,3,1], 8, MaxPart=3), FALSE):
prog::test(combinat::partitions::isA([3,3,1], 7, MaxPart=2), FALSE):
prog::test(combinat::partitions::isA([3,3,1], 7, MaxPart=4)):

prog::testfunc(combinat::partitions::isAWithZeroes):
prog::test(combinat::partitions::isAWithZeroes([])):
prog::test(combinat::partitions::isAWithZeroes([0]), TRUE):
prog::test(combinat::partitions::isAWithZeroes([1,2]), FALSE):
prog::test(combinat::partitions::isAWithZeroes([2,1])):
prog::test(combinat::partitions::isAWithZeroes([2,1,0])):
prog::test(combinat::partitions::isAWithZeroes([2,2,2,1])):	   
prog::test(combinat::partitions::isAWithZeroes([2,2,2,1,0])):	   
prog::test(combinat::partitions::isAWithZeroes([3,3,1,0])):
prog::test(combinat::partitions::isAWithZeroes([3,1,3,1,0]), FALSE):
prog::test(combinat::partitions::isAWithZeroes([3,3,1,0], MaxPart=3)):
prog::test(combinat::partitions::isAWithZeroes([3,3,1,0], MaxPart=2), FALSE):
prog::test(combinat::partitions::isAWithZeroes([3,3,1,0], MaxPart=4)):

prog::testfunc(combinat::partitions::count):

prog::test(combinat::partitions::count(266),779050629562167):
prog::test(combinat::partitions::count(13, MinPart = 2, MaxPart = 4),
           5):
prog::test(combinat::partitions::count(1, MinPart = 2, MaxPart = 4),
           0):
prog::test(combinat::partitions::count(2, MinPart = 2, MaxPart = 4),
           1):
prog::test(combinat::partitions::count(4, MinPart = 2, MaxPart = 4),
           2):

/* from Richard Brent 40+ digit factors found by ECM
  ftp://nimbus.anu.edu.au/pub/Brent/champs.ecm */
prog::test(combinat::partitions::count(19069) mod
	27885873044042449777540626664487051863162949,0):
prog::test(combinat::partitions::count(19997) mod
	5688864305048653702791752405107044435136231,0):


prog::testfunc(combinat::partitions::first):

prog::test(combinat::partitions::first(0), []):
prog::test(combinat::partitions::first(10), [10]):
prog::test(combinat::partitions::first(7, MaxLength=2, MaxPart=4), [4,3]):
prog::test(combinat::partitions::first(7, MaxLength=2, MaxPart=3), FAIL):
prog::test(combinat::partitions::first(7, MaxPart=3), [3,3,1]):

prog::testfunc(combinat::partitions::list):

// The order in which the partitions are listed is not in the
// specifications of combinat::partitions::list, so we sort the
// result before comparing.

prog::test(sort(combinat::partitions::list(0)),
           sort([[]]) ):
prog::test(sort(combinat::partitions::list(1)),
           sort([[1]])):
prog::test(sort(combinat::partitions::list(2)),   
           sort([[2],[1,1]])):
prog::test(sort(combinat::partitions::list(3, Length=2)),
           sort([[2,1]])):
prog::test(sort(combinat::partitions::list(3, Length=2, MinPart=0)),
           sort([[3,0],[2,1]])):
prog::test(sort(combinat::partitions::list(0, MaxLength=0)),
           sort([[]])):
prog::test(sort(combinat::partitions::list(3, MaxLength=0)),
           sort([])):
prog::test(sort(combinat::partitions::list(3, MaxLength=2)),
           sort([[3],[2,1]])):
prog::test(sort(combinat::partitions::list(9, MaxLength=2, MaxPart=4)), 
           sort([])):
prog::test(sort(combinat::partitions::list(4, MaxPart=3)),
           sort([[3, 1], [2, 2], [2, 1, 1], [1, 1, 1, 1]])):
prog::test(sort(combinat::partitions::list(4, MaxPart=2)),
           sort([[2, 2], [2, 1, 1], [1, 1, 1, 1]])):
prog::test(sort(combinat::partitions::list(7, MaxLength=2, MaxPart=4)), 
           sort([[4,3]])):
prog::test(sort(combinat::partitions::list(6, MaxLength=2, MaxPart=4)),
           sort([[4, 2], [3, 3]])):
prog::test(sort(combinat::partitions::list(4, MaxPart=2, MinPart=2)),
           sort([[2, 2]])):
prog::test(sort(combinat::partitions::list(7, MaxPart=3)),
           sort([[3, 3, 1], [3, 2, 2], [3, 2, 1, 1],
                 [3, 1, 1, 1, 1], [2, 2, 2, 1], [2, 2, 1, 1, 1],
                 [2, 1, 1, 1, 1, 1], [1, 1, 1, 1, 1, 1, 1]])):
prog::test(sort(combinat::partitions::list(8, MaxPart=2, MinPart=2, Length=3)),
           sort([])):
prog::test(sort(combinat::partitions::list(8, MaxPart=2, MinPart=2, Length=4)),
           sort([[2, 2, 2, 2]])):
prog::test(sort(combinat::partitions::list(8, Length=4, MinPart=0)),
           sort([[8, 0, 0, 0], [7, 1, 0, 0], [6, 2, 0, 0], [6, 1, 1, 0],
                 [5, 3, 0, 0], [5, 2, 1, 0], [5, 1, 1, 1], [4, 4, 0, 0], 
                 [4, 3, 1, 0], [4, 2, 2, 0], [4, 2, 1, 1], [3, 3, 2, 0],
                 [3, 3, 1, 1], [3, 2, 2, 1], [2, 2, 2, 2]])):
prog::test(sort(combinat::partitions::list(8, Length=4, MinPart=1)),
           sort([[5, 1, 1, 1], [4, 2, 1, 1], [3, 3, 1, 1], [3, 2, 2, 1],
                 [2, 2, 2, 2]])):
prog::test(combinat::partitions::count(8, Length=4, MinPart=1), 5):
prog::test(sort(combinat::partitions::list(8, Outer=[4,4])),
           sort([[4, 4]])):
prog::test(sort(combinat::partitions::list(0, Outer=[4,4])),
           sort([[]])):
prog::test(sort(combinat::partitions::list(1, Outer=[1])),
           sort([[1]])):
prog::test(sort(combinat::partitions::list(2, Outer=[1])),
           sort([])):
prog::test(sort(combinat::partitions::list(2, Outer=[1,1])),
           sort([[1, 1]])):
prog::test(sort(combinat::partitions::list(2, Outer=[2,1])),
           sort([[2], [1, 1]])):
prog::test(sort(combinat::partitions::list(5, Outer=[2,2,2,2])),
           sort([[2, 2, 1], [2, 1, 1, 1]])):
prog::test(sort(combinat::partitions::list(5, Inner=[2,2,2,2])),
           sort([])):
prog::test(sort(combinat::partitions::list(5, Inner=[2,1])),
           sort([[4, 1], [3, 2], [3, 1, 1], [2, 2, 1], [2, 1, 1, 1]])):
prog::test(sort(combinat::partitions::list(0, Inner=[])),
           sort([[]])):
prog::test(sort(combinat::partitions::list(0, Inner=[0])),
           sort([[0]])):

// The next 4 cases could be considered as buggy. For the moment, we
// consider that it's up to the user to check that minpart and inner
// are compatible.
prog::test(sort(combinat::partitions::list(0, Inner=[0], MinPart=1)),
           sort([[0]])):
prog::test(sort(combinat::partitions::list(1, Inner=[0], MinPart=1)),
           sort([[1]])):
prog::test(sort(combinat::partitions::list(2, Inner=[0], MinPart=1)),
           sort([[2], [1, 1]])):
prog::test(sort(combinat::partitions::list(2, Inner=[0], MinPart=2)),
           sort([[2], [0, 2]])):

for k from 0 to 15 do
    prog::test(combinat::generators::count
               (combinat::partitions::generator(k)),
               combinat::partitions::count(k)):
end_for:

prog::testfunc(combinat::partitions::conjugate):
prog::test(combinat::partitions::conjugate([]), []):
prog::test(combinat::partitions::conjugate([1]), [1]):
prog::test(combinat::partitions::conjugate([4]), [1,1,1,1]):
prog::test(combinat::partitions::conjugate([1,1]), [2]):
prog::test(combinat::partitions::conjugate([2,1]), [2,1]):
prog::test(combinat::partitions::conjugate([3, 2, 2, 1, 0]),
           [4, 3, 1]):	
for k from 0 to 8 do
    g:=combinat::partitions::generator(k);
    while (p:=g()) <> FAIL do
        prog::test(combinat::partitions::conjugate
                   (combinat::partitions::conjugate(p)), p);
    end_while;
end_for:

prog::testfunc(combinat::partitions::hooklengths):
prog::test(sort(combinat::partitions::hooklengths([4])), [1,2,3,4]):
prog::test(sort(combinat::partitions::hooklengths([1,1,1,1])), [1,2,3,4]):
prog::test(sort(combinat::partitions::hooklengths([2,1])), [1,1,3]):
prog::test(sort(combinat::partitions::hooklengths([3,2,1])), [1,1,1,3,3,5]):

prog::testfunc(combinat::partitions::toExp):
prog::test(combinat::partitions::toExp([]),
           []):
prog::test(combinat::partitions::toExp([],5),
           [0, 0, 0, 0, 0]):
prog::test(combinat::partitions::toExp([3]),
           [0, 0, 1]):
prog::test(combinat::partitions::toExp([3],5),
           [0, 0, 1, 0, 0]):
prog::test(combinat::partitions::toExp([3,3,1]),
           [1, 0, 2]):
prog::test(combinat::partitions::toExp([3,3,1],2),
           [1, 0, 2]):
prog::test(combinat::partitions::toExp([3,3,1],5),
           [1, 0, 2, 0, 0]):
prog::testfunc(combinat::partitions::fromExp):
prog::test(combinat::partitions::fromExp([1, 0, 2, 0, 0]),
           [3, 3, 1]):

for k from 0 to 5 do
    g:=combinat::partitions::generator(k);
    while (p:=g()) <> FAIL do
        prog::test(combinat::partitions::fromExp
                   (combinat::partitions::toExp(p)), p);
    end_while;
end_for:

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("toArray"):
//////////////////////////////////////////////////////////////////////////////

prog::test(combinat::partitions::toArray([]),
           array(1..1, 1..1)):
prog::test(combinat::partitions::toArray([3, 2, 1]),
           array(1..3, 1..3, (1,1) = "", (2,1) = "", (2,2) = "", (3,1) = "", (3,2) = "", (3,3) = "")):


prog::testfunc(combinat::partitions::dominate):
prog::testfunc(combinat::partitions):
prog::test([combinat::partitions::dominate(p1, p2)
	    $ p1 in combinat::partitions::list(0)
	    $ p2 in combinat::partitions::list(0)],
           [TRUE]):
prog::test([combinat::partitions::dominate(p1, p2)
	    $ p1 in combinat::partitions::list(1)
	    $ p2 in combinat::partitions::list(1)],
           [TRUE]):
prog::test([combinat::partitions::dominate(p1, p2)
	    $ p1 in combinat::partitions::list(2)
	    $ p2 in combinat::partitions::list(2)],
           [TRUE, FALSE, TRUE, TRUE]):
prog::test([combinat::partitions::dominate(p1, p2)
	    $ p1 in combinat::partitions::list(3)
	    $ p2 in combinat::partitions::list(3)],
           [TRUE, FALSE, FALSE, TRUE, TRUE, FALSE, TRUE, TRUE, TRUE]):
prog::test([combinat::partitions::dominate(p1, p2)
	    $ p1 in combinat::partitions::list(4)
	    $ p2 in combinat::partitions::list(4)],
           [TRUE, FALSE, FALSE, FALSE, FALSE, TRUE, TRUE, FALSE,
	    FALSE, FALSE, TRUE, TRUE, TRUE, FALSE, FALSE, TRUE,
	    TRUE, TRUE, TRUE, FALSE, TRUE, TRUE, TRUE, TRUE, TRUE]):
prog::test([combinat::partitions::dominate(p1, p2)
	    $ p1 in combinat::partitions::list(5)
	    $ p2 in combinat::partitions::list(5)],
           [TRUE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE,
	   TRUE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE, TRUE,
	   TRUE, FALSE, FALSE, FALSE, FALSE, TRUE, TRUE, TRUE,
	   TRUE, FALSE, FALSE, FALSE, TRUE, TRUE, TRUE, TRUE,
	   TRUE, FALSE, FALSE, TRUE, TRUE, TRUE, TRUE, TRUE,
	   TRUE, FALSE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE]):

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

   ////////////////////////////////////////////////////////////////////////////////
   // r-core algorithm test
   ////////////////////////////////////////////////////////////////////////////////
   prog::testfunc(combinat::partitions::rCore):
   prog::test(combinat::partitions::rCore([],3),[]):	
   prog::test(combinat::partitions::rCore([8,7,7,4,1,1,1,1,1],3),[2, 1, 1]):
   prog::test(combinat::partitions::rCore([3,3,3,2,1],3),[]):
   prog::test(combinat::partitions::rCore([10,8,7,7],4),[]):
   prog::test(combinat::partitions::rCore([21,15,15,9,6,6,6,3,3],3),[]):

   ////////////////////////////////////////////////////////////////////////////////
   // r-quotient algorithm test
   ////////////////////////////////////////////////////////////////////////////////

   prog::testfunc(combinat::partitions::rQuotient):
   prog::test(combinat::partitions::rQuotient([],3),[[],[],[]]):
   prog::test(combinat::partitions::rQuotient([8,7,7,4,1,1,1,1,1],3),
                                                       [[2,1],[2,2],[2]]):   
   prog::test(combinat::partitions::rQuotient([10,8,7,7],4),[[2],[3],[2],[1]]):
   prog::test(combinat::partitions::rQuotient([6,3,3],3),[[1],[1],[2]]):
   prog::test(combinat::partitions::rQuotient([3,3,3,2,1],3),[[1],[1,1],[1]]):
   prog::test(combinat::partitions::rQuotient([6,6,6,3,3,3],3),[[2,1],[2,1],[2,1]]):
   prog::test(combinat::partitions::rQuotient([21,15,15,9,6,6,6,3,3],3),
                                                       [[5,2,1],[5,2,1],[7,3,2]]):
   prog::test(combinat::partitions::rQuotient([21,15,15,9,6,6,3,3],3),
                                                       [[5,2],[5,2,1],[7,3,1]]):

   ////////////////////////////////////////////////////////////////////////////////
   //  fromCore and Quotient algorithm test
   ////////////////////////////////////////////////////////////////////////////////

   prog::testfunc(combinat::partitions::fromCoreAndQuotient):
   for p in map([$0..6, 12] , op@combinat::partitions::list) do
       prog::test
       (combinat::partitions::fromCoreAndQuotient
	        (combinat::partitions::rCore(p, 3),
		 combinat::partitions::rQuotient(p, 3)),
	         p); 
   end_for:
		
/////////////////////////////////////////////////////////////////////////////
// Adding / removing ribbons on partitions
/////////////////////////////////////////////////////////////////////////////

prog::test(combinat::partitions::addRibbonsAndSpin([4,3,1],[0,2,0]),FAIL):
prog::test(combinat::partitions::addRibbonsAndSpin([4,3,1],[2,0,0])[1],[6,3,1]):
prog::test(combinat::partitions::addRibbonsAndSpin([4,3,1],[0,0,0,2]),FAIL):
prog::test(combinat::partitions::addRibbonsAndSpin([4,3,1],[0,0,0,0,2])[1],[4,3,1,1,1]):

prog::test(combinat::partitions::addRibbonsAndSpin([],[2])[1],[2]):
prog::test(combinat::partitions::addRibbonsAndSpin([],[0,2])[1],[1,1]):
prog::test(combinat::partitions::addRibbonsAndSpin([],[0,0,2]),FAIL):

prog::test(combinat::partitions::removeRibbonsAndSpin([4,3,1],[2,0,0]),FAIL):
prog::test(combinat::partitions::removeRibbonsAndSpin([4,3,1],[0,2,0])[1],[4,1,1]):
prog::test(combinat::partitions::removeRibbonsAndSpin([4,3,1],[0,0,2]),FAIL):
prog::test(combinat::partitions::removeRibbonsAndSpin([4,3,1],[0,0,0,4]),FAIL):

prog::test(combinat::partitions::removeRibbonsAndSpin([],[0,2]),FAIL):
prog::test(combinat::partitions::removeRibbonsAndSpin([4,3,1],[0,0,0,0,0,0])[1],[4,3,1]):
prog::test(combinat::partitions::removeRibbonsAndSpin([4,3,1],[0,0,0,0,2]),FAIL):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

prog::testfunc(combinat::partitions):
prog::testexit():
	
prog::check(combinat::partitions, 3):


// Local Variables: 
// mode: mupad
// End:
