/*****************************************************************************
  File:		lib/COMBINAT/TEST/ribbons.tst
  Authors:	Francois Descouens <francois.descouens@wanadoo.fr>
  Purpose:	Test file for the library 'combinat::ribbons'
  Created:	12/11/2003
  License:	LGPL
*****************************************************************************/

prog::testinit("ribbons"):

// Florent: This is done automatically when calling from Combinat/test
// make COMBINAT/ribbon.res
// Pref::typeCheck(Always): 
// testargs(TRUE):

////////////////////////////////////////////////////////////////////////////////
// function isA test
////////////////////////////////////////////////////////////////////////////////

prog::test(combinat::ribbons::isA([[2,3],[1,4]]),TRUE):
prog::test(combinat::ribbons::isA([[2,1],[2,4]]),FALSE):
prog::test(combinat::ribbons::isA([]),TRUE):

prog::test(combinat::ribbons::isA([[2,3],[2,4]]),TRUE):
prog::test(combinat::ribbons::isA([[],[2,3]]),FALSE):
prog::test(combinat::ribbons::isA([[2,3],[]]),FALSE):
prog::test(combinat::ribbons::isA(3),FALSE):

prog::test(combinat::ribbons::isA([[2,3],[1,4]],[2,2]),TRUE):
prog::test(combinat::ribbons::isA([[5,6],[2,3],[1,4]],[2,2]),FALSE):

//standard tableau of ribbon shape tested
prog::test(combinat::ribbons::isAStandard([[3,4],[1,2]]),TRUE):
prog::test(combinat::ribbons::isAStandard([[2,4],[2,3]]),FALSE):

////////////////////////////////////////////////////////////////////////////////
// function fromShapeAndWord
////////////////////////////////////////////////////////////////////////////////

prog::test(combinat::ribbons::fromShapeAndWord([3,2,4],[1,2,3,4,5,6,7,8]),FAIL):    
prog::test(combinat::ribbons::fromShapeAndWord([3,2,4],[1,2,3,4,5,6,7,8,9]),
	   combinat::ribbons([[1,2,3],[4,5],[6,7,8,9]])):


////////////////////////////////////////////////////////////////////////////////
// function fromDescentsToTableaux
////////////////////////////////////////////////////////////////////////////////

prog::test(combinat::ribbons::fromWord([1,3,2,4]),combinat::ribbons([[1,3],[2,4]])):
prog::test(combinat::ribbons::fromWord([1,2,3,4]),combinat::ribbons([[1,2,3,4]])):
prog::test(combinat::ribbons::fromWord([]),combinat::ribbons([])):

////////////////////////////////////////////////////////////////////////////////
// function list
////////////////////////////////////////////////////////////////////////////////

prog::test(combinat::ribbons::list([2,2]),
	   [ combinat::ribbons([[1,3],[2,4]]),
	     combinat::ribbons([[1,4],[2,3]]),
	     combinat::ribbons([[2,3],[1,4]]),
	     combinat::ribbons([[2,4],[1,3]]),
	     combinat::ribbons([[3,4],[1,2]]) ]):
prog::test(combinat::ribbons::count([3,2,2]),155):
prog::test(combinat::ribbons::list([]),[combinat::ribbons([])]):
prog::test(combinat::ribbons::list([1]),[combinat::ribbons([[1]])]):

////////////////////////////////////////////////////////////////////////////////
// correspondance one to one between permutations and tableaux of ribbons shape
////////////////////////////////////////////////////////////////////////////////

prog::test(combinat::ribbons::toWord(combinat::ribbons([[4,5,6],[2,3],[1]])),
	   [4, 5, 6, 2, 3, 1]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("toArray"):
//////////////////////////////////////////////////////////////////////////////

prog::test(combinat::ribbons::toArray([[3, 2], [1, 4], [5, 6]]),
           array(1..3, 1..4, (1,1) = 3, (1,2) = 2, (2,2) = 1, (2,3) = 4, (3,3) = 5, (3,4) = 6)):
prog::test(combinat::ribbons::toArray([[3, 2]]),
           array(1..1, 1..2, (1,1) = 3, (1,2) = 2)):
prog::test(combinat::ribbons::toArray([[3]]),
           array(1..1, 1..1, (1,1) = 3)):
prog::test(combinat::ribbons::toArray([[]]),
           array(1..1, 1..1)):

////////////////////////////////////////////////////////////////////////////////
// Global checking of the package
// This is done at the end to ensure that as much as possible of the
// package is initialized. A recursive prog::init(combinat::integerMatrices)
// would be usefull here.
///////////////////////////////////////////////////////////////////////////////

prog::testfunc(combinat::ribbons):
prog::testexit():

prog::check(combinat::ribbons, 3):

// Local Variables: 
// mode: mupad
// End:
