prog::testinit("ribbonsTableaux"):

Pref::typeCheck(Always):
testargs(TRUE):

//a big ribbons tableaux for testing functions represing under matix form

a:=new(combinat::ribbonsTableaux,
    [17,17,0,17,18,0],
    [0 ,0 ,0,0 ,0 ,0],
    [9 ,0 ,0,10,12,0 ,0 ,16,0],
    [3 ,5 ,6,0 ,0 ,11,0 ,15,0],
    [0 ,0 ,0,7 ,8 ,0 ,0 ,0 ,0],
    [0 ,0 ,0,0 ,0 ,0 ,10,13,14,18],
    [1 ,2 ,0,5 ,0 ,0 ,0 ,0 ,0 ,0 ],
    [0 ,1 ,0,4 ,0 ,0 ,0 ,0 ,0 ,0 ],
    [0 ,0 ,0,3 ,0 ,0 ,7 ,0 ,0 ,11,0,0]):


///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

   ////////////////////////////////////////////////////////////////////////////////
   //  test of Stanton White bijection direct sense  
   ////////////////////////////////////////////////////////////////////////////////

   //Stanton white direct sense with partition without r-core
   ///////////////////////////////////////////////////////////
   prog::test( combinat::ribbonsTableaux::StantonWhite(
         new(combinat::ribbonsTableaux,[2],[0,0],[1,1,2],[0,0,0,3],[0,0,0,0,0])),
         [ [], [ new(combinat::tableaux,[1]),new(combinat::tableaux,[2],[1,3]),new(combinat::tableaux,[2]) ] ]):

   prog::test(combinat::ribbonsTableaux::StantonWhite(a),
         [[],[ new(combinat::tableaux,[17,17],[3,12,16],[1,5,13]) , new(combinat::tableaux,[17,18],[5,7,15],[2,4,14]),
               new(combinat::tableaux,[9,10,11],[6,8,10,18],[1,3,7,11])] ]):

   prog::test(combinat::ribbonsTableaux::StantonWhite(
         new(combinat::ribbonsTableaux,[4,0,0],[1,2,0],[0,1,0,3],[0,0,0,0,0])),
         [[],[ new(combinat::tableaux,[1]),
               new(combinat::tableaux,[2,3]),
               new(combinat::tableaux,[4],[1]) ] ]):

   //Stanton white direct sense with partition with non-empty r-core
   /////////////////////////////////////////////////////////////////
   prog::test( combinat::ribbonsTableaux::StantonWhite(
         new(combinat::ribbonsTableaux,[1],[0],[0,2,3,0,0],[-1,0,0,2,0,4],[-1,1,0,1,0,0,0],[-1,-1,0,0,0,3,0,0])),
         [ [2,1,1] ,
           [ new(combinat::tableaux,[1,2,2]) , new(combinat::tableaux,[3],[1,3]) , new(combinat::tableaux,[1,4]) ] ]):
   
///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

   ////////////////////////////////////////////////////////////////////////////////
   // test of function for listing ribbons tableau of a given shape and evaluation
   ////////////////////////////////////////////////////////////////////////////////

   prog::testfunc(combinat::ribbonsTableaux::list):
   
   //shape without k-core
   prog::test(nops(combinat::ribbonsTableaux::new([6,6,6], [4,2], 3)), 6):
   prog::test(nops(combinat::ribbonsTableaux::new([3,3,3,2,1], [3,1],3)),1):
   prog::test(nops(combinat::ribbonsTableaux::new([3,3,3,2,1], [2,2], 3)),2):
   prog::test(nops(combinat::ribbonsTableaux::new([3,3,3,2,1], [2,1,1], 3)),5):
   prog::test(nops(combinat::ribbonsTableaux::new([3,3,3,2,1], [1,1,1,1], 3)),12):
   prog::test(combinat::ribbonsTableaux::new([5,4,3,2,1],[2,2,1],3), 
        [new(combinat::ribbonsTableaux,[2],[0,0],[1,1,2],[0,0,0,3],[0,0,0,0,0]),
         new(combinat::ribbonsTableaux,[2],[0,2],[0,0,0],[1,1,0,3],[0,0,0,0,0]), 
         new(combinat::ribbonsTableaux,[2],[0,0],[1,1,3],[0,0,0,0],[0,0,2,0,0]),
         new(combinat::ribbonsTableaux,[2],[0,2],[0,0,3],[1,0,0,0],[0,0,1,0,0]), 
         new(combinat::ribbonsTableaux,[2],[0,3],[0,0,0],[1,1,0,2],[0,0,0,0,0]),
         new(combinat::ribbonsTableaux,[2],[0,3],[0,0,0],[1,2,0,0],[0,0,1,0,0]),
         new(combinat::ribbonsTableaux,[3],[0,0],[1,1,2],[0,0,0,2],[0,0,0,0,0]),
         new(combinat::ribbonsTableaux,[3],[0,0],[1,2,0],[0,1,0,2],[0,0,0,0,0]),
         new(combinat::ribbonsTableaux,[3],[0,0],[2,0,0],[1,1,0,2],[0,0,0,0,0]),
         new(combinat::ribbonsTableaux,[3],[0,0],[2,0,2],[1,0,0,0],[0,0,1,0,0])]):

   //shape with non-empty k-core
   prog::test(nops(combinat::ribbonsTableaux::new([8,7,6,5,1,1],[3,2,2,1],3)),85):
   prog::test(combinat::ribbonsTableaux::new([5,4,3,2,1,1,1],[2,2,1],3), 
             [new(combinat::ribbonsTableaux,[2],[0],[0],[1,1],[0,0,2],[0,0,0,3],[-1,-1,0,0,0]), 
              new(combinat::ribbonsTableaux,[2],[0],[0],[1,2],[0,0,0],[0,1,0,3],[-1,-1,0,0,0]),
              new(combinat::ribbonsTableaux,[2],[0],[0],[1,1],[0,0,3],[0,0,0,0],[-1,-1,2,0,0]),
              new(combinat::ribbonsTableaux,[2],[0],[0],[1,2],[0,0,3],[0,0,0,0],[-1,-1,1,0,0]), 
              new(combinat::ribbonsTableaux,[2],[0],[0],[1,3],[0,0,0],[0,1,0,2],[-1,-1,0,0,0]),
              new(combinat::ribbonsTableaux,[2],[0],[0],[1,3],[0,0,0],[0,2,0,0],[-1,-1,1,0,0]),
              new(combinat::ribbonsTableaux,[3],[0],[0],[1,1],[0,0,2],[0,0,0,2],[-1,-1,0,0,0]),
              new(combinat::ribbonsTableaux,[3],[0],[0],[1,2],[0,0,0],[0,1,0,2],[-1,-1,0,0,0]),
              new(combinat::ribbonsTableaux,[3],[0],[0],[1,2],[0,0,2],[0,0,0,0],[-1,-1,1,0,0]),
              new(combinat::ribbonsTableaux,[3],[0],[0],[2,0],[1,0,2],[0,0,0,0],[-1,-1,1,0,0])]):	

   //shape with non-empty k-core and evaluation not a partition
   prog::test(nops(combinat::ribbonsTableaux::new([7,7,7,2,1,1],[3,2,0,1,1],3)),25):
     
   //case of semi-standard Young tableaux (tableaux of 1 ribbons)
   prog::test(combinat::ribbonsTableaux::new([3,2,1],[2,2,2],1),
             [new(combinat::ribbonsTableaux,[3],[2,2],[1,1,3]),
             new(combinat::ribbonsTableaux,[3],[2,3],[1,1,2])]):
   prog::test(combinat::ribbonsTableaux::new([3,2,1],[2,1,1,1,1],1),
             [new(combinat::ribbonsTableaux,[3],[2,4],[1,1,5]),
              new(combinat::ribbonsTableaux,[4],[2,3],[1,1,5]), 
              new(combinat::ribbonsTableaux,[3],[2,5],[1,1,4]),
              new(combinat::ribbonsTableaux,[4],[2,5],[1,1,3]),
              new(combinat::ribbonsTableaux,[4],[3,5],[1,1,2]),
              new(combinat::ribbonsTableaux,[5],[2,3],[1,1,4]),
              new(combinat::ribbonsTableaux,[5],[2,4],[1,1,3]),
              new(combinat::ribbonsTableaux,[5],[3,4],[1,1,2])]):

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

   ////////////////////////////////////////////////////////////////////////////////
   // test of the function which returns the spin of a tableau
   ////////////////////////////////////////////////////////////////////////////////


   //partition without r-core
   prog::test(map(combinat::ribbonsTableaux::list([5,4,3,2,1],[2,2,1],3),
        combinat::ribbonsTableaux::spinTableau),[4,3,3,3,3,2,4,3,2,2]):
   prog::test(map(combinat::ribbonsTableaux::list([3,3,3,2,1],[1,1,1,1],3),
	combinat::ribbonsTableaux::spinTableau),
	       [7/2,7/2,5/2,5/2,5/2,3/2,7/2,5/2,5/2,3/2,3/2,1/2]):

   //partition with a non empty r-core
   prog::test(map(combinat::ribbonsTableaux::list([8,7,6,5,1,1],[3,2,2,1],3), 
                  combinat::ribbonsTableaux::spinTableau), 
               [13/2,11/2,11/2,13/2,11/2,9/2,9/2,11/2,9/2,9/2,7/2,9/2,7/2,
                7/2,11/2,9/2,9/2,11/2,11/2,11/2,9/2,7/2,7/2,11/2,9/2,9/2,
                9/2,9/2,9/2,7/2,7/2,7/2,7/2,7/2,11/2,9/2,9/2,9/2,11/2,9/2,
                9/2,7/2,9/2,9/2,7/2,7/2,7/2,7/2,7/2,7/2,5/2,5/2,5/2,9/2,
                7/2,5/2,9/2,7/2,7/2,5/2,13/2,11/2,9/2,9/2,11/2,9/2,7/2,
                9/2,7/2,7/2,5/2,7/2,9/2,7/2,7/2,7/2,7/2,7/2,5/2,5/2,7/2,
                5/2,3/2,7/2,5/2]):
   prog::test(map(combinat::ribbonsTableaux::list([5,4,3,2,1,1,1],[2,2,1],3),
                combinat::ribbonsTableaux::spinTableau),
               [9/2,7/2,7/2,7/2,7/2,5/2,9/2,7/2,7/2,5/2]):


    ////////////////////////////////////////////////////////////////////////////////
    // spin and cospin polynom of a given shape, evaluation and ribbon length 
    ////////////////////////////////////////////////////////////////////////////////

    //spin and cospin polynom for partition with empty core
    prog::testfunc(combinat::ribbonsTableaux::spinPolynom):
    prog::test(combinat::ribbonsTableaux::spinPolynom([6,6,6],[4,2],3), 
                            q^2+q^3+2*q^4+q^5+q^6):
    prog::test(combinat::ribbonsTableaux::cospinPolynom([6,6,6],[4,2],3), 
                            q^4+q^3+2*q^2+q+1):
    prog::test(combinat::ribbonsTableaux::spinPolynom([6,6,6],[4,1,1],3),
                            q^2+2*q^3+3*q^4+2*q^5+q^6):
    prog::test(combinat::ribbonsTableaux::cospinPolynom([6,6,6],[4,2],3), 
                            q^4+q^3+2*q^2+q+1):
    prog::test(combinat::ribbonsTableaux::cospinPolynom([3,3,3,2,1], [3,1],3),1):
    prog::test(combinat::ribbonsTableaux::cospinPolynom([3,3,3,2,1], [2,2], 3),1+q):
    prog::test(combinat::ribbonsTableaux::cospinPolynom([3,3,3,2,1], [2,1,1], 3),2+2*q+q^2):
    prog::test(combinat::ribbonsTableaux::cospinPolynom([3,3,3,2,1], [1,1,1,1], 3),
                            3+5*q+3*q^2+q^3):

    //test for partitions with non-empty core
    prog::test(combinat::ribbonsTableaux::spinPolynom([5,4,3,2,1,1,1],[2,2,1],3), 
                         2*q^(5/2)+6*q^(7/2)+2*q^(9/2)):

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////
   
   ////////////////////////////////////////////////////////////////////////////////
   // test of auxiliary function
   ////////////////////////////////////////////////////////////////////////////////
 
   // a ribbons tableaux with a empty 3-core
   /////////////////////////////////////////////
   prog::test(combinat::ribbonsTableaux::toFullRepresentation(
       new(combinat::ribbonsTableaux,[2],[0,0],[1,1,2],[0,0,0,3],[0,0,0,0,0])),
     [[[2], [2, 2], [1, 1, 2], [1, 1, 2, 3], [1, 1, 2, 3, 3]],
       [[4], [4, 4], [2, 3, 5], [2, 3, 5, 6], [2, 3, 5, 6, 6]]]):
   prog::test(combinat::ribbonsTableaux::evaluation(
       new(combinat::ribbonsTableaux,[2],[0,0],[1,1,2],[0,0,0,3],[0,0,0,0,0])),
        [2, 2, 1]):

////////////////////////////////////////////////////////////////////////////////
// Global checking of the package
// This is done at the end to ensure that as much as possible of the
// package is initialized. A recursive prog::init(combinat::integerMatrices)
// would be usefull here.
///////////////////////////////////////////////////////////////////////////////

prog::testexit():
prog::check(combinat::ribbonsTableaux, 3):










