/*****************************************************************************
  $Id: setPartitions.tst,v 1.1.1.3 2004/10/16 15:22:37 nthiery Exp $
  File:		lib/COMBINAT/TEST/setPartitions.tst
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
                Jean-Christophe Novelli <novelli@univ-mlv.fr>
  Purpose:	Test file for the library 'combinat::setPartitions'
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

f := l -> map(l, DOM_SET@op):

prog::testinit("setPartitions", 6.1):

prog::testfunc(combinat::setPartitions::isA):

prog::test(combinat::setPartitions::isA({{1,3},{2}})):
prog::test(combinat::setPartitions::isA({{1,2},{2}}), FALSE):
prog::test(combinat::setPartitions::isA({{1,3},{2}},{1,2,3},[2,1])):
prog::test(combinat::setPartitions::isA({{1,3},{2}},3,[2,1])):
prog::test(combinat::setPartitions::isA({{1,3},{2}},{1,2,3},[2,1])):
prog::test(combinat::setPartitions::isA({{1,3},{2}},[1,2,3])):
prog::test(combinat::setPartitions::isA({{1,3},{2}},{1,2,3,4},[2,1]), FALSE):
prog::test(combinat::setPartitions::isA({{2}, {1, 3}}, {1, 2, 3}, [2, 2]),
           FALSE):
prog::test(combinat::setPartitions::isA({{}, {1, 3}}), FALSE):
prog::test(combinat::setPartitions::isA({{}}), FALSE):
prog::test(combinat::setPartitions::isA({}), TRUE):
prog::test(combinat::setPartitions::isA({}, {}), TRUE):
prog::test(combinat::setPartitions::isA({}, {}, []), TRUE):
prog::test(combinat::setPartitions::isA({{3}, {1, 3, 4}}), FALSE):
prog::test(combinat::setPartitions::isA({{3}, {1, 2, 4}},4,[3,1])):
prog::test(combinat::setPartitions::isA({{3}, {1, 2, 4}},[1,2,3,4],[3,1])):
prog::test(combinat::setPartitions::isA({{3}, {1, 2, 4}},[1,2,3,4],2)):
prog::test(combinat::setPartitions::isA({{3}, {1, 2, 4}},[1,2,3,4],3), FALSE):

prog::testfunc(combinat::setPartitions::count):
if prog::TestNoTestargs = FALSE then
prog::test(combinat::setPartitions::count([a, b, c, d], [3]), TrapError=1028):
end_if:
prog::test([combinat::setPartitions::count(i) $ i = 0..10],
           [1, 1, 2, 5, 15, 52, 203, 877, 4140, 21147, 115975]):
for i from 0 to 7 do
    for part from 0 to i do
	prog::test(bool(nops(combinat::setPartitions::list(i,part)) =
			combinat::setPartitions::count(i,part)) ):
    end_for;
    for part in combinat::partitions::list(i) do
	prog::test(bool(nops(combinat::setPartitions::list(i,part)) =
			combinat::setPartitions::count(i,part)) ):
    end_for;
end_for:


prog::testfunc(combinat::setPartitions::list):
// The order in which the setPartitions are listed is not in the
// specifications of combinat::setPartitions::list, so we sort the result
// before comparing.
if prog::TestNoTestargs = FALSE then
prog::test(combinat::setPartitions::list([a, b, c, d], [3]), TrapError=1028):
end_if:
prog::test(combinat::setPartitions::list([], []), [{}]):
prog::test(combinat::setPartitions::list([1], [1]), [{{1}}]):
prog::test(bool({op(f(combinat::setPartitions::list([1, 2, 3, 4], [2, 2])))} =
	{op(f([[{3, 4}, {1, 2}], [{2, 4}, {1, 3}], [{2, 3}, {1, 4}]]))})):
prog::test(bool({op(f(combinat::setPartitions(4, [2, 1, 1])))} = 
	{op(f([[{4}, {3}, {1, 2}], [{4}, {2}, {1, 3}], [{3}, {2}, {1, 4}], 
	     [{4}, {1}, {2, 3}], [{3}, {1}, {2, 4}], [{2}, {1}, {3, 4}]]))})):
prog::test(bool({op(f(combinat::setPartitions::list([1, 2, 3, 4], [2, 2])))} = 
	{op(f([[{3, 4}, {1, 2}], [{2, 4}, {1, 3}], [{2, 3}, {1, 4}]]))})):
prog::test(bool({op(f(combinat::setPartitions::list(4, [2, 1, 1])))} = 
	{op(f([[{2}, {1}, {3, 4}], [{3}, {1}, {2, 4}], [{4}, {1}, {2, 3}], 
	     [{3}, {2}, {1, 4}], [{4}, {2}, {1, 3}], [{4}, {3}, {1, 2}]]))})):
prog::test(bool({op(f(combinat::setPartitions::list([1, 2, 3, 4])))} = 
	{op(f([[{1, 2, 3, 4}], [{1}, {2, 3, 4}], [{2}, {1, 3, 4}],
	     [{3}, {1, 2, 4}], [{4}, {1, 2, 3}], [{3, 4}, {1, 2}],
	     [{2, 4}, {1, 3}], [{2, 3}, {1, 4}], [{2}, {1}, {3, 4}],
	     [{3}, {1}, {2, 4}], [{4}, {1}, {2, 3}], [{3}, {2}, {1, 4}],
	     [{4}, {2}, {1, 3}], [{4}, {3}, {1, 2}], [{4}, {3}, {2}, {1}]]))})):
prog::test(bool({op(f(combinat::setPartitions::list(4)))} = 
	{op(f([[{1, 2, 3, 4}], [{1}, {2, 3, 4}], [{2}, {1, 3, 4}],
	     [{3}, {1, 2, 4}], [{4}, {1, 2, 3}], [{3, 4}, {1, 2}],
	     [{2, 4}, {1, 3}], [{2, 3}, {1, 4}], [{2}, {1}, {3, 4}],
	     [{3}, {1}, {2, 4}], [{4}, {1}, {2, 3}], [{3}, {2}, {1, 4}],
	     [{4}, {2}, {1, 3}], [{4}, {3}, {1, 2}], [{4}, {3}, {2}, {1}]]))})):
prog::test(bool({op(f(combinat::setPartitions::list(4, 3)))} = 
	{op(f([[{2}, {1}, {3, 4}], [{3}, {1}, {2, 4}], [{4}, {1}, {2, 3}], 
	     [{3}, {2}, {1, 4}], [{4}, {2}, {1, 3}], [{4}, {3}, {1, 2}]]))})):

prog::testfunc(combinat::setPartitions::_less):
prog::test(combinat::setPartitions::_less({{3}, {4}, {1, 2}}, {{4}, {1, 2, 3}}),
           TRUE):
prog::test(combinat::setPartitions::_less({{4}, {1, 2, 3}}, {{3}, {4}, {1, 2}}),
           FALSE):
prog::test(combinat::setPartitions::_less({{3}, {4}, {1, 2}}, {{3}, {4}, {1, 2}}),
           FALSE):

prog::testfunc(combinat::setPartitions::inf):
prog::test(combinat::setPartitions::inf({{1},{4},{2, 3}},{{3},{4},{1, 2}}),
           {{1}, {2}, {3}, {4}}):
prog::test(combinat::setPartitions::inf({{4}, {1, 2, 3}}, {{3}, {1, 2, 4}}),
           {{3}, {4}, {1, 2}}):


prog::testfunc(combinat::setPartitions::sup):
prog::test(combinat::setPartitions::sup({{1}, {4}, {2, 3}}, {{3}, {4}, {1, 2}}),
           {{4}, {1, 2, 3}}):
prog::test(combinat::setPartitions::sup({{4}, {1, 2, 3}}, {{3}, {1, 2, 4}}),
           {{1, 2, 3, 4}}):


prog::testfunc(combinat::setPartitions::supOfSets):
prog::test(combinat::setPartitions::supOfSets({1, 2, 3}, {1, 2, 4}, {3}),
           {{1, 2, 3, 4}}):
prog::test(combinat::setPartitions::supOfSets({1, 2}, {1, 2, 4}, {3}),
           {{3}, {1, 2, 4}}):


//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

// This is done at the end to ensure as much as possible of the
// package is initialized. A recursive prog::init(combinat::setPartitions)
// would be usefull here.

prog::testfunc(combinat::setPartitions):
prog::testexit():

prog::check(combinat::setPartitions, 3):


// Local Variables: 
// mode: mupad
// End:
