/*****************************************************************************
  $Id: setPartitionsOrdered.tst,v 1.1.1.3 2004/10/16 15:22:39 nthiery Exp $
  File:		lib/COMBINAT/TEST/setPartitionsOrdered.tst
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Test file for the library 'combinat::setPartitionsOrdered'
  Created:	26/09/2003
  License:	LGPL
*****************************************************************************/

prog::testinit("setPartitionsOrdered", 7.2):

prog::testfunc(combinat::setPartitionsOrdered::isA):

prog::test(combinat::setPartitionsOrdered::isA([]), TRUE):
prog::test(combinat::setPartitionsOrdered::isA([], {}), TRUE):
prog::test(combinat::setPartitionsOrdered::isA([], {}, []), TRUE):
prog::test(combinat::setPartitionsOrdered::isA([{2},{1,3}, {}]), FALSE):
prog::test(combinat::setPartitionsOrdered::isA([{}, {1, 3}]), FALSE):
prog::test(combinat::setPartitionsOrdered::isA([{}, {1, 3}, {2}], 3, [0,2,1])):
prog::test(combinat::setPartitionsOrdered::isA([{}]), FALSE):
prog::test(combinat::setPartitionsOrdered::isA([{3}, {1, 3, 4}]), FALSE):
prog::test( combinat::setPartitionsOrdered::isA([{1,3},{2}], {1,2,3}, 2)):
prog::test( combinat::setPartitionsOrdered::isA([{1,3},{2}], {1,2,3}, 3), FALSE):
prog::test(combinat::setPartitionsOrdered::isA([], {}, 0), TRUE):
prog::test(combinat::setPartitionsOrdered::isA([], {}, 1), FALSE):
prog::test(combinat::setPartitionsOrdered::isA([{1,3},{2}],{1,2,3},[2,1])):
prog::test(combinat::setPartitionsOrdered::isA([{1,3},{2}],3,[2,1])):
prog::test(combinat::setPartitionsOrdered::isA([{2},{1,3}],3,[1,2])):
prog::test(combinat::setPartitionsOrdered::isA([{2},{1,3}],3,[2,1]), FALSE):
prog::test(combinat::setPartitionsOrdered::isA([{1,3},{2}],{1,2,3},[2,1])):
prog::test(combinat::setPartitionsOrdered::isA([{1,3},{2}],{1,2,3,4},[2,1]), FALSE):
prog::test(combinat::setPartitionsOrdered::isA([{2}, {1, 3}], {1, 2, 3}, [2, 2]),
           FALSE):
prog::test(combinat::setPartitionsOrdered::isA([{}, {1}, {}],{1},[0,1,0]), TRUE):
prog::test(combinat::setPartitionsOrdered::isA([{}, {}, {1}],{1},[0,1,0]), FALSE):
prog::test(combinat::setPartitionsOrdered::isA([{}],{},[0]), TRUE):
prog::test(combinat::setPartitionsOrdered::isA([{1,3}, {}, {2}],{1,2,3},[2,0,1]), TRUE):
prog::test(combinat::setPartitionsOrdered::isAWithEmptyParts([{}, {1}, {}]), TRUE):
prog::test(combinat::setPartitionsOrdered::isAWithEmptyParts([{}, {1,2}, {}]), TRUE):


prog::testfunc(combinat::setPartitionsOrdered::count):
prog::test(combinat::setPartitionsOrdered::count(0), 1):
prog::test(combinat::setPartitionsOrdered::count(1), 1):
prog::test(combinat::setPartitionsOrdered::count(2), 3):
prog::test(combinat::setPartitionsOrdered::count(3), 13):
prog::test(combinat::setPartitionsOrdered::count(4), 75):
prog::test(combinat::setPartitionsOrdered::count(5), 541):
prog::test(combinat::setPartitionsOrdered::count(5,[2,3]), 10):
prog::test(combinat::setPartitionsOrdered::count(4, 2), 14):
prog::test(combinat::setPartitionsOrdered::count(4, 1), 1):
prog::test(combinat::setPartitionsOrdered::count(0, []), 1):
prog::test(combinat::setPartitionsOrdered::count(0, [0]), 1):
prog::test(combinat::setPartitionsOrdered::count(0, [0,0]), 1):
prog::test(combinat::setPartitionsOrdered::count(5, [2,0,3]), 10):


prog::testfunc(combinat::setPartitionsOrdered::list):
prog::test(combinat::setPartitionsOrdered::list([]), [[]]):
prog::test(combinat::setPartitionsOrdered::list([a], [1]),
           [[{a}]]):
prog::test(combinat::setPartitionsOrdered::list([a]),
           [[{a}]]):
prog::test(combinat::setPartitionsOrdered::list({a}),
           [[{a}]]):
prog::test({op(combinat::setPartitionsOrdered::list([a, b]))},
           {op([[{a, b}], [{b}, {a}], [{a}, {b}]])}):
prog::test({op(combinat::setPartitionsOrdered::list([a, b, c]))},
           {op([[{a, b, c}], [{b, c}, {a}], [{a, c}, {b}], [{a, b}, {c}], 
	    [{c}, {a, b}], [{b}, {a, c}], [{a}, {b, c}], [{c}, {b}, {a}], 
	    [{b}, {c}, {a}], [{c}, {a}, {b}], [{b}, {a}, {c}], [{a}, {c}, {b}], [{a}, {b}, {c}]])}):
prog::test({op(combinat::setPartitionsOrdered::list([a, b, c, d], [3, 1]))},
           {op([[{b, c, d}, {a}], [{a, c, d}, {b}], [{a, b, d}, {c}], [{a, b, c}, {d}]])}):
if prog::TestNoTestargs = FALSE then
prog::test(combinat::setPartitionsOrdered::list([a, b, c, d], [3]), TrapError=1028):
end_if:
prog::test({op(combinat::setPartitionsOrdered::list({a, b, c, d}, [2, 2]))},
           {op([[{c, d}, {a, b}], [{b, d}, {a, c}], [{b, c}, {a, d}], 
	    [{a, d}, {b, c}], [{a, c}, {b, d}], [{a, b}, {c, d}]])}):
prog::test({op(combinat::setPartitionsOrdered::list(4, 2))},
           {op([[{2, 3, 4}, {1}], [{1, 3, 4}, {2}], [{1, 2, 4}, {3}], [{1, 2, 3}, {4}], [{3, 4}, {1, 2}], [{2, 4}, {1, 3}], [{2, 3}, {1, 4}], [{1, 4}, {2, 3}], [{1, 3}, {2, 4}], [{1, 2}, {3, 4}], [{4}, {1, 2, 3}], [{3}, {1, 2, 4}], [{2}, {1, 3, 4}], [{1}, {2, 3, 4}]])}):
prog::test(combinat::setPartitionsOrdered::list(4, 1),
           [[{1, 2, 3, 4}]]):
prog::test({op(combinat::setPartitionsOrdered::list(4, [2, 0, 2]))},
           {op([[{3, 4}, {}, {1, 2}], [{2, 4}, {}, {1, 3}], [{2, 3}, {}, {1, 4}], [{1, 4}, {}, {2, 3}], [{1, 3}, {}, {2, 4}], [{1, 2}, {}, {3, 4}]])}):
prog::test(combinat::setPartitionsOrdered::list({},[]), [[]]):
prog::test(combinat::setPartitionsOrdered::list({},[0]), [[{}]]):
prog::test(combinat::setPartitionsOrdered::list({},[0,0,0]), [[{},{},{}]]):

for n from 0 to 5 do
    for p in combinat::compositions::list(n) do
	prog::test(bool(nops(combinat::setPartitionsOrdered::list(n, p)) =
			combinat::setPartitionsOrdered::count(n, p)));
    end_for;
end_for:

prog::testfunc(combinat::setPartitionsOrdered::generator):
for n from 0 to 5 do
    for p in combinat::compositions::list(n).combinat::integerVectors(n, 4) do
	prog::test(bool(combinat::setPartitionsOrdered::list(n, p) =
			combinat::generators::toList(
                            combinat::setPartitionsOrdered::generator(n, p)))
		  );
    end_for;
end_for:

// Methods...
prog::testfunc(combinat::setPartitionsOrdered::intersectionsMatrix):
prog::test(combinat::setPartitionsOrdered::intersectionsMatrix([{1,2},{3}],[{1},{2,3}]),
	   [[{1}, {}], [{2}, {3}]]):
prog::test(combinat::setPartitionsOrdered::intersectionsMatrix([{1,2},{3,4}],[{1},{2,3},{4}]),
	   [[{1}, {}], [{2}, {3}], [{}, {4}]]):
prog::test(combinat::setPartitionsOrdered::intersectionsMatrix([{1,2},{3,4},{}],[{1},{2,3},{4}]),
	   [[{1}, {}, {}], [{2}, {3}, {}], [{}, {4}, {}]]):
	   
// The order in which the setPartitionsOrdered are listed is not in the
// specifications of combinat::setPartitionsOrdered::list, so we should 
// sort the result before comparing.

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

// This is done at the end to ensure as much as possible of the
// package is initialized. A recursive prog::init(combinat::setPartitionsOrdered)
// would be usefull here.

prog::testfunc(combinat::setPartitionsOrdered):
prog::testexit():

prog::check(combinat::setPartitionsOrdered, 3):


// Local Variables: 
// mode: mupad
// End:
