/*****************************************************************************
  $Id: shuffle.tst,v 1.1.1.1 2004/10/04 17:25:16 nthiery Exp $
  File:		lib/COMBINAT/TEST/shuffle.mu
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Test file for the library 'combinat::words::shuffle'
  Created:	24/01/2004
  License:	LGPL
*****************************************************************************/

//////////////////////////////////////////////////////////////////////////////
prog::testinit("shuffle"):
//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::words::shuffle::list):
prog::test(combinat::words::shuffle([],[]),
	   [[]]):
prog::test(combinat::words::shuffle([1],[]),
	   [[1]]):
prog::test(combinat::words::shuffle([],[a]),
	   [[a]]):
prog::test(combinat::words::shuffle([1,2,3],[a]),
	   [[1, 2, 3, a], [1, 2, a, 3], [1, a, 2, 3], [a, 1, 2, 3]]):
prog::test(combinat::words::shuffle([1,2,3],[a,b]),
	   [[1, 2, 3, a, b], [1, 2, a, 3, b], [1, 2, a, b, 3], [1, a, 2, 3, b],
	    [1, a, 2, b, 3], [1, a, b, 2, 3], [a, 1, 2, 3, b], [a, 1, 2, b, 3],
	    [a, 1, b, 2, 3], [a, b, 1, 2, 3]]):
prog::test(combinat::words::shuffle([1,2,3],[a,b,c]),
	   [[1, 2, 3, a, b, c], [1, 2, a, 3, b, c], [1, 2, a, b, 3, c],
	    [1, 2, a, b, c, 3], [1, a, 2, 3, b, c], [1, a, 2, b, 3, c],
	    [1, a, 2, b, c, 3], [1, a, b, 2, 3, c], [1, a, b, 2, c, 3],
	    [1, a, b, c, 2, 3], [a, 1, 2, 3, b, c], [a, 1, 2, b, 3, c],
	    [a, 1, 2, b, c, 3], [a, 1, b, 2, 3, c], [a, 1, b, 2, c, 3],
	    [a, 1, b, c, 2, 3], [a, b, 1, 2, 3, c], [a, b, 1, 2, c, 3],
	    [a, b, 1, c, 2, 3], [a, b, c, 1, 2, 3]]):

prog::testfunc(combinat::words::shuffle::count):
for w1 in [[],[1],[1,2],[1,2,3]] do
    for w2 in [[],[1],[1,2],[1,2,3]] do
	prog::test(bool(combinat::words::shuffle::count(w1, w2)=
			nops(combinat::words::shuffle(w1, w2))));
    end_for;
end_for:


prog::testfunc(combinat::words::shuffle::isA):
prog::test(combinat::words::shuffle::isA([1, 2, 3], [1], [2, 3]),
           TRUE):
prog::test(combinat::words::shuffle::isA([1], [1], [2]),
           FALSE):
prog::test(combinat::words::shuffle::isA([1, 2], [1], [2]),
           TRUE):
prog::test(combinat::words::shuffle::isA([2, 1], [1], [2]),
           TRUE):
prog::test(combinat::words::shuffle::isA([2, 1, 3], [1], [2, 3]),
           TRUE):
prog::test(combinat::words::shuffle::isA([2, 3, 1, 3], [1], [2, 3]),
           FALSE):
prog::test(combinat::words::shuffle::isA([2, 3, 1], [1], [2, 3]),
           TRUE):
prog::test(combinat::words::shuffle::isA([3, 2, 1], [1], [2, 3]),
           FALSE):
prog::test(combinat::words::shuffle::isA([1, 1, 2, 3, 2], [1, 2], [1, 2, 3]), 
	   TRUE):
for w1 in [[],[1],[1,2],[1,2,1],[1,2,3]] do
    for w2 in [[],[1],[1,2],[1,2,1],[1,2,3]] do
	for w in combinat::words::shuffle(w1,w2) do
//	    print(w, w1, w2);
	    prog::test(combinat::words::shuffle::isA(w, w1, w2), TRUE);
	end_for;
    end_for;
end_for:

//prog::testfunc(combinat::words::shuffle):
// prog::testexit():

// prog::check(combinat::words::shuffle, 3):



//////////////////////////////////////////////////////////////////////////////
//prog::testinit("shufflings"):
//////////////////////////////////////////////////////////////////////////////

prog::testfunc(combinat::words::shufflings::isA):

prog::testfunc(combinat::words::shufflings::list):
prog::test(combinat::words::shufflings::list([], [], []),
           [[[], []]]):
prog::test(combinat::words::shufflings::list([], [1], [1]),
           [[[], [1]]]):
prog::test(combinat::words::shufflings::list([1], [1], [1, 1]),
           [[[2], [1]], [[1], [2]]]):
prog::test(combinat::words::shufflings::list([1, 2], [1, 2], [1, 1, 2, 2]),
           [[[2, 4], [1, 3]], [[1, 4], [2, 3]], [[2, 3], [1, 4]], [[1, 3], [2, 4]]]):
prog::test(combinat::words::shufflings::list([1, 2], [1, 2], [1, 2, 1, 2]),
           [[[3, 4], [1, 2]], [[1, 2], [3, 4]]]):
prog::test(combinat::words::shufflings::list([1, 2], [1, 2], [1, 2, 1, 2, 1]),
           []):
prog::test(combinat::words::shufflings::list([1, 2, 1, 1], [1, 1, 2, 1], [1, 1, 2, 1, 1, 2, 1, 1]),
           [[[5, 6, 7, 8], [1, 2, 3, 4]], [[4, 6, 7, 8], [1, 2, 3, 5]], [[2, 3, 5, 8], [1, 4, 6, 7]], 
	    [[1, 3, 5, 8], [2, 4, 6, 7]], [[2, 3, 4, 8], [1, 5, 6, 7]], [[1, 3, 4, 8], [2, 5, 6, 7]], 
	    [[2, 3, 5, 7], [1, 4, 6, 8]], [[1, 3, 5, 7], [2, 4, 6, 8]], [[2, 3, 4, 7], [1, 5, 6, 8]], 
	    [[1, 3, 4, 7], [2, 5, 6, 8]]]):
//prog::testfunc(combinat::words::shufflings):
//prog::testexit():

//prog::check(combinat::words::shufflings, 3):

//////////////////////////////////////////////////////////////////////////////
//prog::testinit("split"):
//////////////////////////////////////////////////////////////////////////////

prog::testfunc(combinat::words::split::isA):
prog::test(combinat::words::split::isA([[1], [2, 3]], [1, 2, 3]),
           TRUE):
prog::test(combinat::words::split::isA([[1], [2, 3]], [1, 2, 3], 1),
           TRUE):
prog::test(combinat::words::split::isA([[1], [2, 3]], [1, 2, 3], 2),
           FALSE):
prog::test(combinat::words::split::isA([[1], [2]], [1]),
           FALSE):
prog::test(combinat::words::split::isA([[1], [2]], [1, 2]),
           TRUE):
prog::test(combinat::words::split::isA([[1], [2]], [1, 2], 1),
           TRUE):
prog::test(combinat::words::split::isA([[1], [2]], [1, 2], 2),
           FALSE):
prog::test(combinat::words::split::isA([[1], [2]], [2, 1]),
           TRUE):
prog::test(combinat::words::split::isA([[1], [2, 3]], [2, 1, 3]),
           TRUE):
prog::test(combinat::words::split::isA([[1], [2, 3]], [2, 3, 1, 3]),
           FALSE):
prog::test(combinat::words::split::isA([[1], [2, 3]], [2, 3, 1]),
           TRUE):
prog::test(combinat::words::split::isA([[1], [2, 3]],[3, 2, 1]),
           FALSE):
prog::test(combinat::words::split::isA([[1, 2], [1, 2, 3]], [1, 1, 2, 3, 2]), 
	   TRUE):
for w1 in [[],[1],[1,2],[1,2,1],[1,2,3],[2,1,3,2,1],[2,1,2,2,1,2,2,1]] do
    for k from 0 to nops(w1) do 
	for res in combinat::words::split::list(w1, k) do
	    prog::test(combinat::words::split::isA(res, w1, k), TRUE);
	end_for;
    end_for;
end_for:

prog::testfunc(combinat::words::split::list):
prog::test(combinat::words::split::list([], 0),
           [[[], []]]):
prog::test(combinat::words::split::list([], 1),
           []):
prog::test(combinat::words::split::list([1], 0),
           [[[], [1]]]):
prog::test(combinat::words::split::list([1], 1),
           [[[1], []]]):
prog::test(combinat::words::split::list([1], 2),
           []):
prog::test(combinat::words::split::list([2, 1, 3, 5, 2, 4], 0),
           [[[], [2, 1, 3, 5, 2, 4]]]):
prog::test(combinat::words::split::list([2, 1, 3, 5, 2, 4], 1),
           [[[2], [1, 3, 5, 2, 4]], [[1], [2, 3, 5, 2, 4]], [[3], [2, 1, 5, 2, 4]], [[5], [2, 1, 3, 2, 4]], 
	    [[2], [2, 1, 3, 5, 4]], [[4], [2, 1, 3, 5, 2]]]):
prog::test(combinat::words::split::list([2, 1, 3, 5, 2, 4], 2),
	   [[[2, 1], [3, 5, 2, 4]], [[2, 3], [1, 5, 2, 4]], [[2, 5], [1, 3, 2, 4]], [[2, 2], [1, 3, 5, 4]], 
	    [[2, 4], [1, 3, 5, 2]], [[1, 3], [2, 5, 2, 4]], [[1, 5], [2, 3, 2, 4]], [[1, 2], [2, 3, 5, 4]], 
	    [[1, 4], [2, 3, 5, 2]], [[3, 5], [2, 1, 2, 4]], [[3, 2], [2, 1, 5, 4]], [[3, 4], [2, 1, 5, 2]], 
	    [[5, 2], [2, 1, 3, 4]], [[5, 4], [2, 1, 3, 2]], [[2, 4], [2, 1, 3, 5]]]):
prog::test(combinat::words::split::list([2,1,3,5,2,4], 3),
	   [[[2, 1, 3], [5, 2, 4]], [[2, 1, 5], [3, 2, 4]], [[2, 1, 2], [3, 5, 4]], [[2, 1, 4], [3, 5, 2]],
	    [[2, 3, 5], [1, 2, 4]], [[2, 3, 2], [1, 5, 4]], [[2, 3, 4], [1, 5, 2]], [[2, 5, 2], [1, 3, 4]],
	    [[2, 5, 4], [1, 3, 2]], [[2, 2, 4], [1, 3, 5]], [[1, 3, 5], [2, 2, 4]], [[1, 3, 2], [2, 5, 4]],
	    [[1, 3, 4], [2, 5, 2]], [[1, 5, 2], [2, 3, 4]], [[1, 5, 4], [2, 3, 2]], [[1, 2, 4], [2, 3, 5]],
	    [[3, 5, 2], [2, 1, 4]], [[3, 5, 4], [2, 1, 2]], [[3, 2, 4], [2, 1, 5]], [[5, 2, 4], [2, 1, 3]]]):
prog::test(combinat::words::split::list([2, 1, 3, 5, 2, 4], 4),
           [[[2, 1, 3, 5], [2, 4]], [[2, 1, 3, 2], [5, 4]], [[2, 1, 3, 4], [5, 2]], [[2, 1, 5, 2], [3, 4]], 
	    [[2, 1, 5, 4], [3, 2]], [[2, 1, 2, 4], [3, 5]], [[2, 3, 5, 2], [1, 4]], [[2, 3, 5, 4], [1, 2]], 
	    [[2, 3, 2, 4], [1, 5]], [[2, 5, 2, 4], [1, 3]], [[1, 3, 5, 2], [2, 4]], [[1, 3, 5, 4], [2, 2]], 
	    [[1, 3, 2, 4], [2, 5]], [[1, 5, 2, 4], [2, 3]], [[3, 5, 2, 4], [2, 1]]]):
prog::test(combinat::words::split::list([2, 1, 3, 5, 2, 4], 5),
           [[[2, 1, 3, 5, 2], [4]], [[2, 1, 3, 5, 4], [2]], [[2, 1, 3, 2, 4], [5]], [[2, 1, 5, 2, 4], [3]], 
	    [[2, 3, 5, 2, 4], [1]], [[1, 3, 5, 2, 4], [2]]]):
prog::test(combinat::words::split::list([2, 1, 3, 5, 2, 4], 6),
           [[[2, 1, 3, 5, 2, 4], []]]):
//prog::testfunc(combinat::words::split):
//prog::testexit():

//prog::check(combinat::words::split, 3):

//////////////////////////////////////////////////////////////////////////////
//prog::testinit("splittings"):
//////////////////////////////////////////////////////////////////////////////

prog::testfunc(combinat::words::splittings::isA):

prog::testfunc(combinat::words::splittings::list):
prog::test(combinat::words::splittings::list([], [], []),
           [[]]):
prog::test(combinat::words::splittings::list([1], [], [1]),
           [[1]]):
prog::test(combinat::words::splittings::list([], [1], [1]),
           [[2]]):
prog::test(combinat::words::splittings::list([1], [1], [1, 1]),
           [[2, 1], [1, 2]]):
prog::test(combinat::words::splittings::list([1, 2], [1, 2], [1, 1, 2, 2]),
           [[2, 1, 2, 1], [1, 2, 2, 1], [2, 1, 1, 2], [1, 2, 1, 2]]):
prog::test(combinat::words::splittings::list([1, 2], [1, 2], [1, 1, 2, 2]),
           [[2, 1, 2, 1], [1, 2, 2, 1], [2, 1, 1, 2], [1, 2, 1, 2]]):
prog::test(combinat::words::splittings::list([1, 2], [1, 2], [1, 2, 1, 2]),
           [[2, 2, 1, 1], [1, 1, 2, 2]]):
prog::test(combinat::words::splittings::list([1, 2], [1, 2], [1, 2, 1, 2, 1]),
           []):
prog::test(combinat::words::splittings::list([1, 2, 1, 1], [1, 1, 2, 1], [1, 1, 2, 1, 1, 2, 1, 1]),
           [[2, 2, 2, 2, 1, 1, 1, 1], [2, 2, 2, 1, 2, 1, 1, 1], [2, 1, 1, 2, 1, 2, 2, 1], 
	    [1, 2, 1, 2, 1, 2, 2, 1], [2, 1, 1, 1, 2, 2, 2, 1], [1, 2, 1, 1, 2, 2, 2, 1], 
	    [2, 1, 1, 2, 1, 2, 1, 2], [1, 2, 1, 2, 1, 2, 1, 2], [2, 1, 1, 1, 2, 2, 1, 2], 
	    [1, 2, 1, 1, 2, 2, 1, 2]]):
//prog::testfunc(combinat::words::splitings):
prog::testexit():


prog::check(combinat::words::shuffle, 3):
prog::check(combinat::words::shufflings, 3):
prog::check(combinat::words::split, 3):
prog::check(combinat::words::splittings, 3):

