/*****************************************************************************
  $Id: skewPartitions.tst,v 1.1.1.5 2004/10/16 15:22:36 nthiery Exp $
  File:		lib/COMBINAT/TEST/skewPartitions.tst
  Authors:	Teresa Gomez-Diaz <Teresa.Gomez-Diaz@univ-mlv.fr>
                Florent Hivert <florent.hivert@univ-mlv.fr>
		Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'combinat::skewPartitions'
  Created:	01/02/2003
  License:	LGPL
*****************************************************************************/

prog::testinit("skewPartitions", 23.3):

prog::testfunc(combinat::skewPartitions::isA):

prog::test(testtype([[], []], combinat::skewPartitions), TRUE):
prog::test(testtype([[], [1]], combinat::skewPartitions), FALSE):
prog::test(testtype([[], [-1]], combinat::skewPartitions), FALSE):
prog::test(testtype([[], [0]], combinat::skewPartitions), FALSE):
prog::test(combinat::skewPartitions::isA([[], []], 0), TRUE):
prog::test(testtype([[3, 2, 1], []], combinat::skewPartitions), TRUE):
prog::test(combinat::skewPartitions::isA([[3, 2, 1], []], 6), TRUE):
prog::test(combinat::skewPartitions::isA([[3, 2, 1], []], 5), FALSE):
prog::test(combinat::skewPartitions::isA([[3, 2, 1], []], 7), FALSE):
prog::test(testtype([[3, 2, 1], [1]], combinat::skewPartitions), TRUE):
prog::test(testtype([[3, 2, 1], [2]], combinat::skewPartitions), TRUE):
prog::test(testtype([[3, 2, 1], [3]], combinat::skewPartitions), TRUE):
prog::test(testtype([[3, 2, 1], [4]], combinat::skewPartitions), FALSE):
prog::test(testtype([[3, 2, 1], [1, 1]], combinat::skewPartitions), TRUE):
prog::test(testtype([[3, 2, 1], [1, 2]], combinat::skewPartitions), FALSE):
prog::test(testtype([[3, 2, 1], [2, 1]], combinat::skewPartitions), TRUE):
prog::test(testtype([[3, 2, 1], [2, 2]], combinat::skewPartitions), TRUE):
prog::test(testtype([[3, 2, 1], [3, 1]], combinat::skewPartitions), TRUE):
prog::test(testtype([[3, 2, 1], [3, 2]], combinat::skewPartitions), TRUE):
prog::test(testtype([[3, 2, 1], [1, 1, 1]], combinat::skewPartitions), TRUE):

prog::test(combinat::skewPartitions::isA([[7, 4, 3, 2], [8, 2, 1]]), FALSE):
prog::test(combinat::skewPartitions::isA([[7, 4, 3, 2], [5, 2, 1]]), TRUE):
prog::test(combinat::skewPartitions::isA([[7, 4, 3, 2], [8, 2, 1]], 8), FALSE):
prog::test(combinat::skewPartitions::isA([[7, 4, 3, 2], [5, 2, 1]], 8), TRUE):
prog::test(combinat::skewPartitions::isA([[7, 4, 3, 2], [5, 2, 1]], 5), FALSE):
prog::test(combinat::skewPartitions::isA([[7, 4, 3, 2], [5, 2, 1]], 5, -1), FALSE):
prog::test(combinat::skewPartitions::isA([[7, 4, 3, 2], [5, 2, 1]], 8, -1), TRUE):
prog::test(combinat::skewPartitions::isA([[7, 4, 3, 2], [5, 2, 1]], 8, -0), FALSE):
prog::test(combinat::skewPartitions::isA([[7, 4, 3, 2], [5, 2, 1]], 8, Connected), FALSE):
prog::test(combinat::skewPartitions::isA([[7, 4, 3, 2], [5, 2, 1]], 8, -2), TRUE):

prog::test(testtype([[], []], combinat::skewPartitions::typeConnected), TRUE):
prog::test(combinat::skewPartitions::isA([[], []], 0, Connected), TRUE):
prog::test(testtype([[3, 2, 1], []], combinat::skewPartitions::typeConnected), TRUE):
prog::test(testtype([[3, 2, 1], [1]], combinat::skewPartitions::typeConnected), TRUE):
prog::test(testtype([[3, 2, 1], [2]], combinat::skewPartitions::typeConnected), FALSE):
prog::test(testtype([[3, 2, 1], [3]], combinat::skewPartitions::typeConnected), FALSE): 
prog::test(testtype([[3, 2, 1], [4]], combinat::skewPartitions::typeConnected), FALSE): 
prog::test(testtype([[3, 2, 1], [1, 1]], combinat::skewPartitions::typeConnected), FALSE):
prog::test(combinat::skewPartitions::isA([[3, 2, 1], [1 ,1]], 4), TRUE):
prog::test(combinat::skewPartitions::isA([[3, 2, 1], [1 ,1]], 4, Connected), FALSE):
prog::test(testtype([[3, 2, 1], [1, 2]], combinat::skewPartitions::typeConnected), FALSE):
prog::test(testtype([[3, 2, 1], [2, 1]], combinat::skewPartitions::typeConnected), FALSE):
prog::test(testtype([[3, 2, 1], [2, 2]], combinat::skewPartitions::typeConnected), FALSE):
prog::test(testtype([[3, 2, 1], [3, 1]], combinat::skewPartitions::typeConnected), FALSE):
prog::test(testtype([[3, 2, 1], [3, 2]], combinat::skewPartitions::typeConnected), FALSE):
prog::test(testtype([[3, 2, 1], [1, 1, 1]], combinat::skewPartitions::typeConnected), FALSE):

prog::test(map(combinat::skewPartitions::list(4), testtype, combinat::skewPartitions),
           [TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE]):

prog::test(map(combinat::skewPartitions::list(4), testtype, combinat::skewPartitions::typeConnected),
           [TRUE, TRUE, FALSE, TRUE, TRUE, FALSE, TRUE, FALSE, FALSE, FALSE, TRUE, FALSE, TRUE, FALSE, FALSE, FALSE, TRUE, FALSE, FALSE, FALSE, TRUE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE]):

/// size, overlap, rowLenghts
prog::testfunc(combinat::skewPartitions::size):

prog::test({map(op(combinat::skewPartitions::list(5)), combinat::skewPartitions::size)},
           {5}):
prog::test(combinat::skewPartitions::size([[],[]]), 0):
prog::test(combinat::skewPartitions::size([[1],[]]), 1):
prog::test(combinat::skewPartitions::size([[10],[]]), 10):
prog::test(combinat::skewPartitions::size([[10],[2]]), 8):
if prog::TestNoTestargs = FALSE then
prog::test(combinat::skewPartitions::size([[10],[-1]]), TrapError=1202):
prog::test(combinat::skewPartitions::size([[10],[0]]), TrapError=1202):
prog::test(combinat::skewPartitions::size([[10,0],[0]]), TrapError=1202):
prog::test(combinat::skewPartitions::size([[7, 4, 3, 2], [9, 2, 1]]), TrapError=1202):
end_if:
prog::test(combinat::skewPartitions::size([[7, 4, 3, 2], [5, 2, 1]]), 8):

prog::testfunc(combinat::skewPartitions::overlap):
prog::test(min(op(map(combinat::skewPartitions::list(5, -2), combinat::skewPartitions::overlap))),
           -2):
prog::test(combinat::skewPartitions::overlap([[],[]]), infinity):
prog::test(combinat::skewPartitions::overlap([[1],[]]), infinity):
prog::test(combinat::skewPartitions::overlap([[10],[]]), infinity):
prog::test(combinat::skewPartitions::overlap([[10],[2]]), infinity):
prog::test(combinat::skewPartitions::overlap([[10, 1],[2]]), -1):
prog::test(combinat::skewPartitions::overlap([[10, 1], [2]]) = 9, -1 = 9):

prog::testfunc(combinat::skewPartitions::rowLenghts):

prog::test(combinat::skewPartitions::rowLenghts([[],[]]), [0]):
prog::test(combinat::skewPartitions::rowLenghts([[1],[]]), [1]):
if prog::TestNoTestargs = FALSE then
prog::test(combinat::skewPartitions::rowLenghts([[],[1]]), TrapError=1202):
end_if:
prog::test(combinat::skewPartitions::rowLenghts([[10],[]]), [10]):
prog::test(combinat::skewPartitions::rowLenghts([[10],[2]]), [8]):


/// count 
prog::testfunc(combinat::skewPartitions::count):

prog::test(combinat::skewPartitions::count(0, Connected), 1):
prog::test(combinat::skewPartitions::count(4, Connected), 9):
prog::test(combinat::skewPartitions::count(5, Connected), 20):
prog::test(combinat::skewPartitions::count(5, 1), 20):
prog::test(combinat::skewPartitions::count(0), 1):
prog::test(combinat::skewPartitions::count(4), 28):
prog::test(combinat::skewPartitions::count(5), 87):

prog::test(combinat::skewPartitions::count(5, -1), 
           nops(combinat::skewPartitions::list(5,-1))):
prog::test(combinat::skewPartitions::count(5, 1), 
           nops(combinat::skewPartitions::list(5,1))):

/// list
prog::testfunc(combinat::skewPartitions::list):

prog::test(combinat::skewPartitions::list(3, Connected),
           [[[3], []], [[2, 1], []], [[2, 2], [1]], [[1, 1, 1], []]]):

prog::test(combinat::skewPartitions::list(3),
           [[[3], []], [[2, 1], []], [[3, 1], [1]], [[2, 2], [1]], [[3, 2], [2]], [[1, 1, 1], []], [[2, 2, 1], [1, 1]], [[2, 1, 1], [1]], [[3, 2, 1], [2, 1]]]):

prog::test(combinat::skewPartitions::list(3, -1),
           [[[3], []], [[2, 1], []], [[3, 1], [1]], [[4, 1], [2]], [[2, 2], [1]], [[3, 2], [2]], [[4, 2], [3]], [[1, 1, 1], []], [[2, 2, 1], [1, 1]], [[3, 3, 1], [2, 2]], [[2, 1, 1], [1]], [[3, 2, 1], [2, 1]], [[4, 3, 1], [3,
2]], [[3, 1, 1], [2]], [[4, 2, 1], [3, 1]], [[5, 3, 1], [4, 2]]]):

/// generator

prog::testfunc(combinat::skewPartitions::generator):
 
prog::test(combinat::skewPartitions::list(5),
           combinat::generators::toList(combinat::skewPartitions::generator(5))):

prog::test(combinat::skewPartitions::list(5, Connected),
           combinat::generators::toList(combinat::skewPartitions::generator(5, Connected))):


prog::test(combinat::skewPartitions::list(5, 1),
           combinat::generators::toList(combinat::skewPartitions::generator(5, Connected))):

prog::test(combinat::skewPartitions::list(5, 2),
           combinat::generators::toList(combinat::skewPartitions::generator(5, 2))):

prog::test(combinat::skewPartitions::list(5, -2),
           combinat::generators::toList(combinat::skewPartitions::generator(5, -2))):


/// conjugate

prog::testfunc(combinat::skewPartitions::conjugate):

prog::test(combinat::skewPartitions::conjugate([[], []]),
           [[], []]):

prog::test(combinat::skewPartitions::conjugate([[7, 4, 3, 2], [3, 2, 1]]),
           [[4, 4, 3, 2, 1, 1, 1], [3, 2, 1]]):

prog::test(combinat::skewPartitions::conjugate([[7, 4, 3, 2], [4, 2, 1]]),
           [[4, 4, 3, 2, 1, 1, 1], [3, 2, 1, 1]]):

prog::test(combinat::skewPartitions::conjugate([[7, 4, 3, 2], [5, 2, 1]]),
           [[4, 4, 3, 2, 1, 1, 1], [3, 2, 1, 1, 1]]):

if prog::TestNoTestargs = FALSE then
prog::test(combinat::skewPartitions::conjugate([[7, 4, 3, 2], [8, 2, 1]]),
           TrapError=1202):
end_if:

/// jacobiTrudi

prog::testfunc(combinat::skewPartitions::jacobiTrudi):

prog::test(combinat::skewPartitions::jacobiTrudy([[4, 3, 2], [2, 1]]),
           matrix(array(1..3, 1..3, (1,1) = h[2], (1,2) = h[0], (1,3) = 0, 
                             (2,1) = h[4], (2,2) = h[2], (2,3) = h[0], 
                             (3,1) = h[6], (3,2) = h[4], (3,3) = h[2]))):

/// corners

prog::testfunc(combinat::skewPartitions::outerCorners):

prog::test(combinat::skewPartitions::outerCorners([[9, 8, 4, 3, 1], [6, 4, 3, 1]]),
           [[1, 9], [2, 8], [3, 4], [4, 3], [5, 1]]):

prog::testfunc(combinat::skewPartitions::innerCorners):

prog::test(combinat::skewPartitions::innerCorners([[9, 8, 4, 3, 1], [6, 4, 3, 1]]),
           [[1, 7], [2, 5], [3, 4], [4, 2], [5, 1]]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("toArray"):
//////////////////////////////////////////////////////////////////////////////

prog::test(combinat::skewPartitions::toArray([[], []]),
           array(1..1, 1..1)):
prog::test(combinat::skewPartitions::toArray([[3, 2], [1]]),
           array(1..2, 1..3, (1,1) = "", (1,2) = "", (2,2) = "", (2,3) = "")):

////////////////////////////////////////////////////////////////////////////////
// Global checking of the package

// This is done at the end to ensure that as much as possible of the
// package is initialized. A recursive prog::init(combinat::integerMatrices)
// would be usefull here.

prog::testfunc(combinat::skewPartitions):
prog::testexit():

prog::check(combinat::skewPartitions, 3):


// Local Variables: 
// mode: mupad
// End:
