/*****************************************************************************
  $Id: skewTableaux.tst,v 1.1.1.2 2005/01/26 13:42:24 nthiery Exp $
  File:         lib/COMBINAT/TEST/skewPartitions.tst
  Authors:      Francois Descouens <francois.descouens@wanadoo.fr>
  Purpose:      Test file for the library 'combinat::skewTableaux'
  Created:      21/11/2003
  License:      LGPL
*****************************************************************************/

prog::testinit("skewTableaux"):

alias(skewTableaux=combinat::skewTableaux):

Pref::typeCheck(Always):
testargs(TRUE):

////////////////////////////////////////////////////////////////////////////////
// function isA test
////////////////////////////////////////////////////////////////////////////////

//tests with classical inner partitions
prog::testfunc(combinat::skewTableaux::isASkewTableau):
prog::test(combinat::skewTableaux::isASkewTableau([[4,4,3,3,2],[[7,8],[34],[4,5],[2],[1,3]]]), FALSE):
prog::test(combinat::skewTableaux::isASkewTableau([[4,4,3,3,2],[[7,8],[6],[4,5],[2],[1,3]]]), TRUE):
prog::test(combinat::skewTableaux::isASkewTableau([[4,2,3,3,2],[[7,8],[5],[4,5],[2],[1,3]]]), FALSE):
prog::test(combinat::skewTableaux::isASkewTableau([[4,2,3,3,2],[[7,8],[34],[4,5],[2],[1,3]]]), FALSE):

//tests on tableaux which are special cases of combinat::skewTableaux
prog::test(combinat::skewTableaux::isASkewTableau([[],[[7,8],[6],[4,5],[2],[1,3]]]), FALSE):
prog::test(combinat::skewTableaux::isASkewTableau([[],[[7,8],[6],[1,5],[2],[1,3]]]), FALSE):

//tests for standard filling (each number appears only one time)
prog::test(combinat::skewTableaux::isASkewTableau([[],[[13],[11,12],[8,9,10],[4,5,6,7],[1,2,3,4]]]), TRUE):
prog::test(combinat::skewTableaux::isASkewTableau([[],[[14],[12,13],[9,10,11],[5,6,7,8],[1,2,3,4]]]), TRUE):

//tests with empty partitions or empty tableaux
prog::test(combinat::skewTableaux::isASkewTableau([]), TRUE):
prog::test(combinat::skewTableaux::isASkewTableau([[2,1],[]]), FALSE):

//tests of standard type of standard skewTableaux
prog::test(combinat::skewTableaux::isAStandardSkewTableau([[],[[13],[11,12],[8,9,10],[4,5,6,7],[1,2,3,4]]]), FALSE):
prog::test(combinat::skewTableaux::isAStandardSkewTableau([[],[[14],[12,13],[9,10,11],[5,6,7,8],[1,2,3,4]]]), TRUE):

////////////////////////////////////////////////////////////////////////////////
// function list of skewTableaux
////////////////////////////////////////////////////////////////////////////////

prog::test(nops(combinat::skewTableaux::list([[4,3,2,1],[2,1]])), 272):
prog::test(combinat::skewTableaux::list([[],[]]),  [new(combinat::skewTableaux)]):
prog::test(combinat::skewTableaux::list([[1],[]]), map([[[], [[1]]]], combinat::skewTableaux::new)):
prog::test(combinat::skewTableaux::list([[2,1],[]]),map([[[],[[2],[1,3]]],[[],[[3],[1,2]]]], combinat::skewTableaux::new)):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("toArray"):
//////////////////////////////////////////////////////////////////////////////

prog::test(combinat::skewTableaux::toArray([[2, 1], [[5, 2], [4, 3, 1]]]),
           array(1..2, 1..5, (1,2) = 5, (1,3) = 2, (2,3) = 4, (2,4) = 3, (2,5) = 1)):
prog::test(combinat::skewTableaux::toArray([[2, 1], [[], []]]),
           array(1..2, 1..2)):
prog::test(combinat::skewTableaux::toArray([[4, 2, 1], [[1], [], [1]]]),
           array(1..3, 1..5, (1,2) = 1, (3,5) = 1)):

////////////////////////////////////////////////////////////////////////////////
// Global checking of the package
// This is done at the end to ensure that as much as possible of the
// package is initialized. A recursive prog::init(combinat::integerMatrices)
// would be usefull here.
///////////////////////////////////////////////////////////////////////////////

prog::testfunc(combinat::skewTableaux):
prog::testexit():

prog::check(combinat::skewTableaux, 3):

// Local Variables: 
// mode: mupad
// End:


