/*****************************************************************************
  $Id: splitNK.tst,v 1.1.1.2 2005/01/26 13:42:25 nthiery Exp $
  File:		lib/COMBINAT/TEST/splitNK.mu
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Test file for the library 'combinat::words::splitNK'
  Created:	24/01/2004
  License:	LGPL
*****************************************************************************/

//////////////////////////////////////////////////////////////////////////////
prog::testinit("combinat::splitNK"):
//////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::splitNK::isA):

prog::test(combinat::splitNK::isA([[], []]), TRUE):
prog::test(combinat::splitNK::isA([[1], []]), TRUE):
prog::test(combinat::splitNK::isA([[], [1]]), TRUE):
prog::test(combinat::splitNK::isA([[1], [1]]), FALSE):
prog::test(combinat::splitNK::isA([[1,2], []]), TRUE):
prog::test(combinat::splitNK::isA([[1,2], [1]]), FALSE):
prog::test(combinat::splitNK::isA([[1], [2]]), TRUE):
prog::test(combinat::splitNK::isA([[1], [3]]), FALSE):
prog::test(combinat::splitNK::isA([[1,2], [3]]), TRUE):
prog::test(combinat::splitNK::isA([[2,3], [2]]), FALSE):
prog::test(combinat::splitNK::isA([[2,4], [3]]), FALSE):

prog::test(combinat::splitNK::isA([[], []], 0, 0), TRUE):
prog::test(combinat::splitNK::isA([[], []], 0, 1), FALSE):
prog::test(combinat::splitNK::isA([[], []], 1, 0), FALSE):
prog::test(combinat::splitNK::isA([[1,2], []], 2), TRUE):
prog::test(combinat::splitNK::isA([[1,2], []], 1), FALSE):
prog::test(combinat::splitNK::isA([[1,2], []], 3), FALSE):
prog::test(combinat::splitNK::isA([[1,2], []], 2, 2), TRUE):
prog::test(combinat::splitNK::isA([[1,2], []], 2, 1), FALSE):
prog::test(combinat::splitNK::isA([[], [1,2]], 2, 0), TRUE):
prog::test(combinat::splitNK::isA([[], [1,2]], 2, 1), FALSE):
prog::test(combinat::splitNK::isA([[1,3], [2]], 3), TRUE):
prog::test(combinat::splitNK::isA([[1,3], [2]], 3, 2), TRUE):
prog::test(combinat::splitNK::isA([[1,3], [2]], 3, 1), FALSE):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::splitNK::count):

prog::test(combinat::splitNK::count(0,0), 1):
prog::test([combinat::splitNK::count(3,i) $ i=0..5], [binomial(3,i) $ i=0..5]):
prog::test([combinat::splitNK::count(5,i) $ i=0..5], [binomial(5,i) $ i=0..5]):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::splitNK::list):

prog::test(combinat::splitNK::list(0, 0),           [[[], []]]):
prog::test(combinat::splitNK::list(1, 0),           [[[], [1]]]):
prog::test(combinat::splitNK::list(1, 1),           [[[1], []]]):
prog::test(combinat::splitNK::list(1, 2),           []):

prog::test([combinat::splitNK::list(3, i) $ i = 0..5],
           [[[[], [1, 2, 3]]],
	    [[[1], [2, 3]], [[2], [1, 3]], [[3], [1, 2]]],
	    [[[1, 2], [3]], [[1, 3], [2]], [[2, 3], [1]]],
	    [[[1, 2, 3], []]],
	    [],
	    []]):
prog::test([combinat::splitNK::list(5, i) $ i = 0..6],
           [[[[], [1, 2, 3, 4, 5]]],
	    [[[1], [2, 3, 4, 5]], [[2], [1, 3, 4, 5]], [[3], [1, 2, 4, 5]], [[4], [1, 2, 3, 5]], [[5], [1, 2, 3, 4]]],
	    [[[1, 2], [3, 4, 5]], [[1, 3], [2, 4, 5]], [[1, 4], [2, 3, 5]], [[1, 5], [2, 3, 4]], [[2, 3], [1, 4, 5]],
	     [[2, 4], [1, 3, 5]], [[2, 5], [1, 3, 4]], [[3, 4], [1, 2, 5]], [[3, 5], [1, 2, 4]], [[4, 5], [1, 2, 3]]],
	    [[[1, 2, 3], [4, 5]], [[1, 2, 4], [3, 5]], [[1, 2, 5], [3, 4]], [[1, 3, 4], [2, 5]], [[1, 3, 5], [2, 4]],
	     [[1, 4, 5], [2, 3]], [[2, 3, 4], [1, 5]], [[2, 3, 5], [1, 4]], [[2, 4, 5], [1, 3]], [[3, 4, 5], [1, 2]]],
	    [[[1, 2, 3, 4], [5]], [[1, 2, 3, 5], [4]], [[1, 2, 4, 5], [3]], [[1, 3, 4, 5], [2]], [[2, 3, 4, 5], [1]]],
	    [[[1, 2, 3, 4, 5], []]],
	    []]):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::splitNK::unrank):

prog::test([combinat::splitNK::unrank(i, 0, 0) $ i = 1..6],
           [[[], []], FAIL, FAIL, FAIL, FAIL, FAIL]):
prog::test([combinat::splitNK::unrank(i, 5, 2) $ i = 1..11],
           [[[1, 2], [3, 4, 5]], [[1, 3], [2, 4, 5]], [[1, 4], [2, 3, 5]], [[1, 5], [2, 3, 4]], [[2, 3], [1, 4, 5]],
	    [[2, 4], [1, 3, 5]], [[2, 5], [1, 3, 4]], [[3, 4], [1, 2, 5]], [[3, 5], [1, 2, 4]], [[4, 5], [1, 2, 3]],
	    FAIL]):



//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::splitNK::random):
prog::test(combinat::splitNK::random(0, 0), [[], []]):
prog::test(combinat::splitNK::random(5, 0), [[], [1, 2, 3, 4, 5]]):
prog::test(combinat::splitNK::random(5, 5), [[1, 2, 3, 4, 5], []]):

(prog::test(bool(contains(combinat::splitNK::list(5, 2), combinat::splitNK::random(5, 2)) <> 0),
           TRUE)) $ i=1..10:

prog::test(nops((l14 := combinat::splitNK::list(14, 5))), 2002):
(prog::test(bool(contains(l14, combinat::splitNK::random(14, 5)) <> 0),
	    TRUE)) $ i=1..100:



//////////////////////////////////////////////////////////////////////////////
prog::testfunc(combinat::splitNK):
prog::testexit():

prog::check(combinat::splitNK, 3):
