/*****************************************************************************
  $Id: subClass.tst,v 1.1.1.2 2004/10/04 17:25:17 nthiery Exp $
  File:		lib/COMBINAT/TEST/subClass.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
                Florent Hivert <florent.hivert@univ-mlv.fr>
  Created:	1/06/2003
  License:	LGPL
*****************************************************************************/

prog::testinit("subClass"):

p3 := combinat::subClass(combinat::permutations, Parameters = 3):
t3 := combinat::subClass(combinat::binaryTrees, Parameters = 3):
vl3 := combinat::subClass(combinat::integerVectors, Parse = ((z) -> (z, 3)), Size = (z -> _plus(op(z)))):
vs3 := combinat::subClass(combinat::integerVectors, Parameters = 3, Size = (z -> nops(z))):
//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::subClass::isA"):
//////////////////////////////////////////////////////////////////////////////
prog::test(map(p3::list(), p3::isA), [TRUE $ p3::count()]):
prog::test(map(t3::list(), t3::isA), [TRUE $ t3::count()]):
prog::test(map(vl3::list(4), z -> vl3::isA(z,4)), [TRUE $ vl3::count(4)]):
prog::test(map(vs3::list(4), vs3::isA), [TRUE $ vs3::count(4)]):
prog::test(map(vs3::list(4), z -> vs3::isA(z,4)), [TRUE $ vs3::count(4)]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::subClass::count"):
//////////////////////////////////////////////////////////////////////////////
prog::test(p3::count(), 6):
prog::test(t3::count(), 5):
prog::test(vl3::count(4), 15):
prog::test(vs3::count(5), 35):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc(subClass::list):
//////////////////////////////////////////////////////////////////////////////
alias(d=combinat::binaryTrees::dummyLabel):
prog::test(p3::list(),
           [[1, 2, 3], [1, 3, 2], [2, 1, 3], [2, 3, 1], [3, 1, 2], [3, 2, 1]]):
prog::test(map(t3::list(), expr),
           [[d, [], [d, [], [d, [], []]]], [d, [], [d, [d, [], []], []]], 
	    [d, [d, [], []], [d, [], []]], [d, [d, [], [d, [], []]], []], 
	    [d, [d, [d, [], []], []], []]]):
prog::test(vl3::list(4),
	   [[4, 0, 0], [3, 1, 0], [3, 0, 1], [2, 2, 0], [2, 1, 1], [2, 0, 2], 
	    [1, 3, 0], [1, 2, 1], [1, 1, 2], [1, 0, 3], [0, 4, 0], [0, 3, 1], 
	    [0, 2, 2], [0, 1, 3], [0, 0, 4]]):
prog::test(vs3::list(4),
	   [[3, 0, 0, 0], [2, 1, 0, 0], [2, 0, 1, 0], [2, 0, 0, 1], [1, 2, 0, 0], 
	    [1, 1, 1, 0], [1, 1, 0, 1], [1, 0, 2, 0], [1, 0, 1, 1], [1, 0, 0, 2], 
	    [0, 3, 0, 0], [0, 2, 1, 0], [0, 2, 0, 1], [0, 1, 2, 0], [0, 1, 1, 1], 
	    [0, 1, 0, 2], [0, 0, 3, 0], [0, 0, 2, 1], [0, 0, 1, 2], [0, 0, 0, 3]]):
prog::test(map(p3::list(), domtype),
           [DOM_LIST $ 6]):
prog::test(map(t3::list(), domtype),
           [combinat::binaryTrees $ 5]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(subClass::categories):
//////////////////////////////////////////////////////////////////////////////

domain A
    inherits Dom::BaseDomain;
    category Cat::CombinatorialClass, Cat::OrderedSet;
    axiom Ax::normalRep, Ax::systemRep;
end_domain:

prog::test((combinat::subClass(A))::hasProp(Cat::CombinatorialClass),
	   TRUE):
prog::test((combinat::subClass(A, Parameters = 1))::hasProp(Ax::normalRep),
	   FALSE):
prog::test(p3::hasProp(Cat::CombinatorialClass), TRUE):
prog::test(p3::hasProp(Cat::GradedCombinatorialClass), FALSE):
prog::test(t3::hasProp(Cat::CombinatorialClass), TRUE):
prog::test(t3::hasProp(Cat::GradedCombinatorialClass), FALSE):
prog::test(vl3::hasProp(Cat::CombinatorialClass), TRUE):
prog::test(vl3::hasProp(Cat::GradedCombinatorialClass), TRUE):
prog::test(vs3::hasProp(Cat::CombinatorialClass), TRUE):
prog::test(vs3::hasProp(Cat::GradedCombinatorialClass), TRUE):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(subClass::generator):
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

prog::testexit():

prog::check([p3, t3, vl3, vs3], 3):

// Local Variables: 
// mode: mupad
// End:
