/*****************************************************************************
  $Id: subwords.tst,v 1.1.1.2 2004/10/04 17:25:17 nthiery Exp $
  File:		lib/COMBINAT/TEST/subwords.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
                Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Test file for the library 'combinat::subwords'
  Created:	26/02/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("subwords"):

prog::testfunc(combinat::subwords::isA):
prog::test(combinat::subwords::isA([], [1, 3, 3, 5, 4, 5, 3, 5]),
           TRUE):
prog::test(combinat::subwords::isA([1], [1, 3, 3, 5, 4, 5, 3, 5], 1),
           TRUE):
prog::test(combinat::subwords::isA([5, 5, 3], [1, 3, 3, 5, 4, 5, 3, 5]),
           TRUE):
prog::test(combinat::subwords::isA([3, 5, 5, 3], [1, 3, 3, 5, 4, 5, 3, 5]),
           TRUE):
prog::test(combinat::subwords::isA([3, 5, 5, 3, 4], [1, 3, 3, 5, 4, 5, 3, 5]),
           FALSE):
prog::test(combinat::subwords::isA([], [1, 3, 3, 5, 4, 5, 3, 5], 0),
           TRUE):
prog::test(combinat::subwords::isA([3, 5, 3], [1, 3, 3, 5, 4, 5, 3, 5], 3),
           TRUE):
prog::test(combinat::subwords::isA([3, 5, 3], [1, 3, 3, 5, 4, 5, 3, 5], 4),
           FALSE):

prog::testfunc(combinat::subwords::smallestPositions):
prog::test(combinat::subwords::smallestPositions([1, 3, 3, 4, 5], []),
           []):
prog::test(combinat::subwords::smallestPositions([1, 3, 3, 4, 5], [1]),
           [1]):
prog::test(combinat::subwords::smallestPositions([1, 3, 3, 4, 5], [1], 1),
           [1]):
prog::test(combinat::subwords::smallestPositions([1, 3, 3, 4, 5], [1], 2),
           FAIL):
prog::test(combinat::subwords::smallestPositions([1, 3, 4, 5], [3, 5]),
           [2, 4]):
prog::test(combinat::subwords::smallestPositions([1, 3, 3, 4, 5], [3, 5]),
           [2, 5]):
prog::test(combinat::subwords::smallestPositions([1, 3, 3, 5, 4, 5, 3, 5], [3, 5, 3]),
           [2, 4, 7]):
prog::test(combinat::subwords::smallestPositions([1, 3, 3, 5, 4, 5, 3, 5], [3, 5, 3], 3),
           [3, 4, 7]):
prog::test(combinat::subwords::smallestPositions([1, 3, 3, 5, 4, 5, 3, 5], [3, 5, 3], 4),
           FAIL):


prog::testfunc(combinat::subwords::count):
prog::test( combinat::subwords::count([],0), 1 ):
prog::test( combinat::subwords::count([1],0), 1 ):
prog::test( combinat::subwords::count([],1), 0 ):
prog::test( combinat::subwords::count([a $ 5],2), 10):
prog::test( combinat::subwords::count([1,2,3,4],2),6):

prog::testfunc(combinat::subwords::list):

prog::test(     combinat::subwords::first([],0),	[]		):
prog::test(     combinat::subwords::first([],1),	FAIL		):
prog::test(     combinat::subwords::first([1,2],2),	[1,2]		):
prog::test(     combinat::subwords::first([1,2,3],3),	[1,2,3]		):
prog::test(     combinat::subwords::first([1,2,3]),	[]		):
prog::test(     combinat::subwords::last([],0),		[]		):
prog::test(     combinat::subwords::last([],1),		FAIL		):
prog::test(     combinat::subwords::last([$1..2],2),	[1,2]		):
prog::test(     combinat::subwords::last([$1..7],3),	[5,6,7]		):

// The order in which the subwords are listed is not in the
// specifications of combinat::subwords::list, so we sort the result
// before comparing.

prog::test(     combinat::subwords::list([],0),	[[]]		):
prog::test(     combinat::subwords::list([],1),	[]		):
prog::test(sort(combinat::subwords::list([1,2],1)),	sort([[2],[1]])	):

prog::test(    combinat::subwords::list([]),	[[]]):
prog::test(sort(combinat::subwords::list([$1..3])),
           sort([[], [1], [2], [3], [1, 2], [1, 3], [2, 3], [1, 2, 3]])):
prog::test(sort(combinat::subwords::list([a,b,c])),
           sort([[], [a], [b], [c], [a, b], [a, c], [b, c], [a, b, c]])):
prog::test(sort(combinat::subwords::list([a,a,c])),
           sort([[], [a], [a], [c], [a, a], [a, c], [a, c], [a, a, c]])):

for k from 0 to 11 do
    prog::test( nops(combinat::subwords::list([$1..10],k)),  
	        combinat::subwords::count([$1..10],k)):
end_for:

for n from 0 to 6 do
    prog::test( combinat::subwords::count([$1..n]),		2^n):
    prog::test( nops(combinat::subwords::list([a $ n])),	2^n):
    prog::test( nops(combinat::subwords::list([$1..n])),	2^n):
end_for:

prog::testfunc(combinat::subwords::unrank):
for n from 0 to 6 do
    w := [$1..n]: 
    prog::test(bool([combinat::subwords::unrank(i,w) $ i=1..2^(nops(w))+2] = 
		    combinat::subwords::list(w).[FAIL, FAIL]));
end_for:

prog::testfunc(combinat::subwords::random):
w := [1,1,2,1,3,2,4,5]: 
for n from 0 to 100 do
    prog::test(combinat::subwords::isA(combinat::subwords::random(w),
				       w));
    prog::test(combinat::subwords::isA(combinat::subwords::random(w, 5),
				       w, 5));
end_for:


//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

// This is done at the end to ensure as much as possible of the
// package is initialized. A recursive prog::init(combinat::subsets)
// would be usefull here.

prog::testfunc(combinat::subwords):
prog::testexit():

prog::check(combinat::subwords, 3):


// Local Variables: 
// mode: mupad
// End:
