/*****************************************************************************
  $Id: tableaux.tst,v 1.1.1.7 2005/01/26 13:42:25 nthiery Exp $
  File:		lib/COMBINAT/TEST/tableaux.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  		Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Test file for the library 'combinat::tableaux'
  Created:	31/10/2001
  License:	LGPL
*****************************************************************************/

export(combinat, Alias, tableaux):

prog::testinit("tableaux"):

prog::testfunc(combinat::tableaux::isA):
prog::test(combinat::tableaux::isA([])):
prog::test(combinat::tableaux::isA([[1]])):
prog::test(combinat::tableaux::isA([[1,2]])):
prog::test(combinat::tableaux::isA([[2],[1,2]])):
prog::test(combinat::tableaux::isA([[2],[2,1]]), FALSE):
prog::test(combinat::tableaux::isA([[1],[1,2]]), FALSE):
prog::test(combinat::tableaux::isA([[2,2],[1,2]]), FALSE):
prog::test(combinat::tableaux::isA([[2,3],[1,2]])):
prog::test(combinat::tableaux::isA([], [])):
prog::test(combinat::tableaux::isA([], [1]), FALSE):
prog::test(combinat::tableaux::isA([[1]], [1])):
prog::test(combinat::tableaux::isA([[2,3],[1,2]], [2,1]), FALSE):
prog::test(combinat::tableaux::isA([[2,3],[1,2]], [2,2])):
prog::test(combinat::tableaux::isA([[2,3],[1,2,2]], [3,2])):
prog::test(combinat::tableaux::isA([[2,3],[1,2,2]], [3,3]), FALSE):

prog::test(combinat::tableaux::isA(combinat::tableaux::new([]))):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([[1]]))):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([[1,2]]))):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([[2],[1,2]]))):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([[2],[2,1]])), FALSE):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([[1],[1,2]])), FALSE):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([[2,2],[1,2]])), FALSE):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([[2,3],[1,2]]))):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([]), [])):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([]), [1]), FALSE):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([[1]]), [1])):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([[2,3],[1,2]]), [2,1]), FALSE):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([[2,3],[1,2]]), [2,2])):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([[2,3],[1,2,2]]), [3,2])):
prog::test(combinat::tableaux::isA(combinat::tableaux::new([[2,3],[1,2,2]]), [3,3]), FALSE):

prog::testfunc(combinat::tableaux::isAStandardTableau):
prog::test(combinat::tableaux::isAStandardTableau([])):
prog::test(combinat::tableaux::isAStandardTableau([[1]])):
prog::test(combinat::tableaux::isAStandardTableau([[1,2]])):
prog::test(combinat::tableaux::isAStandardTableau([[2],[1,2]]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau([[3],[1,2]])):
prog::test(combinat::tableaux::isAStandardTableau([[2],[1,3]])):
prog::test(combinat::tableaux::isAStandardTableau([[2],[2,1]]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau([[1],[1,2]]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau([[2,2],[1,2]]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau([[2,3],[1,2]]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau([[3,4],[1,2]])):
prog::test(combinat::tableaux::isAStandardTableau([], [])):
prog::test(combinat::tableaux::isAStandardTableau([], [1]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau([[1]], [1])):
prog::test(combinat::tableaux::isAStandardTableau([[2,3],[1,2]], [2,1]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau([[2,3],[1,2]], [2,2]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau([[3,4],[1,2]], [2,2])):
prog::test(combinat::tableaux::isAStandardTableau([[2,4],[1,3]], [2,2])):
prog::test(combinat::tableaux::isAStandardTableau([[2,4],[1,3,5]])):
prog::test(combinat::tableaux::isAStandardTableau([[2,4],[1,3,5]], [2,2]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau([[2,4],[1,3,5]], [3,2])):
prog::test(combinat::tableaux::isAStandardTableau([[2,4],[1,3,5]], [3,3]), FALSE):

prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([]))):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[1]]))):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[1,2]]))):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[2],[1,2]])), FALSE):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[3],[1,2]]))):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[2],[1,3]]))):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[2],[2,1]])), FALSE):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[1],[1,2]])), FALSE):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[2,2],[1,2]])), FALSE):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[2,3],[1,2]])), FALSE):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[3,4],[1,2]]))):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([]), [])):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([]), [1]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[1]]), [1])):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[2,3],[1,2]]), [2,1]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[2,3],[1,2]]), [2,2]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[3,4],[1,2]]), [2,2])):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[2,4],[1,3]]), [2,2])):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[2,4],[1,3,5]]))):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[2,4],[1,3,5]]), [2,2]), FALSE):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[2,4],[1,3,5]]), [3,2])):
prog::test(combinat::tableaux::isAStandardTableau(combinat::tableaux::new([[2,4],[1,3,5]]), [3,3]), FALSE):

prog::testfunc(combinat::tableaux::shape):

prog::test(combinat::tableaux::shape([]), []):
if prog::TestNoTestargs = FALSE then
prog::test(combinat::tableaux::shape([[]]), TrapError = 1202):
end_if:
prog::test(combinat::tableaux::shape([[1]]), [1]):
prog::test(combinat::tableaux::shape(
              combinat::tableaux::new([[3],[1,2]])), [2,1]):

prog::testfunc(combinat::tableaux::isAFilling):

prog::test(combinat::tableaux::isAFilling([])):
prog::test(combinat::tableaux::isAFilling([[]]), FALSE):
prog::test(combinat::tableaux::isAFilling([[1]])):  

prog::testfunc(combinat::tableaux::count):
// Check that count is coherent with list far all partitions upto size 6.
(prog::test(bool(nops(combinat::tableaux::list(l)) =
		combinat::tableaux::count(l))) 
 $ l in _concat(combinat::partitions::list(i) $ i = 1..7)):

prog::testfunc(combinat::tableaux::generator):

// The order in which the tableaux are listed is not in the
// specifications of combinat::tableaux::list, so we sort
// the result before comparing.

prog::test(combinat::tableaux::list([]), [new(combinat::tableaux)]):
prog::test(combinat::tableaux::list([]), [combinat::tableaux::new([])]):

prog::test(combinat::tableaux::list([1]),     map([[[1]]], combinat::tableaux::new) ):
prog::test(combinat::tableaux::list([3]),     map([[[1,2,3]]], combinat::tableaux::new) ):
prog::test(combinat::tableaux::list([1,1,1]), map([[[3],[2],[1]]], combinat::tableaux::new) ):

prog::test(combinat::tableaux::count([]),     1):
prog::test(combinat::tableaux::count([1,1,1]),1):
prog::test(combinat::tableaux::count([3]),    1):
prog::test(combinat::tableaux::count([2,2]),  2):
prog::test(combinat::tableaux::count([3,2,2]),  21):
prog::test(combinat::tableaux::count([3,2,2]),  nops(combinat::tableaux::list([3,2,2]))):

prog::testfunc(combinat::tableaux::canonical):

prog::test(combinat::tableaux::canonical([]), 
           combinat::tableaux::new([])):
prog::test(combinat::tableaux::canonical([5,4,2]),
           combinat::tableaux::new([[10, 11], [6,7,8,9], [1, 2, 3, 4, 5]])):
prog::test(combinat::tableaux::canonical([4]),
           combinat::tableaux::new([[1,2,3,4]])):
prog::test(combinat::tableaux::canonical([3,2]),
           combinat::tableaux::new([[4,5], [1,2,3]])):
prog::test(combinat::tableaux::canonical([1,1,1,1]),
           combinat::tableaux::new([[4],[3],[2],[1]])):

prog::testfunc(combinat::tableaux::columnCanonical):

prog::test(combinat::tableaux::columnCanonical([]), 
           combinat::tableaux::new([])):
prog::test(combinat::tableaux::columnCanonical([5,4,2]),
           combinat::tableaux::new([[3, 6], [2, 5, 8, 10], [1, 4, 7, 9, 11]])):
prog::test(combinat::tableaux::columnCanonical([4]),
           combinat::tableaux::new([[1,2,3,4]])):
prog::test(combinat::tableaux::columnCanonical([1,1,1,1]),
           combinat::tableaux::new([[4],[3],[2],[1]])):
prog::test(combinat::tableaux::columnCanonical([3,2]),
           combinat::tableaux::new([[2,4], [1,3,5]])):

prog::testfunc(combinat::tableaux::indexFilling):
if prog::TestNoTestargs = FALSE then
prog::test(combinat::tableaux::indexFilling([[]]), TrapError = 1202):
end_if:
prog::test(combinat::tableaux::indexFilling([[3],[1,2]]),
           [[1], [0, 0]]):
prog::test(combinat::tableaux::indexFilling([[2],[1,3]]),
           [[1], [0, 1]]):
prog::test(combinat::tableaux::indexFilling([[3,5],[1,2,4]]),
           [[1, 2], [0, 0, 1]]):

prog::test(combinat::tableaux::rowStabilizer([[]]),
           [[]]):
prog::test(combinat::tableaux::rowStabilizer([[3], [1, 2]]),
           [[1, 2, 3], [2, 1, 3]]):
prog::test(combinat::tableaux::rowStabilizer([[3], [1, 2, 4]]),
           [[1, 2, 3, 4], [1, 4, 3, 2], [2, 1, 3, 4], [2, 4, 3, 1], [4, 1, 3, 2], [4, 2, 3, 1]]):
prog::test(combinat::tableaux::columnStabilizer([]),
           [[]]):
prog::test(combinat::tableaux::columnStabilizer([[1]]),
           [[1]]):
prog::test(combinat::tableaux::columnStabilizer([[2], [1]]),
           [[1, 2], [2, 1]]):
prog::test(combinat::tableaux::columnStabilizer([[2], [1, 3, 4]]),
           [[1, 2, 3, 4], [2, 1, 3, 4]]):


prog::testfunc(combinat::tableaux::cocharge):
prog::test(_plus(op(map(combinat::tableaux::list([2,2]), S->z^combinat::tableaux::cocharge(S)))),
           z^2+z^4):
prog::test(_plus(op(map(combinat::tableaux::list([4,1]), S->z^combinat::tableaux::cocharge(S)))),
           z+z^2+z^3+z^4):

// Coherency test by computing the hilbert series of the harmonics
// polynomials by two different means.
for n from 4 to 5 do
    prog::test(_plus(_plus(z^combinat::tableaux::cocharge(S)
                           $ S in combinat::tableaux::list(p))
                     * n!/_mult(op(combinat::partitions::hooklengths(p)))
                     $ p in combinat::partitions::list(n)),
               // the q-factorial
               expand(_mult( _plus( z^(d-1) $ d=1..i ) $ i=1..n ))):
end_for:

prog::testfunc(combinat::tableaux::fromWord):
prog::test(combinat::tableaux::fromWord([4,1,2,3]), combinat::tableaux::new([[4],[1,2,3]])):
prog::test(combinat::tableaux::fromWord([]), combinat::tableaux::new([])):
prog::test(combinat::tableaux::fromWord([1]), combinat::tableaux::new([[1]])):
prog::test(combinat::tableaux::fromWord([4,3,2,1]),
           combinat::tableaux::new([[4], [3], [2], [1]])):


prog::testfunc(combinat::tableaux::fromShapeAndWord):
prog::test(combinat::tableaux::fromShapeAndWord([], []),
           combinat::tableaux::new([])):
prog::test(combinat::tableaux::fromShapeAndWord([4], [a, b, c, d]),
           combinat::tableaux::new([[a, b, c, d]])):
prog::test(combinat::tableaux::fromShapeAndWord([1, 1, 1, 1], [a, b, c, d]),
           combinat::tableaux::new([[a], [b], [c], [d]])):
prog::test(combinat::tableaux::fromShapeAndWord([3, 1], [a, b, c, d]),
           combinat::tableaux::new([[a], [b, c, d]])):

//////////////////////////////////////////////
prog::testfunc(combinat::tableaux::conjugate):

prog::test(combinat::tableaux::conjugate([[5,6], [1,2,3,4]]),
	   [[4], [3], [2,6], [1,5]]):
prog::test(combinat::tableaux::conjugate([]),
	   []):
prog::test(combinat::tableaux::conjugate([[5], [4], [3], [2], [1]]),
	   [[1,2,3,4,5]]):
prog::test(combinat::tableaux::conjugate([[1,2,3,4,5]]),
	   [[5], [4], [3], [2], [1]]):

for n from 0 to 7 do
    for p in combinat::partitions::list(n) do
        for T in combinat::tableaux::list(p) do
            S:= combinat::tableaux::expr(T):
            prog::test(combinat::tableaux::conjugate
                       (combinat::tableaux::conjugate(S)),
                       S):
        end_for:
    end_for:
end_for:


// we do not test insertLetter since it's an internal function of
// insertWord.
prog::testfunc(combinat::tableaux::insertWord):

prog::test(combinat::tableaux::insertWord(combinat::tableaux::new([]),[]),
	   combinat::tableaux::new([])):
prog::test(combinat::tableaux::insertWord(combinat::tableaux::new([]),[3,1,4,2,5]),
	   combinat::tableaux::new([[3, 4], [1, 2, 5]])):
prog::test(combinat::tableaux::insertWord(combinat::tableaux::new([[2],[1,1]]),[1,2]),
	   combinat::tableaux::new([[2], [1,1,1,2]])):
prog::test(combinat::tableaux::insertWord(combinat::tableaux::new([[2,3],[1,1]]),[3]),
	   combinat::tableaux::new([[2, 3], [1, 1, 3]])):
prog::test(combinat::tableaux::insertWord(combinat::tableaux::new([[2,3],[1,1]]),[3,2,3]),
	   combinat::tableaux::new([[2, 3, 3], [1, 1, 2, 3]])):
prog::test(combinat::tableaux::insertWord(combinat::tableaux::new([[2,3],[1,1]]),[3,2,3,2,3]),
	   combinat::tableaux::new([[2, 3, 3, 3], [1, 1, 2, 2, 3]])):
prog::test(combinat::tableaux::insertWord(combinat::tableaux::new([[1,2,3,4,5]]),[2,3,4]),
	   combinat::tableaux::new([[3, 4, 5], [1, 2, 2, 3, 4]])):

// The insertion of the row reading is the tableau
for n from 0 to 7 do
    for p in combinat::partitions::list(n) do
        for t in combinat::tableaux::list(p) do
            prog::test(combinat::tableaux::insertWord(
                           combinat::tableaux::new([]),
                           combinat::tableaux::toWord(t)),
                       t):
        end_for;
    end_for;
end_for:

//////////////////////////////////////////////////////////

// Tests that the number of permutation thats gives a certain tableau
// (ie: the plactic class) is equal to the number of tableaux of the
// same shape.
testSchensted := 
proc(n)
    local p, t, tnum, res, nTabShape, tab;
begin
    res := [];
    tnum := table();
    for p in combinat::partitions::list(n) do
	for t in combinat::tableaux::list(p) do
	    tnum[t] := 0;
        end_for;
    end_for;
    g := combinat::permutations::generator(n);
    while (p:=g())<>FAIL do
	tab := combinat::tableaux::insertWord(combinat::tableaux::new([]), p);
	tnum[tab] := tnum[tab] + 1;
    end_while;
    for p in combinat::partitions::list(n) do
	nTabShape := combinat::tableaux::count(p);
        for t in combinat::tableaux::list(p) do
	    if tnum[t] <> nTabShape then
		res := append(res, [t, tnum[t], nTabShape]);
	    end_if;
        end_for;
    end_for;    
    res;
end_proc:

for n from 0 to 7 do
    prog::test(testSchensted(n), []);
end_for:

prog::test(
   nops(map(combinat::tableaux::list([]),x->combinat::tableaux::insertWord(x, []))),
   combinat::tableaux::count([])):

//////////////////////////////////////////////////////////

prog::testfunc(combinat::tableaux::schensted):
prog::test(combinat::tableaux::schensted([]),
           [combinat::tableaux::new([]), combinat::tableaux::new([])]):
prog::test(combinat::tableaux::schensted([1]),
           [combinat::tableaux::new([[1]]), combinat::tableaux::new([[1]])]):
prog::test(combinat::tableaux::schensted([2, 1, 3]),
           [combinat::tableaux::new([[2], [1, 3]]), combinat::tableaux::new([[2], [1, 3]])]):
prog::test(combinat::tableaux::schensted([1, 2, 1, 1, 3]),
           [combinat::tableaux::new([[2], [1, 1, 1, 3]]), combinat::tableaux::new([[3], [1, 2, 4, 5]])]):

prog::testfunc(combinat::tableaux::invSchensted):
prog::test(combinat::tableaux::invSchensted(combinat::tableaux::new([]), combinat::tableaux::new([])),
           []):
prog::test(combinat::tableaux::invSchensted(combinat::tableaux::new([[1]]), combinat::tableaux::new([[1]])),
           [1]):
prog::test(combinat::tableaux::invSchensted(combinat::tableaux::new([[1, 3]]), combinat::tableaux::new([[1, 2]])),
           [1, 3]):
prog::test(combinat::tableaux::invSchensted(combinat::tableaux::new([[1, 2, 3]]), combinat::tableaux::new([[1, 2, 3]])),
           [1, 2, 3]):
prog::test(combinat::tableaux::invSchensted(combinat::tableaux::new([[3], [1, 2]]), combinat::tableaux::new([[3], [1, 2]])),
           [1, 3, 2]):
prog::test(combinat::tableaux::invSchensted(combinat::tableaux::new([[2], [1, 3]]), combinat::tableaux::new([[3], [1, 2]])),
           [2, 3, 1]):

// Test that Schensted and invSchensted are really inverse one of each other
for w in [[], [1], [1,2], [2,1],
	  op(combinat::permutations::list(5)),
	  [1,3,2,1],
	  op(combinat::words::list(3,5)),
	  [3, 2, 4, 1, 1, 2, 3, 5, 4, 1, 2, 4],
	  [1,4,3,5,2,3,4,2,2,3,1,2,3,4,3,1,2,3,4,2,3,2,1] ] do
prog::test(combinat::tableaux::invSchensted(
	      op(combinat::tableaux::schensted(w))),
           w):
end_for:

//////////////////////////////////////////////////////////

prog::testfunc(combinat::tableaux::toPoset):

prog::test(Graph::getEdges(combinat::tableaux::toPoset([[2], [1]])),
           [[1, 2]]):
prog::test(Graph::getEdges(combinat::tableaux::toPoset([[1, 2]])),
           [[1, 2]]):
prog::test(Graph::getEdges(combinat::tableaux::toPoset([[1, 2], [3, 4]])),
           [[1, 2], [3, 1], [3, 4], [4, 2]]):
prog::test(Graph::getEdges(combinat::tableaux::toPoset([[3, 4], [1, 2, 5]])),
           [[1, 2], [1, 3], [2, 4], [2, 5], [3, 4]]):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc("toArray"):
//////////////////////////////////////////////////////////////////////////////

prog::test(combinat::tableaux::toArray([]),
           array(1..1, 1..1)):
prog::test(combinat::tableaux::toArray([[3, 2, 1]]),
           array(1..1, 1..3, (1,1) = 3, (1,2) = 2, (1,3) = 1)):
prog::test(combinat::tableaux::toArray([[2], [3, 2, 1]]),
           array(1..2, 1..3, (1,1) = 2, (2,1) = 3, (2,2) = 2, (2,3) = 1)):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::tableaux::kostka"):

prog::test(tableaux::kostka([3, 2], [2, 2, 1]),
           2):
prog::test(tableaux::kostka([1], [1]),
           1):
prog::test(tableaux::kostka([], []),
           1):
prog::test(tableaux::kostka([], [1]),
           0):
prog::test(tableaux::kostka([1], []),
           0):

// Coherency test between Symmetrica and lrcalc
if Symmetrica <> FAIL and combinat::lrcalc <> FAIL then
    for p in [[], [1],[5,2,1],[4,3,1]] do
	for q in [[]].combinat::compositions::list(combinat::partitions::size(p)) do
	    prog::test(bool(tableaux::kostkaFromLrcoef(p,q) =
			    tableaux::kostkaFromSymmetrica(p,q)));
	    if testtype(q, combinat::partitions) then
		// This one is slow, so we only do it for q partition
		prog::test(bool(tableaux::kostkaFromLrcoef(p,q) =
				tableaux::kostkaFromListNonStandardTableaux(p,q)));
	    end_if;
	end_for;
    end_for;
end_if:

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

// This is done at the end to ensure as much as possible of the
// package is initialized. A recursive prog::init(combinat::subsets)
// would be usefull here.

prog::testfunc(combinat::tableaux):
prog::testexit():

prog::check(combinat::tableaux, 3):


// Local Variables: 
// mode: mupad
// End:
