/*****************************************************************************
  $Id: catalan.mu,v 1.1.1.1 2003/09/15 16:37:32 nthiery Exp $
  File:		lib/COMBINAT/catalan.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Function 'combinat::catalan': Catalan numbers
  Created:	16/02/2001
  License:	LGPL
*****************************************************************************/

combinat::catalan :=
proc(n: Type::NonNegInt) : Type::NonNegInt
   /*
      Returns the n-th integer in the famous Catalan sequence.

      This is the number of dyck words/paths of size n, the number of
      ordered trees with n nodes, the number of binary trees with n+1
      nodes, the number of complete binary trees with 2n+1 ??? nodes,
      the number of standard tableau for the partitions [n,n] or
      [2,...,2], the number of triangulations of a regular n+2-gone ???,
      the number of non crossed set partitions, etc, etc, etc
   */
begin
    binomial(2*n,n) / (n+1);
end_proc:
