/*****************************************************************************
  $Id: finiteClass.mu,v 1.1.1.3 2004/10/04 17:25:16 nthiery Exp $
  File:		lib/COMBINAT/finiteClass.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Source code for the domain combinat::finiteClass
  Created:	Wed Sep  3 13:58:38 2003
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

domain combinat::finiteClass(L: DOM_LIST)
    local nopsL;
    inherits Dom::BaseDomain;
    category Cat::CombinatorialClass;
    axiom Ax::systemRep;

    domtype    := DOM_INT;
    isA        :=
    proc(x) : DOM_BOOL
    begin
	bool(contains(L,x) > 0);
    end_proc;

    list       := () -> L;
    generators := () -> combinat::generators::fromList(L);
    count      := () -> nopsL;

    unrank     := i -> if i <= nopsL then L[i] else FAIL; end;
    rank       := combinat::rankers::rankFromList(L);
    ranker     := [dom::rank, dom::unrank];

    _less      := bool@_less;

begin
    nopsL := nops(L);
end_domain:
