/*****************************************************************************
  $Id: imageClass.mu,v 1.1.1.3 2005/01/26 13:42:24 nthiery Exp $
  File:		lib/COMBINAT/imageClass.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Created:	06/09/2003
  License:	LGPL
*****************************************************************************/

domain combinat::imageClass(class: DOM_DOMAIN, f)
    local ExtraArgs;
    category Cat::CombinatorialClass;
    inherits Dom::BaseDomain;
    axiom Ax::systemRep;

    info_str := "Functor 'combinat::imageClass': image of a combinatorial class via a bijection";

    count     := () -> class::count(args());
    list      := () -> map(class::list(args()), f, ExtraArgs);
    generator := () -> combinat::generators::map(class::generator(args()), f, ExtraArgs);

    unrank    :=
    if class::unrank <> FAIL then
	proc()
	    local x;
	begin
	    if (x := class::unrank(args())) <> FAIL then
		f(x, ExtraArgs)
	    else
		FAIL;
	    end_if;
	end_proc:
    end_if;

    random    :=
    if class::random <> FAIL then
	proc()
	    local x;
	begin
	    if (x := class::random(args())) <> FAIL then
		f(x, ExtraArgs)
	    else
		FAIL;
	    end_if;
	end_proc:
    end_if;

begin
    if not class::hasProp(Cat::CombinatorialClass) then
	error("combinatorial class expected");
    end_if;
    ExtraArgs := args(3..args(0));
end_domain:
