/*****************************************************************************
  $Id: lrcalc.mu,v 1.1.1.1 2004/10/04 17:25:16 nthiery Exp $
  File:		lib/COMBINAT/lrcalc.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Source code for the domain combinat::lrcalc
  Created:	Sun Jul 11 01:15:09 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

// Load the lrcalc dynamic module and put it under
// combinat::lrcalc
// If the module is not available, set combinat::lrcalc to FAIL,
// and removes it from the combinat interface (mainly for prog::check)
// If the module is broken, raises an error

combinat::lrcalc :=
proc()
    save lrcalc;
begin
    if module::which("lrcalc") = FAIL then
	// If the module is simply not available, fail silently
	userinfo(1, "Dynamic module lrcalc not available"):
	sysassign(combinat::interface,
		  combinat::interface minus {hold(lrcalc)});
	FAIL;
    else
        // Avoids an internal error on exit of MuPAD 2.0.0
	%if version() = [2,0,0] then module::displace("stdmod"); end_if;
	if traperror(module("lrcalc")) <> 0 then
	    warning("Error loading the dynamic module lrcalc:");
	    lasterror();
	end_if;
	lrcalc::Name := "combinat::lrcalc":
	lrcalc;
    end_if;
end_proc():
