/*****************************************************************************
  $Id: tools.mu,v 1.1.1.2 2005/01/26 13:42:24 nthiery Exp $
  File:		lib/COMBINAT/tools.mu
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Created:	25/03/2003
  License:	LGPL
*****************************************************************************/

  /////////////////////////////////////////////////////////////////////
  // Abstract methods for searching the transitive ideal of a relation. 
  /////
  // The relation is given by a function rel which takes an element g
  // and returns the elements that are in relations with g.
  ///////
  // Algorithms: We call succRec recursively to store the succesors in
  // the remember table, and then re-read the remember table to get the lists.
  combinat::transitiveIdeal := 
    proc(rel)
  // gen is the generators of the ideal
	local succRec, gen;
    begin
	succRec := proc(g) option remember;
		   begin map(rel(g), succRec); end_proc;
	succRec(gen) $ gen in [args(2..args(0))];
  // Hack to read the remember table
	map([op(op(succRec, 5))], op, 1);  
    end_proc;

  // function which clear the remember table of a given function
  combinat::clearRememberTable :=
  proc(f: DOM_PROC)
  begin
    subsop(f, 5=NIL);
  end_proc:
