/*****************************************************************************
  $Id: AlgebraWithSeveralBases.mu,v 1.1.1.2 2005/01/26 13:42:22 nthiery Exp $
  File:		lib/DOMAINS/CATEGORY/AlgebraWithSeveralBases.mu
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Source code for the category Cat::AlgebraWithSeveralBases
  Created:	Wed Sep 15 10:10:58 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

category Cat::AlgebraWithSeveralBases(CoeffRing : DOM_DOMAIN)

    category Cat::Algebra(CoeffRing), Cat::ModuleWithSeveralBases(CoeffRing);

    info_str := "Cat::AlgebraWithSeveralBases -- The category of algebras expanded on several bases";

    one  := dom::standardBasis::one;
    _mult :=
    proc()
        // try to make dom::one the one of all the bases
        local ar;
    begin
        ar := select([args()], not _equal, dom::one);
        if nops(ar) = 0 then dom::one
        else operators::_mult(op(ar));
        end_if;
    end_proc;
    
end_category:
