/*****************************************************************************
  $Id: LeftAModuleWithBasis.mu,v 1.1.1.2 2005/01/26 13:42:22 nthiery Exp $
  File:		lib/DOMAINS/CATEGORY/LeftAModuleWithBasis.mu
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Source code for the category Cat::LeftAModuleWithBasis
  Created:	Sun Jun 13 10:31:41 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

category Cat::LeftAModuleWithBasis(A : DOM_DOMAIN)
    local R;
    category Cat::ModuleWithBasis(R), Cat::LeftModule(A);

    info_str := "Cat::LeftAModuleWithBasis -- The Category of the left modules over an algebra with a distinguished basis";

    A := A;	
	
//    mult2Basis has signature (A, dom) -> dom
    mult2 :=
    if dom::mult2Basis<>FAIL then
	operators::makeBilinear(dom::mult2Basis, Source1=A, Source2=dom, ImageSet=dom);
    else
	ToBeDefined;
    end_if;

    initDomainAdd := 
    if A <> dom then
        proc()
        begin
	    // WARNING: !!!!
            // Hack to try to ensure that the ranker is synchronized with list.
	    dom::basis::list();
            operators::overloaded::declareDomain(dom);
            operators::overloaded::declareSignature(operators::mult2, [A, dom], dom::mult2);
	end_proc;
    end_if;

    leftMatrix :=
    proc(a : A)
    // compute the matrix of a element of A on this module. 
    begin
	dom::endomorphismMatrix(z->dom::mult2(a, z), args(2..args(0)));
    end_proc;

begin
    userinfo(1, "Creating Cat::LeftAModuleWithBasis(".expr2text(args()).")");
    if not A::hasProp(Cat::FiniteDimensionalAlgebraWithBasis) then
	error ("Left A module needs A to be a Cat::FiniteDimensionalAlgebraWithBasis");
    end_if;
    R := A::coeffRing;
end_category:
