/*****************************************************************************
  $Id: Operad.mu,v 1.1.1.2 2005/01/26 13:42:22 nthiery Exp $
  File:		lib/DOMAINS/CATEGORY/Operad.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
		Frdric Chapoton <chapoton at igd.univ-lyon1.fr>
  Purpose:	Source code for the category Cat::Operad
  Created:	Tue Dec  9 20:54:33 2003
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

export(operators::overloaded, Alias,
       declareConversion):

category Cat::Operad(R)
    // Should be graded module
    category Cat::Module(R);

    info_str := "Cat::Operad -- the category of operads";

    interfaceAdd :=
        {
	 hold(fromCoeffRing),
	 hold(composition),
	 hold(one)
	};

    // Should go in a common ancestor with Cat::Algebra
    fromCoeffRing :=
    proc(r: dom::coeffRing)
    begin
	dom::multcoeffs(dom::one, r)
    end_proc;

    one := toBeDefined;

    composition := toBeDefined;

    // A domain in this category may override the default operad
    // initialization by setting initDomainAlgebraWithBasis
    initDomainAdd := dom::initDomainOperad;
    initDomainOperad :=
    proc()
    begin
	declareConversion(dom::coeffRing, dom, dom::fromCoeffRing);
    end_proc;

end_category:
