/*****************************************************************************
  $Id: OperadWithBasis.mu,v 1.1.1.2 2005/01/26 13:42:22 nthiery Exp $
  File:		lib/DOMAINS/CATEGORY/OperadWithBasis.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
		Frdric Chapoton <chapoton at igd.univ-lyon1.fr>
  Purpose:	Source code for the category Cat::OperadWithBasis
  Created:	Tue Dec  9 20:54:18 2003
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

category Cat::OperadWithBasis(R)
    category Cat::GradedModuleWithBasis(R), Cat::Operad(R);

    info_str := "Cat::OperadWithBasis -- the category of operads over a distinguished basis";

    interfaceAddIfExists :=
	{
	 hold(oneBasis),
	 hold(compositionBasis),
	 hold(ground)
	};

    one :=
    if dom::oneBasis <> FAIL then
	dom::term(dom::oneBasis)
    end_if;

    ground :=
    if dom::oneBasis <> FAIL then
	proc(x: dom)
	begin
	    dom::coeff(x,dom::oneBasis);
	end_proc;
    end_if;

    /// composition of two elements of dom
    composition :=
    if dom::compositionBasis<>FAIL then
	operators::makeBilinear(dom::compositionBasis, Source=dom, ImageSet=dom);
    end_if;

    /// Currently only functional for graded operads?
    _fconcat2Basis :=
    proc(x: dom, y: dom)
	local i;
    begin
	dom::plus(dom::composition(x,y,i) $ i = 1..degree(x));
    end_proc;

end_category:
