/*****************************************************************************
  $Id: CombinatorialClass.tst,v 1.1.1.3 2004/10/04 17:25:13 nthiery Exp $
  File:		lib/DOMAINS/DOMAIN/TEST/CombinatorialClass.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the category 'Cat::CombinatorialClass'
  Created:	04/03/2003
  License:	LGPL
*****************************************************************************/

prog::testinit("CombinatorialClass"):

prog::testfunc(list):

prog::test((
domain A
    inherits Dom::BaseDomain;
    category Cat::CombinatorialClass;
    axiom    Ax::systemRep;

    domtype := DOM_LIST;
end; domtype(A)), DOM_DOMAIN):

prog::test(bool(A::list = A::listFromGenerator)):
prog::test(A::generator(), TrapError=1028):

prog::test((
domain zeroOneVectors 
    inherits Dom::BaseDomain;
    category Cat::CombinatorialClass;
    axiom    Ax::systemRep;
    
    isA := // Type checking.
    proc(obj         : Type::AnyType,
	 size = FAIL : Type::Union(Type::NonNegInt, DOM_FAIL)) : DOM_BOOL
    begin
	if domtype(obj) <> DOM_LIST then return(FALSE); end_if;
	if {op(obj)} minus {0,1} <> {} then return(FALSE); end_if;
	if args(0) = 1 then return(TRUE);
	else
	    bool(nops(obj) = size);
	end_if;
    end_proc;

    size  := proc(v : dom) : Type::NonNegInt begin nops(v); end_proc;
                
    first := proc(size : Type::NonNegInt) : dom
	     begin
		 [ 0 $ size ];
	     end_proc;

    Next := proc(lst : dom) : Type::Union(DOM_FAIL, dom)
		local pos;
	    begin
		if (pos := contains(lst, 0)) <> 0 then 
		    [ 0$(pos-1), 1, op(lst, pos+1..nops(lst))]
		else FAIL
		end_if;  
	    end_proc;
end_domain;domtype(zeroOneVectors)), DOM_DOMAIN):

prog::test(zeroOneVectors::count(3), 2^3):
prog::test(zeroOneVectors::list(2), [[0,0],[1,0],[0,1],[1,1]]):
prog::test((g := zeroOneVectors::generator(3); 
	    [g(),g(),g(),g(),g(),g(),g(),g(),g()]), 
	   [[0,0,0],[1,0,0],[0,1,0],[1,1,0],[0,0,1],[1,0,1],[0,1,1],[1,1,1],FAIL]):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the category

prog::testfunc(Cat::CombinatorialClass):
prog::testexit():

prog::check(A, 3):


// Local Variables: 
// mode: mupad
// End:
