/**
 * DomainConstructor::getEntryFromAllCategories(A, "bla")
 *
 * Look for all the definitions of the entry "bla" in the constructors
 * of its super categories; evaluate them in the context of their
 * respective domains, and, for procedures, bless them as methods of
 * A; finally, return them as a list, starting from A.
 *
 * Largely inspired from CategoryConstructor::getEntry.
 **/

DomainConstructor::getEntryFromAllCategories :=
proc(DOM: DOM_DOMAIN, e: DOM_STRING) : DOM_LIST
    option noDebug;
    local C, r, i, allDefinitions;
begin
    allDefinitions := [];
    i:= 1;
    while (C:= DomainConstructor::getCategory(DOM, i)) <> FAIL do
	i:= i+1;
        // search for entry in category constructor
        if (r := DomainConstructor::getEntryFromCategory(DOM, C, e)) <> NIL then
	    allDefinitions := append(allDefinitions, r);
	end_if;
    end_while;
    allDefinitions;
end_proc:
