/**
  * DomainConstructor::getEntryCategorys(DOM, SuperCategory, "bla")
  *
  * Look for the definitions of the entry "bla" in the constructor of
  * the domain SuperCategory, evaluate it in the context of
  * SuperCategory, and, for a procedure, bless it as methods of A;
  * returns NIL if the entry was not found.
  *
  * Largely inspired from DomainConstructor::getSuperCategoryEntry.
  **/

DomainConstructor::getEntryFromCategory :=
proc(DOM: DOM_DOMAIN, C: Category, e: DOM_STRING)
    option noDebug;
    local r;
begin
    // search for entry in super-domain constructor
    r:= extop(extop(C,1),5);
    if not contains(r, e) then
	return(NIL);
    end_if;
    // evaluate entry in closure of super-domain
    r:= _eval_entry(indexval(r, e), DOM, extop(C,2));
    if r <> NIL and domtype(r)=DOM_PROC then
	r := prog::bless(r, DOM);
    end_if;
    r;
end_proc:
