/*****************************************************************************
  $Id: AlgebraWithBasis_Table.tst,v 1.1.1.1 2003/09/15 16:37:44 nthiery Exp $
  File:		lib/DOMAINS/DOMAIN/TEST/AlgebraWithBasis_Table.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the domain 'Dom::AlgebraWithBasis_Table'
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("AlgebraWithBasis_Table"):

prog::testfunc("domain constructor"):

A:=Dom::AlgebraWithBasis_Table(Dom::Rational,
                               combinat::integerVectors,
                               BasisOne=[0,0,0], 
                               BasisMonoidMult=((x,y)->zip(x,y,_plus))):

prog::testfunc("Axioms"):
prog::test(A::hasProp(Ax::monoidAlgebra)):

// Constants

prog::testfunc("zero"):
prog::test(expr(A::zero), 0):
prog::test(extop(A::zero), table()):
prog::test(A::iszero(A::zero)):

prog::testfunc("one"):
prog::test(A::one, A([0,0,0])):
prog::test(A::isone(A::one)):

// Coercions

prog::testfunc("coercions"):
x:=A([1,2,3]):
prog::test(x, new(A, table([1,2,3]=1))):
prog::test(expr(x), hold(B)([1,2,3])):
prog::test(A(0), A::zero):
prog::test(A(3), A::one*3):

// Algebraic operations

x:=A([1,0,0]):
y:=A([1,1,0]):
prog::testfunc("_plus"):
prog::test(expr(x+2*y), 2*B([1, 1, 0])+B([1, 0, 0])):

prog::testfunc("_mult"):
prog::test(x*y, A([2, 1, 0])):
prog::test(x*x, A([2, 0, 0])):

prog::testfunc("_power"):
x:=A([1,2,3]):
prog::test(x^0, A([0,0,0])):
prog::test(x^1, x):
prog::test(x^2, A([2,4,6])):

// >> plax([1,2])-[1,2];
//                                  - FAIL + [1, 2]
// >> plax([1,2])-plax([1,2]);
//                                         0

//////////////////////////////////////////////////////////////////////////////
// Global checking of the domain

prog::testfunc(Dom::AlgebraWithBasis_Table):

prog::check(A, 3):

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
