prog::testinit("AlternatingGroup"):

G:=Dom::AlternatingGroup(4):		// The alternating group A4

//////////////////////////////////////////////////////////////////////////////
// Global checking of the domain

prog::testfunc(Dom::SymmetricGroup):
prog::init(G):
prog::check(G, 3):

prog::testfunc(Dom::AlternatingGroup):
prog::check(G):

prog::test(G::set,
	   [1,2,3,4]):
prog::test(G::card,
	   4):
prog::test(G::size,
	   12):
prog::test({op(G::allElements())},
	   map({[4, 3, 2, 1], [2, 4, 3, 1], [3, 2, 4, 1], [3, 4, 1, 2],
		[4, 1, 3, 2], [1, 3, 4, 2], [4, 2, 1, 3], [1, 4, 2, 3],
		[2, 1, 4, 3], [2, 3, 1, 4], [3, 1, 2, 4], [1, 2, 3, 4]}, G)):

// Test the action of the group

prog::test(G::canonic([2,1,5,2]),G::canonic([5,2,1,2])):
prog::test(bool(G::canonic([2,1,5,3])<>G::canonic([5,2,1,2]))):
prog::test(bool(G::canonic([2,1,5,3])<>G::canonic([1,2,5,3]))):

// Test Polya Enumeration

prog::test(G::cycleTypes(),
	   table(
		 [0, 2, 0, 0] = 3,
		 [1, 0, 1, 0] = 8,
		 [4, 0, 0, 0] = 1)):
prog::test(G::cycleIndicatorPoly(hold(z)),
	   poly(1/12*z[1]^4 + 2/3*z[1]*z[3] + 1/4*z[2]^2, [z[1], z[2], z[3], z[4]], Dom::Rational)):
prog::test(expand(G::weightEnum([1,y])),
	   1 + y + y^2 + y^3 + y^4):

prog::testexit():
null():

// Local Variables: 
// mode: mupad
// End:
