/*****************************************************************************
  $Id: PermutationGroupOnSets.tst,v 1.1.1.1 2003/09/15 16:37:44 nthiery Exp $
  File:		lib/DOMAINS/DOMAIN/TEST/PermutationGroupOnSets.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the domain 'Dom::PermutationGroupOnSets'
  Taken From:	PerMuVAR, 03/12/2001
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("PermutationGroupOnSets"):

// constants
n:=4:
Sn:=Dom::SymmetricGroup(n):		// The symmetric group of the set {1..n}

prog::testfunc(Dom::PermutationGroupOnSets):
G:=Dom::PermutationGroupOnSets(Sn,2):
	// The permutation group induced by Sn on the subsets of size 2 of {1..n}
prog::check(G, 3):

prog::test(G::card,6):
prog::test(G::size,24):
prog::test({op(G::allElements())},
	   map(
	       {[6, 3, 5, 2, 4, 1], [6, 5, 3, 4, 2, 1], [5, 3, 6, 1, 4, 2],
		[5, 6, 3, 4, 1, 2], [3, 5, 6, 1, 2, 4], [3, 6, 5, 2, 1, 4],
		[6, 2, 4, 3, 5, 1], [6, 4, 2, 5, 3, 1], [4, 2, 6, 1, 5, 3],
		[4, 6, 2, 5, 1, 3], [2, 4, 6, 1, 3, 5], [2, 6, 4, 3, 1, 5],
		[5, 1, 4, 3, 6, 2], [5, 4, 1, 6, 3, 2], [4, 1, 5, 2, 6, 3],
		[4, 5, 1, 6, 2, 3], [1, 4, 5, 2, 3, 6], [1, 5, 4, 3, 2, 6],
		[3, 1, 2, 5, 6, 4], [3, 2, 1, 6, 5, 4], [2, 1, 3, 4, 6, 5],
		[2, 3, 1, 6, 4, 5], [1, 2, 3, 4, 5, 6], [1, 3, 2, 5, 4, 6]},
	       G)):

// Test the action of the group

prog::test(G::set,
	   [{1, 2}, {1, 3}, {2, 3}, {1, 4}, {2, 4}, {3, 4}]):
g:=G::induced(Sn([2,3,4,1])):
h:=G(table({1,2}={2,3},{1,3}={2,4},{2,3}={3,4},
	   {1,4}={2,1},{2,4}={3,1},{3,4}={4,1})):
prog::test(g,G([3, 5, 6, 1, 2, 4])):
prog::test(g,h):
prog::test(g(1),3):
prog::test(g([a,b,c,d,e,f]),[d,e,a,f,b,c]):
prog::test(g({1,2}),{2,3}):
prog::test(op(G([1,6,3,4,2,5])), [1,6,3,4,2,5]):
	// Should actually complain since this permutation is not in G

prog::test(G::canonic([0,1,1,0,0,0]),
	   G::canonic([1,1,0,0,0,0])):
prog::test(G::canonic([0,1,0,0,1,0]),
	   G::canonic([0,0,1,1,0,0])):
prog::test(bool(G::canonic([1,0,0,0,0,1])<>G::canonic([1,1,0,0,0,0]))):

// Test Polya Enumeration

prog::test(G::cycleTypes(),
	   table(
		 [0, 0, 2, 0, 0, 0] = 8,
		 [0, 1, 0, 1, 0, 0] = 6,
		 [2, 2, 0, 0, 0, 0] = 9,
		 [6, 0, 0, 0, 0, 0] = 1
		 )):
	// Should also test the version of cycleTypes for subsets of size <> 2
prog::test(G::cycleIndicatorPoly(hold(z)),
	   poly(1/24*z[1]^6 + 3/8*z[1]^2*z[2]^2 + 1/4*z[2]*z[4] + 1/3*z[3]^2,
		[z[1], z[2], z[3], z[4], z[5], z[6]], Dom::Rational)):
	// cycle indicator polynom
prog::test(expand(G::weightEnum([1,1])),
	   11):
	// Number of unlabelled graphs on 4 nodes
prog::test(expand(G::weightEnum([1,y])),
	   1 + y + y^2*2 + y^3*3 + y^4*2 + y^5 + y^6):
	// Number of unlabelled graphs on 4 nodes by number of edges

prog::testexit():
null():

// Local Variables: 
// mode: mupad
// End:
