/*****************************************************************************
  $Id: QuotientFreeModule.tst,v 1.1.1.1 2004/10/04 17:25:13 nthiery Exp $
  File:		lib/DOMAINS/DOMAIN/TEST/QuotientFreeModule.tst
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Test suite for the domain Dom::QuotientFreeModule
  Created:	Sun Jun 13 18:19:07 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("QuotientFreeModule"):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(Dom::QuotientFreeModule):
nbrs   := combinat::finiteClass(revert([1,2,3,4,5,6,7])):
nbrs::domtype := DOM_INT:
modul  := Dom::FreeModule(Dom::Rational, nbrs, RankerBasis = nbrs::ranker):
rrBas  := map([[[1,1],[2,3],[1,5]],
               [[1,2],[1,3],[1,5]],
               [[1,4],[1,6]]], modul::fromList):
quomod := Dom::QuotientFreeModule(rrBas):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc(Dom::QuotientFreeModule::basisIndices):
prog::test(quomod::basisIndices::list(), [7, 6, 5, 3]):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc(Dom::SubFreeModule::dimension):
prog::test(quomod::dimension, 4):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc(Dom::SubFreeModule::fromSupModule):
prog::test(map(rrBas, quomod::fromSupModule),
	   [quomod::zero $ nops(rrBas)]):
prog::test(quomod::fromSupModule(modul::term(1)), 
	   quomod::fromList([[-2, 3], [-1, 5]])):
prog::test(quomod::fromSupModule(modul::term(2)), 
	   quomod::fromList([[-1, 3], [-1, 5]])):
prog::test(quomod::fromSupModule(modul::term(3)), 
	   quomod::fromList([[1, 3]])):
prog::test(quomod::fromSupModule(modul::term(4)), 
	   quomod::fromList([[-1, 6]])):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc(Dom::SubFreeModule::toSupModule):
for b in quomod::basisIndices::list() do
    prog::test(quomod::toSupModule(quomod::term(b)), modul::term(b));
end_for:

prog::testexit():
//////////////////////////////////////////////////////////////////////////////

prog::check(test, 3):


// Local Variables:
// mode: mupad
// End:
