/*****************************************************************************
  $Id: SteenrodAlgebraP.tst,v 1.1.1.2 2004/10/04 17:25:13 nthiery Exp $
  File:		lib/DOMAINS/DOMAIN/TEST/SteenrodAlgebra.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the domain 'Dom::SteenrodAlgebra'
  Created:	28/06/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("SteenrodAlgebraP"):

S := Dom::SteenrodAlgebraP():

prog::testfunc(Dom::SteenrodAlgebraP):

for p in [[], [1], [2,1], [7,4,2,1]] do
    prog::test(expr(S(p)), P[op(p)]);
end_for:
prog::test(expr(S::one), P[]):
prog::test(S([1,2]),
	   q*S([3]) + S([2, 1])):
prog::test(S([1,3]),
	   (2*q)*S([4])+S([3,1])):
prog::test(mapcoeffs(S([1,2,3]), normal),
	   q*S([3, 3]) + (2*q)*S([4, 2]) + (4*q^2)*S([6]) + q*S([5, 1]) + S([3, 2, 1])
	  ):
p1:=S([1]):
p2:=S([2]):
prog::test(p1*p2-p2*p1, q*S([3])):
prog::test(S([2,1])^2, // correct ?
	   S([2, 2, 1, 1]) + q^2*S([5, 1]) + q*S([3, 2, 1])):
prog::test(S([1,3]) + 2*S([1,2]), 
           2*q*S([3]) + 2*S([2, 1]) + 2*q*S([4]) + S([3, 1])):
prog::test(S([3])*S([1]), S([3, 1])):

prog::testfunc(S::antipode):
prog::test(S::antipode(S([])),
	   S([])):
prog::test(S::antipode(S([1])),
	   -1*S([1])):
prog::test(S::antipode(S([3])),
	   -1*S([3])):
prog::test(S::antipode(S([1,1])),
	   S([1, 1])):
prog::test(S::antipode(S([2,1])),
	   q*S([3]) + S([2, 1])):

for p in combinat::partitions::list(5) do
    prog::test(simplify(S::antipode(S::antipode(S(p)))),
	       S(p)):
end_for:

//////////////////////////////////////////////////////////////////////////////
// Global checking of the domain

prog::check(S, 3):

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
