/*****************************************************************************
  $Id: SubFreeModule.tst,v 1.1.1.1 2004/10/04 17:25:13 nthiery Exp $
  File:		lib/DOMAINS/DOMAIN/TEST/SubFreeModule.tst
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Test suite for the domain Dom::SubFreeModule
  Created:	Sun Jun 13 15:40:30 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("SubFreeModule"):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(Dom::SubFreeModule):
nbrs   := combinat::finiteClass(revert([1,2,3,4,5,6])):
nbrs::domtype := DOM_INT:
modul  := Dom::FreeModule(Dom::Rational, nbrs, RankerBasis = nbrs::ranker):
rrBas  := map([[[1,1],[2,3],[1,5]],
               [[1,2],[1,3],[1,5]],
               [[1,4],[1,6]]], modul::fromList):
submod := Dom::SubFreeModule(rrBas):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc(Dom::SubFreeModule::dimension):
prog::test(submod::dimension, 3):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc(Dom::SubFreeModule::fromSupModule):
prog::test(submod::fromSupModule(rrBas[1]), submod::fromList([[1, 1]])):
prog::test(submod::fromSupModule(rrBas[2]), submod::fromList([[1, 2]])):
prog::test(submod::fromSupModule(rrBas[3]), submod::fromList([[1, 4]])):
prog::test(submod::fromSupModule(2*rrBas[1]+3*rrBas[2]-1/5*rrBas[3]), 
	   submod::fromList([[2, 1], [3, 2], [-1/5, 4]])):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc(Dom::SubFreeModule::toSupModule):
prog::test(submod::toSupModule(submod::fromList([[1, 1]])), rrBas[1]):
prog::test(submod::toSupModule(submod::fromList([[1, 2]])), rrBas[2]):
prog::test(submod::toSupModule(submod::fromList([[1, 4]])), rrBas[3]):
prog::test(submod::toSupModule(submod::fromList([[2, 1], [3, 2], [-1/5, 4]])), 
	   2*rrBas[1]+3*rrBas[2]-1/5*rrBas[3]):
          
prog::testexit():
//////////////////////////////////////////////////////////////////////////////

prog::check(test, 3):


// Local Variables:
// mode: mupad
// End:
