prog::testinit("SymmetricGroup"):

G:=Dom::SymmetricGroup(4):		// The symmetric group S4

//////////////////////////////////////////////////////////////////////////////
// Global checking of the domain

prog::testfunc(Dom::SymmetricGroup):
prog::init(G):
prog::check(G, 3):

//////////////////////////////////////////////////////////////////////////////

prog::test(G::set,
	   [1,2,3,4]):
prog::test(G::card,
	   4):
prog::test(G::size,
	   24):
prog::test(nops(G::generators),
	   2):
// With MuPAD 1.4.2 in debug mode under linux RH6.2, asking for the
// S4::generators and then S5::generators causes a kernel internal error.
prog::test(nops((Dom::SymmetricGroup(5))::generators),
	   2):
prog::test({op(G::allElements())},
	   map({[3, 4, 2, 1], [4, 3, 2, 1], [2, 4, 3, 1], [4, 2, 3, 1],
		[2, 3, 4, 1], [3, 2, 4, 1], [3, 4, 1, 2], [4, 3, 1, 2],
		[1, 4, 3, 2], [4, 1, 3, 2], [1, 3, 4, 2], [3, 1, 4, 2],
		[2, 4, 1, 3], [4, 2, 1, 3], [1, 4, 2, 3], [4, 1, 2, 3],
		[1, 2, 4, 3], [2, 1, 4, 3], [2, 3, 1, 4], [3, 2, 1, 4],
		[1, 3, 2, 4], [3, 1, 2, 4], [1, 2, 3, 4], [2, 1, 3, 4]}, G)):

// Test the action of the group

prog::test(G::canonic([2,1,5,2]),G::canonic([5,2,1,2])):
prog::test(bool(G::canonic([2,1,5,3])<>G::canonic([5,2,1,2]))):

// Test Polya Enumeration

prog::test(G::cycleTypes(),
	   table(
		 [0, 0, 0, 1] = 6,
		 [0, 2, 0, 0] = 3,
		 [1, 0, 1, 0] = 8,
		 [2, 1, 0, 0] = 6,
		 [4, 0, 0, 0] = 1)):
prog::test(G::cycleIndicatorPoly(hold(z)),
	   poly(1/24*z[1]^4 + 1/4*z[1]^2*z[2] + 1/3*z[1]*z[3] + 1/8*z[2]^2
                + 1/4*z[4], [z[1], z[2], z[3], z[4]], Dom::Rational)):
prog::test(expand(G::weightEnum([1,y])),
	   1 + y + y^2 + y^3 + y^4):


prog::testexit():
null():

// Local Variables: 
// mode: mupad
// End:
