// test file for Dom::WeylAlgebra

prog::testinit("WeylAlgebra",0.1):

for WA in [Dom::WeylAlgebra_Table] do

    prog::testfunc(WA):
    W := WA([x,y], Dom::Rational, DegreeOrder): 

    prog::test(W(D(x))*W(x), W(1+x*D(x))):
    prog::test(W::iszero(W(D(x)^3)*W(x)-W::adjoint(W(D(x))*W(x^3)))):
    prog::test(expr(W(D(x)^2)*W(x^2)),
	       4*x*D(x) + x^2*D(x)^2  + 2): // correct?
    prog::test(expr(W(x^2*D(x)^5)^2),
	       20*x^2*D(x)^8 + 10*x^3*D(x)^9 + x^4*D(x)^10): // correct?
    
    w1 := W(x*D(y)+y*D(x)):
    w2 := W(y^2*D(x)*D(y)):
    prog::test(W::convert(x*D(y))+W::convert(y*D(x)), w1):
    prog::test(W::coeffRing, Dom::Rational):
    prog::test(W::variables, [x,y,D(x),D(y)]):
    prog::test(W::monomial2exponent(w2), [0,2,1,1]):
    prog::test(w1 * w2,
	       W(x*y^2*D(x)*D(y)^2+y^3*D(x)^2*D(y)+2*x*y*D(x)*D(y))):
    prog::test(W::commutator(w1, w2), w1 * w2 - w2 * w1):
    
    P:=Dom::MultivariatePolynomial([x,y,z]):

    prog::testfunc(W::onPoly):
    prog::test(W::onPoly(W(D(y)), P(x)), 
	       P(0)):
    prog::test(W::onPoly(W(D(x)), P(x)),   
	       P(1)):
    prog::test(W::onPoly(W(D(x)), P(x^2)), 
	       P(2*x)):
    prog::test(W::onPoly(W(x), P(1)), 
	       P(x)):
    prog::test(W::onPoly(W(x), P(x)), 
	       P(x^2)):
    prog::test(W::onPoly(W(x), P(y)), 
	       P(x*y)):
    prog::test(W::onPoly(W(D(x)^2), P(x^4*y)), 
	       P(12*x^2*y)):
end_for:

//////////////////////////////////////////////////////////////////////////////
// Global checking of the domain

prog::testfunc(Dom::WeylAlgebra):

prog::check(W, 3):

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
