/*****************************************************************************
  $Id: NonCommutativeExpressions.mu,v 1.1.1.2 2005/01/26 13:42:22 nthiery Exp $
  File:		lib/EXAMPLES/NonCommutativeExpressions.mu
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Created:	24/01/2004
  License:	LGPL
*****************************************************************************/

alias(NCExpr = examples::NonCommutativeExpressions):

//////////////////////////////////////////////////////////////////////////////
domain NCExpr(R = Dom::ExpressionField() : DOM_DOMAIN)
    // Why not Dom::FreeModule ??????
    inherits experimental::AlgebraWithBasis(R, combinat::words);
    category Cat::AlgebraWithBasis(R), Cat::IntegralDomain;

    interfaceAdd := {hold(newUnknown)};

    info_str := "Domain for non commutative Expression";

    printTerm := b -> Factored([1, (x,1) $ x in b]);

    one := dom::term([]);

    mult2Basis :=
    proc(l1: dom::basisIndices, l2: dom::basisIndices)
    begin
	dom::term(l1.l2);
    end_proc;

    subs := // use subs(bla, hold(a) = ...)
    proc(elts)
	local equs;
    begin
	equs := args(2..args(0));
	dom::plus(op(map(dom::poly2list(elts),
			 (trm) -> _mult(map((   subs(trm[1], equs), 
					     op(subs(trm[2], equs))
					    ), eval))
			 )));
    end_proc;
		
end_domain:
