/*****************************************************************************
  $Id: FreeQuasiSymmetricFunctions.tst,v 1.1.1.3 2004/10/16 15:15:48 nthiery Exp $
  File:		lib/EXAMPLES/TEST/FreeQuasiSymmetricFunctions.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'examples::FreeQuasiSymmetricFunctions'
  Created:	27/03/2003 (first created 25/11/2002 in experimental)
  License:	LGPL
*****************************************************************************/

prog::testinit("FreeQuasiSymmetricFunctions"):

FQSYM := examples::FreeQuasiSymmetricFunctions():

FF:=FQSYM::F:
GG:=FQSYM::G:

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(FF):
//////////////////////////////////////////////////////////////////////////////
prog::test(FF::one+FF::one, 2*FF::one):
prog::test(FF::one*FF::one, FF::one):
prog::test(FF::one*FF([1,2,4,3]), FF([1,2,4,3])):
prog::test(FF::zero+FF([1,2,4,3]), FF([1,2,4,3])):
prog::test(expr(FF([1,2,3])+2*FF([1,3,2])),2*F[1, 3, 2] + F[1, 2, 3]):
prog::test(expr(FF(1)), F[]):
prog::test(expr(FF(3/4)), 3/4*F[]):
prog::test(expr(FF([1,2,3])), F[1,2,3]):

prog::test(FF::one^10, FF([])):
for n from 1 to 4 do
    prog::test(FF([1])^n, _plus(FF(p) $p in combinat::permutations(n)));
end_for:

prog::test(3/5*FF([1,2,3])+FF([1,2,3])*FF([2,1]),
	   FF([5, 4, 1, 2, 3]) + FF([5, 1, 4, 2, 3]) + FF([5, 1, 2, 4, 3]) +
	   FF([5, 1, 2, 3, 4]) + FF([1, 5, 4, 2, 3]) + FF([1, 5, 2, 4, 3]) +
	   FF([1, 5, 2, 3, 4]) + FF([1, 2, 5, 4, 3]) + FF([1, 2, 5, 3, 4]) +
	   FF([1, 2, 3, 5, 4]) + 3/5*FF([1, 2, 3])):

if prog::TestNoTestargs = FALSE then
prog::test(FF([a,b,c]), TrapError=1202):
end_if:

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(GG):
//////////////////////////////////////////////////////////////////////////////
prog::test(GG::one+GG::one, 2*GG::one):
prog::test(GG::one*GG::one, GG::one):

prog::test(GG::zero+GG([1,2,4,3]), GG([1,2,4,3])):
prog::test(expr(GG([1,2,3])+2*GG([1,3,2])),2*G[1, 3, 2] + G[1, 2, 3]):
prog::test(expr(GG(1)), G[]):
prog::test(expr(GG(3/4)), 3/4*G[]):
prog::test(expr(GG([1,2,3])), G[1,2,3]):

prog::test(GG::one^10, GG([])):
for n from 1 to 4 do
    prog::test(GG([1])^n,_plus(GG(p) $p in combinat::permutations(n)));
end_for:

prog::test(GG(FF([2,3,1])), GG([3,1,2])):

// check that GG is a morphism:
prog::test(3/5*GG(FF([1,2,3]))+GG(FF([1,2,3]))*GG(FF([2,1])),
	   GG(3/5*FF([1,2,3])+FF([1,2,3])*FF([2,1]))):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the library

prog::testfunc(FQSYM):

prog::check(FQSYM, 3):

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
