/*****************************************************************************
  $Id: GraphQuasiSymmetricFunctions.tst,v 1.1.1.1 2004/10/04 17:25:13 nthiery Exp $
  File:		lib/EXAMPLES/TEST/GraphQuasiSymmetricFunctions.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test suite for the domain examples::GraphQuasiSymmetricFunctions
  Created:	Tue Mar 23 08:53:54 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("GraphQuasiSymmetricFunctions"):


export(examples::GraphQuasiSymmetricFunctionsTools, Alias, packedMatrices):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(packedMatrices::isPacked):
//////////////////////////////////////////////////////////////////////////////
prog::test(packedMatrices::isPacked([[0]]),
           FALSE):
prog::test(packedMatrices::isPacked([[1]]),
           TRUE):
prog::test(packedMatrices::isPacked([]),
           TRUE):
prog::test(packedMatrices::isPacked([[0, 1, 0, 0], [0, 0, 0, 1], [0, 0, 0, 0], [0, 0, 0, 0]]),
           FALSE):
prog::test(packedMatrices::isPacked([[0, 0, 1, 0], [0, 0, 0, 1], [0, 0, 0, 0], [0, 0, 0, 0]]),
           TRUE):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(packedMatrices::isA):
//////////////////////////////////////////////////////////////////////////////
prog::test(packedMatrices::isA([[0]]),
	   FALSE):
prog::test(packedMatrices::isA([[]]),
           FALSE):
prog::test(packedMatrices::isA("bla"),
           FALSE):
prog::test(packedMatrices::isA([[1]]),
           TRUE):
prog::test(packedMatrices::isA([]),
           TRUE):
prog::test(packedMatrices::isA([[0, 1, 0, 0], [0, 0, 0, 1], [0, 0, 0, 0], [0, 0, 0, 0]]),
           FALSE):
prog::test(packedMatrices::isA([[0, 0, 1, 0], [0, 0, 0, 1], [0, 0, 0, 0], [0, 0, 0, 0]]),
           TRUE):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(packedMatrices::generator):
//////////////////////////////////////////////////////////////////////////////
for n from 0 to 2 do
    prog::test(testtype(packedMatrices::list(n), Type::ListOf(packedMatrices))):
end_for:

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(examples::GraphQuasiSymmetricFunctions):
prog::testexit():
//////////////////////////////////////////////////////////////////////////////

prog::check(test, 3):


// Local Variables:
// mode: mupad
// End:
