/*****************************************************************************
  $Id: LodayRoncoAlgebra.tst,v 1.1.1.3 2005/01/26 13:42:22 nthiery Exp $
  File:		lib/EXAMPLES/TEST/LodayRoncoAlgebra.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'examples::LodayRoncoAlgebra'
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("LodayRoncoAlgebra"):

alias(LRA = examples::LodayRoncoAlgebra(),
      BT = combinat::binaryTrees,
      coproduct = operators::coproduct):
alias(lo=LRA::o, lp=LRA::p, loo=LRA::o::tensorSquare):
alias(d=BT::dummyLabel):
t1 := BT::unrank(6, 4):  ot1 := lo(t1):
t2 := BT::unrank(26, 5): ot2 := lo(t2):

prog::testfunc(lp::p):
prog::test(lp::one*lp::one,   lp::one):
prog::test(lp::zero+lp::zero, lp::zero):
// Comparison with the examples in the article of Loday & Ronco
p1 := lp(BT::one):
p2 := lp(BT::unrank(1,2)):
p3 := lp(BT::unrank(2,2)):
prog::test(expr(p1*p1),
           p([d, [], [d, [], []]]) + p([d, [d, [], []], []])):
prog::test(expr(p1*p2),
           p([d, [], [d, [], [d, [], []]]]) + p([d, [d, [], []], [d, [], []]])):
prog::test(expr(p1*p3),
           p([d, [], [d, [d, [], []], []]]) + p([d, [d, [], [d, [], []]], []]) + p([d, [d, [d, [], []], []], []])):
prog::test(expr(p2*p1),
           p([d, [], [d, [], [d, [], []]]]) + p([d, [], [d, [d, [], []], []]]) + p([d, [d, [], [d, [], []]], []])):
prog::test(expr(p2*p2),
           p([d, [], [d, [], [d, [], [d, [], []]]]]) + p([d, [], [d, [d, [], []], [d, [], []]]]) + p([d, [d, [], [d, [], []]], [d, [], []]])):
prog::test(expr(p2*p3),
           p([d, [], [d, [], [d, [d, [], []], []]]]) + p([d, [], [d, [d, [], [d, [], []]], []]]) + p([d, [], [d, [d, [d, [], []], []], []]]) + p([d, [d, [], [d, [], [d, [], []]]], []]) + p([d, [d, [], [d, [d, [], []], []]], []]) + p([d, [d, [d, [], [d, [], []]], []], []])):
prog::test(expr(p3*p1),
           p([d, [d, [], []], [d, [], []]]) + p([d, [d, [d, [], []], []], []])):
prog::test(expr(p3*p2),
           p([d, [d, [], []], [d, [], [d, [], []]]]) + p([d, [d, [d, [], []], []], [d, [], []]])):
prog::test(expr(p3*p3),
           p([d, [d, [], []], [d, [d, [], []], []]]) + p([d, [d, [d, [], []], [d, [], []]], []]) + p([d, [d, [d, [d, [], []], []], []], []])):

prog::testfunc(lo):

prog::test(lo::one*lo::one,   lo::one):
prog::test(lo::zero+lo::zero, lo::zero):
prog::test(expr(lp(ot1)*lp(ot2) - lp(ot1*ot2)), 0):

prog::testfunc(loo):
//prog::test(loo::one*loo::one,   loo::one): Yields a traperror ???
prog::test(loo::zero+loo::zero, loo::zero):

//////////////////////////////////////////////////////////////////////////////
// Compared with Frabetti/Brouder's preprint
bla := LRA::o::tensorSquare:
bla::basisName := hold(To):
prog::testfunc(lo::coproduct):
prog::test(expr(coproduct(LRA::o(BT::unrank(1,0)))),
           To([[], []])):
prog::test(expr(coproduct(LRA::o(BT::unrank(1,1)))),
           To([[], [d, [], []]]) + To([[d, [], []], []])):
prog::test(expr(coproduct(LRA::o(BT::unrank(1,2)))),
           To([[], [d, [], [d, [], []]]]) + To([[d, [], [d, [], []]], []])):
prog::test(expr(coproduct(LRA::o(BT::unrank(2,2)))),
           To([[], [d, [d, [], []], []]]) + 2*To([[d, [], []], [d, [], []]]) + To([[d, [d, [], []], []], []])):
prog::test(expr(coproduct(LRA::o(BT::unrank(1,3)))),
           To([[], [d, [], [d, [], [d, [], []]]]]) + To([[d, [], [d, [], [d, [], []]]], []])):
prog::test(expr(coproduct(LRA::o(BT::unrank(2,3)))),
           To([[], [d, [], [d, [d, [], []], []]]]) + To([[d, [], [d, [], []]], [d, [], []]]) + To([[d, [], [d, [d, [], []], []]], []])):
prog::test(expr(coproduct(LRA::o(BT::unrank(3,3)))),
           To([[], [d, [d, [], []], [d, [], []]]]) + To([[d, [], []], [d, [], [d, [], []]]]) + To([[d, [], [d, [], []]], [d, [], []]]) + To([[d, [d, [], []], [d, [], []]], []])):
prog::test(expr(coproduct(LRA::o(BT::unrank(4,3)))),
           To([[], [d, [d, [], [d, [], []]], []]]) + To([[d, [], []], [d, [], [d, [], []]]]) + To([[d, [], [d, [], []]], [d, [], []]]) + To([[d, [d, [], [d, [], []]], []], []])):
prog::test(expr(coproduct(LRA::o(BT::unrank(5,3)))),
           To([[], [d, [d, [d, [], []], []], []]]) + 3*To([[d, [], []], [d, [d, [], []], []]]) + 3*To([[d, [d, [], []], []], [d, [], []]]) + To([[d, [d, [d, [], []], []], []], []])):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

prog::testfunc(examples::LodayRoncoAlgebra):

prog::check(examples::LodayRoncoAlgebra(Dom::Rational), 3):

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
