/*****************************************************************************
  $Id: NonCommutativeSymmetricFunctions.tst,v 1.1.1.1 2003/09/15 16:37:46 nthiery Exp $
  File:		lib/EXAMPLES/TEST/NonCommutativeSymmetricFunctions.tst
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Test file for the library 'examples::NonCommutativeSymmetricFunctions'
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("NonCommutativeSymmetricFunctions"):

NCSF := examples::NonCommutativeSymmetricFunctions():

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(NCSF::L):
//////////////////////////////////////////////////////////////////////////////
prog::test(expr(NCSF::L([3,2,5])), L[3,2,5]):

for b1 in NCSF::bases do
    for b2 in NCSF::bases do
	if operators::overloaded::conversion(b2,b1) = FAIL then
	    fprint(Unquoted, 0, "Warning: Basis change not yet implemented");
	    next;
	end_if;
	prog::test(b1(b2([])), b1::one);
    end_for;
end_for:

prog::test(expr(NCSF::L([2, 1])*NCSF::L([1])),
           L[2,1,1]):

//////////////////////////////////////////////////////////////////////////////
// Check that the canonical morphism NCSF -> Sym is an algebra morphism
Sym := examples::SymmetricFunctions():
operators::overloaded::declareConversion
(NCSF::L, Sym::e, 
 operators::makeLinear(comp -> Sym::e(revert(sort(comp))),
		       Source=NCSF::L, ImageSet=Sym::e)):
for p1 in combinat::compositions::list(3) do
    for p2 in combinat::compositions::list(4) do
	progtest(Sym::e(NCSF::L(p1)*NCSF::L(p2))=Sym::e(NCSF::L(p1))*Sym::e(NCSF::L(p2)));
    end_for;
end_for:

//////////////////////////////////////////////////////////////////////////////
//prog::testfunc(NCSF::L::func_call):
//////////////////////////////////////////////////////////////////////////////
//prog::test((NCSF::m([2, 3, 1]) + NCSF::m([]) + NCSF::m([1, 5, 3, 2, 1]))([a, b, c, d]),
//           a^2*b^3*c + a^2*b^3*d + a^2*c^3*d + b^2*c^3*d + 1):

//////////////////////////////////////////////////////////////////////////////
//prog::testfunc(coproduct):
//////////////////////////////////////////////////////////////////////////////
//alias(Tm=NCSF::m::tensorAlgebra):
//alias(coproduct=operators::coproduct):
//prog::test(operators::coproduct(NCSF::m([])),
//           Tm([[], []])):
//prog::test(operators::coproduct(NCSF::m([3])),
//Tm([[3], []]) + Tm([[], [3]])):
//prog::test(operators::coproduct(NCSF::m([4, 3, 2])),
//           Tm([[4, 3, 2], []]) + Tm([[4, 3], [2]]) + Tm([[4], [3, 2]]) + Tm([[], [4, 3, 2]])):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the library

prog::testfunc(NCSF):

prog::check(NCSF, 3):

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
