/*****************************************************************************
  $Id: QuasiSymmetricFunctions.tst,v 1.1.1.4 2005/01/26 13:42:22 nthiery Exp $
  File:		lib/EXAMPLES/TEST/QuasiSymmetricFunctions.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'examples::QuasiSymmetricFunctions'
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

//sysassign(prog::testfunc, print):
prog::testinit("QuasiSymmetricFunctions"):

QSym := examples::QuasiSymmetricFunctions():

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(QSym::m):
//////////////////////////////////////////////////////////////////////////////
prog::test(expr(QSym::m([3,2,5])), m[3,2,5]):

//print(QSym::bases);
for b1 in QSym::bases do
    for b2 in QSym::bases do
//	print(b1,b2);
	if operators::overloaded::conversion(b2,b1) = FAIL then
//	    fprint(Unquoted, 0, "Warning: Basis change not yet implemented");
	    next;
	end_if;
	prog::test(b1(b2([])), b1::one);
    end_for;
end_for:

prog::test(expr(QSym::m([2, 1])*QSym::m([1])),
           m[2, 2] + m[3, 1] + 2*m[2, 1, 1] + m[1, 2, 1]):

//////////////////////////////////////////////////////////////////////////////
// Check that the canonical embeding Sym -> QSym is an algebra morphism
Sym := examples::SymmetricFunctions():
operators::overloaded::declareConversion(
 Sym::m, QSym::m,
 operators::makeLinear(part -> (QSym::m(c) $ c in combinat::permutations(part)),
		       Source=Sym::m, ImageSet=QSym::m)):
for p1 in combinat::partitions::list(3) do
    for p2 in combinat::partitions::list(4) do
	progtest(QSym::m(Sym::m(p1)*Sym::m(p2))=QSym::m(Sym::m(p1))*QSym::m(Sym::m(p2)));
    end_for;
end_for:

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(QSym::m::func_call):
//////////////////////////////////////////////////////////////////////////////
prog::test((QSym::m([2, 3, 1]) + QSym::m([]) + QSym::m([1, 5, 3, 2, 1]))([a, b, c, d]),
           a^2*b^3*c + a^2*b^3*d + a^2*c^3*d + b^2*c^3*d + 1):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(coproduct):
//////////////////////////////////////////////////////////////////////////////
alias(Tm=QSym::m::tensorSquare):
alias(coproduct=operators::coproduct):
prog::test(operators::coproduct(QSym::m([])),
           Tm([[], []])):
prog::test(operators::coproduct(QSym::m([3])),
           Tm([[3], []]) + Tm([[], [3]])):
prog::test(operators::coproduct(QSym::m([4, 3, 2])),
           Tm([[4, 3, 2], []]) + Tm([[4, 3], [2]]) + Tm([[4], [3, 2]]) + Tm([[], [4, 3, 2]])):

alias(F=QSym::F, TF=QSym::F::tensorSquare):
prog::test(coproduct(F([])),
	   TF::fromList([[1, [[], []]]])):
prog::test(coproduct(F([5])),
           TF::fromList([[1, [[4], [1]]], [1, [[5], []]], [1, [[3], [2]]], [1, [[2], [3]]], [1, [[1], [4]]], [1, [[], [5]]]])):
prog::test(coproduct(F([1, 1, 1, 1, 1])),
           TF::fromList([[1, [[1, 1, 1, 1, 1], []]], [1, [[1, 1], [1, 1, 1]]], [1, [[1, 1, 1], [1, 1]]], [1, [[1, 1, 1, 1], [1]]], [1, [[1], [1, 1, 1, 1]]], [1, [[], [1, 1, 1, 1, 1]]]])):
prog::test(coproduct(F([2, 3])),
           TF::fromList([[1, [[2, 2], [1]]], [1, [[2, 1], [2]]], [1, [[2], [3]]], [1, [[1], [1, 3]]], [1, [[2, 3], []]], [1, [[], [2, 3]]]])):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the library

prog::testfunc(QSym):

prog::check(QSym, 3):

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
