/*****************************************************************************
  $Id: AlgebraWithBasis.mu,v 1.1.1.1 2003/09/15 16:37:46 nthiery Exp $
  File:         experimental/AlgebraWithBasis.mu
  Authors:      Nicolas M. Thiry <nthiery@users.sourceforge.net>
                Florent Hivert <florent.hivert@univ-mlv.fr>
  Created:      3/12/2002
  Purpose:      Experimental base domain for algebra with basis.
  License:      LGPL
*****************************************************************************/

alias(plus2		= operators::plus2):
alias(mult2		= operators::mult2):
alias(declareDomain     = operators::overloaded::declareDomain):
alias(declareConversion = operators::overloaded::declareConversion):
alias(declareSignature  = operators::overloaded::declareSignature);

domain experimental::AlgebraWithBasis
    (R: DOM_DOMAIN,
     Basis: DOM_DOMAIN,
     implementation = FAIL)
    category Cat::AlgebraWithBasis(R);

    inherits
	case implementation
	  of Poly  do Dom::FreeModulePoly(R, Basis); break;
	  of Table do Dom::FreeModuleTable(R, Basis); break;
	  of FAIL  do Dom::FreeModule(R, Basis); break;
	  otherwise
                   if op(implementation, 0) = MnPoly then
                      Dom::FreeModuleMnPoly(R, Basis, op(implementation));
                   else
                      error("Unknown free module implementation: ".
			  expr2text(implementation));
                   end_if;
	end_case;

    new        := x     -> operators::overloaded::convertExplicit(x,dom);
    convert    := dom::new;
    convert_to := (x,T)     -> operators::overloaded::convertExplicit(x,T);

    _subtract := (x,y) -> x+(-y);
    _plus := operators::_plus;
    _mult := operators::_mult;

end_domain:
