// read("modules.mpl"):

roots := [-1,0,1]:
N:=3:
ak := experimental::ArikiKoikeAlgebra(N, roots):

if myexport=hold(myexport) then export(combinat): myexport:=0: end_if:

// ##########################################################################
// # Declarations de base
// ##########################################################################

P := prog::indexedProcedure(ak::term @ (() -> [0$N, [args()]])):
X := prog::indexedProcedure(ak::term @ ((i) -> [op(subsop([0$N],i=1)),
                                  [$1..N]])):
T := prog::indexedProcedure(ak::term @ ((i) -> [0$N,
                                 subs([$1..N], [i=i+1, i+1=i])])):

shiftedConcat :=  misc::genassop((l1,l2) -> _concat(l1, map(l2, _plus,
nops(l1))), []):
listYoung := (l) -> map(cartesianProduct(op(map(l, permutations::list))),
                        shiftedConcat@op):
maxYoung  := (l) -> shiftedConcat(([i-k $ k=0..i-1]) $ i in l):

carre    := (l) -> _plus(P[op(p)] $ p in listYoung(l)):
nabla    := (l) -> P[op(maxYoung(l))]:
eta      := (l) -> nabla(revert(compositions::conjugate(l))) * carre(l) :
// Projectif P_l
minToMax := (l) -> permutations::_mult
                  (permutations::descentsCompositionToMax(l),
                   permutations::inverse
                   (permutations::descentsCompositionToMin(l))):

simpleHeckeGen := (l) -> P[op(minToMax(revert(l)))] * eta(revert(l)):
// simple S_l

// ##########################################################################
isCycloRib := proc(compo,l)
local des,i;
begin
  des := combinat::compositions::descentsSet(compo);
  for i from 1 to nops(l)-1 do
    if (((i in des)) and (l[i]>l[i+1])) then return(FALSE); end_if;
    if (not(i in des) and (l[i]<l[i+1])) then return(FALSE); end_if;
  end_for;
  return(TRUE);
end_proc:

/*
isCycloRib([1,2],[1,3,1]);
isCycloRib([1,2],[1,2,1]);
isCycloRib([1,2],[2,2,2]);
*/

// ##########################################################################
listIndex := proc(n,c)
local i;
begin
  select(combinat::cartesianProduct(
            combinat::compositions::list(n),
            combinat::cartesianProduct([$1..c]$n)),
         isCycloRib@op);
end_proc:

//listIndex(4,3);
//n := 7: c := 6:
//nops(listIndex(n,c))-c*(c+1)^(n-1);

// ##########################################################################
simpleModule := proc(compo,l) // l de long somme de compo.
local i,j,n,res;
begin
  n := nops(l);
  res := ak::mult(( (X[n+1-i]-roots[j]) $ j=1..l[i]-1,
                    (X[n+1-i]-roots[j]) $ j=l[i]+1..n
                  ) $i=1..n);
  return(ak::mult(simpleHeckeGen(compo),res));
end_proc:

//simpleModule([1,2],[1,3,1]):

// ##########################################################################
isSimple := proc(compo,l)
local module;
begin
  module := simpleModule(compo,l);
  
end_proc:


/*

//myelt := simpleModule([1,2],[1,3,1]):
//simpleHeckeGen([2,1]);
//myelt := T1*T2*(1+T1)*(x1)*(x1-1)*(x2)*(x2+1)*(x3-1)*(x3);
//myelt := (x1)*(x1-1)*(x2)*(x2+1)*(x3-1)*(x3);
   //### -> -1 0  -1 1 -1
solve({coeff((T1-t1)*myelt)},t1);
solve({coeff((T2-t2)*myelt)},t2);
solve({coeff((x1-a1)*myelt)},a1);
solve({coeff((x2-a2)*myelt)},a2);
solve({coeff((x3-a3)*myelt)},a3);
*/
// ##########################################################################
//etaak := eta([1,2])*(x1)*(x1-1)*(x2)*(x2+1)*(x3-1)*(x3);
//base := [b*etaak $b in ak::basis()];

//experimental::algTools::RRBasis(base);

