/*****************************************************************************
  $Id: FiniteQuotientOfPolynomials.mu,v 1.1.1.2 2005/01/26 13:42:23 nthiery Exp $
  File:		lib/EXPERIMENTAL/FiniteQuotientOfPolynomials.mu
  Authors:	Florent Hivert
  Created:	2004-06-09
  License:	LGPL
*****************************************************************************/

alias(FPols  = experimental::FiniteQuotientOfPolynomials):

//////////////////////////////////////////////////////////////////////////////
// Quotient of polynomial by a polynomial whose roots are given by the list L
domain FPols(X : DOM_IDENT,
	     L : DOM_LIST, 
	     R = Dom::ExpressionField()) 
    category Cat::AlgebraWithBasis(R);
    inherits Dom::FreeModulePoly(R, combinat::finiteClass([$0..nops(L)-1]),
				 Variables=[X],
				 RankerBasis=[id, id]);

    info_str := "Domain for finite quotient of polynomials";

    variables := X;
    print := dom::polDom@extop;
    expr  := extop;
    one := dom::term(0);
    pol := poly(_mult((X-expr(L[i])) $ i=1..nops(L)),
		[dom::variables], dom::getPolyRingParameters()[1]);
    polDom := Dom::DistributedPolynomial([X], R);
    new    := dom::fromExpr;

    straighten := dom::straightenPol @ extop; // rely on the stucture of freemodules. 
    straightenPol :=  // rely on the stucture of freemodules. 
    proc(p)
    begin
	new(dom, divide(p, dom::pol, Rem));
    end_proc;

    mult2 := // rely on the stucture of freemodules. 
    proc(l1 : dom, l2 : dom)
    begin
	dom::straightenPol(extop(l1)*extop(l2));
    end_proc;

    mult := // rely on the stucture of freemodules. 
    proc()
	local l;
    begin
	if args(0) = 0 then 
	    dom::one
	else
	    dom::straightenPol(_mult(extop(l) $ l in [args()]));
	end_if;
    end_proc;

    fromPoly :=
    proc(p: DOM_POLY)
    begin
	dom::fromList(poly2list(p));
    end_proc;

    fromExpr :=
    proc(e)
    begin
	dom::fromPoly(poly(e, [dom::variables], R));
    end_proc;

end_domain:

/*
reset():TEXTWIDTH:=118:unprotect(experimental):read("FiniteQuotientOfPolynomials.mu"):
fPol := experimental::FiniteQuotientOfPolynomials(X, [-1,1,a]):
FTens := Dom::TensorProductOfFreeModules([fPol $ 2]):
FTens::print := zz -> Dom::DistributedPolynomial([x,y,z], Dom::ExpressionField())(subs(extop(zz), _X1=x, _X2=y)):
*/
