/*****************************************************************************
  $Id: Hecke0.mu,v 1.1.1.2 2004/10/04 17:25:13 nthiery Exp $
  File:         lib/EXPERIMENTAL/HeckeClifford/Hecke0.mu
  Authors:      Florent Hivert <florent.hivert@univ-mlv.fr>
  Created:      20/01/2003
  License:      LGPL
*****************************************************************************/

alias(Perm = combinat::permutations):
alias(makeLinear = operators::makeLinear):
alias(HeckeAlgebra = experimental::HeckeAlgebra):

/****
 0-Hecke Algebra
**********************************************/
domain HeckeAlgebra(n : Type::NonNegInt,
		    R = Dom::ExpressionField())

  category Cat::FiniteDimensionalAlgebraWithBasis(R);
  inherits Dom::FreeModule(R, combinat::subClass(Perm, Parameters=n));

  exprTerm := l -> _concat(hold(P),op(l)); 
  
  oneBasis := [$1..n];

  Ti := (i) -> dom::term(subsop([$1..n], i=i+1, i+1=i));

  mult2Basis := 
    proc(perm1 : dom::basisIndices, perm2 : dom::basisIndices)
	local res, sgn; 
    begin
	res := perm1;
	sgn := 1;
	for i in Perm::reducedWord(perm2) do
	    if res[i] < res[i+1] then 
	    res := subsop(res, i=res[i+1], (i+1)=res[i]);
	    else 
		sgn := -sgn;
	    end_if;
	end_for;
	dom::monomial(R(sgn), res);
    end_proc;
    
begin
end_domain:


