export(combinat):
//N := 3; infos := 1; myTools::devMode(FALSE); read ("hcl.mu");
//*********************
// ShortCuts fo domains
//***
hcl := experimental::HeckeCliffordAlgebra(N):
cl :=  experimental::CliffordAlgebra(N):
wrd := experimental::HeckeCliffordWordModule(hcl):
//***************************************
// Generators of the algebras and modules
//***
C := prog::indexedProcedure(cl::term @ (i -> subsop([0$N], i=1))):
P := prog::indexedProcedure(hcl::term @ (() -> [[0$N], [args()]])):
T := prog::indexedProcedure(hcl::term @ ((i) -> [[0$N], 
				 subs([$1..N], [i=i+1, i+1=i])])):
W := prog::indexedProcedure(wrd::term @ (() -> [[0$N], [args()]])):

shiftedConcat :=  misc::genassop((l1,l2) -> _concat(l1, map(l2, _plus, nops(l1))), []):
listYoung := (l) -> map(cartesianProduct(op(map(l, permutations::list))),
			shiftedConcat@op):
maxYoung  := (l) -> shiftedConcat(([i-k $ k=0..i-1]) $ i in l):

carre    := (l) -> _plus(P[op(p)] $ p in listYoung(l)):
nabla    := (l) -> P[op(maxYoung(l))]:
eta      := (l) -> nabla(revert(compositions::conjugate(l))) * carre(l) : // Projectif P_l
minToMax := (l) -> permutations::_mult
		  (permutations::descentsCompositionToMax(l), 
		   permutations::inverse
		   (permutations::descentsCompositionToMin(l))):

// return a vector v of hcl such that		   
//  T[i] * v = { -v if i is a decent of l
//             {  0 else.
simpleAlgebraGen := (l) -> P[op(minToMax(revert(l)))] * eta(revert(l)): // simple S_l
simpleWordGen := 
proc(l) 
    local len, i; 
begin 
    len := nops(l);
    [(len + 1 - i$ l[i]) $ i=1..len];
end_proc:
//simple    := (l) -> (hcl::MModule(l))::one:
simple := (l) -> (experimental::HeckeCliffordModuleMI(hcl, l))::one:
S := prog::indexedProcedure(simple @ DOM_LIST): 

checkSimple := 
proc()
    local c, s, dc, el;
begin
    for c in compositions(N) do
	userinfo(1, "Checking ".expr2text(c));
	s := simple(c);
	dc := {op(compositions::descents(c))};
	for i from 1 to N-1 do
	    if i in dc then
		el := T[i] + 1 ;
	    else 
		el := T[i];
	    end_if;
	    if not iszero(el*s) then 
		userinfo(1, "Error: ",c);
		userinfo(1, s);
		userinfo(1, i,el);
	        userinfo(1, el*s);
	    end_if;
	end_for;
    end_for;
    null();
end_proc:


//checkSimple(N);
ZeroOneVectors := [op(integerVectors::list(S, N, MaxPart=1)) $ S=0..N]:
genClElem := _plus((b[op(i)] * cl::term(i)) $ i in ZeroOneVectors):

// Generateur des super-modules super-simple de HCl_3
//***************************************************
// Pour la classe de Pics [3]
//   Trois super-modules isomorphes: 
//   S[3];
//   (1 + C1 C2) S[1,2];
//   (1 + C1 C2 - C1 C3 + C2 C3) S[1,1,1];
// Pour la Classe de Pics [2,1]
//   simple([2,1]);
ZeroOne0Vectors := [op(integerVectors::list(2*S, N, MaxPart=1)) $ S=0..N div 2]:
genCl0Elem := _plus((b[op(i)] * cl::term(i)) $ i in ZeroOne0Vectors):

trouveIsoInductSimple := 
    proc(comp2, comp)
	local g, sol, eqsys, dc, i; 
    begin
	eqsys := []; // b[0$N]=1 ];
	g := genClElem * simple(comp): 
	userinfo(NoNL, 1, "gen ");
	dc := {op(compositions::descents(comp2))};
	for i from 1 to N-1 do
	    if i in dc then
		el := T[i] + 1 ;
	    else 
		el := T[i];
	    end_if;
	    eqsys := append(eqsys, coeff(el*g));
	userinfo(NoNL, 1, ".");
	end_for;
	userinfo(NoNL, 1, " eqsys ");
//	print(eqsys);
	sol := linsolve(eqsys);
	userinfo(NoNL, 1, "sol ");
	if iszero(mapcoeffs(genClElem, subs, op(sol))) then return(FAIL); end_if;
	hold(_mult)(mapcoeffs(genClElem, subs, op(sol)),hold(S)[op(comp)]);
    end_proc:


// Generateur des super-modules super-simple de HCl_4
//***************************************************
// Pour la classe de Pics [4]
//   Quatre super-modules isomorphes: 
// trouveIsoInductSimple([1,1,1,1]);
//   (C1 C2 C3 C4 + C3 C4 - C2 C4 + C2 C3 + C1 C4 - C1 C3 + C1 C2 + 1) S[1, 1, 1, 1]
// trouveIsoInductSimple([1,1,2]);
//   (C2 C3 - C1 C3 + C1 C2 + 1) S[1, 1, 2]
// trouveIsoInductSimple([1,3]);
//   (C1 C2 + 1) S[1, 3]
// trouveIsoInductSimple([4]);
//   S[4]

isom := 
proc()
    local lc, p, a, res, t, nParms;
begin
    res :=  [];
    lc := combinat::compositions::list(N);
    for p in combinat::cartesianProduct::list(lc, lc) do
	userinfo(NoNL, 1, "Searching for ".expr2text(op(p))." ... ");
	if (t := trouveIsoInductSimple(op(p))) <> FAIL then
	    if compositions::peaks(p[1]) = compositions::peaks(p[2]) then 
		res  := append(res, [p,t]);
		t := expr(t);
		nParms := select(ZeroOneVectors, z -> has(t, hold(b)[op(z)]));
		userinfo(NoNL, 1, nops(nParms));
		if nops(nParms) <> 2^(nops(compositions::peaks(p[1]))+1) then
		    print(nops(nParms), p[1], compositions::peaks(p[1]));
		    error("Conjecture Fausse !!!");
		end_if;
		userinfo(NoNL, 1, " Ok.\n");
	    else
		error("Morphism between ".expr2text(p, t));
	    end_if;
	else
	    if compositions::peaks(p[1]) = compositions::peaks(p[2]) then 
		error("No morphisms between ".expr2text(p));
	    else
		userinfo(NoNL, 1, "No.\n");		
	    end_if;
	end_if;
    end_for;
    res;
end_proc:

if infos = 1 then
    setuserinfo(checkSimple,1):
    setuserinfo(trouveIsoInductSimple,1):
    setuserinfo(isom,1):
end_if:


diffCompo := 
proc(compo)
  local ds, ds1;
begin
  ds  := {op(compositions::descents(compo))};
  ds1 := map(ds, _plus, 1);
  (ds1 minus ds) union (ds minus ds1);
end_proc:

StembridgeCompositions := 
proc(p, n)
begin
  select(compositions(n), z -> (p minus diffCompo(z)) = {});
end_proc:

// >> print(z, _mult(T[1], z), _mult(T[2], z)) $ z in bs3;
//                                      S[3], 0, 0
//                                     C1 S[3], 0, 0
//                             C2 S[3], (- C2 + C1) S[3], 0
//                             C3 S[3], 0, (- C3 + C2) S[3]
//                           C1 C2 S[3], (- C1 C2 + 1) S[3], 0
//                         C1 C3 S[3], 0, (- C1 C3 + C1 C2) S[3]
//                C2 C3 S[3], (- C2 C3 + C1 C3) S[3], (- C2 C3 + 1) S[3]
//             C1 C2 C3 S[3], (- C1 C2 C3 + C3) S[3], (- C1 C2 C3 + C1) S[3]

// >> print(z, _mult(T[1], z), _mult(T[2], z)) $ z in bs21;
//                                 S[2, 1], 0, -S[2, 1]
//                              C1 S[2, 1], 0, -C1 S[2, 1]
//                     C2 S[2, 1], (- C2 + C1) S[2, 1], -C3 S[2, 1]
//                              C3 S[2, 1], 0, -C3 S[2, 1]
//              C1 C2 S[2, 1], (- C1 C2 + 1) S[2, 1], (C1 C3) S[2, 1] (-1)
//                        C1 C3 S[2, 1], 0, (C1 C3) S[2, 1] (-1)
//                   C2 C3 S[2, 1], (- C2 C3 + C1 C3) S[2, 1], S[2, 1]
//                C1 C2 C3 S[2, 1], (- C1 C2 C3 + C3) S[2, 1], C1 S[2, 1]

ZeroOne2Compo := 
  proc(z)
    local i, n;
  begin
    n := nops(z);
    compositions::fromDescents(select([$1..n], i -> z[i] <> 0), n+1);
  end_proc:

CaractereModuleMI := 
proc(compo)
  local vect, v, i, n, res, resV, Mod;
begin
    res := table();
    Mod := simple(compo);
    for vect in ZeroOneVectors do
	resV := [];
	v := cl(vect) * Mod;
	for i from 1 to N-1 do 
	    resV := append(resV, coeff(T[i] * v, vect));
	end_for;
	resV :=  ZeroOne2Compo(resV);
	if contains(res, resV) then
	    res[resV] := res[resV]+1;
	else
	    res[resV] := 1;
	end_if;
    end_for;
    res;
end_proc:


checkStembridge := 
proc()
  local compo, my, stem;
begin
  for compo in compositions(N) do
    userinfo(NoNL, 1, "Checking ".expr2text(compo)." ... ");
    my   := map({op(CaractereModuleMI(compo))}, op, 1);
    stem := {op(StembridgeCompositions
	   ({op(compositions::peaks(compo))}, N))};
    if my = stem then 
      userinfo(NoNL, 1, " : ".expr2text(nops(my))." ok.\n");
    else
      print(compo);
      print(my);
      print(stem);
      error("Conjecture Fausse !!!!!");
    end_if;
  end_for;
end_proc:
if infos = 1 then
    setuserinfo(checkStembridge, 1):
end_if:

CaractereModuleInductMI := 
proc(compo1, compo2)
    local gen1, gen2, vectHn, genShuffle,
	  vect, v, i, n, res, resV, Mod;
begin
    res := table();
    gen  := simpleWordGen(compo1);
    gen2 := map(simpleWordGen(compo2), _plus, nops(compo1));
    genShuffle := words::shuffle::generator(gen, gen2);
    // Pour tout les vecteurs de la base du module Hn-induit
    while (vectHn := genShuffle()) <> FAIL do 
	for vect in ZeroOneVectors do
	    resV := [];
	    v := hcl::wordModule::term([vect, vectHn]);
	    for i from 1 to N-1 do 
		resV := append(resV, coeff(T[i] * v, [vect, vectHn]));
	    end_for;
	    resV :=  ZeroOne2Compo(resV);
	    if contains(res, resV) then
		res[resV] := res[resV]+1;
	    else
		res[resV] := 1;
	    end_if;
	end_for;
    end_while;
    res;
end_proc:


tableToQSym := 
proc(t)
begin
    _plus(op(x,2) * F[op(op(x,1))] $ x in t);
end_proc:

// [b[0, 0, 2, 1] = 5/8, b[0, 1, 1, 2] = 0, b[0, 1, 2, 1] = 0, b[1, 1, 2, 1] = -3/8, b[1, 0, 1, 2] = 0, 
//  b[1, 0, 2, 1] = 0,   b[1, 1, 1, 2] = 1/4], 
// [b[0, 0, 2, 1] = 1/2, b[0, 1, 1, 2] = -1/4 I, b[0, 1, 2, 1] = 0, b[1, 1, 2, 1] = -1/2, 
//  b[1, 0, 1, 2] = 0, b[1, 0, 2, 1] = 0, b[1, 1, 1, 2] = 1/4], 
// [b[0, 0, 2, 1] = 1/2, b[0, 1, 1, 2] = 1/4 I, b[0, 1, 2, 1] = 0, b[1, 1, 2, 1] = -1/2, b[1, 0, 1, 2] = 0, 
//  b[1, 0, 2, 1] = 0, b[1, 1, 1, 2] = 1/4]

IsShiftedTableau := 
    proc(tab)			    
	    local shape, line, col, n;
	begin
	    if tab=[] then return(TRUE); end_if;
	    shape := map(tab, nops);
	    if not testtype(shape, Type::ListOf(Type::PosInt))
	       or sort(shape) <> shape 
		then return(FALSE); 	
	    end_if;
	    n := nops(shape);
	    for line from 1 to nops(shape)-1 do
		for col from n-line+1 to shape[line]-1 do
//		    print(line, col, tab[line][col]);
		    if    (tab[line][col] > tab[line][col+1]) 
		       or (tab[line][col] <= tab[line+1][col])
			then return(FALSE);
		    end_if;
		end_for;
		if tab[line][col] <= tab[line+1][col]
		    then return(FALSE);
		end_if;
	    end_for;
	    for col from 1 to shape[line]-1 do
		if tab[line][col] > tab[line][col+1] 
		    then return(FALSE);
		end_if;
	    end_for;
	    return(TRUE);
	end_proc:

ShiftTableau := 
proc(tab)
    local n;
begin
    n := nops(tab);
    [[X$ n-i].tab[i] $ i = 1..n];
end_proc:

ShiftedTableaux := 
proc(part)
begin
    select(map(tableaux::list(part), ShiftTableau), IsShiftedTableau);
end_proc:

PicTableau := t -> permutations::peaks 
		  ( permutations::inverse
		   ( map(t, z-> subs(op(z), X=null())))):

chU := 
proc(part)
    local lPic, n;
begin
    n := _plus(op(part));
    lPic := map(ShiftedTableaux(part), PicTableau);
    1/2^(nops(part) div 2) *
    _plus(2^((nops(pic) + 1) div 2) * 
	  chSi[op(compositions::fromDescents(pic, n))]
	  $ pic in lPic);
end_proc:

StrictPart := n -> partitions::list(n, MaxSlope = -1):
PeakCompo := n -> compositions::list(n, MinPart = 2). 
		 map(compositions::list(n-1, MinPart = 2), _concat, [1]):
		 
DecompMatrix := 
    proc(nn)
	local n, m, lp, lc, res, ip, ic, chUp;
    begin
	lp := StrictPart(nn); n := nops(lp);
	lc := revert(sort(PeakCompo(nn), compositions::_less));  
	m := nops(lc);
	res := array(1..n, 1..m);
	for ip from 1 to n do
	    chUp := chU(lp[ip]);
	    for ic from 1 to m do
		res[ip, ic] := coeff(chUp, chSi[op(lc[ic])]);
	    end_for;
	end_for;
	[lp, lc,res];
    end_proc:

TexCompo := proc(c) begin _concat(op(map(c, expr2text))); end_proc:

TexDecompMatrix := 
    proc(nn)
	local lp, lc, res, texlp, texlc, np, nc, i;
    begin
	[lp, lc, res] := DecompMatrix(nn);
	np := nops(lp);
	nc := nops(lc);
	texlp := map(lp, TexCompo);
	texlp := _concat("%\n{ ",
			 ((texlp[i]. " \\\\ ") $ i=1..np), 
			 " }%\n");
	texlc := map(lc, TexCompo);
	texlc := _concat("{ ",
			 (texlc[i]." & ") $ i=1..nc-1, 
			 texlc[nc], " }%\n");
	print(NoNL, texlc.generate::TeX(res).texlp);
    end_proc:
null():

