/*****************************************************************************
  $Id: Schur.mu,v 1.1.1.2 2005/01/26 13:42:23 nthiery Exp $
  File:		lib/EXPERIMENTAL/Schur.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Source code for the domain experimental::Schur
  Created:	Tue Jul  6 09:16:30 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

export(combinat, Alias,
       partitions,
       integerVectors):

domain experimental::Schur

    info_str := "experimental::Schur -- library for schur and multischur functions";

    minorIndex :=
    proc(II: integerVectors, J: integerVectors)
	local row, col;
    begin
	assert(nops(II)=nops(J));
	// Question: do we want the partitions increasing or decreasing
	//II := revert(II);
	//J  := revert(J);
	matrix([[J[col]+col-1 - (II[row]+row-1)
		 $ col=1..nops(J) ]
		$ row=1..nops(II) ]);
    end_proc;

    multiSchur :=
   proc(II: integerVectors, J: integerVectors, alphabets)
   begin
       m := dom::minorIndex(II, J);
       assert(nops(II)=nops(alphabets));
       h := (examples::SymmetricFunctions())::h;
       linalg::det(matrix([[ normal(h::straightenBasis([m[row,col]]) (alphabets[col])) $ col=1..nops(J) ]
			   $ row = 1..nops(II)]));
   end_proc;
   
    schur :=
    proc(J: integerVectors)
	local m, h, f;
    begin
	m := dom::minorIndex([0 $ nops(J)], J);
	h := (examples::SymmetricFunctions())::h;
	f := n -> if n >= 0 then h::straightenBasis([n]) else h::zero; end_if;
	// not map, because does not work for sparse matrices
	m := Dom::Matrix(h)([[ f(m[row,col]) $ col=1..nops(J) ] $ row = 1..nops(J)]);
	linalg::det(m);
    end_proc;
    
end_domain:
