/*****************************************************************************
  $Id: SubAlgebra.mu,v 1.1.1.1 2004/10/04 17:25:13 nthiery Exp $
  File:         lib/EXPERIMENTAL/SubAlgebra.mu
  Authors:      Florent Hivert <florent.hivert@univ-mlv.fr>
                Nicolas M. Thiry <nthiery@users.sf.net>
  Created:      05/06/2003
  License:      LGPL
*****************************************************************************/

/**
 * Let A be a finite dimensional combinatorial algebra
 * Let B be a subalgebra of A
 * Let basis be a vector space basis of B in row echelon form with
 * respect to the term order
 *
 * This implements the subalgebra spanned by B in A
 **/
domain experimental::SubAlgebra(basisOfB: DOM_LIST)
    local A;
    inherits Dom::SubFreeModule(basisOfB);
    category Cat::FiniteDimensionalAlgebraWithBasis(A::coeffRing);

    one := dom::fromSupModule(A::one);

    multBasis :=
    proc() : dom
	option remember; // The computations in the big algebra will typically be expensive
	local i;
    begin
	dom::fromSupModule(A::mult(dom::toSupModuleBasis(args(i)) $ i=1..args(0)));
    end_proc;

begin
    A := (basisOfB[1])::dom;
end_domain:
