/*****************************************************************************
  $Id: SubLeftAModule.mu,v 1.1.1.1 2004/10/04 17:25:13 nthiery Exp $
  File:         lib/EXPERIMENTAL/SubLeftAModule.mu
  Authors:      Florent Hivert <florent.hivert@univ-mlv.fr>
                Nicolas M. Thiry <nthiery@users.sf.net>
  Created:      05/06/2003
  License:      LGPL
*****************************************************************************/

/**
 * Let M be a finite dimensional A-module
 * Let B be a submodule of M
 * Let basis be a vector space basis of B in row echelon form with
 * respect to the term order
 *
 * This implements the sub A-module spanned by B in M
 **/
domain experimental::SubLeftAModule(A, basisOfB: DOM_LIST)
    local M;
    inherits Dom::SubFreeModule(basisOfB);
    category Cat::LeftAModuleWithBasis(A);

    mult2Basis :=
    proc(a: A::basisIndices, v: dom::basisIndices) : dom
	option remember; // The computations in the big module will typically be expensive
	local i;
    begin
	dom::fromSupModule(M::mult2(A::term(a), dom::toSupModuleBasis(v)));
    end_proc;

begin
    M := (basisOfB[1])::dom;
end_domain:
