/*****************************************************************************
  $Id: FreeOperad.tst,v 1.1.1.1 2004/10/04 17:25:13 nthiery Exp $
  File:		lib/EXPERIMENTAL/TEST/FreeOperad.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test suite for the domain experimental::FreeOperad
  Created:	Tue Dec  9 21:59:27 2003
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("FreeOperad"):

experimental::FreeOperad:

alias(Trees = experimental::FreeOperadTools::orderedCompleteBinaryTreesLabelledOnLeaves()):
alias(d=Trees::dummyLabel):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(Trees):
//////////////////////////////////////////////////////////////////////////////

prog::test(sort(map(Trees::list(3), expr)),
	   sort([[d, [1], [d, [2], [3]]], [d, [2], [d, [1], [3]]], [d, [3], [d, [1], [2]]], [d, [1], [d, [3], [2]]], [d, [2], [d, [3], [1]]], [d, [3], [d, [2], [1]]], [d, [d, [1], [2]], [3]], [d, [d, [1], [3]], [2]], [d, [d, [2], [3]], [1]], [d, [d, [2], [1]], [3]], [d, [d, [3], [1]], [2]], [d, [d, [3], [2]], [1]]])):

prog::test(Trees::size(Trees([1])),
           1):
prog::test(Trees::size(Trees::unrank(10^10, 10)),
           10):
prog::test(map(Trees::list(3), Trees::size),
           [3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3]):

prog::test(expr(Trees::mapLeaves(Trees::unrank(10^10, 10), _power, 2)),
           [d, [d, [25], [d, [100], [d, [d, [d, [16], [36]], [1]], [d, [4], [64]]]]], [d, [81], [d, [49], [9]]]]):

prog::test(Trees::mapLeaves(Trees([3]), _power, 2),
	   Trees([9])):
for t in [Trees([1]), op(Trees::list(3)), Trees::unrank(10^2, 5)] do
    for i from 1 to Trees::size(t) do
        prog::test(Trees::graft(t,Trees([1]),i), t)
    end_for;
    prog::test(Trees::graft(Trees([1]), t, 1), t)
end_for:

t := Trees::unrank(10^2, 5):
prog::test(expr(Trees::graft(t, t, 2)),
           [d, [9], [d, [8], [d, [d, [6], [d, [5], [d, [3], [d, [4], [2]]]]], [d, [7], [1]]]]]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc(experimental::FreeOperad):
//////////////////////////////////////////////////////////////////////////////

A := experimental::FreeOperad():

prog::test(A::composition(A::one, A::one, 1),
	   A::fromList([[1, (Trees)([1])]])):
t := 1 + A::basis::unrank(3,5):
prog::test(A::composition(t, t, 1),
           A::fromList([[1, new(Trees,NIL, new(Trees,7), new(Trees,NIL, new(Trees,NIL, new(Trees,3), new(Trees,NIL, new(Trees,1), new(Trees,NIL, new(Trees,2), new(Trees,NIL, new(Trees,4), new(Trees,5))))), new(Trees,NIL, new(Trees,6), new(Trees,NIL, new(Trees,8), new(Trees,9)))))], [2, new(Trees,NIL, new(Trees,3), new(Trees,NIL, new(Trees,1), new(Trees,NIL, new(Trees,2), new(Trees,NIL, new(Trees,4), new(Trees,5)))))], [1, new(Trees,1)]])):

prog::check(A, 3):

prog::testexit():

// Local Variables:
// mode: mupad
// End:
