/*****************************************************************************
  $Id: PBT.tst,v 1.1.1.1 2003/09/15 16:37:47 nthiery Exp $
  File:		experimental/TEST/PBT.tst
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
                Jean-Christophe Novelli <novelli@univ-mlv.fr>
		Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'experimental::PBT'
  Created:	14/03/2003
  License:	LGPL
*****************************************************************************/

prog::testinit("PBT"):

alias(BT=combinat::binaryTrees):
alias(PBT=experimental::PBT):

prog::testfunc(PBT::pSymbol):
prog::test(expr(PBT::pSymbol([1,3,5,4,2])),
	   [2, [1, [], []], [4, [3, [], []], [5, [], []]]]):
prog::test(expr(PBT::qSymbol([1,3,5,4,2])),
	   [5, [1, [], []], [4, [2, [], []], [3, [], []]]]):

prog::testfunc(PBT::canonicalWord):
prog::test(PBT::canonicalWord([1,3,5,4,2]),
	   [5, 3, 4, 1, 2]):

for tree in BT::list(4) do 
    // test that all permutations in the class of tree have it as P-symbol
    prog::test(op({op(map(PBT::class(tree), PBT::UP))}), tree);
end_for:

for n from 1 to 5 do
    // test that the union of the classes are of size n!
    prog::test(nops(_union({op(PBT::class(tree))} $ tree in BT::list(n))),
	       n!);
end_for:

prog::testfunc(PBT::class):
prog::test(PBT::class(BT([1,[1,[1]],[1,[1],[1]]])),
	   [[6, 4, 5, 1, 2, 3], [4, 6, 5, 1, 2, 3], [6, 4, 1, 5, 2, 3], [4, 6, 1, 5, 2, 3],
	    [6, 1, 4, 5, 2, 3], [1, 6, 4, 5, 2, 3], [4, 1, 6, 5, 2, 3], [1, 4, 6, 5, 2, 3],
	    [6, 4, 1, 2, 5, 3], [4, 6, 1, 2, 5, 3], [6, 1, 4, 2, 5, 3], [1, 6, 4, 2, 5, 3],
	    [4, 1, 6, 2, 5, 3], [1, 4, 6, 2, 5, 3], [6, 1, 2, 4, 5, 3], [1, 6, 2, 4, 5, 3],
	    [1, 2, 6, 4, 5, 3], [4, 1, 2, 6, 5, 3], [1, 4, 2, 6, 5, 3], [1, 2, 4, 6, 5, 3]]):


//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

prog::testfunc(experimental::PBT):

prog::check(experimental::PBT, 3):

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
