/*****************************************************************************
  $Id: RQuasiSymmetricFunctions.tst,v 1.1.1.1 2004/10/04 17:25:13 nthiery Exp $
  File:		lib/EXPERIMENTAL/TEST/RQuasiSymmetricFunctions.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test suite for the domain experimental::RQuasiSymmetricFunctions.mu
  Created:	Mon Apr 19 18:12:16 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

prog::testinit("RQuasiSymmetricFunctions"):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("combinat::submultisets"):
//////////////////////////////////////////////////////////////////////////////

experimental::RQuasiSymmetricFunctions: // To be removed ...

prog::test(combinat::submultisets::list([], 0),
           [[]]):
prog::test(combinat::submultisets::list([], 1),
           []):
prog::test(combinat::submultisets::list([], 2),
           []):
prog::test(combinat::submultisets::list([a], 0),
           [[]]):
prog::test(combinat::submultisets::list([a], 1),
           [[a]]):
prog::test(combinat::submultisets::list([a], 2),
           []):
prog::test(combinat::submultisets::list([a, a], 0),
           [[]]):
prog::test(combinat::submultisets::list([a, a], 1),
           [[a]]):
prog::test(combinat::submultisets::list([a, a], 2),
           [[a, a]]):
prog::test(combinat::submultisets::list([a, a], 3),
           []):
prog::test(combinat::submultisets::list([1, 2], 0),
           [[]]):
prog::test(combinat::submultisets::list([1, 2], 1),
           [[1], [2]]):
prog::test(combinat::submultisets::list([1, 2], 2),
           [[1, 2]]):
prog::test(combinat::submultisets::list([1, 2], 3),
           []):
prog::test(combinat::submultisets::list([1, 1, 2, 2, 2, 3], 0),
           [[]]):
prog::test(combinat::submultisets::list([1, 1, 2, 2, 2, 3], 1),
           [[1], [2], [3]]):
prog::test(combinat::submultisets::list([1, 1, 2, 2, 2, 3], 2),
           [[1, 1], [1, 2], [1, 3], [2, 2], [2, 3]]):
prog::test(combinat::submultisets::list([1, 1, 2, 2, 2, 3], 2),
           [[1, 1], [1, 2], [1, 3], [2, 2], [2, 3]]):
prog::test(combinat::submultisets::list([1, 1, 2, 2, 2, 3], 3),
           [[1, 1, 2], [1, 1, 3], [1, 2, 2], [1, 2, 3], [2, 2, 2], [2, 2, 3]]):
prog::test(combinat::submultisets::list([1, 1, 2, 2, 2, 3], 4),
           [[1, 1, 2, 2], [1, 1, 2, 3], [1, 2, 2, 2], [1, 2, 2, 3], [2, 2, 2, 3]]):
prog::test(combinat::submultisets::list([1, 1, 2, 2, 2, 3], 5),
           [[1, 1, 2, 2, 2], [1, 1, 2, 2, 3], [1, 2, 2, 2, 3]]):
prog::test(combinat::submultisets::list([1, 1, 2, 2, 2, 3], 6),
           [[1, 1, 2, 2, 2, 3]]):
prog::test(combinat::submultisets::list([1, 1, 2, 2, 2, 3], 7),
           []):


prog::test(combinat::generators::toList(combinat::submultisets::generatorOne([a, a, b, b, b], 0)),
           []):
prog::test(combinat::generators::toList(combinat::submultisets::generatorOne([a, a, b, b, b], 1)),
           []):
prog::test(combinat::generators::toList(combinat::submultisets::generatorOne([a, a, b, b, b], 2)),
           []):
prog::test(combinat::generators::toList(combinat::submultisets::generatorOne([a, a, b, b, b], 3)),
           [[a, b, b]]):
prog::test(combinat::generators::toList(combinat::submultisets::generatorOne([a, a, b, b, b], 4)),
           [[a, a, b, b], [a, b, b, b]]):
prog::test(combinat::generators::toList(combinat::submultisets::generatorOne([a, a, b, b, b], 5)),
           [[a, a, b, b, b]]):
prog::test(combinat::generators::toList(combinat::submultisets::generatorOne([a, a, b, b, b], 6)),
           []):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc("dimension"):
//////////////////////////////////////////////////////////////////////////////

N:=3:
M:=experimental::RQuasiSymmetricFunctions(0,N):
prog::test({M::dimension(d) - combinat::integerVectors::count(d, N) $ d = 0..8},
           {0}):

M:=experimental::RQuasiSymmetricFunctions(1,3):
// Coincides with [combinat::compositions::count(d, MaxLength=3) $d=0..10] ;
prog::test([M::dimension(d) $ d = 0..10],
           [1, 1, 2, 4, 7, 11, 16, 22, 29, 37, 46]):


//////////////////////////////////////////////////////////////////////////////
prog::testfunc("SymDimension"):
//////////////////////////////////////////////////////////////////////////////

M:=experimental::RQuasiSymmetricFunctions(0,0):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(0,1):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(0,2):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(0,3):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(0,4):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 3, 5, 6, 5, 3, 1, 0, 0, 0, 0]):

M:=experimental::RQuasiSymmetricFunctions(1,0):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(1,1):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(1,2):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(1,3):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 1, 2, 2, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(1,4):
prog::test([M::SymDimension(d) $ d = 0..12],
           [1, 0, 0, 1, 2, 5, 5, 5, 3, 1, 1, 0, 0]):

M:=experimental::RQuasiSymmetricFunctions(2,0):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(2,1):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(2,2):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(2,3):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 0, 0, 1, 1, 2, 1, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(2,4):
prog::test([M::SymDimension(d) $ d = 0..15],
           [1, 0, 0, 0, 0, 1, 1, 3, 3, 4, 4, 3, 2, 1, 1, 0]):

M:=experimental::RQuasiSymmetricFunctions(3,0):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(3,1):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(3,2):
prog::test([M::SymDimension(d) $ d = 0..10],
           [1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0]):
M:=experimental::RQuasiSymmetricFunctions(3,3):
prog::test([M::SymDimension(d) $ d = 0..15],
           [1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0]):
//////////////////////////////////////////////////////////////////////////////
prog::testfunc(experimental::RQuasiSymmetricFunctions.mu):
prog::testexit():
//////////////////////////////////////////////////////////////////////////////

prog::check(test, 3):


// Local Variables:
// mode: mupad
// End:
