export(combinat):

Search132 := 
proc(p : permutations)
    local i, j, k, n, res;
begin
    n := nops(p);
    for k from n downto 3 do
	for j from k-1 downto 2 do
	    if p[j] > p[k] then
		for i from j-1 downto 1 do
		    if p[i] < p[k] then
			return([k,j,i]);
		    end_if;
		end_for;
	    end_if;
	end_for;
    end_for;
    FAIL
end_proc:



CheckConj := 
proc()
    local i, j, k, p, pos, res, tmp;
begin
    for p in permutations::list(5) do
	pos := Search132(p);
	if pos <> FAIL then
//	    print(p, pos);
	    [k,i,j] := pos;    
	    res := [subsop(p, i=p[j], j=p[i]        ),
		    subsop(p,         j=p[k], k=p[j]),
		    subsop(p, i=p[k],         k=p[i]),
		    subsop(p, i=p[j], j=p[k], k=p[i]),
		    subsop(p, i=p[k], j=p[i], k=p[j]) ];
	    res := select(res, 
			  z -> _lazy_and((tmp := Search132(z)) <> FAIL,
					 integerVectors::_less(pos, tmp)));
	    if res <> [] then 
		print(p, pos, map(res, z -> [z,Search132(z)])); 
	    end_if;
	end_if;
    end_for;
end_proc:


// There exists two permutations of S5 such that the rightest pattern 132 is 
// rewritable in a permutation with a 132 pattern wich is at a rigther place. 
//   [1, 2, 5, 3, 4], [5, 3, 2], 
// [[[1, 4, 5, 3, 2], [5, 4, 1]], [[1, 5, 4, 3, 2], [5, 4, 1]]]

//   [2, 5, 1, 3, 4], [5, 2, 1], 
// [[[4, 5, 1, 3, 2], [5, 4, 3]], [[5, 4, 1, 3, 2], [5, 4, 3]]]


Patterns1 := 
proc(perm, patt)
    local n, l, gen, pos, res;
begin
    n := nops(perm);
    l := nops(patt);
    res := null();
    gen := combinat::subwords::generator([$1..n], l);
    while (pos := gen()) <> FAIL do
	if combinat::permutations::standard(map(pos, z-> perm[z])) = patt
	    then res := res, pos;
	end_if;
    end_while;
    [res];
end_proc:

alias(Gen = combinat::generators);
Patterns := 
proc (perm, patt) 
//    option escape;
begin
    Gen::toList(
	 Gen::select(
	      combinat::subwords::generator([$1..nops(perm)], nops(patt)),
		     pos -> (combinat::permutations::standard(map(pos, z-> perm[z]))			     = patt)));
end_proc;

HasPattern := 
proc(perm, patt)
    local n, l, gen, pos, res;
begin
    n := nops(perm);
    l := nops(patt);
    res := null();
    gen := combinat::subwords::generator([$1..n], l);
    while (pos := gen()) <> FAIL do
	if combinat::permutations::standard(map(pos, z-> perm[z])) = patt
	    then 
	    return(TRUE);
	end_if;
    end_while;
    FALSE;
end_proc:

patt := [3,6,4,1,5,2]; p := combinat::permutations::random(15), 
		  time((pat := Patterns(p, patt))), time((pat1 := Pattern
null();

