/*****************************************************************************
  $Id: IPC.tst,v 1.1.1.1 2003/09/15 16:37:46 nthiery Exp $
  File:		src/IPC/IPC.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'IPC'
  Created:	7/08/2002
  License:	LGPL
*****************************************************************************/

prog::testinit("IPC"):

if module::which(hold(IPC)) = FAIL then
    warning("module IPC not available; not checking the IPC library");
else

// Get around a kernel crash in MuPAD 2.0.0
// when the module stdmod is loaded before another module
%if version()=[2,0,0] then
    module::displace(stdmod):
end_if:

prog::testfunc(IPC::popen):
slave := IPC::popen("echo coucou", "r"):
out := IPC::slave::stdout(slave):
prog::test(IPC::getline(out), "coucou"):
prog::test(IPC::getline(out), null()):
IPC::close(slave):

prog::testfunc(IPC::popen2):
slave    := IPC::popen2("cat"):
slavein  := IPC::slave::stdin(slave):
slaveout := IPC::slave::stdout(slave):
IPC::putline(slavein, "coucou"):
prog::test(IPC::getline(slaveout), "coucou"):
IPC::close(slavein):
slave := extsubsop(slave, 2=FAIL):
prog::test(IPC::getline(slaveout), null()):
IPC::close(slave):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

// This is done at the end to ensure as much as possible of the
// package is initialized. A recursive prog::init(IPC)
// would be usefull here.

prog::testfunc(IPC):

prog::check(IPC, 3):

end_if:

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
