/**
|  File muEC.mu (muEC PACKAGE) Mardi 1 juillet 1997 08:05:50
|
|            The 'muEC' library - -EC main package.
|
| VP010797 VP221097 VP020498 VP290399
**/

/**
User Functions:

muEC::Banner         - displays the banner of the current release of -EC.

muEC::Version        - displays the current release number of -EC.

muEC::cat            - concatenates arguments and gives the corresponding expr.
**/

/*-
Algorithms for muEC are mainly from our own.
-*/

muEC := newDomain("muEC"):
muEC::info_str := "Library muEC: mu-EC main package":
muEC::interface := { Banner, Version, clearRememberTable, ERR, TYP, COMP, PART, SFA, SG, SYMF, SP, SYM }:

alias(path = pathname("MUEC")):
alias(loaddomain=prog::loaddomain):

// Flag for Satellite Packages...
muEC::IncludePack := TRUE:

// User Functions...

autoload(muEC::Banner):
autoload(muEC::Version):
muEC::mPrompt := "> ";

// Miscellaneous utilities for muEC

muEC::cat := 
    loadproc(muEC::cat,      		path, "muECmisc"):
muEC::SubSeq := 
    loadproc(muEC::SubSeq,		path, "muECmisc"):
muEC::clearRememberTable :=
    loadproc(muEC::clearRememberTable,	path, "muECmisc"):

/*---------------+
| muEC Libraries |
+---------------*/

muEC::ERR := 
    loaddomain(muEC::ERR, path, "ERR"):
muEC::TYP := 
    loaddomain(muEC::TYP, path, "TYP"):
muEC::COMP := 
    loaddomain(muEC::COMP, path, "COMP"):
muEC::PART := 
    loaddomain(muEC::PART, path, "PART"):
muEC::SFA := 
    loaddomain(muEC::SFA, path, "SFA"):
muEC::SG := 
    loaddomain(muEC::SG, path, "SG"):
muEC::SYMF := 
    loaddomain(muEC::SYMF, path, "SYMF"):
muEC::SP :=
    loaddomain(muEC::SP, path, "SP"):
muEC::SYM := 
    loaddomain(muEC::SYM, path, "SYM"):
unalias(path):

/*-----------------+
| Some Preferences |
+-----------------*/
/*
Pref::prompt:=TRUE:
Pref::promptString:=muEC::mPrompt:
Banner():
*/

null():
