/**
|  File COMP.mu (muEC::COMP PACKAGE) Vendredi 27 juin 1997 09:17:22
|
|            The 'muEC::COMP' library for manipulating compositions.
|
| VP270697 VP020498
**/

/**
User Functions:

muEC::COMP::CompCompo         - CompCompo(c1,c2,ord) tests if the composition c1 is
                          greater than the composition c2, for the ord
                          ordering.

muEC::COMP::Compo2Conjugate   - returns the conjugate composition.

muEC::COMP::Compo2Mat         - returns a planar diagram of the argument.

muEC::COMP::Compo2MajorIndex  - computes the major index associated to a
                          composition.

muEC::COMP::ListCompo         -  returns the list of all compositions of the
                           argument. Several options are available.

muEC::COMP::ListCompoFatter   - computes the list of compositions fatter than the
                          argument.

muEC::COMP::ListCompoFiner    - computes the list of compositions finer than the
                          argument.

Compositions are encoded by integer lists.
**/

/**
Algorithms for COMP are mainly from my own.
**/

muEC::COMP := newDomain("COMP"):
muEC::COMP::info := "Library COMP: manipulating COMPositions encoded ".
                "as lists of integers.":
muEC::COMP::interface := {CompCompo, Compo2Conjugate, Compo2Mat,
                          Compo2MajorIndex, ListCompo, ListCompoFatter,
                          ListCompoFiner }:

alias(path = pathname("MUEC", "COMP")):

muEC::COMP::CompCompo        := loadproc(muEC::COMP::CompCompo,        path, "CmprComp"):
muEC::COMP::Compo2Conjugate  := loadproc(muEC::COMP::Compo2Conjugate,  path, "Comp2Cjg"):
muEC::COMP::Compo2Mat        := loadproc(muEC::COMP::Compo2Mat,        path, "Comp2Mat"):
muEC::COMP::Compo2MajorIndex := loadproc(muEC::COMP::Compo2MajorIndex, path, "Cp2MjIdx"):
muEC::COMP::ListCompo        := loadproc(muEC::COMP::ListCompo,        path, "ListComp"):
muEC::COMP::ListCompoFatter  := loadproc(muEC::COMP::ListCompoFatter,  path, "LstCpFat"):
muEC::COMP::ListCompoFiner   := loadproc(muEC::COMP::ListCompoFiner,   path, "LstCpFnr"):

unalias(path):
