/*
|  File CmprComp (COMP PACKAGE) Jeudi 22 mai 1997 17:24:09
|
|  CompCompo(c1,c2,ord)	tests if the composition c1 is greater than 
|			the composition c2, for the ord ordering.
*/

/*
|  Finer ordering
|  VP220597
*/
muEC::COMP::IsFinerTest := proc(n,p)
local
  i; /* var for seq... */
begin
  if (n<0) then
    -1;
  elif (n=args(3)) then
    p+1;
  else
    muEC::COMP::IsFinerTest(n-args(3), p+1, (args(i) $ i=4..args(0)));
  end_if;
end_proc:

/*
|  VP220597
*/
muEC::COMP::IsFinerCompo:= proc(I1,I2)
local
  ltest; /* finer test... */
begin
  if (nops(I1)=0) and (nops(I2)=0) then
    TRUE;
  else
    ltest := muEC::COMP::IsFinerTest(I2[1],0,op(I1));
    if (ltest = -1) then
      FALSE;
    else
      muEC::COMP::IsFinerCompo([op(I1, ltest+1..nops(I1))], [op(I2, 2..nops(I2))]);
    end_if;
  end_if;
end_proc:

/*
|  VP220597
*/
muEC::COMP::CompCompo_core:=proc(comp1,comp2,kind)
local
  i,  /* variable for loop... */
  n,  /* common size...       */
  n1, /* size of comp1...     */
  n2; /* size of comp2...     */
begin
  n1 := nops(comp1);
  n2 := nops(comp2);
  if (kind = hold(lexic)) then
    n := min(n1,n2);
    for i from 1 to n do
      if (comp1[i] > comp2[i]) then
        return(TRUE);
      elif (comp2[i] > comp1[i]) then
        return(FALSE);
      end_if;
    end_for;
  elif (kind = hold(cixel)) then
    n := min(n1,n2);
    for i from 0 to n-1 do
      if (comp1[n1-i] > comp2[n2-i]) then
        return(TRUE);
      elif (comp2[n2-i] > comp1[n1-i]) then
        return(FALSE);
      end_if;
    end_for;
  elif (kind = hold(finer)) then
    return(muEC::COMP::IsFinerCompo(comp2, comp1));
  end_if;
  _if(n1 >= n2, TRUE, FALSE);
end_proc:

/*
|  VP220597
*/
muEC::COMP::CompCompo_check:=proc(comp1,comp2,kind)
begin
  /* checking types... */
  if (not muEC::TYP::IsCompo(comp1)) then
    muEC::ERR::COMPPerror(1,procname);
  elif (not muEC::TYP::IsCompo(comp2)) then
    muEC::ERR::COMPPerror(3,procname);
  elif (not(type(kind) = DOM_IDENT)) then
    muEC::ERR::COMPPerror(5,procname);
  elif (kind<>hold(lexic) and kind<>hold(cixel) and kind<>hold(finer)) then
    muEC::ERR::COMPPerror(6,procname);
  end_if;
end_proc:

/*
|  VP200597
*/
muEC::COMP::CompCompo := proc(compo)
begin
  if testargs() then
    muEC::COMP::CompCompo_check(args());
  end_if;
  muEC::COMP::CompCompo_core(args());
end_proc:

