/*
|  File Comp2Cjg (COMP PACKAGE) Lundi 19 mai 1997 14:51:13
|
|  Compo2Conjugate(comp) returns the conjugate composition.
|
|  VP190597
*/
muEC::COMP::Compo2Conjugate_core := proc(comp)
local
    i,      /* variable for sequence... */
    j,      /* variable for sequence... */
    k,      /* variable for sequence... */
    n,      /* nops variable...         */
    coofcp, /* misc...                  */
    cocjg;  /* misc...                  */
begin
  if (comp = []) then
    [];
  else
    n := nops(comp);
    coofcp := [_plus(op(comp,1..j))-j+1 $ j=1..n]; /* faire un op(comp, .. */
    cocjg  := [(i $ k=1..(coofcp[n-i+1]-coofcp[n-i])) $ i=1..n-1,
               n $ j=1..coofcp[1]];
    append([cocjg[1]], (cocjg[i]-cocjg[i-1]+1 $ i=2..nops(cocjg)));
  end_if;
end_proc:
/*
|  Argument verification...
|  VP200597
*/
muEC::COMP::Compo2Conjugate_check := proc(comp)
begin
  if (not muEC::TYP::IsCompo(comp)) then
    muEC::ERR::COMPPerror(1,procname); /* Wrong type for first argument... */
  end_if;
end_proc:

/*
|  VP200597
*/
muEC::COMP::Compo2Conjugate := proc(compo)
begin
  if testargs() then
    muEC::COMP::Compo2Conjugate_check(args());
  end_if;
  muEC::COMP::Compo2Conjugate_core(args());
end_proc:
