/*
|  File Comp2Mat (COMP PACKAGE) Lundi 19 mai 1997 14:53:04
| 
|  Compo2Mat(compo) returns a `visual' matrix of the composition compo.
|                   (also called the diagram of compo).
|  VP190597
*/

muEC::COMP::Compo2Mat_alpha := proc(compo, alphbt)
local
  i,   /* variable for loop and sequence... */
  j,   /* variable for loop and sequence... */
  mat, /* result...                         */
  vid, /* misc...                           */
  nl,  /* number of lines...                */
  nc;  /* number of columns...              */
begin
  nl  := nops(compo);
  nc  := compo[1] + _plus(op(compo,2..nl))-nl+1;
  mat := array(1..nl, 1..nc, [[alphbt[3] $ i=1..nc] $ j=1..nl]);
  for i from 1 to nl do
    vid := _plus(op(compo, i+1..nl))-nl+i;
    for j from 1 to vid do
      mat[nl+1-i, j] := alphbt[2];
    end_for;
    for j from vid+1 to vid+compo[i] do
      mat[nl+1-i, j] := alphbt[1];
    end_for;
  end_for;
  mat:
end_proc:
/*
|  We treat options...
|  VP190597
*/
muEC::COMP::Compo2Mat_core := proc(compo)
local
  i,               /* variable for sequence... */
  abt,             /* misc...                  */
  alphbt;          /* alphabet...              */
begin
  alphbt := [1,0,0]; /* default value...         */
  if (args(0) >= 2) then
    if (type(args(2)) = "_equal") then  /* this is the alphabet... */
      abt := op(args(2), 2);
      alphbt := append([op(abt,1..nops(abt))], 0 $ i=nops(abt)..3);
    end_if;
  end_if;
  muEC::COMP::Compo2Mat_alpha(compo, alphbt); /* the real call...        */
end_proc:

/*
|  Argument verification...
|  VP200597
*/
muEC::COMP::Compo2Mat_check:=proc(compo)
begin
  if (not muEC::TYP::IsCompo(compo)) then
    muEC::ERR::COMPPerror(1,procname);   /* Wrong type for first argument...   */
  elif (args(0) >= 2) then
    if (type(args(2)) <> "_equal") then
      muEC::ERR::COMPPerror(3,procname); /* Wrong type for second argument...  */
    elif  (op(args(2), 1) <> hold(alphabet)) then
      muEC::ERR::COMPPerror(3,procname); /* Wrong type for second argument...  */
    elif (type(op(args(2), 2)) <> DOM_LIST) then
      muEC::ERR::COMPPerror(3,procname); /* Wrong type for second argument...  */
    elif (nops(op(args(2), 2)) < 1 or nops(op(args(2), 2)) > 3) then
      muEC::ERR::COMPPerror(4,procname); /* Wrong range for second argument... */
    end_if;
  end_if;
end_proc:

/*
|  VP200597
*/
muEC::COMP::Compo2Mat := proc(compo)
begin
  if testargs() then
    muEC::COMP::Compo2Mat_check(args());
  end_if;
  muEC::COMP::Compo2Mat_core(args());
end_proc:
