/*
|  File Dgl2Part (PART PACKAGE) Vendredi 30 mai 1997 10:25:29
|
|  Diagonal2Part(l) with l=[dl,o] returns the partition associated to the
|                   diagonal list dl, with o, origin of the tableau.
*/

/*
|  VP300597
*/
muEC::PART::Diagonal2Part_core := proc(l)
local
  i,    /* var for loop...      */
  dl,   /* list of diagonals... */
  o,    /* origin...            */
  dgl,  /* misc...              */
  res;  /* the result...        */
begin
  dl   := op(l, 1);
  o    := op(l, 2);
  res  := null();
  dgl  := [0,op(dl),0];
  for i from 1 to o do
    if (dgl[i+1] - dgl[i]) = 0 then
      res := res, 1;
    else 
      res := res, 0;
    end_if;
  end_for;
  for i from o+1 to nops(dgl)-1 do
    if (dgl[i+1] - dgl[i]) = 0 then
      res := res, 0;
    else 
      res := res, 1;
    end_if;
  end_for;
  muEC::PART::Border2Part([res]);
end_proc:

/*
|  VP300597
*/
muEC::PART::Diagonal2Part_check := proc(l)
begin
  if not (muEC::TYP::IsDiagonal(l)) then
    muEC::ERR::PARTPerror(1,procname);  /* Wrong type for first argument... */
  end_if;
end_proc:

/*
|  VP300597
*/
muEC::PART::Diagonal2Part := proc(l)
begin
  if testargs() then
    muEC::PART::Diagonal2Part_check(args());
  end_if;
  muEC::PART::Diagonal2Part_core(args());
end_proc:

