/*
|  File Exp2Part (PART PACKAGE) Wed Apr 22 08:52:51 MET DST 1998
*/

/*
|  Exp2Part(vect) returns the partition associated to the given exponential
|                 notation.
|  VP220498
*/
muEC::PART::Exp2Part_core := proc(vect)
local
    n, /* nops(vect)...  */
    i; /* var for seq... */
begin
  n := nops(vect);
  /*[_seqgen((n-i)$vect[n-i], i=0..n-1)];*/
  [_seqgen((n-i)$vect[n-i], i,0..n-1)];
/*[(n-i)$vect[n-i] $i=0..n-1];*/
end_proc:
/*
|  VP220498
*/
muEC::PART::Exp2Part_check := proc(vect)
begin
  if not _and(op(map(vect, testtype, Type::NonNegInt))) then
    muEC::ERR::PARTPerror(1, procname) /* wrong type for first argument... */
  end_if;
end_proc:
/*
|  VP220498
*/
muEC::PART::Exp2Part := proc(vect)
begin
  if testargs() then
    muEC::PART::Exp2Part_check(args());
  end_if;
  muEC::PART::Exp2Part_core(args());
end_proc:
