/*
|  File Frb2Part (PART PACKAGE) Vendredi 30 mai 1997 10:49:55
|
|  Frob2Part(frob) This function converts Frobenius notation to standard
|                  notation for partitions.
*/

/*
|  VP300597
*/
muEC::PART::Frob2Part_core := proc(frob)
local
  i, /* var for seq... */
  n; /* misc.          */
begin
  n := nops(op(frob, 1));
  [_seqgen(op(op(frob, 1), i)+i, i , 1..n),
   op(muEC::PART::Part2Conjugate([_seqgen(op(op(frob, 2), i)+i-n, i , 1..n)]))];
end_proc:

/*
|  VP300597
*/
muEC::PART::Frob2Part_check := proc(frob)
begin
  if (not (testtype(frob,DOM_LIST) and nops(frob)=2)) then
    muEC::ERR::PARTPerror(1,procname); /* Wrong type for first argument... */
  end_if;
  if (not (muEC::TYP::IsPart_with0(op(frob, 1)) and muEC::TYP::IsPart_with0(op(frob, 2))))
  then
    muEC::ERR::PARTPerror(2,procname); /* Wrong range for first argument... */
  end_if;
end_proc:

/*
|  VP300597
*/
muEC::PART::Frob2Part := proc(frob)
begin
  if testargs() then
    muEC::PART::Frob2Part_check(args());
  end_if;
  muEC::PART::Frob2Part_core(args());
end_proc:

