/*
|  File PCoreQuo (PART PACKAGE) Wed Apr 22 09:12:55 MET DST 1998
*/
/*
|  Part2PCore(part, p)  returns a list, whose first component is the
|                       p-core of partition part, remaining components
|                       being the p-quotients of part.
|  AL230298 VP20498
*/
muEC::PART::Part2PCore_core := proc(pa, p)
local
    i,    /* var for seq...                                 */
    j,    /* var for seq...                                 */
    co,   /* the core...                                    */
    part, /* the new partition...                           */
    n,    /* nops(part)...                                  */
    w,    /* list of lists, classified by remainders / p... */
    v;
begin
  part := [op(pa), 0$(p-irem(nops(pa),p) )];
  n := nops(part);
  v := [_seqgen(part[i]+n-i, i,1..n)];
  w := [_seqgen(select(v,proc(vl,p,i) begin bool(vl mod p=i) end_proc, p, i),
                i,0..p-1)];
  sort(map(w,proc(l,p) local j;  begin
           _seqgen((j-1)*p + (l[j] mod p),j,1..nops(l)) end_proc,p));
  co := sort(subs([_seqgen(%[i]-(i-1), i,1..nops(%))],0=null()),
              proc(x,y) begin bool(x>=y) end_proc);
  subs(
  [co, _seqgen([_seqgen(iquo(op(w[i],j),p)-nops(w[i])+j,j,1..nops(w[i]))],
               i,1..p)], 0=null());
end_proc:
/*
|  type checking
|  VP220498
*/
muEC::PART::Part2PCore_check := proc(part, p)
begin
  if (not muEC::TYP::IsPart(part)) then
    muEC::ERR::PARTPerror(1, procname);          /* wrong type 1st argument... */
  elif (not testtype(p, Type::PosInt)) then
    muEC::ERR::PARTPerror(3, procname);          /* wrong type 3rd argument... */
  end_if;
end_proc:
/*
|  VP220498
*/
muEC::PART::Part2PCore := proc(part, p)
begin
  if testargs() then
    muEC::PART::Part2PCore_check(args());
  end_if;
  muEC::PART::Part2PCore_core(args());
end_proc:
