/*
|  File Part2Cjg (PART PACKAGE) Lundi 30 juin 1997 18:13:32
|
|  Part2Conjugate(part) returns the conjugate partition.
|                       The partition is in decreasing order.
*/

/*
| VP300697
*/
muEC::PART::Part2Conjugate_core := proc(part)
local
  i, /* var for seq...                 */
  j, /* var for seq...                 */
  k, /* var for seq...                 */
  l; /* the length of the partition... */
begin
  if (part = []) then
    [];
  else 
    l := nops(part);
    [_seqgen(l, j,1..part[l]),
     _seqgen(_seqgen(-i, k,1..(part[(-i)]-part[(-i)+1])),i,-l+1..-1)];
  end_if;
end_proc:

/*
|  VP300697
|  Type Checking.
*/
muEC::PART::Part2Conjugate_check := proc(part)
begin
  if (not muEC::TYP::IsPart(part)) then
    muEC::ERR::PARTPerror(1,procname) /* Wrong type for first argument... */
  end_if;
end_proc:

/*
|  VP300697
*/
muEC::PART::Part2Conjugate := proc(part)
begin
  if testargs() then
    muEC::PART::Part2Conjugate_check(args());
  end_if;
  muEC::PART::Part2Conjugate_core(args());
end_proc:
