/*
|  File Part2Dgl (PART PACKAGE) Lundi 30 juin 1997 18:20:46
|
|  Part2Diagonal(lambda) returns the list of diagonals of the partition
|                        lambda  and the position of tableau's origin at the
|                        end of the list.
*/

/*
|  VP300697
*/
muEC::PART::Part2Diagonal_core := proc(lambda)
local
  i,    /* var for loop... */
  d,    /* diagonal...     */
  orig, /* origin...       */
  bord, /* border...       */
  res;  /* the result...   */
begin
  d    := 0;
  res  := null();
  orig := nops(lambda);
  bord := muEC::PART::Part2Border(lambda);
  for i from 1 to orig do
    if (bord[i] = 0) then
      d := d+1;
    end_if;
    res := res, d;
  end_for;
  for i from orig+1 to nops(bord)-1 do
    if (bord[i] = 1) then
      d := d-1;
    end_if;
    res := res, d;
  end_for;
  [[res], orig];
end_proc:

/*
|  VP300697
|  Type Checking.
*/
muEC::PART::Part2Diagonal_check := proc(lambda)
begin
  if (not muEC::TYP::IsPart(lambda)) then
    muEC::ERR::PARTPerror(1,procname); /* Wrong type for first argument... */
  end_if;
end_proc:

/*
|  VP300697
*/
muEC::PART::Part2Diagonal := proc(lambda)
begin
  if testargs() then
    muEC::PART::Part2Diagonal_check(args());
  end_if;
  muEC::PART::Part2Diagonal_core(args());
end_proc:
