/*
|  File Part2Frb (PART PACKAGE) Lundi 30 juin 1997 18:32:46
|
|  Part2Frob(lambda)  This function gives Frobenius notation of the partition
|                     lambda 
*/

/*
|  VP300697
*/
muEC::PART::Part2Frob_core := proc(lambda) 
local 
  i,     /* var for loop... */
  j,     /* var for seq...  */
  n,     /* nops var...     */
  list1, /* left list...    */
  list2; /* right list...   */
begin
  n := nops(lambda);
  for i from 1 to n do
    if (op(lambda, i)-i < 0) then
      n := i-1;
      break;
    end_if;
  end_for;
  list1 := _seqgen(op(lambda, j)-j, j,1..n);
  list2 := [op(muEC::PART::Part2Conjugate(lambda), 1..n)];
  list2 := _seqgen(op(list2, j)-j, j,1..n);
  [[list1], [list2]];
end_proc:

/*
|  VP300697
|  Type Checking.
*/
muEC::PART::Part2Frob_check:=proc(lambda)
begin
  if (not muEC::TYP::IsPart(lambda)) then 
    muEC::ERR::PARTPerror(1,procname) /* Wrong type for first argument... */
  end_if;
end_proc:

/*
|  VP300697
*/
muEC::PART::Part2Frob := proc(lambda)
begin
  if testargs() then
    muEC::PART::Part2Frob_check(args());
  end_if;
  muEC::PART::Part2Frob_core(args());
end_proc:
