/*
|  File Part2LHk (PART PACKAGE) Lundi 30 juin 1997 18:39:55
|
|  Part2ListHook(mu) returns the list of hook-lengths of lambda.
|
|  Part2ListHook(mu,z) returns the Jack-hook-product.
|
|  Part2ListHook(mu,q,t) returns the two-variable hook polynomial.
*/

/*
|  VP300697 
*/
muEC::PART::Part2ListHook_core:=proc(mu)
local
  nu,  /* w partition...  */
  z,w, i, j; /* some vars...    */
begin
  nu := muEC::PART::Part2Conjugate(mu);
  if (args(0) = 1) then
    sort([mu[i]-i+nu[j]-j+1 $ j=1..mu[i] $i=1..nops(mu)],
         proc( x, y) begin bool(x>y) end_proc );
  elif (args(0) = 2) then
    z := args(2);
    _mult(z*(mu[i]-j)+nu[j]-i+1 $ j=1..mu[i] $ i=1..nops(mu));
  else
    z := args(2);
    w := args(3);
    _mult(1-z^(mu[i]-j)*w^(nu[j]-i+1) $ j=1..mu[i] $ i=1..nops(mu));
  end_if;
end_proc:

/*
|  VP300697
|  Type Checking.
*/
muEC::PART::Part2ListHook_check:=proc(mu)
begin
  if not (muEC::TYP::IsPart(mu)) then
    muEC::ERR::PARTPerror(1,procname) /* Wrong type for first argument... */
  end_if;
end_proc:

/*
|  VP300697
*/
muEC::PART::Part2ListHook := proc(mu)
begin
  if testargs() then
    muEC::PART::Part2ListHook_check(args());
  end_if;
  muEC::PART::Part2ListHook_core(args());
end_proc:
