/*
|  File Part2Mat (PART PACKAGE) Lundi 30 juin 1997 18:49:56
|
|  Part2Mat(part) returns a `visual' matrix of the partition part.
*/

/*
|  VP300697
*/
muEC::PART::Part2Mat_alpha := proc(part, alphbt)
local
  i,   /* var for loop and seq... */
  j,   /* var for loop and seq... */
  mat, /* result...               */
  nl,  /* number of lines...      */
  nc;  /* number of columns...    */
begin
  nl  := nops(part);
  nc  := part[1];
  mat := array(1..nl, 1..nc, [_seqgen([_seqgen(alphbt[2], i,1..nc)],j,1..nl)]);
  for i from 1 to nops(part) do
    for j from 1 to part[i] do
      mat[nl+1-i, j] := alphbt[1];
    end_for;
  end_for;
  eval(mat);
end_proc:

/*
|  VP300697
*/
muEC::PART::Part2Mat_core := proc(part)
local
  i,      /* var for seq... */
  abt,    /* misc...        */
  alphbt; /* alphabet...    */
begin
  alphbt := [1,0]; /* default value... */
  if (args(0) >= 2) then
    if (testtype(args(2),"_equal")) then /* this is the alphabet... */
      abt := op(args(2), 2);
      alphbt := [op(abt, 1..nops(abt)),_seqgen(0, i,nops(abt)..2)];
    end_if;
  end_if;
  muEC::PART::Part2Mat_alpha(part, alphbt);
end_proc:

/*
|  VP300697
|  Type Checking.
*/
muEC::PART::Part2Mat_check:=proc(part)
begin
  if not (muEC::TYP::IsPart(part)) then
    muEC::ERR::PARTPerror(1,procname); /* Wrong type for first argument... */
  elif (args(0) >= 2) then
    if (not testtype(args(2),"_equal")) then
      muEC::ERR::PARTPerror(3,procname); /* Wrong type for second argument... */
    elif (op(args(2), 1) <> hold(alphabet)) then
      muEC::ERR::PARTPerror(3,procname); /* Wrong type for second argument... */
    elif (not testtype(op(args(2), 2), DOM_LIST)) then
      muEC::ERR::PARTPerror(3,procname); /* Wrong type for second argument... */
    elif (nops(op(args(2), 2)) < 1 or nops(op(args(2), 2)) > 2) then
      muEC::ERR::PARTPerror(4,procname); /* Wrong range for second argument... */
    end_if;
  end_if;
end_proc:

/*
|  VP300697
*/
muEC::PART::Part2Mat := proc(part)
begin
  if testargs() then
    muEC::PART::Part2Mat_check(args());
  end_if;
  muEC::PART::Part2Mat_core(args());
end_proc:
