/*
|  File SkPa2Mat (PART PACKAGE) Lundi 30 juin 1997 19:01:10
|
|  SkewPart2Mat(skp) returns a `visual' matrix of the skew partition skp.
*/

/*
| VP300697
*/
muEC::PART::SkewPart2Mat_alpha := proc(skew, alphbt)
local
  i,   /* var for loop and seq... */
  j,   /* var for loop and seq... */
  mat, /* result...               */
  nl,  /* number of lines...      */
  nc;  /* number of columns...    */
begin
  nl  := nops(op(skew, 1));
  nc  := op(op(skew, 1), 1);
  mat := array(1..nl, 1..nc, [_seqgen([_seqgen(alphbt[3], i,1..nc)],j,1..nl)]);
  for i from 1 to nops(op(skew, 2)) do
    for j from 1 to op(op(skew, 2), i) do
      mat[nl+1-i, j] := alphbt[2];
    end_for;
    for j from op(op(skew, 2), i)+1 to op(op(skew, 1), i) do
      mat[nl+1-i, j] := alphbt[1];
    end_for;
  end_for;
  for i from nops(op(skew, 2))+1 to nl do
    for j from 1 to op(op(skew, 1), i) do
      mat[nl+1-i, j] := alphbt[1];
    end_for;
  end_for;
  eval(mat);
end_proc:

/*
|  VP300697
*/
muEC::PART::SkewPart2Mat_core := proc(skew)
local
  i,                 /* variable for sequence... */
  abt,               /* misc... */
  alphbt;            /* alphabet... */
begin
  alphbt := [1,0,0]; /* default value... */
  if (args(0) >= 2) then
    if (testtype(args(2),"_equal")) then /* this is the alphabet... */
      abt := op(args(2), 2);
      alphbt := [op(abt, 1..nops(abt)),_seqgen(0,i,nops(abt)..3)];
    end_if;
  end_if;
  muEC::PART::SkewPart2Mat_alpha(skew, alphbt);
end_proc:

/*
|  VP300697
|  Type Checking.
*/
muEC::PART::SkewPart2Mat_check:=proc(skew)
begin
  if not (muEC::TYP::IsSkewPart(skew)) then
    muEC::ERR::PARTPerror(1,procname); /* Wrong type for first argument... */
  elif (args(0) >= 2) then
    if not (testtype(args(2),"_equal")) then
      muEC::ERR::PARTPerror(3,procname); /* Wrong type for second argument... */
    elif (op(args(2), 1) <> hold(alphabet)) then
      muEC::ERR::PARTPerror(3,procname); /* Wrong type for second argument... */
    elif not (testtype(op(args(2), 2),DOM_LIST)) then
      muEC::ERR::PARTPerror(3,procname); /* Wrong type for second argument... */
    elif (nops(op(args(2), 2)) < 1) or (nops(op(args(2), 2)) > 3) then
      muEC::ERR::PARTPerror(4,procname); /* Wrong range for second argument... */
    end_if;
  end_if;
end_proc:

/*
|  VP300697
*/
muEC::PART::SkewPart2Mat := proc(skew)
begin
  if testargs() then
    muEC::PART::SkewPart2Mat_check(args());
  end_if;
  muEC::PART::SkewPart2Mat_core(args());
end_proc:
