/*
|  File SpltPart (PART PACKAGE) Wed Apr 22 09:43:53 MET DST 1998
*/

/*
|  SplitPart(part) gives all possibilities of splitting part into 2 partitions
|  SplitPart(part, n) gives all possibilities of splitting part into n
|                     partitions J.k such that Union(J.k) = part .
|  VP220498
*/
muEC::PART::SplitPart_interface := proc(part,n)
local
  l, j, r;   /* nops(part)... */
begin
  l := nops(part);
  if (l = 0) then
      { [ [] $ n ] };
  else
    {subsop(r, j=[part[1], op(op(r,j))]) $ j=1..n 
            $ r in muEC::PART::SplitPart_interface([op(part, 2..l)], n) };
  end_if;
end_proc:

/*
|  VP220498
*/
muEC::PART::SplitPart_check := proc(part)
begin
  if (not muEC::TYP::IsPart(part)) then
    muEC::ERR::PARTPerror(1, procname) /* wrong type for first argument... */
  elif (args(0) >= 2) then
    if (not testtype(args(2), Type::PosInt)) then
      muEC::ERR::PARTPerror(3, procname) /* wrong type for second argument... */
    end_if;
  end_if;
end_proc:
/*
|  VP220498
*/
muEC::PART::SplitPart_core := proc(part)
local
  n; /* number of partitions... */
begin
  if (args(0) >= 2) then
    n := args(2);
  else
    n := 2; /* default value... */
  end_if;
  muEC::PART::SplitPart_interface(part, n);
end_proc:
/*
|  VP220498
*/
muEC::PART::SplitPart := proc(part)
begin
  if testargs() then
    muEC::PART::SplitPart_check(args());
  end_if;
  muEC::PART::SplitPart_core(args());
end_proc:
