/**
|  File SFA.mu (muEC::SFA PACKAGE) Sun Apr 26 13:23:25 MET DST 1998
|
|            The 'muEC::SFA' library for manipulating
|            Symmetric Functions over different Alphabets.
|
| VP260498
**/

/**
User Functions:

**/

/**
Algorithms for SFA are from my own.
**/

muEC::SFA            := newDomain("SFA"):
muEC::SFA::info      := "Library SFA: manipulating Symmetric Functions over different Alphabets":
muEC::SFA::interface := { Pol2SfA, Sf2SfA, SfA2Sf, SfA2TableVar, SfACollect,
                      SfAExpand, SfAOmega, SfAVars, ToeA, TohA, TomA, TopA,
                      TosA
                     }:

muEC::SFA::SFAAlgBases := [ hold(e), hold(h), hold(p) ]:
muEC::SFA::SFABases    := [op(muEC::SFA::SFAAlgBases), hold(m), hold(s) ]:
muEC::SFA::SFAVars     := {}:

/*
  seq(protect(k,Error), k=muEC::SFA::SFABases):
  seq(protect(k,Warning), k=muEC::SFA::SFABases):
*/

alias(path = pathname("MUEC", "SFA")):

muEC::SFA::AllIndexed   := loadproc(muEC::SFA::AllIndexed   , path, "AllIndA" ):
muEC::SFA::IndetsA      := loadproc(muEC::SFA::IndetsA      , path, "AllIndA" ):
muEC::SFA::MonomialA    := loadproc(muEC::SFA::MonomialA    , path, "Monomial"):
muEC::SFA::Pol2SfA      := loadproc(muEC::SFA::Pol2SfA      , path, "Pol2SfA" ):
muEC::SFA::Sf2SfA       := loadproc(muEC::SFA::Sf2SfA       , path, "Sf2SfA"  ):
muEC::SFA::SfA2Sf       := loadproc(muEC::SFA::SfA2Sf       , path, "SfA2Sf"  ):
muEC::SFA::SfA2TableVar := loadproc(muEC::SFA::SfA2TableVar , path, "SfAVar"  ):
muEC::SFA::SfACollect   := loadproc(muEC::SFA::SfACollect   , path, "SfAColct"):
muEC::SFA::SfAExpand    := loadproc(muEC::SFA::SfAExpand    , path, "SfAExpn" ):
muEC::SFA::SfAOmega     := loadproc(muEC::SFA::SfAOmega     , path, "SfAOmega"):
muEC::SFA::SfAVars      := loadproc(muEC::SFA::SfAVars      , path, "SfAVars" ):
muEC::SFA::ToeA         := loadproc(muEC::SFA::ToeA         , path, "ToSfA"   ):
muEC::SFA::TohA         := loadproc(muEC::SFA::TohA         , path, "ToSfA"   ):
muEC::SFA::TomA         := loadproc(muEC::SFA::TomA         , path, "ToSfA"   ):
muEC::SFA::TopA         := loadproc(muEC::SFA::TopA         , path, "ToSfA"   ):
muEC::SFA::TosA         := loadproc(muEC::SFA::TosA         , path, "ToSfA"   ):

unalias(path):
