/*
|  File AllIndA (SFA PACKAGE) Sun Apr 26 13:49:52 MET DST 1998
*/

/*
|  AllIndexed(poly,b) assuming that poly is expressed on base b[], it returns
|                     the set of all indices appearing in poly as b[...].
|  VP260498
*/
/*
|  IndetsA(pol) returns all b[..](..).
|  VP260498
*/
muEC::SFA::IndetsA := proc(pol)
local
  i; /* var for seq... */
begin
  if testtype(pol,"_plus") or testtype(pol,"_mult") then
    _union(muEC::SFA::IndetsA(op(pol,i)) $ i=1..nops(pol));
  elif testtype(pol,"_power") then
    muEC::SFA::IndetsA(op(pol,1));
  elif testtype(pol,"function") and  testtype(op(pol,0),"_index") then
    {pol};
  else
    {};
  end_if
end_proc:

/*
|  VP270498
*/
muEC::SFA::AllIndexed := proc(pol,b)
local
  r, /* the result...             */
  f, /* a function...             */
  g, /* indeterminates...         */
  i; /* var for indeterminates... */
begin
  if has(muEC::SFA::SFABases, b) then
    f :=  muEC::cat("muEC::TYP::Is",b,"A");
  else
    f := proc(x) begin bool(op(op(x,0),1)=b) end_proc ;
  end_if;
  if testtype(pol,"_plus") or testtype(pol,"_mult") then
    r := {};
    g := muEC::SFA::IndetsA(pol);
    for i in g do
      if (level(eval(f(i)),2)) then
        r := r union {[[op(op(i,0),2..nops(op(i,0)))],op(i)]};
      end_if;
    end_for;
    r;
  elif testtype(pol,"_power") then
    muEC::SFA::AllIndexed(op(pol,1),b);
  else
    if level(eval(f(pol)),2) then
      {[[op(op(pol,0),2..nops(op(pol,0)))],op(pol)]};
    else
      {};
    end_if;
  end_if;
end_proc:  
