/*
|  File Pol2SfA (SFA PACKAGE) Mon Apr 27 10:11:26 MET DST 1998
*/

/*
| Pol2SfA(pol, vlist)  converts any symmetric polynomial in the variables
|                      specified in vlist into a monomial function of SFA.
|  VP270498
*/
muEC::SFA::Pol2SfA_core := proc(pol, vlist)
local
  pos,    /* an indice... */
  i,      /* var for seq... */
  k,      /* var for seq... */
  c,      /* a coefficient... */
  mn,     /* a monom... */
  alphab, /* alphabet... */
  part;   /* a partition... */
begin
  alphab := _plus(op(vlist));
  if testtype(pol, "_plus") then
    map(pol, muEC::SFA::Pol2SfA, vlist);
  elif testtype(pol, "_power") then
    k := contains(vlist, op(pol,1));
    if k<>0 then
      if (k=1) then
        hold(m)[op(pol,2)](alphab);
      else
        0;
      end_if;
    else
      pol;
    end_if;
  elif testtype(pol, "_mult") then
    mn := lmonomial(pol,vlist);
    c := coeff(mn, vlist);  
    part := [_seqin(degree(mn, i), i,vlist)];
    pos := contains(part,0);
    if pos<>0 then
      if (subs([op(part, pos..nops(vlist))],0=null()) <> []) then
        0;
      else
        part := subs(part, 0=null());
        if (part=[]) then
          c;
        elif muEC::TYP::IsPart(part) then
          c*hold(m)[op(part)](alphab);
        else
          0;
        end_if;
      end_if;
    else
      part := subs(part, 0=null());
      if (part=[]) then
        c;
      elif muEC::TYP::IsPart(part) then
        c*hold(m)[op(part)](alphab);
      else
        0;
      end_if;
    end_if;
  else
    k := contains(vlist, pol);
    if k<>0 then
      if (k=1) then
        hold(m)[1](alphab);
      else
        0;
      end_if;
    else
      pol; 
    end_if;
  end_if;
end_proc:

/*
|  VP260498
*/ 
muEC::SFA::Pol2SfA_check := proc(pol, vlist)
begin
  if not testtype(vlist, DOM_LIST) then
    muEC::ERR::SFAPerror(3,procname); /* wrong type for 2nd argument... */
  elif not(_and(op(map(vlist,
    proc(x) begin testtype(x,DOM_IDENT) and not muEC::TYP::IsAlphabet_simple(x) end_proc )))) then
    muEC::ERR::SFAPerror(4,procname); /* wrong type for 4th argument... */
  end_if;
end_proc:
/*
|  VP260498
*/
muEC::SFA::Pol2SfA := proc(pol, vlist)
begin
  if testargs() then
    muEC::SFA::Pol2SfA_check(args());
  end_if;
  muEC::SFA::Pol2SfA_core(args());
end_proc:
