/*
|  File Sf2SfA (SFA PACKAGE) Mon Apr 27 11:22:36 MET DST 1998
*/

/*
|  Sf2SfA(sf) converts a SYMF object into a SFA object by adding the formal
|             alphabet A1.
|
|  SfA2Sf(sf, alphab) does the same, except that the alphabet is given.
|
|  VP270498
*/
muEC::SFA::Sf2SfA_interface := proc(sf, alphab)
local
  i,        /* var for loop... */
  mn,       /* a monom...      */
  v,        /* a monom...      */
  res;      /* the result...   */
begin
  res := 1;
  if testtype(sf, "_plus") then
    res := map(sf, muEC::SFA::Sf2SfA_interface, alphab);
  elif testtype(sf, "_power") then
    v := op(sf,1);
    if testtype(op(sf,2), Type::PosInt) then
      if muEC::TYP::Ise(v) or muEC::TYP::Ish(v) or muEC::TYP::Isp(v)
      or muEC::TYP::Iss(v) or muEC::TYP::Ism(v) then
        res := sf(alphab);
      else
        res := muEC::SFA::Sf2SfA_interface(op(sf, 1), alphab)^op(sf, 2);
      end_if;
    else
      res := muEC::SFA::Sf2SfA_interface(op(sf,1), alphab)^op(sf,2);
    end_if;
  elif testtype(sf, "_mult") then
    for i from 1 to nops(sf) do
      mn := op(sf,i);
      if testtype(mn, "_power") then
        v := op(mn,1);
        if muEC::TYP::Ise(v) or muEC::TYP::Ish(v) or muEC::TYP::Isp(v)
        or muEC::TYP::Iss(v) or muEC::TYP::Ism(v) then
          res := res * mn(alphab);
        else
          res := res * muEC::SFA::Sf2SfA_interface(v, alphab)^op(mn,2);
        end_if;
      else /* a monom made of a single element... */
        if muEC::TYP::Ise(mn) or muEC::TYP::Ish(mn) or muEC::TYP::Isp(mn)
        or muEC::TYP::Iss(mn) or muEC::TYP::Ism(mn) then
          res := res * mn(alphab);
        else /* this is a scalar... */
          res := res * mn;
        end_if;
      end_if;
    end_for;
  else /* a monom made of a single element... */
    if muEC::TYP::Ise(sf) or muEC::TYP::Ish(sf) or muEC::TYP::Isp(sf)
    or muEC::TYP::Iss(sf) or muEC::TYP::Ism(sf) then
      res := sf(alphab);
    else /* this is a scalar... */
      res := sf;
    end_if;
  end_if;
  res;
end_proc:

/*
|  VP270498
*/
muEC::SFA::Sf2SfA_core := proc(sf)
local
  alphab;
begin
  if (args(0) = 2) then
    alphab := args(2);
  else
    alphab := hold(A1); /* default value... */
  end_if;
  muEC::SFA::Sf2SfA_interface(sf, alphab);
end_proc:

/*
|  VP270498
*/
muEC::SFA::Sf2SfA_check:=proc(sf)
begin
end_proc:

/*
|  VP270498
*/
muEC::SFA::Sf2SfA := proc(sf)
begin
  if testargs() then
    muEC::SFA::Sf2SfA_check(args());
  end_if;
  muEC::SFA::Sf2SfA_core(args());
end_proc:
