/*
|  File SfA2Sf (SFA PACKAGE) Mon Apr 27 11:44:11 MET DST 1998
*/

/*
|  SfA2Sf(sfa) suppresses all alphabets in sfa and converts the result into
|              a symmetric function treatable by the SYMF package.
|
|  SfA2Sf(sfa, alist) supresses in sfa the alphabets specified in alist and
|                     converts the result into a symmetric function treatable
|                     by the SYMF package. Functions on remaining alphabets
|                     will thus be hold as scalars.
|  VP270498
*/
muEC::SFA::SfA2Sf_interface := proc(sfa, alist)
local
  i,   /* var for loop... */
  j,   /* var for seq...  */
  t,   /* a table...      */
  res; /* result...       */
begin
  if testtype(sfa, "_plus") then
    res := map(sfa, muEC::SFA::SfA2Sf_interface, alist);
  else
    res := 1;
    t := muEC::SFA::MonomialA(sfa, muEC::SFA::SFABases, alist);
    for i in [op(op(t,j),1)$j=1..nops(t)] do 
      if has(muEC::SFA::SFABases,i) then
        res := res * _mult(op(op(t[i],j),2)$j=1..nops(t[i]));
      end_if;
    end_for;
    res := res * t[hold(coeff)];
  end_if;
  res;
end_proc:

/*
|  VP270498
*/
muEC::SFA::SfA2Sf_core:=proc(sfa)
local
  alist; /* list of alphabets... */
begin
  if (args(0) = 2) then
    alist := args(2);
  else
    alist := ["*"];
  end_if;
  muEC::SFA::SfA2Sf_interface(sfa, alist);
end_proc:

/*
|  VP270498
*/
muEC::SFA::SfA2Sf_check:=proc(sfa)
begin
end_proc:

/*
|  VP270498
*/
muEC::SFA::SfA2Sf := proc(sfa)
begin
  if testargs() then
    muEC::SFA::SfA2Sf_check(args());
  end_if;
  muEC::SFA::SfA2Sf_core(args());
end_proc:
