/*
|  File SfAOmega (SFA PACKAGE) Mon Apr 27 16:13:02 MET DST 1998
*/

/*
|  SfAOmega(sfa) applies the omega-automorphism to the symmetric function sfa.
|  VP270498
*/
muEC::SFA::SfAOmega_core := proc(sfa)
begin
  if args(0)=1 then
    if (testtype(sfa, "_plus") or testtype(sfa, "_mult")) then
      map(sfa, muEC::SFA::SfAOmega_core);
    elif testtype(sfa, "_power") then
      muEC::SFA::Sf2SfA(muEC::SYMF::SfOmega(muEC::SFA::SfA2Sf(op(sfa,1), [op(op(sfa,1))])),
                                 op(op(sfa,1)))^op(sfa,2);
    else
      muEC::SFA::Sf2SfA(muEC::SYMF::SfOmega(muEC::SFA::SfA2Sf(sfa, [op(sfa)])), op(sfa));
    end_if;
  else
    if (testtype(sfa, "_plus") or testtype(sfa, "_mult")) then
      map(sfa, muEC::SFA::SfAOmega_core, args(2));
    elif testtype(sfa, "_power") then
      if has(args(2), op(op(sfa,1))) then
        muEC::SFA::Sf2SfA(muEC::SYMF::SfOmega(muEC::SFA::SfA2Sf(op(sfa,1), [op(op(sfa,1))])),
                                                 op(op(sfa,1)))^op(sfa,2);
      else
        sfa;
      end_if;
    else
      if has(args(2), op(sfa)) then
        muEC::SFA::Sf2SfA(muEC::SYMF::SfOmega(muEC::SFA::SfA2Sf(sfa, [op(sfa)])), op(sfa));
      else
        sfa;
      end_if;
    end_if;
  end_if;
end_proc:

/*
|  VP270498
*/
muEC::SFA::SfAOmega_check:=proc(sfa)
begin
end_proc:

/*
|  VP270498
*/
muEC::SFA::SfAOmega := proc(sfa)
begin
  if testargs() then
    muEC::SFA::SfAOmega_check(args());
  end_if;
  muEC::SFA::SfAOmega_core(args());
end_proc:
