/*
|  File SfAVar (SFA PACKAGE) Mon Apr 27 15:50:13 MET DST 1998
*/

/*
|  SfA2TableVar(sfa) returns a table with all symmetric
|                    functions in sfa. One can restrict the set of symmetric
|                    functions by adding a second argument as in MonomialA.
|  VP270498
*/
muEC::SFA::SfA2TableVar_core := proc(sfa)
local
  i,  /* var for loop... */
  j,  /* var for loop... */
  b,  /* bases... */
  r,  /* a temporary result... */
  t;  /* a table... */
begin
  if args(0)=2 then
    if testtype(args(2), DOM_IDENT) then
      if has(muEC::SFA::SFABases, args(2)) then
        b := {args(2)};
      else
        b := {};
      end_if;
    else
      b:= {op(muEC::SFA::SFABases)} intersect args(2);
    end_if;
  else
    b := muEC::SFA::SFABases;
  end_if;
  t := table();
  for i in b do
    r := muEC::SFA::AllIndexed(sfa,i);
    if nops(r)>0 then
      for j in r do
        t[i][op(j,2)] := {};
      end_for;
      for j in r do
        t[i][op(j,2)] := t[i][op(j,2)] union {op(j,1)};
      end_for;
    else
      t[i] := table();
    end_if;
  end_for;
  if args(0)=2 then
    if (testtype(args(2), DOM_IDENT)) then
      t[args(2)];
    else
      t;
    end_if;
  else
    t;
  end_if;
end_proc:

/*
|  VP270498
*/
muEC::SFA::SfA2TableVar_check := proc(sfa)
begin
  if args(0)=2 then
    if (testtype(args(2), DOM_IDENT)) then
      if not has(muEC::SFA::SFABases, args(2)) then
        muEC::ERR::SFAPerror(4,procname);
      end_if;
    elif testtype(args(2), DOM_SET) then
      if args(2) minus {op(muEC::SFA::SFABases)} <> {} then
        muEC::ERR::SFAPerror(4,procname);
      end_if;
    else
      muEC::ERR::SFAPerror(3,procname);
    end_if;
  end_if;
end_proc:

/*
|  VP270498
*/
muEC::SFA::SfA2TableVar := proc(sfa)
begin
  if testargs() then
    muEC::SFA::SfA2TableVar_check(args());
  end_if;
  muEC::SFA::SfA2TableVar_core(args());
end_proc:
