/*
|  File SfAVars (SFA PACKAGE) Mon Apr 27 11:02:56 MET DST 1998
*/

/*
|  SfAVars(vset) reinitializes the set of variables that must be taken into
|                account by SfAExpand.
|  VP270498
*/
muEC::SFA::SfAVars_core := proc()
begin
  if (args(0)>0) then
    // Use sysassign because muEC is protected
    sysassign(muEC::SFA::SFAVars, args(1));
    sysassign(muEC::SFA::SfAExpand, 
              muEC::clearRememberTable(muEC::SFA::SfAExpand));
  end_if;
  muEC::SFA::SFAVars;
end_proc:

/*
|  VP270498
*/
muEC::SFA::SfAVars_check := proc()
local
  k, /* var for loop... */
  i; /* var for loop... */
begin
  if (args(0)>0) then
    if not testtype(args(1), DOM_SET) then
      muEC::ERR::SFAPerror(1,procname); /* wrong type for 1st argument... */
    else
      for i in args(1) do
        if testtype(i, DOM_SET) then
          if (not testtype(op(i), DOM_IDENT)) or bool(op(i)=hold(A)) then
            muEC::ERR::SFAPerror(2,procname); /* wrong range for 1st argument... */
          else
            for k in ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"] do
              if strmatch(expr2text(op(i)),"\*".k."\*") then
                muEC::ERR::SFAPerror(2,procname); /* wrong range for 1st argument... */
              end_if;
            end_for;
          end_if;
        elif (not testtype(i, DOM_IDENT)) or muEC::TYP::IsAlphabet_simple(i) then
          muEC::ERR::SFAPerror(2,procname); /* wrong range for 1st argument... */
        end_if;
      end_for;
    end_if; 
  end_if; 
end_proc:

/*
|  VP270498
*/
muEC::SFA::SfAVars := proc()
begin
  if testargs() then
    muEC::SFA::SfAVars_check(args());
  end_if;
  muEC::SFA::SfAVars_core(args());
end_proc:
