/*
|  File ToSfA.mu (SFA PACKAGE) Mon Apr 27 16:25:20 MET DST 1998
*/

/*
|  ToSfA(sfa)  expresses sfa on s basis.
|  VP270498
*/
muEC::SFA::ToSfA := proc(sfa,b)
local
  i,   /* var for loop...   */
  j,   /* var for loop...   */
  l,   /* var for seq...    */
  t,   /* monomial table... */
  res; /* the result...     */
begin
  if testtype(sfa, "_plus") then
    map(sfa, muEC::SFA::ToSfA, args(2..args(0)));
  else 
    if args(0)>2 then
      t := muEC::SFA::MonomialA(sfa, muEC::SFA::SFABases, args(3..3));
    else
      t := muEC::SFA::MonomialA(sfa, muEC::SFA::SFABases);
    end_if;
    res := 1;
    for i in {op(op(t,l),1)$l=1..nops(t)} minus {hold(coeff)} do
      for j in [op(op(t[i],l),1)$l=1..nops(t[i])] do
        res := res * (muEC::SYMF::ToSf(t[i][j],b)(j));
      end_for;
    end_for;
    res * t[hold(coeff)];
  end_if;  
end_proc:

/*
|  Type Checking...
|  VP270498
*/
muEC::SFA::To_Acheck := proc(sfa)
    local i;
begin
  if (args(0)>1) then
    for i from 2 to args(0) do
      if (args(i)<>hold(noexpand)) then
        muEC::ERR::SFAPerror(2*i-1,procname);/* Wrong type for ith argument... */
      end_if;
    end_for;
  end_if;
end_proc:

/*
|  VP270498
*/
muEC::SFA::ToeA := proc(sfa)
begin
  if testargs() then
    muEC::SFA::To_check(args());
  end_if;
  muEC::SFA::ToSfA(sfa,hold(e),args(2..args(0)));
end_proc:

/*
|  VP270498
*/
muEC::SFA::TohA := proc(sfa)
begin
  if testargs() then
    muEC::SFA::To_check(args());
  end_if;
  muEC::SFA::ToSfA(sfa,hold(h),args(2..args(0)));
end_proc:

/*
|  VP270498
*/
muEC::SFA::TopA := proc(sfa)
begin
  if testargs() then
    muEC::SFA::To_check(args());
  end_if;
  muEC::SFA::ToSfA(sfa,hold(p),args(2..args(0)));
end_proc:

/*
|  VP270498
*/
muEC::SFA::TomA := proc(sfa)
begin
  if testargs() then
    muEC::SFA::To_check(args());
  end_if;
  muEC::SFA::ToSfA(sfa,hold(m),args(2..args(0)));
end_proc:

/*
|  VP270498
*/
muEC::SFA::TosA := proc(sfa)
begin
  if testargs() then
    muEC::SFA::To_check(args());
  end_if;
  muEC::SFA::ToSfA(sfa,hold(s),args(2..args(0)));
end_proc:
