/*
|  File Apply (SG PACKAGE) Sat Oct 25 15:50:17 MET DST 1997
*/

/*
|  MultPerm() If p1, p2, p3, ..., pn are the arguments of MultPerm, then
|             the "function" calculates p1 (p2 (p3 (... (pn)))) : we see
|             the pi's as mappings (that we write to the left of their
|             argument).
*/

/*
|  VP251097
*/
muEC::SG::MultPerm_core := proc()
local
  i,j; /* var for loops... */
begin
  /* we init the result to be args(args(0)) with some fix points... */
  [op(args(args(0))),
   _seqgen(i, i,(nops(args(args(0)))+1)..max(op(map([args],nops))))];
  for i from (args(0)-1) downto 1 step 1 do
    subs(%,{(j=args(i)[j])$j=1..nops(args(i))});
  end_for;
  %;
end_proc:

/*
|  Type Checking
|  VP251097
*/
muEC::SG::MultPerm_check := proc(perm)
local
  i; /* var for loop... */
begin
  for i from 1 to args(0) do
    if (not muEC::TYP::IsPerm(args(i))) then
      muEC::ERR::SGPerror(9,procname);
    end_if;
  end_for;
end_proc:

/*
|  VP251097
*/
muEC::SG::MultPerm := proc(perm)
begin
  if testargs() then
    muEC::SG::MultPerm_check(args());
  end_if;
  muEC::SG::MultPerm_core(args());
end_proc:
