/*
|  File Betti (SG PACKAGE) Sat Oct 25 17:16:01 MET DST 1997
*/

/*
|  Perm2Betti(perm, q) computes the Betti polynomial.
*/

/*
|  VP251097
*/
muEC::SG::Perm2BettiRec := proc(perm, l, q)
local
  p,   /* a permutation...    */
  r,   /* the result...       */
  c,   /* the code of perm... */
  i;   /* vars for loops...   */
begin
  if (perm=[ $1..l]) then
    1;
  else
    c := muEC::SG::Perm2Code(perm);
    p := map(subsop(perm, 1=null()),
             proc(x,v) begin if (x>v) then x-1; else x; end_if; end_proc,
             perm[1]);
    if (c[1]=0) then
      muEC::SG::Perm2BettiRec(p,l-1,q);
    else
      /* ok with option recontains... */
      r := (q^(c[1])+q^(c[1]-1)) * muEC::SG::Perm2BettiRec(p,l-1,q);
      for i from c[1]-1 downto 1 step 1 do
        r := r + q^(i-1)*muEC::SG::Perm2BettiRec(muEC::SG::PiPerm(c[1]-1,i,p),l-1,q);
      end_for;
      r;
    end_if;
  end_if;
end_proc:

/*
|  VP251097 VP080198
*/
muEC::SG::Perm2Betti_core := proc(perm, q)
local
  r; /* the result... */
begin
  r := expand(muEC::SG::Perm2BettiRec(perm,nops(perm),q));
  sysassign(muEC::SG::Perm2BettiRec,
            muEC::clearRememberTable(muEC::SG::Perm2BettiRec));
  r ;
end_proc:

/*
|  Type Checking
|  VP251097
*/
muEC::SG::Perm2Betti_check:=proc(perm, q)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
end_proc:

/*
|  VP251097
*/
muEC::SG::Perm2Betti := proc(perm)
begin
  if testargs() then
    muEC::SG::Perm2Betti_check(args());
  end_if;
  muEC::SG::Perm2Betti_core(args());
end_proc:
