/*
|  File Des2LPer (SG PACKAGE) Sun Oct 26 12:56:08 MET 1997
|
|  Desc2ListPerm(desc) computes the set of permutations which descent set
| 	              is desc.
*/

/*
|  VP261097
*/
muEC::SG::Desc2ListPerm_rec := proc(compo, perm)
local
  n, /* nops(perm)...  */
  i; /* var for seq... */
option remember;
begin
  n := nops(perm);
  if (nops(compo)=1) then
    [perm];
  elif ({op(compo)}={1}) then
    [[_seqgen(perm[-i], i,-n..-1)]];
  elif (compo[1]=1) then
    map(
        map([_seqgen([perm[i], [op(perm, 1..i-1), op(perm, i+1..n)]], i,2..n)],
            proc(x,y) begin [x[1], muEC::SG::Desc2ListPerm_rec(y, x[2])] end_proc, 
            [op(compo,2..nops(compo))]),
        proc(x) begin
        op(map(x[2],
              proc(y,z) begin
              if (y[1]>z) then null(); else [z, op(y)] end_if;
              end_proc,
              x[1]))
        end_proc
       );
  else
    map(
        map([_seqgen([perm[i], [op(perm,1..i-1), op(perm, i+1..n)]], i,1..n-1)],
            proc(x,y) begin [x[1], muEC::SG::Desc2ListPerm_rec(y, x[2])] end_proc,
            [compo[1]-1, op(compo,2..nops(compo))]),
        proc(x) begin
        op(map(x[2], 
               proc(y,z) begin
               if (y[1]<z) then null(); else [z, op(y)] end_if;
               end_proc, 
               x[1]))
        end_proc
       );
  end_if;
end_proc:

/*
|  VP261097
*/
muEC::SG::Desc2ListPerm_core := proc(desc, n)
local
 edesc, /* extended descent set... */
 r,     /* the result...           */
 i;     /* var for seq...          */
begin
  edesc := [0, op(desc)]; /* removing repetitions and sorting... */
  r := muEC::SG::Desc2ListPerm_rec([edesc[i]-edesc[i-1] $ i=2..nops(edesc),
                              n-edesc[nops(edesc)]],
                             [$1..n]);
  sysassign(muEC::SG::Desc2ListPerm_rec,
            muEC::clearRememberTable(muEC::SG::Desc2ListPerm_rec));
  r;
end_proc:

/*     
|  Type Checking
|  VP261097
*/ 
muEC::SG::Desc2ListPerm_check := proc(desc, n)
local
  i; /* var for loop... */
begin
  if (not(testtype(desc, DOM_LIST))) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
  for i from 1 to nops(desc) do
    if (not testtype(desc[i], Type::PosInt)) then
      muEC::ERR::SGPerror(2,procname);
    end_if;
  end_for;
  if (not(testtype(n, DOM_INT))) then
    muEC::ERR::SGPerror(3,procname);
  elif (n<=0) then
    muEC::ERR::SGPerror(4,procname);
  elif (desc<>[]) then
    if (max(op(desc))>=n) then
      muEC::ERR::SGPerror(4,procname);
    end_if;
  end_if;
end_proc:

/*
|  VP261097
*/
muEC::SG::Desc2ListPerm := proc(desc, n)
begin
  if testargs() then
    muEC::SG::Desc2ListPerm_check(args());
  end_if;
  muEC::SG::Desc2ListPerm_core(args());
end_proc:
