/*
|  File Factoriz (SG PACKAGE) Sun Oct 26 15:07:55 MET 1997
*/

/*
|
|  FactorPerm(perm) tests whether a permutation factorizes or not.
|                   The result is a pair (test,l), where l is the length of
|                   the first block.
*/

/*
|  VP261097
*/
muEC::SG::FactorPerm_core := proc(perm)
local
  m, /* max...                    */
  i; /* var for loop...           */
begin
  m := 0;
  for i from 1 to nops(perm)-1 do
    if (perm[i]>m) then
      m := perm[i];
    end_if;
    if (m=i) then
      return(TRUE, i);
    end_if;
  end_for;
  FALSE, 0;
end_proc:

/*
|  Type Checking
|  VP261097
*/
muEC::SG::FactorPerm_check:=proc(perm)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(9,procname);
  end_if;
end_proc:

/*
|  VP261097
*/
muEC::SG::FactorPerm := proc(perm)
begin
  if testargs() then
    muEC::SG::FactorPerm_check(args());
  end_if;
  muEC::SG::FactorPerm_core(args());
end_proc:
