/*
|  File Inv (SG PACKAGE) Sat Oct 25 16:00:20 MET DST 1997
*/

/*
|  Perm2ListInv(perm) calculates the set of all inversions of the permutation.
|                     It is a list of pair(s) of positions.
|                     The result is in lexicographic ordering.
*/

/*
|  VP251097
*/
muEC::SG::Perm2ListInv_core := proc(perm)
local
  i,j, /* var for loops...                 */
  l,   /* the list of inversions...        */
  n;   /* degree of the symmetric group... */
begin
  n := nops(perm);
  /* we init the result to the empty set... */
  l := null();
  for i from 1 to n-1 do
    for j from i to n do
      if (perm[i]>perm[j]) then
        l := l,{i,j};
      end_if;
    end_for;
  end_for;
  [l];
end_proc:

/*
|  Type Checking
|  VP251097
*/
muEC::SG::Perm2ListInv_check := proc(perm)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
end_proc:

/*
|  VP251097
*/
muEC::SG::Perm2ListInv := proc(perm)
begin
  if testargs() then
    muEC::SG::Perm2ListInv_check(args());
  end_if;
  muEC::SG::Perm2ListInv_core(args());
end_proc:
