/*
|  File Invert (SG PACKAGE) Sat Oct 25 16:06:57 MET DST 1997
*/

/*
|  Perm2Inv(perm) inverts a permutation (seen as a mapping...).
*/

/*
|  VP251097
*/
muEC::SG::Perm2Inv_core := proc(perm)
local
  i; /* var for seq... */
begin
  nops(perm);
  subs([_seqgen(i, i,1..%)], {_seqgen((perm[i]=i), i,1..%)});
end_proc:

/*
|  Type Checking
|  VP251097
*/
muEC::SG::Perm2Inv_check := proc(perm)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
end_proc:

/*
|  VP251097
*/
muEC::SG::Perm2Inv := proc(perm)
begin
  if testargs() then
    muEC::SG::Perm2Inv_check(args());
  end_if;
  muEC::SG::Perm2Inv_core(args());
end_proc:
