/*
|  File ListRd (SG PACKAGE) Sun Oct 26 16:53:20 MET 1997
*/

/*
|  Perm2ListRd(perm) returns the list of all reduced decompositions
|                    of a given permutation. With hold(nb), it counts these
|                    decompositions.
|                    compte les decompositions.
|  VP261097
*/
muEC::SG::Perm2ListRd_core := proc(perm)
local
  l,   /* a list...       */
  i,j; /* vars for seq... */
option remember;
begin
  if (args(0)=1) then
    if (perm=[_seqgen(i, i,1..nops(perm))]) then
      [[]];
    else
      l := map([_seqgen(j=perm[j]-perm[j+1],j,1..(nops(perm)-1))],
               proc(x) begin if (testtype(op(x,2),Type::PosInt)) then
                       op(x,1) else null(); end_if; end_proc);
      [_seqgen(op(map(
             muEC::SG::Perm2ListRd(subsop(perm,l[i]=perm[l[i]+1],l[i]+1=perm[l[i]])),
             proc(x,y) begin [op(x),y] end_proc,
             l[i])), i,1..nops(l))];
    end_if;
  else
    muEC::SG::Perm2NbRd(perm);
  end_if;
end_proc:

/*
|  Perm2NbRd(perm) returns the number of reduced decompositions of a
|                  given permutation.
|  VP261097
*/
muEC::SG::Perm2NbRd := proc(perm)
local
    l,   /* a list...       */
    i,j; /* vars for seq... */
option remember;
begin
  if (perm=[_seqgen(i, i,1..nops(perm))]) then
    1;
  else
    l := map([_seqgen(j=perm[j]-perm[j+1],j,1..(nops(perm)-1))],
             proc(x) begin if (testtype(op(x,2),Type::PosInt)) then
                     op(x,1) else null(); end_if; end_proc);
    _plus(_seqgen(muEC::SG::Perm2NbRd(subsop(perm,l[i]=perm[l[i]+1],l[i]+1=perm[l[i]])),
                  i,1..nops(l)));
  end_if;
end_proc:

/*
|  Type Checking
|  VP261097
*/
muEC::SG::Perm2ListRd_check:=proc(perm)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
  if (args(0)=2) then
    if (not testtype(args(2), DOM_IDENT)) then
      muEC::ERR::SGPerror(3,procname);
    elif (args(2)<>hold(nb)) then
      muEC::ERR::SGPerror(4,procname);
    end_if;
  end_if;
end_proc:

/*
|  VP261097
*/
muEC::SG::Perm2ListRd := proc(perm)
begin
  if testargs() then
    muEC::SG::Perm2ListRd_check(args());
  end_if;
  muEC::SG::Perm2ListRd_core(args());
end_proc:
