/*
|  File Part2CC (SG PACKAGE) Mon Oct 27 13:44:59 MET 1997
*/

/*
|  Part2SgCC(part) returns the list of all permutations whose cycle type
|                  is part. When hold(nb) is added, it returns the cardinal
|                  of the class.
*/

/*
BUGS: nops(Part2SgCC([4,1])); gives 5 instead of 30
*/

/*
|  VP271097 VP080198
*/
muEC::SG::Part2SgCC_rec := proc(l, k)
local
  n, i; /* nops(l)...     */
option remember;
begin
  n := nops(l);
  if (k=0) then
    [{}];
  elif (n<k) then
    [];
  else
  [op(map(muEC::SG::Part2SgCC_rec({muEC::SubSeq(l,i+1..n)}, k-1), 
	  proc(l, e) begin {e, op(l)} end_proc, op(l,i)))
   $ i=1..n-k+1];
  end_if;
end_proc:

/*
|  VP271097 VP080198
*/
muEC::SG::Part2SgCC_core := proc(part)
local
  n,  /* degree of the symmetric group... */
  pa, /* part without 1...                */
  s,  /* list of values 1..n...           */
  c,  /* list of cycles...                */
  j,  /* var for seq...                   */
  i;  /* var for loop...                  */
begin
  if (args(0)=2) then
    fact(_plus(op(part)))/muEC::SYMF::SfZee(part);
  else
    n := _plus(op(part));
    pa := subs(part, 1=null());
    if (pa=[]) then
      [[_seqgen(j, j,1..n)]];
    else
      /* partition pa has at least one part... */
      s := {_seqgen(j, j,1..n)};
      c := map(muEC::SG::Part2SgCC_rec(s, pa[1]), 
               proc(se, s) begin [[se], s minus se]
               end_proc, s);
      for i from 2 to nops(pa) do
       c := map(c,
                proc(cycle, p) begin
                op(map(muEC::SG::Part2SgCC_rec(op(cycle,2), p),
                       proc(se, cycle) begin
                         [[op(op(cycle,1)), se], op(cycle,2) minus se]
                       end_proc,
                       cycle));
                end_proc,
                pa[i])
      end_for;
      sysassign(muEC::SG::Part2SgCC_rec,
                muEC::clearRememberTable(muEC::SG::Part2SgCC_rec));
      c := {op(map(c,proc(cycle) local i; begin
               {op(op(cycle,1)), _seqin({i},i,op(cycle,2))} end_proc))};
      c := [op(map(c,
                   proc(s) begin
                   [op(map(s, proc(s1) begin [op(s1)] end_proc))]
                   end_proc))];
      map(
        map(c,
          proc(cycle) local p; begin
          /* for each block of length k, we permute the k-1 last values... */
          p := proc(cycl) local r; begin
               if (nops(cycl)=1) then
                map(muEC::SG::ListPerm([muEC::SubSeq(op(cycl,1),2..nops(op(cycl,1)))]),
                    proc(l, e) begin [[e, op(l)]] end_proc,
                    op(op(cycl,1),1));
               else
                 r := map(
                      muEC::SG::ListPerm([muEC::SubSeq(op(cycl,1),2..nops(op(cycl,1)))]),
                      proc(l, e) begin [e, op(l)] end_proc,
                      op(op(cycl,1),1));
                 map(
                     p([muEC::SubSeq(cycl,2..nops(cycl))]),
                     proc(cyc, eperm) local i; begin
                       _seqin([i, op(cyc)], i,eperm);
                     end_proc,
                     r);
               end_if;
          end_proc;
          op(p(cycle));
       end_proc),
       muEC::SG::Cycle2Perm);
    end_if;
  end_if;
end_proc:

/*
|  Type Checking
|  VP271097
*/
muEC::SG::Part2SgCC_check:=proc(part)
begin
  if (not muEC::TYP::IsPart(part)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
  if (args(0)=2) then
    if (not testtype(args(2), DOM_IDENT)) then
      muEC::ERR::SGPerror(3,procname);
    elif (args(2)<>hold(nb)) then
      muEC::ERR::SGPerror(4,procname);
    end_if;
  end_if;
end_proc:

/*
|  VP271097
*/
muEC::SG::Part2SgCC := proc(part)
begin
  if testargs() then
    muEC::SG::Part2SgCC_check(args());
  end_if;
  muEC::SG::Part2SgCC_core(args());
end_proc:
