/*
|  File Perm2Cod (SG PACKAGE) Sat Oct 25 12:39:59 MET DST 1997
*/

/*
|  Perm2Code(perm) calculates the lehmer code of a permutation.
|                  The code length equals the degree of S_n even if we know
|                  that the last element is always 0.
*/

/*
|  VP251097
*/
muEC::SG::Perm2Code_core := proc(perm)
local
  i,j,  /* var for loops...                       */
  num,  /* number of inversions for a position... */
  code, /* the code...                            */
  n;    /* degree of the symmetric group...       */
begin
  n := nops(perm);
  code := null();
  /* looking for inversions and counting them in num variable... */
  for i from 1 to n-1 do
    num := 0;
    for j from i+1 to n do
      if (perm[i]>perm[j]) then
        num := num+1;
      end_if;
    end_for;
    code := code, num;
  end_for;
  [code,0];
end_proc:

/*
|  Type Checking
|  VP251097
*/
muEC::SG::Perm2Code_check := proc(perm)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
end_proc:

/*
|  VP251097
*/
muEC::SG::Perm2Code := proc(perm)
begin
  if testargs() then
    muEC::SG::Perm2Code_check(args());
  end_if;
  muEC::SG::Perm2Code_core(args());
end_proc:
