/*
|  File Perm2Mat (SG PACKAGE) Sat Oct 25 14:35:02 MET DST 1997
*/

/*
|  Perm2Mat(perm) calculates a matrix of permutation for the permutation perm.
|                 It associates to each position(row), the value in
|                 the permutation which lies at that position.
*/

/*
|  VP251097
*/
muEC::SG::Perm2Mat_core := proc(perm)
local
  i, /* var for loop...                  */
  n, /* degree of the symmetric group... */
  m; /* a matrix (n,n)...                */
begin
  n := nops(perm);
  m := array(1..n, 1..n, [[0$n]$n]);
  for i from 1 to n do
    m[i, perm[i]] := 1;
  end_for;
  m;
end_proc:

/*
|  Type Checking
|  VP251097
*/
muEC::SG::Perm2Mat_check:=proc(perm)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(1,procname)
  end_if;
end_proc:

/*
|  VP251097
*/
muEC::SG::Perm2Mat := proc(perm)
begin
  if testargs() then
    muEC::SG::Perm2Mat_check(args());
  end_if;
  muEC::SG::Perm2Mat_core(args());
end_proc:
