/*
|  File Perm2RR (SG PACKAGE) Sat Oct 25 14:51:06 MET DST 1997
*/

/*
|  Perm2RRep(perm) computes the matrix associated with perm in the regular
|                  representation of the symmetric group.
|                  This matrix is defined step the left multiplication
|                  operation.
*/

/*
|  VP251097
*/
muEC::SG::Perm2RRep_core := proc(perm)
local
  i,  /* var for loop...                      */
  n,  /* the degree of the symmetric group... */
  p,  /* permutations...                      */
  cm; /* the matrix...                        */
begin
  n  := max(op(perm));
  p  := muEC::SG::ListPerm(n, hold(lexic));
  cm := array(1..fact(n), 1..fact(n), [[0$fact(n)]$fact(n)]);
  for i from 1 to nops(p) do
    cm[contains(p, muEC::SG::MultPerm(perm,p[i])),i] := 1;
  end_for;
  cm;
end_proc:

/*
|  Type Checking
|  VP251097
*/
muEC::SG::Perm2RRep_check := proc(perm)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
end_proc:

/*
|  VP251097
*/
muEC::SG::Perm2RRep := proc(perm)
begin
  if testargs() then
    muEC::SG::Perm2RRep_check(args());
  end_if;
  muEC::SG::Perm2RRep_core(args());
end_proc:
