/*
|  File Perm2Rd (SG PACKAGE) Sat Oct 25 14:59:45 MET DST 1997
*/

/*
|  Perm2Rd(perm) calculates a reduced word for the permutation.
|                The result is a list of i's such that SgTranspo(i) is
|                an elementary transposition. Let l be such a list
|                [l1,l2,..,lk], then
|                perm=MultPerm(SgTranspo(l1),...,SgTranspo(lk))
*/

/*
| VP251097
*/
muEC::SG::Perm2Rd_core := proc(perm)
local
  c, /* the code...                  */
  j, /* var for seq...               */
  r, /* the reduced decomposition... */
  i; /* var for loop...              */
begin
  c := muEC::SG::Perm2Code(perm);
  r := null();
  for i from 1 to nops(c)-1 do
    r := r,_seqgen(c[i]+i-j,j,1..c[i]);
  end_for;
  [r];
end_proc:

/*
|  Type Checking
|  VP251097
*/
muEC::SG::Perm2Rd_check := proc(perm)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
end_proc:

/*
|  VP251097
*/
muEC::SG::Perm2Rd := proc(perm)
begin
  if testargs() then
    muEC::SG::Perm2Rd_check(args());
  end_if;
  muEC::SG::Perm2Rd_core(args());
end_proc:
