/*
|  File Perm2Rot (SG PACKAGE) Sat Oct 25 15:13:56 MET DST 1997
*/

/*
|  Perm2Rothe(perm) calculates the Rothe diagram of a permutation.
*/

/*
|  VP251097 VP080198
*/
muEC::SG::Perm2Rothe_core := proc(perm)
local
  i,   /* var for loop...                      */
  j,   /* old row...                           */
  s,   /* the next elementary transposition... */
  inv, /* the set of inversions...             */
  d,   /* the diagram : a matrix (n,n)...      */
  n;   /* degree of the symmetric group...     */
begin
  n := nops(perm);
  d := array(1..n,1..n, [["."$n]$n]);
  inv := muEC::SG::Perm2ListInv(perm);
  /* traduction in terms of diagram... */
  for i from 1 to nops(inv) do
    d[op(inv[i],1),perm[op(inv[i],2)]] := 1;
  end_for;
  /* we put a x to denote the position of the values 1, 2, ... */
  /* and values to exhibit a reduced decomposition... */
  for i from 1 to n do
    d[i,perm[i]] := "x";
    s := i;
    for j from 1 to n do
      if (d[i,j]=1) then
	d[i,j] := s;
        s := s+1;
      end_if;
    end_for;
  end_for;
  d;
end_proc:

/*
|  Type Checking
|  VP251097
*/
muEC::SG::Perm2Rothe_check:=proc(perm)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
end_proc:

/*
|  VP251097
*/
muEC::SG::Perm2Rothe := proc(perm)
begin
  if testargs() then
    muEC::SG::Perm2Rothe_check(args());
  end_if;
  muEC::SG::Perm2Rothe_core(args());
end_proc:
