/*
|  File Perm2Sha (SG PACKAGE) Sat Oct 25 15:26:12 MET DST 1997
*/

/*
|  Perm2Part(perm) calculates the shape of a permutation that is a partition
|                  equal to the reordered code.
*/

/*
|  VP251097
*/
muEC::SG::Perm2Part_core :=proc(perm)
  /* the shape is a partition whose parts are the non-zero entries of the... */
  /* code arranged in decreasing order... */
begin
  sort(subs(muEC::SG::Perm2Code(perm),0=null()),proc(x,y) begin bool(x>=y) end_proc);
end_proc:

/*
|  Type Checking
|  VP251097
*/
muEC::SG::Perm2Part_check:=proc(perm)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
end_proc:

/*
|  VP251097
*/
muEC::SG::Perm2Part := proc(perm)
begin
  if testargs() then
    muEC::SG::Perm2Part_check(args());
  end_if;
  muEC::SG::Perm2Part_core(args());
end_proc:
