/*
|  File PermLgth (SG PACKAGE) Sat Oct 25 16:16:12 MET DST 1997
*/

/*
|  Perm2Length(perm) calculates the number of inversions.
*/

/*
|  VP251097
*/
muEC::SG::Perm2Length_core := proc(perm)
local
  i,j, /* vars for loops...                */
  l,   /* the length...                    */
  n;   /* degree of the symmetric group... */
begin
  n := nops(perm);
  l := 0;
  for i from 1 to n-1 do
    for j from i to n do
      if (perm[i]>perm[j]) then
        l := l+1;
      end_if;
    end_for;
  end_for;
  l;
end_proc:

/*
|  Type Checking
|  VP251097
*/
muEC::SG::Perm2Length_check:=proc(perm)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
end_proc:

/*
|  VP251097
*/
muEC::SG::Perm2Length := proc(perm)
begin
  if testargs() then
    muEC::SG::Perm2Length_check(args());
  end_if;
  muEC::SG::Perm2Length_core(args());
end_proc:
