/*
|  File RR2Perm (SG PACKAGE) Thu Jan  8 07:32:37 MET 1998
*/

/*
|  RRep2Perm(m) computes the permutation associated with the matrix m in the
|               regular representation of the symmetric group.
|               This matrix is defined by the left multiplication operation.
|               Actually, RRep2Perm takes an array as argument.
|  VP080198
*/

// Attempt of fix, Nicolas Thiry 2004/09/27

muEC::SG::RRep2Perm_core := proc(m)
local
  i,  /* a variable... */
  nb, /* number of rows or columns of m... */
  n;  /* the degree of the symmetric group... */
begin
  n := 1;
  nb := op(op(op(m,0),3),2);
  while (fact(n)<>nb) do n := n+1 end_while;
  op(muEC::SG::ListPerm(n,hold(lexic)),
     contains([m[i,1] $ i = 1..nb], 1));
end_proc:

/*
|  Type Checking.
|  VP080198
*/
muEC::SG::RRep2Perm_check:=proc(m)
begin
  if (not testtype(m,DOM_ARRAY)) then
    muEC::ERR::SGPerror(1,procname)
  end_if;
  /* m should be a square table... */
  if (op(op(op(m,0),2),2)<>op(op(op(m,0),3),2)) then
    muEC::ERR::SGPerror(11,procname)
  end_if;
end_proc:

/*
|  VP080198
*/
muEC::SG::RRep2Perm := proc(m)
begin
  if testargs() then
    muEC::SG::RRep2Perm_check(args());
  end_if;
  muEC::SG::RRep2Perm_core(args());
end_proc:
