/*
|  File Rd2Perm (SG PACKAGE) Thu Jan  8 08:35:51 MET 1998
*/

/*
|  Rd2Perm(rw,n) computes from a reduced word, the permutation of S_n.
|                It does not matter that rw is not reduced.
|                Whenever the second argument is forgotten, it is set to
|                the degree of the smallest symmetric group.
|  VP080198
*/
muEC::SG::Rd2Perm_core := proc(rw)
local
  i, /* variable for sequence... */
  n; /* degree of the symmetric group... */
begin
  if (args(0)=1) then
    if (rw=[]) then
      return([1]);
    end_if;
    n := max(op(rw))+1;
  else
    if (rw=[]) then
      return([_seqgen(i, i,1..args(2))]);
    end_if;
    n := args(2);
  end_if;
  muEC::SG::MultPerm(op(map(rw,muEC::SG::SgTranspo,n)));
end_proc:

/*
|  Type Checking.
|  VP080198
*/
muEC::SG::Rd2Perm_check:=proc(rw)
local
  i; /* variable for loop... */
begin
  if (not testtype(rw,DOM_LIST)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
  for i from 1 to nops(rw) do
    if (not testtype(rw[i],Type::PosInt)) then
      muEC::ERR::SGPerror(2,procname);
    end_if;
  end_for;
  if (args(0)>=2) then
    if (not testtype(args(2),Type::PosInt)) then
      muEC::ERR::SGPerror(3,procname);
    end_if;
    if (rw<>[]) then
      if (args(2)<max(op(rw))+1) then
        muEC::ERR::SGPerror(4,procname);
      end_if;
    end_if;
  end_if;
end_proc:

/*
|  VP080198
*/
muEC::SG::Rd2Perm := proc(rw)
begin
  if testargs() then
    muEC::SG::Rd2Perm_check(args());
  end_if;
  muEC::SG::Rd2Perm_core(args());
end_proc:
