/*
|  File Sign (SG PACKAGE) Thu Jan  8 07:19:45 MET 1998
*/

/*
|  Perm2Sign(perm) computes the signature of a permutation.
|  VP080198
*/
muEC::SG::Perm2Sign_core := proc(perm)
local 
  i,j; /* vars for seq... */
begin
  _mult(_seqgen(
        _mult(_seqgen(sign(perm[j]-perm[i]),i,1..(j-1))),j,2..nops(perm)));
end_proc:

/*
|  Type Checking.
|  VP080198
*/
muEC::SG::Perm2Sign_check:=proc(perm)
begin
  if (not muEC::TYP::IsPerm(perm)) then
    muEC::ERR::SGPerror(1,procname);
  end_if;
end_proc:

/*
|  VP080198
*/
muEC::SG::Perm2Sign := proc(perm)
begin
  if testargs() then
    muEC::SG::Perm2Sign_check(args());
  end_if;
  muEC::SG::Perm2Sign_core(args());
end_proc:
