/**
|  File SP.mu (muEC::SP PACKAGE) Sun May 17 11:18:40 MET DST 1998
|
|            The 'muEC::SP' library for manipulating Schubert polynomials.
|
| VP170598
**/

/**
User Functions:
  TO BE COMPLETED
**/

/**
Algorithms for muEC::SP are adapted from both ACE and SYMMETRICA.
**/

muEC::SP            := newDomain("muEC::SP"):
muEC::SP::info      := "Library muEC::SP: manipulating Schubert Polynomials":
muEC::SP::interface := { NewtonInterp, Sp2TableVar, SpScalarPol,
                     SpSpecialize,
                     TablePe, TableX, TableXX, TableY, TableYY,
                     ToPe, ToX, ToXX, ToY, ToYY, Tox, X2Dim, x2X, x2XX
		     // Undocumented: , XbyX
                   }:
muEC::SP::SPBasesString := [ x, y ]:
muEC::SP::SPBasesIndexed := [ X, XX, Y, YY, Pe ]:
muEC::SP::SPBases := [op({op(muEC::SP::SPBasesString)} union {op(muEC::SP::SPBasesIndexed)})]:

alias(path = pathname("MUEC", "SP")):

muEC::SP::AllValues     := loadproc(muEC::SP::AllValues    , path, "AllValue"):
muEC::SP::EValue        := loadproc(muEC::SP::EValue       , path, "AllValue"):
muEC::SP::Monk          := loadproc(muEC::SP::Monk         , path, "Monk"    ):
muEC::SP::MonkP         := loadproc(muEC::SP::MonkP        , path, "Monk"    ):
muEC::SP::MaxTr         := loadproc(muEC::SP::MaxTr        , path, "MaxTr"   ):
muEC::SP::MaxTr_short   := loadproc(muEC::SP::MaxTr_short  , path, "MaxTr"   ):
muEC::SP::Monomial      := loadproc(muEC::SP::Monomial     , path, "Monomial"):   
muEC::SP::NewtonInterp  := loadproc(muEC::SP::NewtonInterp , path, "NewtonIn"):   
muEC::SP::Pe2X          := loadproc(muEC::SP::Pe2X         , path, "Convert" ):   
muEC::SP::Pe2x_vect     := loadproc(muEC::SP::Pe2x_vect    , path, "Develop" ):   
muEC::SP::ReduceP       := loadproc(muEC::SP::ReduceP      , path, "Monk"    ):   
muEC::SP::Sp2TableVar   := loadproc(muEC::SP::Sp2TableVar  , path, "SpVar"   ):   
muEC::SP::SpScalarPol   := loadproc(muEC::SP::SpScalarPol  , path, "Scalar"  ):   
muEC::SP::SpSpecialize  := loadproc(muEC::SP::SpSpecialize , path, "Special" ):   
muEC::SP::TablePe       := loadproc(muEC::SP::TablePe      , path, "TablePe" ):   
muEC::SP::TableX        := loadproc(muEC::SP::TableX       , path, "TableX"  ):   
muEC::SP::TableXX       := loadproc(muEC::SP::TableXX      , path, "TableXX" ):   
muEC::SP::TableY        := loadproc(muEC::SP::TableY       , path, "TableY"  ):   
muEC::SP::TableYY       := loadproc(muEC::SP::TableYY      , path, "TableYY" ):   
muEC::SP::ToPe          := loadproc(muEC::SP::ToPe         , path, "ToPe"    ):   
muEC::SP::ToX           := loadproc(muEC::SP::ToX          , path, "ToX"     ):   
muEC::SP::ToX_heart     := loadproc(muEC::SP::ToX_heart    , path, "ToX"     ):   
muEC::SP::ToXX          := loadproc(muEC::SP::ToXX         , path, "ToXX"    ):   
//muEC::SP::ToXX_heart    := loadproc(muEC::SP::ToXX_heart   , path, "ToXX"    ):   
muEC::SP::ToXX_heart    := ()->error("muEC::SP::ToXX_heart not implemented"):
muEC::SP::Tox           := loadproc(muEC::SP::Tox          , path, "Toxy"    ):   
muEC::SP::Tox_heart     := loadproc(muEC::SP::Tox_heart    , path, "Toxy"    ):   
muEC::SP::ToY           := loadproc(muEC::SP::ToY          , path, "ToY"     ):   
muEC::SP::ToYY          := loadproc(muEC::SP::ToYY         , path, "ToYY"    ):   
muEC::SP::X2Pe          := loadproc(muEC::SP::X2Pe         , path, "Convert" ):   
muEC::SP::X2Dim         := loadproc(muEC::SP::X2Dim        , path, "X2Dim"   ):   
muEC::SP::X2Pe_remember := loadproc(muEC::SP::X2Pe_remember, path, "TableX"  ):   
muEC::SP::X2x_vect      := loadproc(muEC::SP::X2x_vect     , path, "Develop" ):   
muEC::SP::X2Y           := loadproc(muEC::SP::X2Y          , path, "Convert" ):   
muEC::SP::XProduct      := loadproc(muEC::SP::XProduct     , path, "XbyX"    ):   
muEC::SP::XX2X          := loadproc(muEC::SP::XX2X         , path, "Convert" ):   
muEC::SP::XX2YY         := loadproc(muEC::SP::XX2YY        , path, "Convert" ):   
muEC::SP::XX2x_vect     := loadproc(muEC::SP::XX2x_vect    , path, "Develop" ):   
muEC::SP::XXProduct     := loadproc(muEC::SP::XXProduct    , path, "XXbyXX"  ):   
muEC::SP::x2X           := loadproc(muEC::SP::x2X          , path, "x2X"     ):   
muEC::SP::x2X_heart     := loadproc(muEC::SP::x2X_heart    , path, "x2X"     ):   
muEC::SP::x2XX          := loadproc(muEC::SP::x2XX         , path, "x2XX"    ):   
muEC::SP::x2XX_heart    := loadproc(muEC::SP::x2XX_heart   , path, "x2XX"     ):   
muEC::SP::Y2x_vect      := loadproc(muEC::SP::Y2x_vect     , path, "Develop" ):   
muEC::SP::YY2x_vect     := loadproc(muEC::SP::YY2x_vect    , path, "Develop" ):   
muEC::SP::Y2X           := loadproc(muEC::SP::Y2X          , path, "Convert" ):   
muEC::SP::YY2X          := loadproc(muEC::SP::YY2X         , path, "Convert" ):   
muEC::SP::YY2XX         := loadproc(muEC::SP::YY2XX        , path, "Convert" ):   
unalias(path):

