/*
|  File Convert (SP PACKAGE) Tue Jun 16 09:30:28 MET DST 1998
*/

/*
|  X2Y(f) from X Schubert basis to Y Schubert basis.
|  SV160698 VP290399
*/
muEC::SP::X2Y := proc(f)
local
  l; /* a set... */
begin
  l := muEC::SP::Sp2TableVar(f, hold(X));
  subs(f,
  map(l,
      proc(x) begin
        hold(X)[op(x)]=hold(Y)[op(muEC::SG::Perm2Code(x))]; 
      end_proc));
end_proc:

/*
|  Y2X(f) from Y Schubert basis to X Schubert basis.
|  SV160698 VP290399
*/
muEC::SP::Y2X := proc(f)
local
  l; /* a set... */
begin
  l := muEC::SP::Sp2TableVar(f, hold(Y));
  subs(f,
  map(l,
      proc(x) begin
        hold(Y)[op(x)]=hold(X)[op(muEC::SG::Code2Perm(x))]; 
      end_proc));
end_proc:

/*
|  XX2YY(f) from XX Schubert basis to YY Schubert basis.
|  SV160698 VP290399
*/
muEC::SP::XX2YY := proc(f)
local
  l; /* a set... */
begin
  l := muEC::SP::Sp2TableVar(f, hold(XX));
  subs(f,
  map(l,
      proc(x) begin
        hold(XX)[op(x)]=hold(YY)[op(muEC::SG::Perm2Code(x))]; 
      end_proc));
end_proc:

/*
|  YY2XX(f) from YY Schubert basis to XX Schubert basis.
|  SV160698 VP290399
*/
muEC::SP::YY2XX := proc(f)
local
  l; /* a set... */
begin
  l := muEC::SP::Sp2TableVar(f, hold(YY));
  subs(f,
  map(l,
      proc(x) begin
        hold(YY)[op(x)]=hold(XX)[op(muEC::SG::Code2Perm(x))]; 
      end_proc));
end_proc:

/*
|  X2XX(f) from X Schubert basis to XX Schubert basis.
|  SV220698
*/
muEC::SP::X2XX := proc(f)
begin
  muEC::SP::x2XX(muEC::SP::Tox(f,hold(X)));
end_proc:

/*
|  Y2XX(f) from Y Schubert basis to XX Schubert basis.
|  SV220698
*/
muEC::SP::Y2XX := proc(f)
begin
  muEC::SP::x2XX(muEC::SP::Tox(f,hold(Y)));
end_proc:

/*
|  Pe2XX(f) from Pe basis to XX Schubert basis.
|  SV220698
*/
muEC::SP::Pe2XX := proc(f)
begin
  muEC::SP::x2XX(muEC::SP::Tox(f,hold(Pe)));
end_proc:

/*
|  XX2X(f) from XX Schubert basis to X Schubert basis.
|  SV160698
*/
muEC::SP::XX2X := proc(f)
begin
  muEC::SP::x2X(muEC::SP::Tox(f,hold(XX)));
end_proc:

/*
|  YY2X(f) from YY Schubert basis to X Schubert basis.
|  SV160698
*/
muEC::SP::YY2X := proc(f)
begin
  muEC::SP::x2X(muEC::SP::Tox(f,hold(YY)));
end_proc:

/*
|  Pe2X(f) from Pe basis to X Schubert basis.
|  SV160698
*/
muEC::SP::Pe2X := proc(f)
begin
  muEC::SP::x2X(muEC::SP::Tox(f,hold(Pe)));
end_proc:

/*
|  X2Pe(f) from X Schubert basis to Pe basis.
|  SV160698
*/
muEC::SP::X2Pe := proc(f)
local
  l; /* a set... */
begin
  l := muEC::SP::Sp2TableVar(f, hold(X));
  subs(f,
  map(l,
      proc(x) begin
        hold(X)[op(x)]=muEC::SP::X2Pe_remember(x);
      end_proc));
end_proc:

