/*
|  File Develop (SP PACKAGE) Wed May 20 21:19:37 MET DST 1998
*/

/*
|  X2x_vect(p) develops the Schubert polynomial corresponding to the
|              permutation p on the monomial basis.
|  SV200598
*/
muEC::SP::X2x_vect := proc(p)
local
  i,     /* variable for sequence... */
  maxtr; /* maximal transition for p... */
begin
/* A REFAIRE EN LISTE DE LISTES AU LIEU D'UNE SOMME DE VECTEURS
+ Transformer la liste de listes en polynomes en x ([2,0] -> x1^2)
+ muEC::SYM::m_perm_schubert_monom_summe(p);
*/
  if p=[_seqgen(i, i,1..nops(p))] then
    1;
  else
    maxtr := muEC::SP::MaxTr_short(p);
    hold(x).(op(maxtr,1)) * muEC::SP::X2x_vect(op(maxtr,2)) +
       _plus(op(map(op(maxtr,3), muEC::SP::X2x_vect)));
  end_if;
end_proc:

/*
|  Y2x_vect(c) develops the Schubert polynomial corresponding to the
|              code c on the monomial basis.
|  SV200598 VP290399
*/
muEC::SP::Y2x_vect := proc(c)
begin
  muEC::SP::X2x_vect(muEC::SG::Code2Perm(c));
end_proc:

/*
|  XX2x_vect(p) develops the double Schubert polynomial corresponding to the
|               permutation p on the monomial basis.
|  SV200598
*/
muEC::SP::XX2x_vect := proc(p)
local
  i,     /* variable for sequence... */
  maxtr; /* maximal transition for p... */
begin
/* A REFAIRE EN LISTE DE LISTES AU LIEU D'UNE SOMME DE VECTEURS
+ Transformer la liste de listes en polynomes en x,y ([2,0] -> (x1-y1)(x1-y2))
+ muEC::SYM::m_perm_??double??schubert_monom_summe(p);
*/
  if p=[_seqgen(i, i,1..nops(p))] then
    1;
  else
    maxtr := muEC::SP::MaxTr_short(p);
    (hold(x).(op(maxtr,1))-hold(y).(op(op(maxtr,2),op(maxtr,1)))) *
       muEC::SP::XX2x_vect(op(maxtr,2)) +
       _plus(op(map(op(maxtr,3), muEC::SP::XX2x_vect)));
  end_if;
end_proc:

/*
|  YY2x_vect(c) develops the double Schubert polynomial corresponding to the
|               code c on the monomial basis.
|  SV200598 VP290399
*/
muEC::SP::YY2x_vect := proc(c)
begin
  muEC::SP::XX2x_vect(muEC::SG::Code2Perm(c));
end_proc:

/*
|  Pe2x_vect(p) develops the product of elementary functions of alphabet flag
|               coded by the permutation p on the monomial basis.
|  VP220598
*/
muEC::SP::Pe2x_vect := proc(p)
local
  n, i; /* nops(p)...     */
begin
  n := nops(p);
  expand(_mult(muEC::SP::Y2x_vect([0$(n-p[-i]+i),1$p[-i]]) $ i=-n..-1));
end_proc:
