/*
|  File Monomial (SP PACKAGE) Wed May 20 18:18:48 MET DST 1998
*/

/*
|  Monomial(monom,bases) returns a table whose entries describe the sets of
|                        variables from bases that occur in monom. 
|                        bases may be a list or set of string names.
|                        If the second argument is a string ---name of a
|                        basis---, then the function assumes that monom is
|                        expressed on this basis.
|                        We talk about bases, but in fact it is the x.i's,
|                        y.i's, X[]'s, Y[]'s, XX[]'s and YY[]'s.
|                        An entry hold(coeff) is reserved for the rest of the
|                        monomial in the table.
| SV200598 VP200598
*/
muEC::SP::Monomial := proc(monom, bases)
local
  test, // the test function Ish, Iss, ...
  getv, // the current element has been treated...
  v,v1, // current elements...
  i,j,  // variables for loops...
  t;    // the table...
begin
  if testtype(bases, DOM_IDENT) then
    // we init the table...
    t := table(hold(coeff)=1, bases=1);
    test := muEC::cat("muEC::TYP::Is", bases);
    // we test the structure of the monomial...
    if testtype(monom, "_mult") then
      for i from 1 to nops(monom) do
        v := op(monom, i);
        if (testtype(v,"_power")) then
          if level(eval(test(op(v,1))), 2) then
            t[bases] := t[bases]*v;
          else
            t[hold(coeff)] := t[hold(coeff)]*v;
          end_if; 
        else
          if level(eval(test(v)), 2) then
            t[bases] := t[bases]*v;
          else
            t[hold(coeff)] := t[hold(coeff)]*v;
          end_if; 
        end_if;
      end_for;
    elif testtype(monom,"_power") then
      if level(eval(test(op(monom,1))), 2) then
        t[bases] := monom;
      else
        t[hold(coeff)] := t[hold(coeff)]*monom;
      end_if; 
    else
      // the monomial is made of one term...
      if level(eval(test(monom)), 2) then
        t[bases] := monom;
      else
        t[hold(coeff)] := t[hold(coeff)]*monom;
      end_if; 
    end_if;
  else
    // not only one basis specified...
    // we test the structure of the monomial...
    // we init the table...
    t := table(hold(coeff)=1, op(map(bases, b -> (b=1))));
    if testtype(monom,"_mult") then
      for i from 1 to nops(monom) do
        v := op(monom, i);
        if testtype(v,"_power") then
          v1 := op(v,1);
        else
          v1 := v;
        end_if;
        getv := FALSE;
        for j in bases do
          test := muEC::cat("muEC::TYP::Is",j);
          if level(eval(test(v1)), 2) then
            getv := TRUE;
            t[j] := t[j]*v;
            break;
          end_if;
        end_for;
        if not getv then
          // the current element is a coefficient...
          t[hold(coeff)] := t[hold(coeff)]*v;
        end_if;
      end_for;
    elif (testtype(monom,"_power")) then
      getv := FALSE;
      for j in bases do
        test:=muEC::cat("muEC::TYP::Is", j);
        if level(eval(test(op(monom, 1))), 2) then
          t[j] := monom;
          getv := TRUE;
          break;
        end_if; 
      end_for;
      if not getv then
        // the current element is a coefficient...
        t[hold(coeff)] := t[hold(coeff)]*monom;
      end_if;
    else
      // the monomial is made of one term...
      getv := FALSE;
      for j in bases do
        test := muEC::cat("muEC::TYP::Is", j);
        if level(eval(test(monom)), 2) then
          t[j] := monom;
          getv := TRUE;
          break;
        end_if; 
      end_for;
      if not getv then
        // the current element is a coefficient...
        t[hold(coeff)] := t[hold(coeff)]*monom;
      end_if;
    end_if;
  end_if;
  for j in bases do  
    if t[j]=1 then
 /*     t[j] := NIL;*/
/*CC*/
	delete(t[j]);
/**/
    end_if;
  end_for;
  t;
end_proc:

