/*
|  File Scalar (SP PACKAGE) Fri May 22 09:26:57 MET DST 1998
*/

/*
|  SpScalarPol(pol1, pol2) computes the scalar product <pol1, pol2>.
|
|  SV220598 VP290399
*/
muEC::SP::SpScalarPol_rec := proc(pol, n)
local
  p,   /* a partition...                   */
  i,   /* var for seq..                    */
  ind, /* indets...                        */
  c;   /* coeff of pol...                  */
begin
  if testtype(pol,"_plus") then
    map(pol, muEC::SP::SpScalarPol_rec, n);
  else
    ind := map([op(indets(pol))],
             proc(vgname,x,n) begin
               if muEC::TYP::IsName(vgname, x) and 
                  muEC::SP::EValue(vgname, x)<=n then
                 vgname;
               else
                 null();
               end_if;
             end_proc,
             hold(x),n);
    if ind=[] then
        pol;
    else
      c:=lcoeff(pol, ind);
      p := [muEC::SYMF::RedressVect([degree(pol,hold(x).i)-(n-i) $i=1..n])];
      c*op(p,2)*subs(hold(s)[op(op(p,1))], hold(s)[]=1);
    end_if;
  end_if;
end_proc:
/*
|  SV220598
*/
muEC::SP::SpScalarPol_core := proc(pol1, pol2, n)
  begin
  muEC::SP::SpScalarPol_rec(expand(pol1*pol2), n);
end_proc:
/*
|  Type Checking.
|  SV220598 VP290399
*/
muEC::SP::SpScalarPol_check:=proc(pol1, pol2, n)
begin
  if not testtype(n,DOM_INT) then
     muEC::ERR::SPPerror(5,procname);
  elif n<=0 then
    muEC::ERR::SPPerror(6,procname);
  end_if;
end_proc:

/*
|  VP300697
*/
muEC::SP::SpScalarPol := proc(pol1, pol2, n)
begin
  if testargs() then
    muEC::SP::SpScalarPol_check(args());
  end_if;
  muEC::SP::SpScalarPol_core(args());
end_proc:
