/*
|  File SpVar (SP PACKAGE) Wed May 20 19:04:52 MET DST 1998
*/

/*
|  Sp2TableVar(sp) returns a table with all Schubert polynomials and all
|                  x and y in sp. One can restrict the set of ``bases''
|                  by adding a second argument as in muEC::SP::Monomial.
|  SV200598 VP290399
*/

muEC::SP::Sp2TableVar_core := proc(sf)
local
  i,  /* var for seq...   */
  ib, /* indexed bases... */
  b,  /* bases...         */
  t;  /* a table...       */
begin
  if args(0)=2 then
    if testtype(args(2), DOM_IDENT) then
      if has(muEC::SP::SPBasesString, args(2)) then
        b := {args(2)};
        ib := {};
      else
        b := {};
        ib := {args(2)};
      end_if;
    else
      b := {op(muEC::SP::SPBasesString)} intersect args(2);
      ib := {op(muEC::SP::SPBasesIndexed)} intersect args(2);
    end_if;
  else
    b := {op(muEC::SP::SPBasesString)};
    ib := {op(muEC::SP::SPBasesIndexed)};
  end_if;
  t := table(_seqin(i=muEC::SP::AllValues(sf, i), i,[op(b)]),
             _seqin(i=muEC::SYMF::AllIndexed(sf, i), i,[op(ib)]));
  if args(0)=2 then
    if testtype(args(2), DOM_IDENT) then
      t[args(2)];
    else
      t;
    end_if;
  else
    t;
  end_if;
end_proc:

/*
|  Type Checking.
|  SV200598 VP290399
*/
muEC::SP::Sp2TableVar_check:=proc(sf)
begin
  if args(0)=2 then
    if testtype(args(2), DOM_IDENT) then
      if not has(muEC::SP::SPBases, args(2)) then
        muEC::ERR::SPPerror(4,procname);
      end_if;
    elif testtype(args(2), DOM_SET) then
      if args(2) minus {op(muEC::SP::SPBases)} <> {} then
        muEC::ERR::SPPerror(4,procname);
      end_if;
    else
      muEC::ERR::SPPerror(3,procname);
    end_if;
  end_if;
end_proc:

/*
|  SV200598
*/
muEC::SP::Sp2TableVar := proc(sf)
begin
  if testargs() then
    muEC::SP::Sp2TableVar_check(args());
  end_if;
  muEC::SP::Sp2TableVar_core(args());
end_proc:
