/*
|  File TablePe (SP PACKAGE) Tue Jun 16 16:44:45 MET DST 1998
*/

/*
|  TablePe(n) returns the table of all Pe[..] for a given symmetric group of
|             degree n (the table being indexed by integer vectors).
|             When used with the second parameter hold(X)
|             the result is expressed in the basis of Schubert polynomials.
|  SV160698 VP290399
*/
muEC::SP::TablePe_core := proc(n)
begin
  if args(0)=1 then
    table(op(map(map(muEC::SG::ListPerm(n),muEC::SG::Perm2Code),
                  proc( c) begin c=muEC::SP::Pe2x_vect(c) end_proc )));
  else
    table(op(map(map(muEC::SG::ListPerm(n),muEC::SG::Perm2Code),
                  proc( c) begin c=muEC::SP::x2X(muEC::SP::Pe2x_vect(c)) end_proc )));
  end_if;
end_proc:

/*
|  Type Checking.
|  SV220598
*/
muEC::SP::TablePe_check := proc(n)
begin
  if not testtype(n,DOM_INT) then
    muEC::ERR::SPPerror(1,procname);
  elif n<=0 then
    muEC::ERR::SPPerror(2,procname);
  end_if;
  if args(0)=2 then
    if not testtype(args(2),DOM_IDENT) then
      muEC::ERR::SPPerror(3,procname);
    elif not contains({hold(X)}, args(2)) then
      muEC::ERR::SPPerror(4,procname);
    end_if;
  end_if;
end_proc:

/*
|  SV220598
*/
muEC::SP::TablePe := proc(n)
begin
  if testargs() then
    muEC::SP::TablePe_check(args());
  end_if;
  muEC::SP::TablePe_core(args());
end_proc:
