/*
|  File TableY (SP PACKAGE) Mon May 25 18:17:43 MET DST 1998
*/

/*
|  TableY(n) returns the table of all Schubert polynomials lying in
|            the symmetric group of degree n (the table being indexed
|            by codes).
|  SV250598 VP290399
*/
muEC::SP::TableY_core := proc(n)
local
  t, i; /* a table... */
begin
  t := muEC::SP::TableX(args());
  table(_seqgen(muEC::SG::Perm2Code(op(op(t,i),1))=op(op(t,i),2), i,1..nops(t)));
end_proc:

/*
|  Type Checking.
|  SV250598 VP290399
*/
muEC::SP::TableY_check := proc(n)
begin
  if not testtype(n,DOM_INT) then
    muEC::ERR::SPPerror(1,procname);
  elif n<=0 then
    muEC::ERR::SPPerror(2,procname);
  end_if;
  if args(0)=2 then
    if not testtype(args(2),DOM_IDENT) then
      muEC::ERR::SPPerror(3,procname);
    elif not contains({hold(Pe)}, args(2)) then
      muEC::ERR::SPPerror(4,procname);
    end_if;
  end_if;
end_proc:

/*
|  SV250598
*/
muEC::SP::TableY := proc(n)
begin
  if testargs() then
    muEC::SP::TableY_check(args());
  end_if;
  muEC::SP::TableY_core(args());
end_proc:
