/*
|  File Toxy (SP PACKAGE) Wed May 20 19:00:27 MET DST 1998
*/

/*
|  Tox(pol,b) expresses pol on the x basis assuming that pol is expressed
|             solely in terms of the base b (x, y, X, Y, XX, YY, Pe).
|             Whenever the second argument is forgotten
|             no supposition is made on the bases appearing in pol.
|             pol is expanded before any computation except when the argument
|             noexpand specifies that no expansion should be done.
|             The result is NOT collected with respect to the xi's.
|  SV200598 SV160698 VP290399
*/
muEC::SP::Tox_heart:=proc(pol)
local
  i,   /* var for seq...          */
  j,   /* var for seq...          */
  sf,  /* seq of functions...     */
  ind, /* indices...              */
  t;   /* a table of variables... */
begin
  if args(0)=1 then
    t := muEC::SP::Sp2TableVar(pol, {op(muEC::SP::SPBasesIndexed)});
  elif testtype(args(2), DOM_SET) then
    t := muEC::SP::Sp2TableVar(pol, args(2) minus {op(muEC::SP::SPBasesString)});
  else
    t := muEC::SP::Sp2TableVar(pol, {args(2)} minus {op(muEC::SP::SPBasesString)});
  end_if;
  ind := map([op(t)], op, 1);
  ind := map(ind, proc(x) begin if t[x]={} then null() else x end_if end_proc);
  sf := [_seqin(_seqin(muEC::cat("muEC::SP::",i,"2x_vect"), j,t[i]), i,ind)];
  ind := [_seqin(_seqin(i, j,t[i]), i,ind)];
  subs(pol,
       _seqgen(_seqin((ind[i])[op(j)]=level(eval(sf[i](j)),2), j,t[ind[i]]),
           i,1..nops(ind)));
end_proc:

/*
|  SV200598 VP290399
*/
muEC::SP::Tox := proc(pol)
local
  allv, /* all values... */
  r;    /* the result... */
begin
  if args(0)=1 then
    muEC::SP::Tox_heart(expand(pol));
  elif args(0)=2 then
    if args(2)=hold(NoExpand) then
      muEC::SP::Tox_heart(pol);
    elif args(2)=hold(Collect) then
      r := muEC::SP::Tox_heart(pol);
      allv := [op(map(muEC::SP::AllValues(r, hold(x)), proc( i) begin hold(x).i end_proc )),
               op(map(muEC::SP::AllValues(r, hold(y)), proc( i) begin hold(y).i end_proc ))];
      if nops(allv) <> 0 then
        collect(r, allv);
      else
        r;
      end_if;
    else
      muEC::SP::Tox_heart(expand(pol), args(2));
    end_if;
  elif args(0)=3 then
    if args(2)=hold(NoExpand) then
      if args(3)=hold(Collect) then
        r := muEC::SP::Tox_heart(pol);
        allv := [op(map(muEC::SP::AllValues(r, hold(x)), proc( i) begin hold(x).i end_proc )),
                 op(map(muEC::SP::AllValues(r, hold(y)), proc( i) begin hold(y).i end_proc ))];
        if nops(allv) <> 0 then
          collect(r, allv);
        else
          r;
        end_if;
      else
        muEC::SP::Tox_heart(pol, args(3));
      end_if;
    elif args(3)=hold(Collect) then
      r := muEC::SP::Tox_heart(expand(pol),args(2));
      allv := [op(map(muEC::SP::AllValues(r, hold(x)), proc( i) begin hold(x).i end_proc )),
               op(map(muEC::SP::AllValues(r, hold(y)), proc( i) begin hold(y).i end_proc ))];
      if nops(allv) <> 0 then
        collect(r, allv);
      else
        r;
      end_if;
    else
      muEC::ERR::SPPerror(9, procname);
    end_if;
  else
    if args(2)<>hold(NoExpand) then
      muEC::ERR::SPPerror(4,procname);
    elif args(4)<>hold(Collect) then
      muEC::ERR::SPPerror(6,procname);
    end_if;
    r := muEC::SP::Tox_heart(pol, args(3));
    allv := [op(map(muEC::SP::AllValues(r, hold(x)), proc( i) begin hold(x).i end_proc )),
             op(map(muEC::SP::AllValues(r, hold(y)), proc( i) begin hold(y).i end_proc ))];
    if nops(allv) <> 0 then
      collect(r, allv);
    else
      r;
    end_if;
  end_if;
end_proc:
