/*
|  File X2Dim (SP PACKAGE) Mon May 25 19:08:15 MET DST 1998
*/

/*
|  X2Dim(f) specializes all Schubert polynomials in hold(x).i=1, or hold(x).i=q^(i-1).
|  SV250598
*/
muEC::SP::X2Dimmonom := proc(p)
local
  i,     /* variable for sequence... */
  maxtr; /* maximal transition for p... */
option remember; /* essential in the transition algorithm... */
begin
  if p=[_seqgen(i, i,1..nops(p))] then
    1;
  else
    maxtr := muEC::SP::MaxTr_short(p);
    if args(0)=1 then
     muEC::SP::X2Dimmonom(op(maxtr,2)) +
                     _plus(op(map(op(maxtr,3),muEC::SP::X2Dimmonom)));
    else
      hold(q)^(op(maxtr,1)-1)*muEC::SP::X2Dimmonom(op(maxtr,2),hold(q)) +
                  _plus(op(map(op(maxtr,3),muEC::SP::X2Dimmonom,hold(q))));
    end_if;
  end_if;
end_proc:

/*
|  SV250598
*/
muEC::SP::X2Dim_core := proc(f)
local
  t; /* a set of indices... */
begin
  t := muEC::SP::Sp2TableVar(f, hold(X));
  if args(0)=1 then
    subs(f,map(t, proc( p) begin hold(X)[op(p)]=muEC::SP::X2Dimmonom(p) end_proc ));
  else
    subs(f,map(t, proc( p, v) begin hold(X)[op(p)]=muEC::SP::X2Dimmonom(p,v) end_proc , args(2)));
  end_if;
end_proc:

/*
|  Type Checking.
|  SV250598 VP290399
*/
muEC::SP::X2Dim_check := proc(p)
begin
  if args(0)>1 then
    if not testtype(args(2),DOM_IDENT) then
      muEC::ERR::SPPerror(3,procname);
    elif args(2)<>hold(q) then
      muEC::ERR::SPPerror(4,procname);
    end_if;
  end_if;
end_proc:

/*
|  SV250598
*/
muEC::SP::X2Dim := proc(p)
begin
  if testargs() then
    muEC::SP::X2Dim_check(args());
  end_if;
  muEC::SP::X2Dim_core(args());
end_proc:
