/*
|  File XXbyXX (SP PACKAGE) Wed Jun 17 08:51:20 MET DST 1998
*/

/*
|  XXbyXX(sch1,sch2) multiplies two double Schubert polynomials.
|  SV170698
*/
muEC::SP::XXbyXX := proc(sch1,sch2)
local
  t,
  p1,
  p2,
  f,
  g,
  r;
begin
  if testtype(sch1, "_index") and testtype(sch2, "_index") then
/* this should be done in SYMMETRICA in the future...
    r := muEC::SYM::mult_2schubert_2schubert(sch1, sch2);
*/
    p1 := muEC::SP::ReduceP([op(sch1,2..nops(sch1))]);
    p2 := muEC::SP::ReduceP([op(sch2,2..nops(sch2))]);
    if nops(p2) > nops(p1) then
      r := p1;
      p1 := p2; /* the biggest one... */
      p2 := r;
    end_if;
    g := proc(polxyXX) begin
         if testtype(polxyXX, "_plus") then
           map(polxyXX, g);
         else
           t := muEC::SP::Monomial(polxyXX,hold(XX));
           if t[hold(XX)]=hold(t[XX]) then
             t[hold(coeff)];
           else
             f([op(t[hold(XX)],2..nops(t[hold(XX)]))], t[hold(coeff)]);
           end_if;
         end_if;
         end_proc;
    f := proc(pm,polxy) local t,i, pow, var; begin
         if testtype(polxy,"_plus") then
           _plus(_seqgen(f(pm,op(polxy,i)),i,1..nops(polxy)));
         else
           t := muEC::SP::Monomial(polxy,hold(x));
           if t[hold(x)]=hold(t[x]) then
             t[hold(coeff)]*hold(XX)[op(pm)];
           elif testtype(t[hold(x)], DOM_IDENT) then
             muEC::SP::Monk(muEC::SP::EValue(t[hold(x)], hold(x)), hold(XX)[op(pm)]);
           elif testtype(t[hold(x)], "_power") then
             pow := op(t[hold(x)],2);
             var := op(t[hold(x)],1);
             g(expand(var^(pow-1)*muEC::SP::Monk(muEC::SP::EValue(var, hold(x)),
                    hold(XX)[op(pm)])));
           else
             g(expand(op(t[hold(x)],1..nops(t[hold(x)]-1))*
                      f(pm, op(t[hold(x)],nops(t[hold(x)])))));
           end_if;
         end_if;
         end_proc;
    r := f(p1,expand(muEC::SP::XX2x_vect(p2)));
  else
    r := _mult(sch1,sch2); /* since we may have a scalar... */
  end_if;
  muEC::SP::SpSpecialize(r,hold(XX),proc(perm) begin hold(XX)[op(muEC::SP::ReduceP(perm))] end_proc );
end_proc:

/*
|  XXProduct(sp) applies XXbyXX on sp, when it is either a product, a
|                power or a sum of Schubert polynomials.
|  SV170698 VP290399
*/
muEC::SP::XXProduct := proc(sp)
local
  pow, /* a power...               */
  sch, /* a schubert polynomial... */
  mn,
  r;   /* a result...              */
option remember;
begin
  if testtype(sp, "_power") then
    mn := op(sp,1); pow := op(sp,2);
    if (pow=2) then
      muEC::SP::XXbyXX(mn,mn);
    elif (pow=3) then
      r := expand(mn*muEC::SP::XXbyXX(mn,mn));
      if testtype(r,"_plus") then
        map(r,muEC::SP::XXProduct);
      else
        muEC::SP::XXProduct(r);
      end_if;
    elif not testtype(pow,DOM_INT) then
      sp;
    else
      r := expand(mn^(pow-2)*muEC::SP::XXbyXX(mn,mn));
      if testtype(r,"_plus") then
        map(r,muEC::SP::XXProduct);
      else
        muEC::SP::XXProduct(r);
      end_if;
    end_if;
  elif testtype(sp, "_mult") then
    if testtype(op(sp,1),"_power") then
      if muEC::TYP::IsXX(op(op(sp,1),1)) then
        r := expand(_mult(muEC::SP::XXProduct(op(sp,1)),op(sp,2..nops(sp))));
        if testtype(r,"_plus") then
          map(r,muEC::SP::XXProduct);
        else
          muEC::SP::XXProduct(r);
        end_if;
      else
        expand(op(sp,1)*muEC::SP::XXProduct(_mult(op(sp,2..nops(sp)))))
      end_if;
    elif not muEC::TYP::IsXX(op(sp,1)) then
      expand(op(sp,1)*muEC::SP::XXProduct(_mult(op(sp,2..nops(sp)))));
    else
      r := expand(muEC::SP::XXProduct(_mult(op(sp,2..nops(sp)))));
      if testtype(r,"_plus") then
        map(map(r,_mult,op(sp,1)),muEC::SP::ToXX);
      else
        sch := hold(XX)[op(op(muEC::SYMF::AllIndexed(r, hold(XX))))];
        if sch=hold(XX)[] then
          op(sp,1)*r;
        else
          expand(r/sch*muEC::SP::XXbyXX(sch,op(sp,1)));
        end_if;
      end_if;
    end_if;
  elif testtype(sp, "_plus") then
    map(sp,muEC::SP::XXProduct);
  else
    sp;
  end_if;
end_proc:
