/*
|  File XbyX (SP PACKAGE) Tue Jun 16 18:42:58 MET DST 1998
*/

/*
|  XbyX(sch1,sch2) multiplies two Schubert polynomials.
|  SV160698
*/
muEC::SP::XbyX := proc(sch1,sch2)
local
  r;
begin
  if testtype(sch1, "_index") and testtype(sch2, "_index") then
    r := muEC::SYM::mult_schubert_schubert(sch1, sch2);
  else
    r := _mult(sch1,sch2); /* since we may have a scalar... */
  end_if;
  muEC::SP::SpSpecialize(r,hold(X),proc(perm) begin hold(X)[op(muEC::SP::ReduceP(perm))] end_proc );
end_proc:

/*
|  XProduct(sp) applies XbyX on sp, when it is either a product, a
|               power or a sum of Schubert polynomials.
|  SV160698 VP290399
*/
muEC::SP::XProduct := proc(sp)
local
  pow, /* a power...               */
  sch, /* a schubert polynomial... */
  mn,
  r;   /* a result...              */
option remember;
begin
  if testtype(sp, "_power") then
    mn := op(sp,1); pow := op(sp,2);
    if (pow=2) then
      muEC::SP::XbyX(mn,mn);
    elif (pow=3) then
      r := expand(mn*muEC::SP::XbyX(mn,mn));
      if testtype(r,"_plus") then
        map(r,muEC::SP::XProduct);
      else
        muEC::SP::XProduct(r);
      end_if;
    elif not testtype(pow,DOM_INT) then
      sp;
    else
      r := expand(mn^(pow-2)*muEC::SP::XbyX(mn,mn));
      if testtype(r,"_plus") then
        map(r,muEC::SP::XProduct);
      else
        muEC::SP::XProduct(r);
      end_if;
    end_if;
  elif testtype(sp, "_mult") then
    if testtype(op(sp,1),"_power") then
      if muEC::TYP::IsX(op(op(sp,1),1)) then
        r := expand(_mult(muEC::SP::XProduct(op(sp,1)),op(sp,2..nops(sp))));
        if testtype(r,"_plus") then
          map(r,muEC::SP::XProduct);
        else
          muEC::SP::XProduct(r);
        end_if;
      else
        expand(op(sp,1)*muEC::SP::XProduct(_mult(op(sp,2..nops(sp)))));
      end_if;
    elif not muEC::TYP::IsX(op(sp,1)) then
      expand(op(sp,1)*muEC::SP::XProduct(_mult(op(sp,2..nops(sp)))));
    elif testtype(op(sp,2), "_power") then
      r := expand(map(sp, muEC::SP::XProduct));
      if testtype(r,"_plus") then
        map(r,muEC::SP::XProduct);
      else
        muEC::SP::XProduct(r);
      end_if;
    else
      r := expand(muEC::SP::XProduct(_mult(op(sp,2..nops(sp)))));
      if testtype(r,"_plus") then
        map(map(r,_mult,op(sp,1)),muEC::SP::XProduct);
      else
        sch := hold(X)[op(op(muEC::SYMF::AllIndexed(r, hold(X))))];
        if sch=hold(X)[] then
          op(sp,1)*r;
        else
          expand(r/sch*muEC::SP::XbyX(sch,op(sp,1)));
        end_if;
      end_if;
    end_if;
  elif testtype(sp, "_plus") then
    map(sp,muEC::SP::XProduct);
  else
    sp;
  end_if;
end_proc:
