/**
|  File SYMF.mu (muEC::SYMF PACKAGE) Wed Oct 22 13:26:41 MET DST 1997
|
|            The 'muEC::SYMF' library for manipulating symmetric functions.
|
| VP221097 VP02098 VP250498
**/

/**
User Functions:

muEC::SYMF::RedressVect    -  Redresses a partition of a Schur function
**/

/**
Algorithms for SYMF are adapted from both ACE and SYMMETRICA.
**/

muEC::SYMF            := newDomain("muEC::SYMF"):
muEC::SYMF::info      := "Library muEC::SYMF: manipulating SYMmetric Functions":
muEC::SYMF::interface := { Char2Sf, Sf2Char, Sf2Table, Sf2TableVar, SfCCProd,
                       SfCollect, SfDiff, SfEval, SfInternal, SfJtMat, SfMat,
                       SfOmega, SfPlethysm, SfScalar, SfTheta, SfZee,
                       Table2Sf, Toe, Toh, Top, Tom, Tos
                       // KostkaNumber, KostkaTable,
                       }:
muEC::SYMF::SYMFAlgBases := [ hold(e), hold(h), hold(p) ]:
muEC::SYMF::SYMFBases := [op(muEC::SYMF::SYMFAlgBases), hold(m), hold(s) ]:

/*
  seq(protect(k,Error), k=muEC::SYMF::SYMFBases):
  seq(protect(k,Warning), k=muEC::SYMF::SYMFBases):
*/

alias(path = pathname("MUEC", "SYMF")):

muEC::SYMF::AllIndexed       := loadproc(muEC::SYMF::AllIndexed       , path, "AllInd"  ):
muEC::SYMF::Char2Sf          := loadproc(muEC::SYMF::Char2Sf          , path, "Char2Sf" ):
muEC::SYMF::e2h              := loadproc(muEC::SYMF::e2h              , path, "e2"      ):
muEC::SYMF::e2p              := loadproc(muEC::SYMF::e2p              , path, "e2"      ):
muEC::SYMF::e2m              := loadproc(muEC::SYMF::e2m              , path, "e2"      ):
muEC::SYMF::e2s              := loadproc(muEC::SYMF::e2s              , path, "e2"      ):
muEC::SYMF::h2e              := loadproc(muEC::SYMF::h2e              , path, "h2"      ):
muEC::SYMF::h2p              := loadproc(muEC::SYMF::h2p              , path, "h2"      ):
muEC::SYMF::h2m              := loadproc(muEC::SYMF::h2m              , path, "h2"      ):
muEC::SYMF::h2s              := loadproc(muEC::SYMF::h2s              , path, "h2"      ):
muEC::SYMF::KostkaNumber     := loadproc(muEC::SYMF::KostkaNumber     , path, "Kostka"  ):
muEC::SYMF::KostkaTable      := loadproc(muEC::SYMF::KostkaTable      , path, "Kostka"  ):
muEC::SYMF::LRrSf            := loadproc(muEC::SYMF::LRrSf            , path, "LRrSf"   ):
muEC::SYMF::Monomial         := loadproc(muEC::SYMF::Monomial         , path, "Monomial"):
//muEC::SYMF::Muir1            := loadproc(muEC::SYMF::Muir1            , path, "Muir1"      ):
muEC::SYMF::Muir1            := ()->error("muEC::SYMF::Muir1 not implemented"):
muEC::SYMF::MuirSf           := loadproc(muEC::SYMF::MuirSf           , path, "MuirSf"      ):
muEC::SYMF::m2e              := loadproc(muEC::SYMF::m2e              , path, "m2"      ):
muEC::SYMF::m2h              := loadproc(muEC::SYMF::m2h              , path, "m2"      ):
muEC::SYMF::m2p              := loadproc(muEC::SYMF::m2p              , path, "m2"      ):
muEC::SYMF::m2s              := loadproc(muEC::SYMF::m2s              , path, "m2"      ):
muEC::SYMF::p2e              := loadproc(muEC::SYMF::p2e              , path, "p2"      ):
muEC::SYMF::p2h              := loadproc(muEC::SYMF::p2h              , path, "p2"      ):
muEC::SYMF::p2m              := loadproc(muEC::SYMF::p2m              , path, "p2"      ):
muEC::SYMF::p2s              := loadproc(muEC::SYMF::p2s              , path, "p2"      ):
muEC::SYMF::PieriSf          := loadproc(muEC::SYMF::PieriSf          , path, "PieriSf" ):
muEC::SYMF::Pletes           := loadproc(muEC::SYMF::Pletes           , path, "Pletes"  ):
//muEC::SYMF::Plethh           := loadproc(muEC::SYMF::Plethh           , path, "Plethh"  ):
muEC::SYMF::Plethh           :=()->error("muEC::SYMF::Plethh not implemented"):
muEC::SYMF::Pleths           := loadproc(muEC::SYMF::Pleths           , path, "Pleths"  ):
muEC::SYMF::Pletpp           := loadproc(muEC::SYMF::Pletpp           , path, "Pletpp"  ):
muEC::SYMF::Pletppp          := loadproc(muEC::SYMF::Pletppp          , path, "Pletppp" ):
muEC::SYMF::Pletps           := loadproc(muEC::SYMF::Pletps           , path, "Pletps"  ):
muEC::SYMF::Pletss           := loadproc(muEC::SYMF::Pletss           , path, "Pletss"  ):
muEC::SYMF::RedressVect      := loadproc(muEC::SYMF::RedressVect      , path, "RedrVect"):
muEC::SYMF::s2e              := loadproc(muEC::SYMF::s2e              , path, "s2"      ):
muEC::SYMF::s2h              := loadproc(muEC::SYMF::s2h              , path, "s2"      ):
muEC::SYMF::s2p              := loadproc(muEC::SYMF::s2p              , path, "s2"      ):
muEC::SYMF::s2m              := loadproc(muEC::SYMF::s2m              , path, "s2"      ):
muEC::SYMF::SchurProduct     := loadproc(muEC::SYMF::SchurProduct     , path, "LRrSf"   ):
muEC::SYMF::Sf2Char          := loadproc(muEC::SYMF::Sf2Char          , path, "Sf2Char" ):
muEC::SYMF::Sf2TableVar      := loadproc(muEC::SYMF::Sf2TableVar      , path, "SfVar"   ):
muEC::SYMF::Sf2Table         := loadproc(muEC::SYMF::Sf2Table         , path, "Table"   ):
muEC::SYMF::SfCCProd         := loadproc(muEC::SYMF::SfCCProd         , path, "SfCCProd"):
muEC::SYMF::SfCollect        := loadproc(muEC::SYMF::SfCollect        , path, "CollctSf"):
muEC::SYMF::SfDiff           := loadproc(muEC::SYMF::SfDiff           , path, "SfDiff"  ):
muEC::SYMF::SfEval           := loadproc(muEC::SYMF::SfEval           , path, "SfEval"  ):
muEC::SYMF::SfInternal       := loadproc(muEC::SYMF::SfInternal       , path, "Internal"):
muEC::SYMF::SfJtMat          := loadproc(muEC::SYMF::SfJtMat          , path, "SfJtMat" ):
muEC::SYMF::SfMat            := loadproc(muEC::SYMF::SfMat            , path, "SfMat"   ):
muEC::SYMF::SfOmega          := loadproc(muEC::SYMF::SfOmega          , path, "SfOmega" ):
muEC::SYMF::SfPlethysm       := loadproc(muEC::SYMF::SfPlethysm       , path, "Plethysm"):
muEC::SYMF::SfScalar         := loadproc(muEC::SYMF::SfScalar         , path, "SfScalar"):
muEC::SYMF::SfTheta          := loadproc(muEC::SYMF::SfTheta          , path, "SfTheta" ):
muEC::SYMF::SfZee            := loadproc(muEC::SYMF::SfZee            , path, "SfZee"   ):
muEC::SYMF::Table2Sf         := loadproc(muEC::SYMF::Table2Sf         , path, "Table"   ):
muEC::SYMF::Toe              := loadproc(muEC::SYMF::Toe              , path, "ToSf"    ):
muEC::SYMF::Toh              := loadproc(muEC::SYMF::Toh              , path, "ToSf"    ):
muEC::SYMF::Top              := loadproc(muEC::SYMF::Top              , path, "ToSf"    ):
muEC::SYMF::Tom              := loadproc(muEC::SYMF::Tom              , path, "ToSf"    ):
muEC::SYMF::Tos              := loadproc(muEC::SYMF::Tos              , path, "ToSf"    ):
muEC::SYMF::ToSf             := loadproc(muEC::SYMF::ToSf             , path, "ToSf"    ):

unalias(path):
