/*
|  File Kostka (SYMF PACKAGE) Tue Apr 28 20:05:59 MET DST 1998
*/

/*
|  KostkaNumber (part,content)     computes the kostkanumber, i.e. the number
|               of tableaux of given shape, and of given content.
|  KostkaNumber (skewpart,content) computes the number of skewtableaux of the
|               given shape.
|  VP280498
*/
muEC::SYMF::KostkaNumber_core := proc(part1,part2)
begin
  muEC::SYM::KostkaNumber(part1,part2);
end_proc:

/*
|  Type Checking
|  VP280498
*/
muEC::SYMF::KostkaNumber_check := proc(part1,part2)
begin
  if (not muEC::TYP::IsPart(part1)) and (not muEC::TYP::IsSkewPart(part1)) then
    muEC::ERR::SYMFPerror(1,procname);
  elif not muEC::TYP::IsPart(part2) then
    muEC::ERR::SYMFPerror(3,procname);
  end_if;
end_proc:

/*
| VP280498
*/
muEC::SYMF::KostkaNumber := proc(part1, part2)
begin
  if testargs() then
    muEC::SYMF::KostkaNumber_check(args());
  end_if;
  muEC::SYMF::KostkaNumber_core(args());
end_proc:

/*
|  KostkaTable (part,content)      computes the list of tableaux of a given
|                                  shape, and of a given content.
|  KostkaNumber (skewpart,content) computes the number of skewtableaux of the
|                                  given shape.
|  VP280498
*/
muEC::SYMF::KostkaTable_core := proc(part1,part2)
begin
  muEC::SYM::KostkaTable(part1,part2);
end_proc:

/*
|  Type Checking
|  VP280498
*/
muEC::SYMF::KostkaTable_check := proc(part1,part2)
begin
  if (not muEC::TYP::IsPart(part1)) and (not muEC::TYP::IsSkewPart(part1)) then
    muEC::ERR::SYMFPerror(1,procname);
  elif not muEC::TYP::IsPart(part2) then
    muEC::ERR::SYMFPerror(3,procname);
  end_if;
end_proc:

/*
| VP280498
*/
muEC::SYMF::KostkaTable := proc(part1, part2)
begin
  if testargs() then
    muEC::SYMF::KostkaTable_check(args());
  end_if;
  muEC::SYMF::KostkaTable_core(args());
end_proc:
