/*
|  File LRrSf (SYMF PACKAGE) Tue Dec  2 17:55:26 MET 1997
*/

/*
|  LRrSf(sch1,sch2) multiplies two Schur functions (Littlewood-Richardson)
|  VP021297
*/
muEC::SYMF::LRrSf := proc(sch1,sch2)
begin
  if testtype(sch1, "_index") and testtype(sch2, "_index") then
   if bool(sch1=hold(s)[]) then
      if bool(sch2=hold(s)[]) then
        1;
      else
        sch2;
      end_if;
    elif bool(sch2=hold(s)[]) then
      sch1;
    else
      muEC::SYM::LRrSf(sch1, sch2);
    end_if;
  else
     _mult(sch1,sch2); /* since we may have a scalar... */
  end_if;
end_proc:

/*
|  SchurProduct(sf) applies LRrSf on sf, when it is either a product, a
|                   power or a sum of Schur functions.
|  VP021297 VP121297 VP270498
*/
muEC::SYMF::SchurProduct := proc(sf)
local
  pow, /* a power...          */
  mn;
option remember;
begin
  if testtype(sf, "_power") then
    mn := op(sf,1); pow := op(sf,2);
    if bool(mn=hold(s)[]) then
      1;
    elif (pow=2) then
      muEC::SYMF::LRrSf(mn,mn);
    elif (pow=3) then
      map(map(muEC::SYMF::LRrSf(mn,mn), _mult, mn),muEC::SYMF::SchurProduct);
    elif not testtype(pow,DOM_INT) then
      sf;
    else
      map(map(muEC::SYMF::LRrSf(mn,mn), _mult, _power(mn,pow-2)),
          muEC::SYMF::SchurProduct);
    end_if;
  elif testtype(sf, "_mult") then
    if testtype(op(sf,1),"_power") then
      map(expand(_mult(muEC::SYMF::SchurProduct(op(sf,1)),op(sf,2..nops(sf)))),
        muEC::SYMF::SchurProduct);
    elif not testtype(op(sf,1), "_index") then
      map(muEC::SYMF::SchurProduct(_mult(op(sf,2..nops(sf)))), _mult, op(sf,1));
    elif testtype(op(sf,2), "_power") then
      map(expand(map(sf, muEC::SYMF::SchurProduct)), muEC::SYMF::SchurProduct);
    else
      map(expand(_mult(muEC::SYMF::LRrSf(op(sf,1),op(sf,2)),op(sf, 3..nops(sf)))),
          muEC::SYMF::SchurProduct);
    end_if;
  elif testtype(sf, "_plus") then
   map(sf,muEC::SYMF::SchurProduct);
  elif bool(sf=hold(s)[]) then
    1;
  else
    sf;
  end_if;
end_proc:
