/*
|  File PieriSf (SYMF PACKAGE) Thu Nov 27 15:07:55 MET 1997
*/

/*
|  PieriSf(f,sch) develops the product e.I * sch (respectively h.I) on the
|                 Schur basis (sch is a Schur "function") using the Pieri
|                 formula !  f is e.I or h.I.
|  VP271197
*/
  /* k stands for h.k, p stands for the partition...              */
  /* nb is the maximal number of boxes you may put on a row fr... */
  /* so that the result is still a partition...                   */
muEC::SYMF::PieriDSfrec := proc(k,p,nb,fr)
	local i;		       
begin
  if (k=0) then
    [p];
  elif (nb=0) then
    muEC::SYMF::PieriDSfrec(k,p,min(k,p[fr]-p[fr+1]),fr+1);
  elif (p[fr]=0) then
    if (nb<k) then
      [];
    else
      [subsop(p,fr=p[fr]+k)];
    end_if;
  else
    [op(muEC::SYMF::PieriDSfrec(k-i,subsop(p,fr=p[fr]+i),
                                min(k-i,p[fr]-p[fr+1]),fr+1))
     $ i=0..nb]
  end_if;
end_proc:

/*
|  VP271197
*/
  /* v is TRUE if one may put a box on the row fr... */
  /* so that the result is still a partition...      */
  /* k stands for e.k, p stands for the partition... */
  /* l is the length of the partition + the k 0's... */
muEC::SYMF::PieriSfrec:=proc(k,p,v,l,fr)
local
  r, /* temporary result... */
  i, /* variable for sequence... */
  j; /* variable for loop... */
begin
  if (not v) then
    muEC::SYMF::PieriSfrec(k,p,p[fr]<>p[fr+1],l,fr+1);
  elif (fr=l-k+1) then
    [subsop(p,(i=p[i]+1)$i=fr..fr+k-1)];
  else
    if (k=1) then
      r := subsop(p,fr=p[fr]+1);
      for j from fr+1 to l do
        if (p[j]<p[j-1]) then
          r := r,subsop(p,j=p[j]+1);
        end_if;
      end_for;
      [r];
    else
      if (fr=1) then
        [op(muEC::SYMF::PieriSfrec(k,p,p[fr]<>p[fr+1],l,fr+1)),
         op(muEC::SYMF::PieriSfrec(k-1,subsop(p,fr=p[fr]+1),TRUE,l-1,fr+1))]
      elif (p[fr-1]=p[fr]) then
        muEC::SYMF::PieriSfrec(k,p,p[fr]<>p[fr+1],l,fr+1)
      else
        [op(muEC::SYMF::PieriSfrec(k,p,p[fr]<>p[fr+1],l,fr+1)),
         op(muEC::SYMF::PieriSfrec(k-1,subsop(p,fr=p[fr]+1),TRUE,l-1,fr+1))]
      end_if;
    end_if;
  end_if;
end_proc:

/*
|  VP271197
*/
muEC::SYMF::PieriSf := proc(f,sch)
local
  p,   /* a partition...  */
  n,   /* nops(sch)...    */
  i,j; /* vars for seq... */
begin
print("PieriSf ne marche pas -> SYMMETRICA");
  p := [op(f, 2..nops(f))];
  n := nops(sch);
  if (op(f,1)=hold(e)) then
    if (op(sch,2..n)=null()) then
      _mult(_seqgen(hold(s)[_seqgen(1, i,1..op(p,j))],j,1..nops(p)));
    elif (p=[]) then
      sch;
    else
      _mult(_seqgen(
      _plus(op(map(
      muEC::SYMF::PieriSfrec(op(p,i),[op(sch,2..n),_seqgen(0,
                               i,1..op(p,i))],TRUE,nops([op(sch,2..n)])+op(p,i),1),
      proc(x) begin hold(s)[op(subs(x, 0=null()))]; end_proc ))),
      j,1..nops(p)));
    end_if;
  else /* a product of complete functions... */
    if (op(sch,2..n)=null()) then
      _mult(_seqgen(hold(s)[op(p,j)], j,1..nops(p)));
    elif (p=[]) then
      sch;
    else
      _mult(_seqgen(
      _plus(op(map(
              muEC::SYMF::PieriDSfrec(op(p,i),[op(sch,2..n),0],op(p,i),1),
              proc(x) begin hold(s)[op(subs(x,0=null()))]; end_proc
            ))),
      j,1..nops(p)));
    end_if;
  end_if;
end_proc:
