/*
|  File Pletpp (SYMF PACKAGE) Fri Apr 24 19:51:23 MET DST 1998
*/

/*
|  Pletpp(sf1, sf2) expresses the result of the plethysm sf1[sf2] on the
|                   Schur functions basis. sf1 is on the p-basis and sf2 on
|                   the p-basis.
|
|  Pletpp(sf1, sf2, lg<=k) is the same function, but the Schur functions in the
|                        result have a length <= k.
|
|  Pletpp(sf1, sf2, part<=k) is the same function, but the Schur functions in
|                            the result have their parts <= k.
|  VP240498
*/
muEC::SYMF::Pletpp := proc(sf1, sf2)
local
  opts,
  t,     /* a table...                  */
  r,     /* the result...               */
  mx,    /* maximal part in result...   */
  l;     /* maximal length in result... */
begin
  l := NIL; mx := NIL;
  if args(0)=3 then
    opts:=args(3);
    if testargs() and not testtype(opts, "_leequal") then
        error("Optional argument should be of the form option=value")
    end_if;
    if (op(opts,1)=hold(lg)) then
      l := op(opts,2);
    else
      mx := op(opts,2);
    end_if;
  end_if;
  if muEC::TYP::Isp(sf2) then
    if muEC::TYP::Isp(sf1) then
      r := muEC::SYMF::Pletpp_elem(sf1,sf2,l,mx);
    elif testtype(sf1,"_plus") then
        r := map(sf1, muEC::SYMF::Pletpp, sf2, args(3..args(0)));
    elif (sf1=hold(h)[]) then
      r := 1;
    else
      t := muEC::SYMF::Monomial(sf1, hold(p));
      r :=  t[hold(coeff)]
          * muEC::SYMF::Pletpp(t[hold(p)],sf2, args(3..args(0)));
    end_if;
    sysassign(muEC::SYMF::Pletpp_elem,
              muEC::clearRememberTable(muEC::SYMF::Pletpp_elem));
    r;
  else /* a temporary solution... */
/*
ATTENTION, LES OPTIONS NE PEUVENT ETRE PASSEES QUE SOUS CERTAINES
CONDITIONS. -> A VOIR.
    muEC::SYMF::Tos(muEC::SYMF::Pletppp(muEC::SYMF::Top(sf1),muEC::SYMF::Top(sf2), opts ));
*/
    muEC::SYMF::Tos(muEC::SYMF::Pletppp(muEC::SYMF::Top(sf1),muEC::SYMF::Top(sf2)));
  end_if;
end_proc:

/*
| VP240498
*/
muEC::SYMF::Pletpp_elem := proc(p1,p2,l,mx)
option remember;
begin
  if testtype(l, DOM_INT) then
    muEC::SYM::Pletpps_elem_l(l,p1,p2):
  elif testtype(mx, DOM_INT) then
    muEC::SYM::Pletpps_elem_mx(mx,p1,p2):
  else
    muEC::SYM::Pletpps_elem(p1,p2):
  end_if;
end_proc:
