/*
|  File Pletppp (SYMF PACKAGE) Fri Dec 12 12:11:13 MET 1997
*/

/*
|  Pletppp(sf1, sf2) expresses the result of the plethysm sf1[sf2] on the
|                   products of power sums basis. sf1 and sf2 are on the
|                   p-basis.
|
|  Pletppp(sf1, sf2, lg<=k) is the same function, but the products of power
|                          sums in the result have a length <= k.
|
|  Pletppp(sf1, sf2, part<=k) is the same function, but the products of power
|                            sums in the result have their parts <= k.
|  VP121297 VP090198
*/

muEC::SYMF::Pletppp := proc(sf1, sf2)
local
  opts,
  t1,    /* a table...                  */
  t2,    /* a table...                  */
  n1,    /* a nops var...               */
  n2,    /* a nops var...               */
  part1, /* a partition...              */
  part2, /* a partition...              */
  i,     /* var for seq...              */
  mx,    /* maximal part in result...   */
  l;     /* maximal length in result... */
begin
  l := NIL; mx := NIL;
  if args(0)=3 then
    opts:=args(3);
    if testargs() and not testtype(opts, "_leequal") then
        error("Optional argument should be of the form option=value")
    end_if;
    if (op(opts,1)=hold(lg)) then
      l := op(opts,2);
    else
      mx := op(opts,2);
    end_if;
  end_if;
/* AJOUTER LE TRAITEMENT DES OPTIONS... */
  if testtype(sf1, "_plus") then
     map(sf1, muEC::SYMF::Pletppp, sf2, args(3..args(0)));
  else
    t1 := muEC::SYMF::Monomial(sf1,hold(p));
    n1 := nops(t1[hold(p)]);
    part1 := [op(t1[hold(p)], 2..n1)];
    if testtype(sf2, "_plus") then /* p[I](A+B)=prod p[I.i](A)+p[I.i](B) */ 
       t1[hold(coeff)]*muEC::SYMF::Top(/* expand */(
         _mult(_seqgen(
           muEC::SYMF::Pletppp(hold(p)[part1[i]],op(sf2,1),  args(3..args(0))) +
           muEC::SYMF::Pletppp(hold(p)[part1[i]],op(sf2,2..nops(sf2)), args(3..args(0))),
         i,1..n1-1))
       ));
    elif testtype(sf2, "_mult") then
      t2 := muEC::SYMF::Monomial(sf2,hold(p));
      t1[hold(coeff)]*t2[hold(coeff)]^(n1-1)*
                      muEC::SYMF::Pletppp(t1[hold(p)],t2[hold(p)], args(3..args(0)));
    elif not muEC::TYP::Isp(sf2) then
      t1[hold(coeff)]*sf2^(n1-1);
    else /* a product of power sums... */
      n2 := nops(sf2);
      part2 := [op(sf2, 2..n2)];
      t1[hold(coeff)]*hold(p)[
        _seqgen(op(map(part2, _mult, part1[i])),i,1..n1-1)
      ];
    end_if;
  end_if;
end_proc:
