/*
|  File Pletss (SYMF PACKAGE) Fri Nov 28 08:16:52 MET 1997
*/

/*
|  Pletss(sf1, sf2) expresses the result of the plethysm sf1[sf2] on the
|                   Schur functions basis. sf1 and sf2 are on the s-basis.
|
|  Pletss(sf1, sf2, lg<=k) is the same function, but the Schur functions in the
|                        result have a length <= k.
|
|  Pletss(sf1, sf2, part<=k) is the same function, but the Schur functions in
|                            the result have their parts <= k.
|  VP281197 VP121297
*/

muEC::SYMF::Pletss := proc(sf1, sf2)
local
  opts,
  t,     /* a table...                  */
  r,     /* the result...               */
  mx,    /* maximal part in result...   */
  l;     /* maximal length in result... */
begin
  l := NIL; mx := NIL;
  if args(0)=3 then
    opts:=args(3);
    if testargs() and not testtype(opts, "_leequal") then
        error("Optional argument should be of the form option=value")
    end_if;
    if (op(opts,1)=hold(lg)) then
      l := op(opts,2);
    else
      mx := op(opts,2);
    end_if;
  end_if;
  if muEC::TYP::Iss(sf2) then
    if muEC::TYP::Iss(sf1) then
      if bool(sf2=hold(s)[]) then
        if nops(sf1)>2 then
          r := 0;
        else
          r := 1;
        end_if;
      else
        r := muEC::SYMF::Pletss_elem(sf1,sf2,l,mx);
      end_if;
    elif testtype(sf1,"_plus") then
        r := map(sf1, muEC::SYMF::Pletss, sf2, args(3..args(0)));
    elif (sf1=hold(s)[]) then
      r := 1;
    else
      t := muEC::SYMF::Monomial(sf1, hold(s));
      r :=  t[hold(coeff)]
          * muEC::SYMF::Pletss(muEC::SYMF::SchurProduct(t[hold(s)]),sf2,args(3..args(0)));
    end_if;
    sysassign(muEC::SYMF::Pletss_elem,
              muEC::clearRememberTable(muEC::SYMF::Pletss_elem));
    r;
  else /* a temporary solution... */
/*
ATTENTION, LES OPTIONS NE PEUVENT ETRE PASSEES QUE SOUS CERTAINES
CONDITIONS. -> A VOIR.
    muEC::SYMF::Tos(muEC::SYMF::Pletppp(muEC::SYMF::Top(sf1),muEC::SYMF::Top(sf2), args(3..args(0)) ));
*/
    muEC::SYMF::Tos(muEC::SYMF::Pletppp(muEC::SYMF::Top(sf1),muEC::SYMF::Top(sf2)));
  end_if;
end_proc:

/*
| VP121297
*/
muEC::SYMF::Pletss_elem := proc(p1,p2,l,mx)
option remember;
begin
  if testtype(l, DOM_INT) then
    muEC::SYM::Pletss_elem_l(l,p1,p2):
  elif testtype(mx, DOM_INT) then
    muEC::SYM::Pletss_elem_mx(mx,p1,p2):
  else
    muEC::SYM::Pletss_elem(p1,p2):
  end_if;
end_proc:
