/*
|  File RedrVect (SYMF PACKAGE) Wed Oct 22 13:43:36 MET DST 1997
*/

/*
|  RedressVect(v) tries to redress the Schur function associated to
|                 the vector v. The result is a couple made of the vector
|                 and the signature.  The signature is 1, -1 or 0 if the
|                 result is null.
*/

/*
|  VP221097
*/
muEC::SYMF::RedressVect:=proc(v)
local
    i,    /* var for seq...   */
    m,n,  /* vars for loop... */
    k,    /* var for loop...  */
    l,    /* a length...      */
    part, /* the partition... */
    s;    /* the signature... */
begin
  l := nops(v);
  /* we compute the corresponding last column of the Jacobi-Trudi matrix... */
  part := [_seqgen(v[i]+(l-i),i,1..l)];
  if (nops({op(part)}) <> l) then
    return([], 0);
  end_if;
  /* we do not accept negative entries... */
  for k from 1 to l do
    /* there is a negative part... */
    if part[k]< 0 then
      return([],0);
    end_if;
  end_for;
  s := _mult(_seqgen(_seqgen(sign(part[m]-part[n]), n,m+1..l), m,1..l-1));
  part := sort(part,proc(x,y) begin bool(x >= y) end_proc);
  subs([_seqgen(part[i]+i-l,i,1..l)], 0=null()), s;
end_proc:
