/*
|  File Sf2Char (SYMF PACKAGE) Fri Jan  9 13:09:21 MET 1998
*/

/*
|  Sf2Char(sf) applies the inverse characteristic map to the symmetric
|              function sf. The result is a linear combination of cl[...].
|  VP091098
*/
muEC::SYMF::Sf2Char_core := proc(sf)
local
  i,    /* var for loop...                 */
  k,    /* var for seq...                  */
  r,    /* the result...                   */
  mp,   /* max i (p.i) appearing in onp... */
  allv, /* all values appearing in onp...  */
  onp,  /* sf1 on p basis...               */
  c,    /* coefficients in onp...          */
  v,    /* a vector...                     */
  mn;   /* monom in c...                   */
begin
  onp := expand(muEC::SYMF::Top(sf));
  allv := muEC::SYMF::AllIndexed(onp,hold(p));
  mp := max(_seqin(op(k),k,allv));
  allv := [op(map(allv,proc(x) begin hold(p)[op(x)] end_proc))]; /* need a list... */
  c := [coeff(onp,allv)];
  r := 0;
  for i from 1 to nops(c) do
    mn := op(allv,i);
    v := op(mn,2..nops(mn));
    r := r+muEC::SYMF::SfZee([v])*c[i]*hold(cl)[v];
  end_for;
  r;
end_proc:

/*
|  Type Checking.
|  VP090198
*/
muEC::SYMF::Sf2Char_check := proc(sf)
begin
  if (args(0)>1) then
    muEC::ERR::SYMFPerror(11,procname);
  end_if;
end_proc:

/*
|  VP090198
*/
muEC::SYMF::Sf2Char := proc(sf)
begin
  if testargs() then
    muEC::SYMF::Sf2Char_check(args());
  end_if;
  muEC::SYMF::Sf2Char_core(args());
end_proc:
