/*
|  File SfDiff (SYMF PACKAGE) Fri Jan  9 11:19:33 MET 1998
| VP180598
*/
muEC::SYMF::LRrSfrec := proc(boxes)
local
  n,     /* number of boxes... */
  b,     /* some boxes...      */
  v1,v2; /* two values...      */
begin
  n := nops(boxes);
  if (n=0) then
    [[[], []]];
  else
    b := boxes[n];
    v1 := contains(boxes, [b[1],b[2]+1]);
    v2 := contains(boxes, [b[1]-1,b[2]]);
    map(muEC::SYMF::LRrSfrec([op(boxes, 1..n-1)]),
        proc(boxes,v1,v2) local f, b2, nv1, nv2, i, j; begin
          f := [op(boxes[1]),0]; b2 := boxes[2];
          if v1=0 then nv1 := 0 else nv1 := b2[v1] end_if;
          if v2>0 then nv2 := min(b2[v2], nops(f)) else nv2 := nops(f) end_if;
          op(subs([_seqin([subsop(f, i=f[i]+1), [op(b2), i]],
                        i,map([_seqgen(j, j,nv1+1..nv2)],
                              proc(x, y) begin
                                if (x=1) or (y[x-1]>y[x]) then x else null()
                                end_if
                              end_proc,
                              f)
                 )],0=null()))
        end_proc,
        v2, v1);
  end_if;
end_proc:

/*
|  SfDiff(sf1, sf2) differential operator D_sf1(sf2).
|  VP090198 VP020498 VP240498
*/
muEC::SYMF::SfDiff_part := proc(part, sf)
local
  part1, /* a partition... */
  part2, /* a partition... */
  l,     /* variable for loop... */
  i,j,k, /* variable for sequence... */
  t;     /* a table... */
begin
  if (testtype(sf, "_plus")) then
    map(sf, proc( x, y) begin muEC::SYMF::SfDiff_part(y, x) end_proc , part);
  else
    t := muEC::SYMF::Monomial(sf, hold(s));
    if bool(t[hold(s)]=hold(t[s])) then
      if (part=[]) then
        t[hold(coeff)];
      else
        0;
      end_if;
    else
      if (nops(part)>nops(t[hold(s)])-1) then
        0;
      else
        part1 := part;
        part2 := [op(t[hold(s)], 2..nops(t[hold(s)]))];
        for l from 1 to nops(part1) do
          if (part1[l]>part2[l]) then
            return(0);
          end_if;
        end_for;

        part1 := [op(part1), _seqgen(0, i,1..nops(part2))];
        t[hold(coeff)]*_plus(_seqin(hold(s)[op(k[1])],
             k,muEC::SYMF::LRrSfrec([_seqgen(_seqgen([i,-j],
                                               j,-part2[i]..-(part1[i]+1)),
                                       i,1..nops(part2))])));
      end_if;
    end_if;
  end_if;
end_proc: 

/*
|  VP090198 VP240498
*/ 
muEC::SYMF::SfDiff_rec := proc(sf1, sf2)
local
  t; /* a table... */
begin
  if (testtype(sf1, "_plus")) then 
    map(sf1, muEC::SYMF::SfDiff_rec, sf2);
  else
    t := muEC::SYMF::Monomial(sf1, hold(s));
    if bool(t[hold(s)] <> hold(t[s])) then
      t[hold(coeff)]*
      muEC::SYMF::SfDiff_part([op(t[hold(s)],2..nops(t[hold(s)]))], sf2);
    else
      t[hold(coeff)]*sf2;
    end_if;
  end_if;
end_proc:

/*
|  VP090198 VP240498
*/
muEC::SYMF::SfDiff_core := proc(sf1, sf2)
begin
  muEC::SYMF::SfDiff_rec(expand(muEC::SYMF::Tos(sf1)), expand(muEC::SYMF::Tos(sf2)));
end_proc:

/*
|  VP090198
|  Type Checking.
*/
muEC::SYMF::SfDiff_check:=proc(sf1, sf2)
begin
end_proc:

/*
|  VP090198
*/
muEC::SYMF::SfDiff := proc(sf1,sf2)
begin
  if testargs() then
    muEC::SYMF::SfDiff_check(args());
  end_if;
  muEC::SYMF::SfDiff_core(args());
end_proc:
