/*
|  File SfEval (SYMF PACKAGE) Fri Jan  9 10:46:29 MET 1998
*/

/*
|  SfEval(sf,expre) applies a substitution on sf: p.i -> expre /
|                                                             / x -> x^i
|  VP090198
*/

muEC::SYMF::SfEval_core := proc(sf,expre)
local
  onp,  /* sf on p basis...          */
  allv, /* all indexed p...          */
  ind;  /* indeterminates of expr... */
begin
  /* we express sf on p basis... */
  onp := muEC::SYMF::Top(sf);
  /* we compute the indeterminates of expr... */
  ind := indets(expre);
  allv := muEC::SYMF::AllIndexed(onp,hold(p));
  subs(onp,
       map(allv,
          proc(i,expre,ind) local j,k; begin
            hold(p)[op(i)] = _mult(_seqin(subs(expre,{_seqin(j=j^k,j,ind)}),k,i));
          end_proc,
          expre,ind)
       )
end_proc:

/*
|  Type Checking.
|  VP090198
*/
muEC::SYMF::SfEval_check:=proc(sf1,expre)
begin
end_proc:

/*
|  VP090198
*/
muEC::SYMF::SfEval := proc(sf1,expre)
begin
  if testargs() then
    muEC::SYMF::SfEval_check(args());
  end_if;
  muEC::SYMF::SfEval_core(args());
end_proc:
