/*
|  File SfMat (SYMF PACKAGE) Fri Jan  9 09:16:44 MET 1998
*/

/*
|  SfMat(n, b1, b2) produces the matrix of change of basis from
|                   b1 to b2.
|  VP090198 VP240498
*/
muEC::SYMF::SfMat_decode := proc(expre, n, b2, lp)
local
  ve,   /* vector...       */
  j;    /* var for seq...  */
begin
    ve := [coeff(normal(expre), [_seqin(b2[op(j)], j,lp)])];
    [0$(n-nops(ve)+1),op(ve)];
end_proc:

/*
|  VP090198 VP240498
*/
muEC::SYMF::SfMat_core := proc(n, b1, b2)
local
  i,   /* var for seq...        */
  np,  /* nops(lp)...           */
  f,   /* a function...         */
  lr,  /* list of results...    */
  lp;  /* list of partitions... */
begin
  if (b1=b2) then
    np := muEC::PART::ListPart(n, hold(nb));
    array(1..np, 1..np, [_seqgen([0$(i-1),1,0$(np-i)], i,1..np)])
  else
    f  := muEC::cat("muEC::SYMF::",b1,"2",b2);
    lp := muEC::PART::ListPart(n);
    np := nops(lp);
    lr := map(lp, proc(part, b1, b2) begin
               level(eval(f(b1[op(part)])),2)
            end_proc, b1, b2);
    array(1..np, 1..np, map(lr, muEC::SYMF::SfMat_decode, n, b2, lp))
  end_if;
end_proc:

/*
|  Type Checking.
|  VP090198
*/
muEC::SYMF::SfMat_check := proc(n, b1, b2)
begin
  if (not(testtype(n,DOM_INT))) then
    muEC::ERR::SYMFPerror(1,procname);
  elif (n<1) then
    muEC::ERR::SYMFPerror(2,procname);
  elif (not testtype(b1, DOM_IDENT)) then
    muEC::ERR::SYMFPerror(3,procname);
  elif (not has(muEC::SYMF::SYMFBases,b1)) then
    muEC::ERR::SYMFPerror(4,procname);
  elif (not testtype(b2, DOM_IDENT)) then
    muEC::ERR::SYMFPerror(5,procname);
  elif (not has(muEC::SYMF::SYMFBases,b2)) then
    muEC::ERR::SYMFPerror(6,procname);
  end_if;
end_proc:

/*
|  VP090198
*/
muEC::SYMF::SfMat := proc(n,b1,b2)
begin
  if testargs() then
    muEC::SYMF::SfMat_check(args());
  end_if;
  muEC::SYMF::SfMat_core(args());
end_proc:
