/*
|  File SfTheta (SYMF PACKAGE) Thu Jan  8 09:38:23 MET 1998
*/

/*
|  SfTheta(sf1,a) applies the automorphism p.i -> a*p.i to the
|                 symmetric "function" sf1.
|
|  SfTheta(sf1,q,t) applies the automorphism p.i -> (1-q^i)_(1-t^i)*p.i to the
|                   symmetric "function" sf1.
|  VP080198
*/
muEC::SYMF::SfTheta_core := proc(sf1,a)
local
  onp1; /* sf1 in terms of p basis since SfTheta is defined on this basis... */
begin
  onp1 := muEC::SYMF::Top(sf1);
  if (args(0)>=3) then
    subs(onp1,
         map(muEC::SYMF::AllIndexed(onp1,hold(p)),
             proc(ind,q1,t1) begin
               hold(p)[op(ind)]=_mult(
               op(map(ind, proc(i,q,t) begin (1-q^i)/(1-t^i); end_proc,q1,t1)),
                      hold(p)[op(ind)]);
             end_proc,args(2),args(3)),
         Unsimplified);
  else
    subs(onp1,
         map(muEC::SYMF::AllIndexed(onp1,hold(p)),
             proc(ind,a) begin
               hold(p)[op(ind)]=_mult(hold(p)[op(ind)],a^(nops(ind)));
             end_proc,a),
         Unsimplified);
  end_if;
end_proc:

/*
|  Type Checking.
|  VP080198
*/
muEC::SYMF::SfTheta_check:=proc(sf1,a)
begin
end_proc:

/*
|  VP080198
*/
muEC::SYMF::SfTheta := proc(sf1,a)
begin
  if testargs() then
    muEC::SYMF::SfTheta_check(args());
  end_if;
  muEC::SYMF::SfTheta_core(args());
end_proc:
