/*
|  File SfVar (SYMF PACKAGE) Fri Jan  9 12:37:20 MET 1998
*/

/*
|  Sf2TableVar(sf) returns a table with all symmetric
|                  functions in sf. One can restrict the set of symmetric
|                  functions by adding a second argument as in Monomial.
|  VP090198
*/
muEC::SYMF::Sf2TableVar_core := proc(sf)
local
  i,  /* var for seq... */
  b,  /* bases...       */
  t;  /* a table...     */
begin
  if (args(0)=2) then
    if (testtype(args(2), DOM_IDENT)) then
      b:={args(2)};
    else
      b := {op(muEC::SYMF::SYMFBases)} intersect {op(args(2))};
    end_if;
  else
    b := muEC::SYMF::SYMFBases;
  end_if;
  t := table(_seqin(i=muEC::SYMF::AllIndexed(sf, i), i,b));
  if (args(0)=2) then
    if (testtype(args(2), DOM_IDENT)) then
      t[args(2)];
    else
      t;
    end_if;
  else
    t;
  end_if;
end_proc:

/*
|  Type Checking.
|  VP090198
*/
muEC::SYMF::Sf2TableVar_check := proc(sf)
begin
  if (args(0)=2) then
    if (testtype(args(2), DOM_IDENT)) then
      if not (has(muEC::SYMF::SYMFBases, args(2))) then
        muEC::ERR::SYMFPerror(4,procname);
      end_if;
    elif (testtype(args(2), DOM_SET) or testtype(args(2), DOM_LIST)) then
      if (bool({op(args(2))} minus {op(muEC::SYMF::SYMFBases)} <> {})) then
        muEC::ERR::SYMFPerror(4,procname);
      end_if;
    else
      muEC::ERR::SYMFPerror(3,procname);
    end_if;
  end_if;
end_proc:

/*
|  VP090198
*/
muEC::SYMF::Sf2TableVar := proc(sf)
begin
  if testargs() then
    muEC::SYMF::Sf2TableVar_check(args());
  end_if;
  muEC::SYMF::Sf2TableVar_core(args());
end_proc:
