/*
|  File SfZee (SYMF PACKAGE) Thu Jan  8 09:25:28 MET 1998
*/

/*
|  SfZee(lambda) computes the scalar product <p[lambda],p[lambda]>
|                = 1^(m1)*m1!*2^(m2)*m2!*...  so that m1 1 lie in lambda,
|                m2 2 lie in lambda, ... .
|
|  VP080198
*/
muEC::SYMF::SfZee_core := proc(mu)
local
  res, /* the result...   */
  m,   /* a var...        */
  i;   /* var for loop... */
begin
  m := 1;
  res := _mult(op(mu));
  for i from 2 to nops(mu) do
    if (mu[i]<mu[i-1]) then
      m := 1;
    else
      m := m+1;
    end_if;
    res := res*m;
  end_for;
  res;
end_proc:

/*
|  Type Checking.
|  VP080198
*/
muEC::SYMF::SfZee_check := proc(mu)
begin
  if (not muEC::TYP::IsPart(mu)) then
    muEC::ERR::SYMFPerror(1,procname);
  end_if;
end_proc:

/*
|  VP080198
*/
muEC::SYMF::SfZee := proc(mu)
begin
  if testargs() then
    muEC::SYMF::SfZee_check(args());
  end_if;
  muEC::SYMF::SfZee_core(args());
end_proc:
