/*
|  File h2 (SYMF PACKAGE) Tue Dec  2 10:38:50 MET 1997
*/

/*
|  Some uses of the Wronski formula.
|  h2e(sf) from h basis to e basis.
|  VP021297 VP240498 VP280498
*/
muEC::SYMF::h2e := proc(sf)
local
  nsf, /* new sf...       */
  pow, /* a power...      */
  r,   /* the result...   */
  rr,  /* a result...     */
  f,   /* a function...   */
  i,k1,sq;   /* var for loop... */
begin
  if not testtype(sf,"_power") then
    nsf := sf; pow := 1;
  else
    nsf := op(sf,1); pow := op(sf,2);
  end_if;
/*
$ r := muEC::SYMF::CollectAlgBasesSf(
$      expand(_mult(_seqgen(muEC::SYMF::h2e_recursion(op(nsf, i)), i,2..nops(nsf)))));
$ sysassign(muEC::SYMF::h2e_recursion,
            muEC::clearRememberTable(muEC::SYMF::h2e_recursion));
*/
  r := hold(e)[];
  for i from 2 to nops(nsf) do
    rr := muEC::SYMF::h2e_recursion(op(nsf, i)); /* a + b*e[..] + c*e[..]  + ..*/
    if testtype(rr, DOM_INT) then
      r := rr*r;
    else
      f := proc(rr,r) local ind,k; begin
           if testtype(rr, "_mult") then
              ind := op(op(muEC::SYMF::AllIndexed(rr,hold(e))));
/*CC*/
sq:=[];
for k in muEC::SYMF::AllIndexed(r,hold(e)) do
k1:=op(k);
sq:=[op(sq),hold(e)[k1]=op(rr,2)*hold(e)[op(sort([ind,k1],proc(x,y) begin x>y end_proc ))]];
end_for;
subs(r, op(sq)); 
/**/
/*
              subs(r,
              _seqin(e[op(k)]=op(rr,2)*e[op(sort([op(k),ind],proc(x,y) begin x>y end_proc ))],
                     k,muEC::SYMF::AllIndexed(r,hold(e))));
*/
            elif testtype(rr,"_plus") then
              map(rr,f,r);
            else
              ind := op(op(muEC::SYMF::AllIndexed(rr,hold(e))));
/*CC*/
sq:=[];
for k in muEC::SYMF::AllIndexed(r,hold(e)) do
k1:=op(k);
sq:=[op(sq),hold(e)[k1]=hold(e)[op(sort([ind,k1],proc(x,y) begin x>y end_proc ))]];
end_for;
subs(r, op(sq)); 
/**/
/*
              subs(r,
              _seqin(e[op(k)]=e[op(sort([op(k),ind],proc(x,y) begin x>y end_proc ))],
                     k,muEC::SYMF::AllIndexed(r,hold(e))));
*/
            end_if;
           end_proc;
      r := f(rr,r);
    end_if;
  end_for;
  r^pow;
end_proc:

/*
|  VP021297 VP240498
*/
muEC::SYMF::h2e_recursion := proc(deg)
local
  r, /* the result...   */
  f, /* a function...   */
  i, /* var for loop... */
sq;
/*option remember;*/
begin
  if (deg=0) then
    1;
  else
    /* we init the result... */
    r := 0;
    /* the formula... */
    f := proc(expre,j) local ind,k,k1;
         begin
           if testtype(expre,DOM_INT) then expre*hold(e)[j];
           else
             ind := muEC::SYMF::AllIndexed(expre,hold(e));
/*CC*/ 
             if nops(ind)=0 then hold(e)[j];
             else
 /*CC*/
sq:=[];
for k in ind do
k1:=op(k);
sq:=[op(sq),hold(e)[k1]=hold(e)[op(sort([j,k1],proc(x,y) begin x>y end_proc ))]];
end_for;
subs(expre, op(sq)); 
/**/
/*
               subs(expre, _seqin(e[op(k)]=
e[op(sort([j,op(k)],proc(x,y) begin x>y end_proc ))],
                               k,ind));
*/
             end_if
           end_if;
         end_proc;
    for i from deg downto 1 step 1 do
      r := r+((-1)^(i+1))*f(eval(muEC::SYMF::h2e_recursion(deg-i)),i);
    end_for;
    r;
  end_if;
end_proc:

/*
|  h2p(sf) from h basis to p basis.
|  VP021297 VP121297 VP280498
*/
muEC::SYMF::h2p := proc(sf)
option remember;
begin
  if not testtype(sf,"_power") then
    if bool(sf=hold(h)[]) then
       1;
    else
      muEC::SYM::h2p(sf);
    end_if;
  elif bool(op(sf,1)=hold(h)[]) then
     1;
  else
    muEC::SYM::h2p(op(sf,1))^op(sf,2);
  end_if;
end_proc:


/*
|  h2m(sf) from h basis to m basis.
|  VP021297 VP121297 VP280498
*/
muEC::SYMF::h2m := proc(sf)
option remember;
begin
  if not testtype(sf,"_power") then
    if bool(sf=hold(h)[]) then
       hold(m)[];
    else
      muEC::SYM::h2m(sf);
    end_if;
  elif bool(op(sf,1)=hold(h)[]) then
     hold(m)[];
  else
    muEC::SYM::h2m(op(sf,1))^op(sf,2);
  end_if;
end_proc:

/*
|  h2s(sf) from h basis to s basis.
|  VP021297 VP121297 VP280498
*/
muEC::SYMF::h2s := proc(sf)
option remember;
begin
  if not testtype(sf,"_power") then
    if bool(sf=hold(h)[]) then
       hold(s)[];
    else
      muEC::SYM::h2s(sf);
    end_if;
  elif bool(op(sf,1)=hold(h)[]) then
     hold(s)[];
  else
    muEC::SYM::h2s(op(sf,1))^op(sf,2);
  end_if;
end_proc:
