/*****************************************************************************
  $Id: muEC.tst,v 1.1.1.1 2003/09/15 16:37:46 nthiery Exp $
  File:		lib/MUEC/TEST/muEC.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
                Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Test file for the library 'muEC'
  Created:	26/11//2001
  License:	LGPL
*****************************************************************************/

prog::testinit("muEC"):
prog::testfunc(muEC::PART):
prog::test(muEC::PART::ListPart(4),
           [[4], [3, 1], [2, 2], [2, 1, 1], [1, 1, 1, 1]]):
prog::test(muEC::PART::ListPart(4,regular=1),
           []):
prog::test(muEC::PART::ListPart(4,regular=2),
           [[4], [3, 1]]):
prog::test(muEC::PART::ListPart(4,regular=3),
           [[4], [3, 1], [2, 2], [2, 1, 1]]):
prog::test(muEC::PART::ListPart(4,regular=4),
           [[4], [3, 1], [2, 2], [2, 1, 1]]):
prog::test(muEC::PART::ListPart(4,regular=4, nb),
           4):
prog::test(muEC::PART::ListPart(4,regular=3, nb),
           4):
prog::test(muEC::PART::ListPart(4,regular=2, nb),
           2):
prog::test(muEC::PART::ListPart(4,regular=1, nb),
           0):
prog::test(muEC::PART::ListPart(4,nb),
           5):
prog::test(muEC::PART::ListPart(5,nb),
           7):
prog::test(muEC::PART::ListPart(100,nb),
           190569292):

prog::test(muEC::SG::Desc2ListPerm([1,2],3),
	   [[3,2,1]]):

prog::testfunc(muEC::COMP):
prog::test(muEC::COMP::ListCompo(4),
           [[4], [3, 1], [2, 2], [2, 1, 1], [1, 3], [1, 2, 1],
            [1, 1, 2], [1, 1, 1, 1]]):

prog::testfunc(muEC::TYP::IsCompo):
prog::test(muEC::TYP::IsCompo([1,2,3]),
           TRUE):
prog::test(muEC::TYP::IsCompo([1,2,0]),
           TRUE):
prog::test(muEC::TYP::IsCompo([1,2,-1]),
           FALSE):
prog::test(muEC::TYP::IsCompo([1,2,a]),
           FALSE):

prog::testfunc(muEC::TYP::IsName):
prog::test(muEC::TYP::IsName(x,x), TRUE):
prog::test(muEC::TYP::IsName(x112,x), TRUE):
prog::test(muEC::TYP::IsName(x112,y), FALSE):
prog::test(muEC::TYP::IsName(y[1],x), FALSE):
prog::test(muEC::TYP::IsName(x1a,x), FALSE):

prog::testfunc(muEC::SP::AllValues):
prog::test(muEC::SP::AllValues((x1*x3*(1 + x9) + x4*x8) - 4*y, x),
           {1, 3, 4, 8, 9}):
prog::testfunc(muEC::SP::EValue):
prog::test(muEC::SP::EValue(x1, x),
           1):
prog::test(muEC::SP::EValue(x3, x),
           3):
prog::test(muEC::SP::EValue(y3, x),
           -1):
prog::test(muEC::SP::EValue(yz, x),
           -1):
prog::test(muEC::SP::EValue(yz133, x),
           -1):
prog::test(muEC::SP::EValue(x342, x),
           342):

prog::testfunc(muEC::SFA):
export(muEC): export(SFA):
prog::test(SfAVars( {{x}, u, v} ),
           {{x}, u, v}):
prog::test(SfAExpand( m[3,2](x1+u+v) - q*s[2,2](x1+u+v) ),
           - q*u*v*x1^2 - q*u*v^2*x1 - q*u^2*v*x1 + u^2*v^3 + 
           u^3*v^2 + u^2*x1^3 + u^3*x1^2 + v^2*x1^3 + v^3*x1^2 - 
           q*u^2*v^2 - q*u^2*x1^2 - q*v^2*x1^2):

prog::testfunc(muEC::SYMF):
prog::test(muEC::SYMF::SfPlethysm(p[1]*s[2], h[1]),
           1/2*p[2, 1] + 1/2*p[1, 1, 1]):
// For some reason (term order ?), the two expressions below are not
// tested as equal, whereas their difference is 0. Oh well ...
prog::test(muEC::SYMF::SfPlethysm( e[3], s[2,1], e, s ) -
           (s[2, 2, 2, 1, 1, 1] + s[3, 2, 2, 1, 1] + s[3, 3, 1, 1, 1] +
           s[4, 2, 1, 1, 1] + s[3, 2, 2, 2] + s[3, 3, 2, 1] + s[4, 2, 2, 1] +
           2 * s[4, 3, 1, 1] + s[5, 2, 1, 1] + s[6, 1, 1, 1] + s[3, 3, 3] +
           s[4, 3, 2] + s[5, 2, 2] + s[4, 4, 1] + s[5, 3, 1]), 
           0):
prog::test(muEC::SYMF::Tom(m[1]*m[1] - (2*m[1, 1] + m[2])), 0):
prog::test(muEC::SYMF::Tom(e[1]*e[1] - (2*m[1, 1] + m[2])), 0):
prog::test(muEC::SYMF::Tom(m[1]*e[1] - (2*m[1, 1] + m[2])), 0):
prog::test(muEC::SYMF::Tom(e[1]*m[1] - (2*m[1, 1] + m[2])), 0):

prog::testfunc(muEC::clearRememberTable):
f:=x->x: f(1):=2:
prog::test(f(1),2):
f:=muEC::clearRememberTable(f):
prog::test(f(1),1):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

// This is done at the end to ensure as much as possible of the
// package is initialized. A recursive prog::init(muEC)
// would be usefull here.

prog::init(muEC):
prog::check(muEC, 3):

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
