/**
|  File TYP.mu (TYP PACKAGE) Vendredi 27 juin 1997 10:34:35
|
|          The TYP library for TYPe checking.
|
| VP270697 VP221097 VP020498
**/

/**
User Functions:

muEC::TYP::IsName      - IsName(x1, x) -> true, IsName(x1,y) -> false

> Mainly used in package COMP:

muEC::TYP::IsCompo      - tests whether arg is a composition...


> Mainly used in package PART:

muEC::TYP::IsBorder     - IsBorder(l) tests, whether l is or not a border list, 0
                    denoting an horizontal chunk of the border, 1 a vertical
                    one.

muEC::TYP::IsDiagonal   - tests whether arg is a valid diagonal encoding...

muEC::TYP::IsPart       - tests whether arg is a partition in decreasing order...

muEC::TYP::IsRegPart    - tests whether arg is a n-regular partition...

muEC::TYP::IsSkewDiag   - tests whether arg is a skew diagram...

muEC::TYP::IsSkewPart   - tests whether arg is a skew partition...

> Mainly used in package SG:

muEC::TYP::IsPerm       - tests whether arg is a permutation...

> Mainly used in package SYMF:

muEC::TYP::Isp          - tests whether arg is a product of power sum functions...

muEC::TYP::Ish          - tests whether arg is a product of complete functions...

muEC::TYP::Ise          - tests whether arg is a product of elementary functions...

muEC::TYP::Iss          - tests whether arg is a Schur function...

muEC::TYP::Ism          - tests whether arg is a monomial function...

muEC::TYP::IsAlmostp    - tests whether arg is a product of power sum functions,
                    where the index is not necessary a partition...

muEC::TYP::IsAlmosth    - tests whether arg is a product of complete functions,
                    where the index is not necessary a partition...

muEC::TYP::IsAlmoste    - tests whether arg is a product of elementary functions,
                    where the index is not necessary a partition...

muEC::TYP::IsAlmosts    - tests whether arg is a Schur function,
                    where the index is not necessary a partition...

muEC::TYP::IsAlmostm    - tests whether arg is a monomial function,
                    where the index is not necessary a partition...

> Mainly used in package SFA:

muEC::TYP::IspA         - tests whether arg is a product of power sum functions...

muEC::TYP::IshA         - tests whether arg is a product of complete functions...

muEC::TYP::IseA         - tests whether arg is a product of elementary functions...

muEC::TYP::IssA         - tests whether arg is a Schur function...

muEC::TYP::IsmA         - tests whether arg is a monomial function...

muEC::TYP::IsAlmostpA   - tests whether arg is a product of power sum functions,
                    where the index is not necessary a partition...

muEC::TYP::IsAlmosthA   - tests whether arg is a product of complete functions,
                    where the index is not necessary a partition...

muEC::TYP::IsAlmosteA   - tests whether arg is a product of elementary functions,
                    where the index is not necessary a partition...

muEC::TYP::IsAlmostsA   - tests whether arg is a Schur function,
                    where the index is not necessary a partition...

muEC::TYP::IsAlmostmA   - tests whether arg is a monomial function,
                    where the index is not necessary a partition...


Algorithms of TYP are from my own. No reference.
**/

muEC::TYP := newDomain("muEC::TYP"):
muEC::TYP::info := "Library TYP: type checking for mu-EC objects";
muEC::TYP::interface := {
        IsCompo, IsBorder, IsDiagonal, IsName, IsPart, IsPerm, IsRegPart,
        IsSkewDiag, IsSkewPart, Isp, Ise, Ish, Iss, Ism, IspA, IseA, IshA,
        IssA, IsmA
        // Undocumented: , Isx, Isy, IsX, IsXX, IsY, IsYY, IsPe
        }:

alias(path = pathname("MUEC", "TYP")):

muEC::TYP::IsBorder          := loadproc(muEC::TYP::IsBorder         , path, "IsBorder"):

muEC::TYP::IsCompo           := loadproc(muEC::TYP::IsCompo          , path, "IsCompo" ):

muEC::TYP::IsName            := loadproc(muEC::TYP::IsName           , path, "IsName"  ):

muEC::TYP::IsPart            := loadproc(muEC::TYP::IsPart           , path, "IsPart"  ):

muEC::TYP::IsPart_with0      := loadproc(muEC::TYP::IsPart_with0     , path, "IsPart"  ):

muEC::TYP::IsPerm            := loadproc(muEC::TYP::IsPerm           , path, "IsPerm"  ):

muEC::TYP::IsRegPart         := loadproc(muEC::TYP::IsRegPart        , path, "IsRegPa" ):

muEC::TYP::IsDiagonal        := loadproc(muEC::TYP::IsDiagonal       , path, "IsDiagnl"):

muEC::TYP::IsSkewPart        := loadproc(muEC::TYP::IsSkewPart       , path, "IsSkewPa"):

muEC::TYP::IsSkewDiag        := loadproc(muEC::TYP::IsSkewDiag       , path, "IsSkewPa"):

//muEC::TYP::IsSf              := loadproc(muEC::TYP::IsSf             , path, "IsSf"    ):
muEC::TYP::IsSf              := ()->error("TYP::IsSf not implemented"):

muEC::TYP::IsSfIndexed       := loadproc(muEC::TYP::IsSfIndexed      , path, "IsSf"    ):

muEC::TYP::Isp               := loadproc(muEC::TYP::Isp              , path, "IsSf"    ):

muEC::TYP::Ise               := loadproc(muEC::TYP::Ise              , path, "IsSf"    ):

muEC::TYP::Ish               := loadproc(muEC::TYP::Ish              , path, "IsSf"    ):

muEC::TYP::Iss               := loadproc(muEC::TYP::Iss              , path, "IsSf"    ):

muEC::TYP::Ism               := loadproc(muEC::TYP::Ism              , path, "IsSf"    ):

muEC::TYP::IsAlmostp         := loadproc(muEC::TYP::IsAlmostp        , path, "IsSf"    ):

muEC::TYP::IsAlmoste         := loadproc(muEC::TYP::IsAlmoste        , path, "IsSf"    ):

muEC::TYP::IsAlmosth         := loadproc(muEC::TYP::IsAlmosth        , path, "IsSf"    ):

muEC::TYP::IsAlmosts         := loadproc(muEC::TYP::IsAlmosts        , path, "IsSf"    ):

muEC::TYP::IsAlmostm         := loadproc(muEC::TYP::IsAlmostm        , path, "IsSf"    ):

muEC::TYP::IsSfA             := loadproc(muEC::TYP::IsSfA            , path, "IsSfA"   ):

muEC::TYP::IspA              := loadproc(muEC::TYP::IspA             , path, "IsSfA"   ):

muEC::TYP::IseA              := loadproc(muEC::TYP::IseA             , path, "IsSfA"   ):

muEC::TYP::IshA              := loadproc(muEC::TYP::IshA             , path, "IsSfA"   ):

muEC::TYP::IssA              := loadproc(muEC::TYP::IssA             , path, "IsSfA"   ):

muEC::TYP::IsmA              := loadproc(muEC::TYP::IsmA             , path, "IsSfA"   ):

muEC::TYP::IsAlmostpA        := loadproc(muEC::TYP::IsAlmostpA       , path, "IsSfA"   ):

muEC::TYP::IsAlmosteA        := loadproc(muEC::TYP::IsAlmosteA       , path, "IsSfA"   ):

muEC::TYP::IsAlmosthA        := loadproc(muEC::TYP::IsAlmosthA       , path, "IsSfA"   ):

muEC::TYP::IsAlmostsA        := loadproc(muEC::TYP::IsAlmostsA       , path, "IsSfA"   ):

muEC::TYP::IsAlmostmA        := loadproc(muEC::TYP::IsAlmostmA       , path, "IsSfA"   ):

muEC::TYP::IsAlphabet        := loadproc(muEC::TYP::IsAlphabet       , path, "IsSfA"   ):

muEC::TYP::IsAlphabet_simple := loadproc(muEC::TYP::IsAlphabet_simple, path, "IsSfA"   ):

muEC::TYP::Isx               := loadproc(muEC::TYP::Isx              , path, "Is_x"    ):

muEC::TYP::IsX               := loadproc(muEC::TYP::IsX              , path, "IsX"     ):

muEC::TYP::IsXX              := loadproc(muEC::TYP::IsXX             , path, "IsXX"    ):

muEC::TYP::Isy               := loadproc(muEC::TYP::Isy              , path, "Is_x"    ):

muEC::TYP::IsY               := loadproc(muEC::TYP::IsY              , path, "IsY"     ):

muEC::TYP::IsYY              := loadproc(muEC::TYP::IsYY             , path, "IsYY"    ):

muEC::TYP::IsPe              := loadproc(muEC::TYP::IsPe             , path, "IsPe"    ):

unalias(path):
