/* 
|  File IsBorder (TYP PACKAGE) Vendredi 30 mai 1997 08:56:02
| 
|  IsBorder(l) tests, whether l is or not a border list, 0 denoting an
|              horizontal chunk of the border, 1 a vertical one.
| 
|  IsBorder(l,m) tests, whether l is or not a border list, op(1, op(2, m))
|                denoting an horizontal chunk of the border, op(2, op(2, m))
|                a vertical one.
*/

/*
|  VP300597 VP070797
*/
muEC::TYP::IsBorder:=proc(l)
local
  i, /* var for loop...        */
  h, /* horizontal encoding... */
  v, /* vertical encoding...   */
  m, /* alphabet...            */
  n; /* length of l...         */
begin
  if not (testtype(l, DOM_LIST)) then
    return(FALSE);
  end_if;
  if (args(0) = 2) then
    m := args(2);
    if not (testtype(m, "_equal")) then
      return(FALSE);
    elif (op(m, 1) <> hold(alphabet)) then
      return(FALSE);
    elif (nops(op(m, 2)) <> 2) then
      return(FALSE);
    end_if;
    h :=op(op(m, 2), 1);
    v :=op(op(m, 2), 2);
  else
    h := 0;
    v := 1;
  end_if;
  n := nops(l);
  if (n > 0) then 
    if (l[1] <> h or l[nops(l)] <> v) then
      return(FALSE);
    end_if;
    for i from 2 to nops(l)-1 do
      if (l[i] <> h and l[i] <> v) then
        return(FALSE);
      end_if;
    end_for;
  end_if;
  TRUE;
end_proc:
