/*
|  File IsDiagnl (TYP PACKAGE) Lundi 7 juillet 1997 19:20:53
|
|  IsDiagonal(l) tests, for l=[dl,o] whether dl is or not a llist of diagonals
|            with o as origin (of a partition, seen as a tableau).
|
*/

/*
|  VP300597
*/
muEC::TYP::IsDiagonal := proc(l)
local
  i,  /* var for loop...      */
  dl, /* list of diagonals... */
  n,  /* length of dl...      */
  o;  /* origin...            */
begin
  if not testtype(l, DOM_LIST) then
    return(FALSE);
  end_if;
  if (nops(l) <> 2) then
    return(FALSE);
  end_if;
  dl := l[1];
  o  := l[2];
  n  := nops(dl);
  if not testtype(dl, DOM_LIST) or not testtype(o, DOM_INT) or (o < 0) then
    return(FALSE);
  end_if;
  if (o > n) then
    return(FALSE);
  end_if;
  if (n > 0) then 
    if (dl[1] <> 1 or dl[n] <> 1) then                      /*      extremities */
      return(FALSE);
    end_if;
    if (n > 1) then
      i := 2;
      while(dl[i] >= dl[i-1]) do i := i+1; end_while;       /*  increasing part */
      if (dl[i-1] <> dl[o]) then                            /* origin condition */
        return(FALSE);
      end_if;
      while(i<=n and dl[i] <= dl[i-1]) do i:=i+1; end_while; /* decreasing part */
      if (i <> n+1) then
        return(FALSE);
      end_if;
    end_if;
  elif (o <> 0) then
    return(FALSE);
  end_if;
  return(TRUE);
end_proc:
