/*
|  File IsPe (TYP PACKAGE) Wed May 20 18:42:24 MET DST 1998
*/

/*
|  IsPe(p) tests whether p is Pe[sequence of nonnegative integers].
|         (product of elementary symmetric functions on flag of alphabets)
|  VP200598
*/
muEC::TYP::IsPe := proc(p)
local
  n, /* degree...       */
  i; /* var for loop... */
begin
  if not testtype(p,"_index") then
    return(FALSE);
  end_if;
  if op(p,1)<>hold(Pe) then
    return(FALSE);
  end_if;
  if nops(p)=1 then
    return(FALSE);
  end_if;
  n := nops(p);
  for i from 2 to n do
    if not testtype(op(p,i),Type::NonNegInt) then
      return(FALSE);
    elif op(p,i) > n+1-i then
      return(FALSE);
    end_if;
  end_for;
  TRUE;
end_proc:
