/*
|  File IsPerm (TYP PACKAGE) Sat Oct 25 12:49:29 MET DST 1997
*/

/*
|  IsPerm(p) tests whether p is or not a permutation.
*/

/*
|  VP251097
*/
muEC::TYP::IsPerm := proc(p)
local
  i; /* variable for loop... */
begin
  if (not testtype(p,DOM_LIST)) then
    FALSE;
  elif (p=[]) then
    FALSE;
  else
    /* we assume that p is a list... */
    for i from 1 to nops(p) do
      if (not testtype(p[i],Type::PosInt)) then
        return(FALSE);
      end_if;
    end_for;
    /* we are sure that all the values in p are positive integers... */
    {op(p)};
    if (nops(%)=max(op(p)) and nops(%)=nops(p)) then
      if (args(0)=2) then
        if (args(2)=hold(dominant)) then
          muEC::TYP::IsPerm_IsDominant(p);
        elif (args(2)=hold(grassmannian)) then
          muEC::TYP::IsPerm_IsGrassmannian(p);
        elif (args(2)=hold(vexillary)) then
          muEC::TYP::IsPerm_IsVexillar(p);
        else
          error("problem occured in procedure muEC::TYP::IsPerm: ".
                "Can't do such a work...");
        end_if;
      else
        TRUE;
      end_if;
    else
      FALSE;
    end_if;
  end_if;
end_proc:

/*
|  VP251097
*/
muEC::TYP::IsPerm_IsDominant := proc(perm)
local
  i,      /* var for loop... */
  cperm;  /* the code...     */
begin
  if (nops(perm)<=2) then
    TRUE;
  else
    cperm := muEC::SG::Perm2Code(perm);
    /* the code must be a partition in decreasing order... */
    for i from 2 to nops(cperm) do
      if (cperm[i]>cperm[i-1]) then
        return(FALSE);
      end_if;
    end_for;
    TRUE;
  end_if;
end_proc:

/*
|  VP252097
*/
muEC::TYP::IsPerm_IsGrassmannian := proc(perm)
local
  i, /* var for loop...       */
  r; /* the unique descent... */
begin
  if (nops(perm)=1) then
    TRUE;
  else
    /* w(i)<w(i+1) unless i=r... */
    for i from 2 to nops(perm) do
      if (perm[i]<perm[i-1]) then
        r := i;
        break;
      end_if;
    end_for;
    /* it is the permutation 1..n ... */
    if (not bool(r=hold(r))) then
      TRUE;
    else
      /* from now, we must not have a descent... */
      for i from r+1 to nops(perm) do
        if (perm[i]<perm[i-1]) then
          return(FALSE);
        end_if;
      end_for;
      TRUE;
    end_if;
  end_if;
end_proc:

/*
|  VP251097
*/
muEC::TYP::IsPerm_IsVexillar := proc(perm)
begin
  /* all permutations belonging to S(1), S(2) and S(3) are vexillary ones... */
  if (nops(perm)<4) then
    TRUE; 
  else
    /* perm is vexillary iff Part2Conjugate(Perm2Part(perm)) ... */
    /* = Perm2Part(Perm2Inv(perm)) ... */
    bool(muEC::PART::Part2Conjugate(muEC::SG::Perm2Part(perm))=
          muEC::SG::Perm2Part(muEC::SG::Perm2Inv(perm)));
  end_if;
end_proc:
