/*
|  File IsSkewPa (TYP PACKAGE) Mardi 8 juillet 1997 07:28:17
|
|  IsSkewPart(l) tests, whether l is or not a skew partition, that is, a list
|                with two components l1, l2, l1 being the exterior shape, l2 the
|                interior shape. Boxes are not necessary connected, the only
|                condition being that l2 is included in l1.
*/

/*
|  VP080797
*/
muEC::TYP::IsSkewPart:=proc(l)
local
  i,  /* var for loop... */
  l1, /* partition...    */
  l2; /* partition...    */
begin
  if not testtype(l,DOM_LIST) then
    FALSE;
  elif (nops(l) <> 2) then
    FALSE;
  else
    l1 := l[1];
    l2 := l[2];
    if not muEC::TYP::IsPart(l1) or not muEC::TYP::IsPart(l2) then
      FALSE;
    elif (nops(l1) < nops(l2)) then
      FALSE;
    elif (l2=[]) then
      TRUE;
    else
      for i from 1 to nops(l2) do
        if (l2[i] > l1[i]) then
          return(FALSE);
        end_if;
      end_for;
      TRUE;
    end_if;
  end_if;
end_proc:

/*
|  IsSkewDiag(l) tests, whether l is or not a skew diagram, that is, a list
|                with two components l1, l2, l1 being the exterior shape,
|                l2 the interior shape. These two lists  represent a connex
|                diagram of boxes.
*/

/*
|  VP080797
*/
muEC::TYP::IsSkewDiag:=proc(l)
local
  i,  /* var for loop... */
  l1, /* partition...    */
  l2; /* partition...    */
begin
  if not testtype(l,DOM_LIST) then
    FALSE;
  elif (nops(l) <> 2) then
    FALSE;
  else
    l1 := l[1];
    l2 := l[2];
    if not muEC::TYP::IsPart(l1) or not muEC::TYP::IsPart(l2) then
      FALSE;
    elif (nops(l1) < nops(l2)) then
      FALSE;
    elif (l2=[]) then
      TRUE;
    else
      for i from 1 to nops(l2) do
        if (l2[i] > l1[i]) then
          return(FALSE);
        end_if;
        if (i<>1) then
          if (l1[i]<l2[i-1] and l1[i-1]>l2[i-1]) then
            return(FALSE);
          end_if;
        end_if;
      end_for;
      if (nops(l1)>nops(l2)) then
        if (l1[nops(l2)+1]<l2[nops(l2)]) then
          FALSE;
        else
          TRUE;
        end_if;
      else
        TRUE;
      end_if;
    end_if;
  end_if;
end_proc:
