/*****************************************************************************
  $Id: reachableVertices.tst,v 1.1.1.2 2005/01/26 13:42:23 nthiery Exp $
  File:		lib/GRAPH/TEST/reachableVertices.tst
  Purpose:	Test file for the function 'Graph::reachableVertices'
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Created:	11/09/2004
  License:	LGPL
*****************************************************************************/

prog::testinit("reachableVertices"):

prog::testfunc("Graph::reachableVertices"):

G3 := Graph([a,b,c,d,e,f,g,h],[[a,b],[b,d],[b,a],[a,c],[d,c],[e,a],[e,f],[g,h]], Directed):
prog::test(Graph::reachableVertices(G3, [a]),
           {a, b, c, d}):
prog::test(Graph::reachableVertices(G3, [b]),
           {a, b, c, d}):
prog::test(Graph::reachableVertices(G3, [c]),
           {c}):
prog::test(Graph::reachableVertices(G3, [d]),
           {c, d}):
prog::test(Graph::reachableVertices(G3, [e]),
           {a, b, c, d, e, f}):
prog::test(Graph::reachableVertices(G3, [f]),
           {f}):
prog::test(Graph::reachableVertices(G3, [g]),
           {g, h}):
prog::test(Graph::reachableVertices(G3, [h]),
           {h}):

prog::test(Graph::reachableVertices(G3, [a], Backward),
           {a, b, e}):
prog::test(Graph::reachableVertices(G3, [b], Backward),
           {a, b, e}):
prog::test(Graph::reachableVertices(G3, [c], Backward),
           {a, b, c, d, e}):
prog::test(Graph::reachableVertices(G3, [d], Backward),
           {a, b, d, e}):
prog::test(Graph::reachableVertices(G3, [e], Backward),
           {e}):
prog::test(Graph::reachableVertices(G3, [f], Backward),
           {e, f}):
prog::test(Graph::reachableVertices(G3, [g], Backward),
           {g}):
prog::test(Graph::reachableVertices(G3, [h], Backward),
           {g, h}):

prog::testexit():
