/*****************************************************************************
  $Id: Predicate.tst,v 1.1.1.1 2004/10/04 17:25:13 nthiery Exp $
  File:		lib/TYPE/TEST/Predicate.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'Type::Predicate'
  Created:	04/10/2002
  License:	LGPL
*****************************************************************************/

prog::testinit("Predicate"):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the domain

prog::testfunc(Type::Predicate):

prog::check(Type::Predicate, 3):

prog::test(Type::print(Type::Predicate(x->TRUE)), 
	   hold(slot)(Type, "Predicate")(x->TRUE)):
prog::test(Type::print(Type::Predicate("Bla", x->TRUE)), 
	   hold(slot)(Type, "Bla")):
prog::test(Type::print(Type::Predicate(x->TRUE, a, b, c)),
	   hold(slot)(Type, "Predicate")(x->TRUE, a, b, c)):
prog::test(Type::print(Type::Predicate("Bla", x->TRUE, a, b, c)), 
	   hold(slot)(Type, "Bla")(a, b, c)):


prog::testfunc(Type::Predicate):

typeStandard := Type::Predicate(x->bool(sort(x)=[$1..nops(x)])):
prog::test(testtype([a,b,c], typeStandard), FALSE):
prog::test(testtype([3,1,2], typeStandard), TRUE):

typeSet := Type::Predicate((x,s)->contains(s,x), {1,2,3}):
prog::test(testtype(1, typeSet), TRUE):
prog::test(testtype(a, typeSet), FALSE):

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
