/*****************************************************************************
  $Id: overloaded.tst,v 1.1.1.2 2004/10/04 17:25:13 nthiery Exp $
  File:		lib/COMBINAT/TEST/overloaded.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'operators::overloaded'
  Created:	24/02/2001
  License:	LGPL
*****************************************************************************/

prog::testinit("overloaded"):

alias(overloaded=operators::overloaded):

prog::testfunc(overloaded):

f:=operators::overloaded(bla, table([DOM_INT, DOM_INT]=_plus)):

prog::test(f(1, 1),
           2):
prog::test(f(1, a),
           bla(1, a)):
prog::test(f(1, 0),
           1):
prog::test(f(1, 1/2),
           bla(1, 1/2)):

operators::overloaded::declareSignature(f, [DOM_INT, DOM_RAT],_mult):
prog::test(f(1, 1/2),
           1/2):

operators::overloaded::declareSignature(f, [Dom::Rational, Dom::Rational],ble):

prog::test(f(1/2, 1/2),
           ble(1/2, 1/2)):

// [DOM_INT, DOM_RAT] should match better than [Dom::Rational, Dom::Rational]
prog::test(f(1, 1/2), 
           1/2):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("Named operators"):
//////////////////////////////////////////////////////////////////////////////
prog::test(operators::overloaded::getName(operators::overloaded(bla)),
	   "anonymous operator bla"):
prog::test(operators::overloaded::getName(operators::overloaded("bla")),
	   "bla"):
prog::test(operators::overloaded::getName(operators::overloaded(bla, Name="bli")),
	   "bli"):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("Predefined conversions"):
//////////////////////////////////////////////////////////////////////////////
prog::test(operators::overloaded::convert(4, Dom::IntegerMod(4)),
	   Dom::IntegerMod(4)(4)):
//////////////////////////////////////////////////////////////////////////////
// Global checking of the package

prog::testfunc(operators::overloaded):

prog::check(operators::overloaded, 3):

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
