/*****************************************************************************
  $Id: persistentRemember.tst,v 1.1.1.2 2004/10/16 15:16:58 nthiery Exp $
  File:		lib/OPERATORS/persistentRemember.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'operators::persistentRemember'
  Created:	04/12/2002
  License:	LGPL
*****************************************************************************/

prog::testinit("persistentRemember"):

prog::testfunc("operators::persistentRemember"):

protect(shell): // Silents prog::check about global variable shell

operators::persistentRemember::setDirectory(shell::tempFilename()):

count := table():
// f stores in count how many time it has been called for each set of arguments
f :=
proc()
begin
    if not contains(count, args()) then
	count[args()] := 1;
    else
	count[args()] := count[args()] + 1;
    end_if;
    [args()];
end_proc:
g := operators::persistentRemember(f):
g(1):
prog::test(g(1), [1]):
g(2, x):
prog::test(g(2, x), [2, x]):
bla := 3, [a,b,c], "bla", matrix([[2,a],[5,x+1]]):
g(bla):
prog::test(g(bla), [bla]):
prog::test(g(hold(Recalculate), 1), [1]):

// Check that f has been called the proper number of times
prog::test(count[1], 2):
prog::test(count[2,x], 1):
prog::test(count[bla], 1):

domain bla
    f := x->x^2;
    g := operators::persistentRemember(dom::f);
end_domain:
prog::test(bla::g(2), 4):
prog::test(bla::g(2), 4):

shell::system("rm -rf ".operators::persistentRemember::directory):

prog::testexit():

prog::check(operators::persistentRemember, 3):

// Local Variables: 
// mode: mupad
// End:
