/*****************************************************************************
  $Id: asciiArt.tst,v 1.1.1.2 2004/10/04 17:25:16 nthiery Exp $
  File:		lib/OUTPUT/TEST/asciiArt.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'output::asciiArt'
  Created:	02/07/2002
  License:	LGPL
*****************************************************************************/

prog::testinit("asciiArt"):

export(output, Alias, asciiArt):

// The documentation makes a fairly safe testsuite. Just test some
// trivial cases.

x:=asciiArt([]):
y:=asciiArt(["a"]):
z:=asciiArt(["ab","cd"]):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("print"):
//////////////////////////////////////////////////////////////////////////////
prog::test(x::dom::print(x), ""):
prog::test(y::dom::print(y), "a\n"):
prog::test(z::dom::print(z), "cd\nab\n"):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("width"):
//////////////////////////////////////////////////////////////////////////////
prog::test(x::dom::width(x), 0):
prog::test(y::dom::width(y), 1):
prog::test(z::dom::width(z), 2):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("height"):
//////////////////////////////////////////////////////////////////////////////
prog::test(x::dom::height(x), 0):
prog::test(y::dom::height(y), 1):
prog::test(z::dom::height(z), 2):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("concat"):
//////////////////////////////////////////////////////////////////////////////

d1 := asciiArt([]):
d2 := asciiArt(["bla"]):
d3 := asciiArt(["a","bc"]):
prog::test(asciiArt::concat(d1),
           new(asciiArt,[], Center)):
prog::test(asciiArt::concat(d1, d1),
           new(asciiArt,[], Center)):
prog::test(asciiArt::concat(d1, d2),
           new(asciiArt,["bla"], Center)):
prog::test(asciiArt::concat(d1, d2, d2),
           new(asciiArt,["blabla"], Center)):
prog::test(asciiArt::concat(d3, d2, d3),
           new(asciiArt,["a blaa ", "bc   bc"], Center)):

d5 := asciiArt(["a   ", "bcde"]):
d6 := asciiArt(["bcde", "  bc"]):
prog::test(asciiArt::concat(d5, d6, Packed, Margin = 1),
           new(asciiArt,["a    bcde", "bcde   bc"], Center)):
prog::test(asciiArt::concat(d5, d6, Packed),
           new(asciiArt,["a   bcde",  "bcde  bc"], Center)):

prog::test(asciiArt::concat(asciiArt(["  a", "|  ", "a  "]),
			    asciiArt(["  a", "  |", "a  "]), Packed),
           new(asciiArt,["  aa", "|  |", "aa  "], Center)):
prog::test(asciiArt::concat(asciiArt(["  a", "a  "]), asciiArt(["  a", "a  "]), Packed),
           new(asciiArt,["  a  a", "a  a  "], Center)):

//////////////////////////////////////////////////////////////////////////////
// Global checking of the domain

prog::testfunc(asciiArt):
prog::testexit():
prog::check(asciiArt, 3):

// Local Variables: 
// mode: mupad
// End:
