/*****************************************************************************
  $Id: bless.tst,v 1.1.1.2 2004/10/04 17:25:13 nthiery Exp $
  File:		lib/PROG/TEST/bless.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for the library 'prog::bless'
  Created:	04/12/2002
  License:	LGPL
*****************************************************************************/

prog::testinit("bless"):

prog::testfunc(prog::bless):

prog::check(prog::bless, 3):

domain A
    f:=[prog::bless(()->dom, dom)];
    g:=[prog::bless(funcenv(()->dom), dom)];
begin
end_domain:

f:=prog::bless(()->dom, A):
g:=prog::bless(funcenv(()->dom), A):
prog::test(f(), A):
prog::test(g(), A):
prog::test(A::f[1](), A):
prog::test(A::g[1](), A):

f1:=prog::blessAny(()->dom, A):
g1:=prog::blessAny(funcenv(()->dom), A):
h1:=prog::blessAny(13, A):
prog::test(f1(), A):
prog::test(g1(), A):
prog::test(h1, 13):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("Table of functions and bless"):

domain mydomain3
    new :=
    proc(x)
    begin
        if contains(dom::newFunctions, domtype(x)) then
           dom::newFunctions[domtype(x)](x);
        else
           error("Don't know how to convert x");
        end_if;
    end_proc;

    newFunctions :=
    map(table(
              DOM_INT  = (n -> new(dom, [$1..n])),
              DOM_LIST = (l -> new(dom, l))
             ),
        prog::bless, dom);
end_domain:
prog::test(mydomain3(3),       new(mydomain3, [1,2,3])):
prog::test(mydomain3([1,2,3]), new(mydomain3, [1,2,3])):

prog::testexit():

// Local Variables: 
// mode: mupad
// End:
