/*****************************************************************************
  $Id: loaddomain.tst,v 1.1.1.2 2005/01/26 13:42:22 nthiery Exp $
  File:		lib/PROG/loaddomain.tst
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Test file for prog::loaddomain
  Created:	04/11/2003
  License:	LGPL
*****************************************************************************/

prog::testinit("loaddomain"):

prog::testfunc("prog::isDefined"):
prog::test(prog::isDefined(nonExistentVariable),
           FALSE):
prog::test(prog::isDefined(stdlib),
           TRUE):
prog::test(prog::isDefined(Cat::NonExistentCategory),
           FALSE):
prog::test(prog::isDefined(Cat::BaseCategory),
           TRUE):
blah := loadproc(test, "", "NonExistentFile"):
prog::test(prog::isDefined(blah),
           FALSE): // should not trigger the loadproc

// Tests embedded calls to prog::isDefined
prog::test((() -> prog::isDefined(Cat::Blah))(),
           FALSE):
prog::test((() -> prog::isDefined(Cat::BaseCategory))(),
           TRUE):

//////////////////////////////////////////////////////////////////////////////
prog::testfunc("prog::loaddomain"):

alias(loaddomain=prog::loaddomain):
warning("This test should emit three warnings (including this one)"):
blah := loaddomain(blah, "blah", "blah"):
prog::test(bool(extop(val(blah),0)=stdlib::LoadProc)):
blah := loaddomain(blah, "blah", "blah"):
prog::test(bool(extop(val(blah),0)=stdlib::LoadProc)):
blah := 1:
blah := loaddomain(blah, "blah", "blah"):
prog::test(blah,1):

getEntry :=
proc(aDomain: DOM_DOMAIN, entry: DOM_STRING)
begin
    op(select(extop(aDomain), x->op(x,1)=entry),2);
end_proc:

domain aDomain
    blah := loaddomain(aDomain::blah, "blah", "blah");
end_domain:
aDomain::blah := loaddomain(aDomain::blah, "blah", "blah"):
prog::test(bool(extop(getEntry(aDomain, "blah"),0)=stdlib::LoadProc)):
aDomain::blah := loaddomain(aDomain::blah, "blah", "blah"):
prog::test(bool(extop(getEntry(aDomain, "blah"),0)=stdlib::LoadProc)):
aDomain::blah := 1:
aDomain::blah := loaddomain(aDomain::blah, "blah", "blah"):
prog::test(aDomain::blah, 1):

prog::testexit():

// Local Variables:
// mode: mupad
// End:
