//////////////////////////////////////////////////////////////////////////////
// $Id: GLIP.tst,v 1.1.1.2 2004/10/04 17:25:10 nthiery Exp $
// Name:	GLIP.tst
// Purpose:	MuPAD dynamic module for the GLIP C++ library
//		(test suite)
// Author:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
// Created:	2000/09
// Copyright:	LGPL
//////////////////////////////////////////////////////////////////////////////

prog::testinit("GLIP"):
prog::testfunc("Module creation"):
module(GLIP):
prog::testfunc("new"):
generators:=[[2,1,3,4,5],[2,3,4,5,1]]:
G:=GLIP::new(generators):		// The symmetric group S5

prog::testfunc("size"):
prog::test(GLIP::size(G), 				120):

prog::testfunc("allElements"):
prog::test(nops(GLIP::allElements(G)),			120):

G2:=GLIP::new([[1,2,3]]):
prog::test(GLIP::allElements(G2),			[[1,2,3]]):

prog::testfunc("canonic"):
prog::test(GLIP::canonic(G,[1,3,2,5,3]),		[5,3,3,2,1]):

prog::testfunc("isCanonic"):
prog::test(GLIP::isCanonic(G,[1,2,3,5,3]),		FALSE):
prog::test(GLIP::isCanonic(G,[7,3,3,2,1]),		TRUE):
prog::testfunc("orbit"):
prog::test(GLIP::orbit(G2,[7,3,2]),			[[7,3,2]]):
prog::testfunc("orbitSet"):
prog::test({op(GLIP::orbitSet(G,[1,1,1,1,0]))},
	   {[1,1,1,1,0],[1,1,1,0,1],[1,1,0,1,1],[1,0,1,1,1],[0,1,1,1,1]}):
prog::testfunc("orbitSize"):
prog::test(GLIP::orbitSize(G,[3,3,2,2,2]),		10):
prog::testfunc("automorphismGroupSize"):
prog::test(GLIP::automorphismGroupSize(G,[3,1,2,2,3]),	4):

prog::testfunc("canonicBinaryLists"):
prog::test(nops(GLIP::canonicBinaryLists(G,3)),		1):

prog::testfunc("canonicCompositions"):
for n from 1 to 5 do
    prog::test(nops(GLIP::canonicCompositions(G,n)), combinat::partitions::count(n)):
end_for:

prog::testexit():
null():

// Local Variables: 
// mode: mupad
// End:
