//////////////////////////////////////////////////////////////////////////////
// $Id: MAPITL.tst,v 1.1.1.1 2003/09/15 16:37:49 nthiery Exp $
// Name:	MAPITL_test.cc
// Purpose:	Template Library for the
//		MuPAD Application Programming Interface
//		(Test suite, MuPAD part)
// Author:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
// Created:	2000/09
// Copyright:	LGPL
//////////////////////////////////////////////////////////////////////////////

TestPrecision:=14:	// Precision for floating point tests
fprint(Unquoted,0,"Warning: making floating point tests with only ", TestPrecision, " decimals."):
fequal :=
proc(x,y) begin
   return(bool(abs(x-y)<float(10^(-TestPrecision))));
end_proc:

export(prog, test):
prog::testinit("MAPITL"):

prog::testfunc("Module loading"):

module(MAPITL_test):
test(bool(MAPITL_test::doc<>FAIL)):
export(MAPITL_test):

prog::testfunc("Conversions of boolean types"):

test(test_bool(FALSE), FALSE):
test(test_bool(TRUE ), TRUE ):

prog::testfunc("Conversions of integer types"):

test(test_int(1),2):

prog::testfunc("Conversions of float types"):

prog::testfunc("Float types"):
test(fequal(test_float (4  ),5  )):
test(fequal(test_float (4.5),5.5)):
test(fequal(test_double(4  ),5  )):
test(fequal(test_double(4.5),5.5)):

prog::testfunc("Conversions of pointers"):

// test(test_pointer(18),???):

prog::testfunc("Conversions of strings"):

test(test_string		   ("Coucou"),		"uocuoC"):

prog::testfunc("Conversions of containers"):

test(test_iterator		   (),			[0,1,2,3,4]):
test(test_pair			   ([1,"bla"]),		[2, "alb"]):
test(test_list			   ([1,2,3,4]),		[4,3,2,1]):
test(test_list2			   ([1,2,3,4]),		[4,3,2,1]):
test(test_listlist		   ([[1,2],[3,4]]),	[[3,4],[1,2]]):

prog::testfunc("Container"):

test(test_Container_size	   ([1,2,3,4]),		4):
test(test_Container_reference	   ([1,2,7,4],3),	7):
test(test_Container_subscript_const([1,2,7,4],3),	7):
test(test_Container_subscript	   ([1,2,7,4],3,5),	[1,2,5,4]):
test(test_Container_iterator_const ([1,2,7,4]),		[4,7,2,1]):
test(test_Container_push_back      ([1,2,7,4],3),	[1,2,7,4,3]):
test(test_Container_iterator	   ([1,2,7,4]),		[4,7,2,1]):

// This tests causes an internal failure. Why ?
// test_Container_iterator	   ([1]),1:

prog::testexit():
null():

// Local Variables: 
// mode: mupad
// End:
