javaview := newDomain("javaview"):

javaview::interface := {hold(plot)}:
javaview::packageLocation := FILEPATH."..":

javaview::plot :=
proc(tmp, res, exportOpts)
  local docFile, FPS, converter, i, lastKey;
begin
  if traperror(shell::system("test -x \"`which javaview`\"")) <> 0 then
    docFile := shell::system("/bin/echo -n $MuPAD_ROOT_PATH")."/share/doc/readme.html";
    warning("javaview not available; please read\n".docFile."\nabout plotting via javaview");
    if plot::callCounter() = 1 then
      for i in ["firefox", "mozilla", "konqueror",
                "gnome-help-browser"] do
        if traperror(shell::system(i." \"file://".docFile."#JavaView_export:\" > /dev/null 2>&1")) = 0 then
                break;
        end_if;
      end_for;
    end_if;
    return();
  end_if;

  if traperror(shell::system("test -x \"".javaview::packageLocation."/`sysinfo`/bin/xvc2jvx\" > /dev/null 2>&1")) = 0 then
    // xvc2jvx found in package;  use it
    converter := javaview::packageLocation."/`sysinfo`/bin/xvc2jvx";
  else
    // use xvc2jvx in PATH
    converter := "xvc2jvx";
  end_if;
  
  if contains(res, "TimeRange") and
    type(res["TimeRange"]) = "_range" then
    // Animation
    if contains(exportOpts, FramesPerSecond) then
      FPS := exportOpts[FramesPerSecond];
    else
      FPS := 5;
    end_if;
    lastKey := floor(FPS*(op(res["TimeRange"], 2) - op(res["TimeRange"], 1)) + 1);
    shell::system(converter." -f ".FPS." -o ".tmp.".jvx ".tmp);
    shell::system(converter." -d -o ".tmp.".jvd ".tmp);
    shell::removeFile(tmp);
    shell::system("(javaview \"model=".tmp.".*.jvx\" \"displayFile=".tmp.".jvd\" \"size=480x320\" Animation.interpolType=NONE Animation.lastKey=".lastKey." ; rm ".tmp."*.jv? ) &");
  else
    // no animation
    shell::system(converter." -o ".tmp.".jvx ".tmp);
    shell::system(converter." -d -o ".tmp.".jvd ".tmp);
    shell::removeFile(tmp);
    shell::system("(javaview \"model=".tmp.".jvx\" \"displayFile=".tmp.".jvd\" \"size=480x320\"; rm ".tmp.".jv? ) &");
  end_if;  
end_proc:

  
protect(javaview, ProtectLevelError):
null():