/* $Date: 2004/07/22 11:34:41 $  $Author: ccr $  $Revision: 1.100 $ */

/**************************************************************************/
/* FILE:             MUP_constants.h                                      */
/* Autor:            Andreas Kemper                                       */
/* Erstellt:         25/04/91                                             */
/* Letzte Aenderung: 03/03/97                                             */
/**************************************************************************/

#ifndef __MUP_constants__
#define __MUP_constants__


/**************************************************************************/
/* Dieses File enythaelt die Definition fuer alle Konstanten.             */
/**************************************************************************/

/* Jetzt geht's los .... */


#define NO_SYM_BIT             0x0

#define OPTIONS_CHECKED_BIT    0x8
#define NO_DEBUG_BIT           0x10
#define HOLD_BIT               0x20
#define REMEMBER_BIT           0x40
#define ARROW_BIT              0x80
#define ESCAPE_BIT             0x100
#define NO_EXPOSE_BIT          0x200

#define NO_LEXENV_BIT          0x4000

/* Oder-Maske aller Prozedur-Options-Bits */
#define OPTION_BITS_MASK       0x3F0

/* Oder-Maske aller fuer Vergleiche beruecksichtigten Bits */
#define COMPARE_BITS_MASK      0x3F8

#ifdef MSDOS
#  define SYS_SIGNAL SIGQUIT    /* Dummy, da MSDOS SIGUSR2 nicht kennt  */
#else
#  define SYS_SIGNAL SIGUSR2    /* Signal an mupad zur Ank"undigung     */
                                /* eines Systembefehls                  */
#endif


/************* Defintion der Datentypen der Speicherverwaltung ***********
 *
 * Bei MMM-Typen, von denen Signaturen berechnet werden, muss die zugehoerige
 * MMM_-Konstante kleiner als MUPC_MaxStorTypes sein.
 */

enum MMME_type {
    MMM_INT             = 14,
    MMM_LIST            = 15,
    MMM_EXT_LIST        = 16,
    MMM_CATEGORY        = 17,
    MMM_STRING          = 18,
    MMM_ASS_MEM         = 19,
    MMM_VECTOR          = 20, // multi-purpose vector of s-pointers, generates
                              // r/o literal
    MMM_INTERVAL        = 21,
    MMM_VALUE           = 26,
    MMM_DOMAIN          = 27,
    MMM_ARRAY           = 28,
    MMM_STRING_HELP     = 29, // Hilfstyp, der vom MCode benutzt wird
    MMM_NAMESPACE       = 30,
    MMM_BYTECODE        = 31,
    MMM_VAR             = 32,
    MMM_PROC_ENV        = 33,
    MMM_ASSOC           = 34,
    MMM_RW_LIT          = 35, // multi-purpose type for internal use only, 
                              // generates r/w literal
    MMM_RO_LIT          = 36, // multi-purpose type for internal use only, 
                              // generates r/o literal
    MMM_FRAME           = 37, // see CAT_FRAME
    MMM_IDENT           = 38, ///< internal data structure for identifiers
    MMM_EXEC            = 40,
    MMM_CODE            = 41,
    MMM_PARI            = 44,
    MMM_DIST_POLY       = 45,
    MMM_FUNCLIST        = 46,
    MMM_TMP             = 102,
    MMM_HIDDEN          = 103,
    MMM_CLTCTX          = 104,
    MMM_OUT_COLLECT     = 109,
    MMM_OUT_NODE        = 110,
    MMM_OUT_TEXT        = 111,
    MMM_OUT_FIELD       = 112
};


/****************** Defintion der Kategorietypen *************************/
/*
 * ACHTUNG: Bei Erweiterungen/Aenderungen muss auch die Tabelle der
 * zugehoerigen Namen (MEVV_CAT_NAMES) angepasst werden!
 *
 * ACHTUNG: Die Konstanten duerfen nicht geaendert werden, da der MCode-
 * Parser sie zur Serialisierung verwendet!
 */

enum MTRE_cat_type {
    CAT_APM        =  1,      //// These values must not be changed,
    CAT_FLOAT      =  2,      //// because they must be identical
    CAT_INT        =  3,      //// to the internal PARI numbers.
    CAT_RAT        =  4,      //// Furthermore, everything from 1 to 6
    CAT_COMPLEX    =  6,      //// is assumed to be a PARI number.
    // everything up to here is assumed numerical, i.e., a single PARI
    // number.  Do not use the numbers 5 or 7!
    CAT_INTERVAL   =  8,
    CAT_STRING     = 10,
    CAT_BOOL       = 11,
    CAT_NULL       = 13,
    CAT_NIL        = 14,
    CAT_EXT2       = 18,  ///< Special type used inside the MCODE
    CAT_FRAME      = 19,  ///< interactive namespaces for variables
    CAT_IDENT      = 20,
    CAT_SET_FINITE = 21,
    CAT_STAT_LIST  = 23,
    CAT_ARRAY      = 24,
    CAT_TABLE      = 25,
    CAT_EXPR       = 26,
    CAT_FUNC_ENV   = 27,
    CAT_VAR        = 28,
    CAT_PROC_ENV   = 29,
    CAT_EXEC       = 31,
    CAT_DEBUG      = 32,
    CAT_PROC       = 33,
    CAT_POLY       = 34,
    CAT_DOM        = 35,
    CAT_EXT        = 36,
    CAT_FAILED     = 37,
// 38, 39 are free nor:  were CAT_POLYGON, CAT_POINT
    CAT_RPOLY      = 40,
    CAT_NAMESPACE  = 41,
    CAT_BYTECODE   = 42
    // Attention MUPC_MaxCatTypes is 50 but if one chooses a number greater 
    // than 42 one have to increase the definement MEVC_MAX_OPERANDS because
    // otherwise the definement MEV_CAT_2_MEV finds an entry in 
    // MEVV_LegalOpTab which does not exist
};

#define MUPC_MaxCatTypes 50

#define MUPC_real         5
#define MUPC_num          7
#define MUPC_simple      20


/****************** Definition der '_' - Systemfunktionen ****************/
/*                                                                       */
/*                   ACHTUNG !  ACHTUNG !  ACHTUNG!                      */
/*     Diese muessen zur Zeit mit den Konstanten MEVC_* und MPAC_*       */
/*                        unbedingt uebereinstimmen.                     */
/*************************************************************************/

enum MUPC_sysfunc {
  _EXPRSEQ      = 1,  //MEVC_EXPRSEQ,
  _OR           = 2,  //MEVC_OR,
  _AND_         = 3,  //MEVC_AND, /* _AND kollidiert mit AMIGA */
  _SEQGEN       = 4,  //MEVC_SEQGEN,
  _LESS         = 5,  //MEVC_LESS,
  _LEEQUAL      = 6,  //MEVC_LEEQUAL,
  _EQUAL        = 7,  //MEVC_EQUAL,
  _UNEQUAL      = 8,  //MEVC_UNEQUAL,
  _RANGE        = 9,  //MEVC_RANGE,
  _MOD          = 10, //MEVC_MOD,
  _DIV          = 11, //MEVC_DIV,
  _UNION        = 12, //MEVC_UNION,
  _MINUS        = 13, //MEVC_MINUS,
  _INTERSECT    = 14, //MEVC_INTERSECT,
  _PLUS         = 15, //MEVC_PLUS,
  _MULT         = 16, //MEVC_MULT,
  _POWER_       = 17, //MEVC_POWER,  /* _POWER kollidiert mit math.h */
  _CONCAT       = 18, //MEVC_CONCAT,
  _FCONCAT      = 19, //MEVC_FCONCAT,
  _DUMMY_1      = 20, //N.N.
  _DUMMY_2      = 21, //MEVC_STMT,
  _DUMMY_3      = 22, //MEVC_UNKNOWN,
  _DUMMY_4      = 23, //MEVC_SIGN,
  _DIVEX        = 24, //MEVC_DIVIDE,
  _INVERT       = 25, //MEVC_INVERT,
  _SUBTRACT     = 26, //MEVC_SUBTRACT,
  _NEGATE       = 27, //MEVC_NEGATE,
  SEQIN         = 28, //MEVC_SEQIN,
  _SEQSTEP      = 29, //MEVC_SEQSTEP,

  // Ende des mit MEV_evaluate_help.h synchronen Bereichs

  _ASSIGN,
  _IF,
  _CASE,
  _FOR,
  //  _FOR_PAR,
  _FOR_DOWN,
  _FOR_IN,
  //  _FOR_IN_PAR,
  _WHILE,
  _REPEAT,
  _NEXT,
  _BREAK,
  _QUIT,
  // _PARBEGIN,
  // _SEQBEGIN,
  _STMTSEQ,
  _SYSASSIGN,
  _DELETE,
  _SYSDELETE,
  _LAZY_AND,
  _LAZY_OR,
  _SAVE,


/*************************************************************************/
/* Definition aller weiteren '_' - Systemfunktionen. Diese werden als    */
/* 'MMM_STRING's in die Tabelle MTRV_SYS_FUNC_LIST eingetragen. Die      */
/* Funktionsnamen stimmen i.A. mit dem Definement ueberein.              */
/*************************************************************************/


/* Andere Datentypen */

  _PROCDEF,
  _FUNC_ENV,
  _BUILT_IN,
  _ARRAY,
  _TABLE,

  _NULL_,      // _NULL is defined on PowerMac
  _SPLIT,

  _FRAME,
  _PARENTFRAME,
  _ROOTFRAME,

/* I/O - Routinen */

  _PRINT_,  // _PRINT may be defined in ctype.h
  _INPUT,
  _TEXTINPUT,
  _WRITE,
  _FILEREAD,
  _FCLOSE,
  _FINPUT,
  _FILEOPEN,   // _FOPEN may be defined in a std header
  _FPRINT,
  _FTEXTINPUT,
  STRPRINT,
  GETLASTERROR,
  WRITECONTENT,

  _FNAME,
  _READBYTES,
  _WRITEBYTES,
  _FLOCK,
  _UNLOCK,


/* Objektmanipulation */

  _TYPE_,      // _TYPE is defiened in math.h for VC++ 4.2
  _NOPS,
  _OP,
  _SUBS,
  _SUBSEX,
  _SUBSOP,
  _TESTTYPE,
  _MUP_VAL,
  _SLOT,
  _EXTNOPS,
  _EXTOP,
  _EXTSUBSOP,
  _MAP,
  _SORT,
  _CONTEXT_,   /* _CONTEXT kollidiert mit Visual C++ 4.0 */
  _ID,
  _DOMTYPE,
  _ZIP,
  _SELECT,


/* Systemzustand - Analyse */

  _TIME_,    /* _TIME kollidiert mit PowerMac */
  _RTIME,
  _ASSIGN_CNT,
  _HISTORY,
  _LAST,
  _RESET,
  _BYTES,
  _ANAMES,
  _SYSTEM,
  _PROTOCOL,
  _SYSNAME,
  _TESTARGS,
  _PARSER_CALLBACK,
  _REGISTER,
  _GETPID,

/* Konvertierungsfunktionen */

  _FLOAT,
  _BOOL,
  _NEW_EXTELEMENT,
  _NEW_DOMAIN,
  _GEN_LIT,
  _HULL,
  _INTERVAL,
  _NEW_BYTECODE,
  _SHARE,

/* Textmanipulation */

  _SUBSTRING,
  _TBL2TEXT,
  _TEXT2TBL,
  _TEXT2LIST,
  _STRMATCH,
  _TEXT2EXPR,
  _EXPR2TEXT,
  COLLAPSEWS,

/* Graphik */

  _PLOT,
  _POINT,
  _POLYGON,

/* Pari - Funktionen */

  _INT2TEXT,
  _TEXT2INT,
  _SININT,
  _COSINT,

// fuer 2.5.1
  _LAMBERTV,

  _LAMBERTW,
  _ABSS,
  _ACOS,
  _ASIN,
  _ASINH,
  _ATAN,
  _ATANH,
  _COS,
  _COSH,
  _EXP,
  _LN,
  _SIN,
  _SINH,
  _SQRT,
  _TAN,
  _TANH,
  _ACOSH,
  _ZETA,
  _GAMMA,
  _PSI,
  _ERFC,
  _CEIL,
  _FLOOR,
  _FRAC,
  _ISPRIME,
  _NEXTPRIME,
  _FACT,
  _ROUND,
  _TRUNC,
  _IGCD,
  _ILCM,
  _SIGN,
  _FRANDOM,
  _IFACTOR,
  _ITHPRIME,
  _PHI,
  _PRIMEDIVISORS,
  _NUMDIVISORS,
  _IGCDEX,
  _MODP,
  _MODS,
  _MUP_MAX,
  _MUP_MIN,
  _POWERMOD,
  _EINT,
  _IGAMMA,
  _ISQRT,
  _LLLINT,
  _EXP1,
  IBETA,

  ISNONZERO,
  ISLESS,

/* Verschiedenes */

  _LASTERROR,
  _ASSIGN_ELEMS,
  _INDEX_VAL,
  _ARGS_,    /* _ARGS kollidiert mit gcc 2.2.3 */
  _RETURN,
  _TRAPERROR,
  _ERROR,
  _EVAL,
  _APPEND,
  _DIFF,
  _EXPAND,
  _INDEX,
  _HOLD,
  _HELP,
  _LEVEL,
  _NOT,
  _CONTAINS,
  _GPROF,
  _VOLATIL,
  _UNVOLATIL,
  _INDETS,
  _GENIDENT,
  _PROPERTIES,
  _HAS,
  _PREF,
  _ENCODE,
  _WARNING,

/* Polynom-Operationen */

  _POLY,
  _EXPR,
  _DEGREE,
  _DEGREEVEC,
  _LTERM,
  _LCOEFF,
  _TCOEFF,
  _COEFF,
  _MAPCOEFFS,
  _DIVIDE,
  _PDIVIDE,
  _ICONTENT,
  _MULTCOEFFS,
  _NORM,
  _EVALP,
  _ISZERO,
  _GENPOLY,
  _NTHTERM,
  _NTHCOEFF,
  _NTERMS,
  _LMONOMIAL,
  _NTHMONOMIAL,
  _DPOLY,
  _LDEGREE,
  _POLY2LIST,
  _FLOAT_MULT,
  _FLOAT_PLUS,
  _FLOAT_POWER,
  _RPOLY,
  _PINDETS,
  _MONOMIALS,

/* Dynamische Module */

  _LOADMODUL,
  _UNLOADMODUL,
  _EXTERNAL,

/* Verschiedenes II */

  _USERINFO,
  _USERINFO_LEVEL,
  _SYSORDER,
  _LENGTH,
  _NOCOMPROD,
  _MUP_PROTECTED,
  _PARSER_CONFIG,
  FROM64,
  TO64,

/* Operator-Funktionen */

  _OP_PLUSMULT,
  _OP_POWER,
  _OP_FCONCAT,
  _OP_FCONCATPOWER,

  _DOMAINFUNCCALL,
  _OUTPUT_FORMAT,
  _OUTPUT_TYPE,

/* Debugger-Funktionen */

  _DEBUG_,    /* _DEBUG kollidiert mit Visual C++ 4.0 */
  _GCOV,

/* Konstruktoren, Clients */

  _COPY_CLOSURE,
  _ACT_PROC_ENV,
  _EVAL_ENTRY,
  _CLIENT_OBJECT,
  _CLIENT_CALL,
  _CLIENT_MESSAGE,

/* Funktionen zum Rechnen mit Floats und gerichteten Rundungen */

  _RD_ROUND,
  _RD_INT2FLOAT,
  _RD_ABS,
  _RD_NEG,
  _RD_ADD,
  _RD_SUB,
  _RD_MUL,
  _RD_DIV,
  _RD_FLOAT2TEXT,
  _RD_TEXT2FLOAT,
  _RD_ISFINITE,
  _RD_GETSIGN,

/* Operationen auf Intervallen */
  IV_LN,
  IV_EXP,
  IV_SIN,
  IV_SINH,
  IV_ATAN,
  IV_SET2EXPR,
  IV_ARG,
  IV_ABS,

  // weitere Utility-Funktionen
  HASFLOAT,

  // letzter Eintrag!
  MUPC_sysfunc_max
};

/* Achtung die Laenge dieser Liste ist durch 'MSYC_sys_func_list_len' */
/* in der Datei 'MSY_sys_func_init.cpp' beschraenkt.                  */


/********************* Konstanten ****************************************/

#define MUPC_MaxStorTypes  120   /* Maximale Anzahl der verschiedenen    */
                                 /* Speichertypen (MMM)                  */

/*********** Rechnerabhaengige Konstanten *******************************/

#define MAX_INT        2147483647
#define MIN_INT        2147483648

/************************************************************************/

#ifndef TRUE
#define TRUE      1
#endif

#ifndef FALSE
#define FALSE     0
#endif

/************************************************************************/

/* Modi fuer fopen() */

#ifdef MACINTOSH

#  define MUPC_READ_BIN    "rb"
#  define MUPC_READ_TEXT   "r"
#  define MUPC_WRITE_BIN   "wb"
#  define MUPC_WRITE_TEXT  "w"
#  define MUPC_APPEND_BIN  "ab"
#  define MUPC_APPEND_TEXT "a"
#  define MUPC_READ_WRITE_BIN "rb+"
#  define MUPC_READ_WRITE_TEXT   "r+"

#else
#ifdef MSDOS

#  define MUPC_READ_BIN    "rb"
#  define MUPC_READ_TEXT   "rt"
#  define MUPC_WRITE_BIN   "wb"
#  define MUPC_WRITE_TEXT  "wt"
#  define MUPC_APPEND_BIN  "ab"
#  define MUPC_APPEND_TEXT "at"
#  define MUPC_READ_WRITE_BIN "rb+"
#  define MUPC_READ_WRITE_TEXT "rt+"

#else

#  define MUPC_READ_BIN    "r"
#  define MUPC_READ_TEXT   "r"
#  define MUPC_WRITE_BIN   "w"
#  define MUPC_WRITE_TEXT  "w"
#  define MUPC_APPEND_BIN  "a"
#  define MUPC_APPEND_TEXT "a"
#  define MUPC_READ_WRITE_BIN "r+"
#  define MUPC_READ_WRITE_TEXT "r+"

#endif /* MSDOS */
#endif /* MACINTOSH */

/**************************  GLOBAL MACROS  *****************************/

#ifdef OLD_OUTPUT_TYPES
#define MUP_flush_stdout()  MIO_write('\0')
#else
#define MUP_flush_stdout()
#endif

#if   (defined MACINTOSH)
#  define MUP_exit(c)   { MAC_CloseFrontend(); ExitToShell(); }
#  define MUP_fatal(x)  { MAC_fatal(x); }
#elif (defined MSDOS)
#  define MUP_exit(n)   { MSW_exit(n); }
#  define MUP_fatal(s)  { MSW_fatal(s); }
#else //       UNIX
#  define MUP_exit(c)   { exit(c); }
#  define MUP_fatal(t)  { fprintf(stderr,"\n%s\n", (t)); \
                          fflush(stderr);                \
                          exit(MUPC_FATAL_ERR); }
#endif

/*********** Default - Werte veraenderbarer MuPAD - Systemvariablen *****/

#define MEVC_LEVEL_DEFAULT          100
#define MEVC_MAXLEVEL_DEFAULT       100
#define MEVC_MAXDEPTH_DEFAULT       500
#define MEVC_MAXMAXDEPTH           1000
#define MEVC_TEXTWIDTH_DEFAULT       75

#define MEVC_DQ_DEFAULT       "\"" /* Darf nicht ver"andert werden */

/****************** Konstanten des Evaluierers **************************/

#define MEVC_LEVEL_INF     2147483647  /* 2^31 - 1 */

#if defined MSDOS && !defined __GNUC__
/* Dummy-Vereinbarungen */
#define kill(a,b)               0
#define getpid()                0
#define getppid()               0
#endif

#define MUPC_constants_CAT_BOOL_FALSE   3  /* FALSE < UNKNOWN < TRUE ! */
#define MUPC_constants_CAT_BOOL_UNKNOWN 4
#define MUPC_constants_CAT_BOOL_TRUE    5

#if (defined MSDOS) || (defined WIN32)
#  define MUPC_PATHLIST_SEPARATOR ';' /* Trennung von Pfaden in Listen */
#  define MUPC_PATH_SEPARATOR '\\'    /* Trennung von Directory-Namen  */
#  ifdef __GNUC__
#  define MUPC_MAX_PATH 512           /* max. Pfadlaenge von Filenamen */
#  else
#  define MUPC_MAX_PATH _MAX_PATH     /* max. Pfadlaenge von Filenamen */
#  endif
#elif (defined MACINTOSH)
#  define MUPC_PATHLIST_SEPARATOR ';' 
#  define MUPC_PATH_SEPARATOR ':'
#  define MUPC_MAX_PATH 512  
#else
#  define MUPC_PATHLIST_SEPARATOR ':'
#  define MUPC_PATH_SEPARATOR '/'
#  ifdef PATH_MAX
#   define MUPC_MAX_PATH PATH_MAX
#  else
#   define MUPC_MAX_PATH 512
#  endif
#endif

#endif /* __MUP_constants__ */

