/*****************************************************************************
  $Id: binomialRecursive.mu,v 1.1 2004/01/15 18:48:14 hivert Exp $
  File:		lib/COMBINAT/binomialRecursive.mu
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Function 'combinat::binomialRecursive': recursive binomial
  Created:	10/01/2004
  License:	LGPL
*****************************************************************************/

combinat::binomialRecursive :=
proc(n : Type::Integer,
     k : Type::Integer)
// compute the binomial coefficient in a crude manner in order to store 
// them in a remember table. This can speed up drastically some function such as
// words::split::unrank and the labelled generation of decomposableObjects.
    option remember;
begin
    if k < 0     then 0;
    elif n-k < k then combinat::binomialRecursive(n, n-k);
    elif k = 0   then 1;
    elif k = 1   then n;
    else combinat::binomialRecursive(n-1, k-1) + 
	 combinat::binomialRecursive(n-1, k);
    end_if;
end_proc:

