/*****************************************************************************
  $Id: decomposableStructure.mu,v 1.3 2003/01/30 13:42:40 nthiery Exp $
  File:		lib/COMBINAT/structure.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
                Florent Hivert <florent.hivert@univ-mlv.fr>
  Created:	16/02/2001
  License:	LGPL
*****************************************************************************/

category combinat::decomposableStructure

    category combinat::structure;

    info := "Category 'combinat::decomposableStructure': combinatorial structures that can be described by a grammar";

    interface_DecomposableStructure :=
    dom::interface_Structure union
    {
      hold(unrank), hold(random)
    };

    interface := dom::interface_DecomposableStructure; // to allow for reuse


    specification := toBeDefined;
    grammar := combinat::decomposableObjects(dom::specification);
    
    fromGrammar := id;

    count     := dom::grammar::count@id;
    generator := 
    if dom::fromGrammar=id then
	dom::grammar::generator
    else
	proc()
	begin
	    combinat::generators::map(dom::grammar::generator(args()),
				      dom::fromGrammar);
	end_proc:
    end_if;

    // A wrapper around fromGrammar to deal with FAIL
    // Fixes bug #628090
    fromGrammarFAIL :=
    if dom::fromGrammar=id then id;
    else
	proc(x)
	begin
	    if x=FAIL then
		x
	    else
		dom::fromGrammar(x)
	    end_if;
	end_proc;
    end_if;

    unrank := dom::fromGrammarFAIL @ dom::grammar::unrank;
    random := dom::fromGrammarFAIL @ dom::grammar::random;

begin
end_category:

stdlib::LoadlibState["combinat::structure"] := TRUE:
