// $Date: 2004/07/12 21:38:52 $ $Author: nthiery $ $Revision: 1.7 $

// combinat::getOptions -- extract and verify options within a procedure
// 
// 
// This is prog::getOptions from MuPAD 3.0.0

combinat::getOptions:=
  proc(allOptions = [], optionTypes = [], skip = 0)
    //option noDebug;
    local ARGS, NAMES, OPTS, ERRWARN, k, n;
  begin
    // Error or Warning
    ERRWARN:= contains([hold(Warning), hold(Error)], args(args(0)));

    // missing optionTypes
    if domtype(optionTypes) = DOM_INT then
      skip:= optionTypes;
      optionTypes:= []
    elif domtype(skip) <> DOM_INT then
      skip:= 0
    end_if;
    
    if domtype(allOptions) = DOM_FUNC_ENV then
      if (n:= slot(allOptions, "options")) = FAIL then
        op([id, warning, error], ERRWARN + 1)
        ("no options defined in '".prog::getname(allOptions)."'");
        return(table())
      end_if;
      if (k:= slot(allOptions, "optionTypes")) <> FAIL then
        optionTypes:= k
      else
        optionTypes:= []
      end_if;
      allOptions:= n;
    end_if;
    %if select(table(`#X`=NIL), has, `#X`)=table() then
	// Patch by Nicolas to work around MuPAD bugs # 1055 / 1056
	// with MuPAD < 3.0.0
	if domtype(allOptions) = DOM_TABLE then
	    allOptions:=[op(allOptions)];
	end_if;
    end_if;
/*  Patch by Nicolas:
    do the type checking even if there are no optional arguments
    if context(hold(args)(0)) < skip + 1 then
      // return default valued options
      return(table(op(select([op(allOptions)], testtype, "_equal"))))
    else*/
      // get arguments of calling procedure
      ARGS:= [context(hold(context)(hold(args)(skip+1..hold(args)(0))))];
      NAMES:= map([op(allOptions)], X -> if type(X) = "_equal" then op(X, 1) else X end);
      // select all options
      OPTS:= select(ARGS, has, NAMES);

      // explicit error or warning
      if ERRWARN > 0 then
        if nops(OPTS) < nops(ARGS) then
          // first argument not an option
          n:= contains(ARGS, op(select(ARGS, _not@has, NAMES), 1));
          context(op([hold(warning), hold(error)], ERRWARN)
//                  ("wrong ".output::ordinal(skip + n)." argument: ".expr2text(ARGS[n])))
                  ("wrong ".output::ordinal(skip + n)." argument"))
        end_if
      end_if;

      // return value
      OPTS:= table(op(select(allOptions, testtype, "_equal")), // default values
                   op(map(OPTS, X -> if type(X) = "_equal" then X else X = TRUE end)));

      optionTypes:= [op(optionTypes)];
       // do type check
      if optionTypes <> [] then
        // check type of options
        for k in optionTypes do
          if type(k) <> "_equal" then
            error("option types must be given as equation: ". expr2text(optionTypes))
          elif contains(OPTS, op(k, 1)) then
            if type(op(k, 2)) = DOM_PROC and bool(op(k, 2)(OPTS[op(k, 1)])) <> TRUE
               or type(op(k, 2)) <> DOM_PROC and not testtype(OPTS[op(k, 1)], op(k, 2)) then
              context(op([hold(error), hold(warning)], (ERRWARN mod 2) + 1)
                      ("wrong type of ".
                       output::ordinal(skip + contains(ARGS, op(k, 1) = OPTS[op(k, 1)])
                                       + contains(ARGS, op(k, 1)))." argument"))
            end_if
          end_if;
        end_for
      end_if;
    /* end_if; */
    OPTS
  end_proc:
