/*****************************************************************************
  $Id: imageClass.mu,v 1.2 2003/12/10 09:45:49 nthiery Exp $
  File:		lib/COMBINAT/imageClass.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Created:	06/09/2003
  License:	LGPL
*****************************************************************************/

domain combinat::imageClass(class: DOM_DOMAIN, f)
    category Cat::CombinatorialClass;
    inherits Dom::BaseDomain;
    axiom Ax::systemRep;

    info := "Functor 'combinat::imageClass': image of a combinatorial class via a bijection";

    count     := () -> class::count(args());
    list      := () -> map(class::list(args()), f);
    generator := () -> combinat::generators::map(class::generator(args()), f);

    unrank    :=
    if class::unrank <> FAIL then
	f @ class::unrank;
    end_if;

    random    :=
    if class::random <> FAIL then
	f @ class::random;
    end_if;

begin
    if not class::hasProp(Cat::CombinatorialClass) then
	error("combinatorial class expected");
    end_if;
end_domain:
