/*****************************************************************************
  $Id: subClass.mu,v 1.7 2004/05/28 13:23:04 hivert Exp $
  File:         lib/COMBINAT/subClass.mu
  Authors:      Nicolas M. Thiry <nthiery@users.sourceforge.net>
                Florent Hivert <florent.hivert@univ-mlv.fr>
  Created:      1/06/2003
  License:      LGPL
*****************************************************************************/


protect(InheritsWithParameters):
protect(InheritsWithoutParameters):
protect(Parse):
protect(Size):
protect(Parameters):

domain combinat::subClass(class : DOM_DOMAIN)
    local opt;
    category (if opt[Size] <> null() then 
		 Cat::GradedCombinatorialClass;
	     else
		 Cat::CombinatorialClass;
	     end_if);
    axiom Ax::systemRep; // should be Ax::facadeDomain ???
    inherits Dom::BaseDomain;

    info := "Library 'combinat::subClass': utilities for sub-classes of a combinatorial class";

    domtype := if class::hasProp(Ax::systemRep) then
		   class::domtype  
	       else
		   class
	       end_if;

    size := if opt[Size] <> null() then opt[Size] end_if;

    initDomain := // Create the entry of the domain 
    proc()
	option escape;
	local nm;
        save __argsSkipped;
    begin
	for nm in opt[InheritsWithParameters] do
	    if domtype(nm) = DOM_STRING then 
		if slot(class, nm) <> FAIL then
		    slot(dom, nm) := slot(class, nm) @ opt[Parse];
		end_if;
	    else // pair [name of proc, args to be skipped]
		if slot(class, nm[1]) <> FAIL then
		    slot(dom, nm[1]) := slot(class, nm[1]) @
				  subs((() -> (args(1..hold(__argsSkipped)), // better than yet another closure ???
					       opt[Parse](args(hold(__argsSkipped)+1 .. args(0))) 
					      )), hold(__argsSkipped) = nm[2]); 
		end_if;
	    end_if;
	end_for;
	for nm in opt[InheritsWithoutParameters] do
	    slot(dom, nm) := id @ slot(class, nm); // to avoid for blessing 
	end_for;
    end_proc;


begin
    if not class::hasProp(Cat::CombinatorialClass) then
        error("combinatorial class expected");
    end_if;
    opt := combinat::getOptions
	 (table(InheritsWithParameters    = ["count", "list", "generator", ["isA", 1], ["unrank", 1]],
		InheritsWithoutParameters = ["convert", "expr", "print"],
		Size  = null(),
		Parse = null(),
		Parameters = null()),
	  table(InheritsWithParameters    = Type::ListOf(Type::Union(DOM_STRING, 
								     Type::ListProduct(DOM_STRING, Type::NonNegInt))),
		InheritsWithoutParameters = Type::ListOf(DOM_STRING),
		Size  = Type::Union(DOM_NULL, Type::Function),
		Parse = Type::Union(DOM_NULL, Type::Function),
	        Parameters = Type::AnyType),
	  1, Error);
    if opt[Parameters] <> null() then
	opt[Parse] := () -> (opt[Parameters], args());
    end_if;
end_domain:
