/*****************************************************************************
  $Id: CombinatorialClassWith2DBoxedRepresentation.mu,v 1.6 2004/10/03 10:43:34 nthiery Exp $
  File:		lib/DOMAINS/CATEGORY/CombinatorialClassWith2DBoxedRepresentation.mu.new
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Purpose:	Source code for the category Cat::CombinatorialClassWith2DBoxedRepresentation
  Created:	Sat Nov 22 23:16:30 2003
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

export(output, Alias, asciiArt):

category Cat::CombinatorialClassWith2DBoxedRepresentation
    category Cat::CombinatorialClass;

    info := "Cat::CombinatorialClassWith2DBoxedRepresentation -- the category of combinatorial classes with a 2D boxed-style representation";

    interfaceAdd :=
    {
     hold(printPretty),
     hold(printCompact),
     if not dom::hasProp(Ax::systemRep) then
	 hold(print)
     else
	 null();
     end_if
    };

    toArray                  := toBeDefined;
    toArrayVerticalAlignment := Center;
    toArraySeparator         := ()->null();
  
    // Hack: type checking disabled to allow for fillings in combinat::tableaux

    printPretty :=
    proc(x//: dom
	) : asciiArt
    begin
	asciiArt::fromArray(dom::toArray(x), dom::toArraySeparator(x), 
			    VerticalAlignment = dom::toArrayVerticalAlignment,
			    args(2 ..args(0)));
    end_proc;

    printCompact :=
    proc(x//: dom
	) : asciiArt
    begin
        dom::printPretty(x, hold(Compact));
    end_proc;

    // For backward compatibility
    prettyPrint := dom::printPretty;

    print :=
    if not dom::hasProp(Ax::systemRep) then
	proc(x: dom)
	begin
	    if PRETTYPRINT then
		dom::printPretty(x);
	    else
		subsop(hold(f)(expr(x)), 0=dom, Unsimplified);
	    end_if;
	end_proc;
    end_if;

end_category:







