/*****************************************************************************
  $Id: DecomposableClass.mu,v 1.9 2004/09/29 22:09:44 nthiery Exp $
  File:		lib/COMBINAT/DecomposableClass.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
                Florent Hivert <florent.hivert@univ-mlv.fr>
  Created:	16/02/2001
  License:	LGPL
*****************************************************************************/

category Cat::DecomposableClass
    category Cat::GradedCombinatorialClass;

    info := "Category 'Cat::DecomposableClass': combinatorial classes that can be described by a grammar";

    // Should check that those entries indeed exists, as in
    // combinat::decomposableObjects
    interfaceAdd := { hold(unrank), hold(random), hold(specification) };

    specification := toBeDefined;
    decomposableClassOptions := [];
    grammar := combinat::decomposableObjects(dom::specification, op(dom::decomposableClassOptions));
    
    fromGrammar := id;

    // Beware: the @id are required for count and generator to avoid
    // overriding the value of dom in the procedures from dom::grammar!

    count     := dom::grammar::count@id;
    generator :=
    if dom::fromGrammar=id then
	dom::grammar::generator@id;
    else
	proc()
	begin
	    combinat::generators::map(dom::grammar::generator(args()),
				      dom::fromGrammar);
	end_proc:
    end_if;

    // A wrapper around fromGrammar to deal with FAIL
    // Fixes bug #628090
    fromGrammarFAIL :=
    if dom::fromGrammar=id then id;
    else
	proc(x)
	begin
	    if x=FAIL then
		x
	    else
		dom::fromGrammar(x)
	    end_if;
	end_proc;
    end_if;

    unrank := dom::fromGrammarFAIL @ dom::grammar::unrank;
    random := dom::fromGrammarFAIL @ dom::grammar::random;

begin
end_category:

