/*****************************************************************************
  $Id: GradedCombinatorialClass.mu,v 1.5 2004/10/05 16:12:15 nthiery Exp $
  File:		lib/DOMAINS/CATEGORY/GradedCombinatorialClass.mu
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Source code for the category Cat::GradedCombinatorialClass
  Created:	Mon Feb 16 21:59:38 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

category Cat::GradedCombinatorialClass
    category Cat::CombinatorialClass;

    info := "Cat::GradedCombinatorialClass -- the category of graded combinatorial classes";

/*****************************************************************************
A domain of this category ensure that if one of the function count,
list and generator is called with an integer parameter then the result
is correct. 

It is a good idea also to define a method size, but this is not mandatory 
(example decomposableClass). 
*****************************************************************************/

    typeSize := Type::NonNegInt;

    interfaceAdd := { hold(typeSize) };

    interfaceAddIfExists := { hold(size) };

end_category:
