/*****************************************************************************
  $Id: SemiRng.mu,v 1.2 2003/09/05 10:42:36 nthiery Exp $
  File:		lib/DOMAINS/CATEGORY/SemiRng.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Created:	02/09/2003
  License:	LGPL
*****************************************************************************/

/*++
Cat::SemiRng -- the category of semi-rings without units

A Cat::SemiRng is essentially a Cat::Rng, except that + need not have
an opposite operation. So it's a Cat::AbelianMonoid and a
Cat::SemiGroup with the distributive laws a*(b+c) = a*b + a*c and
(a+b)*c = a*c + b*c for each a, b, c.

++*/

category Cat::SemiRng
    category Cat::AbelianMonoid, Cat::SemiGroup;

/*
    // Allows for subtracting an element from itself
    // This is currently required for the method _set_index of Dom::Matrix:
    // to set to a the coefficient of X^i in a polynomial, this
    // method first subtract c*X^i where c is the former coefficient
    // of X^i, and then adds a*X^i
    _subtract :=
    proc(x: dom, y: dom)
    begin
	if x = y then
	    dom::zero
	else
	    error("not implemented");
	end_if;
    end_proc;
*/
end_category:
