/*****************************************************************************
  $Id: UseOverloading.mu,v 1.2 2003/08/29 14:09:00 nthiery Exp $
  File:         lib/DOMAINS/CATEGORY/UseOverloading.mu
  Authors:      Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Created:      26/03/2003 (was experimental::BaseDomain until 18/06/2003)
  Purpose:      Extension to Cat::BaseCategory that supports the use
		of overloaded operators and automatic conversions
  License:      LGPL
*****************************************************************************/

category Cat::UseOverloading
    category Cat::BaseCategory;

    // conversions are done via operators::overloaded
    convert    :=
    proc(x)
	option noDebug;
    begin
	operators::overloaded::convertExplicit(x, dom);
    end_proc;
    convert_to :=
    proc(x,T)
	option noDebug;
    begin
	operators::overloaded::convertExplicit(x, T);
    end_proc;

    // initDomain calls the procedures initDomainAdd() of all the
    // super domains from topmost down, and finaly of the domain
    // itself. This way, a domain can easilly add some initialization
    // code (typically overloading declarations), while keeping the
    // initialization code of its super domains.
    initDomain :=
    proc()
	option remember;
	local p;
    begin
	userinfo(3, "Initializing the domain ".expr2text(dom));
	operators::overloaded::declareDomain  (dom);
	for p in revert(DomainConstructor::getEntryFromAllCategories(dom,"initDomainAdd")) do
	    p();
	end_for;
	for p in revert(DomainConstructor::getEntryFromAllSuperDomains(dom,"initDomainAdd")) do
	    p();
	end_for;
	null():
    end_proc;

end_category:
