// $Date: 2004/02/19 14:20:55 $ $Author: kg $ $Revision: 1.16 $ 

/*++
getEntry -- get entry of domain

getEntry(Dom,e)

Dom - domain
e   - name of entry

Creates domain entry e on the fly, depending on the domain 'Dom' and its
actual parameters. The new entry is returned (and inserted into the
domain by 'slot').
++*/

DomainConstructor::getEntry:= proc(DOM: DOM_DOMAIN, e: DOM_STRING)
    option noDebug;
    local m;
begin
    m:= DomainConstructor::makeEntry(DOM, e);
    case domtype(m[1])
    of DOM_PROC do
      // proc is blessed by kernel (via _assign)
      // set procname if none exists
      if op(m, [1,6]) = NIL then
        subsop(m[1], 6=hold(slot)(DOM::key, e))
      else
        m[1]
      end_if;
      break;
    of DOM_FUNC_ENV do
      // set procname if none exists
      if op(m, [1,1,6]) = NIL then
        m:= subsop(m, [1,1,6]=hold(slot)(DOM::key, e));
      end_if;
      prog::blessAny(m[1], DOM);
      break;
    otherwise
      m[1];
    end_case
end_proc:

// end of file 
