/* ++
Dom::JanetDivision 

Author: Marcus Hausdorf, Uni Mannheim
        (hausdorf@math.uni-mannheim.de)
Created: 	Tue Dec 11 13:25:05 2001
Last update: 	Thu Sep  4 12:14:07 2003
++ */


domain Dom::JanetDivision(nV:Type::PosInt)
local perm_f:DOM_BOOL, perm, invperm, i, mvdloop, classr, rvgreater, tmp, avars, mvloop;
inherits Dom::BaseDomain;
category Cat::InvolutiveDivision(nV);

//========== obsolete ==========

separationTableMult := proc(mi_l:Type::ListOf(Type::ListOf(Type::NonNegInt)), s_f = FALSE)
    local res_t:DOM_TABLE, i;
    begin
	if nops(mi_l) = 1 then
	    return(table(mi_l[1] = {i $ i = 1..nV}));
	else
	    if perm_f then
		mi_l := map(mi_l, l -> [l[i] $ i in perm]);
	    end_if;
	    if not s_f then
		mi_l := sort(mi_l, (l1, l2) -> (rvgreater(l1, l2)));
	    end_if;
	    res_t := mvdloop(nV, {i $ i = 1..nV}, mi_l[1], [op(mi_l, 2..nops(mi_l))]);
	    if perm_f then
		res_t[[mi_l[1][i] $ i in invperm]] := {i $ i = 1..nV};
	    else
		res_t[mi_l[1]] := {i $ i = 1..nV};
	    end_if;
	end_if;
	res_t;
    end_proc;
    
//==============================

sepListMult := proc(mu_l:Type::ListOf(Type::ListOf(Type::NonNegInt)))
    local i;
    begin
	if mu_l = [] then
	    return([]);
	elif nops(mu_l) = 1 then
	    return([[mu_l[1], avars]]);
	else
	    if perm_f then
		mu_l := map(mu_l, l -> [l[i] $ i in perm]);
	    end_if;
	    mu_l := sort(mu_l, (l1, l2) -> (rvgreater(l1, l2)));
	    if perm_f then
		return([[[mu_l[1][i] $ i in invperm], avars]] 
		    . mvloop(nV, avars, mu_l[1], mu_l[2..nops(mu_l)]));
	    else
		return([[mu_l[1], avars]] . mvloop(nV, avars, mu_l[1], mu_l[2..nops(mu_l)]));
	    end_if;
	end_if;
    end_proc;
    
sepListMultAdd := proc(sep_l, mi:Type::ListOf(Type::NonNegInt))
    local mu_l, mip, k, i;
    begin
	if perm_f then 
	    mip := [mi[i] $ i in perm];
	    mu_l := map(sep_l, l -> [l[1][i] $ i in perm]);
	else
	    mip := mi;
	    mu_l := map(sep_l, op, 1);
	end_if;
	for k from 1 to nops(mu_l) do
	    if rvgreater(mi, mu_l[k]) then
		if k = 1 then
		    return([[mi, avars]] . mvloop(nV, avars, mip, mu_l));
		elif k = 2 then
		    return([sep_l[1]] . mvloop(nV, avars, mu_l[1], [mip] . mu_l[2..nops(mu_l)]));
		else		
		    if perm_f then
			return([op(sep_l, 1..(k - 1))] . 
			    mvloop(classr(zip(mu_l[k - 2], mu_l[k - 1], _subtract)), 
				map(sep_l[k - 1][2], l -> invperm[l]), mu_l[k - 1], 
				    [mip] . mu_l[k..nops(mu_l)]));
		    else
			return([op(sep_l, 1..(k - 1))] . 
			    mvloop(classr(zip(mu_l[k - 2], mu_l[k - 1], _subtract)), 
				sep_l[k - 1][2], sep_l[k - 1][1], [mip] . mu_l[k..nops(mu_l)]));
		    end_if;
		end_if;
	    end_if;
	end_for;
	sep_l . [[mi, select(sep_l[nops(mu_l)][2], 
	    l -> bool(sep_l[nops(mu_l)][1][l] = mip[l]))]];
    end_proc;
    
sepListMultRem := proc(sep_l, mi:Type::ListOf(Type::NonNegInt))
    local mu_l, i, pos;
    begin
	if nops(sep_l) = 1 then
	    return([]);
	elif nops(sep_l) = 2 then
	    if sep_l[1][1] = mi then
		return([sep_l[2][1], avars]);
	    elif sep_l[2][1] = mi then
		return([sep_l[1]]);
	    else
		error("invalid multiindex");
	    end_if;
	else
	    if perm_f then
		mu_l := map(sep_l, l -> [l[1][i] $ i in perm]);
	    else
		mu_l := map(sep_l, op, 1);
	    end_if;
	    if iszero((pos := contains(mu_l, mi))) then
		error("invalid multiindex");
	    end_if;
	    if pos = 1 then
		return([[mu_l[2], avars]] . mvloop(nV, avars, mu_l[2], mu_l[3..nops(mu_l)]));
	    elif pos = 2 then
		return([sep_l[1]] . mvloop(nV, avars, mu_l[1], mu_l[3..nops(mu_l)]));
	    else
		if perm_f then
		    return([op(sep_l, 1..(pos - 1))] . 
			mvloop(classr(zip(mu_l[pos - 2], mu_l[pos - 1], _subtract)),
			    map(sep_l[pos - 1][2], l -> invperm[l]), 
				[sep_l[pos - 1][1][i] $ i in perm], 
				    mu_l[(pos + 1)..nops(mu_l)]));
		else
		    return([op(sep_l, 1..(pos - 1))] . 
			mvloop(classr(zip(mu_l[pos - 2], mu_l[pos - 1], _subtract)),
			    sep_l[pos - 1][2], sep_l[pos - 1][1], mu_l[(pos + 1)..nops(mu_l)]));
		end_if;
	    end_if;
	end_if;
    end_proc;
    
combinatorialDecomposition := proc(N)
    local mv_t, class_l, res_l, k, p, j, i, q, ii, N1, N2;
    begin
	if perm_f then
	    N1 := map(N, l -> [l[1][i] $ i in perm]);
	    N2 := map(N, l -> map(l[2], l2 -> invperm[l2]));
	else
	    N1 := map(N, op, 1);
	    N2 := map(N, op, 2);
	end_if;
	N := sort(N1, rvgreater);
	mv_t := table(op(zip(N1, N2, (l1, l2) -> (l1 = l2))));
	class_l := [N[1][i..nV] $ i = 2..(nV + 1)];
	res_l := [];
	for k from 2 to nops(N) do
	    p := classr(zip(N[k -1], N[k], _subtract));
	    for j from 1 to (p - 1) do
		res_l := res_l . [[[0 $ (j - 1)] . [q] . class_l[j], (mv_t[N[k - 1]] minus {i $ i = 1..j}) union {i $ i = 1..(j - 1)}]
		    $ q = 0..(N[k - 1][j] - 1)];
		class_l[j] := N[k][(j + 1)..nV];
	    end_for;
	    res_l := res_l . [[[0 $ (p - 1)] . [q] . class_l[p], (mv_t[N[k - 1]] minus {i $ i = 1..p}) union {i $ i = 1..(p - 1)}]  
		$ q = (N[k][p] + 1)..(N[k - 1][p] - 1)];
	end_for;
	res_l := res_l . [[[0 $ (i - 1)] . [q] . class_l[i], 
		(mv_t[N[nops(N)]] minus {ii $ ii = 1..i}) union {ii $ ii = 1..(i - 1)}]  
	    $ q = 0..(N[nops(N)][i] - 1) $ i = 1..nV]; 
	if perm_f then
	    return(map(res_l, l -> [[l[1][i] $ i in invperm], map(l[2], l2 -> perm[l2])]));
	else
	    return(res_l);
	end_if;
    end_proc;
    
standardPairs := proc(N)
    local res_l, i, k, tmp, reduced, k2;
    begin
	res_l := [];
	N := map(dom::combinatorialDecomposition(N), l -> [subsop(l[1], (i = 0 $ i in l[2])),l[2]]);
	if perm_f then
	    N := map(N, l -> [[l[1][i] $ i in perm], map(l[2], l2 -> invperm[l2])]);
	end_if;
	N := sort(N, (l1, l2) -> (rvgreater(l2[1], l1[1])));
	for k from nops(N) downto 2 do
	    tmp := N[k];
	    delete N[k];
	    reduced := FALSE;
	    for k2 from 1 to nops(N) do    
		if not iszero(dom::isInvDivisor(N[k2][1], tmp[1], N[k2][2])) and (tmp[2] subset N[k2][2]) then
		    reduced := TRUE;
		    break;
		end_if;
	    end_for;
	    if not reduced then
		res_l := append(res_l, tmp);
	    end_if;
	end_for;
	res_l := append(res_l, N[1]);
	if perm_f then
	    return(map(res_l, l -> [[l[1][i] $ i in invperm], map(l[2], l2 -> perm[l2])]));
	else
	    return(res_l);
	end_if;
    end_proc;
    
convert := (() -> FAIL);

expr := (() -> FAIL);

print := (() -> FAIL);

permutation := if perm_f then perm else [i $ i = 1..nV] end_if;

begin
    perm_f := FALSE;
    if args(0) = 2 then
	if (testtype(args(2), Type::ListOf(Type::NonNegInt)) and
	    nops(args(2)) = nV) 
	then
	    perm_f := TRUE;
	    perm := args(2);
	    invperm := [contains(perm, i) $ i = 1..nV];
	end_if;
    end_if;
    avars := {i $ i = 1..nV};
    
//    classr := (l -> (if not iszero(traperror(
//	(tmp := max(op(map(select([[l[i], i] $ i = 1..nops(l)],
//	    l2 -> not iszero(l2[1])), op, 2)))))) then 1 else tmp end_if));

    classr := proc(mu)
	local k;
	begin
	    for k from nV downto 1 do
		if not iszero(mu[k]) then
		    return(k);
		end_if;
	    end_for;
	    return(1);
	end_proc;
    
//========== obsolete ==========    
    
    mvdloop := proc(p1:DOM_INT, current_mv:DOM_SET, current_mu:DOM_LIST, mi_l:DOM_LIST)
	local res_t:DOM_TABLE, p2:DOM_INT, k:DOM_INT, i;
	begin
	    for k from 1 to nops(mi_l) do
	        p2 := classr(zip(current_mu, mi_l[k], _subtract));
		if p2 <= p1 then
		    current_mv := current_mv minus {p2};
		elif p2 > p1 then
		    current_mv := (current_mv minus {p2}) union 
			{i $ i = p1..(p2 - 1)};
		end_if;
		if perm_f then
		    res_t[[mi_l[k][i] $ i in invperm]] := map(current_mv, l -> perm[l])
		else
		    res_t[mi_l[k]] := current_mv;
		end_if;
		current_mu := mi_l[k];
		p1 := p2;
	    end_for;
	    res_t;
	end_proc;
	
//==============================

    mvloop := proc(p1:DOM_INT, current_mv:DOM_SET, current_mu:DOM_LIST, mu_l:DOM_LIST)
	local res_l, k, p2, i;
	begin
	    if mu_l = [] then return([]) end_if;
	    res_l := [NIL $ nops(mu_l)];
	    for k from 1 to nops(mu_l) do
		p2 := classr(zip(current_mu, mu_l[k], _subtract));
		if p2 <= p1 then
		    current_mv := current_mv minus {p2};
		elif p2 > p1 then
		    current_mv := (current_mv minus {p2}) union 
			{i $ i = p1..(p2 - 1)};
		end_if;
		if perm_f then
		    res_l[k] := [[mu_l[k][i] $ i in invperm], map(current_mv, l -> perm[l])];
		else
		    res_l[k] := [mu_l[k], current_mv];
		end_if;
		current_mu := mu_l[k];
		p1 := p2;
	    end_for;
	    res_l;
	end_proc;
	    
    rvgreater := proc(mu1, mu2)
	local tmp, k;
	begin
	    for k from nV downto 1 do
		tmp := mu2[k] - mu1[k];
		if tmp > 0 then
		    return(FALSE);
		elif tmp < 0 then 
		    return(TRUE);
		end_if;
	    end_for;
	    TRUE;
	end_proc;
	      
end_domain:
