/* ++
Dom::PommaretDivision

Author: Marcus Hausdorf, Uni Mannheim
        (hausdorf@math.uni-mannheim.de)
Created: 	Mon Dec 17 15:33:31 2001
Last update: 	Thu Sep  4 12:52:30 2003
++ */


domain Dom::PommaretDivision(nV:Type::PosInt)
local perm_f:DOM_BOOL, perm, invperm, i, rvgreater, classr;
inherits Dom::BaseDomain;
category Cat::InvolutiveDivision(nV);

//=========== obsolete ==========

separationTableMult := proc(mi_l:Type::ListOf(Type::ListOf(Type::NonNegInt)))
    local DOM:DOM_DOMAIN, i;
    begin
	DOM := dom;
	if perm_f then
	    table(op(zip(mi_l, map(map(map(mi_l, l -> [l[i] $ i in invperm]), 
		l2 -> {i $ i = 1..DOM::class(l2)}),
		    l3 -> map(l3, l4 -> perm[l4])), (l5, l6) -> l5 = l6)));
	else
	    table(op(zip(mi_l, map(mi_l, l -> {i $ i = 1..DOM::class(l)}), 
		(l1, l2) -> l1 = l2)));
	end_if;
    end_proc;
    
//===============================

sepListMult := proc(mu_l:Type::ListOf(Type::ListOf(Type::NonNegInt)))
    local i, DOM;
    begin
	if mu_l = [] then
	    return([]);
	end_if;
	DOM := dom;
	if perm_f then
	    map(mu_l, l -> [l, map({i $ i = 1..DOM::class([l[i] $ i in invperm])},
		l2 -> perm[l2])]);
	else
	    map(mu_l, l -> [l, {i $ i = 1..DOM::class(l)}]);
	end_if;
    end_proc;
    
sepListMultAdd := proc(sep_l, mi:Type::ListOf(Type::NonNegInt))
    local i, DOM;
    begin
	DOM := dom;
	if perm_f then
	    append(sep_l, [mi, map({i $ i = 1..DOM::class([mi[i] $ i in invperm])},
		l -> perm[l])]);
	else
	    append(sep_l, [mi, {i $ i = 1..DOM::class(mi)}]);
	end_if;
    end_proc;
    
sepListMultRem := proc(sep_l, mi:Type::ListOf(Type::NonNegInt))
    local pos;
    begin
	if not iszero((pos := contains(map(sep_l, op, 1), mi))) then
	    delete sep_l[pos];
	else
	    error("invalid multiindex");
	end_if;
    end_proc;
    
//class := proc(mu)
//    option remember;
//    local i, tmp;
//    begin
//	if not iszero(traperror((tmp := min(op(map(select([[mu[i], i] $ i = 1..nV],
//	    l -> not iszero(l[1])), op, 2))))))
//	then
//	    return(nV);
//	else
//	    return(tmp);
//	end_if;
//    end_proc;

class := proc(mu)
    local k;
    begin
	for k from 1 to nV do
	    if not iszero(mu[k]) then
		return(k);
	    end_if;
	end_for;
	return(nV);
    end_proc;
    
combinatorialDecomposition := proc(N)
    local mv_t, class_l, res_l, k, p, j, i, q, ii, N1, N2;
    begin
	if perm_f then
	    N1 := map(N, l -> [l[1][i] $ i in perm]);
	    N2 := map(N, l -> map(l[2], l2 -> invperm[l2]));
	else
	    N1 := map(N, op, 1);
	    N2 := map(N, op, 2);
	end_if;
	N := sort(N1, rvgreater);
	mv_t := table(op(zip(N1, N2, (l1, l2) -> (l1 = l2))));
	class_l := [N[1][i..nV] $ i = 2..(nV + 1)];
	res_l := [];
	for k from 2 to nops(N) do
	    p := classr(zip(N[k -1], N[k], _subtract));
	    for j from 1 to (p - 1) do
		res_l := res_l . [[[0 $ (j - 1)] . [q] . class_l[j], (mv_t[N[k - 1]] minus {i $ i = 1..j}) union {i $ i = 1..(j - 1)}]
		    $ q = 0..(N[k - 1][j] - 1)];
		class_l[j] := N[k][(j + 1)..nV];
	    end_for;
	    res_l := res_l . [[[0 $ (p - 1)] . [q] . class_l[p], (mv_t[N[k - 1]] minus {i $ i = 1..p}) union {i $ i = 1..(p - 1)}]  
		$ q = (N[k][p] + 1)..(N[k - 1][p] - 1)];
	end_for;
	res_l := res_l . [[[0 $ (i - 1)] . [q] . class_l[i], 
		(mv_t[N[nops(N)]] minus {ii $ ii = 1..i}) union {ii $ ii = 1..(i - 1)}]  
	    $ q = 0..(N[nops(N)][i] - 1) $ i = 1..nV]; 
	if perm_f then
	    return(map(res_l, l -> [[l[1][i] $ i in invperm], map(l[2], l2 -> perm[l2])]));
	else
	    return(res_l);
	end_if;
    end_proc;
    
standardPairs := proc(N)
    local res_l, i, k, tmp, reduced, k2;
    begin
	res_l := [];
	N := map(dom::combinatorialDecomposition(N), l -> [subsop(l[1], (i = 0 $ i in l[2])),l[2]]);
	if perm_f then
	    N := map(N, l -> [[l[1][i] $ i in perm], map(l[2], l2 -> invperm[l2])]);
	end_if;
	N := sort(N, (l1, l2) -> (rvgreater(l2[1], l1[1])));
	for k from nops(N) downto 2 do
	    tmp := N[k];
	    delete N[k];
	    reduced := FALSE;
	    for k2 from 1 to nops(N) do    
		if not iszero(dom::isInvDivisor(N[k2][1], tmp[1], N[k2][2])) and (tmp[2] subset N[k2][2]) then
		    reduced := TRUE;
		    break;
		end_if;
	    end_for;
	    if not reduced then
		res_l := append(res_l, tmp);
	    end_if;
	end_for;
	res_l := append(res_l, N[1]);
	if perm_f then
	    return(map(res_l, l -> [[l[1][i] $ i in invperm], map(l[2], l2 -> perm[l2])]));
	else
	    return(res_l);
	end_if;
    end_proc;

convert := (() -> FAIL);

expr := (() -> FAIL);

print := (() -> FAIL);
        
permutation := if perm_f then perm else [i $ i = 1..nV] end_if;

begin
    perm_f := FALSE;
    if args(0) = 2 then
	if (testtype(args(2), Type::ListOf(Type::NonNegInt)) and
	    nops(args(2)) = nV) 
	then
	    perm_f := TRUE;
	    perm := args(2);
	    invperm := [contains(perm, i) $ i = 1..nV];
	end_if;
    end_if;
    
    rvgreater := proc(mu1, mu2)
    local tmp, k;
    begin
	for k from nV downto 1 do
	    tmp := mu2[k] - mu1[k];
	    if tmp > 0 then
		return(FALSE);
	    elif tmp < 0 then 
		return(TRUE);
	    end_if;
	end_for;
	TRUE;
    end_proc;
    
    classr := proc(mu)
	local k;
	begin
	    for k from nV downto 1 do
		if not iszero(mu[k]) then
		    return(k);
		end_if;
	    end_for;
	    return(1);
	end_proc;    

end_domain: