/*****************************************************************************
  $Id: reachableVertices.mu,v 1.1 2004/10/01 15:28:12 nthiery Exp $
  File:		lib/GRAPH/reachableVertices.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Created:	11/09/2004
  License:	LGPL
*****************************************************************************/

/**
 * reachableVertices(G, startVertices)
 * reachableVertices(G, startVertices, direction)

  * returns the connected component(s) in G of the vertices in startVertices
**/

Graph::reachableVertices :=
proc(G: Graph, startVertices: DOM_LIST, Direction = Forward: Type::Union(Type::Singleton(Forward), Type::Singleton(Backward))) : DOM_SET
    local component, todo, getNeighbors, newNeighbors, node;
begin
    todo := {op(startVertices)};
    component := todo;
    if Direction = Backward then
	getNeighbors := Graph::getAdjacentEdgesEntering;
    else
	getNeighbors := Graph::getAdjacentEdgesLeaving;
    end_if;
    while todo <> {} do
	node := op(todo,1);
	// the [] around node below are pure bug ware
	newNeighbors := ({op(getNeighbors(G,[node]))} minus component);
	component := component union newNeighbors;
	todo := todo minus {node} union newNeighbors;
    end_while;
    component;
end_proc:
