// $Id: legendre.mu,v 1.1 2003/08/14 08:45:33 ccr Exp $

// interval evalution of legendre polynomials
// using Rodriguez' formula:
//                     n
//                 (-1)                 2 n
//    P(n, x) = ------------ diff((1 - x ) , x $ n)
//                n
//              (2  fact(n))
//
// Using automatic differentiation, this is relatively
// cheap and precise.

// Note that orthpoly::legendre is considerably faster,
// for a very moderate increase of the ouput width.
// Therefore, these functions may be deleted soon.

// for mutliple evaluations of the same polynomial:
interval::_legendre_poly := 
  proc(n)
    local ad, v;
    option escape;
  begin
    ad := interval::autodiff((1-`#x`^2)^n, n);
    v := (-1)^n/2^n;   
    x -> v*(ad(x))[n+1];
  end_proc:

// user function for a single evaluation:
interval::legendre :=
  proc(n, x)
    local ad;
  begin
    ad := interval::autodiff((1-`#x`^2)^n, n);
    (-1)^n/2^n*(ad(x))[n+1];
  end_proc:
