// $Date: 2004/10/02 16:33:21 $ $Author: nthiery $ $Revision: 1.23 $ 
/*++
Cat -- a library of basic category constructors
++*/

domains: // force loading 'domains' 

Cat:= newDomain("Cat"):
Cat::info:= "Library 'Cat': basic category constructors":
Cat::interface:= {
    hold(AbelianGroup),
    hold(AbelianMonoid),
    hold(AbelianSemiGroup),
    hold(Algebra),
    hold(AlgebraWithBasis),
    hold(BaseCategory),
    hold(CancellationAbelianMonoid),
    hold(CombinatorialClass),
    hold(CommutativeRing),
//    hold(DecomposableClass),
    hold(DifferentialRing),
//    hold(DifferentialVariable),
//    hold(DifferentialFunction),
    hold(EntireRing),
    hold(EuclideanDomain),
    hold(FactorialDomain),
    hold(Field),
//    hold(FiniteMonoidRing),
    hold(FiniteCollection),
    hold(GcdDomain),
    hold(Group),
    hold(HomogeneousFiniteCollection),
    hold(HomogeneousFiniteProduct),
//    hold(InvolutiveDivision),
    hold(IntegerListsLexClass),
    hold(IntegralDomain),
    hold(LeftModule),
    hold(Matrix),
    hold(Module),
    hold(ModuleWithBasis),
    hold(Monoid),
//    hold(MonoidRing),
    hold(OrderedSet),
//    hold(OrderedAbelianMonoid),
//    hold(OrderedMonoid),
    hold(PartialDifferentialRing),
//    hold(PermutationGroup),
    hold(Polynomial),
    hold(PrincipalIdealDomain),
    hold(QuotientField),
    hold(RightModule),
    hold(Ring),
    hold(Rng),
    hold(SemiGroup),
    hold(SemiRing),
    hold(SemiRng),
    hold(Set),
    hold(SkewField),
    hold(UnivariatePolynomial),
//    hold(UnivariateSkewPolynomial),
//    hold(SolvableAlgebra),
    hold(SquareMatrix),
    hold(UseOverloading),
    hold(VectorSpace)
}:

alias(path = pathname("DOMAINS", "CATEGORY")):

Cat::AbelianGroup:= loadproc(Cat::AbelianGroup, path, "AbGroup"):
Cat::AbelianMonoid:= loadproc(Cat::AbelianMonoid, path, "AbMonoid"):
Cat::AbelianSemiGroup:= loadproc(Cat::AbelianSemiGroup, path, "AbSemGrp"):
Cat::Algebra:= loadproc(Cat::Algebra, path, "Algebra"):
Cat::AlgebraWithBasis := loadproc(Cat::AlgebraWithBasis, path, "AlgebraWithBasis"):
Cat::BaseCategory:= loadproc(Cat::BaseCategory, path, "BaseCat"):
Cat::CancellationAbelianMonoid:= loadproc(Cat::CancellationAbelianMonoid, path, "CanAbMon"):
Cat::CombinatorialClass:= loadproc(Cat::CombinatorialClass, path, "CombinatorialClass"):
autoload(Cat::GradedCombinatorialClass):
autoload(Cat::CombinatorialClassWith2DBoxedRepresentation):
Cat::CommutativeRing:= loadproc(Cat::CommutativeRing, path, "CommRing"):
Cat::DecomposableClass:= loadproc(Cat::DecomposableClass, path, "DecomposableClass"):
Cat::DifferentialRing:= loadproc(Cat::DifferentialRing, path, "DiffRing"):
Cat::DifferentialFunction:=loadproc(Cat::DifferentialFunction,path,"DFunCat"):
Cat::DifferentialVariable:=loadproc(Cat::DifferentialVariable,path,"DVarCat"):
Cat::EntireRing:= loadproc(Cat::EntireRing, path, "EntRing"):
Cat::EuclideanDomain:= loadproc(Cat::EuclideanDomain, path, "EuclDom"):
Cat::FactorialDomain:= loadproc(Cat::FactorialDomain, path, "FactDom"):
Cat::Field:= loadproc(Cat::Field, path, "Field"):
Cat::FiniteCollection:= loadproc(Cat::FiniteCollection, path, "FinCollC"):
Cat::FiniteMonoidRing:=loadproc(Cat::FiniteMonoidRing,path,"FinMonRing"):
Cat::GcdDomain:= loadproc(Cat::GcdDomain, path, "GcdDom"):
Cat::Group:= loadproc(Cat::Group, path, "Group"):
Cat::HomogeneousFiniteCollection:= loadproc(Cat::HomogeneousFiniteCollection, path, "HFinColC"):
Cat::HomogeneousFiniteProduct:= loadproc(Cat::HomogeneousFiniteProduct, path, "HFiProdC"):
Cat::IntegralDomain:= loadproc(Cat::IntegralDomain, path, "IntegDom"):
Cat::IntegerListsLexClass:= loadproc(Cat::IntegerListsLexClass, path, "IntegerListsLexClass"):
Cat::InvolutiveDivision:=loadproc(Cat::InvolutiveDivision,path,"InvDiv"):
Cat::LeftModule:= loadproc(Cat::LeftModule, path, "LeftMod"):
Cat::Matrix:= loadproc(Cat::Matrix, path, "MatCat"):
Cat::Module:= loadproc(Cat::Module, path, "Module"):
Cat::ModuleWithBasis := loadproc(Cat::ModuleWithBasis, path, "ModuleWithBasis"):
Cat::Monoid:= loadproc(Cat::Monoid, path, "Monoid"):
Cat::MonoidRing:=loadproc(Cat::MonoidRing,path,"MonRing"):
Cat::OrderedAbelianMonoid:=loadproc(Cat::OrderedAbelianMonoid,path,"OrdAbMon"):
Cat::OrderedMonoid:=loadproc(Cat::OrderedMonoid,path,"OrdMon"):
Cat::OrderedSet:= loadproc(Cat::OrderedSet, path, "OrdSet"):
Cat::PartialDifferentialRing:= loadproc(Cat::PartialDifferentialRing, path, "PDiffRng"):
Cat::PermutationGroup:= loadproc(Cat::PermutationGroup, path, "PermutationGroup"):
Cat::Polynomial:= loadproc(Cat::Polynomial, path, "PolyCat"):
Cat::PrincipalIdealDomain:= loadproc(Cat::PrincipalIdealDomain, path, "PrIdDom"):
Cat::QuotientField:= loadproc(Cat::QuotientField, path, "QuoField"):
Cat::RightModule:= loadproc(Cat::RightModule, path, "RightMod"):
Cat::Ring:= loadproc(Cat::Ring, path, "Ring"):
Cat::Rng:= loadproc(Cat::Rng, path, "Rng"):
//Cat::SemiGroup:= loadproc(Cat::SemiGroup, path, "SemiGrp"):
Cat::SemiGroup:= loadproc(Cat::SemiGroup, path, "SemiGroup"):
Cat::SemiRing := loadproc(Cat::SemiRing, path, "SemiRing"):
Cat::SemiRng := loadproc(Cat::SemiRng, path, "SemiRng"):
Cat::Set:= loadproc(Cat::Set, path, "Set"): 
Cat::SkewField:= loadproc(Cat::SkewField, path, "SkewFld"):
Cat::SolvableAlgebra:=loadproc(Cat::SolvableAlgebra,path,"SolvAlgCat"):
Cat::SquareMatrix:= loadproc(Cat::SquareMatrix, path, "SqMatCat"):
Cat::UnivariatePolynomial:= loadproc(Cat::UnivariatePolynomial, path, "UPolyCat"):
Cat::UnivariateSkewPolynomial:= loadproc(Cat::UnivariateSkewPolynomial, path, "OrePolyC"):
Cat::UseOverloading := loadproc(Cat::UseOverloading, path, "UseOverloading"):
Cat::VectorSpace:= loadproc(Cat::VectorSpace, path, "Vspace"):

// Temporary
Cat::TreesClass := loadproc(Cat::TreesClass,   pathname("COMBINAT"), "treesGeneric"):

null():

// end of file 
