// $Date: 2004/10/04 17:10:39 $ $Author: nthiery $ $Revision: 1.65 $

//
// prog.mu -- define/load auxiliary functions
//

prog:= newDomain("prog"):
prog::create_dom:=hold(prog):

prog::info:= "Library 'prog': programming utilities":
prog::interface:=
   {
    //hold(findSlot),
    hold(allFunctions),
    hold(bless),
    hold(calltree),
    hold(calledFrom),
    hold(changes),
    hold(check),
    //hold(checkFile), // not yet documented
    //hold(checkDisableMessage),
    hold(error),
    hold(exprlist),
    hold(exprtree),
    //hold(exprtable), // not documented
    hold(find),
    hold(getname),
    hold(getOptions),
    hold(init),
    hold(isGlobal),
    // nur noch interner Gebrauch
    //hold(makeBinLib),
    hold(memuse),
    hold(ntime),
    hold(profile),
    hold(remember),
    hold(sort),
    hold(tcov),
    hold(test),
    hold(testcall),
    hold(testerrors),
    hold(testfunc),
    hold(testinit),
    hold(testmethod),
    hold(testnum),
    hold(testexit),
    hold(trace),
    hold(traced),
    hold(untrace),
    hold(wait)
    }:

alias(path = pathname("PROG")):

// default output - screen
prog::OUT := 0:

// internal for prog::check
prog::globalIdents:= table():
prog::PATH:= []: // 
prog::NMSG:= {}: // disabled messages
prog::Entries:= loadproc(prog::Entries , path, "checkini"):
prog::VNM:= loadproc(prog::VNM , path, "check"):
prog::type:= loadproc(prog::type, path, "check"):
prog::isGlobal:= loadproc(prog::isGlobal, path, "checkini"):

prog::allFunctions:= loadproc(prog::allFunctions, path, "allfunc"):
prog::calltree:= loadproc(prog::calltree, path, "calltree"):

// compatibility
prog::Changes:= loadproc(prog::Changes, path, "compatible"):
prog::changes:= loadproc(prog::changes, path, "compatible"):

prog::check:= loadproc(prog::check, path, "check"):
prog::checkDisableMessage:= loadproc(prog::checkDisableMessage, path, "checkset"):
prog::setcheckglobals:= loadproc(prog::setcheckglobals, path, "checkset"):

prog::error:= loadproc(prog::error, path, "error"):

prog::exprlist:= loadproc(prog::exprlist, path, "exprlist"):
prog::exprtree:= loadproc(prog::exprtree, path, "exprtree"):
prog::exprtable:= loadproc(prog::exprtable, path, "exprtable"):

// analyze MuPAD library
prog::analyze:= loadproc(prog::analyze, path, "analyze"):

prog::find:= loadproc(prog::find, path, "find"):
prog::findSlot:= loadproc(prog::findSlot, path, "findSlot"):

// extract options from argument list
prog::getOptions:= loadproc(prog::getOptions, path, "getoptions"):

prog::checkFile:= loadproc(prog::checkFile, path, "checkFile"):

prog::getname:= loadproc(prog::getname , path, "checknm"):
prog::calledFrom:= loadproc(prog::calledFrom , path, "calledFrom"):

prog::init := loadproc(prog::init , path, "checkini"):

prog::makeBinLib:= loadproc(prog::makeBinLib, path, "makelib"):

prog::memuse:= loadproc(prog::memuse, path, "memuse"):

// system independend time unit
prog::ntime:= loadproc(prog::ntime, path, "ntime"):

// utility for the daily tests
prog::timererror:= loadproc(prog::timererror, path, "timererror"):

// 
prog::profile:= loadproc(prog::profile, path, "profile"):

// complex remember mechanism
prog::remember:= loadproc(prog::remember, path, "remember"):

//
prog::tcov:= loadproc(prog::tcov, path, "tcov"):

//
prog::bless:= loadproc(prog::bless, path, "bless"):
prog::blessAny:= loadproc(prog::blessAny, path, "bless"):

// test environment
prog::test      := loadproc(prog::test,       path, "test"      ):
prog::testexit  := loadproc(prog::testexit,   path, "testexit"  ):
prog::testfunc  := loadproc(prog::testfunc,   path, "testfunc"  ):
prog::testinit  := loadproc(prog::testinit,   path, "testinit"  ):
prog::testmethod:= loadproc(prog::testmethod, path, "testmethod"):
prog::testnum   := loadproc(prog::testnum,    path, "testnum"   ):
prog::testtime  := loadproc(prog::testtime,   path, "testtime"  ):
prog::lasterror := loadproc(prog::lasterror,  path, "lasterror" ):
prog::testerrors:= loadproc(prog::testerrors, path, "testerrors"):
prog::testcall  := loadproc(prog::testcall,   path, "testcall"  ):

// bisher undokumentiert
prog::testNoTestArgs :=
  proc(state)
  begin
    if args(0) = 0 then
      return(prog::TestNoTestargs)
    else
      sysassign(prog::TestNoTestargs, state)
    end_if
  end_proc:

// for 'prog::test(init)'
prog::TestNoTestargs:= FALSE:// don't set testargs(TRUE) and Pref::typeCheck(Always)
                             // in 'prog::test'

// trace functions
prog::trace   := loadproc(prog::trace,    path, "trace"   ):
prog::traced  := loadproc(prog::traced,   path, "trace"   ):
prog::untrace := loadproc(prog::untrace,  path, "trace"   ):

// create examples for the doc
prog::makeExample := loadproc(prog::makeExample, path, "makeExample"):
// create tests
prog::makeTest:= loadproc(prog::makeTest, path, "makeTest"):
// manipulate functions to write test files
prog::makeTestFile:= loadproc(prog::makeTestFile, path, "makeTestFile"):

// wait for a while
prog::wait:= loadproc(prog::wait, path, "wait"):

// sort by a function, that returns numerical values
prog::sort := loadproc(prog::sort, path, "sort"):

// pseudo random number with range
prog::psrand := loadproc(prog::psrand, path, "psrand"):

// variant of loadproc; temporarily here until the functionality is
// integrated into loadproc.
prog::loaddomain :=
    loadproc(prog::loaddomain, pathname("PROG"), "loaddomain"):
// prog::domainWrapper will be deprecated as soon as one
// can overload bla[...] when bla is a domain.
autoload(prog::domainWrapper):

null():
