// Trans.mu  --  library for transformations

transform:= newDomain("transform"):
transform::create_dom:=hold(transform):
transform::info := "Library 'transform': library for integral transformations":
transform::interface := { hold(laplace),hold(invlaplace),
                          hold(fourier),hold(invfourier)
			  // hold(mellin) // raus, da mellin nicht funktioniert
		       }:

alias(path = pathname("TRANS"));

transform::IntTrans:= loadproc( transform::IntTrans, path, "IntTrans" ):

unalias(path):

alias(path = pathname("TRANS","LAPLACE")):

transform::laplace:= loadproc( transform::laplace, path, "laplace" ):
transform::invlaplace:= loadproc( transform::invlaplace, path, "ilaplace" ):

unalias(path):

//alias(path = pathname("TRANS","FOURIER")):
// use Paul's version from STDLIB until Dirk has fixed/written it. 
alias(path = pathname("TRANS")):

transform::fourier:= loadproc( transform::fourier, path, "fourier" ):
transform::invfourier:= loadproc( transform::invfourier, path, "ifourier" ):

transform::mellin:= loadproc( transform::mellin, path, "mellin" ):

// ------------------------------------------------------------------
//  Define integral transforms for kernel functions
// ------------------------------------------------------------------

_mult::laplace:= loadproc(_mult::laplace,
                          pathname("TRANS","LAPLACE"), "L_mult"):
_mult::invlaplace:= loadproc(_mult::invlaplace,
                          pathname("TRANS","LAPLACE"), "IL_mult"):
_power::laplace:= loadproc(_power::laplace,
                          pathname("TRANS","LAPLACE"), "L_power"):
_power::invlaplace:= loadproc(_power::invlaplace,
                          pathname("TRANS","LAPLACE"), "IL_power"):

diff::laplace:= loadproc(diff::laplace,
                          pathname("TRANS","LAPLACE"), "L_diff"):
//------------------------------------------------------------------
unalias(path):

null():

