
/**************************

numlib::partialSievePhi(N, k)

returns the number of integers <= N
not divisible by the k smallest primes

***************************/


numlib::partialSievePhi:=
proc(N: DOM_INT, k)
  local lphi, i, p;
  option remember;
begin
  if N<= 0 then
    return(0)
  end_if;
  if k = 0 then
    return(0)
  end_if;
  if N < ithprime(k+1) then
    return(1)
  end_if;

  
  if k <= 50 and N >= numlib::primeProducts[k] then
    return(numlib::partialSievePhi(N mod numlib::primeProducts[k], k) +
           (N div numlib::primeProducts[k])*numlib::pminus1Products[k])
  end_if;
    
  lphi:=[(N+1) div 2, 0 $(k-1)]:
  p:=3; // = ithprime(2)
  for i from 2 to k do
    lphi[i]:= lphi[i-1] - numlib::partialSievePhi(N div p, i-1);
    p:= nextprime(p+2); // now p = ithprime(i+1)
  end_for;
  lphi[k]
end_proc:


[numlib::primeProducts, numlib::pminus1Products]:=
proc()
  local N, Q, i, l, p, pr, q;
begin
  N:= 50;
  p:=0;
  pr:= 1;
  q:= 1;
  l:= [0 $ N];
  Q:= [0 $ N];
  for i from 1 to N do
    p:= nextprime(p+1);
    pr:= pr*p;
    q:= q* (p-1);
    l[i]:= pr;
    Q[i]:= q
  end_for;
  [l, Q]
end_proc():
 