// Friedrich Schwarz 29.8.1994 

/*--
toAscii(s) encodes a string 
s - a string (consisting of printable characters,
              the tabulator character \t and 
              the newline character \n)
output: a list of ASCII codes
--*/

numlib::toAscii := proc(aString)
  local i, idx;
begin
  if testargs() then
    if args(0) <> 1 then
       error("expected one argument in function call")
    elif domtype(aString) <> DOM_STRING then
       error("argument must be a string")
    end_if
  end_if;
  [if (idx := contains(numlib::ascii2char, aString[i])) <> 0 then
     idx - 1
   else
     FAIL
   end_if $ i = 1..length(aString)]
end_proc:


numlib::toLatin9 := proc(aString)
  local i, idx;
begin
  if testargs() then
    if args(0) <> 1 then
       error("expected one argument in function call")
    elif domtype(aString) <> DOM_STRING then
       error("argument must be a string")
    end_if
  end_if;
  [if (idx := contains(numlib::iso_8859_1_2char, aString[i])) <> 0 then
     idx - 1
   else
     FAIL
   end_if $ i = 1..length(aString)]
end_proc:
