/*****************************************************************************
  $Id: tensorProductOfMaps.mu,v 1.2 2004/02/25 12:30:55 hivert Exp $
  File:		lib/OPERATORS/TensorProductOfMaps.mu
  Authors:	Florent Hivert <florent.hivert@univ-mlv.fr>
  Purpose:	Source code for operators::tensorProductOfMaps
  Created:	Thu Feb  15 20:04:58 2004
  License:	LGPL
  Project:	MuPAD-Combinat, http://mupad-combinat.sf.net
*****************************************************************************/

alias(TPFM      = Dom::TensorProductOfFreeModules):
alias(TPFMTools = Dom::TensorProductOfFreeModulesTools):
alias(assocTP   = TPFMTools::assocTensorProduct):

operators::tensorProductOfMaps :=
proc(maps    : DOM_LIST, 
     sources = null() : Type::Union(DOM_DOMAIN, Type::ListOf(DOM_DOMAIN)), 
     targets = null() : Type::Union(DOM_DOMAIN, Type::ListOf(DOM_DOMAIN)))
    option escape;
    local sourceT, targetT,
	  deConstr, constr, fCart; // constructor and deconstructor of tensors. 
begin
    if domtype(sources) = DOM_DOMAIN then
	if not sources::hasProp(TPFM) then
	    error("Wrong type of 2. argument (ListOf(Dom::FreeModule(Poly|List|Table))".
		  "or Dom::TensorProductOfFreeModules expected, got argument '".
		  expr2text(sources)."');")
	end_if;
	sourceT := sources; sources := sourceT::modules;
    else
	sourceT := Dom::TensorProductOfFreeModules(sources);
    end_if;	
    if domtype(targets) = DOM_DOMAIN then
	if not targets::hasProp(TPFM) then
	    error("Wrong type of 3. argument (ListOf(Dom::FreeModule(Poly|List|Table))".
		  " or Dom::TensorProductOfFreeModules expected, got argument '".
		  expr2text(targets)."');")
	end_if;
	targetT := targets; targets := targetT::modules;
    else
	targetT := Dom::TensorProductOfFreeModules(targets);
    end_if;
    deConstr := sourceT::toCartesianProductFromSignature(sources);
    constr   := targetT::tensorConstructorFromSignature(targets);
    fCart   := z -> constr(zip(maps, z, fp::apply));
    proc(el : sourceT) : targetT
	name TensorProductOfMaps;
    begin
	targetT::plus(op(map(deConstr(el), fCart)));
    end_proc;
end_proc:
