// $Date: 2004/07/20 14:29:44 $ $Author: ccr $ $Revision: 1.22 $ 
// tonner, 23/06/98 

/*++
output::MathContent -- Wrapper for Content markup
++*/

MathContent := newDomain(hold(MathContent)):
MathContent::create_dom:=hold(MathContent):
MathContent::print := x -> extop(x,1):
MathContent::new := 
proc() 
begin
  if Pref::autoPlot() and
     map({args()}, type) = {"plotObject"} and
     MathContent::usedByNotebook then
    plot(args());
    return(new(dom, hold(``), "\n"))
  end_if;
  if MathContent::usedByNotebook then // not a calc control
    if length(args()) > 20000 then
      error("too big")
    end_if;
  end:
  dom::create(args());
end_proc:

MathContent::create :=  
proc() 
  local aliasList;
begin
  if args() = null() then
    if MathContent::usedByNotebook then
      new(dom, hold(``), "\n")
    else
      new(dom, hold(``))
    end_if;
  else
    // return MathContent objects
    if domtype(args()) = MathContent then
      return(args())
    elif domtype(args()) = Content then
      if MathContent::usedByNotebook then
        return(new(dom, args(), strprint(args())))
      else
        return(new(dom, args()))
      end_if;
    end_if;
    
    aliasList := _pref(hold(Alias));
    if testtype(aliasList, DOM_LIST) and op(aliasList, 1) = TRUE and
      testtype(op(aliasList, 2), DOM_PROC) then
      Content::setAliasTab(op(aliasList, 2)())
    else
      Content::setAliasTab(table)
    end_if;
    if MathContent::usedByNotebook then
      new(dom, Content::new(args()), strprint(args()))
    else
      new(dom, Content::new(args()))
    end_if
  end_if;
end:

MathContent::usedByNotebook :=
proc()
  local cl, doc;
begin
  cl:= clientObject();
  if cl::dom::slot = FAIL
    or traperror((
       doc:= cl::document();
       doc::release()
     )) <> 0 
  then // not a calc control
    TRUE
  else
    FALSE
  end_if;
end_proc():
MathContent::map := (x, y) -> new(dom, map(extop(x), y)):
MathContent::expr := x -> Content::expr(extop(x,1)):
MathContent::op := proc(x, l = null()) begin Content::op(extop(x,1), l) end_proc:
MathContent::subsop := proc(x, l = null()) begin MathContent(Content::subsop(extop(x,1), l, Unsimplified)) end_proc:
MathContent::testtype := FALSE:
MathContent::create_dom := hold(MathContent):

