// $Date: 2003/09/03 13:07:22 $  $Author: tonner $   $Revision: 1.1 $

/* -----------------------------------------------------------
    Group2d -- The Group2d

    Syntax:
    Group2d(x, y<, op1, op2, ...>)

    x, y         : plot objects
    op1, op2, ...: plot options of the form 'option = value'
----------------------------------------------------------------*/ 

plot::createPlotDomain("Group2d",
                       "group of 2D graphical primitives"):

// methods yet to be implemented:  convert, convert_to, expr

// here we have to do something
plot::Group2d::new:=
  proc()
    local object, other, children, dimensions;
  begin
    // check all known options from the argument list
    object := dom::checkArgs([], args());
    
    // get arguments which are not yet processed
    other := object::other;
    
    if nops(other) <> 0 then
      error("unexpected arguments: ".expr2text(op(other)));
    end_if;

    children := object::children;

    if nops(children) = 0 then
      // empty Group2d
      return(dom::checkObject(object))
    end_if;
    
    dimensions := map({op(children)}, x -> x::dom::dimension);
    if nops(dimensions) <> 1 or dimensions <> {2} then
      error("only 2-dimensional plot objects allowed")
    end_if;

    // semantically check for validity
    dom::checkObject(object);
  end_proc:

plot::Group2d::print :=
  obj -> "plot::Group2d(...)":
