// $Date: 2003/09/03 13:07:23 $  $Author: tonner $   $Revision: 1.1 $

/* -----------------------------------------------------------
    View3d -- The current view position

    Internal object for keeping the view in replots.

    Syntax:
    plot::View3d(ViewPositionX=val, ....)

----------------------------------------------------------------*/ 

plot::createPlotDomain("View3d", "the current view position"):

// methods yet to be implemented:  convert, convert_to, expr

// here we have to do something
plot::View3d::new:=
  proc()
    local object, other, children;
  begin
    // check all known options from the argument list
    object := dom::checkArgs([], args());
    
    // get arguments which are not yet processed
    other := object::other;
    
    if nops(other) <> 0 then
      error("unexpected arguments: ".expr2text(op(other)));
    end_if;

    children := object::children;

    if nops(children) <> 0 then
      // empty plot
      error("a view must not contain any children");
    end_if;
        
    // semantically check for validity
    dom::checkObject(object);
  end_proc:

plot::View3d::print :=
  obj -> "plot::View3d(...)":
