// $Date: 2002/04/17 13:41:31 $ $Author: tonner $ $Revision: 1.9 $ 


/*++
	cyclotomic(n,x) 

	computes the n-th cyclotomic polynomial, expressed
	in the indeterminate x

++*/


polylib::cyclotomic:=
proc(n: Type::PosInt, x: DOM_IDENT)
 local divs: DOM_LIST,
  pos: DOM_LIST,
  neg: DOM_LIST,
  d:   DOM_INT;

begin
  divs:= numlib::divisors(n);
  pos:= select(divs, d -> numlib::moebius(n/d) = 1);
  neg:= select(divs, d -> numlib::moebius(n/d) = -1);
  divide(_mult(poly(1 - x^d, [x]) $d in pos),
         _mult(poly(1 - x^d, [x]) $d in neg),
         Exact)
end_proc: 

