// $Date: 2004/10/04 09:49:15 $ $Author: bij $ $Revision: 1.11 $

//
// This file contains informations about changes
// between MuPAD 1.4.2 - 2.0, 2.0 - 2.5, 2.5 -> 3.0, 3.0 -> 3.1
//
// new objects
// 

///////////////////////////////////////////////////////////////////////////////////////////////////
//// Changes 3.0 -> 3.1 ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

slot(prog::Changes, "newKeywords3.1"):=
  []:

slot(prog::Changes, "newLibs3.1"):=
  []:

slot(prog::Changes, "newFunctions3.1"):=
table(hold(plot)     = [hold(Scatterplot),
                        hold(Listplot),
                        hold(Vectorfield3d),
                        hold(Sequence),
                        hold(Sweep),
                        hold(SparseMatrixplot),
                        hold(Plane),
                        hold(Reflect2d),
                        hold(Reflect3d),
                        hold(Integral)],
      hold(Pref)     = [hold(autoPlot),
                        hold(experimentalInt)],
      hold(prog)     = [hold(exprlist),
                        hold(calledFrom),
                        hold(wait),
                        hold(testcall),
                        hold(testerrors),
                        hold(testmethod)],
      hold(System)   = [hold(block),
                        hold(blockTransparent),
                        hold(blockIdent),
                        hold(unblock),
                        hold(getlasterror)],
      hold(output)   = [hold(Symbol)]
      ):


///////////////////////////////////////////////////////////////////////////////////////////////////
//// Changes 2.5 -> 3.0 ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

slot(prog::Changes, "newKeywords3.0"):=
  ["assuming", "subset", "!!"]:

slot(prog::Changes, "newLibs3.0"):=
  ["Graph", "unit"]:

slot(prog::Changes, "newFunctions3.0"):=
table(hold(adt)      = [hold(Heap)],
      hold(combinat) = [hold(decomposableObjects), hold(linearExtensions)],
      hold(Cat)      = [hold(ModuleWithBasis)],
      hold(generate) = [hold(MathML)],
      hold(import)   = [hold(bitmap)],
      hold(linalg)   = [hold(pascal), hold(invpascal),
			hold(potential),
			hold(toeplitz), hold(toeplitzSolve),
			hold(vandermonde), hold(invvandermonde)],
      hold(numeric)  = [hold(polyrootbound)],
      hold(numlib)   = [hold(cornacchia), hold(factorGaussInt),
			hold(sqrtmodp), hold(sumOfDigits)],
      hold(output)   = [hold(roman), hold(fence)],
      hold(polylib)  = [hold(coeffRing)],
      hold(Pref)     = [hold(dbgAutoList)],
      hold(prog)     = [hold(getOptions), hold(ntime),
			hold(remember), hold(sort), hold(testerrors)],
      hold(stats)    = [hold(correlationMatrix)],
      hold(RGB)      = [hold(fromHSV), hold(toHSV), hold(plotColorPalette)],
      hold(System)   = [hold(Simplify), hold(_assuming),
			hold(airyAi), hold(airyBi), hold(densematrix),
			folc(fact2), hold(kummerU), hold(monomials),
			hold(strprint), hold(_subset), hold(surd),
			hold(testeq), hold(whittakerM), hold(whittakerW)],
      hold(stringlib) = [hold(collapseWhitespace), hold(order),
			 hold(random), hold(split),
			 hold(validIdent)],
      hold(Type)     = [hold(Intersection), hold(Predicate),
			hold(TableOf)]
      ):


///////////////////////////////////////////////////////////////////////////////////////////////////
//// Changes 2.0 -> 2.5 ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

slot(prog::Changes, "newKeywords2.5"):=
  ["==>", "<=>", "frame", "save", "xor"]:

slot(prog::Changes, "newLibs2.5"):=
  []:

slot(prog::Changes, "newFunctions2.5"):=
  table(
        hold(System)   = [hold(_save), hold(assert), hold(card), hold(copyClosure),
                          hold(DOM_INTERVAL), hold(FILEPATH), hold(fname),
                          hold(frandom), hold(hull), hold(hypergeom),
                          hold(interval), hold(PACKAGEPATH)],
        hold(Ax)       = [hold(indetElements)],
        hold(Dom)      = [hold(/*Sparse*/Matrix), hold(DomFloatIV)],
        hold(Type)     = [hold(Indeterminate), hold(Set)],
        hold(groebner) = [hold(stronglyIndependentSet)],
        hold(linalg)   = [hold(laplacian)],
        hold(numeric)  = [hold(cubicSpline2d), hold(leastSquares),
                          hold(odesolveGeometric), hold(ode2vectorfield)],
        hold(plot)     = [hold(bars), hold(piechart2d), hold(piechart3d),
                          hold(surface)],
        hold(prog)     = [hold(tcov)],
        hold(stats)    = [hold(betaCDF), hold(betaPDF), hold(betaQuantile),
                          hold(betaRandom), hold(binomialCDF), hold(binomialPF),
                          hold(binomialQuantile), hold(binomialRandom),
                          hold(cauchyCDF), hold(cauchyPDF), hold(cauchyQuantile),
                          hold(cauchyRandom), hold(chisquareCDF), hold(chisquarePDF),
                          hold(chisquareQuantile), hold(chisquareRandom),
                          hold(covariance), hold(csGOFT), hold(empiricalCDF),
                          hold(equiprobableCells), hold(erlangCDF), hold(erlangPDF),
                          hold(erlangQuantile), hold(erlangRandom),
                          hold(exponentialCDF), hold(exponentialPDF),
                          hold(exponentialQuantile), hold(exponentialRandom),
                          hold(fCDF), hold(fPDF), hold(fQuantile), hold(fRandom),
                          hold(gammaCDF), hold(gammaPDF), hold(gammaQuantile),
                          hold(gammaRandom), hold(geometricCDF), hold(geometricPF),
                          hold(geometricQuantile), hold(geometricRandom),
                          hold(hypergeometricCDF), hold(hypergeometricPF),
                          hold(hypergeometricRandom), hold(ksGOFT), hold(logisticCDF),
                          hold(logisticPDF), hold(logisticQuantile),
                          hold(logisticRandom), hold(meandev), hold(moment),
                          hold(normalPDF), hold(normalQuantile), hold(normalRandom),
                          hold(poissonCDF), hold(poissonPF), hold(poissonQuantile),
                          hold(poissonRandom), hold(swGOFT), hold(tPDF),
                          hold(tQuantile), hold(tRandom), hold(uniformCDF),
                          hold(uniformPDF), hold(uniformQuantile), hold(uniformRandom),
                          hold(weibullCDF), hold(weibullPDF), hold(weibullQuantile),
                          hold(weibullRandom)]
        ):

///////////////////////////////////////////////////////////////////////////////////////////////////
//// Changes 1.4.2 -> 2.0  ////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

slot(prog::Changes, "newKeywords2.0"):=
  ["domain", "save", "delete"]:

slot(prog::Changes, "newLibs2.0"):=
  [hold(matchlib), hold(adt), hold(polylib), hold(prog), hold(output),
   hold(solvelib), hold(detools), hold(intlib), hold(listlib)]:

slot(prog::Changes, "newFunctions2.0"):=
  table(
        hold(System)   = [hold(lhs), hold(rhs), hold(package), hold(piecewise),
                          hold(newDomain), hold(matrix), hold(coerce),
                          hold(operator), hold(ground), hold(lasterror),
                          hold(unexport), hold(int2text), hold(unfreeze),
                          hold(external), hold(Factored), hold(universe),
                          hold(share), hold(slot), hold(clientCall), 
                          hold(clientObject), hold(ClientObject),
                          hold(outputFormat), hold(outputType),
                          hold(rdabs), hold(rddivide), hold(rdfloat2text),
                          hold(rdgetsign), hold(rdint2float), hold(rdisfinite),
//                        hold(interpolate),  // fuer 2.0 -> 2.1
                          hold(rdmult), hold(rdnegate), hold(rdplus),
                          hold(rdround), hold(rdsubtract), hold(rdtext2float)],
        hold(adt)      = [hold(Tree), hold(Stack), hold(Queue)],
        hold(Cat)      = [hold(Set)],
        hold(Dom)      = [hold(ImageSet), hold(MonomOrdering), hold(SparseMatrixF2), hold(SubSet)],
        hold(domains)  = [hold(grouporder)],
        hold(linalg)   = [hold(minpoly), hold(pseudoInverse), hold(inverseLU),
                          hold(factorLU), hold(hessenberg), hold(wiedemann), hold(frobeniusForm),
                          hold(hilbert), hold(invhilbert), hold(vandermondeSolve),
                          hold(companion), hold(permanent), hold(substitute), hold(smithForm)],
        hold(matchlib) = [hold(match), hold(analyze)],
        hold(numeric)  = [
                          hold(complexRound),
                          hold(cubicSpline), 
                          hold(expMatrix),
                          hold(fMatrix),
                          hold(fsolve),
                          hold(indets),
                          hold(int),
                          hold(lagrange), // verschwindet fuer 2.1 wieder -> (stdlib) interpolate
                          hold(linsolve),
                          hold(matlinsolve),
                          hold(odesolve2),
                          hold(odesolveGeometric),
                          hold(polyroots),
                          hold(polysysroots),
                          hold(rationalize),
                          hold(realroot),
                          hold(realroots),
                          hold(solve),
                          hold(sort),
                          hold(spectralradius)
                         ],
        hold(output)   = [hold(tree)],
        hold(plotlib)  = [hold(inequalityplot)],
        hold(plotlib)  = [hold(ode)],
        hold(polylib)  = [hold(realroots)],
        hold(prog)     = [hold(check), hold(getname), hold(remember), hold(calltree),
                          hold(exprtree), hold(init), hold(traced), hold(find)],
        hold(property) = [hold(hasprop)],
        hold(specfunc) = [hold(arg), hold(log), hold(lambertV),
                          hold(lambertW), hold(polylog), hold(BesselI),
                          hold(BesselK), hold(Ci), hold(signIm)],
        hold(stats)    = [hold(BPCorr), hold(FCorr), hold(Tdist), hold(a_quantil), hold(calc),
                          hold(col), hold(concatCol), hold(concatRow), hold(geometric),
                          hold(harmonic), hold(kurtosis), hold(linReg), hold(mean),
                          hold(meanTest), hold(median), hold(modal), hold(normal),
                          hold(obliquity), hold(quadratic), hold(reg), hold(row),
                          hold(sample), hold(sample2list), hold(selectRow), hold(sortSample),
                          hold(stdev), hold(tabulate), hold(unzipCol), hold(variance), hold(zipCol)],
        hold(student)  = [hold(simpson), hold(trapezoid), hold(riemann)]
        ):

