// $Id: allfunc.mu,v 1.5 2002/08/06 19:30:34 bij Exp $

// bij 2000/2002
// overview of all defined function determined with 'anames'
//

alias(allOptions = {hold(Recursive), hold(Output), hold(Read),
                    hold(DB), hold(Domain)}):

alias(DBsep = "#"):
                    
prog::allFunctions:=
  proc(TYPE)
    local DP, DE, DFE, DD, DF, OPT, FILE, PRE, k, allDomainMethods, SORTF;
  begin
    // init all
    fprint(Unquoted, 0, "Warning: Reading all MuPAD objects, this may take a while...");
    prog::init(All, All);
    // paranoia
    prog::init(All, All);

    OPT:= prog::getOptions(args(), allOptions);
    
    if contains(OPT, hold(Diff)) then
      PRE:= map(stdlib::anames(3), expr2text) // use kernel function
    else
      PRE:= {}
    end_if;

    if contains(OPT, hold(Output)) then
      FILE:= prog::checkFile(OPT[hold(Output)], hold(Write))
    else
      FILE:= 0 // screen
    end_if;

    SORTF:= (X, Y) -> stringlib::order()(expr2text(X), expr2text(Y));
    
    // DOM_PROC /////////////////////////////////////////////////////////////
    userinfo(Text, 1, "all DOM_PROC");
    DP:= sort([op(select(stdlib::anames(3), X -> type(context(X)) = DOM_PROC))],
              SORTF);
    // DOM_FUNC_ENV /////////////////////////////////////////////////////////
    userinfo(Text, 1, "all DOM_FUNC_ENV");
    DFE:= {op(select(stdlib::anames(3), X -> type(context(X)) = DOM_FUNC_ENV))};
    userinfo(Text, 1, "extracting all DOM_EXEC");
    DE:= select(DFE, X -> type(op(context(X), 1)) = DOM_EXEC);
    DFE:= DFE minus DE;
    DFE:= sort([op(DFE)], SORTF);
    DE:= sort([op(DE)], SORTF);
    // DOM_DOMAIN ///////////////////////////////////////////////////////////
    userinfo(Text, 1, "pre-init most DOM_DOMAIN");
    DD:= sort([op(select(stdlib::anames(3), X -> type(context(X)) = DOM_DOMAIN))],
              SORTF);
    for DF in DD do
      DF:= context(DF);
      if domtype(DF) = DOM_DOMAIN then
	//if contains(context(DF), "constructor") then
	  prog::init(DF);
	  sysdelete(prog::init(DF))
	//end_if
      end_if
    end_for;

    if not contains(OPT, hold(DB)) then
      fprint(Unquoted, FILE, "DOM_EXEC: [", nops(DE), "]");
      output::tableForm(DE, Output = FILE);
      
      fprint(Unquoted, FILE, "\nDOM_PROC: [", nops(DP), "]");
      output::tableForm(DP, Output = FILE);
      
      fprint(Unquoted, FILE, "\nDOM_FUNC_ENV: [", nops(DFE), "]");
      output::tableForm(DFE, Output = FILE);
      
      fprint(Unquoted, FILE, "\nDOM_DOMAIN: [", nops(DD), "]");
      output::tableForm(DD, Output = FILE);
    else
      for k in DE do
        fprint(Unquoted, FILE, k, DBsep, DOM_EXEC, DBsep, "", DBsep)
      end_for;
      for k in DP do
        fprint(Unquoted, FILE, k, DBsep, DOM_PROC, DBsep, "", DBsep)
      end_for;
      for k in DFE do
        fprint(Unquoted, FILE, k, DBsep, DOM_FUNC_ENV, DBsep, "", DBsep)
      end_for;
      for k in DD do
        fprint(Unquoted, FILE, k, DBsep, DOM_DOMAIN, DBsep, "", DBsep)
      end_for;
    end_if;
    
    if contains(OPT, hold(Domain)) then
      allDomainMethods:=
        proc(DOM, HR = [])
          local OPR, DM;
        begin
          HR:= append(HR, DOM);
      
          DOM:= context(DOM);
          prog::init(DOM, hold(All));
          for OPR in select(map({op(DOM)}, op, 1),
                            X -> type(X) in {DOM_DOMAIN, DOM_EXEC, DOM_PROC, DOM_FUNC_ENV}) do
            prog::init(OPR)
          end_for;
      
          OPR:= map({op(DOM)}, op, 1);

          if not contains(OPT, hold(DB)) then
            fprint(Unquoted, FILE, "\nDomain: '", DOM, "'",
                   _if(args(0) > 3, "  (sub domain of '".expr2text(args(4))."')", ""));
        
            fprint(Unquoted, FILE, "\nAll domains of '", DOM, "'");
            output::tableForm(select(OPR, X -> type(slot(DOM, X)) = DOM_DOMAIN), Output = FILE);
        
            fprint(Unquoted, FILE, "\nAll methods of '", DOM, "'");
            output::tableForm(select(OPR, X -> type(slot(DOM, X)) in {DOM_EXEC, DOM_PROC, DOM_FUNC_ENV}),
                              Output = FILE);
        
            fprint(Unquoted, FILE, "\nAll entries of '", DOM, "'");
            output::tableForm(select(OPR, X -> not (type(slot(DOM, X)) in {DOM_DOMAIN, DOM_EXEC,
                                                                           DOM_PROC, DOM_FUNC_ENV})),
                              Output = FILE);
          else // DB
            for k in select(OPR, X -> type(slot(DOM, X)) in {DOM_DOMAIN, DOM_EXEC,
                                                             DOM_PROC, DOM_FUNC_ENV}) do
              fprint(Unquoted, FILE, k, DBsep, type(slot(DOM, k)), DBsep, DOM, DBsep)
            end_for
          end_if;
      
          if contains(OPT, hold(Recursive)) then
            for DM in sort(map([op(select(OPR, X -> type(slot(DOM, X)) = DOM_DOMAIN))], X -> slot(DOM, X))) do
              if contains(HR, DM) = 0 then
                allDomainMethods(DM, (HR:= append(HR, DM)))
              end_if
            end_for
          end_if;
      
          null()
        end_proc;
      
      fprint(Unquoted, FILE, "\n");
      map(DD, allDomainMethods)
    end_if;
    null()
  end_proc:

// --- DATABASE FILEFORMAT ---
// %% name : type : basedomain :
// assume:DOM_PROC::
// ...
// property::Rel:DOM_DOMAIN:property:
