// $Id: checkFile.mu,v 1.4 2003/09/23 09:05:45 bij Exp $

// bij 2002
//
// checkFile(FILE, <DIRECTION>, <Quiet>)
//   FILE      - filename as string or filehandle as integer
//   DIRECTION - Read or Write or Append, Close to close the file/end reading
//   Quiet     - FAIL instead of error

// this table keeps the status of each opened/used file
// each file in this table is assumed to be opened
// entries:       id   mode
//    filename = [int, read ]
//    fileid   = [int,      ]
prog::checkFILES := table():


prog::checkFile :=
  proc(FILE : Type::Union(DOM_STRING, Type::PosInt))
    local OPT, res;
  begin
    // options
    OPT := prog::getOptions([hold(Read),   // default read
                             hold(Write),
                             hold(Append),
                             hold(Text),
                             hold(Bin),
                             hold(Raw),
                             hold(Close),
                             hold(Quiet)], 1);
                            
    // filename
    if domtype(FILE) = DOM_STRING then
      if contains(OPT, hold(Close)) then
        // close file
        if contains(prog::checkFILES, FILE) then
          
          fclose(prog::checkFILES[FILE][1]); // id
          sysdelete(prog::checkFILES[FILE])
        else
          
          return(FAIL)
        end_if
      elif not contains(OPT, hold(Write)) and not contains(OPT, hold(Append)) then
        // reading
        // inspect REAPATH?? -> todo
        if (res := fopen(FILE)) <> FAIL then
          return(res)
        elif contains(OPT, hold(Quiet)) then
          return(FAIL)
        else
          context(hold(error)("cannot open file '".FILE."' for reading"))
        end_if
      else
        // writing
        // WRITEPATH??
        if (res := fopen(FILE, op(map({op(OPT)}, op, 1) intersect {hold(Bin),
                                                                   hold(Text),
                                                                   hold(Raw),
                                                                   hold(Write),
                                                                   hold(Append)}))) <> FAIL then
          return(res)
        elif contains(OPT, hold(Quiet)) then
          return(FAIL)
        else
          context(hold(error)("cannot open file '".FILE."' for writing"))
        end_if
      end_if
    // file descriptor of open file
    elif domtype(FILE) = DOM_INT then
      if contains(OPT, hold(Close)) then
        // close file
        fclose(FILE)
      elif not contains(OPT, hold(Write)) and not contains(OPT, hold(Append)) then
        return(FILE)
      else
        // writing
        // WRITEPATH??
        if traperror(fprint(hold(NoNL), FILE, "")) = 0 then
          return(FILE)
        elif contains(OPT, hold(Quiet)) then
          return(FAIL)
        else
          context(hold(error)("cannot write to given file"))
        end_if
      end_if
    else
      FAIL
    end_if
  end_proc:
