/*****************************************************************************
  $Id: makeTest.mu,v 1.3 2003/06/02 13:47:20 nthiery Exp $
  File:		lib/PROG/makeTest.mu
  Authors:	Nicolas M. Thiry <nthiery@users.sourceforge.net>
  Created:	16/02/2001
  License:	LGPL
*****************************************************************************/

/**
prog::makeTest -- utility for preparing test cases

prog::makeTest(expression1, expression2, ...):

Prints out a test case for each expressions ready to be copy-pasted
into a test suite.

Returns null():

Example:

>> prog::makeTest(combinat::partitions::count(4), combinat::partitions::list(3)):
prog::test(combinat::partitions::count(4),
           5):
prog::test(combinat::partitions::list(3),
           [[3], [2, 1], [1, 1, 1]]):

**/

prog::makeTest :=
proc()
    option hold;
    local expression, expressionEvaluated;
begin
    for expression in [args()] do
	expressionEvaluated := context(expression);
	fprint(Unquoted, 0,
	       "prog::test(", expression,
	       ",\n           ",expr2text(expressionEvaluated),
	       "):");
    end_for;
    null():
end_proc:
