// $Id: psrand.mu,v 1.1 2003/09/19 10:28:10 bij Exp $

// pseudo random number

// psrand(string, range)
// string - any MuPAD string
// range  - a range of two integers, default (when not given) 1..100
//
// psrand(string, range) returns a fixed pseudo random number
// depending on the given string in the given range (including borders).

prog::psrand :=
  proc(string = "MuPAD", range = 1..100)
  begin
    if domtype(range) = DOM_INT then
      range := 1..range
    elif type(range) = "_range" then
    else
      error("second argument must be an integer or a range")
    end_if;

    (crypto::cvhp_hash(string) mod (1 + op(range, 2) - op(range, 1))) + op(range, 1)
  end_proc:
