// $Date: 2002/08/26 10:48:43 $ $Author: bij $ $Revision: 1.2 $

/*++
prog::testfunc -- init testing of function

prog::testfunc(f)

f - expression

prog::testfunc(f) initializes the testing of function f. The argument
is not evaluated. If the test result file has not been opened it is
opened by prog::testfunc. If the variable 'TESTPATH' has a
value, it is used as a prefix for the path name.
++*/

prog::testfunc:=
  proc(FUNC)
    option hold;
  begin
    if args(0) <> 1 then
      error("wrong no of args")
    end_if;
    FUNC:= prog::getname(FUNC);
    if prog::TestFile = FAIL then
      prog::testinit(FUNC)
    end_if;
    sysassign(prog::TestNo, 1);
    sysassign(prog::TestFunc, FUNC);
    null()
  end_proc:

