// $Id: Prop.mu,v 1.12 2003/11/07 10:01:23 bij Exp $

/*
   Prop - generic property domain
*/

alias(Prop = property::Prop):

Prop:= newDomain("property::Prop"):
Prop::info:= "Domain of generic property 'Prop'":
Prop::domtype:= () -> Type:
Prop::type:= "Prop":
Prop::prop:= TRUE:
//Prop::autoload:= TRUE:
Prop::testtype:= Type::testtype:

Prop::ax:= []:

alias(Args(X) = extop(X, 5)):

Prop::new:= 
  proc(X)
  begin
    if args(0) = 1 then
      new(Prop, hold(Prop), FALSE, FALSE, FALSE, X)
    else
      error("wrong number of arguments")
    end_if
  end_proc:

// gibt bool zuruck, ob aus arg1, ..., argn-1 -> argn folgt 
Prop::is:=
  proc(X1, X2)
  begin
    if Args(X1) = Args(X2) then
      return(TRUE)
    else
      return(UNKNOWN)
    end_if
  end_proc:

Prop::op:=
  proc(X)
  begin
    Args(X)
  end_proc:

Prop::_and:=
  proc()
  begin
    property::_Op(Prop, _and, (X1, X2) -> hold(_and)(X1, X2), args())
  end_proc:

Prop::_or:=
  proc()
  begin
    property::_Op(Prop, _or, (X1, X2) -> hold(_or)(X1, X2), args())
  end_proc:

Prop::_not:=
  proc(X)
  begin
    hold(_not)(X)
  end_proc:

Prop::_plus:=
  proc()
  begin
    property::_Op(Prop, _plus, (X1, X2) -> hold(_plus)(X1, X2), args())
  end_proc:

Prop::_subtract:=
  proc(X1, X2)
  begin
    hold(_subtract)(X1, X2)
  end_proc:

Prop::_negate:=
  proc(X)
  begin
    hold(_negate)(X)
  end_proc:

Prop::_mult:=
  proc()
  begin
    property::_Op(Prop, _mult, (X1, X2) -> hold(_mult)(X1, X2), args())
  end_proc:

Prop::_divide:=
  proc(X1, X2)
  begin
    hold(_divide)(X1, X2)
  end_proc:

Prop::_invert:=
  proc(X)
  begin
    hold(_invert)(X)
  end_proc:

Prop::_power:=
  proc(X, pow)
  begin
    hold(_power)(X, pow)
  end_proc:

Prop::expr2text:=
  proc(X)
  begin
    "property::Prop(".
    expr2text(Args(X)).
    ")"
  end_proc:

Prop::print:=
  proc(X)
  begin
    hold(property::Prop)(Args(X))
  end_proc:

