// $Date: 2002/04/09 12:26:25 $ $Author: bij $ $Revision: 1.9 $

// 09.04.2002
// - new version: indets(expr, All) returns _all_ identifiers (also 0th operands)
// - recursive calls are not further necessary
// - EXCEPT: indexed identifiers are not identified, until the new concept is
//           realized

property::hasprop:=
  proc(ex = hold(Global))
  begin
    if properties(hold(Global)) <> FAIL then
      return(TRUE)
    elif domtype(ex) = DOM_IDENT then
      return(bool(properties(ex) <> FAIL))
    elif domtype(ex) = DOM_EXPR then
      if type(ex) = "_index" and domtype(op(ex, 1)) = DOM_IDENT then
        contains(property::ITABLE, ex)
      elif domtype(eval(op(ex, 0))) = DOM_FUNC_ENV
         and slot(eval(op(ex, 0)), "minprop") <> FAIL then
        return(TRUE)
      else
        // there are four different methods; the first activated!
        
        // without libary procedure
        ex:= eval(indets(ex, All)); // extract all identifiers, also inspect 0th operands
        if map(select(ex, testtype, DOM_IDENT), properties) <> {FAIL} then
          return(TRUE)
        elif map(select(ex, testtype, DOM_FUNC_ENV), slot, "minprop") <> {FAIL} then
          return(TRUE)
        else
          return(FALSE)
        end_if
        
//         // conventional method - takes the same time!
//         contains(map(eval(indets(ex, hold(All))),
//                      proc(X)
//                        name property_hasprop_inside;
//                      begin
//                        case domtype(X)
//                          of DOM_IDENT do
//                            // of DOM_INDEXED do
//                            return(bool(properties(X) <> FAIL))
//                          of DOM_FUNC_ENV do
//                            return(bool(slot(X, "minprop") <> FAIL))
//                          otherwise
//                            return(FALSE)
//                        end_case
//                      end_proc), TRUE);
       
//         // lazy evaluation should be faster, but isn't!
//         ex:= eval(indets(ex, All)); // extract all identifiers, also inspect 0th operands
//         // hasprop_inside must been pre-defined with a local variable!
//         // evaluate 'lazy' each identifier
//         eval(subsop(hold(_lazy_or)(FALSE),
//                     1 = (hold(hasprop_inside)(op(ex, k)) $ k = 1..nops(ex)), Unsimplified))

        // old recursive library call - too slow
//         eval(subsop(hold(_lazy_or)(FALSE), 1 = (hold(property::hasprop)(op(ex, k)) $ k = 1..nops(ex)), Unsimplified))

      end_if
    else
      return(FALSE)
    end_if
  end_proc:
