// $Id: DOM_COMPLEX.mu,v 1.1 2002/06/18 11:49:48 bij Exp $

// conversion methods for complexing point numbers

DOM_COMPLEX::Rectform:=
  proc(complex)
  begin
    if op(complex, 1) <> 0 then
      Set("Rectform", Set("Finite", op(complex, 1)), Set("Finite", op(complex, 2)))
    else
      Set("Rectform", Set::Zero, Set("Finite", op(complex, 2)))
    end_if
  end_proc:

DOM_COMPLEX::Polarform:=
  proc(complex)
  begin
    Set::coerce(DOM_COMPLEX::Rectform(complex), "Polarform")
  end_proc:

DOM_COMPLEX::Real:=
  proc(complex)
  begin
    FAIL
  end_proc:

DOM_COMPLEX::Finite:=
  proc(complex)
  begin
    Set("Finite", complex)
  end_proc:

DOM_COMPLEX::Interval:=
  proc(complex)
  begin
    FAIL
  end_proc:

DOM_COMPLEX::Union:=
  proc(complex)
  begin
    Set("Union", Set("Finite", complex))
  end_proc:

DOM_COMPLEX::Intersect:=
  proc(complex)
  begin
    Set("Intersect", Set("Finite", complex))
  end_proc:

DOM_COMPLEX::Minus:=
  proc(complex)
  begin
    Set("Minus", Set("Finite", complex), Set::Empty)
  end_proc:

DOM_COMPLEX::Bigunion:=
  proc(complex)
  begin
    FAIL
  end_proc:

DOM_COMPLEX::Imageset:=
  proc(complex)
  begin
    Set("Imageset", `#k`, `#k`, DOM_COMPLEX::Finite(complex))
  end_proc:

DOM_COMPLEX::Set:=
  proc(complex)
  begin
    Set("Finite", complex)
  end_proc: