// $Id: DOM_FLOAT.mu,v 1.1 2002/06/18 11:49:48 bij Exp $

// conversion methods for floating point numbers

DOM_FLOAT::Rectform:=
  proc(float)
  begin
    Set("Rectform", Set("Finite", float), Set::Zero)
  end_proc:

DOM_FLOAT::Polarform:=
  proc(float)
  begin
    Set::coerce(DOM_FLOAT::Rectform(float), "Polarform")
  end_proc:

DOM_FLOAT::Real:=
  proc(float)
  begin
    Set("Real", "real", {sign(float)})
  end_proc:

DOM_FLOAT::Finite:=
  proc(float)
  begin
    Set("Finite", float)
  end_proc:

DOM_FLOAT::Interval:=
  proc(float)
  begin
    Set("Interval", [float], [float])
  end_proc:

DOM_FLOAT::Union:=
  proc(float)
  begin
    Set("Union", Set("Finite", float))
  end_proc:

DOM_FLOAT::Intersect:=
  proc(float)
  begin
    Set("Intersect", Set("Finite", float))
  end_proc:

DOM_FLOAT::Minus:=
  proc(float)
  begin
    Set("Minus", Set("Finite", float), Set::Empty)
  end_proc:

DOM_FLOAT::Bigunion:=
  proc(float)
  begin
    FAIL
  end_proc:

DOM_FLOAT::Imageset:=
  proc(float)
  begin
    Set("Imageset", `#k` = float, `#k`, DOM_FLOAT::Real(float))
  end_proc:

DOM_FLOAT::Set:=
  proc(float)
  begin
    Set("Finite", float)
  end_proc: