// $Id: DOM_INTERVAL.mu,v 1.1 2002/06/18 11:49:48 bij Exp $

// conversion methods for intervals

DOM_INTERVAL::Rectform:=
  proc(iv)
  begin
    if iszero(Im(iv)) then // reell
      if domtype(op(iv, 1)) = DOM_INTERVAL then // union
        Set("Rectform", Set("Union", Set("Interval", op(op(iv, 1))), Set("Interval", op(op(iv, 2)))),
                        Set::Zero)
      else
        Set("Rectform", Set("Interval", op(iv)), Set::Zero)
      end_if
    else // complex
      Set("Rectform", Set("Interval", op(op(iv, 1))), Set("Interval", op(op(iv, 2))))
    end_if
  end_proc:

DOM_INTERVAL::Polarform:=
  proc(iv)
  begin
    Set::coerce(DOM_INTERVAL::Rectform(iv), "Polarform")
  end_proc:

DOM_INTERVAL::Real:=
  proc(iv)
  begin
    if iszero(Im(iv)) then // reell
      if domtype(op(iv, 1)) = DOM_INTERVAL then // union
        FAIL //Set("Union", Set("Interval", op(op(iv, 1))), Set("Interval", op(op(iv, 2))))
      else
        Set("Interval", op(iv))
      end_if
    else // complex
      FAIL //Set("Rectform", Set("Interval", op(op(iv, 1))), Set("Interval", op(op(iv, 2))))
    end_if
  end_proc:

DOM_INTERVAL::Finite:=
  proc(iv)
  begin
    FAIL
  end_proc:

DOM_INTERVAL::Interval:=
  proc(iv)
  begin
    if iszero(Im(iv)) then // reell
      if domtype(op(iv, 1)) = DOM_INTERVAL then // union
        FAIL //Set("Union", Set("Interval", op(op(iv, 1))), Set("Interval", op(op(iv, 2))))
      else
        Set("Interval", op(iv))
      end_if
    else // complex
      FAIL //Set("Rectform", Set("Interval", op(op(iv, 1))), Set("Interval", op(op(iv, 2))))
    end_if
  end_proc:

DOM_INTERVAL::Union:=
  proc(iv)
  begin
    if iszero(Im(iv)) then // reell
      if domtype(op(iv, 1)) = DOM_INTERVAL then // union
        Set("Union", Set("Interval", op(op(iv, 1))), Set("Interval", op(op(iv, 2))))
      else
        FAIL //Set("Interval", op(iv))
      end_if
    else // complex
      FAIL //Set("Rectform", Set("Interval", op(op(iv, 1))), Set("Interval", op(op(iv, 2))))
    end_if
  end_proc:

DOM_INTERVAL::Intersect:=
  proc(iv)
  begin
    FAIL
  end_proc:

DOM_INTERVAL::Minus:=
  proc(iv)
  begin
    FAIL
  end_proc:

DOM_INTERVAL::Bigunion:=
  proc(iv)
  begin
    FAIL
  end_proc:

DOM_INTERVAL::Imageset:=
  proc(iv)
  begin
    Set("Imageset", `#X`, `#X`, DOM_INTERVAL::Set(iv))
  end_proc:

DOM_INTERVAL::Set:=
  proc(iv)
  begin
    if iszero(Im(iv)) then // reell
      if domtype(op(iv, 1)) = DOM_INTERVAL then // union
        Set("Union", Set("Interval", op(op(iv, 1))), Set("Interval", op(op(iv, 2))))
      else
        Set("Interval", op(iv))
      end_if
    else // complex
      Set("Rectform", Set("Interval", op(op(iv, 1))), Set("Interval", op(op(iv, 2))))
    end_if
  end_proc: