// $Date: 2002/08/20 11:33:47 $ $Author: bij $ $Revision: 1.2 $

/*
   Finite     - Domain of finite sets

   op(Finite) - set of elements, {} when empty

*/

alias(Finite = Set::Finite):
alias(Elem(x) = op(extop(x, 2))): // elements
alias(Elemset(x) = extop(x, 2)):  // set of elements
alias(ELEMSET = 2):

Finite:= newDomain("Set::Finite"):
Finite::create_dom:= hold(Set::Finite):
Finite::info:= "Domain of finite sets":
Finite::domtype:= () -> Set:
Finite::type:= "Finite":

Finite::new:=
  proc(SET = {})
  begin
    if domtype(SET) <> DOM_SET then
      SET:= {args()}
    end_if;
    new(Set, "Finite", SET)
  end_proc:

//////////////////////////////////////////////////////////////////////
// predefined objects
//////////////////////////////////////////////////////////////////////
Set::Empty       := Finite::new({}):
Set::Zero        := Finite::new({0}):
Set::One         := Finite::new({1}):
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

Finite::_union:=
  proc(FS1, FS2)
  begin
    Finite::new(Elemset(FS1) union Elemset(FS2))
  end_proc:

Finite::_intersect:=
  proc(FS1, FS2)
  begin
    Finite::new(Elemset(FS1) intersect Elemset(FS2))
  end_proc:

Finite::_minus:=
  proc(FS1, FS2)
  begin
    Finite::new(Elemset(FS1) minus Elemset(FS2))
  end_proc:

Finite::contains:=
  proc(FS1, elem)
  begin
    contains(Elemset(FS1), elem)
  end_proc:



// elem-wise conversion
Finite::Realdom:=
  proc(FS)
  begin
    Set::coerce(Set::_union(map((Elem(FS)), Set::coerce, Set::Realdom)), Set::Realdom)
  end_proc:

// elem-wise conversion
Finite::Rectform:=
  proc(FS)
  begin
    Set::coerce(Set::_union(map((Elem(FS)), Set::coerce, Set::Rectform)), Set::Rectform)
  end_proc:

// elem-wise conversion
Finite::Interval:=
  proc(FS)
  begin
    Set::coerce(Set::_union(map((Elem(FS)), Set::coerce, Set::Interval)), Set::Interval)
  end_proc:

// 
Finite::print:=
  proc(FS)
  begin
    case Elemset(FS)
      of {0} do
        // predefines objects
        hold(Set::Zero); break
      of {1} do
        // predefines objects
        hold(Set::One); break
      otherwise
        Elemset(FS)
    end_case
  end_proc: