// $Date: 2002/07/02 13:37:03 $ $Author: bij $ $Revision: 1.1 $

/*
   Minus     - Domain of minus sets

   op(Minus) - set, excl
               

*/

alias(Minus = Set::Minus):
alias(Set1(x) = extop(x, 1)): // set
alias(SET1 = 1):
alias(Excl(x) = extop(x, 2)): // exclusion
alias(EXCL = 2):

Minus:= newDomain("Set::Minus"):
Minus::create_dom:= hold(Set::Minus):
Minus::info:= "Domain of minus sets":
Minus::domtype:= ()->Set:
Minus::type:= "Minus":
Minus::prop:= TRUE: // usable as property
Minus::testtype:= Type::testtype: // ??

Minus::new:=
  proc(set1, excl)
  begin
    if excl = Set::Empty then
      set1
    else
      new(Minus, set1, excl)
    end_if
  end_proc:

// implies
Minus::contains:=
  proc(s1, s2)
  begin
    // Minus, Minus
    contains(Set1(s1), Set1(s2)) and not contains(Excl(s2), Exscl(s1))
  end_proc:

// implies
Minus::_implies:=
  proc(s1, s2)
  begin
    // Minus, Minus
    _implies(Set1(s1), Set1(s2)) and not _implies(Excl(s2), Exscl(s1))
  end_proc:

Minus::sign:=
  proc(s)
  begin
    sign(Set1(s)) minus sign(Excl(s))
  end_proc:

Minus::_union:=
  proc(s1, s2)
  begin
    FAIL
  end_proc:

Minus::_intersect:=
  proc(s1, s2)
  begin
    FAIL
  end_proc:

Minus::_minus:=
  proc(s1, s2)
  begin
    FAIL
  end_proc:

Minus::_plus:=

Minus::_subtract:=

Minus::_negate:=

Minus::_mult:=

Minus::_divide:=

Minus::_invert:=

Minus::_power:=

Minus::expr2text:=
  proc(s)
  begin
    "Set::Minus(".
    expr2text(Set1(s)).
    ", ".
    expr2text(Excl(s)).")"
  end_proc:

Minus::print:=
  proc(s)
  begin
    hold(_minus)(Set1(s), Excl(s))
  end_proc:

