// $Date: 2002/08/16 09:41:49 $ $Author: bij $ $Revision: 1.3 $

/*
    Set::coerce(x, t)

    x      : expression
    t      : an internal type string (Set::internalTypes)

    coerce(x, t) tries to convert x to an object of the type t.

    If the conversion is not possible (or not implemented), then FAIL 
    is returned.
*/

Set::coerce:=
  proc(x, t = Set)
    local d;
  begin
    // always right type
    if type(x) = t or domtype(t) = DOM_DOMAIN and contains(d, t::type) then return(x) end_if;

    // conversion method
    d:= slot(x::dom, type(x));
    if d <> FAIL then
      if contains(d, t) then
        return(slot(d, t)(x))
      elif domtype(t) = DOM_DOMAIN and contains(d, t::type) then
        return(slot(d, t::type)(x))
      end_if
    end_if;
    FAIL
  end_proc:

