// $Id: combineExponents.mu,v 1.5 2003/11/07 17:21:35 stefanw Exp $

// 06/2003, bij, stefanw
//

Simplify::combineExponents:=
proc(e: "_mult")
  local t: DOM_TABLE, a, sgn: DOM_INT, bas, expo, reduceMod2;
begin
 // rewrite x^a*x^b --> x^(a+b)

    
  t:= table();
  for a in e do
    if type(a) = "_power" then
      bas:= op(a, 1);
      expo:= op(a, 2);
    else
      bas:= a;
      expo:= 1;
    end_if;
    // special case
    if bas = I then
      bas:= -1;
      expo:= expo/2
    elif bas = -I then
      bas:= -1;
      expo:= 3*expo/2
    end_if;
      
    if contains(t, bas) then
      t[bas]:= t[bas] + expo
    else
      t[bas]:= expo
    end_if;
  end_for;

  if contains(t, -1) then
  // symmetric reduction modulo 2
    reduceMod2:=
    proc(b)
      local p, q;
    begin
      case type(b)
        of DOM_INT do
          return(b mod 2)
        of DOM_RAT do
          return(frac(1/2 + b/2)*2 - 1)
        of DOM_COMPLEX do
          p:= op(b, 1);
          q:= op(b, 2);
            // reduce p modulo 2
          return(reduceMod2(op(b, 1)) + op(b, 2)*I)
        of "_plus" do
          return(map(b, reduceMod2))
      end_case;
      if is(b, Type::Integer)=TRUE and stdlib::hasmsign(b) then
        -b
      else
        b
      end_if
    end_proc;

    t[-1] := reduceMod2(t[-1]);
    if contains({DOM_INT, DOM_RAT, DOM_FLOAT}, domtype(t[-1])) and t[-1] < 0 then
      t[-1]:= t[-1] + 1;
      sgn:= -1
    else
      sgn:= 1
    end_if
  else
    sgn:= 1
  end_if;
  
  sgn*_mult(op(a, 1)^op(a, 2) $a in t)
end_proc: