// $Id: distributeExponent.mu,v 1.6 2003/11/11 15:57:39 stefanw Exp $

// 06/2003, bij, stefanw
//

Simplify::distributeExponent:=
proc(e: "_power")
  local _a, b, c, aa, t, p, q, complexpart;
begin

  [_a, b] := [op(e)];
  
  if type(_a) = "_mult" then
    if is(b, Type::Integer) = TRUE then
      return(map(_a, _power, b))
    elif type(b) = DOM_RAT then
      c := op(_a, nops(_a));
      if testtype(c, Type::Numeric) then
        if testtype(c, Type::Real) and c < 0 then
          t := trunc(b);
          if (t <> 0) then
            return(_a^t*_a^(b-t))
          end_if;
        end_if;
      end_if;
    end_if;

    p := 1;
    aa := 1;
    complexpart :=1;
    for q in _a do
      if is(q >= 0) = TRUE then
        p := p* q^b
      elif is(q <= 0) = TRUE then
        // extract (-q)^b
        p:= p* (-q)^b;
        aa:= -aa;
      elif is(Re(q) > 0) = TRUE and is(Re(complexpart) > 0) = TRUE then
        // use the rule a^n * b^n = (a*b)^n as long as a, b are known
        // to satisfy Re(a), Re(b) > 0
        complexpart:= complexpart * q;
        p:= p* q^b
      else
        aa := aa*q
      end_if;
    end_for;   
    return(p*aa^b)  
  end_if;
  
  e
end_proc: