// $Id: ratExponent.mu,v 1.4 2003/09/04 16:04:38 stefanw Exp $

// 06/2003, bij, stefanw
//

Simplify::ratExponent:=
proc(e:"_power")
  local a, b, p, l;
begin
  [a, b] := [op(e)];


  if domtype(b) <> DOM_RAT then
    return(e)
  end_if;

  // try whether a^(p/q) can be expressed as (a^p)^(1/q)
  if specfunc::abs(op(b, 1)) > 1 and
    testtype(a, Type::Constant) and
    is(arg(a) < PI/abs(op(b, 1)) and arg(a) > -PI/abs(op(b, 1))) = TRUE
    then

    l:= expand(a ^ (op(b, 1)));
    if property::complexity(l) <= property::complexity(a) then
      return(l^(1/op(b, 2)))
    end_if
  end_if;

  
  if testtype(a,hold(_power)(Type::AnyType,Type::Rational)) then // (x^r)^(j/k)
    p:=op(a,1)^(op(a,2)*b);
    if is(p>=0)=TRUE then
      return(p)
    elif b=1/2 then
      if is(p,Type::Real)=TRUE then
        //return(abs(p))
        return(p*sign(p))
      elif is(Re(a)>0)=TRUE
        or is (Im(a)<>0)=TRUE
        or (is(op(a,2), Type::Even) = TRUE
            and is(Re(op(a,1)^(op(a,2)/2)) > 0) = TRUE )
        then
        return(p)
      end_if
    end_if;
  end_if;

  e
end_proc:
  