// $Id: ratRatPower.mu,v 1.4 2003/09/04 16:04:38 stefanw Exp $

// 06/2003, bij, stefanw
//

// special method for rational powers of rationals

Simplify::ratRatPower:=
proc(e: "_power")
  local a, b, p, q, br, l, i;

begin
  [a, b]:= [op(e)];
  if domtype(a) <> DOM_RAT or domtype(b) <> DOM_RAT then
    return(e)
  end_if;


  

  if a < 0 then
    return((-1)^b * (-a)^b )
  end_if;
    
  if op(a, 1) = 1 or a > 0 and b < 0 then
    // (1/n)^(p/q) -> n^(-p/q)
    //  1 / (5/3)^(1/2) -> (3/5)^(1/2)
    return((1/a)^(-b))
  end_if;

        
    
    
  // extract powers
  // do the same as in the case type(a) = DOM_INT,
  // but separately for numerator and denominator
  q:=denom(b);
  p:=numer(b);
  br:= 1;
  l:=stdlib::ifactor(op(a, 1), UsePrimeTab);
  for i from 2 to nops(l) step 2 do
    if l[i+1] >= q then
      a := a / l[i]^ (q*(l[i+1] div q));
      br:= br* l[i] ^ (p*(l[i+1] div q))
    end_if
  end_for;
  // by diving off factors from a, a should still be rational
  assert(domtype(a) = DOM_RAT);
  l:=stdlib::ifactor(op(a, 2), UsePrimeTab);
  for i from 2 to nops(l) step 2 do
    if l[i+1] >= q then
      a := a * l[i]^ (q*(l[i+1] div q));
      br:= br/ l[i] ^ (p*(l[i+1] div q))
    end_if
  end_for;
    
  return(a^(p/q)*br)

end_proc:

  