// squarefree factorization, using algebraic dependencies


Simplify::sqrfreeFactor:=
proc(e)
  local t, equ, base, expo, variable, p, q, l;
begin
  t := rationalize(e, NIL, NIL, {"_power"}, ShowDependencies);
  e := op(t, 1);
  e := expr(polylib::sqrfree(e));
  for equ in op(t, 2) do
    if type(op(equ, 2)) = "_power" and
      type((expo := op(equ, [2, 2]))) = DOM_RAT then
      base := op(equ, [2, 1]);
      variable := op(equ, 1);
      p := op(expo, 1);
      q := op(expo, 2);
      e := misc::maprec
      (e, {"_power"} =
       proc(pow)
       begin
         if op(pow, 1) = variable and type(op(pow, 2)) = DOM_INT then
          variable^(op(pow, 2) mod q)*base^((op(pow, 2) div q)*p)
         else
           pow
         end_if
       end_proc)
    end_if
  end_for;
  repeat
    l := e;
    e := subs(e, op(t, 2))
  until l = e end_repeat;
  e
end_proc: