// $Date: 2003/09/22 11:45:43 $ $Author: bij $ $Revision: 1.2 $

// 
// patt, repl, OPT (wie fur match)
// 
// 
// 
// 
// 

Simplify::MatchRules::_and:=
  [
   // expand (distributive law)
   Rule(`#A` and (`#B` or `#C`), hold(`#A` and `#B` or `#A` and `#C`)),
   
   Rule(not `#A` and not `#B`, hold(not (`#A` or `#B`))),

   // substitutivity of =

   Rule(`#A`=`#B` and `#C`, hold(`#A`=`#B` and eval(subs(`#C`, `#A`=`#B`))),
        {}, table("Default" = 0.7)),

   // rules for equations and inequalities

   Rule(`#A`=`#B` and `#A`<>`#B`, FALSE),
   Rule(`#A`<=`#B` and `#A`<>`#B`, `#A` < `#B`),
   Rule(`#A` < `#B` and `#A`<>`#B`, `#A` < `#B`),

   Rule(`#A`<=`#B` and `#B`<=`#C`, `#A`<=`#B` and `#B`<=`#C` and `#A`<=`#C`),
   Rule(`#A`<=`#B` and `#A`>=`#C`, FALSE,
        {(`#B`, `#C`)-> is(`#C` > `#B`) = TRUE}),
   Rule(`#A`<`#B` and `#A`>`#C`, FALSE,
        {(`#B`,`#C`) -> is(`#C`>=`#B`) = TRUE }),

   // inequalities imply that both sides are real

   Rule(`#A`<`#B` and `#A` in R_, `#A`<`#B`),
   Rule(`#A`<`#B` and `#B` in R_, `#A`<`#B`),
   Rule(`#A`<=`#B` and `#A` in R_, `#A`<=`#B`),
   Rule(`#A`<=`#B` and `#B` in R_, `#A`<=`#B`),


   // set operations
   Rule(`#X` in `#B` and `#X` in `#C`, hold(`#X` in `#B` intersect `#C`)),
   Rule(`#X` in `#B` and not `#X` in `#C`, hold(`#X` in `#B` minus `#C`)),


   // rules for real numbers

   Rule(`#U` and `#X` in R_ and `#Y` in R_,
        `#U` and `#X` in R_ and `#Y` in R_ and `#X`*`#Y` in R_),

   Rule(`#X` in R_ and `#Y` in R_, `#X` in R_ and `#X` + `#Y` in R_),
   Rule(`#X` in R_ and `#Y` in R_,
        `#X` in R_ and `#Y` in R_ and `#X`*`#Y` in R_)

   ]:
