// $Date: 2003/10/06 09:32:38 $ $Author: stefanw $ $Revision: 1.3 $

// 
// patt, repl, OPT (wie fur match)
// 
// 
// 
// 
// 

Simplify::MatchRules::_power:=
  [Rule(X^n, hold(map(X, _power, n)),
         {(X, n) -> is(n, Type::Integer) = TRUE and type(X) = "_mult"}),
   
   Rule(X^n, hold(expand(X^n)),
         {(X, n) -> type(n)=DOM_INT and n>0 and type(X)="_plus"}),


   Rule(X^p, hold((proc(n, p)
                    local l;
                   begin
                    l:=stdlib::ifactor(n);
                    l[1]^p * _mult(l[2*i]^(l[2*i+1]*p) $i=1..nops(l) div 2)
                  end_proc)
                    (X,p)),
         {(X, p) -> type(X)=DOM_INT and type(p) = DOM_RAT}),
   

   // simplify like a product:
   Rule(X^p, hold(I^p * op(X, 2)^p), {X -> type(X) = DOM_COMPLEX and op(X, 1) = 0 and op(X, 2) > 0}),

   // voruebergehend:
   
   Rule(X^p, hold(radsimp(X^p)),  {p -> type(p) = DOM_RAT}),

   Rule(X^p, hold(expr(rectform(X^p))), {X -> type(X) = DOM_COMPLEX,
                                         p -> type(p) = DOM_RAT}  ),
      
   Rule(X^p, hold(exp(op(X)*p)),
        {X -> type(X) = "exp" and is(op(X,1), Type::Real) = TRUE}),
   
   Rule(X^r, hold(op(X, 1)^(op(X, 2)*r)),
         {r -> is(r, Type::Rational) = TRUE,
                X -> type(X) = "_power" and
                is(op(X, 1), Type::NonNegative) = TRUE and
                is(op(X, 2), Type::Rational) = TRUE}),

   Rule(sqrt(X), hold(sign(op(X, 1))*op(X, 1)),
         {X -> type(X) = "_power"
                and is(op(X, 1), Type::Real) = TRUE
                and op(X, 2) = 2}),
   Rule(X^Y, hold(exp(Y*ln(X))),
         {(X, Y) -> is(X<>0) and not testtype(Y, Type::Constant)}),

   Rule(B^(log(B, X)), X),   

   Rule(X^(A+B), hold(X^A * X^B)),
   
   Rule(X^p, hold(isqrt(X)^(2*p)),
         {X -> (domtype(X) = DOM_INT and isqrt(X)^2 = X)}),
   Rule(sin(X)^2, 1 - cos(X)^2),
   Rule(cos(X)^2, 1 - sin(X)^2)
   ]:
