// $Id: All.mu,v 1.14 2004/08/13 11:56:46 stefanw Exp $

// 06/2003, bij, stefanw
//
// simplification methods for expressions of any type
//   must be a list of procedures or rules

Simplify::All :=
  proc(EXPR): DOM_LIST
    local inds, sl, res: DOM_LIST;
  begin
    
    if contains({DOM_LIST, DOM_SET}, domtype(EXPR)) then
      // no rules, subexpression step only
      // we must *not* map Simplify (with all options) to the elements, since
      // we would not be able to handle e.g. the option All
      return([])
    end_if;

    // use lazy evaluation: sl will point to the "Simplify" slot,
    // or, if that one does not exist, to the "simplify" slot if the 
    if (sl:= EXPR::dom::Simplify) <> FAIL or
      (sl:= EXPR::dom::simplify) <> FAIL then
      if domtype(sl) <> DOM_LIST then
        return([Rule(sl, {}, table("Default" = 0.0))])
      else
        return(sl)
      end_if
    else
      
      // overloading by function attribute
      if domtype(eval(op(EXPR, 0))) = DOM_FUNC_ENV then
        if (sl:= slot(eval(op(EXPR, 0)), "Simplify")) <> FAIL then
          if domtype(sl) <> DOM_LIST then
            // do only this step
            return([Rule(Simplify::overload, {}, table("Default" = 0.0)) ])
          else
            res:= sl
          end_if
        elif (sl:= slot(eval(op(EXPR, 0)), "simplify")) <> FAIL then
          res:= [Rule(Simplify::overload, {}, table("Default" = 0.0))];
          return(res)        
        else
          res:= []
        end_if
      else
        res:= []
      end_if;
  
      inds:= indets(EXPR, All);
      res.
      [
       
       Rule(expand, {}, table("Default" = 0.8)),

       
       if testtype(EXPR, Type::Arithmetical) then
         Rule(X -> normal(X),  {}, table("Default" = 0.85))
       else
         null()
       end_if,

       if inds intersect {hold(sin), hold(cos)} <> {} then
         Rule(X -> combine(X, sincos), {}, table("Default" = 0.9))
       else
         null()
       end_if      
       
       ]
    end_if
  end_proc:
