// $Id: _mult.mu,v 1.14 2004/02/05 15:44:10 stefanw Exp $

// 06/2003, bij, stefanw
//
// simplification methods for expressions of type '_mult'
//   must be a list of procedures or rules

Simplify::_mult :=
proc(expression)
  local inds, types, ratinds;
begin
  inds:= indets(expression, All);
  ratinds:= indets(expression, RatExpr);
  types:= map({op(expression)}, type);
  [
   
   



  // if there are expand-Attributes, omit them
            
   Rule(X -> expand(X, op(indets(X, RatExpr))), {}, table("Default" = 0.8)),

   
   if contains(inds, hold(exp)) and nops(select(ratinds, testtype, "exp")) > 1
     then
     Rule(Simplify::expSimpl, {}, table("Default" = 0.95))
   else
     null()
   end_if,
   if contains(types, "_power") then
     Rule(Simplify::combineIntPowers),
     Rule(Simplify::combineExponents),
     Rule(Simplify::combineConstantWithRoots)
   else
     null()
   end_if,
   Rule(_mult::combine, {}, table("Default" = .92)),
   (if inds intersect {hold(sin), hold(cos)} <> {} then
      Rule(X -> combine(X, sincos))
    elif contains(inds, hold(exp)) then
      Rule(X -> combine(X, exp))
    elif contains(inds, hold(ln)) then
      Rule(X -> combine(X, ln))
    else
      null()
    end_if),

    if contains(types, "sign") then
      // replace sign by abs
      Rule(Simplify::signToAbsInProd, {}, table("Default" = 1.1)),
      (if contains(types, "abs") then
         Rule(Simplify::collectAbsSign)
       else
         null()
       end_if)
    else
      null()
    end_if
      
 
   ]
end_proc:
    
