// $Id: _power.mu,v 1.15 2004/08/17 09:43:45 stefanw Exp $

// 06/2003, bij, stefanw
//
// simplification methods for expressions of type '_power'


Simplify::_power :=
proc(expression: "_power"): DOM_LIST
  local bas, expo;
begin
  assert(nops(expression) = 2);
  [bas, expo]:= [op(expression)];
  
  if bas = 0 then
    return([Rule(Simplify::zeroPower)])
  end_if;

  if bas = - 1 then
    return([Rule(Simplify::minus1Power)])
  end_if;
  
  [
   //Rule(radsimp),                             // 1 Test in Old.tst, uerst langsam!!


   case type(bas)
     of DOM_COMPLEX do
       Rule(Simplify::IToMinus1);
       break
     of DOM_INT do
       Rule(Simplify::intBase, {}, table("Default" = 0.8));
       break
     of "exp" do
       Rule(combine::exp);
       break
     of "sign" do
       Rule(Simplify::signToAbsInPower);
       break
     otherwise  
       null()
   end_case,


   
   

   case type(expo)
     of DOM_INT do
       case type(bas)
         of "sin" do
           // special case 1/sin^2 = 1 + cot^2
           if expo = -2 then
             Rule(X -> 1 + cot(op(X, [1, 1]))^2)
           else
             null()
           end_if,
            // do a local rewrite:
            // rewrite sin(X)^(2*n) as (1-cos(X)^2)^n
            // and     sin(X)^(2*n+1) as sin(X) * (1-cos(X)^2)^n
           Rule(X -> op(X, 1)^(op(X,2) mod 2) *
           (1 - cos(op(X, [1, 1]))^2)^(op(X,2) div 2));
           break
         of "cos" do
           // special case 1/cos^2 = 1 + tan^2
           if expo = -2 then
             Rule(X -> 1 + tan(op(X, [1, 1]))^2)
           else
             null()
           end_if,
           Rule(X -> op(X, 1)^(op(X,2) mod 2) *
              (1 - sin(op(X, [1, 1]))^2)^(op(X,2) div 2));
           break
         otherwise
           null()
       end_case;
       break

     of DOM_RAT do
       if domtype(bas) = DOM_RAT then
         Rule(Simplify::ratRatPower)
       else
         Rule(Simplify::ratExponent)
       end_if;
       break
     otherwise
       // will only help if the exponent has the property Type::Even
       // done by the kernel if the exponent is a DOM_INT
       Rule(Simplify::normalizesignBase, {}, table("Default" = 1.05))
   end_case,


   if type(expo) = "log" then
     Rule(Simplify::expPowLog)
   else
     null()
   end_if,
   
   Rule(Simplify::distributeExponent), 

   if domtype(bas) <> DOM_INT and domtype(bas) <> DOM_RAT then
     Rule(Simplify::extractContentFromBase)
   else
     null()
   end_if,
  
   Rule(Simplify::radsimpMatchSqrt)
  


   
   
   //Rule(X -> rewrite(X, exp)),
   //Rule(proc(X)
   //       local fac;
   //     begin
   //       if domtype(op(X, 1)) = DOM_INT then
   //         fac := ifactor(op(X, 1));
   //         (op(fac, 1)*op(fac, 2))^(op(fac, 3)*op(X, 2))
   //       else
   //         FAIL
   //       end_if
   //     end_proc),

   ]
 

end_proc:
