// $Date: 2003/01/06 16:13:27 $ $Author: stefanw $ $Revision: 1.4 $


// solvelib::ignoreSpecialCases

/* filters the input to a piecewise such
   that all equalities are considered FALSE unless they
   are provably TRUE */

solvelib::ignoreSpecialCases:=
proc()
  option hold;
  local argv, argv1, removeEquals, u;
  
begin
  removeEquals:=
  proc(cond)
  begin
    case type(cond)
      of "_equal" do
        if is(cond)=TRUE then
          TRUE
        else  
          FALSE
        end_if;
        break
      of "_unequal" do
        if is(cond)=FALSE then
          FALSE
        else
          TRUE
        end_if;
        break
      of "_in" do
        if type(op(cond, 2)) = DOM_SET then
          return(FALSE)
        elif type(op(cond, 2)) = "_minus" and
          op(cond, [2, 1]) = C_ and
          type(op(cond, [2, 2])) = DOM_SET then
          return(TRUE)
        else
          return(cond)
        end_if;
      of "_or" do
      of "_and" do
      of "_not" do  
        map(cond, removeEquals);
        break
      otherwise
        cond
    end_case;
  end_proc;

     // flatten first ? Not necessary if solver does not pass exprseqs 

  argv1:= context(hold(val)([args()]));
  
  argv:=[];
  for u in argv1 do
    if type(u)<>DOM_LIST then
      error("Argument is not a list")
    end_if;
    removeEquals(context(u[1]));
    case %
      of TRUE do
        return(context(u[2]))
      of FALSE do
        break
      otherwise  
        argv:=append(argv, [%, context(u[2])])
    end_case
  end_for;
  piecewise(op(argv))
end_proc:
  
