// $Date: 2002/11/21 13:35:06 $ $Author: ccr $ $Revision: 1.24 $ 

// kg, 13/01/94 

/*++
arccosh -- the inverse hyperbolic cosine

arccosh(x)

x - expression
++*/

arccosh:= proc(x)
  option noDebug;
  name arccosh;
  local k;
begin
  if args(0) = 0 then error("no arguments given")
  elif x::dom::arccosh <> FAIL then return(x::dom::arccosh(args()))
  elif args(0) <> 1 then error("wrong no of args") 
  end_if;

  case type(x)
  of DOM_SET do
  of "_union" do
      return(map(x,arccosh));

    of DOM_FLOAT do
	return(arccosh::float(x));

    of DOM_COMPLEX do
	if domtype(op(x,1)) = DOM_FLOAT or
	   domtype(op(x,2)) = DOM_FLOAT then
	    return(arccosh::float(x))
	end_if;
  end_case;

  if not testtype(x,Type::Arithmetical) then
      error("argument must be of 'Type::Arithmetical'")
  end_if;

  case type(x)
    of "cosh" do // arccosh(cosh(x))=x when 0 <= Im x <= PI 
        k:=round(-Im(op(x))/2/PI);
        return((if type(k)=DOM_INT then
           k:=op(x)+2*k*PI*I;
           if sign(Im(k))=-1 then -k else k end_if;
        else procname(x) end_if))

  end_case;

  procname(x)
end_proc:

arccosh(1):= 0:
arccosh(0):=1/2*I*PI:

arccosh:= funcenv(arccosh, op(specfunc::arccosh, 2)):
arccosh::print := "arccosh":
arccosh::info := "arccosh -- the inverse hyperbolic cosine":
arccosh::type := "arccosh":
arccosh::float := specfunc::arccosh:
// potential library fix for PARI's arccosh:
//proc(x) begin
//      x:= float(x):
//      ln(x + sqrt(x^2-1))
// end_proc):

arccosh::hull := DOM_INTERVAL::arccosh@hull:

// Folgendes complexDiscont ist richtig!  Fehler in  Abramowitz/Stegun!
arccosh::complexDiscont :=
    loadproc(arccosh::complexDiscont, pathname("STDLIB","DISCONT"), "arccosh"):
arccosh::realDiscont := {}:
arccosh::undefined := {}:

arccosh::inverse := "cosh":

arccosh::diff :=
  proc(f)
    local op1;
  begin 
    op1 := op(f, 1);
    diff(op1, args(2..args(0))) / sqrt(op1^2-1)
  end_proc:

arccosh::series := loadproc(arccosh::series, pathname("SERIES"), "arccosh"):

arccosh::Content := (Out, data) -> Out::Capply(Out::Carccosh, Out(op(data))):

// end of file 
