// $Id: acsc.mu,v 1.12 2002/04/02 07:43:29 tonner Exp $

arccsc := proc(x)
    option noDebug;
    // arccsc(x) = arcsin(1/x) 
begin
  if args(0) = 0 then error("no arguments given")
  elif x::dom::arccsc <> FAIL then return(x::dom::arccsc(args()))
  elif args(0) <> 1 then error("1 argument expected")
  end_if;

  // handle sets
  case type(x)
    of DOM_SET do
    of "_union" do
      return(map(x, arccsc))
  end_case;
  if not testtype(x,Type::Arithmetical) then
      error("argument must be of 'Type::Arithmetical'")
  elif iszero(x) then
    error("singularity")
  else
    arcsin(1/x)
  end_if
end_proc:

arccsc:= funcenv(arccsc):
arccsc::type := "arccsc":
arccsc::print := "arccsc":
arccsc::info := "arccsc -- the inverse cosecant":

arccsc::inverse := "csc":

arccsc::hull := DOM_INTERVAL::arccsc@hull:

arccsc::Content := (Out, data) -> Out::Capply(Out::Carccsc, Out(op(data))):

// end of file 
