// $Id: csc.mu,v 1.13 2002/04/02 07:43:29 tonner Exp $

csc :=
proc(x)
  option noDebug;
  // csc(x) = 1/sin(x) 
begin
  if args(0) = 0 then
    error("no arguments given")
  elif x::dom::csc <> FAIL then
    return(x::dom::csc(args()))
  elif args(0) <> 1 then
    error("1 argument expected")
  end_if;

  case type(x)
    of DOM_SET do
    of "_union" do
      return(map(x, csc))
  end_case;
  
  if not testtype(x,Type::Arithmetical) then
    error("argument must be of 'Type::Arithmetical'")
  end_if;

  x:= sin(x);
  if iszero(x) then
    error("singularity")
  else
    1/x
  end_if
end_proc:

csc := funcenv(csc):
csc::type := "csc":
csc::print := "csc":
csc::info := "csc -- the cosecant":

csc::hull := DOM_INTERVAL::csc@hull:

csc::inverse := "arccsc":

csc::expand := x -> expand(1/sin(x)):

csc::conjugate :=
   loadproc(csc::conjugate, pathname("STDLIB","CONJ"),"csc"):

csc::Content := (Out, data) -> Out::Capply(Out::Ccsc, Out(op(data))):

// end of file 
