/*++
fact -- factorial function

fact(n)

n - expression
++*/

fact:=
proc(x)
begin
  if args(0) = 0 then
    error("no arguments given")
  elif x::dom::fact <> FAIL then
    x::dom::fact(args())
  elif args(0) <> 1 then
    error("expecting one argument")
  end_if;

  case type(x)
    of DOM_SET do
    of "_union" do
      return(map(x, fact))
  end_case;
  
  if not testtype(x,Type::Arithmetical) then
    error("argument must be of 'Type::Arithmetical'")
  else
    specfunc::fact(args())
  end_if
end_proc:

fact:= funcenv(fact, builtin(1099, 1300, "!", "fact")):
fact::print := "fact":
fact::info  := "fact -- the factorial function":
fact::type  := "fact":

fact::expand:= loadproc(fact::expand, pathname("STDLIB","EXPAND"), "fact"):

fact::series:= x -> gamma::series(x+1,args(2..args(0))):

fact::rectform:= n -> new(rectform, fact(n), 0, 0):

fact(FAIL)  := FAIL:

fact::Content:= (Out, data) -> Out::Capply(Out::Cfactorial, Out(op(data))):

fact::TeX := (f, ex, prio) -> generate::TeXquote(generate::tex(op(ex), output::Priority::Fact)."! ",
                                                 prio, output::Priority::Fact):

// end of file 
