/*++
fact2 -- double factorial function

fact2(n)

n - expression
++*/

fact2:=
proc(x)
  local i;
begin
  if args(0) = 0 then
    error("no arguments given")
  elif x::dom::fact2 <> FAIL then
    x::dom::fact2(args())
  elif args(0) <> 1 then
    error("expecting one argument")
  end_if;

  case type(x)
    of DOM_SET do
    of "_union" do
      return(map(x, fact2))
  end_case;
  
  if not testtype(x,Type::Arithmetical) then
    error("argument must be of 'Type::Arithmetical'")
  end_if;

  if not testtype(x, Type::Numeric) then
    return(procname(x))
  end_if;

  if domtype(x) <> DOM_INT or x < -1 then
    error("Integer >= -1 expected")
  end_if;

  case modp(x, 2)
    of 0 do
      _mult(2*i $i=1..x div 2);
      break
    of 1 do
      _mult(2*i+1 $i=1..x div 2);
      break
  end_case  
    
end_proc:

fact2:= funcenv(fact2, builtin(1099, 1300, "!!", "fact2")):
fact2::print := "fact2":
fact2::info  := "fact2 -- the double factorial function":
fact2::type  := "fact2":

// fact2::expand : missing


fact2(FAIL)  := FAIL:

// fact2::Content : still missing !

fact2::TeX := (f, ex, prio) -> generate::TeXquote(generate::tex(op(ex),
                                                                output::Priority::Fact)."!! ",
                                                  prio, output::Priority::Fact):

// end of file 
