// $Id: trunc.mu,v 1.10 2002/11/20 09:20:23 tonner Exp $
// PARI's trunc is ok, but we still need an interface function
// to handle sets ;-(

trunc := proc(a)
  option noDebug;
  save DIGITS;
begin
  if args(0) <> 1 then
    error("one argument expected")
  elif a::dom::trunc <> FAIL then
    return(a::dom::trunc(args()))
  end_if;

  case type(a)
    of DOM_INT do return(a);
    of DOM_RAT do
    of DOM_FLOAT do
    of DOM_COMPLEX do
       return(specfunc::trunc(a));
    of DOM_SET do
    of "_union" do
       return(map(a, trunc))
  end_case;
  
  if not testtype(a,Type::Arithmetical) then
     error("argument must be of 'Type::Arithmetical'")
  end_if;

  specfunc::trunc(a):
end_proc:

trunc:= funcenv(trunc):
trunc::type:= "trunc":

trunc::float:= specfunc::trunc:

trunc::hull:= hull@DOM_INTERVAL::trunc@hull:

trunc::undefined:= {}:
trunc::realDiscont:=
    loadproc(trunc::realDiscont, pathname("STDLIB", "DISCONT"), "trunc"):

trunc::series:=
	loadproc(trunc::series, pathname("SERIES"), "trunc"):

