// $Id: subset.mu,v 1.9 2002/08/12 10:39:55 ccr Exp $

// The operator subset and its negation

_subset := funcenv
(proc(A, B)
   name _subset;
 begin
   if A::dom::_subset <> FAIL then
     return(A::dom::_subset(A, B));
   elif B::dom::_subset <> FAIL then
     return(B::dom::_subset(A, B));
   elif A::dom = DOM_SET and B::dom = DOM_SET then
     return(bool(A minus B = {}));
   else
     procname(args());
   end_if
 end_proc,
 builtin(1100, output::Priority::Relation, " subset ", "_subset")):

_subset::TeX :=
(arg1, arg2, arg3) -> (generate::TeXoperator(" \\subset ", arg3,
                                             output::Priority::Relation, op(arg2))):

_subset::Content := (Out, data) ->
                     Out::Capply(Out::Csubset, map(op(data), Out)):
_subset::_not := () -> _notsubset(args()):
_subset::type := "_subset":
_subset::print := "_subset":

// _prsubset := funcenv
// (proc(A, B)
//    name _prsubset;
//    local sub;
//  begin
//    if A::dom::_prsubset <> FAIL then
//      return(A::dom::_prsubset(A, B));
//    elif B::dom::_prsubset <> FAIL then
//      return(B::dom::_prsubset(A, B));
//    elif A = B then
//      return(FALSE);
//    else
//      sub := _subset(A, B);
//      if sub::dom = DOM_BOOL then
//        return(sub);
//      else
//        procname(args());
//      end_if
//    end_if
//  end_proc,
//  builtin(1100, output::Priority::Relation, " prsubset ", "_prsubset")):
// 
// _prsubset::TeX :=
// (arg1, arg2, arg3) -> (generate::TeXoperator(" \\subsetneq ", arg3,
//                                              output::Priority::Relation, op(arg2))):
// 
// _prsubset::Content := (Out, data) ->
//                      Out::Capply(Out::Cprsubset, map(op(data), Out)):
// _prsubset::_not := () -> _notprsubset(args()):
// _prsubset::type := "_prsubset":
// _prsubset::print := "_prsubset":

_notsubset := funcenv
(proc(A, B)
   name _notsubset;
   local sub;
 begin
   sub := _subset(A, B);
   if sub::dom = DOM_BOOL then
     return(not sub);
   else
     procname(args());
   end_if
 end_proc,
 ex -> hold(_not)(hold(_subset)(op(ex)))):

_notsubset::TeX :=
(arg1, arg2, arg3) -> (generate::TeXoperator(" \\not\\subset ", arg3,
                                             output::Priority::Relation, op(arg2))):

_notsubset::Content := (Out, data) ->
                       Out::Capply(Out::Cnotsubset, map(op(data), Out)):
_notsubset::_not := () -> _subset(args()):
_notsubset::type := "_notsubset":
_notsubset::print := "_notsubset":

// _notprsubset := funcenv
// (proc(A, B)
//    name _notprsubset;
//    local sub;
//  begin
//    sub := _prsubset(A, B);
//    if sub::dom = DOM_BOOL then
//      return(not sub);
//    else
//      procname(args());
//    end_if
//  end_proc,
//  ex -> hold(_not)(hold(_prsubset)(op(ex)))):
// 
// _notprsubset::TeX :=
// (arg1, arg2, arg3) -> (generate::TeXoperator(" \\not\\subsetneq ", arg3,
//                                              output::Priority::Relation, op(arg2))):
// 
// _notprsubset::Content := (Out, data) ->
//                          Out::Capply(Out::Cnotprsubset, map(op(data), Out)):
// _notprsubset::_not := () -> _prsubset(args()):
// _notprsubset::type := "_notprsubset":
// _notprsubset::print := "_notprsubset":

null():
