// $Id: random.mu,v 1.5 2003/08/01 07:25:51 bij Exp $

// bij
// creates a random  string
// stringlib::random(<LENGTH>, <CHARACTERS>, <Prefix = "">, <Suffix = "">)

alias(allOptions = {hold(Prefix), hold(Suffix), hold(Name), hold(Exclude)}):

stringlib::random:=
  proc(LENGTH = 7)
    local CHARS, OPT, RAND, PR, SU, check;
  begin
    OPT:= prog::getOptions(allOptions);
    // default value;
    CHARS:= (stringlib::lowerLetters.stringlib::upperLetters.stringlib::digits $ 4)
            .stringlib::punctuation;
    OPT[hold(Length)]:= TRUE;
    OPT[hold(Add)]:= 0;
    if contains({DOM_LIST, DOM_SET}, type(LENGTH)) then
      // list or set of characters
      CHARS:= LENGTH;
      LENGTH:= 7;
    elif type(LENGTH) = DOM_INT or type(LENGTH) = "_range" then
      delete OPT[hold(Length)]; // length explicit set
      if type(LENGTH) = "_range" then
        OPT[hold(Add)]:= op(LENGTH, 2);
        LENGTH:= op(LENGTH, 1) + random(-_subtract(op(LENGTH)) + 1)();
        OPT[hold(Add)]:= OPT[hold(Add)] - LENGTH // difference to maximum length
      end_if;
      if args(0) > 1 and contains({DOM_LIST, DOM_SET}, type(args(2))) then
        CHARS:= args(2)
      end_if
    else
      LENGTH:= 7 // default
    end_if;
    if contains(OPT, hold(Exclude)) then
      SU := OPT[hold(Exclude)];
      if domtype(SU) = DOM_SET or domtype(SU) = DOM_LIST then
        CHARS := select(CHARS, X -> not has(SU, X));
        if CHARS = [] then
          error("no characters left after exclusion")
        end_if
      else
        error("wrong value for option 'Exclude'")
      end_if
    end_if;

    if contains(OPT, hold(Prefix)) then
      // convert to a string
      PR:= prog::getname(OPT[hold(Prefix)]);
    else
      PR:= ""
    end_if;
    if contains(OPT, hold(Suffix)) then
      // convert to a string
      SU:= prog::getname(OPT[hold(Suffix)]);
    else
      SU:= ""
    end_if;

    if LENGTH <= length(PR) then
      if OPT[hold(Add)] + LENGTH > length(PR) then
        [OPT[hold(Add)], LENGTH]:= [OPT[hold(Add)] - (length(PR) + 1 - LENGTH), length(PR) + 1]
      elif contains(OPT, hold(Length)) then //default length
        LENGTH:= length(PR) + 2 // two free characters
      else
        error("Prefix too long or length too small")
      end_if
    end_if;
    if LENGTH <= length(SU) then
      if OPT[hold(Add)] + LENGTH > length(SU) then
        [OPT[hold(Add)], LENGTH]:= [OPT[hold(Add)] - (length(SU) + 1 - LENGTH), length(SU) + 1]
      elif contains(OPT, hold(Length)) then //default length
        LENGTH:= length(PR) + length(SU) + 2 // two free characters
      else
        error("Suffix too long or length too small")
      end_if
    end_if;
    if LENGTH <= length(PR) + length(SU) then
      if OPT[hold(Add)] + LENGTH > length(PR) + length(SU) then
        LENGTH:= random(OPT[hold(Add)] + LENGTH - length(PR) - length(SU))() + 1
      else
        error("Prefix.Suffix too long or length too small")
      end_if
    else
      LENGTH:= LENGTH - length(PR) - length(SU)
    end_if;

    if contains(OPT, hold(Name)) then
      check:= proc(STR, CHR) // check whether STR contains only characters of CHR
                local k;
                name stringlib::random::check;
              begin
                for k from 1 to length(STR) do
                  if contains(CHR, substring(STR, k)) = 0 then
                    return(FALSE)
                  end_if
                end_for;
                TRUE
              end_proc;
      
      // valid prefix?
      if contains(OPT, hold(Prefix)) then
        if check(PR[1], stringlib::lowerLetters.stringlib::upperLetters.["_"])
           and (length(PR) = 1
                or check(PR[2..-1],
                         stringlib::lowerLetters.stringlib::upperLetters.["_"].stringlib::digits)) then
        else
          error("wrong prefix for names")
        end_if
      else // generate prefix
        PR:= op(stringlib::lowerLetters.stringlib::upperLetters.["_"],
                random(nops(stringlib::lowerLetters.stringlib::upperLetters.["_"]))() + 1)
      end_if;
      // valid suffix?
      if contains(OPT, hold(Suffix)) then
        if check(SU, stringlib::lowerLetters.stringlib::upperLetters.["_"].stringlib::digits) then
        else
          error("wrong suffix for names")
        end_if
      end_if;
      // valid characters?
      if contains(OPT, hold(Chars)) then
        if check(_concat(op(CHARS)),
                 stringlib::lowerLetters.stringlib::upperLetters.["_"].stringlib::digits) then
        else
          error("wrong characters for names")
        end_if
      else
        CHARS:= stringlib::lowerLetters.stringlib::upperLetters.["_"].stringlib::digits
      end_if;
    end_if;

    RAND:= random(nops(CHARS));
    PR._concat(op(CHARS, RAND() + 1) $ OPT = 1..LENGTH).SU
    
  end_proc: