// $Id: readText.mu,v 1.3 2003/09/23 09:03:28 bij Exp $

// bij, 05/2003
//
// readText(FILE, <List,> <String, <NoNL, Separator = STRING>>)
// 
// read in a whole file with name FILE or file-descriptor FILE
// return a list of strings, one string per line, newlines are chopped
//
// List   [default]
//                 return a list of strings, each string per line, newlines are chopped
// String
//                 return a single string, newlines are kept
// NoNL
//                 return a single string without newlines
// Separator = STRING
//                 return a single string with STRING instead of newlines

stringlib::readText :=
  proc(file)
    local FILE, OPT, LINE, RET;
  begin
    FILE := prog::checkFile(file);
    OPT := prog::getOptions([hold(List), hold(String), hold(NoNL), hold(Separator)],
                            table(hold(List) = DOM_BOOL, hold(String) = DOM_BOOL,
                                  hold(NoNL) = DOM_BOOL, hold(Separator) = DOM_STRING),
                            1); // skip first parameter

    RET := [];

    // collect lines, while available
    file := traperror((while (LINE := ftextinput(FILE)) <> null() do
                    RET := append(RET, LINE)
                  end_while));
      
    prog::checkFile(FILE, hold(Close)); // close the opened file
    if file <> 0 then
      userinfo(1, "non text file closed");
      error("cannot open file or file is no text file")
    end_if;

    if contains(OPT, hold(String)) then
      if contains(OPT, hold(NoNL)) then
        return(_concat(op(RET)))
      else
        return(op(_concat(op(map(RET[1..-2], _concat,
                                 (if contains(OPT, hold(Separator)) then
                                    OPT[hold(Separator)]
                                  else
                                    "\n"
                                  end_if)
                                 )))) . RET[-1])
      end_if
    else
      // list of lines
      return(RET)
    end_if
  end_proc:
