/*-

stringlib::subsop -- substitutes substrings

Calling sequence:

stringlib::subsop(s, a=r)
stringlib::subsop(s, a..b=r)

Parameter:

s, r  - strings
a, b  - non-negative integers

Examples:

>> stringlib::subsop("abcdef", 3 = "XX");

                                 "abcXXef"


>> stringlib::subsop("abcdef", 3 = "");
 
                                  "abcef"

>> stringlib::subsop("abcdef", 2..4 = "X");

                                  "abXf"

-*/

stringlib::subsop :=
proc(s, eqn)
  local l, r;
begin
  
  l := op(eqn, 1);
  r := op(eqn, 2);
  
  if testargs() then
    if type(s) <> DOM_STRING then
      error("String expected");
    end_if;
    if type(eqn) <> "_equal" then
      error("equation expected");
    end_if;
  end_if;

  if type(l) = "_range" then
    s[l] := r;
  else
    s[l..l] := r;
  end_if;
  s;
end_proc:
