// $Date: 2004/10/04 08:17:34 $  $Author: bij $   $Revision: 1.18 $

student::plotRiemann :=
  proc(f, range = -5..5, N = 10)
    local OPTS, ret, k, knownMethods, methods;
  begin
    if args(0) = 0 then error("function expected as first argument") end_if;
    if f::dom::plotRiemann <> FAIL then return(f::dom::plotRiemann(args())) end_if;

    // obtain options
    OPTS := prog::getOptions(table(hold(Middle) = FALSE,
                                   hold(Left)   = FALSE,
                                   hold(Right)  = FALSE,
                                   hold(Lower)  = FALSE,
                                   hold(Upper)  = FALSE,
                                   hold(Color) = [plot::getDefault(plot::Integral::FillColor),
                                                  RGB::LightYellow,
                                                  RGB::Rose,
                                                  RGB::Plum,
                                                  RGB::LimeGreen]),
                             table(), 1);
    
    if not has(select(OPTS, has, TRUE), {hold(Middle), hold(Left), hold(Right),
                                         hold(Lower), hold(Upper)}) then
      // no methods given -> default
      OPTS[hold(Upper)] := TRUE;
      OPTS[hold(Lower)] := TRUE
    end_if;
    
    knownMethods := {Middle, Left, Right, Upper, Lower};

    // all given methods in reverse order
    methods := select([args()], X -> contains(knownMethods, X));

    if methods = [] then
      methods := [Lower, Upper]
    end_if;

    // one color ginve
    if testtype(OPTS[Color], Type::ListOf(Type::Real, 3)) then
      OPTS[Color] := [OPTS[Color]]
    end_if;
    // more colors need
    if nops(methods) > nops(OPTS[Color]) then
      OPTS[Color] := _concat(OPTS[Color] $ (nops(methods) div nops(OPTS[Color])) + 1)
    end_if;
    
    // f - function
    if testtype(range, Type::Equation(DOM_IDENT, "_range")) then
      f := plot::Function2d(f, range);
      if testtype(N, Type::PosInt) or testtype(N, Type::ListOf(Type::Real)) then
        // ok
      else
        // default
        N := 10
      end_if;
    else // default
      f := plot::Function2d(f);
      // second argument is N?
      if testtype(range, Type::PosInt) or testtype(range, Type::ListOf(Type::Real)) then
        N := range
      else
        // default value
        N := 10
      end_if
    end_if;

    ret := null();
    // several methods can be given
    for k from 1 to nops(methods) do
      ret := ret, 
             plot::Integral(f, hold(Nodes) = N,
                               hold(IntMethod) = text2expr("Riemann".expr2text(methods[k])),
                               hold(ShowInfo) = [hold(IntMethod), ("" $ k-1), hold(Integral)],
                               _if(k > 1 or OPTS[Color][1] <> plot::getDefault(plot::Integral::FillColor),
                                   Color = OPTS[Color][k], null()))
    end_for;

    return(op(revert([f, ret])))
    
end_proc:
