// $Date: 2004/10/04 08:11:12 $  $Author: bij $   $Revision: 1.13 $

student::plotSimpson :=
  proc(f, range = -5..5, N = 4)
  begin
    if args(0) = 0 then error("function expected as first argument") end_if;
    if f::dom::plotSimpson <> FAIL then return(f::dom::plotSimpson(args())) end_if;

    // f - function
    if testtype(range, Type::Equation(DOM_IDENT, "_range")) then
      f := plot::Function2d(f, range);
      if testtype(N, Type::PosInt) or testtype(N, Type::ListOf(Type::Real)) then
        // ok
      else
        // default
        N := 4
      end_if;
    else // default
      f := plot::Function2d(f);
      // second argument is N?
      if testtype(range, Type::PosInt) or testtype(range, Type::ListOf(Type::Real)) then
        N := range
      else
        // default value
        N := 4
      end_if
    end_if;

    // 
    plot::Integral(f, hold(Nodes) = N, hold(IntMethod) = hold(Simpson)),
    f
    
end_proc:

// old implementation
///student::plotSimpson := proc(f, range, N = 10)
///    local z, fterm, i, a, b, x, y, parabs, extraopts, numerical,
///	  hatchargs, lineargs, textargs, functionargs, anim;
///    option escape;
///begin
///    if args(0) < 2 then error("expecting at least two arguments") end_if;
///    if f::dom::plotSimpson <> FAIL then return( f::dom::plotSimpson(args()) ) end_if;
///
///    if testargs() then
///      if not testtype(range, Type::Equation(DOM_IDENT, "_range"))
///	 or domtype(float(op(range,[2,1]))) <> DOM_FLOAT or domtype(float(op(range,[2,2]))) <> DOM_FLOAT
///	then
///	error("2nd argument: illegal range definition ('x = xmin..xmax' expected)")
///      elif not testtype(f, Type::Arithmetical) then
///	error("1st argument: arithmetical expression or procedure expected")
///      end_if
///    end_if;
///  
///  extraopts := args(4..args(0));
///  
///  if domtype(N) <> DOM_INT and domtype(N) <> DOM_LIST then
///    extraopts := N, extraopts;
///    N := 10;
///  end_if;
///  
///  fterm := f;
///  if domtype(f) <> DOM_PROC then
///    z := op(range, 1);
///    f := fp::unapply(f, z);
///  end_if;
///  
///  a := op(range, [2,1]);
///  b := op(range, [2,2]);
///  
///  if domtype(N) = DOM_LIST then
///    N := sort(float(N));
///    x := table(0 = a,
///	       (i = N[i])$i=1..nops(N),
///	       nops(N)+1=b);
///    N := nops(x)-1;
///  else
///    x:= table((i = a + i*(b-a)/N) $ i=0..N);
///  end_if;
///  y := table((x[i]=f(x[i]))$i=0..N,
///	     ((x[i]+x[i+1])/2 = f((x[i]+x[i+1])/2))$i=0..N-1);
///  
///  
///  extraopts := map(extraopts,
///		   x -> if contains(plot::attributes, x) then
///			  x = TRUE;
///			else
///			  x;
///			end_if);
///  
///  if {extraopts} <> {} and map({extraopts}, type) <> {"_equal"} then
///    error("unknown option(s) ".expr2text(op(select({extraopts},
///						   x -> type(x) <> "_equal"))));
///  end_if;
///
///  extraopts := table(extraopts);
///  anim := select([op(extraopts)], 
///		 x -> (not contains(plot::attributes, lhs(x)) and
///		       not testtype(lhs(x), plot::StyleSheetEntry)));
///  
///  if nops(anim) > 1 then
///    error("unknown options ". expr2text(op(anim)));
///  end_if;
///  
///  anim := op(anim);
///  
///  hatchargs := plot::MuPlotML::fixAttributes(extraopts,
///					     plot::Hatch);
///  if contains(extraopts, Filled) and
///     not contains(hatchargs, Visible) then
///    hatchargs[Visible] := extraopts[Filled];
///  end_if;
///  
///  hatchargs := op(hatchargs);
///  
///  lineargs := op(plot::MuPlotML::fixAttributes(extraopts,
///					       plot::Line2d));
///  textargs := op(plot::MuPlotML::fixAttributes(extraopts,
///					       plot::Text2d));
///  
///  functionargs := op(plot::MuPlotML::fixAttributes(extraopts,
///						   plot::Function2d));
///  
///  parabs := [plot::Function2d(1/(x[i + 1] - x[i])^2*
///			      (2*`#t`^2*y[x[i + 1]] + y[x[i + 1]]*x[i]^2 +
///			       y[x[i]]*x[i + 1]^2 + 2*`#t`^2*y[x[i]] - 
///			       4*`#t`^2*y[(x[i + 1] + x[i])/2] + 
///			       y[x[i + 1]]*x[i + 1]*x[i] - 3*`#t`*y[x[i + 1]]*x[i] - 
///			       3*`#t`*y[x[i]]*x[i + 1] + 
///			       4*`#t`*y[(x[i + 1] + x[i])/2]*x[i + 1] + 
///			       y[x[i]]*x[i + 1]*x[i] - `#t`*y[x[i + 1]]*x[i + 1] -
///			       `#t`*y[x[i]]*x[i] - 
///			       4*y[(x[i + 1] + x[i])/2]*x[i + 1]*x[i] + 
///			       4*`#t`*y[(x[i + 1] + x[i])/2]*x[i]),
///			      `#t`=x[i]..x[i+1],
///			      Name = expr2text(x[i]..x[i+1]),
///			      functionargs, anim)$i=0..N-1];
///  
///  // sub-optimal, just a lazy programmer ...
///  numerical := _plus(numeric::int(i::Function, i::XName=i::XRange) 
///		     $ i in parabs);
///  
///  plot::Group2d(plot::Group2d(op(map(parabs,
///				     p -> 
///				     plot::Group2d(p,
///						   plot::Hatch(p, hatchargs, anim),
///						   plot::Line2d([p::XMin, 0], 
///								[p::XMin, y[p::XMin]],
///								lineargs, anim),
///						   plot::Line2d([p::XMax, 0], 
///								[p::XMax, y[p::XMax]],
///								lineargs, anim))))),
///		plot::Text2d(subs(()->("simpson: ".
///				       stringlib::formatf(float(`#numerical`), 3).
///				       "\nreal:".
///				       stringlib::formatf(numeric::int(`#f#x`,
///								       `#x`=`#a`..`#b`), 3)),
///				  [`#numerical` = numerical,
///				   `#f#x` = f(`#x`),
///				   `#a` = a, `#b` = b]),
///			     [a, max(op(map([op(y)], op, 2)))],
///			     HorizontalAlignment = Left,
///			     textargs, anim),
///		plot::Function2d(fterm, range, functionargs, anim));
///  
///end_proc:
///
