// Dirk Mueller, olorien, 28/10/96, v1.0 

besselJ::laplace:=
  proc(_f, var1, var2) 
    local _c, _d, _a2;
  begin
    _c:=op(_f,1); _a2:=op(_f,2);
//    if testtype(_c,Type::Numeric) and (not testtype(_c, DOM_COMPLEX)) then
//  -------------------------------- Stephan Huckemann, April 2002:
//  cf. "Laplace Transforms by Oberhettinger, 14.1
//  Laplace(besselJ(c, d*t), t, s) = d^(-c) (d^2 + s^2)^(-1/2) 
//						((d^2 + s^2)^(1/2) - s)^c
//  when Re(c) > - 1 for s such that Re(s) > abs(Im(d))
//  	indeed the root can be continously defined in a simply connected 
//	domain where d^2 <> - s^2. Moreover since 
//	besselJ(c,t) = (t/2)^c + O(t^c), the laplace transform is infinite
//	whenever Re(c) <= -1
   if (testtype(_c,Type::Numeric) and (Re(_c) > -1))
	or // symbolic case and assumption
	(not testtype(_c,Type::Numeric) and (is(Re(_c) > -1)= TRUE))
	then
      _d:=_a2/var1;
      if (not has(_d, var1)) then
        return( ( sqrt(var2^2+_d^2)-var2 )^_c/( sqrt(var2^2+_d^2)*_d^_c ) );
      end_if;
    end_if;
    
    FAIL;
  end_proc:

// end of file 
