#ifdef __cplusplus
extern "C" {
#endif


/* file def.h SYMMETRICA */
/* INT should always be 4 byte */
#ifndef DEF_H


#ifdef __alpha
typedef  int  INT;
typedef unsigned  int  UINT;
#else /* __alpha */
typedef long INT;
typedef unsigned long UINT;
#endif /* __alpha */

typedef short SHORT;

#include <stdio.h>

/* Patch by Nicolas Thiry <nthiery@users.sf.net> for compatibility
   with Darwin */
#include "config.h"
#if !STDC_HEADERS && HAVE_MALLOC_H
#  include <malloc.h>
#endif
/* End of patch */

#include <memory.h>

#ifndef TITELTEXT
#define TITELTEXT " Mon Jan 17 12:42:45 1994 "
#endif


# define	NO_REDUCE		(INT)0		/*	TPMcD	*/
# define	POWER_REDUCE	(INT)1		/*	TPMcD	*/
# define	STD_BASIS		(INT)2		/*	TPMcD	*/


#ifdef ULTRIX
#define unix
  /* #include <malloc.h> */
#endif /* ULTRIX */

#undef TRUE
#undef FALSE
#define REPORT (INT)3
#define TRUE (INT)1
#define FALSE (INT)0

#define OK (INT)0
#define ERROR (INT)-1
#define ERROR_RETRY (INT)-5 /* AK 020294 */
#define ERROR_EXPLAIN (INT)-6 /* AK 250195 */

/* exit values of symmetrica, parameters to exit */
#define ERROR_BACKGROUND (int) 101 /* AK 210297 */ /* error called while in background mode */
#define ERROR_TIMELIMIT (int) 100 /* AK 210297 */ /* time limit */

#define I2PE (INT)1502960 /* 2 equal parameter */
  //#define  not !
#define IMPROPER (INT)1001 /* MD */
#define NONCOMPARABLE (INT)10

#define FIRSTVARINDEX (INT)11125
#define VARTYP (INT)11124
#define LETTERS (INT)11122
#define NUMERICAL (INT)11223

#define EQUAL (INT)300792 /* return value of check_equal_ */
#define NORESULT (INT)20996 /* return value of check_result_ */
#define FREE (char)1
#define NOFREE (char)0

#define comp SYM_AK_comp
#define div SYM_AK_div
#define t_SQRAD_CYCLO convert_sqrad_cyclo


/* definitionen fuer object.c */
typedef long OBJECTKIND;  /* long statt char AK 290692 */
typedef union {
	INT ob_INT;
	INT * ob_INTpointer;
	char *ob_charpointer;
	struct bruch *ob_bruch;
	struct graph *ob_graph;
	struct list *ob_list;
	struct longint *ob_longint;
	struct matrix *ob_matrix;
	struct monom *ob_monom;
	struct number *ob_number; /* MD */
	struct partition *ob_partition;
	struct permutation *ob_permutation;
	struct reihe *ob_reihe;
	struct skewpartition *ob_skewpartition;
	struct symchar *ob_symchar;
	struct tableaux *ob_tableaux;
	struct vector *ob_vector;
	} OBJECTSELF;

struct object { OBJECTKIND ob_kind; OBJECTSELF ob_self; };
typedef struct object * OP;

/* die verschiedenen typen */

#define INFREELIST (OBJECTKIND)-1 /* 210995 */
#define EMPTY (OBJECTKIND)0 /* 290590 */
#define INTEGER (OBJECTKIND)1
#define VECTOR (OBJECTKIND)2
#define PARTITION (OBJECTKIND)3
#define BRUCH (OBJECTKIND)4
#define PERMUTATION (OBJECTKIND)6
#define SKEWPARTITION (OBJECTKIND)7  /* 020488 */
#define TABLEAUX (OBJECTKIND)8  /* 020488 */
#define POLYNOM (OBJECTKIND)9
#define SCHUR (OBJECTKIND)10
#define MATRIX (OBJECTKIND)11
#define AUG_PART (OBJECTKIND)12
#define HOM_SYM (OBJECTKIND)13
#define HOMSYM (OBJECTKIND)13
#define SCHUBERT (OBJECTKIND)14
#define INTEGERVECTOR (OBJECTKIND)15
#define INTVECTOR (OBJECTKIND)15
#define KOSTKA (OBJECTKIND)16
#define INTINT (OBJECTKIND)17	/* nur fuer test-zwecke */
#define SYMCHAR (OBJECTKIND)18
#define WORD (OBJECTKIND)19
#define SYMLIST (OBJECTKIND)20 /* 210688 */
#define MONOM (OBJECTKIND)21 /*230688*/
#define LONGINT (OBJECTKIND)22 /* 170888 */
#define GEN_CHAR (OBJECTKIND)23 /* 280888  nur fuer test-zwecke */
#define BINTREE (OBJECTKIND)24 /* 291288 */
#define GRAPH (OBJECTKIND)25 /* 210889 */
#define COMP (OBJECTKIND)26 /* 300889 */
#define KRANZTYPUS (OBJECTKIND)27 /* 280390 */
#define POW_SYM (OBJECTKIND)28
#define MONOMIAL (OBJECTKIND)29  /* 090992 */
#define BTREE (OBJECTKIND)30
#define KRANZ (OBJECTKIND)31
#define GRAL (OBJECTKIND)32 /* 200691 */
#define GROUPALGEBRA (OBJECTKIND)32 /* 170693 */
#define ELM_SYM (OBJECTKIND)33  /* 090992 */
#define ELMSYM (OBJECTKIND)33  /* 090992 */
#define FINITEFIELD (OBJECTKIND) 35 /* 250193 */
#define FF (OBJECTKIND) 35 /* 250193 */
#define REIHE (OBJECTKIND) 36 /* 090393 */
#define CHARPARTITION (OBJECTKIND) 37 /* 130593 */ /* internal use */
#define CHAR_AUG_PART (OBJECTKIND) 38 /* 170593 */ /* internal use */
#define INTEGERMATRIX (OBJECTKIND)40 /* AK 141293 */
#define CYCLOTOMIC (OBJECTKIND) 41 /* MD */
#define MONOPOLY (OBJECTKIND) 42 /* MD */
#define SQ_RADICAL (OBJECTKIND) 43 /* MD */
#define BITVECTOR (OBJECTKIND) 44 
#define LAURENT (OBJECTKIND)45

#define FASTPOLYNOM (OBJECTKIND)211093L
#define BARPERM (OBJECTKIND)230695


#ifdef DGUX
#define signed 
#endif /* DGUX */

#ifdef sun
#define signed 
#endif
#ifdef hpux
#define signed 
#endif



struct loc
{ 
   INT w2,w1,w0;
   struct loc *nloc;
  };

struct longint
{
   struct loc *floc;
   signed char signum; /* -1,0,+1 */
   INT laenge;
};


struct ganzdaten
{
   INT basis,basislaenge,auspos,auslaenge,auszz;
   char folgezeichen;
};

struct zahldaten
{
   char ziffer[13];
   INT mehr;
   INT  ziffernzahl;
   struct loc  *fdez;
};


struct vector { OP v_length; OP v_self; };

struct REIHE_variablen {
  INT index;
  INT potenz;
  struct REIHE_variablen *weiter; };

struct REIHE_mon {
  OP coeff;
  struct REIHE_variablen *zeiger;
  struct REIHE_mon *ref; };

struct REIHE_poly {
  INT grad;
  struct REIHE_mon *unten;
  struct REIHE_poly *rechts; };

struct reihe {
  INT exist;
  INT reihenart;        /* Werte: -1,0,1 */
  INT z;                /* bei Operationen pot und transform */
  struct reihe *x,*y;   /* Zeiger auf Ursprung bei Verknuepfung */
  struct reihe *p;      /* zeigt auf Potenzenliste */
  INT (*eingabefkt)(); /* zeiger auf Eingabefunktion */
  char ope;                  /* Operation */
  struct REIHE_poly *infozeig; };  /* Zeiger auf Reihenglieder */


typedef struct reihe* REIHE_zeiger;


struct list { OP l_self; OP l_next; };

struct partition { OBJECTKIND pa_kind; OP pa_self; };
#define LASTPARTITION 1234
#define EXPONENT (OBJECTKIND)88
#define FROBENIUS (OBJECTKIND)92
#define LASTCOMP 1234L

struct permutation { OBJECTKIND p_kind; OP p_self; };
#define LASTLEHMERCODE 12L
#define LASTPERMUTATION 13L
#define LAST_PERMUTATION 13L
#define LAST_FF (INT)170194
#define LASTSHUFFLE 12048802L
#define ZYKEL (OBJECTKIND)40888	/* fuer zykelschreibweise */
#define BITREC (OBJECTKIND)230195	/* fuer bitvector rectrice */
#define BAR (OBJECTKIND)25		/* AK 260292 fuer barred perm */
#define BARCYCLE (OBJECTKIND)26		/* AK 260292 fuer barred perm */

struct monom { OP mo_self;  OP mo_koeff;  };

struct bruch { OP b_oben; OP b_unten; INT b_info; };
#define GEKUERZT 40892L
#define NGEKUERZT 408921L

struct matrix { OP m_length; OP m_height; OP m_self; };
#define SINGULAER 2903884

struct skewpartition { OP spa_gross; OP spa_klein; };

struct tableaux { OP t_umriss;  OP t_self; };

struct symchar{ OP sy_werte; OP sy_parlist; OP sy_dimension; };

struct graph {  OBJECTKIND gr_kind; OP   gr_self; };
#define NACHBARLISTE (OBJECTKIND) 1

typedef struct { OP index, deg, poly, autos; } CYCLO_DATA; /* MD */
typedef struct { OP index, deg, poly; } FIELD_DATA; /* MD */
union data { CYCLO_DATA *c_data; FIELD_DATA *f_data; OP o_data; } ; /* MD */
struct number { OP n_self; union data n_data; };  /* MD */

/* return value fuer insert */
#define INSERTEQ 301288  /* falls eq */
#define INSERTOK 3012881  /* falls insert */

#ifdef ALLTRUE
#define INTEGERTRUE 1
#define VECTORTRUE 1
#define PARTTRUE 1
#define PERMTRUE 1
#define LONGINTTRUE 1
#define MATRIXTRUE 1
#define SCHURTRUE 1
#define HOMSYMTRUE 1
#define POWSYMTRUE 1
#define ELMSYMTRUE 1
#define MONOMIALTRUE 1
#define BRUCHTRUE 1
#define CHARTRUE 1
#define KOSTKATRUE 1
#define SCHUBERTTRUE 1
#define SHUFFLETRUE 1
#define SKEWPARTTRUE 1
#define TABLEAUXTRUE 1
#define WORDTRUE 1
#define KRANZTRUE 1
#define BINTREETRUE 1
#define MONOPOLYTRUE 1
#define SQRADTRUE 1
#define CYCLOTRUE 1
#define NUMBERTRUE 1
#define DGTRUE 1
#define WTTRUE 1
#define SABTRUE 1
#define PLETTRUE 1
#define ZONALTRUE 1
#define GRALTRUE 1
#define FFTRUE 1
#define REIHETRUE 1
#define POLYTRUE 1
#define LAURENTTRUE 1

#endif

#ifdef FFTRUE
#define VECTORTRUE 1
#endif

#ifdef POLYTRUE 
#define VECTORTRUE 1
#endif

#ifdef DGTRUE
#define SABTRUE 1
/* for gl-m reps */
#define MATRIXTRUE 1
#define CHARTRUE 1
#define PARTTRUE 1
#define NUMBERTRUE 1
#endif

#ifdef ZONALTRUE
#define KOSTKATRUE 1
#define CHARTRUE 1
#define MATRIXTRUE 1
#define POLYTRUE 1
#define PARTTRUE 1
#endif

#ifdef NUMBERTRUE
#define INTEGERTRUE 1
#define BRUCHTRUE 1
#define LISTTRUE 1
#define MONOMTRUE 1
#define SQRADTRUE 1
#define CYCLOTRUE 1
#define MONOPOLYTRUE 1
#endif

#ifdef PLETTRUE
#define SCHURTRUE 1
#define MATRIXTRUE 1
#define CHARTRUE 1
#endif

#ifdef SKEWPARTTRUE
#define PARTTRUE 1
#endif 

#ifdef KOSTKATRUE
#define MATRIXTRUE 1
#define SCHURTRUE 1
#endif

#ifdef CHARTRUE
#define INTEGERTRUE 1
#define LONGINTTRUE 1
#define VECTORTRUE 1
#define PARTTRUE 1
#define MATRIXTRUE 1
#define SCHURTRUE 1
#define BRUCHTRUE 1
#define KOSTKATRUE 1
#define NUMBERTRUE 1
#define SQRADTRUE 1
#define CYCLOTRUE 1
#define MONOPOLYTRUE 1
#endif

#ifdef SCHUBERTTRUE
#define POLYTRUE 1
#define PARTTRUE 1
#define PERMTRUE 1
#define VECTORTRUE 1
#define INTEGERTRUE 1
#endif


#ifdef SCHURTRUE
#define BINTREETRUE 1
#define POLYTRUE 1
#define PARTTRUE 1
#define PERMTRUE 1
#define INTEGERTRUE 1
#define VECTORTRUE 1
#define SKEWPARTTRUE 1
#endif

#ifdef BINTREETRUE
#define INTEGERTRUE 1
#endif

#ifdef POLYTRUE
#define LISTTRUE 1
#define MONOMTRUE 1
#define VECTORTRUE 1
#endif

#ifdef PERMTRUE
#define PARTTRUE 1
#define INTEGERTRUE 1
#define VECTORTRUE 1
#endif
#ifdef PARTTRUE
#define INTEGERTRUE 1
#define VECTORTRUE 1
#endif

#ifdef VECTORTRUE
#define INTEGERTRUE 1
#endif


extern INT no_mem_check;
extern INT sym_no_results;     /* 0 == stored results will be used */
                        /* 1 == stored results will not be used */
extern OP cons_eins;
extern OP cons_negeins;
extern OP cons_null;
extern OP cons_zwei;
extern FILE *texout;
extern INT (*check_time_co)();
extern INT zeilenposition;
extern INT english_tableau;
extern INT no_banner;
extern INT kuerzen_yn;
extern INT texmath_yn; /* 1 in mathmode */ /* 0 not in mathmode */
extern INT scanoutput_yn; /* 1 no output */ /* 0 bitte output */
extern INT texposition;
extern OP *speicher;
extern INT speicherposition;
extern INT doffset; /* AK 160393 */
extern INT sym_background;
extern INT sym_timelimit;

extern int 	SYM_free(char *);	/* Prototyped de.c:57--VP  6jui01 */
extern char*  	SYM_malloc(int);	/* Prototyped de.c:132--VP  6jui01 */
extern char*  	SYM_realloc(char *,int);	/* Prototyped de.c:223--VP  6jui01 */
extern char*  	SYM_calloc(int,int);	/* Prototyped de.c:174--VP  6jui01 */
#define SPEICHERSIZE (INT)10000

#ifdef LONGINTTRUE
extern struct ganzdaten gd; /* a global datastructure */
#endif

#define DEF_H


/* from here automatically generated */
extern INT 	Cdeg(OP,OP);	/* Prototyped di.c:222--VP  6jui01 */
extern INT 	Cgen(OP,OP);	/* Prototyped di.c:144--VP  6jui01 */
extern INT 	Cosinus_eingabe(REIHE_zeiger,INT);	/* Prototyped rh.c:653--VP  6jui01 */
extern INT 	E_eingabe(REIHE_zeiger,INT);	/* Prototyped rh.c:780--VP  6jui01 */
extern INT 	Exp_eingabe(REIHE_zeiger,INT);	/* Prototyped rh.c:485--VP  6jui01 */
extern INT 	Ggen(OP);	/* Prototyped di.c:88--VP  6jui01 */
extern INT 	Perm_eingabe(REIHE_zeiger,INT);	/* Prototyped rh.c:719--VP  6jui01 */
extern INT 	R_roftableaux(OP,OP);	/* Prototyped rest.c:2731--VP  6jui01 */
extern INT 	S_a_rofword(OP,OP,OP);	/* Prototyped rest.c:2671--VP  6jui01 */
extern INT 	S_rofword(OP,OP);	/* Prototyped rest.c:2686--VP  6jui01 */
extern INT 	S_wt(OP,OP);	/* Prototyped wt.c:404--VP  6jui01 */
extern INT 	Sd_wt(OP,OP);	/* Prototyped wt.c:394--VP  6jui01 */
extern INT 	Sinus_eingabe(REIHE_zeiger,INT);	/* Prototyped rh.c:600--VP  6jui01 */
extern INT 	Sk_wt(OP,OP);	/* Prototyped wt.c:374--VP  6jui01 */
extern INT 	Sn_wt(OP,OP);	/* Prototyped wt.c:384--VP  6jui01 */
extern INT 	T_weintraube(OP,OP);	/* Prototyped wt.c:226--VP  6jui01 */
extern INT 	UD_permutation(OP,OP);	/* Prototyped perm.c:2667--VP  6jui01 */
extern INT 	a_charvalue();	/* Prototyped nc.c:1066--VP  6jui01 */
extern INT 	absolute(OP,OP);	/* Prototyped nu.c:103--VP  6jui01 */
extern INT 	absolute_bruch(OP,OP);	/* Prototyped bruch.c:102--VP  6jui01 */
extern INT 	absolute_longint(OP,OP);	/* Prototyped lo.c:2057--VP  6jui01 */
extern INT 	absolute_matrix(OP,OP);	/* Prototyped ma.c:128--VP  6jui01 */
extern INT 	absolute_vector(OP,OP);	/* Prototyped vc.c:548--VP  6jui01 */
extern INT 	add(OP,OP,OP);	/* Prototyped nu.c:253--VP  6jui01 */
extern INT 	add_apply(OP,OP);	/* Prototyped nu.c:2111--VP  6jui01 */
extern INT 	add_apply_bruch(OP,OP);	/* Prototyped bruch.c:785--VP  6jui01 */
extern INT 	add_apply_bruch_bruch(OP,OP);	/* Prototyped bruch.c:740--VP  6jui01 */
extern INT 	add_apply_bruch_scalar(OP,OP);	/* Prototyped bruch.c:755--VP  6jui01 */
extern INT 	add_apply_cyclo(OP,OP);	/* Prototyped nb.c:4238--VP  6jui01 */
extern INT 	add_apply_ff(OP,OP);	/* Prototyped ff.c:1097--VP  6jui01 */
extern INT 	add_apply_gral(OP,OP);	/* Prototyped ga.c:483--VP  6jui01 */
extern INT 	add_apply_gral_gral(OP,OP);	/* Prototyped ga.c:474--VP  6jui01 */
extern INT 	add_apply_integer(OP,OP);	/* Prototyped rest.c:1730--VP  6jui01 */
extern INT 	add_apply_integer_integer(OP,OP);	/* Prototyped rest.c:1850--VP  6jui01 */
extern INT 	add_apply_integer_longint(OP,OP);	/* Prototyped lo.c:2226--VP  6jui01 */
extern INT 	add_apply_integervector(OP,OP);	/* Prototyped vc.c:1403--VP  6jui01 */
extern INT 	add_apply_laurent(OP,OP);	/* Prototyped rest.c:3143--VP  6jui01 */
extern INT 	add_apply_longint(OP,OP);	/* Prototyped lo.c:2094--VP  6jui01 */
extern INT 	add_apply_longint_integer(OP,OP);	/* Prototyped lo.c:2197--VP  6jui01 */
extern INT 	add_apply_longint_longint(OP,OP);	/* Prototyped lo.c:2171--VP  6jui01 */
extern INT 	add_apply_matrix(OP,OP);	/* Prototyped ma.c:896--VP  6jui01 */
extern INT 	add_apply_matrix_matrix(OP,OP);	/* Prototyped ma.c:868--VP  6jui01 */
extern INT 	add_apply_monopoly(OP,OP);	/* Prototyped nb.c:2249--VP  6jui01 */
extern INT 	add_apply_polynom(OP,OP);	/* Prototyped poly.c:1528--VP  6jui01 */
extern INT 	add_apply_polynom_polynom(OP,OP);	/* Prototyped poly.c:1504--VP  6jui01 */
extern INT 	add_apply_polynom_scalar(OP,OP);	/* Prototyped poly.c:1516--VP  6jui01 */
extern INT 	add_apply_polynom_schubert(OP,OP);	/* Prototyped poly.c:1565--VP  6jui01 */
extern INT 	add_apply_reihe(OP,OP);	/* Prototyped rh.c:1436--VP  6jui01 */
extern INT 	add_apply_scalar_bruch(OP,OP);	/* Prototyped bruch.c:769--VP  6jui01 */
extern INT 	add_apply_scalar_polynom(OP,OP);	/* Prototyped rest.c:1717--VP  6jui01 */
extern INT 	add_apply_schubert(OP,OP);	/* Prototyped sb.c:1011--VP  6jui01 */
extern INT 	add_apply_schubert_schubert(OP,OP);	/* Prototyped sb.c:1000--VP  6jui01 */
extern INT 	add_apply_sqrad(OP,OP);	/* Prototyped nb.c:3051--VP  6jui01 */
extern INT 	add_apply_symchar(OP,OP);	/* Prototyped sc.c:1066--VP  6jui01 */
extern INT 	add_apply_symfunc(OP,OP);	/* Prototyped sr.c:2013--VP  6jui01 */
extern INT 	add_apply_symfunc_symfunc(OP,OP);	/* Prototyped sr.c:2003--VP  6jui01 */
extern INT 	add_apply_vector(OP,OP);	/* Prototyped vc.c:276--VP  6jui01 */
extern INT 	add_bruch(OP,OP,OP);	/* Prototyped bruch.c:119--VP  6jui01 */
extern INT 	add_bruch_bruch(OP,OP,OP);	/* Prototyped bruch.c:78--VP  6jui01 */
extern INT 	add_bruch_scalar(OP,OP,OP);	/* Prototyped bruch.c:46--VP  6jui01 */
extern INT 	add_cyclo(OP,OP,OP);	/* Prototyped nb.c:4031--VP  6jui01 */
extern INT 	add_cyclo_cyclo(OP,OP,OP);	/* Prototyped nb.c:3931--VP  6jui01 */
extern INT 	add_elmsym(OP,OP,OP);	/* Prototyped sr.c:2419--VP  6jui01 */
extern INT 	add_elmsym_elmsym(OP,OP,OP);	/* Prototyped sr.c:1115--VP  6jui01 */
extern INT 	add_ff(OP,OP,OP);	/* Prototyped ff.c:1108--VP  6jui01 */
extern INT 	add_homsym(OP,OP,OP);	/* Prototyped sr.c:2394--VP  6jui01 */
extern INT 	add_homsym_homsym(OP,OP,OP);	/* Prototyped sr.c:1125--VP  6jui01 */
extern INT 	add_integer(OP,OP,OP);	/* Prototyped rest.c:1304--VP  6jui01 */
extern INT 	add_integer_integer(OP,OP,OP);	/* Prototyped rest.c:1285--VP  6jui01 */
extern INT 	add_koeff(OP,OP);	/* Prototyped poly.c:866--VP  6jui01 */
extern INT 	add_laurent(OP,OP,OP);	/* Prototyped rest.c:3116--VP  6jui01 */
extern INT 	add_longint(OP,OP,OP);	/* Prototyped lo.c:1967--VP  6jui01 */
extern INT 	add_longint_integer(OP,OP,OP);	/* Prototyped lo.c:2267--VP  6jui01 */
extern INT 	add_matrix(OP,OP,OP);	/* Prototyped ma.c:914--VP  6jui01 */
extern INT 	add_matrix_matrix(OP,OP,OP);	/* Prototyped ma.c:925--VP  6jui01 */
extern INT 	add_monom(OP,OP,OP);	/* Prototyped poly.c:832--VP  6jui01 */
extern INT 	add_monom_schur(OP,OP,OP);	/* Prototyped poly.c:851--VP  6jui01 */
extern INT 	add_monomial(OP,OP,OP);	/* Prototyped sr.c:2461--VP  6jui01 */
extern INT 	add_monomial_monomial(OP,OP,OP);	/* Prototyped sr.c:1111--VP  6jui01 */
extern INT 	add_monopoly(OP,OP,OP);	/* Prototyped nb.c:2100--VP  6jui01 */
extern INT 	add_monopoly_monopoly(OP,OP,OP);	/* Prototyped nb.c:1924--VP  6jui01 */
extern INT 	add_part_part(OP,OP,OP);	/* Prototyped part.c:129--VP  6jui01 */
extern INT 	add_partition(OP,OP,OP);	/* Prototyped part.c:217--VP  6jui01 */
extern INT 	add_polynom(OP,OP,OP);	/* Prototyped poly.c:903--VP  6jui01 */
extern INT 	add_polynom_polynom(OP,OP,OP);	/* Prototyped poly.c:949--VP  6jui01 */
extern INT 	add_powsym(OP,OP,OP);	/* Prototyped sr.c:2439--VP  6jui01 */
extern INT 	add_powsym_powsym(OP,OP,OP);	/* Prototyped sr.c:1119--VP  6jui01 */
extern INT 	add_reihe(OP,OP,OP);	/* Prototyped rh.c:1878--VP  6jui01 */
extern INT 	add_scalar_cyclo(OP,OP,OP);	/* Prototyped nb.c:3870--VP  6jui01 */
extern INT 	add_scalar_monopoly(OP,OP,OP);	/* Prototyped nb.c:1867--VP  6jui01 */
extern INT 	add_scalar_polynom(OP,OP,OP);	/* Prototyped poly.c:884--VP  6jui01 */
extern INT 	add_scalar_sqrad(OP,OP,OP);	/* Prototyped nb.c:2650--VP  6jui01 */
extern INT 	add_schubert_schubert(OP,OP,OP);	/* Prototyped sb.c:523--VP  6jui01 */
extern INT 	add_schur(OP,OP,OP);	/* Prototyped sr.c:2360--VP  6jui01 */
extern INT 	add_schur_schur(OP,OP,OP);	/* Prototyped sr.c:1133--VP  6jui01 */
extern INT 	add_sqrad(OP,OP,OP);	/* Prototyped nb.c:2846--VP  6jui01 */
extern INT 	add_sqrad_sqrad(OP,OP,OP);	/* Prototyped nb.c:2714--VP  6jui01 */
extern INT 	add_staircase_part(OP,OP,OP);	/* Prototyped sr.c:2044--VP  6jui01 */
extern INT 	add_symchar(OP,OP,OP);	/* Prototyped sc.c:1077--VP  6jui01 */
extern INT 	add_vector(OP,OP,OP);	/* Prototyped vc.c:310--VP  6jui01 */
extern INT 	addinvers(OP,OP);	/* Prototyped nu.c:653--VP  6jui01 */
extern INT 	addinvers_apply(OP);	/* Prototyped nu.c:1893--VP  6jui01 */
extern INT 	addinvers_apply_bruch(OP);	/* Prototyped bruch.c:228--VP  6jui01 */
extern INT 	addinvers_apply_cyclo(OP);	/* Prototyped nb.c:4264--VP  6jui01 */
extern INT 	addinvers_apply_ff(OP);	/* Prototyped ff.c:1004--VP  6jui01 */
extern INT 	addinvers_apply_integer(OP);	/* Prototyped rest.c:1129--VP  6jui01 */
extern INT 	addinvers_apply_laurent(OP);	/* Prototyped rest.c:3458--VP  6jui01 */
extern INT 	addinvers_apply_longint(OP);	/* Prototyped lo.c:2069--VP  6jui01 */
extern INT 	addinvers_apply_monom(OP);	/* Prototyped poly.c:1173--VP  6jui01 */
extern INT 	addinvers_apply_monopoly(OP);	/* Prototyped nb.c:2272--VP  6jui01 */
extern INT 	addinvers_apply_polynom(OP);	/* Prototyped poly.c:1187--VP  6jui01 */
extern INT 	addinvers_apply_sqrad(OP);	/* Prototyped nb.c:3078--VP  6jui01 */
extern INT 	addinvers_apply_symchar(OP);	/* Prototyped sc.c:1091--VP  6jui01 */
extern INT 	addinvers_apply_vector(OP);	/* Prototyped vc.c:527--VP  6jui01 */
extern INT 	addinvers_bruch(OP,OP);	/* Prototyped bruch.c:216--VP  6jui01 */
extern INT 	addinvers_cyclo(OP,OP);	/* Prototyped nb.c:4123--VP  6jui01 */
extern INT 	addinvers_ff(OP,OP);	/* Prototyped ff.c:1042--VP  6jui01 */
extern INT 	addinvers_integer(OP,OP);	/* Prototyped rest.c:1137--VP  6jui01 */
extern INT 	addinvers_longint(OP,OP);	/* Prototyped lo.c:2079--VP  6jui01 */
extern INT 	addinvers_matrix(OP,OP);	/* Prototyped ma.c:122--VP  6jui01 */
extern INT 	addinvers_monom(OP,OP);	/* Prototyped poly.c:1163--VP  6jui01 */
extern INT 	addinvers_monopoly(OP,OP);	/* Prototyped nb.c:2235--VP  6jui01 */
extern INT 	addinvers_polynom(OP,OP);	/* Prototyped poly.c:1181--VP  6jui01 */
extern INT 	addinvers_reihe(OP,OP);	/* Prototyped rh.c:2392--VP  6jui01 */
extern INT 	addinvers_sqrad(OP,OP);	/* Prototyped nb.c:2935--VP  6jui01 */
extern INT 	addinvers_symchar(OP,OP);	/* Prototyped sc.c:1099--VP  6jui01 */
extern INT 	addinvers_vector(OP,OP);	/* Prototyped vc.c:514--VP  6jui01 */
extern INT 	addtoallvectorelements(OP,OP,OP);	/* Prototyped vc.c:537--VP  6jui01 */
extern INT 	ak_make_alt_classes();	/* Prototyped nc.c:17--VP  6jui01 */
extern INT 	ak_make_alt_partitions();	/* Prototyped nc.c:94--VP  6jui01 */
extern INT 	all_plactic_word(OP,OP);	/* Prototyped ta.c:1812--VP  6jui01 */
extern INT 	all_ppoly(OP,OP,OP);	/* Prototyped sb.c:421--VP  6jui01 */
extern INT 	all_weintrauben(OP,OP,OP);	/* Prototyped wt.c:78--VP  6jui01 */
extern INT 	alle_teiler(OP,OP);	/* Prototyped zykelind.c:3751--VP  6jui01 */
extern INT 	allkostka(OP);	/* Prototyped ko.c:306--VP  6jui01 */
extern INT 	alt_dimension();	/* Prototyped nc.c:28--VP  6jui01 */
extern INT 	alt_odg_trafo();	/* Prototyped boe.c:407--VP  6jui01 */
extern INT 	alt_sdg_trafo();	/* Prototyped boe.c:192--VP  6jui01 */
extern INT 	an_odg();	/* Prototyped boe.c:1964--VP  6jui01 */
extern INT 	an_rz_perm();	/* Prototyped boe.c:591--VP  6jui01 */
extern INT 	an_sdg();	/* Prototyped boe.c:2111--VP  6jui01 */
extern INT 	an_tafel(OP,OP);	/* Prototyped nc.c:1569--VP  6jui01 */
extern INT 	an_trafo_odg();	/* Prototyped boe.c:695--VP  6jui01 */
extern INT 	an_trafo_sdg();	/* Prototyped boe.c:823--VP  6jui01 */
extern INT 	anfang();	/* Prototyped de.c:278--VP  6jui01 */
extern INT 	append(OP,OP,OP);	/* Prototyped rest.c:592--VP  6jui01 */
extern INT 	append_part_part(OP,OP,OP);	/* Prototyped part.c:199--VP  6jui01 */
extern INT 	append_vector(OP,OP,OP);	/* Prototyped vc.c:1196--VP  6jui01 */
extern INT 	apply_INJDT(OP,OP,INT,INT);	/* Prototyped ta.c:1225--VP  6jui01 */
extern INT 	augpart(OP);	/* Prototyped sc.c:17--VP  6jui01 */
extern INT 	b_d_sc(OP,OP);	/* Prototyped sc.c:1242--VP  6jui01 */
extern INT 	b_gk_spa(OP,OP,OP);	/* Prototyped rest.c:2546--VP  6jui01 */
extern INT 	b_i_pa(OP,OP);	/* Prototyped part.c:1715--VP  6jui01 */
extern INT 	b_kl_pa(OBJECTKIND,OP,OP);	/* Prototyped part.c:1769--VP  6jui01 */
extern INT 	b_ks_o(OBJECTKIND,OBJECTSELF,OP);	/* Prototyped rest.c:2137--VP  6jui01 */
extern INT 	b_ks_p(OBJECTKIND,OP,OP);	/* Prototyped perm.c:1744--VP  6jui01 */
extern INT 	b_ks_pa(OBJECTKIND, OP, OP);	/* Prototyped part.c:1749--VP  6jui01 */
extern INT 	b_ksd_n(OBJECTKIND,OP,OP,OP);	/* Prototyped nb.c:1248--VP  6jui01 */
extern INT 	b_l_nv(OP,OP);	/* Prototyped vc.c:242--VP  6jui01 */
extern INT 	b_l_v(OP,OP);	/* Prototyped vc.c:201--VP  6jui01 */
extern INT 	b_lh_m(OP,OP,OP);	/* Prototyped ma.c:392--VP  6jui01 */
extern INT 	b_lh_nm(OP,OP,OP);	/* Prototyped ma.c:374--VP  6jui01 */
extern INT 	b_lhs_m(OP,OP,OP,OP);	/* Prototyped ma.c:430--VP  6jui01 */
extern INT 	b_ls_v(OP,OP,OP);	/* Prototyped vc.c:715--VP  6jui01 */
extern INT 	b_matrix_tableaux(OP,OP);	/* Prototyped ta.c:406--VP  6jui01 */
extern INT 	b_o_v(OP,OP);	/* Prototyped vc.c:99--VP  6jui01 */
extern INT 	b_ou_b(OP,OP,OP);	/* Prototyped bruch.c:434--VP  6jui01 */
extern INT 	b_pa_s(OP,OP);	/* Prototyped sr.c:1080--VP  6jui01 */
extern INT 	b_s_po(OP,OP);	/* Prototyped poly.c:310--VP  6jui01 */
extern INT 	b_sk_mo(OP,OP,OP);	/* Prototyped poly.c:187--VP  6jui01 */
extern INT 	b_skn_mp(OP,OP,OP,OP);	/* Prototyped nb.c:1727--VP  6jui01 */
extern INT 	b_skn_po(OP,OP,OP,OP);	/* Prototyped poly.c:1217--VP  6jui01 */
extern INT 	b_skn_s(OP,OP,OP,OP);	/* Prototyped sr.c:1168--VP  6jui01 */
extern INT 	b_skn_sch(OP,OP,OP,OP);	/* Prototyped sb.c:555--VP  6jui01 */
extern INT 	b_sn_l(OP,OP,OP);	/* Prototyped list.c:255--VP  6jui01 */
extern INT 	b_sn_s(OP,OP,OP);	/* Prototyped sr.c:1380--VP  6jui01 */
extern INT 	b_us_t(OP,OP,OP);	/* Prototyped ta.c:361--VP  6jui01 */
extern INT 	b_wpd_sc(OP,OP,OP,OP);	/* Prototyped sc.c:1285--VP  6jui01 */
extern INT 	bar_rectr(OP,OP);	/* Prototyped bar.c:856--VP  6jui01 */
extern INT 	bdg(OP,OP,OP);	/* Prototyped sab.c:710--VP  6jui01 */
extern INT 	bestimme_fixpunkt();	/* Prototyped di.c:416--VP  6jui01 */
extern INT 	bestimme_konjugiertenklasse(OP);	/* Prototyped di.c:371--VP  6jui01 */
extern INT 	bin_ggt(OP,OP,OP);	/* Prototyped nu.c:2327--VP  6jui01 */
extern INT 	binom(OP,OP,OP);	/* Prototyped nu.c:745--VP  6jui01 */
extern	INT brauer_char();
extern INT 	bru_comp(OP,OP);	/* Prototyped perm.c:3147--VP  6jui01 */
extern INT 	bruch_anfang();	/* Prototyped bruch.c:18--VP  6jui01 */
extern INT 	bruch_ende();	/* Prototyped bruch.c:27--VP  6jui01 */
extern INT 	bruch_not_scalar(OP);	/* Prototyped bruch.c:1533--VP  6jui01 */
extern INT 	bruhat_comp_perm(OP,OP);	/* Prototyped perm.c:3134--VP  6jui01 */
extern	INT build_lc ();
extern INT 	build_propab_vector(OP,OP,OP,OP,OP);	/* Prototyped di.c:333--VP  6jui01 */
extern INT 	c_AUGPART_PARTITION(OP);	/* Prototyped part.c:2387--VP  6jui01 */
extern INT 	c_CHARAUGPART_CHARPARTITION(OP);	/* Prototyped part.c:2358--VP  6jui01 */
extern INT 	c_CHARPARTITION_CHARAUGPART(OP);	/* Prototyped part.c:2373--VP  6jui01 */
extern INT 	c_PARTITION_AUGPART(OP);	/* Prototyped part.c:2402--VP  6jui01 */
extern INT 	c_b_o(OP,OP);	/* Prototyped bruch.c:519--VP  6jui01 */
extern INT 	c_b_u(OP,OP);	/* Prototyped bruch.c:530--VP  6jui01 */
extern INT 	c_ff_ip(OP,INT *);	/* Prototyped ff.c:79--VP  6jui01 */
extern INT 	c_gr_k(OP,OBJECTKIND);	/* Prototyped gra.c:39--VP  6jui01 */
extern INT 	c_gr_s(OP,OP);	/* Prototyped gra.c:28--VP  6jui01 */
extern INT 	c_i_i(OP,INT);	/* Prototyped rest.c:1651--VP  6jui01 */
extern INT 	c_i_n(OP,OP,OP,OP);	/* Prototyped sc.c:530--VP  6jui01 */
extern INT 	c_i_n_an(OP,OP,OP,OP);	/* Prototyped sc.c:598--VP  6jui01 */
extern INT 	c_ijk_sn(OP,OP,OP,OP);	/* Prototyped sc.c:1866--VP  6jui01 */
extern INT 	c_kr_g(OP,OP);	/* Prototyped perm.c:445--VP  6jui01 */
extern INT 	c_kr_v(OP,OP);	/* Prototyped perm.c:451--VP  6jui01 */
extern INT 	c_l_n(OP,OP);	/* Prototyped list.c:454--VP  6jui01 */
extern INT 	c_l_s(OP,OP);	/* Prototyped list.c:459--VP  6jui01 */
extern INT 	c_m_h(OP,OP);	/* Prototyped ma.c:1251--VP  6jui01 */
extern INT 	c_m_l(OP,OP);	/* Prototyped ma.c:1256--VP  6jui01 */
extern INT 	c_m_s(OP,OP);	/* Prototyped ma.c:1246--VP  6jui01 */
extern INT 	c_mo_k(OP,OP);	/* Prototyped poly.c:435--VP  6jui01 */
extern INT 	c_mo_s(OP,OP);	/* Prototyped poly.c:426--VP  6jui01 */
extern INT 	c_n_d(OP,OP);	/* Prototyped nb.c:92--VP  6jui01 */
extern INT 	c_n_s(OP,OP);	/* Prototyped nb.c:74--VP  6jui01 */
extern INT 	c_o_k(OP,OBJECTKIND);	/* Prototyped rest.c:2235--VP  6jui01 */
extern INT 	c_o_s(OP,OBJECTSELF);	/* Prototyped rest.c:2244--VP  6jui01 */
extern INT 	c_p_k(OP,OBJECTKIND);	/* Prototyped perm.c:2143--VP  6jui01 */
extern INT 	c_p_s(OP,OP);	/* Prototyped perm.c:2161--VP  6jui01 */
extern INT 	c_pa_k(OP,OBJECTKIND);	/* Prototyped part.c:1907--VP  6jui01 */
extern INT 	c_pa_s(OP,OP);	/* Prototyped part.c:1916--VP  6jui01 */
extern INT 	c_s_n(OP,OP);	/* Prototyped sr.c:1370--VP  6jui01 */
extern INT 	c_sc_d(OP,OP);	/* Prototyped sc.c:1369--VP  6jui01 */
extern INT 	c_sc_p(OP,OP);	/* Prototyped sc.c:1379--VP  6jui01 */
extern INT 	c_sc_w(OP,OP);	/* Prototyped sc.c:1389--VP  6jui01 */
extern INT 	c_sch_n(OP,OP);	/* Prototyped sb.c:682--VP  6jui01 */
extern INT 	c_spa_g(OP,OP);	/* Prototyped rest.c:2313--VP  6jui01 */
extern INT 	c_spa_k(OP,OP);	/* Prototyped rest.c:2330--VP  6jui01 */
extern INT 	c_t_s(OP,OP);	/* Prototyped ta.c:765--VP  6jui01 */
extern INT 	c_t_u(OP,OP);	/* Prototyped ta.c:770--VP  6jui01 */
extern INT 	c_v_i(OP,OP,INT);	/* Prototyped vc.c:816--VP  6jui01 */
extern INT 	c_v_l(OP,OP);	/* Prototyped vc.c:840--VP  6jui01 */
extern INT 	c_v_s(OP,OP);	/* Prototyped vc.c:830--VP  6jui01 */
extern INT 	calculate_fixed_point_number(OP,OP,OP);	/* Prototyped di.c:269--VP  6jui01 */
extern OP 	callocobject();	/* Prototyped rest.c:2190--VP  6jui01 */
extern INT 	callocobject_anfang();	/* Prototyped rest.c:30--VP  6jui01 */
extern INT 	callocobject_ende();	/* Prototyped rest.c:41--VP  6jui01 */
extern OP 	callocobject_trace();	/* Prototyped rest.c:2174--VP  6jui01 */
extern INT 	cast_apply(OBJECTKIND,OP);	/* Prototyped rest.c:3020--VP  6jui01 */
extern INT 	cast_apply_barperm(OP);	/* Prototyped bar.c:5--VP  6jui01 */
extern INT 	cast_apply_bruch(OP);	/* Prototyped bruch.c:1027--VP  6jui01 */
extern INT 	cast_apply_ff(OP);	/* Prototyped ff.c:1155--VP  6jui01 */
extern INT 	cast_apply_integer(OP);	/* Prototyped rest.c:2982--VP  6jui01 */
extern INT 	cast_apply_matrix(OP);	/* Prototyped ma.c:30--VP  6jui01 */
extern INT 	cast_apply_monom(OP);	/* Prototyped poly.c:2272--VP  6jui01 */
extern INT 	cast_apply_part(OP);	/* Prototyped part.c:2601--VP  6jui01 */
extern INT 	cast_apply_perm(OP);	/* Prototyped perm.c:3088--VP  6jui01 */
extern INT 	cast_apply_schur(OP);	/* Prototyped sr.c:3213--VP  6jui01 */
extern INT 	cast_apply_tableaux(OP);	/* Prototyped ta.c:33--VP  6jui01 */
extern INT 	change_column_ij(OP,INT,INT);	/* Prototyped ma.c:1161--VP  6jui01 */
extern INT 	change_row_ij(OP,INT,INT);	/* Prototyped ma.c:1192--VP  6jui01 */
extern INT 	char_matrix_scalar_product(OP,OP,OP,OP);	/* Prototyped sc.c:865--VP  6jui01 */
extern INT 	character_polynom(OP,OP);	/* Prototyped poly.c:1832--VP  6jui01 */
extern INT 	characteristik_symchar(OP,OP);	/* Prototyped sc.c:1825--VP  6jui01 */
extern INT 	characteristik_to_symchar(OP,OP);	/* Prototyped sc.c:1770--VP  6jui01 */
extern INT 	charakteristik_to_ypolynom(OP,OP,OP,OP);	/* Prototyped perm.c:760--VP  6jui01 */
extern INT 	charge_tableaux(OP,OP);	/* Prototyped ta.c:65--VP  6jui01 */
extern INT 	charge_word(OP,OP);	/* Prototyped rest.c:2586--VP  6jui01 */
extern INT 	chartafel(OP,OP);	/* Prototyped sc.c:370--VP  6jui01 */
extern INT 	chartafel_bit(OP,OP);	/* Prototyped sc.c:375--VP  6jui01 */
extern INT 	chartafel_nonbit(OP,OP);	/* Prototyped sc.c:453--VP  6jui01 */
extern INT 	chartafel_partvector(OP,OP,OP);	/* Prototyped sc.c:361--VP  6jui01 */
extern INT 	charvalue(OP,OP,OP,OP);	/* Prototyped sc.c:269--VP  6jui01 */
extern INT	charvalue_bit(OP,OP,OP);	/* Updated by hand--VP  6jui01 */
extern INT 	charvalue_tafel_part(OP,OP,OP,OP,OP);	/* Prototyped sc.c:253--VP  6jui01 */
extern	INT check_braid ();
extern	INT check_commute ();
extern INT 	check_equal_2(OP,OP,INT (*)(),INT *);	/* Prototyped rest.c:135--VP  6jui01 */
extern INT 	check_equal_3(OP,OP,OP,INT (*)(),INT *);	/* Prototyped rest.c:58--VP  6jui01 */
extern INT 	check_equal_4(OP,OP,OP,OP,INT (*)(),INT *);	/* Prototyped rest.c:92--VP  6jui01 */
extern	INT check_hecke_generators ();
extern	INT check_hecke_quadratic ();
extern INT 	check_longint(OP);	/* Prototyped lo.c:2410--VP  6jui01 */
extern INT 	check_result_1(OP,OP,char *);	/* Prototyped rest.c:173--VP  6jui01 */
extern INT 	check_result_2(OP,OP,OP,char *);	/* Prototyped rest.c:190--VP  6jui01 */
extern INT 	check_time();	/* Prototyped rest.c:2157--VP  6jui01 */
extern	INT check_zero_matrix ();
extern INT 	class_bar(OP,OP);	/* Prototyped bar.c:451--VP  6jui01 */
extern INT 	class_rep_bar(OP,OP);	/* Prototyped bar.c:417--VP  6jui01 */
extern INT 	class_rep_kranz(OP,OP);	/* Prototyped nc.c:542--VP  6jui01 */
extern	INT co_070295();
extern	INT co_k_dimmod();
extern INT 	co_polya3_sub(OP,OP,OP,OP);	/* Prototyped zykelind.c:3625--VP  6jui01 */
extern INT 	co_polya_sub(OP,OP,OP,OP);	/* Prototyped zykelind.c:3497--VP  6jui01 */
extern INT 	co_zykelind_pglkq(OP,OP,OP);	/* Prototyped zykelind.c:2396--VP  6jui01 */
extern INT 	coeff_of_in(OP,OP,OP);	/* Prototyped zykelind.c:3970--VP  6jui01 */
extern	INT column_standardise_tableau ();
extern	INT columns_standardise_tableau ();
extern INT 	columnwordoftableaux(OP,OP);	/* Prototyped ta.c:951--VP  6jui01 */
extern INT 	comp(OP,OP);	/* Prototyped rest.c:946--VP  6jui01 */
extern INT 	comp_bigr_bigr(OP,OP);	/* Prototyped bar.c:888--VP  6jui01 */
extern INT 	comp_bigr_perm(OP,OP);	/* Prototyped bar.c:877--VP  6jui01 */
extern INT 	comp_bruch(OP,OP);	/* Prototyped bruch.c:557--VP  6jui01 */
extern INT 	comp_bruch_scalar(OP,OP);	/* Prototyped bruch.c:592--VP  6jui01 */
extern INT 	comp_bv(OP,OP);	/* Prototyped vc.c:605--VP  6jui01 */
extern INT 	comp_colex_part(OP,OP);	/* Prototyped sr.c:1572--VP  6jui01 */
extern INT 	comp_colex_schurmonom(OP,OP);	/* Prototyped sr.c:1559--VP  6jui01 */
extern INT 	comp_colex_vector(OP,OP);	/* Prototyped vc.c:1467--VP  6jui01 */
extern INT 	comp_cyclo(OP,OP);	/* Prototyped nb.c:4291--VP  6jui01 */
extern INT 	comp_ff(OP,OP);	/* Prototyped ff.c:986--VP  6jui01 */
extern INT 	comp_integer(OP,OP);	/* Prototyped rest.c:1358--VP  6jui01 */
extern INT 	comp_integer_integer(OP,OP);	/* Prototyped rest.c:1348--VP  6jui01 */
extern INT 	comp_integervector(OP,OP);	/* Prototyped vc.c:621--VP  6jui01 */
extern INT 	comp_kranztafel(OP,OP);	/* Prototyped ma.c:811--VP  6jui01 */
extern INT 	comp_lex_perm(OP,OP);	/* Prototyped perm.c:2528--VP  6jui01 */
extern INT 	comp_list(OP,OP);	/* Prototyped list.c:398--VP  6jui01 */
extern INT 	comp_list_co(OP,OP,INT (*)());	/* Prototyped list.c:403--VP  6jui01 */
extern INT 	comp_longint(OP,OP);	/* Prototyped lo.c:2364--VP  6jui01 */
extern INT 	comp_matrix(OP,OP);	/* Prototyped ma.c:839--VP  6jui01 */
extern INT 	comp_monom(OP,OP);	/* Prototyped poly.c:342--VP  6jui01 */
extern INT 	comp_monomvector_monomvector(OP,OP);	/* Prototyped poly.c:989--VP  6jui01 */
extern INT 	comp_monopoly(OP,OP);	/* Prototyped nb.c:2301--VP  6jui01 */
extern INT 	comp_number(OP,OP);	/* Prototyped nb.c:1399--VP  6jui01 */
extern INT 	comp_numeric_vector(OP,OP);	/* Prototyped vc.c:1362--VP  6jui01 */
extern INT 	comp_partition(OP,OP);	/* Prototyped part.c:1304--VP  6jui01 */
extern INT 	comp_permutation(OP,OP);	/* Prototyped perm.c:1361--VP  6jui01 */
extern INT 	comp_permutation_pol(OP,OP);	/* Prototyped perm.c:2683--VP  6jui01 */
extern INT 	comp_polynom(OP,OP);	/* Prototyped poly.c:984--VP  6jui01 */
extern INT 	comp_reihe(OP,OP);	/* Prototyped rh.c:950--VP  6jui01 */
extern INT 	comp_sqrad(OP,OP);	/* Prototyped nb.c:3097--VP  6jui01 */
extern INT 	comp_symchar(OP,OP);	/* Prototyped sc.c:954--VP  6jui01 */
extern INT 	comp_tableaux(OP,OP);	/* Prototyped ta.c:607--VP  6jui01 */
extern INT 	comp_vector(OP,OP);	/* Prototyped vc.c:636--VP  6jui01 */
extern INT 	complete_complete_plet(OP,OP,OP);	/* Prototyped pletint.c:6231--VP  6jui01 */
extern INT 	complete_schur_plet(OP,OP,OP);	/* Prototyped pletint.c:6132--VP  6jui01 */
extern INT 	complex_conjugate(OP,OP);	/* Prototyped nb.c:1444--VP  6jui01 */
extern INT 	compute_complete_with_alphabet(OP,OP,OP);	/* Prototyped sr.c:841--VP  6jui01 */
extern INT 	compute_elmsym_with_alphabet(OP,OP,OP);	/* Prototyped sr.c:900--VP  6jui01 */
extern INT 	compute_monomial_with_alphabet(OP,OP,OP);	/* Prototyped sr.c:774--VP  6jui01 */
extern INT 	compute_power_with_alphabet(OP,OP,OP);	/* Prototyped sr.c:958--VP  6jui01 */
extern INT 	compute_schur(OP,OP);	/* Prototyped sr.c:581--VP  6jui01 */
extern INT 	compute_schur_with_alphabet(OP,OP,OP);	/* Prototyped sr.c:1016--VP  6jui01 */
extern INT 	compute_schur_with_alphabet_det(OP,OP,OP);	/* Prototyped sr.c:555--VP  6jui01 */
extern INT 	compute_skewschur_with_alphabet_det(OP,OP,OP);	/* Prototyped sr.c:521--VP  6jui01 */
extern INT 	compute_zonal_with_alphabet(OP,OP,OP);	/* Prototyped zo.c:12--VP  6jui01 */
extern INT 	conj_cyclo(OP,OP,OP);	/* Prototyped nb.c:4140--VP  6jui01 */
extern INT 	conj_sqrad(OP,OP,OP);	/* Prototyped nb.c:3385--VP  6jui01 */
extern INT 	conjugate(OP,OP);	/* Prototyped nu.c:603--VP  6jui01 */
extern INT 	conjugate_schur(OP);	/* Prototyped pletint.c:2817--VP  6jui01 */
extern INT 	contain_comp_part(OP,OP);	/* Prototyped part.c:2105--VP  6jui01 */
extern INT 	convert_cyclo_scalar(OP);	/* Prototyped nb.c:4300--VP  6jui01 */
extern INT 	convert_radical_cyclo(OP,OP);	/* Prototyped nb.c:3531--VP  6jui01 */
extern INT 	convert_sqrad_cyclo(OP,OP);	/* Prototyped nb.c:3655--VP  6jui01 */
extern INT 	convert_sqrad_scalar(OP);	/* Prototyped nb.c:3505--VP  6jui01 */
extern INT 	copy(OP,OP);	/* Prototyped rest.c:506--VP  6jui01 */
extern INT 	copy_bintree(OP,OP);	/* Prototyped bi.c:188--VP  6jui01 */
extern INT 	copy_bitvector(OP,OP);	/* Prototyped vc.c:1442--VP  6jui01 */
extern INT 	copy_bruch(OP,OP);	/* Prototyped bruch.c:374--VP  6jui01 */
extern INT 	copy_ff(OP,OP);	/* Prototyped ff.c:838--VP  6jui01 */
extern INT 	copy_graph(OP,OP);	/* Prototyped gra.c:249--VP  6jui01 */
extern INT 	copy_integer(OP,OP);	/* Prototyped rest.c:1449--VP  6jui01 */
extern INT 	copy_integervector(OP,OP);	/* Prototyped vc.c:1452--VP  6jui01 */
extern INT 	copy_kranztypus(OP,OP);	/* Prototyped ma.c:968--VP  6jui01 */
extern INT 	copy_list(OP,OP);	/* Prototyped list.c:188--VP  6jui01 */
extern INT 	copy_longint(OP,OP);	/* Prototyped lo.c:1933--VP  6jui01 */
extern INT 	copy_matrix(OP,OP);	/* Prototyped ma.c:981--VP  6jui01 */
extern INT 	copy_monom(OP,OP);	/* Prototyped poly.c:356--VP  6jui01 */
extern INT 	copy_number(OP,OP);	/* Prototyped nb.c:1421--VP  6jui01 */
extern INT 	copy_partition(OP,OP);	/* Prototyped part.c:1442--VP  6jui01 */
extern INT 	copy_permutation(OP,OP);	/* Prototyped perm.c:1872--VP  6jui01 */
extern INT 	copy_polynom(OP,OP);	/* Prototyped poly.c:1496--VP  6jui01 */
extern INT 	copy_reihe(OP,OP);	/* Prototyped rh.c:1478--VP  6jui01 */
extern INT 	copy_skewpartition(OP,OP);	/* Prototyped rest.c:2401--VP  6jui01 */
extern INT 	copy_symchar(OP,OP);	/* Prototyped sc.c:989--VP  6jui01 */
extern INT 	copy_tableaux(OP,OP);	/* Prototyped ta.c:322--VP  6jui01 */
extern INT 	copy_vector(OP,OP);	/* Prototyped vc.c:564--VP  6jui01 */
extern INT 	cyclic_tafel(OP,OP);	/* Prototyped nc.c:502--VP  6jui01 */
extern INT 	debruijn_all_functions(OP,OP,OP);	/* Prototyped zykelind.c:3065--VP  6jui01 */
extern INT 	debruijn_inj_functions(OP,OP,OP);	/* Prototyped zykelind.c:3155--VP  6jui01 */
extern INT 	debugprint(OP);	/* Prototyped de.c:605--VP  6jui01 */
extern INT 	debugprint_ff(OP);	/* Prototyped ff.c:1779--VP  6jui01 */
extern INT 	debugprint_longint(OP);	/* Prototyped lo.c:2611--VP  6jui01 */
extern INT 	debugprint_object(OP);	/* Prototyped rest.c:2276--VP  6jui01 */
extern INT 	debugprint_reihe(OP);	/* Prototyped rh.c:2274--VP  6jui01 */
extern INT 	dec(OP);	/* Prototyped nu.c:905--VP  6jui01 */
extern INT 	dec_integer(OP);	/* Prototyped rest.c:1151--VP  6jui01 */
extern INT 	dec_longint(OP);	/* Prototyped lo.c:2282--VP  6jui01 */
extern INT 	dec_partition(OP);	/* Prototyped part.c:1779--VP  6jui01 */
extern INT 	dec_permutation(OP);	/* Prototyped perm.c:1952--VP  6jui01 */
extern INT 	dec_vector(OP);	/* Prototyped vc.c:1162--VP  6jui01 */
extern	INT decp_mat();
extern INT 	decreasingp_vector(OP);	/* Prototyped vc.c:50--VP  6jui01 */
extern INT 	degree_monopoly(OP,OP);	/* Prototyped nb.c:4783--VP  6jui01 */
extern INT 	degree_polynom(OP,OP);	/* Prototyped poly.c:1670--VP  6jui01 */
extern INT 	delete_column_matrix(INT,OP,OP);	/* Prototyped ma.c:214--VP  6jui01 */
extern INT 	delete_entry_vector(OP,OP,INT);	/* Prototyped vc.c:1303--VP  6jui01 */
extern INT 	delete_row_matrix(INT,OP,OP);	/* Prototyped ma.c:176--VP  6jui01 */
extern INT 	det(OP,OP);	/* Prototyped nu.c:1848--VP  6jui01 */
extern INT 	det270588(OP,OP,OP);	/* Prototyped ma.c:506--VP  6jui01 */
extern INT 	det_imm_matrix(OP,OP);	/* Prototyped ma.c:542--VP  6jui01 */
extern INT 	det_mat_imm(OP,OP);	/* Prototyped ma.c:537--VP  6jui01 */
extern INT 	det_mat_tri(OP,OP);	/* Prototyped ma.c:266--VP  6jui01 */
extern INT 	det_matrix(OP,OP);	/* Prototyped ma.c:251--VP  6jui01 */
extern INT 	dg_mp(OP,OP);	/* Prototyped bruch.c:1051--VP  6jui01 */
extern INT 	diagramm_permutation(OP,OP);	/* Prototyped perm.c:91--VP  6jui01 */
extern INT 	dimension(OP,OP);	/* Prototyped nu.c:964--VP  6jui01 */
extern INT 	dimension_augpart(OP,OP);	/* Prototyped part.c:676--VP  6jui01 */
extern INT 	dimension_bit(OP,OP);	/* Prototyped vc.c:1796--VP  6jui01 */
extern	INT dimension_mod();
extern INT 	dimension_partition(OP,OP);	/* Prototyped part.c:620--VP  6jui01 */
extern INT 	dimension_schubert(OP,OP);	/* Prototyped sb.c:1140--VP  6jui01 */
extern INT 	dimension_schur(OP,OP);	/* Prototyped sr.c:2025--VP  6jui01 */
extern INT 	dimension_skewpartition(OP,OP);	/* Prototyped rest.c:2451--VP  6jui01 */
extern INT 	dimension_symmetrization(OP,OP,OP);	/* Prototyped sab.c:2387--VP  6jui01 */
extern INT 	dimino(OP);	/* Prototyped zyk.c:1148--VP  6jui01 */
extern INT 	display(OP);	/* Prototyped io.c:230--VP  6jui01 */
extern INT 	display_schubert(OP);	/* Prototyped sb.c:696--VP  6jui01 */
extern INT 	distanzdiagramm(OP,OP,OP);	/* Prototyped wt.c:1237--VP  6jui01 */
extern INT 	div(OP,OP,OP);	/* Prototyped nu.c:1004--VP  6jui01 */
extern INT 	divdiff(OP,OP,OP);	/* Prototyped perm.c:274--VP  6jui01 */
extern INT 	divdiff_bar(OP,OP,OP);	/* Prototyped bar.c:59--VP  6jui01 */
extern INT 	divdiff_perm_schubert(OP,OP,OP);	/* Prototyped sb.c:1228--VP  6jui01 */
extern INT 	divdiff_schubert(OP,OP,OP);	/* Prototyped sb.c:1182--VP  6jui01 */
extern INT 	divideddiff_lc(OP,OP,OP);	/* Prototyped perm.c:262--VP  6jui01 */
extern INT 	divideddiff_permutation(OP,OP,OP);	/* Prototyped perm.c:246--VP  6jui01 */
extern INT 	divideddiff_rz(OP,OP,OP);	/* Prototyped perm.c:203--VP  6jui01 */
extern INT 	divideddiff_rz_bar(OP,OP,OP);	/* Prototyped bar.c:88--VP  6jui01 */
extern INT 	divideddifference(OP,OP,OP);	/* Prototyped perm.c:334--VP  6jui01 */
extern INT 	divideddifference_bar(OP,OP,OP);	/* Prototyped bar.c:106--VP  6jui01 */
extern INT 	dixon_wilf_transversal();	/* Prototyped di.c:616--VP  6jui01 */
extern INT 	dom_comp_part(OP,OP);	/* Prototyped part.c:2117--VP  6jui01 */
extern INT 	double_apply(OP);	/* Prototyped nu.c:2090--VP  6jui01 */
extern INT 	ds_j_wt(OP,OP,INT);	/* Prototyped wt.c:489--VP  6jui01 */
extern INT 	dynamicp(OP);	/* Prototyped rest.c:666--VP  6jui01 */
extern INT 	dz_i_wt(OP,OP,INT);	/* Prototyped wt.c:497--VP  6jui01 */
extern INT 	einsp(OP);	/* Prototyped rest.c:764--VP  6jui01 */
extern INT 	einsp_bruch(OP);	/* Prototyped bruch.c:185--VP  6jui01 */
extern INT 	einsp_ff(OP);	/* Prototyped ff.c:1079--VP  6jui01 */
extern INT 	einsp_integer(OP);	/* Prototyped rest.c:1429--VP  6jui01 */
extern INT 	einsp_longint(OP);	/* Prototyped lo.c:2334--VP  6jui01 */
extern INT 	einsp_matrix(OP);	/* Prototyped ma.c:157--VP  6jui01 */
extern INT 	einsp_monopoly(OP);	/* Prototyped nb.c:1693--VP  6jui01 */
extern INT 	einsp_permutation(OP);	/* Prototyped perm.c:2517--VP  6jui01 */
extern INT 	einsp_polynom(OP);	/* Prototyped poly.c:1797--VP  6jui01 */
extern INT 	einsp_reihe(OP);	/* Prototyped rh.c:1362--VP  6jui01 */
extern INT 	einsp_schubert(OP);	/* Prototyped sb.c:32--VP  6jui01 */
extern INT 	einsp_symchar(OP);	/* Prototyped sc.c:1176--VP  6jui01 */
extern INT 	einsp_vector(OP);	/* Prototyped vc.c:41--VP  6jui01 */
extern INT 	elementarp_permutation(OP,OP);	/* Prototyped perm.c:2170--VP  6jui01 */
extern INT 	elementary_schur_plet(OP,OP,OP);	/* Prototyped pletint.c:6208--VP  6jui01 */
extern INT 	empty_listp(OP);	/* Prototyped list.c:42--VP  6jui01 */
extern INT 	emptyp(OP);	/* Prototyped rest.c:2253--VP  6jui01 */
extern INT 	en_forme(OP);	/* Prototyped bruch.c:1598--VP  6jui01 */
extern INT 	ende();	/* Prototyped de.c:351--VP  6jui01 */
extern	INT enter_list_to_matrix ();
extern INT 	eq(OP,OP);	/* Prototyped rest.c:1035--VP  6jui01 */
extern INT 	eq_fieldobject_int(OBJECTKIND,OP,INT);	/* Prototyped nb.c:1159--VP  6jui01 */
extern INT 	equal_2_error();	/* Prototyped rest.c:255--VP  6jui01 */
extern INT 	equal_parts(OP,OP);	/* Prototyped part.c:2621--VP  6jui01 */
extern INT 	error(char *);	/* Prototyped de.c:554--VP  6jui01 */
extern INT 	error_during_computation(char *);	/* Prototyped rest.c:259--VP  6jui01 */
extern INT 	euler_phi(OP,OP);	/* Prototyped nb.c:316--VP  6jui01 */
extern INT 	eval_2schubert(OP,OP,OP);	/* Prototyped sb.c:1445--VP  6jui01 */
extern INT 	eval_char_polynom(OP,OP,OP);	/* Prototyped poly.c:2010--VP  6jui01 */
extern INT 	eval_monopoly(OP,OP,OP);	/* Prototyped nb.c:1668--VP  6jui01 */
extern INT 	eval_polynom(OP,OP,OP);	/* Prototyped poly.c:90--VP  6jui01 */
extern INT 	eval_polynom_dir_prod(OP,OP,OP);	/* Prototyped zykelind.c:214--VP  6jui01 */
extern INT 	even(OP);	/* Prototyped rest.c:874--VP  6jui01 */
extern INT 	even_integer(OP);	/* Prototyped rest.c:1260--VP  6jui01 */
extern INT 	even_longint(OP);	/* Prototyped lo.c:2532--VP  6jui01 */
extern INT 	even_partition(OP,OP);	/* Prototyped part.c:2161--VP  6jui01 */
extern INT 	even_permutation(OP);	/* Prototyped perm.c:68--VP  6jui01 */
extern INT 	exchange_alphabets(OP,OP);	/* Prototyped sb.c:1425--VP  6jui01 */
extern INT 	exor_bitvector_apply(OP,OP);	/* Prototyped vc.c:1637--VP  6jui01 */
extern INT 	extended_ggt(OP,OP,OP,OP,OP);	/* Prototyped nu.c:2385--VP  6jui01 */
extern INT 	factorize_integer(OP,OP);	/* Prototyped rest.c:1100--VP  6jui01 */
extern INT 	fakul(OP,OP);	/* Prototyped nu.c:1158--VP  6jui01 */
extern INT 	fakul_longint(OP,OP);	/* Prototyped nu.c:1205--VP  6jui01 */
extern INT 	fastconjugate_partition(OP,OP);	/* Prototyped part.c:280--VP  6jui01 */
extern INT 	fastrectr(OP,OP);	/* Prototyped perm.c:3203--VP  6jui01 */
extern INT 	fatal_error(char *);	/* Prototyped de.c:548--VP  6jui01 */
extern INT 	ferrers(OP);	/* Prototyped io.c:77--VP  6jui01 */
extern INT 	ferrers_partition(OP);	/* Prototyped part.c:327--VP  6jui01 */
extern INT 	ferrers_skewpartition(OP);	/* Prototyped rest.c:2493--VP  6jui01 */
extern INT 	ff_ende();	/* Prototyped ff.c:351--VP  6jui01 */
extern INT 	fill_left_down_matrix(OP);	/* Prototyped perm.c:171--VP  6jui01 */
extern INT 	filter_apply_list(OP,INT (*)());	/* Prototyped list.c:865--VP  6jui01 */
extern INT 	filter_list(OP,OP,INT (*)());	/* Prototyped list.c:291--VP  6jui01 */
extern OP 	find_bintree(OP,OP);	/* Prototyped bi.c:219--VP  6jui01 */
extern	INT find_non_root_standard_pos ();
extern	INT find_non_rowstandard_pos ();
extern INT 	find_tab_entry(OP,OP,INT *,INT *);	/* Prototyped ta.c:1608--VP  6jui01 */
extern OP 	find_vector(OP,OP);	/* Prototyped vc.c:1326--VP  6jui01 */
extern INT 	first(OBJECTKIND,OP,OP);	/* Prototyped rest.c:2114--VP  6jui01 */
extern INT 	first_bar(OP,OP);	/* Prototyped bar.c:324--VP  6jui01 */
extern INT 	first_composition(OP,OP,OP);	/* Prototyped part.c:240--VP  6jui01 */
extern INT 	first_ff(OP,OP,OP);	/* Prototyped ff.c:1865--VP  6jui01 */
extern INT 	first_kranztypus(OP,OP,OP);	/* Prototyped perm.c:532--VP  6jui01 */
extern INT 	first_lehmercode(OP,OP);	/* Prototyped perm.c:1370--VP  6jui01 */
extern INT 	first_part_EXPONENT(OP,OP);	/* Prototyped part.c:776--VP  6jui01 */
extern INT 	first_part_VECTOR(OP,OP);	/* Prototyped part.c:762--VP  6jui01 */
extern INT 	first_partition(OP,OP);	/* Prototyped part.c:822--VP  6jui01 */
extern INT 	first_perm_n_invers(OP,OP,OP);	/* Prototyped perm.c:2791--VP  6jui01 */
extern INT 	first_permutation(OP,OP);	/* Prototyped perm.c:1397--VP  6jui01 */
extern INT 	first_prime_factor(OP,OP);	/* Prototyped nb.c:812--VP  6jui01 */
extern INT 	first_tab_perm(OP,OP);	/* Prototyped perm.c:157--VP  6jui01 */
extern INT 	first_tableaux(OP,OP);	/* Prototyped ta.c:1484--VP  6jui01 */
extern INT 	fprint(FILE *,OP);	/* Prototyped io.c:139--VP  6jui01 */
extern INT 	fprint_bintree(FILE *,OP);	/* Prototyped bi.c:95--VP  6jui01 */
extern INT 	fprint_bitvector(OP,FILE *);	/* Prototyped vc.c:1537--VP  6jui01 */
extern INT 	fprint_bruch(FILE *,OP);	/* Prototyped bruch.c:321--VP  6jui01 */
extern INT 	fprint_ff(OP,FILE *);	/* Prototyped ff.c:1801--VP  6jui01 */
extern INT 	fprint_graph(FILE *,OP);	/* Prototyped gra.c:240--VP  6jui01 */
extern INT 	fprint_integer(FILE *,OP);	/* Prototyped rest.c:1623--VP  6jui01 */
extern INT 	fprint_list(FILE *,OP);	/* Prototyped list.c:56--VP  6jui01 */
extern INT 	fprint_longint(FILE *,OP);	/* Prototyped lo.c:1897--VP  6jui01 */
extern INT 	fprint_matrix(FILE *,OP);	/* Prototyped ma.c:1302--VP  6jui01 */
extern INT 	fprint_monom(FILE *,OP);	/* Prototyped poly.c:250--VP  6jui01 */
extern INT 	fprint_number(FILE *,OP);	/* Prototyped nb.c:1323--VP  6jui01 */
extern INT 	fprint_partition(FILE *,OP);	/* Prototyped part.c:348--VP  6jui01 */
extern INT 	fprint_permutation(OP,FILE *);	/* Prototyped perm.c:1896--VP  6jui01 */
extern INT 	fprint_reihe(FILE *,OP);	/* Prototyped rh.c:963--VP  6jui01 */
extern INT 	fprint_skewpartition(OP,FILE *);	/* Prototyped rest.c:2500--VP  6jui01 */
extern INT 	fprint_symchar(FILE *,OP);	/* Prototyped sc.c:1184--VP  6jui01 */
extern INT 	fprint_tableaux(FILE *,OP);	/* Prototyped ta.c:674--VP  6jui01 */
extern INT 	fprint_vector(FILE *,OP);	/* Prototyped vc.c:900--VP  6jui01 */
extern INT 	fprintln(FILE *,OP);	/* Prototyped io.c:257--VP  6jui01 */
extern	INT free_cyclotomic_parameters ();
extern	INT free_root_parameters ();
extern	INT free_useful_monopolies ();
extern INT 	SYMfreeall(OP);	/* Prototyped rest.c:375--VP  6jui01 */
extern INT 	freeself(OP);	/* Prototyped rest.c:423--VP  6jui01 */
extern INT 	freeself_bintree(OP);	/* Prototyped bi.c:49--VP  6jui01 */
extern INT 	freeself_bitvector(OP);	/* Prototyped vc.c:467--VP  6jui01 */
extern INT 	freeself_bruch(OP);	/* Prototyped bruch.c:347--VP  6jui01 */
extern INT 	freeself_ff(OP);	/* Prototyped ff.c:824--VP  6jui01 */
extern INT 	freeself_graph(OP);	/* Prototyped gra.c:259--VP  6jui01 */
extern INT 	freeself_integer(OP);	/* Prototyped rest.c:1671--VP  6jui01 */
extern INT 	freeself_integervector(OP);	/* Prototyped vc.c:448--VP  6jui01 */
extern INT 	freeself_kranztypus(OP);	/* Prototyped ma.c:1009--VP  6jui01 */
extern INT 	freeself_list(OP);	/* Prototyped list.c:470--VP  6jui01 */
extern INT 	freeself_longint(OP);	/* Prototyped lo.c:1953--VP  6jui01 */
extern INT 	freeself_matrix(OP);	/* Prototyped ma.c:1024--VP  6jui01 */
extern INT 	freeself_monom(OP);	/* Prototyped poly.c:323--VP  6jui01 */
extern INT 	freeself_number(OP);	/* Prototyped nb.c:1368--VP  6jui01 */
extern INT 	freeself_partition(OP);	/* Prototyped part.c:1408--VP  6jui01 */
extern INT 	freeself_permutation(OP);	/* Prototyped perm.c:2650--VP  6jui01 */
extern INT 	freeself_reihe(OP);	/* Prototyped rh.c:1457--VP  6jui01 */
extern INT 	freeself_skewpartition(OP);	/* Prototyped rest.c:2386--VP  6jui01 */
extern INT 	freeself_symchar(OP);	/* Prototyped sc.c:1115--VP  6jui01 */
extern INT 	freeself_tableaux(OP);	/* Prototyped ta.c:308--VP  6jui01 */
extern INT 	freeself_vector(OP);	/* Prototyped vc.c:482--VP  6jui01 */
extern INT 	frip_latex_zykelind(OP);	/* Prototyped zykelind.c:4241--VP  6jui01 */
extern INT 	fusedmemory(FILE *,char *);	/* Prototyped de.c:480--VP  6jui01 */
extern INT 	ganzdiv(OP,OP,OP);	/* Prototyped nu.c:1121--VP  6jui01 */
extern INT 	ganzdiv_apply(OP,OP);	/* Prototyped nu.c:1131--VP  6jui01 */
extern INT 	ganzsquareroot(OP,OP);	/* Prototyped nu.c:44--VP  6jui01 */
extern INT 	ganzsquareroot_integer(OP,OP);	/* Prototyped nb.c:450--VP  6jui01 */
extern INT 	ganzsquareroot_longint(OP,OP);	/* Prototyped nb.c:441--VP  6jui01 */
extern INT 	garnir(OP,OP,OP,OP);	/* Prototyped ga.c:632--VP  6jui01 */
extern INT 	gauss_polynom(OP,OP,OP);	/* Prototyped poly.c:2288--VP  6jui01 */
extern INT 	gauss_schubert_polynom(OP,OP,OP);	/* Prototyped poly.c:1578--VP  6jui01 */
extern INT 	gcd_int_po(OP,OP,OP);	/* Prototyped bruch.c:1112--VP  6jui01 */
extern INT 	gcd_mp(OP,OP,OP);	/* Prototyped bruch.c:1288--VP  6jui01 */
extern INT 	gcd_mp_lent(OP,OP,OP);	/* Prototyped bruch.c:1265--VP  6jui01 */
extern INT 	ge(OP,OP);	/* Prototyped rest.c:1060--VP  6jui01 */
extern INT 	gen_mat();	/* Prototyped boe.c:952--VP  6jui01 */
extern INT 	gen_smat();	/* Prototyped boe.c:1136--VP  6jui01 */
extern	INT generate_root_tableaux ();
extern	INT generate_standard_tableaux ();
extern INT 	gengroup(OP);	/* Prototyped perm.c:2711--VP  6jui01 */
extern INT 	get_ax_dist(OP,OP,INT,INT);	/* Prototyped boe.c:1332--VP  6jui01 */
extern INT 	get_bv_i(OP,INT);	/* Prototyped vc.c:1523--VP  6jui01 */
extern INT 	get_index();	/* Prototyped boe.c:981--VP  6jui01 */
extern INT 	get_level_vector_of_verband(OP,OP,OP,INT (*)());	/* Prototyped gra.c:335--VP  6jui01 */
extern INT 	get_orb_rep();	/* Prototyped di.c:1226--VP  6jui01 */
extern INT 	get_perm();	/* Prototyped di.c:1496--VP  6jui01 */
extern INT 	get_position(OP,OP,INT);	/* Prototyped boe.c:1380--VP  6jui01 */
extern INT 	get_tex_polynom_parameter(INT);	/* Prototyped poly.c:16--VP  6jui01 */
extern INT 	get_time(OP);	/* Prototyped de.c:462--VP  6jui01 */
extern INT 	gewicht_v(OP,OP);	/* Prototyped wt.c:845--VP  6jui01 */
extern INT 	gewicht_wt(OP,OP);	/* Prototyped wt.c:884--VP  6jui01 */
extern INT 	ggt(OP,OP,OP);	/* Prototyped nu.c:1257--VP  6jui01 */
extern INT 	ggt_i(INT,INT);	/* Prototyped nu.c:1230--VP  6jui01 */
extern INT 	ggt_integer(OP,OP,OP);	/* Prototyped nu.c:1223--VP  6jui01 */
extern	INT gl_character ();
extern	INT gl_dimension ();
extern	INT gl_tableaux ();
extern INT 	glm_homtest(OP,OP);	/* Prototyped sab.c:2526--VP  6jui01 */
extern INT 	glmndg(OP,OP,OP,INT);	/* Prototyped sab.c:2866--VP  6jui01 */
extern INT 	glpdg(OP,OP,OP);	/* Prototyped sab.c:1986--VP  6jui01 */
extern INT 	gr(OP,OP);	/* Prototyped rest.c:1053--VP  6jui01 */
extern INT 	grouporder_kranz(OP,OP);	/* Prototyped nc.c:594--VP  6jui01 */
extern INT 	growingorder_schur(OP);	/* Prototyped pletint.c:6040--VP  6jui01 */
extern INT 	gt(OP,OP);	/* Prototyped rest.c:1067--VP  6jui01 */
extern INT 	gupta_nm(OP,OP,OP);	/* Prototyped part.c:434--VP  6jui01 */
extern INT 	gupta_nm_speicher(OP,OP,OP);	/* Prototyped part.c:518--VP  6jui01 */
extern INT 	gupta_tafel(OP,OP);	/* Prototyped part.c:480--VP  6jui01 */
extern INT 	half_apply(OP);	/* Prototyped nu.c:2071--VP  6jui01 */
extern INT 	half_apply_longint(OP);	/* Prototyped lo.c:2435--VP  6jui01 */
extern INT 	hall_littlewood(OP,OP);	/* Prototyped sr.c:1906--VP  6jui01 */
extern INT 	hall_littlewood_alt(OP,OP);	/* Prototyped sr.c:1638--VP  6jui01 */
extern INT 	hall_littlewood_dij(OP,OP,INT,INT);	/* Prototyped sr.c:1753--VP  6jui01 */
extern INT 	hall_littlewood_tafel(OP,OP);	/* Prototyped sr.c:1601--VP  6jui01 */
extern INT 	has_one_variable(OP);	/* Prototyped nb.c:4821--VP  6jui01 */
extern	INT hash_ende();
extern	INT hecke_action_lc_on_lc ();
extern	INT hecke_action_perm_on_hecke ();
extern	INT hecke_action_perm_on_lc ();
extern	INT hecke_add ();
extern INT 	hecke_dg(OP,OP,OP);	/* Prototyped hiccup.c:323--VP  6jui01 */
extern	INT hecke_generator_reps ();
extern	INT hecke_mult ();
extern	INT hecke_root_generator_reps ();
extern	INT hecke_scale ();
extern INT 	hfix_in_ww(OP,OP);	/* Prototyped di.c:1481--VP  6jui01 */
extern INT 	hoch(OP,OP,OP);	/* Prototyped nu.c:1328--VP  6jui01 */
extern INT 	hook_diagramm(OP,OP);	/* Prototyped part.c:566--VP  6jui01 */
extern INT 	hook_length(OP,OP,INT,INT);	/* Prototyped part.c:584--VP  6jui01 */
extern INT 	hook_length_augpart(OP,OP,INT,INT);	/* Prototyped part.c:543--VP  6jui01 */
extern INT 	hook_part(OP,OP);	/* Prototyped nc.c:1883--VP  6jui01 */
extern INT 	hookp(OP);	/* Prototyped rest.c:685--VP  6jui01 */
extern INT 	horizontal_sum(OP,OP);	/* Prototyped ga.c:55--VP  6jui01 */
extern INT 	hplus(OP,OP);	/* Prototyped ga.c:205--VP  6jui01 */
extern INT 	idempotent(OP,OP);	/* Prototyped ga.c:305--VP  6jui01 */
extern INT 	immanente_matrix(OP,OP,OP);	/* Prototyped ma.c:622--VP  6jui01 */
extern INT 	inc(OP);	/* Prototyped nu.c:860--VP  6jui01 */
extern INT 	inc_integer(OP);	/* Prototyped rest.c:1144--VP  6jui01 */
extern INT 	inc_longint(OP);	/* Prototyped lo.c:2293--VP  6jui01 */
extern INT 	inc_matrix(OP);	/* Prototyped ma.c:662--VP  6jui01 */
extern INT 	inc_partition(OP);	/* Prototyped part.c:53--VP  6jui01 */
extern INT 	inc_permutation(OP);	/* Prototyped perm.c:1961--VP  6jui01 */
extern INT 	inc_reihe(OP);	/* Prototyped rh.c:894--VP  6jui01 */
extern INT 	inc_tableaux(OP);	/* Prototyped ta.c:615--VP  6jui01 */
extern INT 	inc_vector(OP);	/* Prototyped vc.c:992--VP  6jui01 */
extern INT 	inc_vector_co(OP,INT);	/* Prototyped vc.c:997--VP  6jui01 */
extern INT 	index_vector(OP,OP);	/* Prototyped vc.c:1291--VP  6jui01 */
extern INT 	indexofpart(OP);	/* Prototyped part.c:996--VP  6jui01 */
extern INT 	inf_bitvector(OP,OP,OP);	/* Prototyped vc.c:1618--VP  6jui01 */
extern INT 	inf_bitvector_apply(OP,OP);	/* Prototyped vc.c:1654--VP  6jui01 */
extern INT 	inhalt(OP,OP);	/* Prototyped nu.c:545--VP  6jui01 */
extern INT 	inhalt_tableaux(OP,OP);	/* Prototyped ta.c:808--VP  6jui01 */
extern INT 	inhalt_word(OP,OP);	/* Prototyped rest.c:2705--VP  6jui01 */
extern INT 	init(OBJECTKIND,OP);	/* Prototyped rest.c:1896--VP  6jui01 */
extern INT 	init_bintree(OP);	/* Prototyped bi.c:62--VP  6jui01 */
extern INT 	init_cyclo(OP);	/* Prototyped nb.c:1236--VP  6jui01 */
extern INT 	init_hall_littlewood(OP,OP);	/* Prototyped sr.c:1661--VP  6jui01 */
extern INT 	init_kostka(OP,OP,OP);	/* Prototyped ko.c:588--VP  6jui01 */
extern INT 	init_kranz(OP);	/* Prototyped perm.c:475--VP  6jui01 */
extern INT 	init_longint(OP);	/* Prototyped lo.c:1872--VP  6jui01 */
extern INT 	init_reihe(OP);	/* Prototyped rh.c:235--VP  6jui01 */
extern INT 	init_sqrad(OP);	/* Prototyped nb.c:1223--VP  6jui01 */
extern INT 	inner_tensor_sc(OP,OP,OP);	/* Prototyped sc.c:1015--VP  6jui01 */
extern INT 	innermaxmofn(OP,OP,OP);	/* Prototyped sc.c:1401--VP  6jui01 */
extern	INT input_lc_permutations ();
extern	INT input_tableau ();
extern INT 	insert(OP,OP,INT (*)(),INT (*)());	/* Prototyped rest.c:2026--VP  6jui01 */
extern INT 	insert_bintree(OP,OP,INT (*)(),INT (*)());	/* Prototyped bi.c:119--VP  6jui01 */
extern INT 	insert_bt_bt(OP,OP,INT (*)(),INT (*)());	/* Prototyped bi.c:155--VP  6jui01 */
extern INT 	insert_list(OP,OP,INT (*)(),INT (*)());	/* Prototyped list.c:118--VP  6jui01 */
extern INT 	insert_list_list_2(OP,OP,INT (*)(),INT (*)());	/* Prototyped list.c:663--VP  6jui01 */
extern INT 	integer_factor(OP,OP);	/* Prototyped nb.c:755--VP  6jui01 */
extern INT 	integer_factors_to_integer(OP,OP);	/* Prototyped nb.c:152--VP  6jui01 */
extern INT 	intlog(OP);	/* Prototyped rest.c:1878--VP  6jui01 */
extern INT 	invers(OP,OP);	/* Prototyped nu.c:1403--VP  6jui01 */
extern INT 	invers_POLYNOM(OP,OP);	/* Prototyped poly.c:2339--VP  6jui01 */
extern INT 	invers_apply(OP);	/* Prototyped nu.c:1870--VP  6jui01 */
extern INT 	invers_apply_integer(OP);	/* Prototyped rest.c:1122--VP  6jui01 */
extern INT 	invers_bar(OP,OP);	/* Prototyped bar.c:31--VP  6jui01 */
extern INT 	invers_bruch(OP,OP);	/* Prototyped bruch.c:240--VP  6jui01 */
extern INT 	invers_cyclo(OP,OP);	/* Prototyped nb.c:4157--VP  6jui01 */
extern INT 	invers_ff(OP,OP);	/* Prototyped ff.c:1052--VP  6jui01 */
extern INT 	invers_integer(OP,OP);	/* Prototyped rest.c:1461--VP  6jui01 */
extern INT 	invers_laurent(OP,OP);	/* Prototyped rest.c:3444--VP  6jui01 */
extern INT 	invers_matrix(OP,OP);	/* Prototyped ma.c:695--VP  6jui01 */
extern INT 	invers_monopoly(OP,OP);	/* Prototyped nb.c:4772--VP  6jui01 */
extern INT 	invers_permutation(OP,OP);	/* Prototyped perm.c:1685--VP  6jui01 */
extern INT 	invers_polynom(OP,OP);	/* Prototyped sb.c:1077--VP  6jui01 */
extern INT 	invers_sqrad(OP,OP);	/* Prototyped nb.c:2951--VP  6jui01 */
extern INT 	inverse_jeudetaquin_tableaux(OP,OP,INT,INT);	/* Prototyped ta.c:158--VP  6jui01 */
extern INT 	inverse_nilplactic_jeudetaquin_tableaux(OP,OP,INT,INT);	/* Prototyped ta.c:78--VP  6jui01 */
extern INT 	inversion_matrix_perm(OP,OP);	/* Prototyped wt.c:420--VP  6jui01 */
extern INT 	inversordcen(OP,OP);	/* Prototyped part.c:1498--VP  6jui01 */
extern INT 	is_scalar_polynom(OP);	/* Prototyped poly.c:2137--VP  6jui01 */
extern INT 	is_scalar_reihe(OP);	/* Prototyped rh.c:1353--VP  6jui01 */
extern INT 	jacobi(OP,OP,OP);	/* Prototyped nb.c:1002--VP  6jui01 */
extern INT 	jeudetaquin_tableaux(OP,OP);	/* Prototyped ta.c:206--VP  6jui01 */
extern INT 	kgv(OP,OP,OP);	/* Prototyped nu.c:192--VP  6jui01 */
extern INT 	kl(OP,OP,OP);	/* Prototyped kl.c:4904--VP  6jui01 */
extern INT 	konj_gral_perm(OP,OP,OP);	/* Prototyped ga.c:181--VP  6jui01 */
extern INT 	konj_perm_perm(OP,OP,OP);	/* Prototyped ga.c:8--VP  6jui01 */
extern INT 	konjugation(OP,OP,OP,INT);	/* Prototyped ga.c:104--VP  6jui01 */
extern INT 	konjugation2(OP,OP,OP);	/* Prototyped ga.c:369--VP  6jui01 */
extern INT 	konjugierende(OP,OP,INT);	/* Prototyped ga.c:150--VP  6jui01 */
extern INT 	kostka_character(OP,OP);	/* Prototyped ko.c:830--VP  6jui01 */
extern INT 	kostka_number(OP,OP,OP);	/* Prototyped ko.c:26--VP  6jui01 */
extern INT 	kostka_number_partition(OP,OP,OP);	/* Prototyped ko.c:66--VP  6jui01 */
extern INT 	kostka_number_skewpartition(OP,OP,OP);	/* Prototyped ko.c:1046--VP  6jui01 */
extern INT 	kostka_tab(OP,OP,OP);	/* Prototyped ko.c:640--VP  6jui01 */
extern INT 	kostka_tafel(OP,OP);	/* Prototyped ko.c:139--VP  6jui01 */
extern INT 	kranztafel(OP,OP,OP,OP,OP);	/* Prototyped perm.c:859--VP  6jui01 */
extern INT 	kranztypus_charakteristik(OP,OP);	/* Prototyped perm.c:720--VP  6jui01 */
extern INT 	kranztypus_kranztypus_monom(OP,OP,OP);	/* Prototyped perm.c:682--VP  6jui01 */
extern INT 	kranztypus_to_matrix(OP,OP);	/* Prototyped perm.c:615--VP  6jui01 */
extern INT 	kronecker(OP,OP,OP);	/* Prototyped nb.c:1095--VP  6jui01 */
extern INT 	kronecker_product(OP,OP,OP);	/* Prototyped ma.c:1713--VP  6jui01 */
extern INT 	krz(OP);	/* Prototyped bruch.c:1354--VP  6jui01 */
extern INT 	krz(OP);	/* Prototyped bruch.c:1354--VP  6jui01 */
extern INT 	kuerzen(OP);	/* Prototyped bruch.c:607--VP  6jui01 */
extern INT 	kuerzen_old(OP);	/* Prototyped bruch.c:613--VP  6jui01 */
extern INT 	kung_formel(OP,OP,OP,OP);	/* Prototyped zykelind.c:1436--VP  6jui01 */
extern INT 	l_complete_complete_plet(OP,OP,OP,OP);	/* Prototyped pletint.c:6220--VP  6jui01 */
extern INT 	l_complete_schur_plet(OP,OP,OP,OP);	/* Prototyped pletint.c:6067--VP  6jui01 */
extern INT 	l_elementary_schur_plet(OP,OP,OP,OP);	/* Prototyped pletint.c:6147--VP  6jui01 */
extern INT 	l_outerproduct_schur_lrs(OP,OP,OP,OP);	/* Prototyped pletint.c:4344--VP  6jui01 */
extern INT 	l_power_schur_plet(OP,OP,OP,OP);	/* Prototyped pletint.c:6488--VP  6jui01 */
extern INT 	l_powerproduct_schur_plet(OP,OP,OP,OP);	/* Prototyped pletint.c:6613--VP  6jui01 */
extern INT 	l_schur_monomial_mult(OP,OP,OP,OP);	/* Prototyped pletint.c:5868--VP  6jui01 */
extern INT 	l_schur_power_schur_plet_mult(OP,OP,OP,OP,OP);	/* Prototyped pletint.c:6531--VP  6jui01 */
extern INT 	l_schur_powerproduct_schur_plet_mult(OP,OP,OP,OP,OP);	/* Prototyped pletint.c:6569--VP  6jui01 */
extern INT 	l_schur_schur_plet(OP,OP,OP,OP);	/* Prototyped pletint.c:6252--VP  6jui01 */
extern INT 	l_schur_schur_pletbis(OP,OP,OP,OP);	/* Prototyped pletint.c:6655--VP  6jui01 */
extern INT 	l_t_monomial_schur(OP,OP,OP);	/* Prototyped pletint.c:6001--VP  6jui01 */
extern INT 	lagrange_polynom(OP,OP,OP);	/* Prototyped poly.c:1699--VP  6jui01 */
extern INT 	last_lehmercode(OP,OP);	/* Prototyped perm.c:1382--VP  6jui01 */
extern INT 	last_part_EXPONENT(OP,OP);	/* Prototyped part.c:744--VP  6jui01 */
extern INT 	last_part_VECTOR(OP,OP);	/* Prototyped part.c:769--VP  6jui01 */
extern INT 	last_partition(OP,OP);	/* Prototyped part.c:799--VP  6jui01 */
extern INT 	last_permutation(OP,OP);	/* Prototyped perm.c:1980--VP  6jui01 */
extern INT 	lastof(OP,OP);	/* Prototyped rest.c:344--VP  6jui01 */
extern INT 	lastof_partition(OP,OP);	/* Prototyped part.c:1802--VP  6jui01 */
extern INT 	lastof_skewpartition(OP,OP);	/* Prototyped rest.c:2365--VP  6jui01 */
extern INT 	lastof_vector(OP,OP);	/* Prototyped vc.c:850--VP  6jui01 */
extern INT 	lastp(OP);	/* Prototyped rest.c:848--VP  6jui01 */
extern INT 	lastp_list(OP);	/* Prototyped list.c:200--VP  6jui01 */
extern INT 	latex_glm_dar(OP);	/* Prototyped io.c:914--VP  6jui01 */
extern INT 	latex_kranztafel(OP,OP,OP);	/* Prototyped perm.c:941--VP  6jui01 */
extern INT 	latex_line(INT,INT,INT,INT);	/* Prototyped gra.c:412--VP  6jui01 */
extern INT 	latex_verband(OP);	/* Prototyped gra.c:379--VP  6jui01 */
extern INT 	latticepword(OP);	/* Prototyped rest.c:2870--VP  6jui01 */
extern INT 	ldcf_monopoly(OP,OP);	/* Prototyped nb.c:4804--VP  6jui01 */
extern INT 	ldcf_mp(OP,OP);	/* Prototyped bruch.c:1071--VP  6jui01 */
extern INT 	le(OP,OP);	/* Prototyped rest.c:1074--VP  6jui01 */
extern INT 	leftkey_wt(OP,OP);	/* Prototyped wt.c:1015--VP  6jui01 */
extern INT 	lehmercode(OP,OP);	/* Prototyped nu.c:227--VP  6jui01 */
extern INT 	lehmercode2_permutation(OP,OP);	/* Prototyped perm.c:1666--VP  6jui01 */
extern INT 	lehmercode_bar(OP,OP);	/* Prototyped bar.c:606--VP  6jui01 */
extern INT 	lehmercode_permutation(OP,OP);	/* Prototyped perm.c:1514--VP  6jui01 */
extern INT 	lehmercode_tableaux(OP,OP);	/* Prototyped ta.c:1269--VP  6jui01 */
extern INT 	lehmercode_vector(OP,OP);	/* Prototyped perm.c:1547--VP  6jui01 */
extern INT 	lehmercode_vector_bar(OP,OP);	/* Prototyped bar.c:680--VP  6jui01 */
extern INT 	length(OP,OP);	/* Prototyped nu.c:486--VP  6jui01 */
extern INT 	length_bar(OP,OP);	/* Prototyped bar.c:584--VP  6jui01 */
extern INT 	length_list(OP,OP);	/* Prototyped list.c:271--VP  6jui01 */
extern INT 	length_partition(OP,OP);	/* Prototyped part.c:1810--VP  6jui01 */
extern INT 	length_permutation(OP,OP);	/* Prototyped perm.c:1890--VP  6jui01 */
extern INT 	length_reihe(OP,OP);	/* Prototyped rh.c:2590--VP  6jui01 */
extern INT 	length_skewpartition(OP,OP);	/* Prototyped rest.c:2377--VP  6jui01 */
extern INT 	length_vector(OP,OP);	/* Prototyped vc.c:857--VP  6jui01 */
extern INT 	list_anfang();	/* Prototyped list.c:14--VP  6jui01 */
extern INT 	list_ende();	/* Prototyped list.c:27--VP  6jui01 */
extern INT 	listp(OP);	/* Prototyped rest.c:1081--VP  6jui01 */
extern INT 	longint_ende();	/* Prototyped lo.c:1754--VP  6jui01 */
extern INT 	longint_release();	/* Prototyped lo.c:1738--VP  6jui01 */
extern INT 	lt(OP,OP);	/* Prototyped rest.c:1024--VP  6jui01 */
extern INT 	lyndon_orb(OP,OP,OP);	/* Prototyped di.c:1406--VP  6jui01 */
extern INT 	m_2schubert_wt(OP,OP);	/* Prototyped wt.c:1424--VP  6jui01 */
extern INT 	m_INTEGER_elmtrans(OP,OP);	/* Prototyped perm.c:2885--VP  6jui01 */
extern INT 	m_INT_elmtrans(INT,OP);	/* Prototyped perm.c:2890--VP  6jui01 */
extern INT 	m_T_pol_summe(OP,OP);	/* Prototyped wt.c:242--VP  6jui01 */
extern INT 	m_T_tableaux_summe(OP,OP);	/* Prototyped wt.c:265--VP  6jui01 */
extern INT 	m_T_wt_summe(OP,OP);	/* Prototyped wt.c:253--VP  6jui01 */
extern INT 	m_bar_schubert(OP,OP);	/* Prototyped bar.c:801--VP  6jui01 */
extern INT 	m_cosinus_reihe(OP);	/* Prototyped rh.c:2065--VP  6jui01 */
extern INT 	m_d_sc(OP,OP);	/* Prototyped sc.c:1227--VP  6jui01 */
extern INT 	m_eins_reihe(OP);	/* Prototyped rh.c:2088--VP  6jui01 */
extern INT 	m_ff_vector(OP,OP);	/* Prototyped ff.c:1848--VP  6jui01 */
extern INT 	m_function_reihe(OP,INT (*)());	/* Prototyped rh.c:849--VP  6jui01 */
extern INT 	m_gk_spa(OP,OP,OP);	/* Prototyped rest.c:2535--VP  6jui01 */
extern INT 	m_gl_alt(OP,OP);	/* Prototyped nc.c:817--VP  6jui01 */
extern INT 	m_gl_chartafel(OP,OP);	/* Prototyped nc.c:477--VP  6jui01 */
extern INT 	m_gl_cl(OP,OP);	/* Prototyped nc.c:337--VP  6jui01 */
extern INT 	m_gl_co(OP,OP);	/* Prototyped nc.c:366--VP  6jui01 */
extern INT 	m_gl_cr(OP,OP);	/* Prototyped nc.c:433--VP  6jui01 */
extern INT 	m_gl_cyclic(OP,OP);	/* Prototyped nc.c:807--VP  6jui01 */
extern INT 	m_gl_first(OP,OP);	/* Prototyped nc.c:1929--VP  6jui01 */
extern INT 	m_gl_go(OP,OP);	/* Prototyped nc.c:226--VP  6jui01 */
extern INT 	m_gl_hyp(OP,OP);	/* Prototyped nc.c:800--VP  6jui01 */
extern INT 	m_gl_il(OP,OP);	/* Prototyped nc.c:250--VP  6jui01 */
extern INT 	m_gl_nc(OP,OP,OP);	/* Prototyped nc.c:280--VP  6jui01 */
extern INT 	m_gl_next(OP,OP,OP);	/* Prototyped nc.c:1941--VP  6jui01 */
extern INT 	m_gl_sym(OP,OP);	/* Prototyped nc.c:827--VP  6jui01 */
extern INT 	m_gl_symkranz(OP,OP,OP);	/* Prototyped nc.c:785--VP  6jui01 */
extern INT 	m_i_elmsym(INT,OP);	/* Prototyped sr.c:2224--VP  6jui01 */
extern INT 	m_i_i(INT,OP);	/* Prototyped rest.c:1660--VP  6jui01 */
extern INT 	m_i_longint(OP,INT);	/* Prototyped lo.c:2598--VP  6jui01 */
extern INT 	m_i_pa(OP,OP);	/* Prototyped part.c:1697--VP  6jui01 */
extern INT 	m_i_schubert(INT,OP);	/* Prototyped sb.c:1060--VP  6jui01 */
extern INT 	m_i_schur(INT,OP);	/* Prototyped sr.c:2237--VP  6jui01 */
extern INT 	m_i_staircase(OP,OP);	/* Prototyped part.c:58--VP  6jui01 */
extern INT 	m_iindex_iexponent_monom(INT,INT,OP);	/* Prototyped poly.c:1760--VP  6jui01 */
extern INT 	m_iindex_monom(INT,OP);	/* Prototyped poly.c:1751--VP  6jui01 */
extern INT 	m_iindex_monopoly(INT,OP);	/* Prototyped nb.c:2405--VP  6jui01 */
extern INT 	m_il_bv(INT,OP);	/* Prototyped vc.c:128--VP  6jui01 */
extern INT 	m_il_nbv(INT,OP);	/* Prototyped vc.c:143--VP  6jui01 */
extern INT 	m_il_nv(INT,OP);	/* Prototyped vc.c:117--VP  6jui01 */
extern INT 	m_il_p(INT,OP);	/* Prototyped perm.c:1724--VP  6jui01 */
extern INT 	m_il_v(INT,OP);	/* Prototyped vc.c:161--VP  6jui01 */
extern INT 	m_ilih_m(INT,INT,OP);	/* Prototyped ma.c:447--VP  6jui01 */
extern INT 	m_ilih_nm(OP,INT,INT);	/* Prototyped ma.c:341--VP  6jui01 */
extern INT 	m_index_monom(OP,OP);	/* Prototyped poly.c:1742--VP  6jui01 */
extern INT 	m_int_pa(INT,OP);	/* Prototyped part.c:1682--VP  6jui01 */
extern INT 	m_ioiu_b(INT,INT,OP);	/* Prototyped bruch.c:450--VP  6jui01 */
extern INT 	m_kl_pa(OBJECTKIND,OP,OP);	/* Prototyped part.c:1764--VP  6jui01 */
extern INT 	m_ks_p(OBJECTKIND,OP,OP);	/* Prototyped perm.c:1733--VP  6jui01 */
extern INT 	m_ks_pa(OP,OP,OBJECTKIND);	/* Prototyped part.c:1734--VP  6jui01 */
extern INT 	m_ksd_n(OBJECTKIND,OP,OP,OP);	/* Prototyped nb.c:1208--VP  6jui01 */
extern INT 	m_l_nv(OP,OP);	/* Prototyped vc.c:111--VP  6jui01 */
extern INT 	m_l_v(OP,OP);	/* Prototyped vc.c:257--VP  6jui01 */
extern INT 	m_lehmer_schubert_monom_summe(OP,OP);	/* Prototyped sb.c:53--VP  6jui01 */
extern INT 	m_lh_m(OP,OP,OP);	/* Prototyped ma.c:407--VP  6jui01 */
extern INT 	m_lh_nm(OP,OP,OP);	/* Prototyped ma.c:357--VP  6jui01 */
extern INT 	m_matrix_tableaux(OP,OP);	/* Prototyped ta.c:426--VP  6jui01 */
extern INT 	m_matrix_umriss(OP,OP);	/* Prototyped ta.c:447--VP  6jui01 */
extern INT 	m_nc_kranz(OP,OP,OP);	/* Prototyped nc.c:748--VP  6jui01 */
extern INT 	m_o_v(OP,OP);	/* Prototyped vc.c:86--VP  6jui01 */
extern INT 	m_ou_b(OP,OP,OP);	/* Prototyped bruch.c:422--VP  6jui01 */
extern INT 	m_pa_s(OP,OP);	/* Prototyped sr.c:1067--VP  6jui01 */
extern INT 	m_part_Qschur(OP,OP);	/* Prototyped sr.c:3381--VP  6jui01 */
extern INT 	m_part_centralsc(OP,OP);	/* Prototyped sc.c:642--VP  6jui01 */
extern INT 	m_part_kostkaperm(OP,OP);	/* Prototyped ko.c:844--VP  6jui01 */
extern INT 	m_part_part_perm(OP,OP,OP);	/* Prototyped sr.c:1453--VP  6jui01 */
extern INT 	m_part_perm(OP,OP);	/* Prototyped perm.c:2283--VP  6jui01 */
extern INT 	m_part_qelm(OP,OP);	/* Prototyped sr.c:2154--VP  6jui01 */
extern INT 	m_part_sc(OP,OP);	/* Prototyped sc.c:666--VP  6jui01 */
extern INT 	m_part_sc_tafel(OP,OP,OP);	/* Prototyped sc.c:673--VP  6jui01 */
extern INT 	m_part_tableaux(OP,OP,OP);	/* Prototyped part.c:1096--VP  6jui01 */
extern INT 	m_part_youngsc(OP,OP);	/* Prototyped sc.c:1497--VP  6jui01 */
extern INT 	m_perm_2schubert_monom_summe(OP,OP);	/* Prototyped sb.c:1298--VP  6jui01 */
extern INT 	m_perm_2schubert_operating_monom_summe(OP,OP,OP);	/* Prototyped sb.c:1539--VP  6jui01 */
extern INT 	m_perm_2wt_summe(OP,OP);	/* Prototyped wt.c:1412--VP  6jui01 */
extern INT 	m_perm_paareperm(OP,OP);	/* Prototyped perm.c:1312--VP  6jui01 */
extern INT 	m_perm_reihe(OP);	/* Prototyped rh.c:2054--VP  6jui01 */
extern INT 	m_perm_rz_number(OP,OP);	/* Prototyped perm.c:3040--VP  6jui01 */
extern INT 	m_perm_rz_set(OP,OP);	/* Prototyped perm.c:2984--VP  6jui01 */
extern INT 	m_perm_sch(OP,OP);	/* Prototyped sb.c:597--VP  6jui01 */
extern INT 	m_perm_schubert_dimension(OP,OP);	/* Prototyped sb.c:120--VP  6jui01 */
extern INT 	m_perm_schubert_monom_summe(OP,OP);	/* Prototyped sb.c:70--VP  6jui01 */
extern INT 	m_perm_schubert_qpolynom(OP,OP);	/* Prototyped sb.c:107--VP  6jui01 */
extern INT 	m_perm_schur(OP,OP);	/* Prototyped sr.c:1499--VP  6jui01 */
extern INT 	m_perm_sdwt_summe(OP,OP);	/* Prototyped wt.c:296--VP  6jui01 */
extern INT 	m_perm_skwt_summe(OP,OP);	/* Prototyped wt.c:307--VP  6jui01 */
extern INT 	m_perm_snwt_summe(OP,OP);	/* Prototyped wt.c:285--VP  6jui01 */
extern INT 	m_perm_tableaux_summe(OP,OP);	/* Prototyped wt.c:331--VP  6jui01 */
extern INT 	m_perm_vector_kranz(OP,OP,OP);	/* Prototyped perm.c:485--VP  6jui01 */
extern INT 	m_perm_wt_summe(OP,OP);	/* Prototyped wt.c:319--VP  6jui01 */
extern INT 	m_s_po(OP,OP);	/* Prototyped poly.c:298--VP  6jui01 */
extern INT 	m_scalar_bruch(OP,OP);	/* Prototyped bruch.c:702--VP  6jui01 */
extern INT 	m_scalar_elmsym(OP,OP);	/* Prototyped sr.c:2253--VP  6jui01 */
extern INT 	m_scalar_polynom(OP,OP);	/* Prototyped poly.c:1815--VP  6jui01 */
extern INT 	m_scalar_reihe(OP,OP);	/* Prototyped rh.c:865--VP  6jui01 */
extern INT 	m_scalar_schur(OP,OP);	/* Prototyped sr.c:2268--VP  6jui01 */
extern INT 	m_sinus_reihe(OP);	/* Prototyped rh.c:2099--VP  6jui01 */
extern INT 	m_sk_gr(OP,OP,OBJECTKIND);	/* Prototyped gra.c:50--VP  6jui01 */
extern INT 	m_sk_mo(OP,OP,OP);	/* Prototyped poly.c:175--VP  6jui01 */
extern INT 	m_skewpart_skewperm(OP,OP);	/* Prototyped sr.c:1817--VP  6jui01 */
extern INT 	m_skn_mp(OP,OP,OP,OP);	/* Prototyped nb.c:1706--VP  6jui01 */
extern INT 	m_skn_po(OP,OP,OP,OP);	/* Prototyped poly.c:1195--VP  6jui01 */
extern INT 	m_skn_s(OP,OP,OP,OP);	/* Prototyped sr.c:1155--VP  6jui01 */
extern INT 	m_skn_sch(OP,OP,OP,OP);	/* Prototyped sb.c:543--VP  6jui01 */
extern INT 	m_sn_l(OP,OP,OP);	/* Prototyped list.c:235--VP  6jui01 */
extern INT 	m_tableaux_polynom(OP,OP);	/* Prototyped part.c:1069--VP  6jui01 */
extern INT 	m_tableaux_tableauxpair(OP,OP,OP);	/* Prototyped rest.c:2819--VP  6jui01 */
extern INT 	m_u_t(OP,OP);	/* Prototyped ta.c:278--VP  6jui01 */
extern INT 	m_umriss_tableaux(OP,OP,OP);	/* Prototyped part.c:1111--VP  6jui01 */
extern INT 	m_us_t(OP,OP,OP);	/* Prototyped ta.c:349--VP  6jui01 */
extern INT 	m_v_pa(OP,OP);	/* Prototyped part.c:1632--VP  6jui01 */
extern INT 	m_v_po_mz(OP,OP,OP);	/* Prototyped zykelind.c:4790--VP  6jui01 */
extern INT 	m_v_s(OP,OP);	/* Prototyped sr.c:1097--VP  6jui01 */
extern INT 	m_vcl_kranz(OP,OP);	/* Prototyped nc.c:640--VP  6jui01 */
extern INT 	m_vco_kranz(OP,OP);	/* Prototyped nc.c:668--VP  6jui01 */
extern INT 	m_vec_grad_nc_hyp(OP,OP,OP);	/* Prototyped nc.c:523--VP  6jui01 */
extern INT 	m_vec_vec_poly(OP,OP,OP);	/* Prototyped poly.c:2096--VP  6jui01 */
extern INT 	m_vector_diagonalmatrix(OP,OP);	/* Prototyped ma.c:1658--VP  6jui01 */
extern INT 	m_vector_ff(OP,OP,OP);	/* Prototyped ff.c:1817--VP  6jui01 */
extern INT 	m_vector_graph(OP,OP,INT (*)());	/* Prototyped gra.c:183--VP  6jui01 */
extern INT 	m_wpd_sc(OP,OP,OP,OP);	/* Prototyped sc.c:1274--VP  6jui01 */
extern INT 	m_wt_tableaux(OP,OP);	/* Prototyped wt.c:951--VP  6jui01 */
extern INT 	m_wt_wtkontertab(OP,OP);	/* Prototyped wt.c:1051--VP  6jui01 */
extern INT 	m_wt_wttab(OP,OP);	/* Prototyped wt.c:962--VP  6jui01 */
extern INT 	m_wttab_tableaux(OP,OP);	/* Prototyped wt.c:1069--VP  6jui01 */
extern INT 	make_all_st_tabs();	/* Prototyped boe.c:220--VP  6jui01 */
extern INT 	make_alt_classes();	/* Prototyped nc.c:919--VP  6jui01 */
extern INT 	make_alt_partitions();	/* Prototyped nc.c:1285--VP  6jui01 */
extern INT 	make_coprimes(OP,OP);	/* Prototyped nb.c:189--VP  6jui01 */
extern INT 	make_cyclotomic_monopoly(OP,OP);	/* Prototyped nb.c:2470--VP  6jui01 */
extern INT 	make_ij_part(INT,INT,OP,OP);	/* Prototyped ko.c:421--VP  6jui01 */
extern INT 	make_index_coeff_power_cyclo(OP,OP,OP,OP);	/* Prototyped nb.c:3828--VP  6jui01 */
extern INT 	make_monopoly_sqrad(OP,OP);	/* Prototyped nb.c:2567--VP  6jui01 */
extern INT 	make_n_id(OP,OP);	/* Prototyped perm.c:2874--VP  6jui01 */
extern INT 	make_n_kelmtrans(OP,OP,OP);	/* Prototyped perm.c:2905--VP  6jui01 */
extern INT 	make_n_transpositionmatrix(OP,OP);	/* Prototyped ko.c:149--VP  6jui01 */
extern INT 	make_neu_partij_schur();	/* Prototyped ko.c:495--VP  6jui01 */
extern INT 	make_nzykel(OP,OP);	/* Prototyped perm.c:2862--VP  6jui01 */
extern INT 	make_partij_perm(OP,OP,INT,INT);	/* Prototyped ko.c:440--VP  6jui01 */
extern INT 	make_partij_schur(OP,OP,INT,INT);	/* Prototyped ko.c:519--VP  6jui01 */
extern INT 	make_real_cycletype(OP,OP);	/* Prototyped di.c:242--VP  6jui01 */
extern INT 	make_scalar_cyclo(OP,OP);	/* Prototyped nb.c:3809--VP  6jui01 */
extern INT 	make_scalar_sqrad(OP,OP);	/* Prototyped nb.c:2615--VP  6jui01 */
extern INT 	make_tab_signs();	/* Prototyped boe.c:217--VP  6jui01 */
extern INT 	make_unitary0_monopoly(OP,OP);	/* Prototyped nb.c:2415--VP  6jui01 */
extern INT 	make_unitary_eins_monopoly(OP,OP);	/* Prototyped nb.c:2439--VP  6jui01 */
extern INT 	makealtclassreps();	/* Prototyped nc.c:911--VP  6jui01 */
extern INT 	makevectorof_class_bar(OP,OP);	/* Prototyped bar.c:402--VP  6jui01 */
extern INT 	makevectorof_class_rep_bar(OP,OP);	/* Prototyped bar.c:388--VP  6jui01 */
extern INT 	makevectorof_kranztypus(OP,OP,OP);	/* Prototyped perm.c:596--VP  6jui01 */
extern INT 	makevectorofpart(OP,OP);	/* Prototyped part.c:2058--VP  6jui01 */
extern INT 	makevectorofperm(OP,OP);	/* Prototyped perm.c:3116--VP  6jui01 */
extern INT 	makevectorofrect_lehmercode(OP,OP);	/* Prototyped perm.c:3261--VP  6jui01 */
extern INT 	makevectorofrect_permutation(OP,OP);	/* Prototyped perm.c:3244--VP  6jui01 */
extern INT 	makevectorofshuffle(OP,OP,OP);	/* Prototyped sc.c:1050--VP  6jui01 */
extern INT 	makevectoroftableaux(OP,OP,OP);	/* Prototyped ta.c:1501--VP  6jui01 */
extern INT 	makevectoroftranspositions(OP,OP);	/* Prototyped perm.c:2770--VP  6jui01 */
extern INT 	matrix_monom_ypolynom(OP,OP,OP,OP,OP);	/* Prototyped perm.c:786--VP  6jui01 */
extern INT 	matrix_to_kranztypus(OP,OP);	/* Prototyped perm.c:650--VP  6jui01 */
extern INT 	matrixp(OP);	/* Prototyped ma.c:110--VP  6jui01 */
extern INT 	max(OP,OP);	/* Prototyped nu.c:73--VP  6jui01 */
extern INT 	max_bar(OP,OP);	/* Prototyped bar.c:336--VP  6jui01 */
extern INT 	max_degree_reihe(OP,OP);	/* Prototyped rh.c:156--VP  6jui01 */
extern INT 	max_divideddiff(OP,OP,OP);	/* Prototyped perm.c:230--VP  6jui01 */
extern INT 	max_matrix(OP,OP);	/* Prototyped ma.c:1671--VP  6jui01 */
extern INT 	max_vector(OP,OP);	/* Prototyped vc.c:1064--VP  6jui01 */
extern INT 	maxdegree_schubert(OP,OP);	/* Prototyped sb.c:16--VP  6jui01 */
extern INT 	maximalplace(OP);	/* Prototyped perm.c:1995--VP  6jui01 */
extern INT 	maxorder_young(OP,OP);	/* Prototyped perm.c:2920--VP  6jui01 */
extern INT 	maxrindexword(OP,OP,OP,OP);	/* Prototyped rest.c:2847--VP  6jui01 */
extern INT 	mem_callocobject_dec();	/* Prototyped rest.c:25--VP  6jui01 */
extern INT 	mem_callocobject_inc();	/* Prototyped rest.c:21--VP  6jui01 */
extern INT 	mem_size(OP);	/* Prototyped de.c:832--VP  6jui01 */
extern INT 	mem_size_matrix(OP);	/* Prototyped ma.c:71--VP  6jui01 */
extern INT 	mem_size_vector(OP);	/* Prototyped vc.c:184--VP  6jui01 */
extern INT 	mem_small();	/* Prototyped de.c:504--VP  6jui01 */
extern INT 	memcheck(char *);	/* Prototyped de.c:520--VP  6jui01 */
extern INT 	mod(OP,OP,OP);	/* Prototyped nu.c:1099--VP  6jui01 */
extern INT 	mod_integer(OP,OP,OP);	/* Prototyped rest.c:1278--VP  6jui01 */
extern INT 	mod_matrix(OP,OP,OP);	/* Prototyped ma.c:89--VP  6jui01 */
extern INT 	mod_part(OP,OP,OP);	/* Prototyped sr.c:2062--VP  6jui01 */
extern	INT moddg();
extern INT 	moebius(OP,OP);	/* Prototyped nu.c:2295--VP  6jui01 */
extern INT 	moebius_tafel(OP,OP);	/* Prototyped ko.c:867--VP  6jui01 */
extern INT 	monom_anfang();	/* Prototyped poly.c:47--VP  6jui01 */
extern INT 	monom_ende();	/* Prototyped poly.c:75--VP  6jui01 */
extern INT 	monom_release();	/* Prototyped poly.c:57--VP  6jui01 */
extern INT 	mp_is_cst(OP);	/* Prototyped bruch.c:1333--VP  6jui01 */
extern INT 	mult(OP,OP,OP);	/* Prototyped nu.c:1479--VP  6jui01 */
extern INT 	mult_apply(OP,OP);	/* Prototyped nu.c:1984--VP  6jui01 */
extern INT 	mult_apply_bruch(OP,OP);	/* Prototyped bruch.c:816--VP  6jui01 */
extern INT 	mult_apply_bruch_scalar(OP,OP);	/* Prototyped bruch.c:725--VP  6jui01 */
extern INT 	mult_apply_cyclo(OP,OP);	/* Prototyped nb.c:4251--VP  6jui01 */
extern INT 	mult_apply_ff(OP,OP);	/* Prototyped ff.c:1084--VP  6jui01 */
extern INT 	mult_apply_gral(OP,OP);	/* Prototyped ga.c:508--VP  6jui01 */
extern INT 	mult_apply_integer(OP,OP);	/* Prototyped rest.c:1787--VP  6jui01 */
extern INT 	mult_apply_integer_bruch(OP,OP);	/* Prototyped rest.c:1775--VP  6jui01 */
extern INT 	mult_apply_integer_integer(OP,OP);	/* Prototyped rest.c:1826--VP  6jui01 */
extern INT 	mult_apply_integer_longint(OP,OP);	/* Prototyped lo.c:2237--VP  6jui01 */
extern INT 	mult_apply_integer_matrix(OP,OP);	/* Prototyped rest.c:1761--VP  6jui01 */
extern INT 	mult_apply_longint(OP,OP);	/* Prototyped lo.c:2136--VP  6jui01 */
extern INT 	mult_apply_longint_integer(OP,OP);	/* Prototyped lo.c:2212--VP  6jui01 */
extern INT 	mult_apply_longint_longint(OP,OP);	/* Prototyped lo.c:2185--VP  6jui01 */
extern INT 	mult_apply_longint_matrix(OP,OP);	/* Prototyped lo.c:2122--VP  6jui01 */
extern INT 	mult_apply_matrix(OP,OP);	/* Prototyped ma.c:1496--VP  6jui01 */
extern INT 	mult_apply_matrix_matrix(OP,OP);	/* Prototyped ma.c:1406--VP  6jui01 */
extern INT 	mult_apply_monopoly(OP,OP);	/* Prototyped nb.c:2261--VP  6jui01 */
extern INT 	mult_apply_polynom(OP,OP);	/* Prototyped poly.c:671--VP  6jui01 */
extern INT 	mult_apply_polynom_polynom(OP,OP);	/* Prototyped poly.c:707--VP  6jui01 */
extern INT 	mult_apply_polynom_scalar(OP,OP);	/* Prototyped poly.c:655--VP  6jui01 */
extern INT 	mult_apply_reihe(OP,OP);	/* Prototyped rh.c:2407--VP  6jui01 */
extern INT 	mult_apply_scalar_bruch(OP,OP);	/* Prototyped bruch.c:713--VP  6jui01 */
extern INT 	mult_apply_scalar_matrix(OP,OP);	/* Prototyped ma.c:1394--VP  6jui01 */
extern INT 	mult_apply_scalar_monom(OP,OP);	/* Prototyped poly.c:734--VP  6jui01 */
extern INT 	mult_apply_scalar_polynom(OP,OP);	/* Prototyped poly.c:741--VP  6jui01 */
extern INT 	mult_apply_sqrad(OP,OP);	/* Prototyped nb.c:3063--VP  6jui01 */
extern INT 	mult_apply_symchar(OP,OP);	/* Prototyped sc.c:917--VP  6jui01 */
extern INT 	mult_apply_vector(OP,OP);	/* Prototyped vc.c:1231--VP  6jui01 */
extern INT 	mult_apply_vector_vector(OP,OP);	/* Prototyped vc.c:1244--VP  6jui01 */
extern INT 	mult_bar_bar(OP,OP,OP);	/* Prototyped bar.c:536--VP  6jui01 */
extern INT 	mult_bruch(OP,OP,OP);	/* Prototyped bruch.c:877--VP  6jui01 */
extern INT 	mult_bruch_bruch(OP,OP,OP);	/* Prototyped bruch.c:266--VP  6jui01 */
extern INT 	mult_bruch_integer(OP,OP,OP);	/* Prototyped bruch.c:253--VP  6jui01 */
extern INT 	mult_cyclo(OP,OP,OP);	/* Prototyped nb.c:4060--VP  6jui01 */
extern INT 	mult_cyclo_cyclo(OP,OP,OP);	/* Prototyped nb.c:3977--VP  6jui01 */
extern INT 	mult_disjunkt_polynom_polynom(OP,OP,OP);	/* Prototyped poly.c:600--VP  6jui01 */
extern INT 	mult_ff(OP,OP,OP);	/* Prototyped ff.c:1062--VP  6jui01 */
extern INT 	mult_gral_gral(OP,OP,OP);	/* Prototyped ga.c:26--VP  6jui01 */
extern INT 	mult_imatrix_imatrix(OP,OP,OP);	/* Prototyped na.c:70--VP  6jui01 */
extern INT 	mult_integer(OP,OP,OP);	/* Prototyped rest.c:1184--VP  6jui01 */
extern INT 	mult_integer_integer(OP,OP,OP);	/* Prototyped rest.c:1158--VP  6jui01 */
extern INT 	mult_kranz_kranz(OP,OP,OP);	/* Prototyped perm.c:518--VP  6jui01 */
extern INT 	mult_laurent(OP,OP,OP);	/* Prototyped rest.c:3166--VP  6jui01 */
extern INT 	mult_longint(OP,OP,OP);	/* Prototyped lo.c:2002--VP  6jui01 */
extern INT 	mult_longint_integer(OP,OP,OP);	/* Prototyped lo.c:2251--VP  6jui01 */
extern INT 	mult_longint_longint(OP,OP,OP);	/* Prototyped lo.c:2045--VP  6jui01 */
extern INT 	mult_matrix(OP,OP,OP);	/* Prototyped ma.c:1449--VP  6jui01 */
extern INT 	mult_matrix_matrix(OP,OP,OP);	/* Prototyped ma.c:1421--VP  6jui01 */
extern INT 	mult_matrix_vector(OP,OP,OP);	/* Prototyped ma.c:1471--VP  6jui01 */
extern INT 	mult_monopoly(OP,OP,OP);	/* Prototyped nb.c:2160--VP  6jui01 */
extern INT 	mult_monopoly_monopoly(OP,OP,OP);	/* Prototyped nb.c:1944--VP  6jui01 */
extern INT 	mult_nc_kranz(OP,OP,OP);	/* Prototyped nc.c:582--VP  6jui01 */
extern INT 	mult_perm_fix(OP,OP,OP);	/* Prototyped di.c:1467--VP  6jui01 */
extern INT 	mult_permutation(OP,OP,OP);	/* Prototyped perm.c:1823--VP  6jui01 */
extern INT 	mult_polynom(OP,OP,OP);	/* Prototyped poly.c:460--VP  6jui01 */
extern INT 	mult_polynom_polynom(OP,OP,OP);	/* Prototyped poly.c:539--VP  6jui01 */
extern INT 	mult_power_schur(OP,OP,OP);	/* Prototyped sr.c:2284--VP  6jui01 */
extern INT 	mult_reihe(OP,OP,OP);	/* Prototyped rh.c:1630--VP  6jui01 */
extern INT 	mult_scalar_cyclo(OP,OP,OP);	/* Prototyped nb.c:3894--VP  6jui01 */
extern INT 	mult_scalar_matrix(OP,OP,OP);	/* Prototyped ma.c:1371--VP  6jui01 */
extern INT 	mult_scalar_monom(OP,OP,OP);	/* Prototyped poly.c:447--VP  6jui01 */
extern INT 	mult_scalar_monopoly(OP,OP,OP);	/* Prototyped nb.c:1890--VP  6jui01 */
extern INT 	mult_scalar_polynom(OP,OP,OP);	/* Prototyped poly.c:522--VP  6jui01 */
extern INT 	mult_scalar_schubert(OP,OP,OP);	/* Prototyped sb.c:813--VP  6jui01 */
extern INT 	mult_scalar_sqrad(OP,OP,OP);	/* Prototyped nb.c:2679--VP  6jui01 */
extern INT 	mult_scalar_symchar(OP,OP,OP);	/* Prototyped sc.c:976--VP  6jui01 */
extern INT 	mult_scalar_vector(OP,OP,OP);	/* Prototyped vc.c:1079--VP  6jui01 */
extern INT 	mult_schubert_monom(OP,OP,OP);	/* Prototyped sb.c:943--VP  6jui01 */
extern INT 	mult_schubert_polynom(OP,OP,OP);	/* Prototyped sb.c:965--VP  6jui01 */
extern INT 	mult_schubert_schubert(OP,OP,OP);	/* Prototyped sb.c:823--VP  6jui01 */
extern	INT mult_schubert_variable ();
extern INT 	mult_schur(OP,OP,OP);	/* Prototyped sr.c:2485--VP  6jui01 */
extern INT 	mult_schur_schur(OP,OP,OP);	/* Prototyped sr.c:1426--VP  6jui01 */
extern INT 	mult_sqrad(OP,OP,OP);	/* Prototyped nb.c:2879--VP  6jui01 */
extern INT 	mult_sqrad_sqrad(OP,OP,OP);	/* Prototyped nb.c:2760--VP  6jui01 */
extern INT 	mult_symchar_symchar(OP,OP,OP);	/* Prototyped sc.c:942--VP  6jui01 */
extern INT 	mult_symfunc(OP,OP,OP);	/* Prototyped sr.c:2546--VP  6jui01 */
extern INT 	mult_symfunc_symfunc(OP,OP,OP);	/* Prototyped sr.c:2517--VP  6jui01 */
extern INT 	mult_vector_matrix(OP,OP,OP);	/* Prototyped vc.c:1095--VP  6jui01 */
extern INT 	mult_vector_vector(OP,OP,OP);	/* Prototyped vc.c:1119--VP  6jui01 */
extern INT 	multinom(OP,OP,OP);	/* Prototyped nu.c:2223--VP  6jui01 */
extern INT 	mx_outerproduct_schur_lrs(OP,OP,OP,OP);	/* Prototyped pletint.c:4230--VP  6jui01 */
extern INT 	mx_power_schur_plet(OP,OP,OP,OP);	/* Prototyped pletint.c:6470--VP  6jui01 */
extern INT 	mx_powerproduct_schur_plet(OP,OP,OP,OP);	/* Prototyped pletint.c:6628--VP  6jui01 */
extern INT 	mx_schur_monomial_mult(OP,OP,OP,OP);	/* Prototyped pletint.c:5766--VP  6jui01 */
extern INT 	mx_schur_power_schur_plet_mult(OP,OP,OP,OP,OP);	/* Prototyped pletint.c:6544--VP  6jui01 */
extern INT 	mx_schur_powerproduct_schur_plet_mult(OP,OP,OP,OP,OP);	/* Prototyped pletint.c:6582--VP  6jui01 */
extern INT 	mx_schur_schur_plet(OP,OP,OP,OP);	/* Prototyped pletint.c:6363--VP  6jui01 */
extern INT 	mx_schur_schur_pletbis(OP,OP,OP,OP);	/* Prototyped pletint.c:6670--VP  6jui01 */
extern INT 	mx_t_monomial_schur(OP,OP,OP);	/* Prototyped pletint.c:6018--VP  6jui01 */
extern INT 	mz_extrahieren();	/* Prototyped zykelind.c:4678--VP  6jui01 */
extern INT 	mz_vereinfachen(OP,OP);	/* Prototyped zykelind.c:4640--VP  6jui01 */
extern INT 	n_fold_kronecker_product(OP,OP,OP);	/* Prototyped ma.c:1700--VP  6jui01 */
extern INT 	nb_ende();	/* Prototyped nb.c:1523--VP  6jui01 */
extern INT 	ndg(OP,OP,OP);	/* Prototyped na.c:1226--VP  6jui01 */
extern INT 	neg_sum(OP,OP);	/* Prototyped ga.c:557--VP  6jui01 */
extern INT 	negeinsp(OP);	/* Prototyped rest.c:811--VP  6jui01 */
extern INT 	negeinsp_bruch(OP);	/* Prototyped bruch.c:193--VP  6jui01 */
extern INT 	negeinsp_integer(OP);	/* Prototyped rest.c:1439--VP  6jui01 */
extern INT 	negp(OP);	/* Prototyped rest.c:898--VP  6jui01 */
extern INT 	negp_bruch(OP);	/* Prototyped bruch.c:172--VP  6jui01 */
extern INT 	negp_integer(OP);	/* Prototyped rest.c:1272--VP  6jui01 */
extern INT 	negp_longint(OP);	/* Prototyped lo.c:2553--VP  6jui01 */
extern INT 	neq(OP,OP);	/* Prototyped rest.c:1046--VP  6jui01 */
extern INT 	neqparts_partition(OP);	/* Prototyped part.c:1926--VP  6jui01 */
extern INT 	new_divdiff_bar(OP,OP,OP);	/* Prototyped bar.c:48--VP  6jui01 */
extern INT 	new_divideddiff_rz_bar(OP,OP,OP);	/* Prototyped bar.c:71--VP  6jui01 */
extern INT 	new_divideddifference_bar(OP,OP,OP);	/* Prototyped bar.c:727--VP  6jui01 */
extern INT 	new_orbit(OP,OP,OP);	/* Prototyped di.c:846--VP  6jui01 */
extern INT 	newtrans(OP,OP);	/* Prototyped sr.c:279--VP  6jui01 */
extern INT 	newtrans_limit_limitfunction(OP,OP,OP,OP,INT (*)());	/* Prototyped sr.c:297--VP  6jui01 */
extern INT 	newtrans_limitfunction(OP,OP,OP,INT (*)());	/* Prototyped sr.c:308--VP  6jui01 */
extern INT 	next(OP,OP);	/* Prototyped rest.c:1974--VP  6jui01 */
extern INT 	next_bar(OP,OP);	/* Prototyped bar.c:627--VP  6jui01 */
extern INT 	next_composition(OP,OP);	/* Prototyped part.c:255--VP  6jui01 */
extern INT 	next_ff(OP,OP);	/* Prototyped ff.c:1879--VP  6jui01 */
extern INT 	next_kranztypus(OP,OP);	/* Prototyped perm.c:560--VP  6jui01 */
extern INT 	next_lehmercode(OP,OP);	/* Prototyped perm.c:1463--VP  6jui01 */
extern INT 	next_part_EXPONENT(OP,OP);	/* Prototyped part.c:907--VP  6jui01 */
extern INT 	next_part_VECTOR(OP,OP);	/* Prototyped part.c:855--VP  6jui01 */
extern INT 	next_partition(OP,OP);	/* Prototyped part.c:840--VP  6jui01 */
extern INT 	next_perm_invers(OP,OP);	/* Prototyped perm.c:2820--VP  6jui01 */
extern INT 	next_permutation(OP,OP);	/* Prototyped perm.c:1440--VP  6jui01 */
extern INT 	next_permutation_lex(OP,OP);	/* Prototyped perm.c:1415--VP  6jui01 */
extern INT 	next_shuffle_part(OP,OP,OP);	/* Prototyped perm.c:2946--VP  6jui01 */
extern INT 	next_shufflepermutation(OP,OP,OP);	/* Prototyped perm.c:1152--VP  6jui01 */
extern INT 	next_shufflevector(OP,OP,OP);	/* Prototyped perm.c:1120--VP  6jui01 */
extern INT 	no_memory();	/* Prototyped de.c:599--VP  6jui01 */
extern INT 	normal_laurent(OP);	/* Prototyped rest.c:3208--VP  6jui01 */
extern INT 	not_yet_implemented(char *);	/* Prototyped rest.c:248--VP  6jui01 */
extern INT 	ntopaar_symchar(OP,OP);	/* Prototyped sc.c:708--VP  6jui01 */
extern INT 	null_object(char *);	/* Prototyped rest.c:241--VP  6jui01 */
extern INT 	nullp(OP);	/* Prototyped rest.c:704--VP  6jui01 */
extern INT 	nullp_bitvector(OP);	/* Prototyped vc.c:1588--VP  6jui01 */
extern INT 	nullp_bruch(OP);	/* Prototyped bruch.c:206--VP  6jui01 */
extern INT 	nullp_cyclo(OP);	/* Prototyped nb.c:4274--VP  6jui01 */
extern INT 	nullp_ff(OP);	/* Prototyped ff.c:1074--VP  6jui01 */
extern INT 	nullp_integer(OP);	/* Prototyped rest.c:1419--VP  6jui01 */
extern INT 	nullp_integervector(OP);	/* Prototyped vc.c:1267--VP  6jui01 */
extern INT 	nullp_longint(OP);	/* Prototyped lo.c:2542--VP  6jui01 */
extern INT 	nullp_matrix(OP);	/* Prototyped ma.c:146--VP  6jui01 */
extern INT 	nullp_monopoly(OP);	/* Prototyped nb.c:2279--VP  6jui01 */
extern INT 	nullp_polynom(OP);	/* Prototyped poly.c:1779--VP  6jui01 */
extern INT 	nullp_reihe(OP);	/* Prototyped rh.c:1358--VP  6jui01 */
extern INT 	nullp_schubert(OP);	/* Prototyped sb.c:1121--VP  6jui01 */
extern INT 	nullp_sqrad(OP);	/* Prototyped nb.c:3086--VP  6jui01 */
extern INT 	nullp_symchar(OP);	/* Prototyped sc.c:1159--VP  6jui01 */
extern INT 	nullp_vector(OP);	/* Prototyped vc.c:1281--VP  6jui01 */
extern INT 	number_of_digits(OP);	/* Prototyped nb.c:129--VP  6jui01 */
extern INT 	number_of_irred_poly_of_degree(OP,OP,OP);	/* Prototyped zykelind.c:1569--VP  6jui01 */
extern INT 	numberof_class_kranz(OP,OP);	/* Prototyped nc.c:699--VP  6jui01 */
extern INT 	numberof_inversionen(OP,OP);	/* Prototyped perm.c:1641--VP  6jui01 */
extern INT 	numberof_shufflepermutation(OP,OP);	/* Prototyped perm.c:1098--VP  6jui01 */
extern INT 	numberofpart(OP,OP);	/* Prototyped part.c:970--VP  6jui01 */
extern INT 	numberofpart_i(OP);	/* Prototyped part.c:955--VP  6jui01 */
extern INT 	numberofvariables(OP,OP);	/* Prototyped poly.c:573--VP  6jui01 */
extern INT 	nxt_ym(OP,OP);	/* Prototyped ta.c:1558--VP  6jui01 */
extern INT 	objectread(FILE *,OP);	/* Prototyped io.c:687--VP  6jui01 */
extern INT 	objectread_bruch(FILE *,OP);	/* Prototyped bruch.c:1016--VP  6jui01 */
extern INT 	objectread_bv(FILE *,OP);	/* Prototyped vc.c:933--VP  6jui01 */
extern INT 	objectread_gral(FILE *,OP);	/* Prototyped ga.c:401--VP  6jui01 */
extern INT 	objectread_integer(FILE *,OP);	/* Prototyped rest.c:1596--VP  6jui01 */
extern INT 	objectread_list(FILE *,OP);	/* Prototyped list.c:837--VP  6jui01 */
extern INT 	objectread_longint(FILE *,OP);	/* Prototyped lo.c:2563--VP  6jui01 */
extern INT 	objectread_matrix(FILE *,OP);	/* Prototyped ma.c:1514--VP  6jui01 */
extern INT 	objectread_monom(FILE *,OP);	/* Prototyped poly.c:216--VP  6jui01 */
extern INT 	objectread_monopoly(FILE *,OP);	/* Prototyped nb.c:2362--VP  6jui01 */
extern INT 	objectread_number(FILE *,OP,OBJECTKIND);	/* Prototyped nb.c:1298--VP  6jui01 */
extern INT 	objectread_partition(OP,FILE *);	/* Prototyped part.c:1939--VP  6jui01 */
extern INT 	objectread_permutation(OP,FILE *);	/* Prototyped perm.c:2198--VP  6jui01 */
extern INT 	objectread_schur(OP,FILE *);	/* Prototyped sr.c:1182--VP  6jui01 */
extern INT 	objectread_skewpartition(FILE *,OP);	/* Prototyped rest.c:2425--VP  6jui01 */
extern INT 	objectread_symchar(FILE *,OP);	/* Prototyped sc.c:1134--VP  6jui01 */
extern INT 	objectread_tableaux(FILE *,OP);	/* Prototyped ta.c:381--VP  6jui01 */
extern INT 	objectread_vector(FILE *,OP);	/* Prototyped vc.c:945--VP  6jui01 */
extern INT 	objectwrite(FILE *,OP);	/* Prototyped io.c:760--VP  6jui01 */
extern INT 	objectwrite_bruch(FILE *,OP);	/* Prototyped bruch.c:1003--VP  6jui01 */
extern INT 	objectwrite_bv(FILE *,OP);	/* Prototyped vc.c:958--VP  6jui01 */
extern INT 	objectwrite_gral(FILE *,OP);	/* Prototyped ga.c:418--VP  6jui01 */
extern INT 	objectwrite_integer(FILE *,OP);	/* Prototyped rest.c:1607--VP  6jui01 */
extern INT 	objectwrite_list(FILE *,OP);	/* Prototyped list.c:813--VP  6jui01 */
extern INT 	objectwrite_longint(FILE *,OP);	/* Prototyped lo.c:2576--VP  6jui01 */
extern INT 	objectwrite_matrix(FILE *,OP);	/* Prototyped ma.c:1532--VP  6jui01 */
extern INT 	objectwrite_monom(FILE *,OP);	/* Prototyped poly.c:204--VP  6jui01 */
extern INT 	objectwrite_number(FILE *,OP);	/* Prototyped nb.c:1270--VP  6jui01 */
extern INT 	objectwrite_partition(FILE *,OP);	/* Prototyped part.c:1951--VP  6jui01 */
extern INT 	objectwrite_permutation(FILE *,OP);	/* Prototyped perm.c:2215--VP  6jui01 */
extern INT 	objectwrite_schur(FILE *,OP);	/* Prototyped sr.c:1206--VP  6jui01 */
extern INT 	objectwrite_skewpartition(FILE *,OP);	/* Prototyped rest.c:2439--VP  6jui01 */
extern INT 	objectwrite_symchar(FILE *,OP);	/* Prototyped sc.c:1147--VP  6jui01 */
extern INT 	objectwrite_tableaux(FILE *,OP);	/* Prototyped ta.c:393--VP  6jui01 */
extern INT 	objectwrite_vector(FILE *,OP);	/* Prototyped vc.c:976--VP  6jui01 */
extern INT 	odd(OP);	/* Prototyped rest.c:868--VP  6jui01 */
extern INT 	odd_longint(OP);	/* Prototyped lo.c:2522--VP  6jui01 */
extern INT 	odd_to_strict_part(OP,OP);	/* Prototyped part.c:2740--VP  6jui01 */
extern INT 	odg(OP,OP,OP);	/* Prototyped sab.c:1874--VP  6jui01 */
extern INT 	operate_gral_polynom(OP,OP,OP);	/* Prototyped perm.c:2538--VP  6jui01 */
extern INT 	operate_perm_polynom(OP,OP,OP);	/* Prototyped perm.c:2565--VP  6jui01 */
extern INT 	operate_perm_tableaux(OP,OP,OP);	/* Prototyped ta.c:1458--VP  6jui01 */
extern INT 	operate_perm_vector(OP,OP,OP);	/* Prototyped perm.c:2597--VP  6jui01 */
extern	INT or_character ();
extern	INT or_dimension ();
extern	INT or_tableaux ();
extern INT 	orblen(OP,OP);	/* Prototyped di.c:1427--VP  6jui01 */
extern INT 	ordcen(OP,OP);	/* Prototyped part.c:1046--VP  6jui01 */
extern INT 	ordcen_bar(OP,OP);	/* Prototyped bar.c:367--VP  6jui01 */
extern INT 	ordcon(OP,OP);	/* Prototyped part.c:1533--VP  6jui01 */
extern INT 	ordcon_bar(OP,OP);	/* Prototyped bar.c:352--VP  6jui01 */
extern INT 	order_class_kranz(OP,OP,OP);	/* Prototyped nc.c:719--VP  6jui01 */
extern INT 	order_ff(OP,OP);	/* Prototyped ff.c:1623--VP  6jui01 */
extern INT 	ordnung_affkq(OP,OP,OP);	/* Prototyped zykelind.c:1417--VP  6jui01 */
extern INT 	ordnung_glkq(OP,OP,OP);	/* Prototyped zykelind.c:1388--VP  6jui01 */
extern INT 	outerproduct_schubert(OP,OP,OP);	/* Prototyped sb.c:840--VP  6jui01 */
extern INT 	outerproduct_schur(OP,OP,OP);	/* Prototyped sr.c:1479--VP  6jui01 */
extern INT 	outerproduct_schur_limit(OP,OP,OP,OP);	/* Prototyped sr.c:1543--VP  6jui01 */
extern INT 	outerproduct_schur_limit_limitfunction(OP,OP,OP,OP,OP);	/* Prototyped sr.c:1512--VP  6jui01 */
extern INT 	outerproduct_schur_limitfunction(OP,OP,OP,OP);	/* Prototyped sr.c:1528--VP  6jui01 */
extern INT 	outerproduct_schur_lrs(OP,OP,OP);	/* Prototyped pletint.c:4128--VP  6jui01 */
extern INT 	p_hook_diagramm(OP,OP,OP);	/* Prototyped part.c:2710--VP  6jui01 */
extern INT 	p_root_part(OP,OP,OP,OP);	/* Prototyped sr.c:2114--VP  6jui01 */
extern INT 	p_root_schur(OP,OP,OP,OP);	/* Prototyped sr.c:2076--VP  6jui01 */
extern INT 	part_comp();	/* Prototyped nc.c:105--VP  6jui01 */
extern INT 	part_ende();	/* Prototyped part.c:1385--VP  6jui01 */
extern INT 	part_part_skewschur(OP,OP,OP);	/* Prototyped sr.c:1864--VP  6jui01 */
extern INT 	partitionp(OP);	/* Prototyped part.c:68--VP  6jui01 */
extern INT 	perm_anfang();	/* Prototyped perm.c:47--VP  6jui01 */
extern INT 	perm_ende();	/* Prototyped perm.c:55--VP  6jui01 */
extern INT 	perm_matrix(OP,OP);	/* Prototyped perm.c:2494--VP  6jui01 */
extern INT 	perm_tableaux(OP,OP);	/* Prototyped ta.c:1253--VP  6jui01 */
extern INT 	perm_weintraube(OP,OP);	/* Prototyped wt.c:459--VP  6jui01 */
extern INT 	permutationp(OP);	/* Prototyped perm.c:81--VP  6jui01 */
extern INT 	pfact(OP);	/* Prototyped perm.c:2756--VP  6jui01 */
extern INT 	pfaffian_matrix(OP,OP);	/* Prototyped ma.c:585--VP  6jui01 */
extern INT 	pgcd(OP,OP,OP);	/* Prototyped bruch.c:1141--VP  6jui01 */
extern INT 	pictex_skwt_liste(OP);	/* Prototyped wt.c:506--VP  6jui01 */
extern INT 	pictex_snwt_liste(OP);	/* Prototyped wt.c:508--VP  6jui01 */
extern INT 	pictex_wt(OP);	/* Prototyped wt.c:656--VP  6jui01 */
extern INT 	pictex_wt_liste(OP);	/* Prototyped wt.c:510--VP  6jui01 */
extern INT 	pictex_wt_liste_co(OP,INT (*)());	/* Prototyped wt.c:513--VP  6jui01 */
extern INT 	pl_j_wt(OP,OP,INT);	/* Prototyped wt.c:1191--VP  6jui01 */
extern INT 	plane_tableau(OP,OP);	/* Prototyped ta.c:1161--VP  6jui01 */
extern INT 	plaziere_verband(OP,INT (*)());	/* Prototyped gra.c:284--VP  6jui01 */
extern INT 	plet_schur_schur_pol();	/* Prototyped sr.c:3301--VP  6jui01 */
extern	INT pn_character ();
extern	INT pn_dimension ();
extern	INT pn_tableaux ();
extern INT 	pol_sd_wt(OP,OP);	/* Prototyped wt.c:162--VP  6jui01 */
extern INT 	pol_sn_wt(OP,OP);	/* Prototyped wt.c:151--VP  6jui01 */
extern INT 	pol_wt(OP,OP);	/* Prototyped wt.c:174--VP  6jui01 */
extern INT 	polya1_sub(OP,OP,OP);	/* Prototyped zykelind.c:3305--VP  6jui01 */
extern INT 	polya2_sub(OP,OP,OP);	/* Prototyped zykelind.c:3341--VP  6jui01 */
extern INT 	polya3_sub(OP,OP,OP,OP);	/* Prototyped zykelind.c:3386--VP  6jui01 */
extern INT 	polya_const_sub(OP,OP,OP);	/* Prototyped zykelind.c:3433--VP  6jui01 */
extern INT 	polya_multi_const_sub(OP,OP,OP);	/* Prototyped zykelind.c:5550--VP  6jui01 */
extern INT 	polya_multi_sub(OP,OP);	/* Prototyped zykelind.c:5479--VP  6jui01 */
extern INT 	polya_n_sub(OP,OP,OP);	/* Prototyped zyk.c:1083--VP  6jui01 */
extern INT 	polya_sub(OP,OP,OP);	/* Prototyped poly.c:1603--VP  6jui01 */
extern INT 	pos_sum(OP,OP);	/* Prototyped ga.c:553--VP  6jui01 */
extern INT 	posp(OP);	/* Prototyped rest.c:924--VP  6jui01 */
extern INT 	posp_bruch(OP);	/* Prototyped bruch.c:543--VP  6jui01 */
extern INT 	posp_integer(OP);	/* Prototyped rest.c:1266--VP  6jui01 */
extern INT 	posp_longint(OP);	/* Prototyped lo.c:2512--VP  6jui01 */
extern INT 	power_schur_plet(OP,OP,OP);	/* Prototyped pletint.c:6504--VP  6jui01 */
extern INT 	power_schur_plet_old(OP,OP,OP);	/* Prototyped pletint.c:6679--VP  6jui01 */
extern INT 	powerproduct_schur_plet(OP,OP,OP);	/* Prototyped pletint.c:6601--VP  6jui01 */
extern INT 	pr_j_wt(OP,OP,INT);	/* Prototyped wt.c:1147--VP  6jui01 */
extern INT 	prepartdom(OP,OP,INT *,INT *);	/* Prototyped ko.c:531--VP  6jui01 */
extern INT 	primep(OP);	/* Prototyped nb.c:328--VP  6jui01 */
extern INT 	print(OP);	/* Prototyped io.c:271--VP  6jui01 */
extern INT 	print_cyclo_data(CYCLO_DATA *);	/* Prototyped nb.c:4589--VP  6jui01 */
extern INT 	print_cyclo_list();	/* Prototyped nb.c:4641--VP  6jui01 */
extern INT 	print_cyclo_table();	/* Prototyped nb.c:4622--VP  6jui01 */
extern INT 	print_schubert_difference(OP,OP);	/* Prototyped sb.c:744--VP  6jui01 */
extern INT 	print_time();	/* Prototyped de.c:471--VP  6jui01 */
extern INT 	print_type(OBJECTKIND);	/* Prototyped io.c:16--VP  6jui01 */
extern INT 	printeingabe(char *);	/* Prototyped io.c:105--VP  6jui01 */
extern INT 	println(OP);	/* Prototyped io.c:287--VP  6jui01 */
extern INT 	println_schub_lehmer(OP);	/* Prototyped sb.c:1036--VP  6jui01 */
extern INT 	printobjectkind(OP);	/* Prototyped io.c:29--VP  6jui01 */
extern INT 	prsym(OP,OP);	/* Prototyped pr.c:39--VP  6jui01 */
extern INT 	put_length_limit_schur(OP,INT);	/* Prototyped sr.c:3327--VP  6jui01 */
extern INT 	q_core(OP,OP,OP);	/* Prototyped part.c:2648--VP  6jui01 */
extern INT 	qdimension(OP,OP);	/* Prototyped nu.c:944--VP  6jui01 */
extern INT 	qdimension_schubert(OP,OP);	/* Prototyped sb.c:1161--VP  6jui01 */
extern INT 	qsort_vector(OP);	/* Prototyped vc.c:337--VP  6jui01 */
extern INT 	quadraticp(OP);	/* Prototyped ma.c:476--VP  6jui01 */
extern INT 	quores(OP,OP,OP,OP);	/* Prototyped nu.c:1017--VP  6jui01 */
extern INT 	quores_integer(OP,OP,OP,OP);	/* Prototyped rest.c:1381--VP  6jui01 */
extern INT 	quores_longint(OP,OP,OP,OP);	/* Prototyped lo.c:2444--VP  6jui01 */
extern INT 	quores_monopoly(OP,OP,OP,OP);	/* Prototyped nb.c:2007--VP  6jui01 */
extern INT 	raise_power_monopoly(OP,OP);	/* Prototyped nb.c:2312--VP  6jui01 */
extern INT 	random_bar(OP,OP);	/* Prototyped bar.c:561--VP  6jui01 */
extern INT 	random_bruch(OP);	/* Prototyped bruch.c:60--VP  6jui01 */
extern INT 	random_bv(OP,OP);	/* Prototyped vc.c:381--VP  6jui01 */
extern INT 	random_char_ff(OP,OP);	/* Prototyped ff.c:1030--VP  6jui01 */
extern INT 	random_ff(OP);	/* Prototyped ff.c:1015--VP  6jui01 */
extern INT 	random_gral(OP,OP);	/* Prototyped ga.c:528--VP  6jui01 */
extern INT 	random_integer(OP,OP,OP);	/* Prototyped rest.c:1493--VP  6jui01 */
extern INT 	random_integervector(OP,OP);	/* Prototyped vc.c:436--VP  6jui01 */
extern INT 	random_longint(OP,OP);	/* Prototyped lo.c:2720--VP  6jui01 */
extern INT 	random_monom(OP);	/* Prototyped poly.c:2178--VP  6jui01 */
extern INT 	random_partition(OP,OP);	/* Prototyped part.c:2175--VP  6jui01 */
extern INT 	random_permutation(OP,OP);	/* Prototyped perm.c:2064--VP  6jui01 */
extern INT 	random_polynom(OP);	/* Prototyped poly.c:2209--VP  6jui01 */
extern INT 	random_reihe(OP);	/* Prototyped rh.c:2076--VP  6jui01 */
extern INT 	random_word(OP,OP);	/* Prototyped rest.c:2653--VP  6jui01 */
extern INT 	rank(OP,OP);	/* Prototyped ma.c:1791--VP  6jui01 */
extern INT 	rank_permutation(OP,OP);	/* Prototyped perm.c:21--VP  6jui01 */
extern INT 	red_dia_perm(OP,OP);	/* Prototyped perm.c:120--VP  6jui01 */
extern INT 	redf_cap(OP,OP);	/* Prototyped zykelind.c:4401--VP  6jui01 */
extern INT 	redf_cap_hoch(OP,OP,OP);	/* Prototyped zykelind.c:4276--VP  6jui01 */
extern INT 	redf_cup(OP,OP);	/* Prototyped zykelind.c:4439--VP  6jui01 */
extern INT 	redf_cup_hoch(OP,OP,OP);	/* Prototyped zykelind.c:4339--VP  6jui01 */
extern INT 	reduce_inner_tensor_sc(OP,OP,OP);	/* Prototyped sc.c:1003--VP  6jui01 */
extern INT 	reduce_nc(OP,OP);	/* Prototyped nc.c:191--VP  6jui01 */
extern INT 	reduce_nc_kranz(OP,OP);	/* Prototyped nc.c:551--VP  6jui01 */
extern INT 	reduce_symchar(OP,OP);	/* Prototyped sc.c:776--VP  6jui01 */
extern INT 	reduce_symchar_tafel(OP,OP,OP);	/* Prototyped sc.c:782--VP  6jui01 */
extern INT 	reduceninpaar(OP,OP);	/* Prototyped sc.c:1031--VP  6jui01 */
extern INT 	release_numbers();	/* Prototyped nb.c:1501--VP  6jui01 */
extern INT 	remove_hook(OP,OP,INT,INT);	/* Prototyped part.c:2674--VP  6jui01 */
extern	INT remove_mp_qnumber_fac ();
extern INT 	remove_part_part(OP,OP,OP);	/* Prototyped part.c:155--VP  6jui01 */
extern	INT remove_vec_qnumber ();
extern INT 	remove_zero_terms(OP);	/* Prototyped nb.c:1803--VP  6jui01 */
extern INT 	removepartij(OP,OP,INT,INT);	/* Prototyped ko.c:390--VP  6jui01 */
extern INT 	reorder_hall_littlewood(OP,OP);	/* Prototyped sr.c:1674--VP  6jui01 */
extern	INT represent_hecke_element ();
extern INT 	reset_basis(INT);	/* Prototyped nb.c:1531--VP  6jui01 */
extern INT 	reset_saving(INT);	/* Prototyped nb.c:1541--VP  6jui01 */
extern INT 	rh_test();	/* Prototyped rh.c:2604--VP  6jui01 */
extern INT 	rightkey_wt(OP,OP);	/* Prototyped wt.c:979--VP  6jui01 */
extern INT 	rindexword(OP,OP,OP,OP);	/* Prototyped rest.c:2897--VP  6jui01 */
extern INT 	rindexword_sub(OP,OP,OP,OP);	/* Prototyped rest.c:2916--VP  6jui01 */
extern INT 	rm_rindex(OP,OP);	/* Prototyped rest.c:2782--VP  6jui01 */
extern	INT root_dimension ();
extern	INT root_normalise_monopoly ();
extern	INT root_represent_hecke_action ();
extern	INT root_standardise_cold_tableaux_list ();
extern INT 	row_column_matrices(OP,OP,OP);	/* Prototyped part.c:2428--VP  6jui01 */
extern INT 	rowwordoftableaux(OP,OP);	/* Prototyped ta.c:922--VP  6jui01 */
extern INT 	runtime(long *);	/* Prototyped de.c:448--VP  6jui01 */
extern INT 	rz(OP,OP);	/* Prototyped rest.c:300--VP  6jui01 */
extern INT 	rz_Dn(OP,OP);	/* Prototyped perm.c:3352--VP  6jui01 */
extern INT 	rz_bar(OP,OP);	/* Prototyped bar.c:211--VP  6jui01 */
extern INT 	rz_lehmercode(OP,OP);	/* Prototyped perm.c:2022--VP  6jui01 */
extern INT 	rz_lehmercode_bar(OP,OP);	/* Prototyped bar.c:222--VP  6jui01 */
extern INT 	rz_perm(OP,OP);	/* Prototyped perm.c:2007--VP  6jui01 */
extern OP 	s_b_o(OP);	/* Prototyped bruch.c:483--VP  6jui01 */
extern INT 	s_b_oi(OP);	/* Prototyped bruch.c:507--VP  6jui01 */
extern OP 	s_b_u(OP);	/* Prototyped bruch.c:495--VP  6jui01 */
extern INT 	s_b_ui(OP);	/* Prototyped bruch.c:513--VP  6jui01 */
extern OP 	s_ff_c(OP);	/* Prototyped ff.c:812--VP  6jui01 */
extern INT 	s_ff_ci(OP);	/* Prototyped ff.c:806--VP  6jui01 */
extern INT 	s_ff_di(OP);	/* Prototyped ff.c:818--VP  6jui01 */
extern INT 	s_ff_ii(OP,INT);	/* Prototyped ff.c:87--VP  6jui01 */
extern OBJECTKIND 	s_gr_k(OP);	/* Prototyped gra.c:8--VP  6jui01 */
extern OP 	s_gr_kn(OP);	/* Prototyped gra.c:76--VP  6jui01 */
extern OP 	s_gr_kni(OP,INT);	/* Prototyped gra.c:92--VP  6jui01 */
extern OP 	s_gr_koor(OP);	/* Prototyped gra.c:130--VP  6jui01 */
extern OP 	s_gr_koori(OP,INT);	/* Prototyped gra.c:140--VP  6jui01 */
extern OP 	s_gr_na(OP);	/* Prototyped gra.c:106--VP  6jui01 */
extern OP 	s_gr_nai(OP,INT);	/* Prototyped gra.c:116--VP  6jui01 */
extern OP 	s_gr_s(OP);	/* Prototyped gra.c:18--VP  6jui01 */
extern OP 	s_gr_xkoori(OP,INT);	/* Prototyped gra.c:153--VP  6jui01 */
extern OP 	s_gr_ykoori(OP,INT);	/* Prototyped gra.c:167--VP  6jui01 */
extern INT 	s_i_i(OP);	/* Prototyped rest.c:1642--VP  6jui01 */
extern INT 	s_i_wt(OP,OP,INT);	/* Prototyped wt.c:772--VP  6jui01 */
extern INT 	s_ki_wt(OP,OP,INT);	/* Prototyped wt.c:1464--VP  6jui01 */
extern OP 	s_kr_g(OP);	/* Prototyped perm.c:431--VP  6jui01 */
extern OP 	s_kr_gl(OP);	/* Prototyped perm.c:469--VP  6jui01 */
extern INT 	s_kr_gli(OP);	/* Prototyped perm.c:463--VP  6jui01 */
extern OP 	s_kr_i(OP,INT);	/* Prototyped perm.c:457--VP  6jui01 */
extern OP 	s_kr_v(OP);	/* Prototyped perm.c:438--VP  6jui01 */
extern OP 	s_l_n(OP);	/* Prototyped list.c:442--VP  6jui01 */
extern OP 	s_l_s(OP);	/* Prototyped list.c:430--VP  6jui01 */
extern OP 	s_m_h(OP);	/* Prototyped ma.c:1230--VP  6jui01 */
extern INT 	s_m_hi(OP);	/* Prototyped ma.c:1238--VP  6jui01 */
extern OP 	s_m_ij(OP,INT,INT);	/* Prototyped ma.c:1260--VP  6jui01 */
extern INT 	s_m_iji(OP,INT,INT);	/* Prototyped ma.c:1295--VP  6jui01 */
extern OP 	s_m_l(OP);	/* Prototyped ma.c:1234--VP  6jui01 */
extern INT 	s_m_li(OP);	/* Prototyped ma.c:1242--VP  6jui01 */
extern OP 	s_m_s(OP);	/* Prototyped ma.c:1226--VP  6jui01 */
extern OP 	s_mo_k(OP);	/* Prototyped poly.c:385--VP  6jui01 */
extern INT 	s_mo_ki(OP);	/* Prototyped poly.c:420--VP  6jui01 */
extern OP 	s_mo_s(OP);	/* Prototyped poly.c:372--VP  6jui01 */
extern OP 	s_mo_si(OP,INT);	/* Prototyped poly.c:408--VP  6jui01 */
extern INT 	s_mo_sii(OP,INT);	/* Prototyped poly.c:413--VP  6jui01 */
extern OP 	s_mo_sl(OP);	/* Prototyped poly.c:398--VP  6jui01 */
extern INT 	s_mo_sli(OP);	/* Prototyped poly.c:403--VP  6jui01 */
extern OP 	s_mz_po(OP);	/* Prototyped zykelind.c:4784--VP  6jui01 */
extern OP 	s_mz_v(OP);	/* Prototyped zykelind.c:4764--VP  6jui01 */
extern OP 	s_mz_vi(OP);	/* Prototyped zykelind.c:4770--VP  6jui01 */
extern INT 	s_mz_vii(OP);	/* Prototyped zykelind.c:4777--VP  6jui01 */
extern OP 	s_n_d(OP);	/* Prototyped nb.c:81--VP  6jui01 */
extern OP 	s_n_dcd(OP);	/* Prototyped nb.c:111--VP  6jui01 */
extern OP 	s_n_dci(OP);	/* Prototyped nb.c:105--VP  6jui01 */
extern OP 	s_n_dcp(OP);	/* Prototyped nb.c:117--VP  6jui01 */
extern OP 	s_n_s(OP);	/* Prototyped nb.c:63--VP  6jui01 */
extern INT 	s_ni_wt(OP,OP,INT);	/* Prototyped wt.c:716--VP  6jui01 */
extern OBJECTKIND 	s_o_k(OP);	/* Prototyped rest.c:2228--VP  6jui01 */
extern OBJECTSELF 	s_o_s(OP);	/* Prototyped rest.c:2218--VP  6jui01 */
extern OP 	s_p_i(OP,INT);	/* Prototyped perm.c:2109--VP  6jui01 */
extern INT 	s_p_ii(OP,INT);	/* Prototyped perm.c:2115--VP  6jui01 */
extern OBJECTKIND 	s_p_k(OP);	/* Prototyped perm.c:2101--VP  6jui01 */
extern OP 	s_p_l(OP);	/* Prototyped perm.c:2127--VP  6jui01 */
extern INT 	s_p_li(OP);	/* Prototyped perm.c:2133--VP  6jui01 */
extern OP 	s_p_s(OP);	/* Prototyped perm.c:2093--VP  6jui01 */
extern OP 	s_pa_i(OP,INT);	/* Prototyped part.c:1883--VP  6jui01 */
extern INT 	s_pa_ii(OP,INT);	/* Prototyped part.c:1889--VP  6jui01 */
extern OBJECTKIND 	s_pa_k(OP);	/* Prototyped part.c:1875--VP  6jui01 */
extern OP 	s_pa_l(OP);	/* Prototyped part.c:1895--VP  6jui01 */
extern INT 	s_pa_li(OP);	/* Prototyped part.c:1901--VP  6jui01 */
extern OP 	s_pa_s(OP);	/* Prototyped part.c:1867--VP  6jui01 */
extern OP 	s_po_k(OP);	/* Prototyped poly.c:1238--VP  6jui01 */
extern INT 	s_po_ki(OP);	/* Prototyped poly.c:1278--VP  6jui01 */
extern OP 	s_po_n(OP);	/* Prototyped poly.c:1248--VP  6jui01 */
extern OP 	s_po_s(OP);	/* Prototyped poly.c:1228--VP  6jui01 */
extern OP 	s_po_si(OP,INT);	/* Prototyped poly.c:1258--VP  6jui01 */
extern INT 	s_po_sii(OP,INT);	/* Prototyped poly.c:1284--VP  6jui01 */
extern OP 	s_po_sl(OP);	/* Prototyped poly.c:1268--VP  6jui01 */
extern INT 	s_po_sli(OP);	/* Prototyped poly.c:1291--VP  6jui01 */
extern OP 	s_s_k(OP);	/* Prototyped sr.c:1334--VP  6jui01 */
extern INT 	s_s_ki(OP);	/* Prototyped sr.c:1354--VP  6jui01 */
extern OP 	s_s_n(OP);	/* Prototyped sr.c:1339--VP  6jui01 */
extern OP 	s_s_s(OP);	/* Prototyped sr.c:1329--VP  6jui01 */
extern OP 	s_s_si(OP,INT);	/* Prototyped sr.c:1344--VP  6jui01 */
extern INT 	s_s_sii(OP,INT);	/* Prototyped sr.c:1359--VP  6jui01 */
extern OP 	s_s_sl(OP);	/* Prototyped sr.c:1349--VP  6jui01 */
extern INT 	s_s_sli(OP);	/* Prototyped sr.c:1365--VP  6jui01 */
extern OP 	s_sc_d(OP);	/* Prototyped sc.c:1360--VP  6jui01 */
extern INT 	s_sc_di(OP);	/* Prototyped sc.c:1355--VP  6jui01 */
extern OP 	s_sc_p(OP);	/* Prototyped sc.c:1334--VP  6jui01 */
extern OP 	s_sc_pi(OP,INT);	/* Prototyped sc.c:1343--VP  6jui01 */
extern INT 	s_sc_pli(OP);	/* Prototyped sc.c:1349--VP  6jui01 */
extern OP 	s_sc_w(OP);	/* Prototyped sc.c:1307--VP  6jui01 */
extern OP 	s_sc_wi(OP,INT);	/* Prototyped sc.c:1316--VP  6jui01 */
extern INT 	s_sc_wii(OP,INT);	/* Prototyped sc.c:1322--VP  6jui01 */
extern INT 	s_sc_wli(OP);	/* Prototyped sc.c:1328--VP  6jui01 */
extern OP 	s_sch_k(OP);	/* Prototyped sb.c:617--VP  6jui01 */
extern INT 	s_sch_ki(OP);	/* Prototyped sb.c:654--VP  6jui01 */
extern OP 	s_sch_n(OP);	/* Prototyped sb.c:626--VP  6jui01 */
extern OP 	s_sch_s(OP);	/* Prototyped sb.c:608--VP  6jui01 */
extern OP 	s_sch_si(OP);	/* Prototyped sb.c:635--VP  6jui01 */
extern INT 	s_sch_sii(OP);	/* Prototyped sb.c:662--VP  6jui01 */
extern OP 	s_sch_sl(OP);	/* Prototyped sb.c:645--VP  6jui01 */
extern INT 	s_sch_sli(OP);	/* Prototyped sb.c:672--VP  6jui01 */
extern OP 	s_spa_g(OP);	/* Prototyped rest.c:2309--VP  6jui01 */
extern OP 	s_spa_gi(OP,INT);	/* Prototyped rest.c:2339--VP  6jui01 */
extern INT 	s_spa_gii(OP,INT);	/* Prototyped rest.c:2347--VP  6jui01 */
extern INT 	s_spa_gli(OP);	/* Prototyped rest.c:2352--VP  6jui01 */
extern OP 	s_spa_k(OP);	/* Prototyped rest.c:2322--VP  6jui01 */
extern OP 	s_spa_ki(OP,INT);	/* Prototyped rest.c:2343--VP  6jui01 */
extern INT 	s_spa_kii(OP,INT);	/* Prototyped rest.c:2356--VP  6jui01 */
extern INT 	s_spa_kli(OP);	/* Prototyped rest.c:2360--VP  6jui01 */
extern OP 	s_t_h(OP);	/* Prototyped ta.c:761--VP  6jui01 */
extern INT 	s_t_hi(OP);	/* Prototyped ta.c:749--VP  6jui01 */
extern OP 	s_t_ij(OP,INT,INT);	/* Prototyped ta.c:757--VP  6jui01 */
extern INT 	s_t_iji(OP,INT,INT);	/* Prototyped ta.c:753--VP  6jui01 */
extern OP 	s_t_l(OP);	/* Prototyped ta.c:741--VP  6jui01 */
extern INT 	s_t_li(OP);	/* Prototyped ta.c:745--VP  6jui01 */
extern OP 	s_t_s(OP);	/* Prototyped ta.c:721--VP  6jui01 */
extern OP 	s_t_u(OP);	/* Prototyped ta.c:729--VP  6jui01 */
extern OP 	s_t_ug(OP);	/* Prototyped ta.c:737--VP  6jui01 */
extern INT 	s_t_ugii(OP,INT);	/* Prototyped ta.c:798--VP  6jui01 */
extern INT 	s_t_ugli(OP);	/* Prototyped ta.c:802--VP  6jui01 */
extern OP 	s_t_ui(OP,INT);	/* Prototyped ta.c:782--VP  6jui01 */
extern INT 	s_t_uii(OP,INT);	/* Prototyped ta.c:786--VP  6jui01 */
extern OP 	s_t_uk(OP);	/* Prototyped ta.c:774--VP  6jui01 */
extern INT 	s_t_ukii(OP,INT);	/* Prototyped ta.c:790--VP  6jui01 */
extern INT 	s_t_ukli(OP);	/* Prototyped ta.c:794--VP  6jui01 */
extern OP 	s_t_us(OP);	/* Prototyped ta.c:778--VP  6jui01 */
extern OP 	s_v_i(OP,INT);	/* Prototyped vc.c:796--VP  6jui01 */
extern INT 	s_v_ii(OP,INT);	/* Prototyped vc.c:825--VP  6jui01 */
extern OP 	s_v_l(OP);	/* Prototyped vc.c:751--VP  6jui01 */
extern INT 	s_v_li(OP);	/* Prototyped vc.c:788--VP  6jui01 */
extern OP 	s_v_s(OP);	/* Prototyped vc.c:729--VP  6jui01 */
extern OP 	s_w_i(OP,INT);	/* Prototyped rest.c:2967--VP  6jui01 */
extern INT 	s_w_ii(OP,INT);	/* Prototyped rest.c:2974--VP  6jui01 */
extern OP 	s_w_l(OP);	/* Prototyped rest.c:2953--VP  6jui01 */
extern INT 	s_w_li(OP);	/* Prototyped rest.c:2960--VP  6jui01 */
extern OP 	s_w_s(OP);	/* Prototyped rest.c:2946--VP  6jui01 */
extern INT 	s_x_nu_to_ypolynom(INT,INT,OP,OP,OP,OP,OP);	/* Prototyped perm.c:812--VP  6jui01 */
extern INT 	sab(OP,OP,OP,OP,OP);	/* Prototyped sab.c:72--VP  6jui01 */
extern INT 	save_cyclo_list(char *);	/* Prototyped nb.c:4661--VP  6jui01 */
extern INT 	scalarp(OP);	/* Prototyped rest.c:646--VP  6jui01 */
extern INT 	scalarproduct(OP,OP,OP);	/* Prototyped nu.c:1703--VP  6jui01 */
extern INT 	scalarproduct_bar_schubert(OP,OP,OP);	/* Prototyped bar.c:735--VP  6jui01 */
extern INT 	scalarproduct_nc(OP,OP,OP);	/* Prototyped nc.c:210--VP  6jui01 */
extern INT 	scalarproduct_schubert(OP,OP,OP);	/* Prototyped sb.c:1681--VP  6jui01 */
extern INT 	scalarproduct_schur(OP,OP,OP);	/* Prototyped sr.c:3236--VP  6jui01 */
extern INT 	scalarproduct_symchar(OP,OP,OP);	/* Prototyped sc.c:827--VP  6jui01 */
extern INT 	scalarproduct_vector(OP,OP,OP);	/* Prototyped vc.c:1140--VP  6jui01 */
extern INT 	scale_monopoly(OP,OP);	/* Prototyped nb.c:2330--VP  6jui01 */
extern INT 	scan(OBJECTKIND,OP);	/* Prototyped io.c:318--VP  6jui01 */
extern INT 	scan_bar(OP);	/* Prototyped bar.c:267--VP  6jui01 */
extern INT 	scan_bitvector(OP);	/* Prototyped vc.c:652--VP  6jui01 */
extern INT 	scan_bruch(OP);	/* Prototyped bruch.c:466--VP  6jui01 */
extern INT 	scan_cyclo(OP);	/* Prototyped nb.c:3850--VP  6jui01 */
extern INT 	scan_elmsym(OP);	/* Prototyped sr.c:1227--VP  6jui01 */
extern INT 	scan_fastpolynom(OP);	/* Prototyped poly.c:794--VP  6jui01 */
extern INT 	scan_ff(OP);	/* Prototyped ff.c:857--VP  6jui01 */
extern INT 	scan_gl_nc(OP,OP);	/* Prototyped nc.c:168--VP  6jui01 */
extern INT 	scan_gral(OP);	/* Prototyped ga.c:445--VP  6jui01 */
extern INT 	scan_homsym(OP);	/* Prototyped sr.c:1237--VP  6jui01 */
extern INT 	scan_integer(OP);	/* Prototyped rest.c:1564--VP  6jui01 */
extern INT 	scan_integermatrix(OP);	/* Prototyped ma.c:1066--VP  6jui01 */
extern INT 	scan_integervector(OP);	/* Prototyped vc.c:671--VP  6jui01 */
extern INT 	scan_kostka(OP);	/* Prototyped ko.c:203--VP  6jui01 */
extern INT 	scan_kranz(OP);	/* Prototyped perm.c:500--VP  6jui01 */
extern INT 	scan_laurent(OP);	/* Prototyped rest.c:3256--VP  6jui01 */
extern INT 	scan_list(OP,OBJECTKIND);	/* Prototyped list.c:517--VP  6jui01 */
extern INT 	scan_longint(OP);	/* Prototyped lo.c:2496--VP  6jui01 */
extern INT 	scan_matrix(OP);	/* Prototyped ma.c:1071--VP  6jui01 */
extern INT 	scan_monom(OP);	/* Prototyped poly.c:230--VP  6jui01 */
extern INT 	scan_monomial(OP);	/* Prototyped sr.c:1222--VP  6jui01 */
extern INT 	scan_monopoly(OP);	/* Prototyped nb.c:1743--VP  6jui01 */
extern INT 	scan_nc_kranz(OP);	/* Prototyped nc.c:611--VP  6jui01 */
extern INT 	scan_partition(OP);	/* Prototyped part.c:1846--VP  6jui01 */
extern INT 	scan_permutation(OP);	/* Prototyped perm.c:1803--VP  6jui01 */
extern INT 	scan_permutation_cycle(OP);	/* Prototyped perm.c:1758--VP  6jui01 */
extern INT 	scan_polynom(OP);	/* Prototyped poly.c:760--VP  6jui01 */
extern INT 	scan_powsym(OP);	/* Prototyped sr.c:1232--VP  6jui01 */
extern INT 	scan_printeingabe(char *);	/* Prototyped io.c:96--VP  6jui01 */
extern INT 	scan_reihe(OP);	/* Prototyped rh.c:2680--VP  6jui01 */
extern INT 	scan_schubert(OP);	/* Prototyped sb.c:568--VP  6jui01 */
extern INT 	scan_schur(OP);	/* Prototyped sr.c:1242--VP  6jui01 */
extern INT 	scan_skewpartition(OP);	/* Prototyped rest.c:2512--VP  6jui01 */
extern INT 	scan_skewsymmetric_matrix(OP);	/* Prototyped ma.c:1078--VP  6jui01 */
extern INT 	scan_sqrad(OP);	/* Prototyped nb.c:2634--VP  6jui01 */
extern INT 	scan_symchar(OP);	/* Prototyped sc.c:1201--VP  6jui01 */
extern INT 	scan_tableaux(OP);	/* Prototyped ta.c:854--VP  6jui01 */
extern INT 	scan_vector(OP);	/* Prototyped vc.c:686--VP  6jui01 */
extern INT 	scan_word(OP);	/* Prototyped rest.c:2930--VP  6jui01 */
extern OBJECTKIND 	scanobjectkind();	/* Prototyped io.c:559--VP  6jui01 */
extern INT 	schen_word(OP,OP,OP);	/* Prototyped ta.c:1644--VP  6jui01 */
extern INT 	schensted_row_delete_step(OP,OP,OP);	/* Prototyped ta.c:1767--VP  6jui01 */
extern INT 	schensted_row_insert_step(OP,OP,OP);	/* Prototyped ta.c:1664--VP  6jui01 */
extern INT 	schicht_print(INT,OP);	/* Prototyped wt.c:827--VP  6jui01 */
extern	INT schnitt_mat();
extern INT 	schnitt_schur(OP,OP,OP);	/* Prototyped sr.c:444--VP  6jui01 */
extern INT 	schubertp(OP);	/* Prototyped sb.c:43--VP  6jui01 */
extern INT 	schur_ende();	/* Prototyped sr.c:30--VP  6jui01 */
extern INT 	schur_monomial_mult(OP,OP,OP);	/* Prototyped pletint.c:5970--VP  6jui01 */
extern INT 	schur_power_schur_plet_mult(OP,OP,OP,OP);	/* Prototyped pletint.c:6519--VP  6jui01 */
extern INT 	schur_powerproduct_schur_plet_mult(OP,OP,OP,OP);	/* Prototyped pletint.c:6557--VP  6jui01 */
extern INT 	schur_schur_plet(OP,OP,OP);	/* Prototyped pletint.c:6348--VP  6jui01 */
extern INT 	schur_schur_pletbis(OP,OP,OP);	/* Prototyped pletint.c:6643--VP  6jui01 */
extern INT 	sd_i_wt(OP,OP,INT);	/* Prototyped wt.c:1102--VP  6jui01 */
extern INT 	sdg(OP,OP,OP);	/* Prototyped sab.c:1515--VP  6jui01 */
extern INT 	select_coeff_polynom(OP,OP,OP);	/* Prototyped poly.c:2151--VP  6jui01 */
extern INT 	select_coeff_reihe(OP,OP,OP);	/* Prototyped rh.c:2572--VP  6jui01 */
extern INT 	select_column(OP,OP,INT);	/* Prototyped ma.c:1774--VP  6jui01 */
extern INT 	select_column_tableaux(OP,OP,INT);	/* Prototyped ta.c:1437--VP  6jui01 */
extern INT 	select_degree_reihe(OP,OP,OP);	/* Prototyped rh.c:2528--VP  6jui01 */
extern OP 	select_i(OP,OP);	/* Prototyped rest.c:3070--VP  6jui01 */
extern INT 	select_row(OP,OP,INT);	/* Prototyped ma.c:1756--VP  6jui01 */
extern INT 	select_row_tableaux(OP,OP,INT);	/* Prototyped ta.c:1420--VP  6jui01 */
extern INT 	set_bv_i(OP,INT);	/* Prototyped vc.c:1510--VP  6jui01 */
extern	INT set_cyclotomic_parameters ();
extern	INT set_root_parameters ();
extern INT 	set_tex_polynom_parameter(INT,INT);	/* Prototyped poly.c:27--VP  6jui01 */
extern	INT set_useful_monopolies ();
extern INT 	setup_numbers(INT,INT);	/* Prototyped nb.c:1483--VP  6jui01 */
extern INT 	signum(OP,OP);	/* Prototyped nu.c:207--VP  6jui01 */
extern INT 	signum_permutation(OP,OP);	/* Prototyped perm.c:1623--VP  6jui01 */
extern INT 	skewplane_plane(OP,OP);	/* Prototyped ta.c:1085--VP  6jui01 */
extern INT 	skip_comment();	/* Prototyped io.c:299--VP  6jui01 */
extern	INT sn_character ();
extern	INT sn_dimension ();
extern	INT sn_tableaux ();
extern INT 	sn_weintraube(OP,OP);	/* Prototyped wt.c:210--VP  6jui01 */
extern	INT so_character ();
extern	INT so_dimension ();
extern	INT so_tableaux ();
extern INT 	sort(OP);	/* Prototyped nu.c:463--VP  6jui01 */
extern INT 	sort_rows_tableaux_apply(OP);	/* Prototyped ta.c:1404--VP  6jui01 */
extern INT 	sort_vector(OP);	/* Prototyped vc.c:354--VP  6jui01 */
extern INT 	sp_br(OP);	/* Prototyped bruch.c:1795--VP  6jui01 */
extern	INT sp_character ();
extern	INT sp_dimension ();
extern	INT sp_tableaux ();
extern INT 	spalten_summe(OP,OP);	/* Prototyped ma.c:1622--VP  6jui01 */
extern INT 	spaltenanfang(OP,INT);	/* Prototyped ta.c:977--VP  6jui01 */
extern INT 	spaltenende(OP,INT);	/* Prototyped ta.c:1006--VP  6jui01 */
extern INT 	specht_dg(OP,OP,OP);	/* Prototyped boe.c:11--VP  6jui01 */
extern INT 	specht_irred_characteristik(OP,OP);	/* Prototyped sc.c:1688--VP  6jui01 */
extern INT 	specht_m_part_sc(OP,OP);	/* Prototyped sc.c:1675--VP  6jui01 */
extern INT 	specht_poly(OP,OP);	/* Prototyped boe.c:112--VP  6jui01 */
extern INT 	specht_powersum(OP,OP);	/* Prototyped sc.c:1721--VP  6jui01 */
extern	INT spin_tableaux_character ();
extern INT 	split();	/* Prototyped nc.c:29--VP  6jui01 */
extern INT 	sprint(char *,OP);	/* Prototyped io.c:114--VP  6jui01 */
extern INT 	sprint_integer(char *,OP);	/* Prototyped rest.c:1616--VP  6jui01 */
extern INT 	sprint_longint(char *,OP);	/* Prototyped lo.c:1887--VP  6jui01 */
extern INT 	sprint_partition(char *,OP);	/* Prototyped part.c:393--VP  6jui01 */
extern INT 	square_free_part(OP,OP,OP,OP,OP,OP);	/* Prototyped nb.c:948--VP  6jui01 */
extern INT 	square_free_part_0(OP,OP,OP);	/* Prototyped nb.c:866--VP  6jui01 */
extern INT 	squareroot(OP,OP);	/* Prototyped nu.c:8--VP  6jui01 */
extern INT 	squareroot_bruch(OP,OP);	/* Prototyped nb.c:3480--VP  6jui01 */
extern INT 	squareroot_integer(OP,OP);	/* Prototyped nb.c:3452--VP  6jui01 */
extern INT 	squareroot_longint(OP,OP);	/* Prototyped nb.c:3472--VP  6jui01 */
extern INT 	sscan(char *,OBJECTKIND,OP);	/* Prototyped io.c:440--VP  6jui01 */
extern INT 	sscan_bar(OP,char *);	/* Prototyped bar.c:255--VP  6jui01 */
extern INT 	sscan_integer(OP,char *);	/* Prototyped rest.c:1587--VP  6jui01 */
extern INT 	sscan_integervector(OP,char *);	/* Prototyped vc.c:395--VP  6jui01 */
extern INT 	sscan_longint(char *,OP);	/* Prototyped lo.c:2636--VP  6jui01 */
extern INT 	sscan_partition(OP,char *);	/* Prototyped part.c:2559--VP  6jui01 */
extern INT 	sscan_permutation(OP,char *);	/* Prototyped perm.c:3105--VP  6jui01 */
extern INT 	sscan_schur(char *,OP);	/* Prototyped sr.c:1247--VP  6jui01 */
extern	INT standardise_cold_tableaux_list ();
extern INT 	standardise_cyclo(OP);	/* Prototyped nb.c:3745--VP  6jui01 */
extern INT 	standardp(OP);	/* Prototyped ta.c:1363--VP  6jui01 */
extern INT 	starpart(OP,OP,OP);	/* Prototyped rest.c:2466--VP  6jui01 */
extern INT 	start_longint();	/* Prototyped lo.c:1701--VP  6jui01 */
extern INT 	starting_bar_schubert(OP,OP);	/* Prototyped bar.c:755--VP  6jui01 */
extern INT 	starttableaux(OP,OP);	/* Prototyped rest.c:2754--VP  6jui01 */
extern INT 	std_perm();	/* Prototyped nc.c:920--VP  6jui01 */
extern INT 	stirling_first_tafel(OP,OP);	/* Prototyped ko.c:971--VP  6jui01 */
extern INT 	stirling_numbers_second_kind(OP,OP);	/* Prototyped zykelind.c:3267--VP  6jui01 */
extern INT 	stirling_second_number(OP,OP,OP);	/* Prototyped ko.c:936--VP  6jui01 */
extern INT 	stirling_second_number_kostka(OP,OP,OP);	/* Prototyped ko.c:890--VP  6jui01 */
extern INT 	stirling_second_number_tafel(OP,OP,OP,OP);	/* Prototyped ko.c:1004--VP  6jui01 */
extern INT 	stirling_second_tafel(OP,OP);	/* Prototyped ko.c:982--VP  6jui01 */
extern INT 	store_result_1(OP,OP,char *);	/* Prototyped rest.c:208--VP  6jui01 */
extern INT 	store_result_2(OP,OP,OP,char *);	/* Prototyped rest.c:223--VP  6jui01 */
extern INT 	strict_to_odd_part(OP,OP);	/* Prototyped part.c:2772--VP  6jui01 */
extern INT 	strictp(OP);	/* Prototyped part.c:104--VP  6jui01 */
extern INT 	strong_check_barp(OP);	/* Prototyped bar.c:288--VP  6jui01 */
extern INT 	strong_check_permutationp(OP);	/* Prototyped perm.c:1768--VP  6jui01 */
extern INT 	strong_generators(OP,OP);	/* Prototyped zyk.c:717--VP  6jui01 */
extern INT 	sub(OP,OP,OP);	/* Prototyped nu.c:167--VP  6jui01 */
extern INT 	sub_comp_bv(OP,OP);	/* Prototyped vc.c:583--VP  6jui01 */
extern	INT substitute_one_matrix ();
extern	INT substitute_one_monopoly ();
extern INT 	sum(OP,OP);	/* Prototyped nu.c:570--VP  6jui01 */
extern INT 	sum_matrix(OP,OP);	/* Prototyped ma.c:134--VP  6jui01 */
extern INT 	sum_vector(OP,OP);	/* Prototyped vc.c:1049--VP  6jui01 */
extern INT 	sup_bitvector(OP,OP,OP);	/* Prototyped vc.c:1599--VP  6jui01 */
extern INT 	swap(OP,OP);	/* Prototyped rest.c:287--VP  6jui01 */
extern INT 	symchar_hoch_n(OP,OP,OP);	/* Prototyped sc.c:572--VP  6jui01 */
extern INT 	symmetricp(OP);	/* Prototyped poly.c:2255--VP  6jui01 */
extern INT 	symmetricp_i(OP,INT);	/* Prototyped poly.c:2231--VP  6jui01 */
extern INT 	symmetricp_matrix(OP);	/* Prototyped ma.c:1610--VP  6jui01 */
extern INT 	t_2SCHUBERT_POLYNOM(OP,OP);	/* Prototyped sb.c:1490--VP  6jui01 */
extern INT 	t_BARCYCLE_BAR(OP,OP);	/* Prototyped bar.c:484--VP  6jui01 */
extern INT 	t_BAR_BARCYCLE(OP,OP);	/* Prototyped bar.c:513--VP  6jui01 */
extern INT 	t_BINTREE_LIST(OP,OP);	/* Prototyped bi.c:380--VP  6jui01 */
extern INT 	t_BINTREE_SCHUR(OP,OP);	/* Prototyped bi.c:430--VP  6jui01 */
extern INT 	t_BITVECTOR_INTVECTOR(OP,OP);	/* Prototyped vc.c:1671--VP  6jui01 */
extern INT 	t_BIT_VECTOR(OP,OP);	/* Prototyped vc.c:1762--VP  6jui01 */
extern INT 	t_BRUCH_LAURENT(OP,OP);	/* Prototyped rest.c:3467--VP  6jui01 */
extern INT 	t_ELMSYM_HOMSYM(OP,OP);	/* Prototyped sr.c:2959--VP  6jui01 */
extern INT 	t_ELMSYM_MONOMIAL(OP,OP);	/* Prototyped sr.c:2948--VP  6jui01 */
extern INT 	t_ELMSYM_POWSYM(OP,OP);	/* Prototyped sr.c:3179--VP  6jui01 */
extern INT 	t_ELMSYM_SCHUR(OP,OP);	/* Prototyped sr.c:2811--VP  6jui01 */
extern INT 	t_EXPONENT_VECTOR(OP,OP);	/* Prototyped part.c:1992--VP  6jui01 */
extern INT 	t_HOMSYM_MONOMIAL(OP,OP);	/* Prototyped sr.c:2937--VP  6jui01 */
extern INT 	t_HOMSYM_POWSYM(OP,OP);	/* Prototyped sr.c:3156--VP  6jui01 */
extern INT 	t_HOMSYM_SCHUR(OP,OP);	/* Prototyped sr.c:2756--VP  6jui01 */
extern INT 	t_INTEGER_FF(OP,OP,OP);	/* Prototyped ff.c:1130--VP  6jui01 */
extern INT 	t_INTEGER_LAURENT(OP,OP);	/* Prototyped rest.c:3413--VP  6jui01 */
extern INT 	t_INTVECTOR_BITVECTOR(OP,OP);	/* Prototyped vc.c:1558--VP  6jui01 */
extern INT 	t_INTVECTOR_UCHAR(OP,char **);	/* Prototyped vc.c:1339--VP  6jui01 */
extern INT 	t_LAURENT_OBJ(OP,OP);	/* Prototyped rest.c:3274--VP  6jui01 */
extern INT 	t_LIST_POLYNOM(OP,OP);	/* Prototyped poly.c:2311--VP  6jui01 */
extern INT 	t_LIST_VECTOR(OP,OP);	/* Prototyped list.c:566--VP  6jui01 */
extern INT 	t_MA_MONOPOLY_MA_POLYNOM(OP,OP);	/* Prototyped bruch.c:1557--VP  6jui01 */
extern INT 	t_MONOMIAL_HOMSYM(OP,OP);	/* Prototyped sr.c:2926--VP  6jui01 */
extern INT 	t_MONOMIAL_POWSYM(OP,OP);	/* Prototyped sr.c:3201--VP  6jui01 */
extern INT 	t_MONOMIAL_SCHUR(OP,OP);	/* Prototyped sr.c:2690--VP  6jui01 */
extern INT 	t_MONOPOLY_LAURENT(OP,OP);	/* Prototyped rest.c:3342--VP  6jui01 */
extern INT 	t_MONOPOLY_POLYNOM(OP,OP);	/* Prototyped nb.c:4753--VP  6jui01 */
extern INT 	t_OBJ_LAURENT(OP,OP);	/* Prototyped rest.c:3428--VP  6jui01 */
extern INT 	t_PARTITION_AUGPART(OP,OP);	/* Prototyped part.c:2340--VP  6jui01 */
extern INT 	t_PERMUTATION_SCHUBERT(OP,OP);	/* Prototyped sb.c:986--VP  6jui01 */
extern INT 	t_POLYNOM_ELMSYM(OP,OP);	/* Prototyped sr.c:699--VP  6jui01 */
extern INT 	t_POLYNOM_LAURENT(OP,OP);	/* Prototyped rest.c:3373--VP  6jui01 */
extern INT 	t_POLYNOM_MONOMIAL(OP,OP);	/* Prototyped sr.c:596--VP  6jui01 */
extern INT 	t_POLYNOM_MONOPOLY(OP,OP);	/* Prototyped bruch.c:1087--VP  6jui01 */
extern INT 	t_POLYNOM_POWER(OP,OP);	/* Prototyped sr.c:625--VP  6jui01 */
extern INT 	t_POLYNOM_SCHUBERT(OP,OP);	/* Prototyped sb.c:131--VP  6jui01 */
extern INT 	t_POLYNOM_SCHUR(OP,OP);	/* Prototyped sr.c:686--VP  6jui01 */
extern INT 	t_POLYNOM_T(OP,OP);	/* Prototyped wt.c:186--VP  6jui01 */
extern INT 	t_POWSYM_ELMSYM(OP,OP);	/* Prototyped sr.c:3168--VP  6jui01 */
extern INT 	t_POWSYM_HOMSYM(OP,OP);	/* Prototyped sr.c:3145--VP  6jui01 */
extern INT 	t_POWSYM_MONOMIAL(OP,OP);	/* Prototyped sr.c:3190--VP  6jui01 */
extern INT 	t_POWSYM_SCHUR(OP,OP);	/* Prototyped sr.c:3033--VP  6jui01 */
extern INT 	t_REIHE_POLYNOM(OP,OP);	/* Prototyped rh.c:1338--VP  6jui01 */
extern INT 	t_SCHUBERT_POLYNOM(OP,OP);	/* Prototyped sb.c:783--VP  6jui01 */
extern INT 	t_SCHUR_ELMSYM(OP,OP);	/* Prototyped sr.c:2970--VP  6jui01 */
extern INT 	t_SCHUR_HOMSYM(OP,OP);	/* Prototyped sr.c:2867--VP  6jui01 */
extern INT 	t_SCHUR_MONOMIAL(OP,OP);	/* Prototyped sr.c:2634--VP  6jui01 */
extern INT 	t_SCHUR_POWSYM(OP,OP);	/* Prototyped sr.c:3087--VP  6jui01 */
extern INT 	t_SCHUR_SYMCHAR(OP,OP);	/* Prototyped sc.c:1909--VP  6jui01 */
extern INT 	t_UCHAR_INTVECTOR(OP,char *);	/* Prototyped vc.c:1350--VP  6jui01 */
extern INT 	t_VECTOR_BIT(OP,OP);	/* Prototyped vc.c:1692--VP  6jui01 */
extern INT 	t_VECTOR_BITREC(OP,OP);	/* Prototyped perm.c:3176--VP  6jui01 */
extern INT 	t_VECTOR_EXPONENT(OP,OP);	/* Prototyped part.c:1963--VP  6jui01 */
extern INT 	t_VECTOR_FROB(OP,OP);	/* Prototyped part.c:2260--VP  6jui01 */
extern INT 	t_VECTOR_LIST(OP,OP);	/* Prototyped list.c:597--VP  6jui01 */
extern INT 	t_VECTOR_ZYKEL(OP,OP);	/* Prototyped perm.c:2376--VP  6jui01 */
extern INT 	t_ZYKEL_VECTOR(OP,OP);	/* Prototyped perm.c:2450--VP  6jui01 */
extern INT 	t_augpart_part(OP,OP);	/* Prototyped part.c:1277--VP  6jui01 */
extern INT 	t_bar_doubleperm(OP,OP);	/* Prototyped bar.c:835--VP  6jui01 */
extern INT 	t_int_longint(OP,OP);	/* Prototyped lo.c:2348--VP  6jui01 */
extern INT 	t_j_wt(OP,OP,INT);	/* Prototyped wt.c:896--VP  6jui01 */
extern INT 	t_longint_int(OP);	/* Prototyped lo.c:2304--VP  6jui01 */
extern INT 	t_monomial_schur(OP,OP);	/* Prototyped pletint.c:5984--VP  6jui01 */
extern INT 	t_vperm_zperm(OP,OP);	/* Prototyped perm.c:2381--VP  6jui01 */
extern INT 	t_zperm_vperm(OP,OP);	/* Prototyped perm.c:2455--VP  6jui01 */
extern INT 	tab_anfang();	/* Prototyped ta.c:14--VP  6jui01 */
extern INT 	tab_ende();	/* Prototyped ta.c:21--VP  6jui01 */
extern INT 	tab_funk();	/* Prototyped boe.c:1720--VP  6jui01 */
extern INT 	tab_wt(OP,OP);	/* Prototyped wt.c:353--VP  6jui01 */
extern	INT tableaux_character ();
extern INT 	tableauxp(OP);	/* Prototyped ta.c:57--VP  6jui01 */
extern INT 	test_bintree();	/* Prototyped bi.c:483--VP  6jui01 */
extern	INT test_brc();
extern INT 	test_bruch();	/* Prototyped bruch.c:957--VP  6jui01 */
extern INT 	test_callocobject();	/* Prototyped rest.c:2259--VP  6jui01 */
extern	INT test_dcp();
extern INT 	test_integer();	/* Prototyped rest.c:1678--VP  6jui01 */
extern INT 	test_kostka();	/* Prototyped ko.c:608--VP  6jui01 */
extern INT 	test_list();	/* Prototyped list.c:624--VP  6jui01 */
extern INT 	test_longint();	/* Prototyped lo.c:2692--VP  6jui01 */
extern INT 	test_matrix();	/* Prototyped ma.c:1552--VP  6jui01 */
extern	INT test_mdg();
extern INT 	test_ndg();	/* Prototyped na.c:112--VP  6jui01 */
extern INT 	test_number();	/* Prototyped nb.c:4732--VP  6jui01 */
extern INT 	test_object();	/* Prototyped rest.c:2287--VP  6jui01 */
extern INT 	test_part();	/* Prototyped part.c:2014--VP  6jui01 */
extern INT 	test_perm();	/* Prototyped perm.c:1172--VP  6jui01 */
extern INT 	test_plet();	/* Prototyped pletint.c:6785--VP  6jui01 */
extern INT 	test_poly();	/* Prototyped poly.c:1299--VP  6jui01 */
extern INT 	test_schubert();	/* Prototyped sb.c:704--VP  6jui01 */
extern INT 	test_schur();	/* Prototyped sr.c:1391--VP  6jui01 */
extern INT 	test_symchar();	/* Prototyped sc.c:1628--VP  6jui01 */
extern INT 	test_word();	/* Prototyped rest.c:2568--VP  6jui01 */
extern INT 	tex(OP);	/* Prototyped io.c:827--VP  6jui01 */
extern INT 	tex_2schubert_monom_summe(OP);	/* Prototyped sb.c:1253--VP  6jui01 */
extern INT 	tex_bruch(OP);	/* Prototyped bruch.c:282--VP  6jui01 */
extern INT 	tex_cyclo(OP);	/* Prototyped nb.c:4386--VP  6jui01 */
extern INT 	tex_dia_wt(OP);	/* Prototyped wt.c:858--VP  6jui01 */
extern INT 	tex_hall_littlewood(OP);	/* Prototyped sr.c:1807--VP  6jui01 */
extern INT 	tex_hecke_monopoly(OP);	/* Prototyped hiccup.c:294--VP  6jui01 */
extern INT 	tex_integer(OP);	/* Prototyped rest.c:1545--VP  6jui01 */
extern INT 	tex_kostka(OP,OP);	/* Prototyped ko.c:172--VP  6jui01 */
extern INT 	tex_lc(OP);	/* Prototyped perm.c:1217--VP  6jui01 */
extern INT 	tex_list(OP);	/* Prototyped list.c:644--VP  6jui01 */
extern INT 	tex_longint(OP);	/* Prototyped lo.c:1918--VP  6jui01 */
extern INT 	tex_matrix(OP);	/* Prototyped ma.c:1327--VP  6jui01 */
extern INT 	tex_matrix_co(OP,INT (*)());	/* Prototyped ma.c:1332--VP  6jui01 */
extern INT 	tex_monom(OP);	/* Prototyped poly.c:280--VP  6jui01 */
extern INT 	tex_monom_plus(INT,OP);	/* Prototyped nb.c:1549--VP  6jui01 */
extern INT 	tex_monopoly(OP);	/* Prototyped nb.c:2375--VP  6jui01 */
extern INT 	tex_partition(OP);	/* Prototyped part.c:1457--VP  6jui01 */
extern INT 	tex_permutation(OP);	/* Prototyped perm.c:1254--VP  6jui01 */
extern INT 	tex_polynom(OP);	/* Prototyped poly.c:1380--VP  6jui01 */
extern INT 	tex_rz(OP);	/* Prototyped perm.c:1291--VP  6jui01 */
extern INT 	tex_schubert(OP);	/* Prototyped sb.c:484--VP  6jui01 */
extern INT 	tex_schur(OP);	/* Prototyped sr.c:478--VP  6jui01 */
extern INT 	tex_sqrad(OP);	/* Prototyped nb.c:3165--VP  6jui01 */
extern INT 	tex_symchar(OP);	/* Prototyped sc.c:1168--VP  6jui01 */
extern INT 	tex_tableaux(OP);	/* Prototyped ta.c:559--VP  6jui01 */
extern INT 	tex_vector(OP);	/* Prototyped vc.c:865--VP  6jui01 */
extern INT 	tex_weintraube(OP,OP);	/* Prototyped wt.c:813--VP  6jui01 */
extern INT 	tidy(OP);	/* Prototyped nb.c:1598--VP  6jui01 */
extern	INT tl_set_index_inc();
extern	INT tl_set_max_numb();
extern	INT tl_set_prime();
extern INT 	trace(OP,OP);	/* Prototyped nu.c:1827--VP  6jui01 */
extern INT 	trace_matrix(OP,OP);	/* Prototyped ma.c:1591--VP  6jui01 */
extern INT 	trafo_check();	/* Prototyped boe.c:711--VP  6jui01 */
extern INT 	trans2formlist(OP,OP,OP,INT (*)());	/* Prototyped list.c:373--VP  6jui01 */
extern INT 	trans_index_monopoly_cyclo(OP,OP,OP);	/* Prototyped nb.c:3695--VP  6jui01 */
extern INT 	transform_apply_list(OP,INT (*)());	/* Prototyped list.c:324--VP  6jui01 */
extern INT 	transformlist(OP,OP,INT (*)());	/* Prototyped list.c:335--VP  6jui01 */
extern INT 	transpose(OP,OP);	/* Prototyped nu.c:143--VP  6jui01 */
extern INT 	transpose_matrix(OP,OP);	/* Prototyped ma.c:792--VP  6jui01 */
extern INT 	typusorder(OP,OP,OP,OP,OP);	/* Prototyped perm.c:1041--VP  6jui01 */
extern INT 	umriss_tableaux(OP,OP);	/* Prototyped ta.c:1352--VP  6jui01 */
extern INT 	unimodalp(OP);	/* Prototyped poly.c:1644--VP  6jui01 */
extern INT 	unrank_subset(OP,OP,OP);	/* Prototyped rest.c:3524--VP  6jui01 */
extern INT 	unset_bv_i(OP,INT);	/* Prototyped vc.c:1497--VP  6jui01 */
extern INT 	usersort_vector(OP,INT (*)());	/* Prototyped vc.c:347--VP  6jui01 */
extern INT 	vander(OP,OP);	/* Prototyped nu.c:1760--VP  6jui01 */
extern INT 	vander_gen(OP,OP);	/* Prototyped boe.c:66--VP  6jui01 */
extern INT 	vec_anfang();	/* Prototyped vc.c:17--VP  6jui01 */
extern INT 	vec_ende();	/* Prototyped vc.c:26--VP  6jui01 */
extern INT 	vectorp(OP);	/* Prototyped vc.c:62--VP  6jui01 */
extern INT 	vertikal_sum(OP,OP);	/* Prototyped ga.c:77--VP  6jui01 */
extern INT 	vexillaryp(OP,OP);	/* Prototyped rest.c:831--VP  6jui01 */
extern INT 	vexillaryp_permutation(OP,OP);	/* Prototyped perm.c:1481--VP  6jui01 */
extern INT 	vminus(OP,OP);	/* Prototyped ga.c:254--VP  6jui01 */
extern INT 	vminus_hecke(OP,OP);	/* Prototyped ga.c:601--VP  6jui01 */
extern INT 	vminus_tabloid(OP,OP);	/* Prototyped sc.c:1948--VP  6jui01 */
extern INT 	weight(OP,OP);	/* Prototyped nu.c:1794--VP  6jui01 */
extern INT 	weight_augpart(OP,OP);	/* Prototyped part.c:2092--VP  6jui01 */
extern INT 	weight_partition(OP,OP);	/* Prototyped part.c:1822--VP  6jui01 */
extern INT 	weight_skewpartition(OP,OP);	/* Prototyped rest.c:2412--VP  6jui01 */
extern INT 	weight_tableaux(OP,OP);	/* Prototyped ta.c:645--VP  6jui01 */
extern INT 	weintraube_monom(OP,OP);	/* Prototyped wt.c:40--VP  6jui01 */
extern INT 	weintraube_vector(OP,OP);	/* Prototyped wt.c:54--VP  6jui01 */
extern INT 	weintrauben_polynom(OP,OP);	/* Prototyped wt.c:132--VP  6jui01 */
extern INT 	wert(OP,OP,INT);	/* Prototyped nc.c:1830--VP  6jui01 */
extern INT 	which_part();	/* Prototyped nc.c:1187--VP  6jui01 */
extern INT 	word_schen(OP,OP,OP);	/* Prototyped ta.c:1631--VP  6jui01 */
extern INT 	word_tableaux(OP,OP);	/* Prototyped ta.c:1621--VP  6jui01 */
extern INT 	word_wt(OP,OP);	/* Prototyped wt.c:1287--VP  6jui01 */
extern INT 	wordoftableaux(OP,OP);	/* Prototyped ta.c:911--VP  6jui01 */
extern INT 	wrong_type_oneparameter(char *,OP);	/* Prototyped rest.c:279--VP  6jui01 */
extern INT 	wrong_type_twoparameter(char *,OP,OP);	/* Prototyped rest.c:268--VP  6jui01 */
extern INT 	wt_liste_gewicht(OP,OP);	/* Prototyped wt.c:679--VP  6jui01 */
extern INT 	wt_word(OP,OP);	/* Prototyped wt.c:1263--VP  6jui01 */
extern INT 	ym_min(OP,OP);	/* Prototyped ta.c:1528--VP  6jui01 */
extern INT 	young_alt_scalar_tafel(OP,OP,OP);	/* Prototyped sc.c:1581--VP  6jui01 */
extern INT 	young_character(OP,OP,OP);	/* Prototyped sc.c:1503--VP  6jui01 */
extern INT 	young_polynom(OP,OP);	/* Prototyped poly.c:1912--VP  6jui01 */
extern INT 	young_scalar_tafel(OP,OP,OP);	/* Prototyped sc.c:1540--VP  6jui01 */
extern INT 	young_tafel(OP,OP,OP,OP);	/* Prototyped sc.c:1433--VP  6jui01 */
extern INT 	youngp(OP);	/* Prototyped ta.c:1389--VP  6jui01 */
extern INT 	zeilen_summe(OP,OP);	/* Prototyped ma.c:1683--VP  6jui01 */
extern INT 	zeilenanfang(OP,INT);	/* Prototyped ta.c:1035--VP  6jui01 */
extern INT 	zeilenende(OP,INT);	/* Prototyped ta.c:1060--VP  6jui01 */
extern INT 	zentralprim(OP,OP);	/* Prototyped ga.c:330--VP  6jui01 */
extern INT 	zykelind_An(OP,OP);	/* Prototyped zyk.c:188--VP  6jui01 */
extern INT 	zykelind_Cn(OP,OP);	/* Prototyped zyk.c:61--VP  6jui01 */
extern INT 	zykelind_Dn(OP,OP);	/* Prototyped zyk.c:108--VP  6jui01 */
extern INT 	zykelind_Sn(OP,OP);	/* Prototyped zyk.c:295--VP  6jui01 */
extern INT 	zykelind_aff1Zn(OP,OP);	/* Prototyped zykelind.c:2264--VP  6jui01 */
extern INT 	zykelind_affkq(OP,OP,OP);	/* Prototyped zykelind.c:1791--VP  6jui01 */
extern INT 	zykelind_affkzn();	/* Prototyped zykelind.c:2023--VP  6jui01 */
extern INT 	zykelind_arb(OP,OP);	/* Prototyped zyk.c:1045--VP  6jui01 */
extern INT 	zykelind_centralizer(OP,OP);	/* Prototyped zykelind.c:1295--VP  6jui01 */
extern INT 	zykelind_cube(OP);	/* Prototyped zykelind.c:5005--VP  6jui01 */
extern INT 	zykelind_cube_edges(OP);	/* Prototyped zykelind.c:5163--VP  6jui01 */
extern INT 	zykelind_cube_edges_extended(OP);	/* Prototyped zykelind.c:5214--VP  6jui01 */
extern INT 	zykelind_cube_extended(OP);	/* Prototyped zykelind.c:5077--VP  6jui01 */
extern INT 	zykelind_cube_faces(OP);	/* Prototyped zykelind.c:5180--VP  6jui01 */
extern INT 	zykelind_cube_faces_extended(OP);	/* Prototyped zykelind.c:5231--VP  6jui01 */
extern INT 	zykelind_cube_vertices(OP);	/* Prototyped zykelind.c:5146--VP  6jui01 */
extern INT 	zykelind_cube_vertices_extended(OP);	/* Prototyped zykelind.c:5197--VP  6jui01 */
extern INT 	zykelind_dec(OP,OP);	/* Prototyped zykelind.c:1067--VP  6jui01 */
extern INT 	zykelind_dec_apply(OP);	/* Prototyped zykelind.c:1091--VP  6jui01 */
extern INT 	zykelind_dir_prod();	/* Prototyped zykelind.c:77--VP  6jui01 */
extern INT 	zykelind_dir_prod_apply(OP,OP);	/* Prototyped zykelind.c:132--VP  6jui01 */
extern INT 	zykelind_dir_summ();	/* Prototyped zykelind.c:143--VP  6jui01 */
extern INT 	zykelind_dir_summ_apply();	/* Prototyped zykelind.c:161--VP  6jui01 */
extern INT 	zykelind_dodecahedron(OP);	/* Prototyped zykelind.c:5248--VP  6jui01 */
extern INT 	zykelind_dodecahedron_edges(OP);	/* Prototyped zykelind.c:5393--VP  6jui01 */
extern INT 	zykelind_dodecahedron_edges_extended(OP);	/* Prototyped zykelind.c:5444--VP  6jui01 */
extern INT 	zykelind_dodecahedron_extended(OP);	/* Prototyped zykelind.c:5315--VP  6jui01 */
extern INT 	zykelind_dodecahedron_faces(OP);	/* Prototyped zykelind.c:5410--VP  6jui01 */
extern INT 	zykelind_dodecahedron_faces_extended(OP);	/* Prototyped zykelind.c:5462--VP  6jui01 */
extern INT 	zykelind_dodecahedron_vertices(OP);	/* Prototyped zykelind.c:5376--VP  6jui01 */
extern INT 	zykelind_dodecahedron_vertices_extended(OP);	/* Prototyped zykelind.c:5427--VP  6jui01 */
extern INT 	zykelind_exponentiation(OP,OP,OP);	/* Prototyped zykelind.c:1195--VP  6jui01 */
extern INT 	zykelind_glkq(OP,OP,OP);	/* Prototyped zykelind.c:1671--VP  6jui01 */
extern INT 	zykelind_glkzn(OP,OP,OP);	/* Prototyped zykelind.c:1985--VP  6jui01 */
extern INT 	zykelind_hoch_dir_prod(OP,OP,OP);	/* Prototyped zykelind.c:183--VP  6jui01 */
extern INT 	zykelind_hoch_dir_summ(OP,OP,OP);	/* Prototyped zykelind.c:171--VP  6jui01 */
extern INT 	zykelind_inc(OP);	/* Prototyped zykelind.c:1053--VP  6jui01 */
extern INT 	zykelind_kranz(OP,OP,OP);	/* Prototyped zykelind.c:1150--VP  6jui01 */
extern INT 	zykelind_on_2sets(OP,OP);	/* Prototyped zykelind.c:482--VP  6jui01 */
extern INT 	zykelind_on_ksubsets(OP,OP,OP);	/* Prototyped zykelind.c:735--VP  6jui01 */
extern INT 	zykelind_on_ktuples();	/* Prototyped zykelind.c:816--VP  6jui01 */
extern INT 	zykelind_on_ktuples_injective(OP,OP,OP);	/* Prototyped zykelind.c:844--VP  6jui01 */
extern INT 	zykelind_on_pairs();	/* Prototyped zykelind.c:316--VP  6jui01 */
extern INT 	zykelind_on_pairs_disjunkt(OP,OP);	/* Prototyped zykelind.c:346--VP  6jui01 */
extern INT 	zykelind_on_pairs_oriented(OP,OP);	/* Prototyped zykelind.c:569--VP  6jui01 */
extern INT 	zykelind_on_pairs_reduced();	/* Prototyped zykelind.c:289--VP  6jui01 */
extern INT 	zykelind_on_power_set(OP,OP);	/* Prototyped zykelind.c:601--VP  6jui01 */
extern INT 	zykelind_pglkq(OP,OP,OP);	/* Prototyped zykelind.c:2291--VP  6jui01 */
extern INT 	zykelind_plethysm(OP,OP,OP);	/* Prototyped zykelind.c:1184--VP  6jui01 */
extern INT 	zykelind_stabilizer_part(OP,OP);	/* Prototyped zykelind.c:1346--VP  6jui01 */
extern INT 	zykelind_superp_lin_dir_graphs(OP,OP);	/* Prototyped zykelind.c:508--VP  6jui01 */
extern INT 	zykelind_test();	/* Prototyped zykelind.c:888--VP  6jui01 */
extern INT 	zykelind_tetraeder(OP);	/* Prototyped zykelind.c:4804--VP  6jui01 */
extern INT 	zykelind_tetraeder_edges(OP);	/* Prototyped zykelind.c:4920--VP  6jui01 */
extern INT 	zykelind_tetraeder_edges_extended(OP);	/* Prototyped zykelind.c:4971--VP  6jui01 */
extern INT 	zykelind_tetraeder_extended(OP);	/* Prototyped zykelind.c:4858--VP  6jui01 */
extern INT 	zykelind_tetraeder_faces(OP);	/* Prototyped zykelind.c:4937--VP  6jui01 */
extern INT 	zykelind_tetraeder_faces_extended(OP);	/* Prototyped zykelind.c:4988--VP  6jui01 */
extern INT 	zykelind_tetraeder_vertices(OP);	/* Prototyped zykelind.c:4903--VP  6jui01 */
extern INT 	zykelind_tetraeder_vertices_extended(OP);	/* Prototyped zykelind.c:4954--VP  6jui01 */
extern INT 	zykeltyp(OP,OP);	/* Prototyped perm.c:2225--VP  6jui01 */
extern INT 	zykeltyp_hoch_n(OP,OP,OP);	/* Prototyped perm.c:2334--VP  6jui01 */
extern INT 	zykeltyp_permutation(OP,OP);	/* Prototyped perm.c:2248--VP  6jui01 */
extern INT 	zykeltyp_pi_hoch();	/* Prototyped zykelind.c:3815--VP  6jui01 */
#endif


#ifdef __cplusplus
}
#endif
